<?php
// $Id: AddHelpdeskBucketResponse.php,v 1.12 2006/03/22 20:38:06 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action uses the information provided by the AddHelpdeskBucket action to add a new helpdesk bucket to
 * the system. The form data passed in via $_REQUEST is used as the data inserted into the database for the new
 * helpdesk bucket. Once this action is finished executing, it redirects to the ShowHelpdeskBucketDetails
 * action for the new helpdesk bucket, or displays an error to the screen if one occurred during execution.
 *
 * @author  Vic Fryzel
 * @author  Michael Fountain
 */
class AddHelpdeskBucketResponse extends MB_Action {
	/**
	 * The constructor for an AddHelpdeskBucketResponse action object. This calls the parent constructor,
	 * sets the string representation of this object, and sets up $this->params.
	 */
	function AddHelpdeskBucketResponse() {
		parent::MB_Action();
		$this->stringRep = "AddHelpdeskBucketResponse";
		$this->params = array("hdBucketName");
	}

	/**
	 * The main method of this class that executes the AddHelpdeskBucketResponse action, and returns
	 * success or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		if(!is_array($_REQUEST["adminIDs"]) || !count($_REQUEST["adminIDs"])) {
			$this->addError(TRANS_ACTIONERROR, "No admins given for new helpdesk bucket.");
		}
		if(!is_array($_REQUEST["hdDepartmentIDs"]) || !count($_REQUEST["hdDepartmentIDs"])) {
			$this->addError(TRANS_ACTIONERROR, "No departments given for new helpdesk bucket.");
		}

		// Generate relational portions of the query...
		$addAdminXML = $addDepartmentXML = "";
		if(!$this->getNumErrors()) {
			// Due to unknown changes with some MBAPI commands, we must generate the admin XML by hand.
			// No longer do we merely pass only an admin ID...
			if(is_array($_REQUEST["adminIDs"]) && count($_REQUEST["adminIDs"])) {
				foreach($_REQUEST["adminIDs"] as $adminID) {
					$addAdminXML .= "<admin><adminID>".((int) $adminID)."</adminID></admin>\n";
				}
			}
			$addDepartmentXML = getAddIDXML("hdDepartmentID", array(),
				$_REQUEST["hdDepartmentIDs"]);
		}

		$query = $this->getMBAPIQuery("SetHelpdeskBuckets", "insert",
			array("admins" => $addAdminXML, "hdDepartmentIDs" => $addDepartmentXML));
		$data = dispatchMBAPI($query, 1);
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			if($_REQUEST["redirectURL"] && $_REQUEST["redirectAction"]) {
				redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])
					."&".$_REQUEST["redirectArgs"]);
			} else {
				redirect("helpdesk.php", getACtionID("ShowHelpdeskBucketDetails"),
					array("hdBucketID" => $data["mbapi"][0]["header"][0]["lastInsertID"][0]));
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddHelpdeskBucketResponse
?>