<?php
// $Id: AddHelpdeskResponseTemplate.php,v 1.7 2006/04/18 20:45:08 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");

/**
 * This action displays a form to the user to collect information about a new helpdesk response template. 
 * A response template is a template with which admins can use to quickly formulate a reply to tickets, 
 * without the hassle of filling in a client's data. This action uses the MBAPI to acquire a list of 
 * departments, and dispatches to the template with this list of departments, as at least one department 
 * is required for a helpdesk response template to function properly (templates are ordered by department 
 * to increase ease of use). This action calls the AddHelpdeskResponseTemplate template, which must post 
 * data to the AddHelpdeskResponseTemplateResponse action.
 *
 * @author  Vic Fryzel
 */
class AddHelpdeskResponseTemplate extends MB_Action {
	/**
	 * The constructor for an AddCompany action object. This calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function AddHelpdeskResponseTemplate() {
		parent::MB_Action();
		$this->stringRep = "AddHelpdeskResponseTemplate";
	}

	/**
	 * The main method of this class that executes the AddHelpdeskResponseTemplate action, and returns success 
	 * or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise. 0 is never returned.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$departments = $this->getMBAPIData("GetHelpdeskDepartments", "helpdeskDepartments", "helpdeskDepartment");
		if($departments === false) {
			$this->addError(TRANS_ACTIONERROR, "Failed to collect a list of helpdesk departments.");
		} else if(!count($departments)) {
			$this->addError(TRANS_ACTIONERROR, "No helpdesk departments found. Please add a helpdesk department "
				."before adding a helpdesk response template.");
		}
		if(!$this->getNumErrors()) {
			$s = array();
			$s["helpdeskDepartments"] = $departments;
			$this->addTemplate("AddHelpdeskResponseTemplate", collapseArrayElements($s));
			
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddHelpdeskResponseTemplate
?>