<?php
// $Id: AddHelpdeskTicket.php,v 1.7 2006/04/18 20:45:08 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");

/**
 * This action displays a form to the user to collect information for a new helpdesk ticket. The data provided 
 * in the form should be posted to the AddHelpdeskTicketResponse action, where it will be inserted into the 
 * database. This action acquires data about departments from the MBAPI, and dispatches it to the 
 * AddHelpdeskTicket template for use in listing departments to select for the ticket to exist in. An array of 
 * admins is also provided to the template for the user to select which admins they'd like to see the ticket.
 *
 * @author  Vic Fryzel
 */
class AddHelpdeskTicket extends MB_Action {
	/**
	 * The constructor for an AddHelpdeskTicket action object. This calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function AddHelpdeskTicket() {
		parent::MB_Action();
		$this->stringRep = "AddHelpdeskTicket";
	}

	/**
	 * The main method of this class that executes the AddHelpdeskTicket action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise. 0 is never returned.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$buckets = $this->getMBAPIData("GetHelpdeskBuckets", "helpdeskBuckets", "helpdeskBucket");
		$departments = $this->getMBAPIData("GetHelpdeskDepartments", "helpdeskDepartments", "helpdeskDepartment");
		if($buckets === false) {
			$this->addError(TRANS_ACTIONERROR, "Failed to collect a list of buckets to potentially associate "
				."with the new helpdesk ticket.");
		}
		if($departments === false) {
			$this->addError(TRANS_ACTIONERROR, "Failed to collect a list of helpdesk departments.");
		}
		if(!count($buckets) && !count($departments)) {
			$this->addError(TRANS_ACTIONERROR, "No helpdesk buckets or departments found. At least one of "
				."either must be added prior to adding a helpdesk ticket.");
		}
		
		if(!$this->getNumErrors()) {
			$s = array();
			$s["helpdeskBuckets"] = $buckets;
			$s["helpdeskDepartments"] = $departments;
			$this->addTemplate("AddHelpdeskTicket", collapseArrayElements($s));
			
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddHelpdeskTicket
?>