<?php
// $Id: EditHelpdeskDepartment.php,v 1.14 2006/04/18 20:45:08 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This action dispatches a template that shows a form prepopulated with helpdesk department data. That
 * data should be posted to the EditHelpdeskDepartmentResponse action, at which point it will be applied to
 * the current helpdesk department in the database. The helpdesk department to edit is identified by
 * $_REQUEST["hdDepartmentID"]. If an invalid helpdesk department ID is provided, an error is thrown,
 * otherwise the template will be displayed, and fed data for the current helpdesk department.
 *
 * @author  Vic Fryzel
 */
class EditHelpdeskDepartment extends MB_Action {
	/**
	 * The constructor for a EditHelpdeskDepartment action object. This calls the parent constructor, and sets
	 * the string representation of this object.
	 */
	function EditHelpdeskDepartment() {
		parent::MB_Action();
		$this->stringRep = "EditHelpdeskDepartment";
		$this->params = array("hdDepartmentID");
	}

	/**
	 * The main method of this class that executes the EditHelpdeskDepartment action, and returns success
	 * or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		if(!((int) $_REQUEST["hdDepartmentID"])) {
			$this->addError(TRANS_ACTIONERROR, "No helpdesk department ID given.");
		} else {
			$admins = $this->getMBAPIData("GetAdmins", "admins", "admin");
			if($admins === false) {
				$this->addError(TRANS_ACTIONERROR, "Failed to collect list of admins.");
			}
			$query = $this->getMBAPIQuery("GetHelpdeskDepartments", "", array("getAdminData" => 1));
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$s = array();
				$s["helpdeskDepartment"] = $data["mbapi"][0]["results"][0]["helpdeskDepartments"][0]
					["helpdeskDepartment"][0];

				// We have to convert the result data from the MBAPI result
				// It gives us full admin data, but we already have that, so we just need the admin IDs
				// for cross-referencing in the template. So we'll quickly loop through and grab all the IDs.
				$s["helpdeskDepartment"]["adminIDs"] = array();
				if(is_array($s["helpdeskDepartment"]["admins"][0]["admin"]) &&
						count(($s["helpdeskDepartment"]["admins"][0]["admin"]))) {
					foreach($s["helpdeskDepartment"]["admins"][0]["admin"] as $admin) {
						$s["helpdeskDepartment"]["adminIDs"][] = $admin["adminID"];
					}
				}
				unset($s["helpdeskDepartment"]["admins"]);

				// This is the var. that the template will use as a reference for admin data
				$s["admins"] = $admins;

				$this->addTemplate("EditHelpdeskDepartment", collapseArrayElements($s));
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditHelpdeskDepartment
?>