<?php
// $Id: EditHelpdeskResponseTemplate.php,v 1.12 2006/04/18 20:45:08 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This action dispatches a template that shows a form prepopulated with helpdesk response template data. 
 * That data should be posted to the EditHelpdeskResponseTemplateResponse action, at which point it will be 
 * applied to the current helpdesk response template in the database. The helpdesk response template to edit 
 * is identified by $_REQUEST["hdRespTplID"]. If an invalid helpdesk response template ID is 
 * provided, an error is thrown, otherwise the template will be displayed, and fed data for the current helpdesk 
 * response template.
 *
 * @author  Vic Fryzel
 */
class EditHelpdeskResponseTemplate extends MB_Action {
	/**
	 * The constructor for a EditHelpdeskResponseTemplate action object. This calls the parent constructor, 
	 * and sets 
	 * the string representation of this object.
	 */
	function EditHelpdeskResponseTemplate() {
		parent::MB_Action();
		$this->stringRep = "EditHelpdeskResponseTemplate";
		$this->params = array("hdRespTplID");
	}

	/**
	 * The main method of this class that executes the EditHelpdeskResponseTemplate action, and returns 
	 * success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		if(!((int) $_REQUEST["hdRespTplID"])) {
			$this->addError(TRANS_ACTIONERROR, "No helpdesk response template ID given.");
		} else {
			$departments = $this->getMBAPIData("GetHelpdeskDepartments", "helpdeskDepartments",
				"helpdeskDepartment");
			if($departments === false || !count($departments)) {
				$this->addError(TRANS_ACTIONERROR, "Failed to obtain list of helpdesk departments.");
			}
			$query = $this->getMBAPIQuery("GetHelpdeskResponseTemplates", "", 
				array("getHelpdeskDepartmentData" => 1));
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$s = array();
				$s["helpdeskResponseTemplate"] = $data["mbapi"][0]["results"][0]["helpdeskResponseTemplates"][0]
					["helpdeskResponseTemplate"][0];
				$s["helpdeskDepartments"] = $departments;
				$this->addTemplate("EditHelpdeskResponseTemplate", collapseArrayElements($s));
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditHelpdeskResponseTemplate
?>