<?php
// $Id: RemoveHelpdeskDepartment.php,v 1.12 2006/04/18 20:45:08 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This action double checks that a user is sure they want to remove a helpdesk department from the database. 
 * It dispatches the current helpdesk department's data to a template, and the template contains a form with 
 * which a user can choose to delete the helpdesk department or cancel the deletion. For now there is no 
 * alternate helpdesk department assignment, such that a helpdesk department can be merged before it is 
 * removed. At this moment a user can merge the helpdesk department they wish to remove into another 
 * helpdesk department and then remove the intended helpdesk department. The helpdesk department to remove is
 * identified by $_REQUEST["hdDepartmentID"]. If an invalid helpdesk department ID is provided, 
 * an error is thrown.
 *
 * @author  Vic Fryzel
 */
class RemoveHelpdeskDepartment extends MB_Action {
	/**
	 * The constructor for a RemoveHelpdeskDepartment action object. This calls the parent constructor, 
	 * sets the string representation of this object, and is where $this->params is setup.
	 */
	function RemoveHelpdeskDepartment() {
		parent::MB_Action();
		$this->stringRep = "RemoveHelpdeskDepartment";
		$this->params = array("hdDepartmentID");
	}

	/**
	 * The main method of this class that executes the RemoveHelpdeskDepartment action, and returns success 
	 * or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		if(!((int) $_REQUEST["hdDepartmentID"])) {
			$this->addError(TRANS_ACTIONERROR, "No helpdesk department ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetHelpdeskDepartments");
			$data = dispatchMBAPI($query, 1);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$s = array();
					$s["helpdeskDepartment"] = $data["mbapi"][0]["results"][0]["helpdeskDepartments"][0]
						["helpdeskDepartment"][0];
					$this->addTemplate("RemoveHelpdeskDepartment", collapseArrayElements($s));
					
				} else {
					$this->addError(TRANS_ACTIONERROR, "Helpdesk department not found.");
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveHelpdeskDepartment
?>