<?php
// $Id: ShowHelpdeskBucketDetails.php,v 1.13 2006/04/18 20:45:08 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class dispatches a template that displays the details of a helpdesk bucket.
 *
 * @author  Vic Fryzel
 */
class ShowHelpdeskBucketDetails extends MB_Action {
	/**
	 * The constructor for a ShowHelpdeskBucketDetails object. This sets up our string represenation, calls
	 * the parent constructor, and sets up $this->params.
	 */
	function ShowHelpdeskBucketDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowHelpdeskBucketDetails";
		$this->params = array("hdBucketID");
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		if(!((int) $_REQUEST["hdBucketID"])) {
			$this->addError(TRANS_ACTIONERROR, "No helpdesk bucket ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetHelpdeskBuckets", "", array("getAdminData" => 2,
				"getHelpdeskDepartmentData" => 2));
			$data = dispatchMBAPI($query, 1);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$s = array();
					$s["helpdeskBucket"] = $data["mbapi"][0]["results"][0]["helpdeskBuckets"][0]["helpdeskBucket"][0];
					$results =& $data["mbapi"][0]["results"][0];
					$s["helpdeskBucket"]["hdDepartments"] =
						(count($results["helpdeskBuckets"][0]["helpdeskBucket"][0]["hdDepartments"][0]["hdDepartment"]) == 1)
						? array(0 => $results["helpdeskBuckets"][0]["helpdeskBucket"][0]["hdDepartments"][0]["hdDepartment"])
						: $results["helpdeskBuckets"][0]["helpdeskBucket"][0]["hdDepartments"][0]["hdDepartment"];
					$s["helpdeskBucket"]["admins"] =
						(count($results["helpdeskBuckets"][0]["helpdeskBucket"][0]["admins"][0]["admin"]) == 1)
						? array(0 => $results["helpdeskBuckets"][0]["helpdeskBucket"][0]["admins"][0]["admin"])
						: $results["helpdeskBuckets"][0]["helpdeskBucket"][0]["admins"][0]["admin"];
					$this->addTemplate("ShowHelpdeskBucketDetails", collapseArrayElements($s));
				} else {
					$this->addError(TRANS_ACTIONERROR, "Helpdesk bucket does not exist.");
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowHelpdeskBucketDetails
?>