<?php
// $Id: ShowHelpdeskBucketTickets.php,v 1.2 2006/05/30 21:49:45 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class dispatches a template that displays the details of a helpdesk bucket.
 *
 * @author  Brian Smith
 */
class ShowHelpdeskBucketTickets extends MB_Action {
	/**
	 * The constructor for a ShowHelpdeskBucketTickets object. This sets up our string represenation, calls
	 * the parent constructor, and sets up $this->params.
	 */
	function ShowHelpdeskBucketTickets() {
		parent::MB_Action();
		$this->stringRep = "ShowHelpdeskBucketTickets";
		$this->params = array("hdBucketID", "hdDepartmentID", "hdTicketStatusID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		// -----------------
		// Get the Bucket Data.
		// -----------------

		if (notZero( $_REQUEST["hdBucketID"] )) {
			
			$query = $this->getMBAPIQuery("GetHelpdeskBuckets", "", array(
							"getHelpdeskDepartmentData" => 1,
							"getTicketData" => 3));
			$rawData = dispatchMBAPI($query, 1);
			
	
			$data = grabSimpleMBAPIResults($rawData);
			$data = $data[0];

			
			
			dbg("########## GetHelpdeskBuckets #############");
			dbg($data);
			
			if (notZero( $data["hdBucketID"] )) {
				$this->smartyVars["bucket"] = array();
				$this->smartyVars["bucket"]["hdBucketID"] = $data["hdBucketID"];
				$this->smartyVars["bucket"]["hdBucketName"] = $data["hdBucketName"];
	
				$this->smartyVars["department"] = array();
				$this->smartyVars["department"] = $data["hdDepartmentIDs"][0]["hdDepartmentID"][0];
				
				if (is_array( $data["helpdeskTickets"][0] ))
					$this->smartyVars["tickets"] = $data["helpdeskTickets"][0]["helpdeskTicket"];
	
				$this->smartyVars["ticketStatuses"] = getStatuses("helpdesk");
				
				$this->smartyVars["paginationLinks"] =
						collapseArrayElements($rawData["mbapi"][0]["results"][0]["paginationLinks"][0]);
	
				dbg("############# Being sent to Smarty ######################");
				dbg($this->smartyVars);
				
				unset( $query, $data );
				$this->addTemplate("ShowHelpdeskBucketTickets");
			}
			
		} elseif (notZero( $_REQUEST["hdDepartmentID"] )) {
			
			$query = $this->getMBAPIQuery("GetHelpdeskDepartments", "", array(
							"getHelpdeskBucketData" => 1,
							"getTicketData" => 3));
			$rawData = dispatchMBAPI($query, 1);
	
			$data = grabSimpleMBAPIResults($rawData);
			$data = $data[0];
			
			dbg("########## GetHelpdeskBuckets #############");
			dbg($data);
			if (notZero( $data["hdDepartmentID"] )) {
				$this->smartyVars["bucket"] = array();
				$this->smartyVars["bucket"] = $data["helpdeskBuckets"][0]["helpdeskBucket"][0];
	
				$this->smartyVars["department"] = array();
				$this->smartyVars["department"]["hdDepartmentID"] = $data["hdDepartmentID"];
				$this->smartyVars["department"]["hdDepartmentName"] = $data["hdDepartmentName"];
				$this->smartyVars["department"]["hdDepartmentDescription"] = $data["hdDepartmentDescription"];
				
				if (is_array( $data["helpdeskTickets"][0] ))
					$this->smartyVars["tickets"] = $data["helpdeskTickets"][0]["helpdeskTicket"];
	
				$this->smartyVars["ticketStatuses"] = getStatuses("helpdesk");
				
				$this->smartyVars["paginationLinks"] =
						collapseArrayElements($rawData["mbapi"][0]["results"][0]["paginationLinks"][0]);
	
				dbg("############# Being sent to Smarty ######################");
				dbg($this->smartyVars);
				
				unset( $query, $data );
				$this->addTemplate("ShowHelpdeskBucketTickets");
			}
		} else {
			$this->addError( TRANS_ACTIONERROR, "No Bucket or Department ID Set." );
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}

?>
