<?php
// $Id: ShowHelpdeskDepartments.php,v 1.12 2006/04/18 20:45:08 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action displays information on all helpdesk departments currently maintained by the system. It queries
 * the MBAPI GetHelpdeskDepartments command, and dispatches that data to the template for display. The template
 * should link to the AddHelpdeskDepartment, EditHelpdeskDepartment, RemoveHelpdeskDepartment, and
 * ShowHelpdeskDepartmentDetails actions. An error is not thrown if no companies are found, but rather the template
 * is still dispatched.
 *
 * @author  Vic Fryzel
 */
class ShowHelpdeskDepartments extends MB_Action {
	/**
	 * The constructor for a ShowHelpdeskDepartments action object. This calls the parent constructor,
	 * sets the string representation of this object, and sets up $this->sortColumns for use in
	 * $this->getMBAPIQuery().
	 */
	function ShowHelpdeskDepartments() {
		parent::MB_Action();
		$this->stringRep = "ShowHelpdeskDepartments";
		$this->sortColumns = array
		(
			"hdDepartmentName", // default sort
			"hdDepartmentID",
		);
	}

	/**
	 * The main method of this class that executes the ShowHelpdeskDepartments action, and returns success
	 * or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		// --------------------------------------
		// Data: GetHelpdeskDepartments
		// --------------------------------------

		$params = array
		(
			"getCountData" => 1
		);
		$query = $this->getMBAPIQuery("GetHelpdeskDepartments", "", $params, 1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			$results =& $data["mbapi"][0]["results"][0];

			$s = array();
			$s["helpdeskDepartments"] = $results["helpdeskDepartments"][0]["helpdeskDepartment"];
			if($data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
				$s["helpdeskDepartments"] = array(0 => $results["helpdeskDepartments"][0]["helpdeskDepartment"]);
			}
			// $s["admins"] is for the add dept. form, so they can choose the admins to add it for.
			$s["admins"] = $this->getMBAPIData("GetAdmins", "admins", "admin");
			$s["paginationLinks"] = $results["paginationLinks"][0];

			$this->addTemplate("ShowHelpdeskDepartments", collapseArrayElements($s));

		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowHelpdeskDepartments
?>