#!/usr/bin/env php
<?php
// $Id: pipemail.php,v 1.6 2005/10/12 20:22:54 mgarrett Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

/**
 * Make sure that you change this to point to the path of your common.php, after you move this file outside of a web 
 * accessible directory. (Do not change lines that include { or }.)
 *
 * Example:  require_once "/home/myuser/public_html/modernbill/include/common.php";
 * Example:  require_once "C:\www\modernbill\include\common.php";
 */
if(!$CONF || $_REQUEST["CONF"]) {
	require_once "include/common.php";
}

/**
 * This file takes an email from STDIN and parses it, storing it where needed (usually in the helpdesk or something).
 *
 * @author  Vic Fryzel
 */
// Don't bother checking for valid fp, it's STDIN
$data = "";
while(!@feof(STDIN)) {
	$data .= @fread(STDIN, 1024);
}

if($data) {
	// Gather different pieces of data from this email
	$lines = explode("\n", $data);
	$foundBody = false;
	// We don't use the sender yet, but in the future we might need it.
	$subject = $sender = $body = "";
	foreach($lines as $line) {
		$matches = array();
		// Check the subject for 
		if(preg_match("/^Subject:(.*)/i", $line, $matches)) {
			$subject = trim($matches[1]);
		} else if(preg_match("/^From:(.*)/i", $line, $matches)) {
			$sender = trim($matches[1]);
		} else if(!trim($line) && !$foundBody) {
			$foundBody = true;
			continue;
		}
		if($foundBody && !eregi("^>")) {
			$body .= $line."\n";
		}
	}
	
	// Is this even a ticket?
	if(preg_match("/\[([a-z0-9]{5}\-[a-z0-9]{5})\]/i", $subject, $matches)) {
		$ticketKey = $matches[1];
		// Does this key match a ticket in the database?
		$cols = array(getDBCol("hdTicketID"), getDBCol("userID"), getDBCol("userType"));
		$h =& new QueryMaster("select", "hd_tickets");
		foreach($cols as $col) {
			$h->addColumn($col);
		}
		$h->addAndClause(getDBCol("hdTicketKey"), "=", $ticketKey);
		$ticket = $h->getRow();
		$h = NULL;
		
		$xml = "
<mbapi>
 <command>GetHelpdeskTickets</command>
 <params><hdTicketKey>".$ticketKey."</hdTicketKey><numRecords>1</numRecords></params>
</mbapi>";
		$ticket = dispatchMBAPI($xml, 1);
		$ticket =& collapseArrayElements($ticket["mbapi"][0]["results"][0]["tickets"][0]["ticket"][0]);
		if(is_array($ticket) && count($ticket)) {
			$xml = "
<mbapi>
 <command>SetHelpdeskTicketResponse</command>
 <params>
  <hdTicketID>".$ticket["ticketID"]."</hdTicketID>
  <userID>".$ticket["userID"]."</userID>
  <userType>".$ticket["userType"]."</userType>
  <hdTicketRespDateCreated>".mktime()."</hdTicketRespDateCreated>
  <hdTicketRespBody>".secureInput($body)."</hdTicketRespBody>
 </params>
</mbapi>";
			dispatchMBAPI($xml);
		}
	}
	
	// Done
}
?>