<?php
// $Id: EditGeneralJournalEntry.php,v 1.4 2006/06/12 21:59:48 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");

/**
 * This Action displays the page to enter a journal entry.
 *
 * @author  Kris Bailey
 */
class EditGeneralJournalEntry extends MB_Action {
    /**
     * The constructor for a AddGeneralJournalEntry action object. This merely calls the parent constructor,
     * and sets the string representation of this object. This method also sets up $this->params and
     * $this->sortColumns for use in $this->getMBAPIQuery().
     */
    function EditGeneralJournalEntry() {
        parent::MB_Action();
        $this->stringRep = "EditGeneralJournalEntry";

    }

    /**
     * Execute this action object, and display any output generated to the screen.
     *
     * @return  1 if no errors occurred during execution, or 0 if otherwise.
     */
	function execute() {
		global $CONF;
		parent::execute();

		$this->smartyVars = array();

		$generalJournalID = (int)$_REQUEST["generalJournalID"];

		$this->smartyVars["generalJournalID"] = $generalJournalID;

		if(!$generalJournalID) {
			$this->addError(TRANS_ACTIONERROR, "No General Journal ID given.");
		} else {

			$journalInfo = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetAccountingGeneralJournal",
					"params" => array(
						"generalJournalID" => $generalJournalID,
					)
				)
			)));

			if (isset($journalInfo["generalJournalID"])){
				$data =& $journalInfo;
				$this->smartyVars["currencyID"] = $data["currencyID"];
				$this->smartyVars["generalDescription"] = $data["generalDescription"];
				$this->smartyVars["generalDateCreated"] = $data["generalDateCreated"];
				$this->smartyVars["generalDateCreatedYear"] = date("Y", $this->smartyVars["generalDateCreated"]);
				$this->smartyVars["generalDateCreatedMonth"] = date("m", $this->smartyVars["generalDateCreated"]);
				$this->smartyVars["generalDateCreatedDay"] = date("d", $this->smartyVars["generalDateCreated"]);

				$this->smartyVars["formValues"] = $this->smartyVars;

				$entryInfo = correctArray(grabResultsFromMBAPIArraY(array(
					"mbapi" => array(
						"command" => "GetAccountingGeneralLedger",
						"params" => array(
							"journalTableName" => "accounting_general_journal", 
							"journalTableID" => $generalJournalID,
						)
					)
				)));

				if (isset($entryInfo[0]["generalLedgerID"])){

					$this->smartyVars["existingEntries"] = $entryInfo;
					$this->addLedgerAccounts();
					$this->addTemplate("accounting/EditGeneralJournalEntry", $this->smartyVars);

				} else {
					$this->addError(TRANS_ACTIONERROR, "No General Ledger Entries Found.");
				}

			} else {
				$this->addError(TRANS_ACTIONERROR, "General Journal Entry Not Found.");
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditGeneralJournalEntry
?>
