<?php
// $Id: EditLedgerAccountResponse.php,v 1.5 2006/07/06 18:11:34 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");

/**
 * This Action object collects information on a ledger account, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class EditLedgerAccountResponse extends MB_Action {
	/**
	 * The constructor for a EditLedgerAccountResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function EditLedgerAccountResponse() {
		parent::MB_Action();
        $this->stringRep = "EditLedgerAccountResponse";
        $this->params = array(
            "ledgerAccountID",
            "parentLedgerAccountID",
            "ledgerAccountNumber",
            "ledgerAccountType",
            "ledgerAccountName",
            "ledgerAccountTransKey");

	}

	/**
	 * The main method of this class that executes the EditLedgerAccountResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

        $doQuery = 1;
        $this->smartyVars = array();

        if ($_REQUEST["ledgerAccountNumber"]=="" || $_REQUEST["ledgerAccountTransKey"]==""){
            $doQuery = 0;
            $this->smartyVars["errorMessages"][] = TRANS_FORGOT_REQUIRED_FIELDS;
        }

        $subCmd = "update";
        $ledgerAccountID = ((int) $_REQUEST["ledgerAccountID"]);
        if (!$ledgerAccountID) {
            if ((int)$_REQUEST["parentLedgerAccountID"]){
                $getcmd = "<mbapi>
                    <command>GetAccountingLedgerAccounts</command>
                    <params>
                        <ledgerAccountID>".((int)$_REQUEST["parentLedgerAccountID"])."</ledgerAccountID>
                    </params>
                </mbapi>";
                $data = dispatchMBAPI($getcmd, 1);
                $parentType = $data["mbapi"][0]["results"][0]["ledger_accounts"][0]["account"][0]["ledgerAccountType"][0];
                if ($parentType!=$_REQUEST["ledgerAccountType"]){
                    $_REQUEST["parentLedgerAccountID"] = 0;
                }
            }
            $subCmd = "insert";
        }

        $getcmd = "<mbapi>
                    <command>GetAccountingLedgerAccounts</command>
                    <params>
                        <ledgerAccountNumber>".((int)$_REQUEST["ledgerAccountNumber"])."</ledgerAccountNumber>
                    </params>
                </mbapi>";
        $data = dispatchMBAPI($getcmd, 1);
		if ($data["mbapi"][0]["results"] && $data["mbapi"][0]["results"][0]["ledger_accounts"] && $data["mbapi"][0]["results"][0]["ledger_accounts"][0]["account"] && $data["mbapi"][0]["results"][0]["ledger_accounts"][0]["account"][0]["ledgerAccountID"]){
			$checkID = $data["mbapi"][0]["results"][0]["ledger_accounts"][0]["account"][0]["ledgerAccountID"][0];
			$check = ($data["mbapi"][0]["results"][0]["ledger_accounts"][0]["account"][0]["ledgerAccountID"][0])?1:0;
		} else {
			$checkID = 0;
			$check = 0;
		}

        if ($check && $checkID!=$ledgerAccountID){
            $doQuery = 0;
            $this->smartyVars["errorMessages"][] = TRANS_ACCOUNT_NUMBER_USED;
        }


        if ($doQuery){
            $wasSuccessful = 1;
            $query = $this->getMBAPIQuery("SetAccountingGeneralLedgerAccount", $subCmd, array());
            $CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
            $data = dispatchMBAPI($query, 1);
            $CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
            if (!$ledgerAccountID) {
                $ledgerAccountID = ((int) $data["mbapi"][0]["header"][0]["lastInsertID"][0]);
            }
        }

        if ($wasSuccessful){

            if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
                redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
            } else {
                redirect("accounting.php?action=".getActionID("ShowLedgerAccountDetails")."&ledgerAccountID=".$ledgerAccountID."&sid=".secureInput($_REQUEST["sid"]));
            }

        } else {

            $this->smartyVars["request"] = $_REQUEST;

            if ($subCmd=="update"){

                $this->smartyVars["accountTypes"] = $CONF["ledgerCategories"];

                $query = $this->getMBAPIQuery("GetAccountingLedgerAccounts", array("ledgerAccountID"=>(int)$_REQUEST["ledgerAccountID"]));
                $CONF["debug"]->add("Action Command (ShowLedgerAccountDetails:GetAccountingLedgerAccounts)", htmlentities($query));
                $data = dispatchMBAPI($query, 1);
                $CONF["debug"]->add("Action Result (EditLedgerAccount:GetAccountingLedgerAccounts)", $data);

                $this->smartyVars["account"] = collapseArrayElements($data["mbapi"][0]["results"][0]["ledger_accounts"][0]["account"][0]);

                $query2 = "
                    <mbapi>
                        <command>GetAccountingLedgerAccounts</command>
                        <params>
                        </params>
                    </mbapi>
                ";
                $data2 = dispatchMBAPI($query2, 1);
                $CONF["debug"]->add("Action Result (EditLedgerAccountResponse:GetAccountingLedgerAccounts)", $data);

                $this->smartyVars["ledgerAccounts"] = collapseArrayElements($data2["mbapi"][0]["results"][0]["ledger_accounts"][0]["account"]);
                if ($data2["mbapi"][0]["header"][0]["numResults"][0] == 1) {
                    $this->smartyVars["ledgerAccounts"] = array(0 => collapseArrayElements($data2["mbapi"][0]["results"][0]["ledger_accounts"][0]["account"]));
                }
                foreach ($this->smartyVars["ledgerAccounts"] as $k=>$v){
                    if ($v["ledgerAccountType"]!=$this->smartyVars["account"]["ledgerAccountType"] || $v["ledgerAccountID"]==$this->smartyVars["account"]["ledgerAccountID"]){
                        unset($this->smartyVars["ledgerAccounts"][$k]);
                    }
                }

                $this->smartyVars["ledgerAccounts"] = array_values($this->smartyVars["ledgerAccounts"]);

                $this->addTemplate("accounting/EditLedgerAccount", $this->smartyVars);

            } else {
                // insert form display code here
                $this->smartyVars["accountTypes"] = $CONF["ledgerCategories"];

                $query2 = "
                    <mbapi>
                        <command>GetAccountingLedgerAccounts</command>
                        <params>
                        </params>
                    </mbapi>
                ";
                $data2 = dispatchMBAPI($query2, 1);
                $CONF["debug"]->add("Action Result (EditLedgerAccountResponse:GetAccountingLedgerAccounts)", $data);

                $this->smartyVars["ledgerAccounts"] = collapseArrayElements($data2["mbapi"][0]["results"][0]["ledger_accounts"][0]["account"]);
                if($data2["mbapi"][0]["header"][0]["numResults"][0] == 1) {
                    $this->smartyVars["ledgerAccounts"] = array(0 => collapseArrayElements($data2["mbapi"][0]["results"][0]["ledger_accounts"][0]["account"]));
                }

                $this->addTemplate("accounting/AddLedgerAccount", $this->smartyVars);
            }

        }

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditLedgerAccount
?>