<?php
// $Id: ShowAgingReport.php,v 1.1 2006/05/09 02:05:05 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");
require_once mb_path("/lib-action/include/reports/ARAging.php");

/**
 * This class is a child class of MB_Action. It displays the aging report for the selected date.
 *
 * @author  Kris Bailey
 */
class ShowAgingReport extends MB_Action {

	function ShowAgingReport() {
		parent::MB_Action();
		$this->stringRep = "ShowAgingReport";
	}

	function execute() {
		global $CONF;
		parent::execute();

		$this->smartyVars = array();

		$this->reportParams = array(
			"detailLevel" => 0,
			"outputType" => 0,
			);
		
		if (is_array($_REQUEST["reportParams"])){
			foreach ((array)$_REQUEST["reportParams"] as $k=>$v){
				$this->reportParams[$k] = $v;
			}
		}

		// sanify our date
		if ($_REQUEST["dateQuery"]){
			$endPointTimestamp = explode("/", unsecureInput($_REQUEST["dateQuery"][0]));
			if ($endPointTimestamp[0]<1 || $endPointTimestamp[0]>12)$endPointTimestamp[0] = date("m");
			if ($endPointTimestamp[1]<1 || $endPointTimestamp[1]>31)$endPointTimestamp[1] = date("d");
			if ($endPointTimestamp[2]<2000)$endPointTimestamp[2] = date("Y");
			unset($_REQUEST["dateQuery"]); // we dont want addTemplate to throw it to smarty
		} else {
			$endPointTimestamp = explode("/", date("m/d/Y"));
		}
		$this->smartyVars["endDate"] = $this->reportParams["generalLedgerDateCreatedMax"] = mktime(0,0,0,$endPointTimestamp[0],$endPointTimestamp[1]+1,$endPointTimestamp[2]);

		if ($_REQUEST["ledgerAccountIDs"]){
			$this->reportParams["ledgerAccountID"] = array();
			foreach ($_REQUEST["ledgerAccountIDs"] as $acct){
				if ((int)$acct)$this->reportParams["ledgerAccountID"][] = (int)$acct;
			}
		} else {
			$this->reportParams["ledgerAccountID"] = array(getGeneralLedgerAccountID("accounts_receivable"));
		}

		$this->report =& new ARAgingReport($this->reportParams);
		//dbg($this->report->execute());
		$this->smartyVars["reportData"] = $this->report->execute();

		$this->addTemplate("accounting/ShowAgingReport", $this->smartyVars);

	} // execute
} // MB_Action
?>
