<?php
// $Id: ShowGeneralJournal.php,v 1.4 2006/03/22 20:41:02 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all general journal entries that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class ShowGeneralJournal extends MB_Action {
    /**
     * The constructor for a ShowGeneralJournal action object. This merely calls the parent constructor,
     * and sets the string representation of this object. This method also sets up $this->params and
     * $this->sortColumns for use in $this->getMBAPIQuery().
     */
    function ShowGeneralJournal() {
        parent::MB_Action();
        $this->stringRep = "ShowGeneralJournal";

        $this->params = array
        (
            "generalJournalID",
            "generalDescription",
            "currencyID",

            // generalDebitAmount options
            "generalDebitAmount",
            "generalDebitAmountLessThan",
            "generalDebitAmountGreaterThan",

            // generalCreditAmount options
            "generalCreditAmount",
            "generalCreditAmountLessThan",
            "generalCreditAmountGreaterThan",

            // generalDateCreated options
            "generalDateCreated",
            "generalDateCreatedLessThan",
            "generalDateCreatedGreaterThan",

        );

        // handle date searches and correct mismatch of amount labels
        $this->setupDateRequestArgs();

        // handle amount searches and correct mismatch of amount labels
        $this->setupAmountRequestArgs();

        // search in a specific column
        if ($_REQUEST["queryColumn"]!=""){
            if ($_REQUEST["query"]!="") {
                $_REQUEST[$_REQUEST["queryColumn"]] = $_REQUEST["query"];
            }
        } else if ($_REQUEST["query"]!="") {
            $_REQUEST["generalDescription"] = $_REQUEST["query"];
        }

        $this->sortColumns = array
        (
            "generalJournalID",
            "generalDateCreated",
            "generalDescription",
            "generalDebitAmount",
            "generalCreditAmount",
            "currencyID"
        );
    }

    /**
     * Execute this action object, and display any output generated to the screen.
     *
     * @return  1 if no errors occurred during execution, or 0 if otherwise.
     */
    function execute() {
        global $CONF;
        parent::execute();

        $this->smartyVars = array();

        $query = $this->getMBAPIQuery("GetAccountingGeneralJournal", "",  array(), 1, 1, 1, 1);
        $data = dispatchMBAPI($query, 1);

        $results =& $data["mbapi"][0]["results"][0];

        if($this->addMBAPIErrors($data) === 0) {

            // set master invoices data array
            $this->smartyVars["entries"] = collapseArrayElements(
                                                protectArray($results["journalEntries"][0]["entry"])
                                            );

            $this->smartyVars["paginationLinks"] = collapseArrayElements($results["paginationLinks"][0]);
            // call the display template
            $this->addTemplate("accounting/ShowGeneralJournal", $this->smartyVars);

        }
        $this->addErrorTemplates();
        return $this->hasExecutedSuccessfully();
    }
} // ShowGeneralJournal
?>