<?php
// $Id: ShowGeneralLedger.php,v 1.12 2006/03/22 20:41:02 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");

/**
 * This Action object collects information on all receipt journal records that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Michael Fountain
 */
class ShowGeneralLedger extends MB_Action {
	/**
	 * The constructor for a ShowGeneralLedger action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowGeneralLedger() {
		parent::MB_Action();
		$this->stringRep = "ShowGeneralLedger";

		$this->params = array
		(
			"generalLedgerDateCreated",
            "generalLedgerDateCreatedLessThan",
            "generalLedgerDateCreatedGreaterThan",
            "generalLedgerDateCreatedLeast",
            "generalLedgerDateCreatedGreatest"
		);

        // handle date searches and correct mismatch of amount labels
        $this->setupDateRequestArgs();

		$this->sortColumns = array("generalLedgerDateCreated");
	}

	/**
	 * The main method of this class that executes the ShowGeneralLedger action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

        $this->smartyVars = array();

		$xmlArgs = array
		(
			"generalLedgerType" => getGeneralLedgerTypeID("general")
		);
		$query = $this->getMBAPIQuery("GetAccountingGeneralLedger","",$xmlArgs,1,1,1,1);
		$CONF["debug"]->add("Action Command (ShowGeneralLedger::execute GetAccountingGeneralLedger)", htmlentities($query));
		$data = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result (ShowGeneralLedger::execute GetAccountingGeneralLedger)", $data);

        $this->smartyVars["paginationLinks"] = collapseArrayElements($data["mbapi"][0]["results"][0]["paginationLinks"][0]);
		$results =& $data["mbapi"][0]["results"][0]["accounting_general_ledger"][0]["ledger"];


        $this->smartyVars["currencies"] = array();

        for ($i = 0; $i < count($results); $i++){

            $this->smartyVars["currencies"][$results[$i]["currencyID"][0]][] = collapseArrayElements($results[$i]);

        }

        $this->addTemplate("accounting/ShowGeneralLedger", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowGeneralLedger
?>