<?php
// $Id: CloneAdminGroupResponse.php,v 1.8 2006/03/22 20:40:51 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object takes information provided by the CloneAdminGroup action, applies that information to
 * records in the database, and redirects to the ShowAdminGroupDetails action for the given AdminGroup.
 *
 * @author  Andy Christ
 */
class CloneAdminGroupResponse extends MB_Action {
	/**
	 * The constructor for a CloneAdminGroupResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params and defines the possible inputs.
	 */
	function CloneAdminGroupResponse() {
		parent::MB_Action();
		$this->stringRep = "EditAdminGroup";
		$this->params = array(
			"adminGroupName");
	}

	/**
	 * The main method of this class that executes the CloneAdminGroupResponse action, and returns to
	 * the detail screen for this new adminGroup after duplicating the desired group.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$adminGroupID = ((int) $_REQUEST["adminGroupID"]);
		if(!$adminGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No AdminGroup ID given.");
		} else {

			$query = $this->getMBAPIQuery("GetAdminGroups");
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);

			$query = $this->getMBAPIQuery("SetAdminGroups", "insert",collapseArrayElements($data['mbapi'][0]['results'][0]['adminGroups'][0]['adminGroup'][0]));

			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				
				if(!redirect("adminGroups.php",getActionID("ShowAdminGroupDetails"), array("adminGroupID"=>((int) $data["mbapi"][0]["header"][0]["lastInsertID"][0])))) {
					$this->addError(TRANS_ACTIONERROR, "Failed to redirect to adminGroup detail.");
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // CloneAdminGroupResponse
?>