<?php
// $Id: RemoveAdminResponse.php,v 1.12 2006/03/22 20:40:51 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It handles the data from RemoveAdmin action
 * and removes an existing admin record if data is valid; else redirects back to ShowAdminDetails.
 *
 * @author  Michael Fountain
 */
class RemoveAdminResponse extends MB_Action {
	/**
	 * The constructor for an RemoveAdminResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function RemoveAdminResponse() {
		parent::MB_Action();
		$this->stringRep = "RemoveAdminResponse";
	}

	/**
	 * The main method of this class that executes the EditAdminResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$adminID = ((int) $_REQUEST["adminID"]);
		if(!$adminID) {
            $this->addError(TRANS_ACTIONERROR, "No Admin ID given.");
		} elseif ($adminID==$CONF["user"]["id"]) {
            $this->addError(TRANS_ACTIONERROR, "Unable to delete yourself. Nice try.");
        } else {

			// create sanatized xml command
			$cmd = "
			<mbapi>
			    <command>SetAdmins</command>
			    <subCommand>delete</subCommand>
				<params>
					 <adminID>$adminID</adminID>
				</params>
			</mbapi>
			";
			$CONF["debug"]->add("Action Command", htmlentities($cmd), __FILE__, __LINE__);
			$data = dispatchMBAPI($cmd, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			$header = $data['mbapi'][0]['header'][0];
			$results =  $data['mbapi'][0]['results'][0];

			if($this->addMBAPIErrors($data) === 0) {
				// Assign smarty variables
				$smartyVars = array();
				$smartyVars["admin"] = collapseArrayElements($results["admins"][0]['admin'][0]);

				$smartyVars["pageLinks"] = $results["paginationLinks"];
				// Set the templete for output
				//

				//
				
                			// show new admin record
				header("location: admins.php?action=".getActionID("showAdmins"));

			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // MB_Action
?>