<?php
// $Id: ShowAdminDetails.php,v 1.25 2006/07/10 16:10:11 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * This class is a child class of MB_Action. It takes $_REQUEST["adminID"] and displays all
 * the client detail information.
 *
 * @author  Michael Fountain
 */
class ShowAdminDetails extends MB_Action {

	function ShowAdminDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowAdminDetails";
        $this->params = array("adminID");
	}

	/**
	 * The main method of this class that executes the ShowAdmins action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

 		do {
			if($this->err($adminID = getParam("adminID"), "No admin ID given.")) break;
			//echo '<pre>';

			$adminQuery =& new MBQuery(
				"GetAdmins", "",
				array(
					"adminID" => $adminID,
					"getAdminGroupData" => 1,
					"getBookmarkData" => 1,
					"getAllHelpdeskDepartmentData" => 1,
					"getHelpdeskBucketData" => 1,
					"getAssignedTicketData" => 1,
					"getTransferredTicketData" => 1,
				)
			);
			if(!$this->addErrorsFromResult($adminResult =& $adminQuery->getResult())) break;
			$adminTable =& $adminResult->getTableFrom(
				array("mbapi", "results", "admins", "admin"),
				"adminID", "adminName"
			);
			$this->smartyVars['admin'] = $adminTable->getOne();

			$adminGroupSubject =& $adminResult->getSubjectFrom(
				array("mbapi", "results", "admins", "admin", "adminGroupIDs", 0),
				"adminGroupID"
			);
			if($adminGroupData = $adminGroupSubject->getData()) {
				$adminGroupOptions = array_combine($adminGroupData['adminGroupID'], $adminGroupData['adminGroupName']);
				foreach($adminGroupOptions as $adminGroupID => $adminGroupName) {
					$adminGroups[] = array(
						'adminGroupID' => $adminGroupID,
						'adminGroupName' => $adminGroupName,
					);
				}
			} else {
				$adminGroups = array();
			}
			$this->smartyVars['adminGroups'] = $adminGroups;

			$bkQuery =& new MBQuery("GetBookmarks", "", array("adminID" => $adminID, "sortDir" => "desc"));
			$bkData = $bkQuery->GetResult();

			if (!$bkData->getErrorCount()) {
				$this->smartyVars["bookmarkList"] = grabSimpleMBAPIResults( $bkData->getStructure() );
			}

			$this->smartyVars["bookmarkTargets"] = array(
							"_self" => TRANS_LOAD_BOOKMARK_MAIN_PAGE,
							"_top" => TRANS_LOAD_BOOKMARK_MAIN_PAGE,
							"_blank" => TRANS_LOAD_BOOKMARK_NEW_PAGE);
			unset( $bkData, $bkQuery );
			
			$helpdeskDepartmentTable =& $adminResult->getTableFrom(
				array("mbapi", "results", "admins", "admin", "helpdeskDepartments", "helpdeskDepartment"),
				"hdDepartmentID", "hdDepartmentName"
			);
			$this->smartyVars['helpdeskDepartments'] = $helpdeskDepartmentTable->getTable();
			
			$helpdeskBucketTable =& $adminResult->getTableFrom(
				array("mbapi", "results", "admins", "admin", "helpdeskBuckets", "helpdeskBucket"),
				"hdBucketID", "hdBucketName"
			);
			$this->smartyVars['helpdeskBuckets'] = $helpdeskBucketTable->getTable();
			
			$helpdeskAssignedTicketTable =& $adminResult->getTableFrom(
				array("mbapi", "results", "admins", "admin", "helpdeskAssignedTickets", "helpdeskAssignedTicket"),
				"hdTicketID", "hdTicketSubject"
			);
			$this->smartyVars['helpdeskAssignedTickets'] = $helpdeskAssignedTicketTable->getTable();
			
			$helpdeskTransferredTicketTable =& $adminResult->getTableFrom(
				array("mbapi", "results", "admins", "admin", "helpdeskTransferredTickets", "helpdeskTransferredTickets"),
				"hdTicketID", "hdTicketSubject"
			);
			$this->smartyVars['helpdeskTransferredTickets'] = $helpdeskTransferredTicketTable->getTable();
			
			$this->smartyVars["saved"] = (int) $_REQUEST["saved"];
			
			$this->mergeSystemNavData();
			$this->mergeCountryData();
			$this->mergeLanguageData();
			$this->mergeThemeData();
			//print_r($this->smartyVars);
			//echo '</pre>';
			$this->addTemplate("admins/ShowAdminDetails");
			
		} while(false);
       
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // MB_Action
?>
