<?php
// $Id: ShowAdmins.php,v 1.28 2006/06/14 22:19:18 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It lists all admins that match one
 * or many of the input params.
 *
 * @author  Michael Fountain
 */
class ShowAdmins extends MB_Action {

	function ShowAdmins() {
		parent::MB_Action();
		$this->stringRep = "ShowAdmins";

		// set all possible xml params here, $_GET is already cleaned
		$this->params = array
		(
			"adminFirstName",
			"adminLastName",
			"adminEmail",
			"adminUsername"
		);

		// if we are searching for any possible match, set VALID params now
		if ($_REQUEST["query"]!="") {
			if ($_REQUEST["queryColumn"]!="") {
				$_REQUEST[$_REQUEST["queryColumn"]] = $_REQUEST["query"];
			} else {
				foreach($this->params as $value) {
					$_REQUEST[$value] = $_REQUEST["query"];
				}
			}
		}

		// add filtered columns to $this->params LAST, they are NOT searchable
		if (is_numeric($_REQUEST["adminActive"])) {
			$this->params[] = "adminActive";
		}

		// define $sortColumn
		$this->sortColumns = array
		(
			"adminID",
			"adminFirstName",
			"adminLastName",
			"adminEmail",
			"adminUsername"
		);
	}

	/**
	 * The main method of this class that executes the ShowAdmins action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$query = $this->getMBAPIQuery("GetAdmins", "", array("getAdminGroupData"=>1), 1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);

        $header =& $data["mbapi"][0]["header"][0];
		$results =& $data["mbapi"][0]["results"][0];

		if($this->addMBAPIErrors($data) === 0) {
			// Assign smarty variables

            // account for 1 or many admin groups per admin
            $c = count($results["admins"][0]["admin"]);
            for($i=0;$i<$c;$i++){
            	if (isset( $results["admins"][0]["admin"] ))
                	$results["admins"][0]["admin"][$i]["adminGroupIDs"] =
                    		protectArray($results["admins"][0]["admin"][$i]["adminGroupIDs"]);
            }

			$this->smartyVars["admins"] = protectArray($results["admins"][0]["admin"]);
			$this->smartyVars["paginationLinks"] = $results["paginationLinks"][0];

			// assign filtered columns
			if (is_numeric($_REQUEST["adminActive"])) {
				$this->smartyVars["adminActive"] = ((int) $_REQUEST["adminActive"]);
			}
			// assign sortable columns for advanced options
			$this->smartyVars["sortColumns"] = array
			(
				"adminID"		 => TRANS_ADMINID,
				"adminFirstName" => TRANS_FIRST_NAME,
				"adminLastName"  => TRANS_LAST_NAME,
				"adminEmail"     => TRANS_EMAIL,
				"adminUsername"  => TRANS_USERNAME
			);

			// Set the templete for output
            $this->smartyVars = collapseArrayElements($this->smartyVars);
			$this->mergeSystemNavData();
			$this->addTemplate("admins/ShowAdmins",$this->smartyVars, 1);

		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} // execute
} // MB_Action
?>