<?php
// $Id: CloneBookmarkResponse.php,v 1.1 2006/07/10 16:10:11 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It clones a given bookmark over
 * to another admin, allowing them to have the same bookmark as well.
 *
 * @author  Brian Smith
 */
class CloneBookmarkResponse extends MB_Action {
	/**
	 * The constructor for a CloneBookmarkResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function CloneBookmarkResponse() {
		parent::MB_Action();
		$this->stringRep = "CloneBookmarkResponse";
		$this->params = array("bookmarkID", "adminID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$bookmarkID = (int)$_REQUEST["bookmarkID"];
		$adminID = (int)$_REQUEST["adminID"];
		
		if(!notZero($bookmarkID)) {
			$this->addError(TRANS_ACTIONERROR, "No bookmark ID given.");
		} elseif (!notZero($adminID)) {
			$this->addError(TRANS_ACTIONERROR, "No Admin ID given.");
		} else {
			$query =& new MBQuery("GetBookmarks", "", array("bookmarkID" => $bookmarkID));
			$bookmark = $query->GetResult();
			unset($query);
			if (!$bookmark->getErrorCount()) {
				$bookmark = grabSimpleMBAPIResults($bookmark->getStructure());
				$bookmark = $bookmark[0];

				unset($bookmark["bookmarkID"], $bookmark["clientID"], $bookmark["adminID"]);

				// verify admin data
				$test = arrayFor("admins", array("adminID" => $adminID));
				$test = $test[0];
				if (notNull($test)) {
					$bookmark["adminID"] = $adminID;

					$setQuery =& new MBQuery("SetBookmarks", "insert", $bookmark);
					$results = $setQuery->getResult();

					if (!$results->getErrorCount()) {
						if (notNull($_REQUEST["redirectURL"])) {
							$this->goBack();
						} else {
							redirect("admins.php", "ShowAdminDetails", array("adminID" =>$adminID));
						}
					} else {
						foreach( (array)$results->getErrors() as $type => $msg ) {
							$this->addError($type, $msg);
						}
					}
				} else {
					$this->addError(TRANS_ACTIONERROR, "No admin exists for that ID, please verify.");
				}
			}
		} // bookmarkID
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} // execute

} // CloneBookmarkResponse
?>