<?php
// $Id: EditBookmark.php,v 1.16 2006/03/22 20:40:52 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It takes $_REQUEST["bookmarkID"] and displays all
 * the bookmark detail information for editing.
 *
 * @author  Mark Garrett
 */
class EditBookmark extends MB_Action {

	function EditBookmark() {
		parent::MB_Action();
		$this->stringRep = "EditBookmark";
		$this->params = array("bookmarkID");
	}

	/**
	 * The main method of this class that executes the EditBookmark action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$bookmarkID = ((int) $_REQUEST["bookmarkID"]);
		if(!$bookmarkID) {
			$this->addError(TRANS_ACTIONERROR, "No bookmark ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetBookmarks");
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			$results =& $data["mbapi"][0]["results"][0];
	
			// check for errors
			if($data["mbapi"][0]["header"][0]["numResults"][0] != 1) {
				$this->addError(TRANS_ACTIONERROR, "Bookmark ID not found.");
			}

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				// Assign smarty variables
				$smartyVars = array();
				$smartyVars["bookmark"] = $results["bookmarks"][0]["bookmark"];
				$smartyVars["targets"] = array(
				"_self" => "Load bookmark in main page",
				"_blank" => "Load bookmark in new page"
				);

				// Set the templete for output
				$this->addTemplate("bookmarks/EditBookmark", collapseArrayElements($smartyVars), 1);
				$CONF["debug"]->add("Array to Template", collapseArrayElements($smartyVars, __FILE__, __LINE__));

			}
			
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} //execute
} // EditBookmark
?>