<?php
// $Id: RemoveBookmark.php,v 1.3 2006/07/10 16:10:11 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It takes $_REQUEST["bookmarkID"] and displays all
 * the bookmark detail information for removing.
 *
 * @author  Brian Smith
 */
class RemoveBookmark extends MB_Action {

	function RemoveBookmark() {
		parent::MB_Action();
		$this->stringRep = "RemoveBookmark";
		$this->params = array("bookmarkID");
	}

	/**
	 * The main method of this class that executes the RemoveBookmark action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$bookmarkID = (int)$_REQUEST["bookmarkID"];
		
		if(!$bookmarkID) {
			$this->addError(TRANS_ACTIONERROR, "No bookmark ID given.");
		} else {
			$query =& new MBQuery("GetBookmarks", "", array("bookmarkID" => $bookmarkID));
			$bookmark = $query->getResult();
	
			if(!$bookmark->getErrorCount()) {
				// Assign smarty variables
				$bookmark = grabSimpleMBAPIResults($bookmark->getStructure());
				$this->smartyVars["bookmark"] =& $bookmark[0];

				$this->smartyVars["bookmark"]["admin"] = oneOf("admins", array("adminID" => $bookmark[0]["adminID"]));
				
				switch( $bookmark[0]["bookmarkTarget"] ) {
					case "_blank":
						$bookmark[0]["bookmarkTarget"] = TRANS_LOAD_BOOKMARK_NEW_PAGE;
						break;

					default:
						$bookmark["0"]["bookmarkTarget"] = TRANS_LOAD_BOOKMARK_MAIN_PAGE;
						break;
				}

				$this->mergeSystemNavData();
				
				// Set the templete for output
				$this->addTemplate("bookmarks/RemoveBookmark");
			}
			
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} //execute
} // RemoveBookmark
?>