<?php
// $Id: RemoveBookmarkResponse.php,v 1.14 2006/07/10 16:10:11 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It removes a bookmark with an id
 * of $_REQUEST["bookmarkID"]. It redirects the browser to admin profile.
 *
 * @author  Brian Smith
 */
class RemoveBookmarkResponse extends MB_Action {
	/**
	 * The constructor for a RemoveBookmarkResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function RemoveBookmarkResponse() {
		parent::MB_Action();
		$this->stringRep = "RemoveBookmarkResponse";
		$this->params = array("bookmarkID");
	}

	function execute() {
		global $CONF;
		parent::execute();
		
		$bookmarkID = ((int) $_REQUEST["bookmarkID"]);
		if(!$bookmarkID) {
			$this->addError(TRANS_ACTIONERROR, "No bookmark ID given.");
		} else {
			$query =& new MBQuery("SetBookmarks", "delete", array("bookmarkID" => $bookmarkID));
			$data = $query->getResult();
			
			if(!$data->getErrorCount()) {
				
				if (notNull($_REQUEST["redirectURL"])) {
					$this->goBack();
				} else {
					redirect("bookmarks", "ShowBookmarks");
				}
			}
		} // bookmarkID
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} // execute

} // MB_Action
?>