<?php
// $Id: AddCert.php,v 1.10 2006/05/10 20:01:46 mfountain Exp $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/certs.php");

/**
 * This Action object collects information on a cert so that that cert may be added to the 
 * database.
 *
 * @author  Michael Fountain
 */
class AddCert extends MB_Action {
	/**
	 * The constructor for a AddCert action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function AddCert() {
		parent::MB_Action();
		$this->stringRep = "AddCert";
	}

	/**
	 * The main method of this class that executes the AddCert action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$smartyVars = array();
		foreach($CONF["certs"] as $certID => $certInfo) {
			$smartyVars["certProducts"][$certID] = $certInfo[1];
		}

		$this->addTemplate("certs/AddCert",$smartyVars);
		$this->addErrorTemplates();

		return $this->hasExecutedSuccessfully();
	}
} // AddCert
?>