<?php
// $Id: RemoveCertResponse.php,v 1.12 2006/05/10 20:01:46 mfountain Exp $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/certs.php");

/**
 * This Action object takes information provided by the RemoveCert action, and removes the specified cert. *
 * @author  getActionFiles.php (Automatically Generated)
 */
class RemoveCertResponse extends MB_Action {
	/**
	 * The constructor for an RemoveCertResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function RemoveCertResponse() {
		parent::MB_Action();
		$this->stringRep = "RemoveCertResponse";
		$this->params = array("certID");
	}

	/**
	 * The main method of this class that executes the RemoveCertResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$certID = ((int) $_REQUEST["certID"]);
		if(!$certID) {
			$this->addError(TRANS_ACTIONERROR, "No Cert ID given.");
		} else {
			$query = $this->getMBAPIQuery("SetCerts", "delete", array());
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				
				header("Location: certs.php?action=".getActionID("ShowCerts"));
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveCertResponse
?>