<?php
// $Id: ShowCertDetails.php,v 1.15 2006/07/24 22:18:14 bsmith Exp $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/certs.php");

/**
 * This class is a child class of MB_Action. Using $_REQUEST["certID"] it displays all
 * the details for the found cert, and only displays the details of a single cert.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ShowCertDetails extends MB_Action {
	/**
	 * The constructor for a ShowCertDetails object. This merely sets up our string represenation, calls 
	 * the parent constructor, and sets up $this->params.
	 */
	function ShowCertDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowCertDetails";
		$this->params = array("certID");
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$certID = ((int) $_REQUEST["certID"]);
		if(!notZero($certID)) {
			$this->addError(TRANS_ACTIONERROR, "No Cert ID given.");
		} else {
			$cert =& new MBQuery("GetCerts", "", array(
							"getProductPackage" => 1,
							"getClientData"=>1,
							"certID" => $certID));
			$cert = $cert->getResult();
			
			if(!$cert->getErrorCount()) {
				$cert = grabSimpleMBAPIResults( $cert->getStructure() );
				
				$this->smartyVars['cert'] = array_merge($cert[0], oneOf('clientWithPrimary', array('clientID' => $cert[0]['clientID'])));


				$tabbedTable = array(
					// describing the table itself
						"table" => array(
							'tableName' => 'tabbedTable'
							),
					// the tabs
						"tabs" => array(
							"CSRCSRView" => array(
								"displayName" => (defined('TRANS_CSRINFORMATION') ? constant('TRANS_CSRINFORMATION') : 'TRANS_CSRINFORMATION')
								),

							"contactInfo" => array(
								"displayName" => (defined('TRANS_CERTCONTACTINFO') ? constant('TRANS_CERTCONTACTINFO') : 'TRANS_CERTCONTACTINFO'),
								),
							"packageInfo" => array(
								"displayName" => (defined('TRANS_PACKAGE_SUMMARY') ? constant('TRANS_PACKAGE_SUMMARY') : 'TRANS_PACKAGE_SUMMARY'),
								)
								),
					// the rows
						"rows" => array(
						// a tab
							'CSRCSRView' => array(
								array(
									"title" => 'TRANS_SELF_SIGNED_CERT',
									"dataTemplate" => "keyValueOutput",
									"message" => $this->smartyVars['cert']['CSRCSR']
								),
								array(
									"title" => 'TRANS_CSRINFORMATION',
									"dataTemplate" => "keyValueOutput",
									"message" => array(
										array(
											'label' => 'TRANS_DOMAIN_NAME',
											'message' => $this->smartyVars['cert']['CSRDomainName']
											),
										array(
											'label' => 'TRANS_ORGANIZATION',
											'message' => $this->smartyVars['cert']['CSROrganization']
											),
										array(
											'label' => 'TRANS_EMAIL',
											'message' => $this->smartyVars['cert']['CSREmail'],
											),
										array(
											'label' => 'TRANS_ADDRESS',
											'message' => $this->smartyVars['cert']['CSRLocality']." ".$this->smartyVars['cert']['CSRState']." ".$this->smartyVars['cert']['CSRCountry']
											))
								)),
						// another tab
							'contactInfo' => array(
								array(
									"title" => 'TRANS_SUPPLIED_CONTACT',
									"dataTemplate" => "contactInfo",
									"message" => array(
										'name' => $this->smartyVars['cert']['ACFirstName'].' '.$this->smartyVars['cert']['ACLastName'],
										'phone1' => $this->smartyVars['cert']['ACPhone'],
										'email' => $this->smartyVars['cert']['ACEmail']),
									),
								array(
									"title" => 'TRANS_TECHNICAL_CONTACT',
									"dataTemplate" => "contactInfo",
									"message" => array(
										'name' => $this->smartyVars['cert']['TCFirstName'].' '.$this->smartyVars['cert']['TCLastName'],
										'phone1' => $this->smartyVars['cert']['TCPhone'],
										'email' => $this->smartyVars['cert']['TCEmail'])
									),
								array(
									"title" => 'TRANS_BILLING_CONTACT',
									"dataTemplate" => "contactInfo",
									"message" => array(
										'name' => $this->smartyVars['cert']['BCFirstName'].' '.$this->smartyVars['cert']['BCLastName'],
										'phone1' => $this->smartyVars['cert']['BCPhone'],
										'email' => $this->smartyVars['cert']['BCEmail'])
									)
									),
						// yet another tab
							'packageInfo' => array(
								array(
									'title' => 'TRANS_PACKAGE_SUMMARY',
									'dataTemplate' => 'packageInfo',
									'message' => array(
										'packageName' => $this->smartyVars['cert']['packageName'],
										'packageDateCreated' => $this->smartyVars['cert']['packageDateCreated'],
										'packageQuantity' => $this->smartyVars['cert']['packageQuantity'],
										'cycleID' => $this->smartyVars['cert']['cycleID']),
								)
								)
							
						
								) // rows
								);
				$this->smartyVars['tabbedTable'] =& $tabbedTable;
				
				$this->mergeCycleData();
				$this->smartyVars["packageStatuses"] = getStatuses("package");

				
				$this->addTemplate("certs/ShowCertDetails");
			} else {
				$this->addError(TRANS_ACTIONERROR, "Cert does not exist.");
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowCertDetails
?>