<?php
// $Id: AddBillingAccount.php,v 1.16 2006/07/27 20:55:24 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It displays a form to add a new
 * client billing account record.
 *
 * @author  Michael Fountain
 */
class AddBillingAccount extends MB_Action {

	function AddBillingAccount() {
		parent::MB_Action();
		$this->stringRep = "AddBillingAccount";
		$this->params = array(
			"clientID",
			"clientContactID",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();

		$clientID = getParam('clientID');
		$clientContactID = getParam('clientContactID');
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else if(!$clientContactID) {
			$this->addError(TRANS_ACTIONERROR, "No client contact ID given.");
		} else {

			$query = $this->getMBAPIQuery("GetClients", "", array("getContactData"=> "4"));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$this->smartyVars["client"] = collapseArrayElements($results["clients"][0]["client"][0]);
				$this->smartyVars["contact"] = collapseArrayElements($results["clients"][0]["client"][0]["contacts"][0]["contact"][0]);
				$this->smartyVars["billingAccountTypes"] = $CONF["types"]["billingAccount"];
				$this->smartyVars["bankAccountTypes"] = $CONF["types"]["bankAccount"];
				$this->smartyVars["cardTypes"] = $CONF["types"]["card"];
				$this->smartyVars["cardExtraTypes"] = $CONF["types"]["cardExtraIDs"];
				
				$defaults = array(
					"billingAccountOrder" => "0",
					"billingAccountPercent" => "100.0",
				);
				$this->mergeFormState($defaults);
				// do we have an lek stored?
				if ($CONF["system"]["encryption"]["lek_pin"]==''){
					$this->smartyVars["needKey"] = 1;
				}

				$this->addTemplate("clients/AddBillingAccount", $this->smartyVars);
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	}
} // MB_Action
?>