<?php
// $Id: AddClientCreditResponse.php,v 1.3 2006/03/22 20:40:52 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It adds a client credit and redirects.
 *
 * @author  Kris Bailey
 */
class AddClientCreditResponse extends MB_Action {

	function AddClientCreditResponse() {
		parent::MB_Action();
		$this->stringRep = "AddClientCreditResponse";
	}

	function execute() {
		global $CONF;
		parent::execute();

		$clientID = (int)$_REQUEST["clientID"];
		if (!$clientID){
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else {

		 	if (doubleval($this->getNumberFromInput($_REQUEST["creditAmount"]))){
				$creditXML = "	<mbapi>
									<command>SetCreditAccounting</command>
									<params>
										<clientID>".$clientID."</clientID>
										<ledgerAccountName>".secureInput($_REQUEST["ledgerAccountName"])."</ledgerAccountName>
										<amount>".doubleval($this->getNumberFromInput($_REQUEST["creditAmount"]))."</amount>
										<currencyID>".secureInput($_REQUEST["creditCurrencyID"])."</currencyID>
										<description>".secureInput($_REQUEST["creditComments"])."</description>
									</params>
								</mbapi>";
				$data = dispatchMBAPI($creditXML, 1);
				dbg($data);
				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
						redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
					} else {
						redirect("clients.php", getActionID("ShowClientDetails"), array("clientID"=>$clientID));
					}
				}
			} else {
			 	dbg("didnt get a credit amount.");
				redirect("clients.php", getActionID("ShowClientDetails"), array("clientID"=>$clientID));
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} // execute

} // MB_Action
?>