<?php
// $Id: AddClientResponse.php,v 1.34 2006/05/10 21:54:51 mgarrett Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It handles the data from AddClient action
 * and creates a new client record if data is valid; else redirects back to AddClient.
 *
 * @author  modernbill
 */
class AddClientResponse extends MB_Action {

	function AddClientResponse() {
		parent::MB_Action();
		$this->stringRep = "AddClientResponse";
		$this->params = array
		(
			"contactFirstName",
			"contactLastName",
			"contactEmail",
			"clientCompany",
			"contactPasswordConfirm",
			"applyTax",
			"taxIDNumber",
			"languageID",
			"countriesID",
			"themeID",
			"companyID",
			"clientActive",
			"clientDateCreated",
			// to be converted to extra params and stripped: 
			"contactAddress1",
			"contactAddress2",
			"contactCity",
			"contactState",
			"contactZip",
			"contactPhone1",
			"contactPhone2",
			"contactFax",
			"contactDateCreated",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();

		// XXX hack
		$_REQUEST['companyID'] = 1;

		$this->setReferralActionID(getActionID("AddClient"));
		$this->setReferralActionFile("clients.php");


		$success = $this->validateMultiInputs(
			array(
				"contactFirstName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactLastName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactEmail" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"clientCompany" => INPUT_RESTRICTION_STRING,
				"contactUsername" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactPassword" => array(INPUT_RESTRICTION_PASSWORD|INPUT_RESTRICTION_REQUIRED, array('confirm' => 'contactPasswordConfirm')),
				"applyTax" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"taxIDNumber" => INPUT_RESTRICTION_STRING,
				"languageID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"countriesID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"themeID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"companyID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"clientActive" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"contactAddress1" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactAddress2" => INPUT_RESTRICTION_STRING,
				"contactCity" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactState" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactZip" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactPhone1" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactPhone2" => INPUT_RESTRICTION_STRING,
				"contactFax" => INPUT_RESTRICTION_STRING,
			),
			array(
				'contactPassword',
				'contactPasswordConfirm',
				'clientDateCreated',
				'contactDateCreated',
			)
		);

		if($success) {
			unset($_REQUEST['contactPasswordConfirm']);
			$_REQUEST["clientDateCreated"] = microtime(1);
			$_REQUEST["contactDateCreated"] = mktime();

			$contactXML = "\n<contactFirstName>" . $_REQUEST['contactFirstName'] . "</contactFirstName>\n"
				. "<contactLastName>" . $_REQUEST["contactLastName"] . "</contactLastName>\n"
				. "<contactEmail>" . $_REQUEST["contactEmail"] . "</contactEmail>\n"
				. "<contactUsername>" . $_REQUEST["contactUsername"] . "</contactUsername>\n"
				. "<contactPassword>" . $_REQUEST["contactPassword"] . "</contactPassword>\n"
				. "<contactCompany>" . $_REQUEST["clientCompany"] . "</contactCompany>\n"
				. "<contactAddress1>" . $_REQUEST["contactAddress1"] . "</contactAddress1>\n"
				. "<contactAddress2>" . $_REQUEST["contactAddress2"] . "</contactAddress2>\n"
				. "<contactCity>" . $_REQUEST["contactCity"] . "</contactCity>\n"
				. "<contactState>" . $_REQUEST["contactState"] . "</contactState>\n"
				. "<contactZip>" . $_REQUEST["contactZip"] . "</contactZip>\n"
				. "<languageID>" . $_REQUEST["languageID"] . "</languageID>\n"
				. "<countriesID>" . $_REQUEST["countriesID"] . "</countriesID>\n"
				. "<contactPhone1>" . $_REQUEST["contactPhone1"] . "</contactPhone1>\n"
				. "<contactPhone2>" . $_REQUEST["contactPhone2"] . "</contactPhone2>\n"
				. "<contactFax>" . $_REQUEST["contactFax"] . "</contactFax>\n"
				. "<contactDateCreated>" . $_REQUEST["contactDateCreated"] . "</contactDateCreated>\n"
				. "<contactActive>1</contactActive>\n"
				. "<contactEmailFormat>1</contactEmailFormat>\n"
				. "<contactPrimary>1</contactPrimary>\n";
			
			$primaryContactParams = array(
				'clientContacts' => array(
					'clientContact' => array(
						'0' => $contactXML
					)
				)
			);
	
			$query = $this->getMBAPIQuery("SetClients", "insert", $primaryContactParams,
				0, 0, 0, 0, 0,
				array(
					"contactAddress1",
					"contactAddress2",
					"contactCity",
					"contactState",
					"contactZip",
					"contactPhone1",
					"contactPhone2",
					"contactFax",
					"contactDateCreated",
				)
			);
			$data = dispatchMBAPI($query, 1);
			
			$results =& $data["mbapi"][0]["results"][0];
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
				} else {
					$clientID = ((int) $data["mbapi"][0]["header"][0]["lastInsertID"][0]);
					redirect("clients.php", getActionID("ShowClientDetails"), array("clientID"=>$clientID));
				}
			}
		}
			
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} // execute

} // MB_Action
?>
