<?php
// $Id: EditBillingAccountResponse.php,v 1.22 2006/06/19 17:40:36 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/types.php");

/**
 * This class is a child class of MB_Action. It handles the data from EditBillingAccount action
 * and modifies an existing client billing account record if data is valid; else
 * redirects back to EditBillingAccount.
 *
 * @author  Michael Fountain
 */
class EditBillingAccountResponse extends MB_Action {

	function EditBillingAccountResponse() {
		parent::MB_Action();
		$this->stringRep = "EditBillingAccountResponse";
		
		// set all possible xml params here, $_REQUEST is already cleaned
		$this->params = array
		(
			"clientID",
			"clientContactID",
			"billingAccountID",
			// account
			"billingAccountType",
			"billingAccountOrder",
			"billingAccountPercent",
			"billingAccountPercentEqual",
			// card account
			"billingCardType",
			"billingCardNum",
			"billingCardExpMonth",
			"billingCardExpYear",
			"billingCardIssueNum",
			"billingCardStartDate",
			// bank account
			"billingBankType",
			"billingBankName",
			"billingBankState",
			"billingBankAbaCode",
			"billingBankAccountNum",
			"billingBankLicenseNum",
			"billingBankLicenseState",
			"billingBankDob",
			"encKey",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();

		$this->setReferralActionID(getActionID("EditBillingAccount"));
		$this->setReferralActionFile("clients.php");

		// if these fields are blank, we don't change them.
		if($_REQUEST['billingBankAccountNum'] === '') {
			unset($_REQUEST['billingBankAccountNum']);
		}
		if($_REQUEST['billingCardNum'] === '') {
			unset($_REQUEST['billingCardNum']);
		}

		// save for later 
		//$billingAccountPercentEqual = (int) $_REQUEST["billingAccountPercentEqual"];
		$billingAccountType = (int) $_REQUEST["billingAccountType"];
		$edit = array();
		$typeName = getTypeName("billingAccount", $billingAccountType);
		if($typeName == TRANS_MANUAL_PAYMENT_ACCOUNT || $typeName == TRANS_SECONDARY_ACCOUNT) {
			unset($_REQUEST['billingBankType']);
			unset($_REQUEST['billingBankName']);
			unset($_REQUEST['billingBankState']);
			unset($_REQUEST['billingBankABACode']);
			unset($_REQUEST['billingBankAccountNum']);
			unset($_REQUEST['billingBankLicenseNum']);
			unset($_REQUEST['billingBankLicenseState']);
			unset($_REQUEST['billingBankDob']);

			unset($_REQUEST['billingCardNameOnCard']);
			unset($_REQUEST['billingCardType']);
			unset($_REQUEST['billingCardNum']);
			unset($_REQUEST['billingCardExpMonth']);
			unset($_REQUEST['billingCardExpYear']);
			unset($_REQUEST['billingCardIssueNum']);
			unset($_REQUEST['billingCardStartDate']);
			$edit = array(
				"clientID",
				"clientContactID",
				"billingAccountID",
			);
		} else if($typeName == TRANS_CREDIT_CARD_ACCOUNT) {
			unset($_REQUEST['billingBankType']);
			unset($_REQUEST['billingBankName']);
			unset($_REQUEST['billingBankState']);
			unset($_REQUEST['billingBankABACode']);
			unset($_REQUEST['billingBankAccountNum']);
			unset($_REQUEST['billingBankLicenseNum']);
			unset($_REQUEST['billingBankLicenseState']);
			unset($_REQUEST['billingBankDob']);
			$edit = array(
				"clientID",
				"clientContactID",
				"billingAccountID",
				// account
				"billingAccountType",
				"billingAccountOrder",
				"billingAccountPercent",
				// card account
				"billingCardNameOnCard",
				"billingCardType",
				"billingCardNum",
				"billingCardExpMonth",
				"billingCardExpYear",
			);
			$billingCardType = (int) $_REQUEST["billingCardType"];
			$cardExtraTypes = $CONF["types"]["cardExtraIDs"];
			if(in_array($billingCardType, $cardExtraTypes)) {
				$edit = array_merge(
					$edit,
					array(
						"billingCardIssueNum",
						"billingCardStartDate",				
					)
				);
			} else {
				unset($_REQUEST['billingCardIssueNum']);
				unset($_REQUEST['billingCardStartDate']);
			}
		} else {
			unset($_REQUEST['billingCardNameOnCard']);
			unset($_REQUEST['billingCardType']);
			unset($_REQUEST['billingCardNum']);
			unset($_REQUEST['billingCardExpMonth']);
			unset($_REQUEST['billingCardExpYear']);
			unset($_REQUEST['billingCardIssueNum']);
			unset($_REQUEST['billingCardStartDate']);
			$edit = array(
				"clientID",
				"clientContactID",
				"billingAccountID",
				// account
				"billingAccountType",
				"billingAccountOrder",
				"billingAccountPercent",
				// bank account
				"billingBankType",
				"billingBankName",
				"billingBankState",
				"billingBankAbaCode",
				"billingBankAccountNum",
				"billingBankLicenseNum",
				"billingBankLicenseState",
				"billingBankDob",
			);
		}

		$success = $this->validateMultiInputs(
			array(
				"clientID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"clientContactID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"billingAccountID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				// account
				"billingAccountType" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"billingAccountOrder" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"billingAccountPercent" => INPUT_RESTRICTION_DOUBLE|INPUT_RESTRICTION_REQUIRED,
				"billingAccountPercentEqual" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				// card account
				"billingCardNameOnCard" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"billingCardType" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"billingCardNum" => array(
					INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED|INPUT_RESTRICTION_MAXLEN|INPUT_RESTRICTION_MINLEN|INPUT_RESTRICTION_CARD,
					array(
						'maxLength' => 16,
						'minLength' => 13,
						'allowedCardTypes' => getTypeName("card", $_REQUEST['billingCardType']),
					),
				),
				"billingCardExpMonth" => INPUT_RESTRICTION_MONTH|INPUT_RESTRICTION_REQUIRED,
				"billingCardExpYear" => INPUT_RESTRICTION_YEAR|INPUT_RESTRICTION_REQUIRED,
				"billingCardIssueNum" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"billingCardStartDate" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				// bank account
				"billingBankType" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"billingBankName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"billingBankState" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"billingBankAbaCode" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"billingBankAccountNum" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"billingBankLicenseNum" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"billingBankLicenseState" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"billingBankDob" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
			),
			array(
				// secure params
				"billingCardType",
				"billingCardNum",
				"billingCardExpMonth",
				"billingCardExpYear",
				"billingCardIssueNum",
				"billingCardStartDate",				
				"billingBankAccountNum",
				// perhaps more bank data should be stripped as well		
			),
			$edit,
			1 // for edit mode
		);
		
		
		dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "SetBillingAccountShare",
				"subCommand" => "delete",
				"params" => array(
					"billingAccountID" => (int)$_REQUEST["billingAccountID"],
				),
			),
		)));
		
		foreach ((array)$_REQUEST["packages"] as $packageID){
			if ((int)$packageID){
				dispatchMBAPI(toXML(array(
					"mbapi" => array(
						"command" => "SetBillingAccountShare",
						"subCommand" => "insert",
						"params" => array(
							"billingAccountID" => (int)$_REQUEST["billingAccountID"],
							"billingAccountShareGroup" => "0",
							"billingAccountFallbackGroup" => "1",
							"billingAccountShareValue" => "1",
							"packageID" => (int)$packageID
						),
					),
				)));
			}
		}
		
		
		if($success) {

			$clientID = (int) $_REQUEST["clientID"];
			$clientContactID = (int) $_REQUEST["clientContactID"];
			$billingAccountID = (int) $_REQUEST["billingAccountID"];
			if(!$clientID) {
				$this->addError(TRANS_ACTIONERROR, "No client ID given.");
			} else if(!$clientContactID) {
				$this->addError(TRANS_ACTIONERROR, "No client contact ID given.");
			} else if(!$billingAccountID) {
				$this->addError(TRANS_ACTIONERROR, "No billing account ID given.");
			} else {
	
				// set all possible xml params here, $_REQUEST is already cleaned
				$params = array
				(
					// account
					"billingAccountType",
					"billingAccountOrder",
					"billingAccountPercent",
					// card account
					"billingCardNameOnCard",
					"billingCardType",
					"billingCardNum",
					"billingCardExpMonth",
					"billingCardExpYear",
					"billingCardIssueNum",
					"billingCardStartDate",
					// bank account
					"billingBankType",
					"billingBankName",
					"billingBankState",
					"billingBankAbaCode",
					"billingBankAccountNum",
					"billingBankLicenseNum",
					"billingBankLicenseState",
					"billingBankDob",
					"encKey",
				);
				$xmlParams = "";
				foreach ($params as $paramName) {
					if (isset($_REQUEST["$paramName"]) && $_REQUEST["$paramName"]!='') {
	
						// set xml paramValue
						$xmlParams = $xmlParams."<$paramName>".$_REQUEST["$paramName"]."</$paramName>\n";
					}
				}
	
				// create sanatized xml command
				$cmd = "
				<mbapi>
				    <command>SetClients</command>
				    <subCommand>update</subCommand>
					<params>
						<clientID>$clientID</clientID>
						<clientContacts>
							<clientContact>
								<clientContactID>$clientContactID</clientContactID>
								<clientBillingAccounts>
									<clientBillingAccount>
										<billingAccountID>$billingAccountID</billingAccountID>
										$xmlParams
									</clientBillingAccount>
								</clientBillingAccounts>
							</clientContact>
						</clientContacts>
					</params>
				</mbapi>
				";

				$CONF["debug"]->add("Action Command", htmlentities($cmd), __FILE__, __LINE__);
				$data = dispatchMBAPI($cmd, 1);
				$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
	
				$billingAccountID = $data["mbapi"][0]["header"][0]["lastInsertID"][0];
	
				$results =& $data["mbapi"][0]["results"][0];

				//exit;
				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
						redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
					} else {
						redirect("clients.php", getActionID("ShowBillingAccounts"), array("clientID"=>$clientID, "clientContactID"=>$clientContactID));
					}
				}

			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	} // execute

} // MB_Action
?>
