<?php
// $Id: EditClientContactResponse.php,v 1.25 2006/06/16 03:42:44 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It handles the data from EditClientContact action
 * and modifies an existing client contact record if data is valid; else redirects back to EditClientContact.
 *
 * @author  Michael Fountain
 */
class EditClientContactResponse extends MB_Action {

	function EditClientContactResponse() {
		parent::MB_Action();
		$this->stringRep = "EditClientContactResponse";

		// set all possible xml params here, $_REQUEST is already cleaned
		$this->params = array
		(
			"clientContactID",
			"contactFirstName",
			"contactLastName",
			"contactEmail",
			"contactUsername",
			"contactEmailFormat",
			"contactCompany",
			"contactAddress1",
			"contactAddress2",
			"contactCity",
			"contactState",
			"contactZip",
			"countriesID",
			"languageID",
			"contactPhone1",
			"contactPhone2",
			"contactFax",
			"contactPrimary",
			"emailActionIDs",
			"contactActive"
		);
	}

	function execute() {
		global $CONF;
		parent::execute();

		$this->setReferralActionID(getActionID("EditClientContact"));
		$this->setReferralActionFile("clients.php");

		require_once mb_path("/lib-tk/toolkit.php");
		$d =& new DataSource("clients", array("getContactData" => 1));
		$s =& $d->getSubject();
		$contactsByID =& $s->getAdditionalDataByKey("contacts", "contact");
		$contacts = new Table(array(), "clientContactID");
		foreach($contactsByID as $id => $contactsForID) {
			$contactTable =& $contactsForID->getTable();
			$contactTable->setKey("clientContactID");
			$contacts =& $contacts->getMergedWith($contactTable);
		}
		//echo (int) $contacts->valExistsInCol($_REQUEST["contactUsername"], "contactUsername");

//Pick back up here with the dup username check -AC

		$success = $this->validateMultiInputs(
			array(
				"clientContactID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"contactFirstName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactLastName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactUsername" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactPassword" => array(INPUT_RESTRICTION_PASSWORD, array("confirm" => "contactPasswordConfirm")),
				"contactEmail" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactEmailFormat" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"contactCompany" => INPUT_RESTRICTION_STRING,
				"contactAddress1" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactAddress2" => INPUT_RESTRICTION_STRING,
				"contactCity" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactState" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactZip" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"countriesID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"languageID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"contactPhone1" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"contactPhone2" => INPUT_RESTRICTION_STRING,
				"contactFax" => INPUT_RESTRICTION_STRING,
				"contactPrimary" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
			),
			array(
				"contactPassword",
				"contactPasswordConfirm",
			),
			array(),
			1 // for edit mode
		);
		if($success) {
			unset($_REQUEST["contactPasswordConfirm"]);
			$clientContactID = ((int) $_REQUEST["clientContactID"]);
			if(!$clientContactID) {
				$this->addError(TRANS_ACTIONERROR, "No contact ID given.");
			} else {

				// only update the password if set
				unset($_REQUEST["contactPasswordConfirm"]);
				if ($_REQUEST["contactPassword"]=="") {
					unset($_REQUEST["contactPassword"]);
				} else {
					$this->params[] = "contactPassword";
				}

				$xmlParams = "";
				foreach ($this->params as $paramName) {
					if ($paramName == "emailActionIDs"){
						$xmlParams .= "<emailActionIDs>\n";
						foreach((array)$_REQUEST["emailActionIDs"] as $key=>$eaid){
							$xmlParams .= "<emailActionID>".(int)$eaid."</emailActionID>\n";
						}
						$xmlParams .= "</emailActionIDs>\n";
					}else{
						$xmlParams .= "<".$paramName.">".$_REQUEST[$paramName]."</".$paramName.">\n";
					}
				}

				// fetch client ID for this contact first
				$query = "
				<mbapi>
				    <command>GetClients</command>
					<params>
						 <clientContactID>$clientContactID</clientContactID>
					</params>
				</mbapi>
				";
				$data = dispatchMBAPI($query, 1);
	
				$clientID = $data["mbapi"][0]["results"][0]["clients"][0]["client"][0]["clientID"][0];
	
				// create sanatized xml command
				$query = "
				<mbapi>
				    <command>SetClients</command>
				    <subCommand>update</subCommand>
					<params>
						<clientID>$clientID</clientID>
						<clientContacts>
							<clientContact>
								<clientContactID>$clientContactID</clientContactID>																		
								$xmlParams
							</clientContact>
						</clientContacts>
					</params>
				</mbapi>
				";
	
				$data = dispatchMBAPI($query, 1);
	
				$results =& $data["mbapi"][0]["results"][0];
				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
						redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
					} else {
						redirect("clients.php", getActionID("ShowClientContacts"), array("clientID"=>$clientID));
					}
				}
	
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	} // execute

} // MB_Action
?>
