<?php
// $Id: EditClientResponse.php,v 1.32 2006/05/05 19:30:37 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It handles the data from EditClient action
 * and modifies an existing client record if data is valid; else redirects back to EditClient.
 *
 * @author  Michael Fountain
 */
class EditClientResponse extends MB_Action {

	function EditClientResponse() {
		parent::MB_Action();
		$this->stringRep = "EditClientResponse";
		$this->params = array
		(
			"clientID",
			"clientCompany",
			"clientStatus",
			"applyTax",
			"taxIDNumber",
			"languageID",
			"countriesID",
			"themeID",
			"clientActive",
			"clientDateCreated",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();

		$clientID = ((int) $_REQUEST["clientID"]);
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else {

			$this->setReferralActionID(getActionID("EditClient"));
			$this->setReferralActionFile("clients.php");
			$success = $this->validateMultiInputs(
				array(
					"clientID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
					"clientCompany" => INPUT_RESTRICTION_STRING,
					"clientStatus" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
					"applyTax" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
					"taxIDNumber" => INPUT_RESTRICTION_STRING,
					"languageID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
					"countriesID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
					"themeID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
					"clientActive" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				),
				array(
					'clientDateCreated',
				),
				array(),
				1 // for edit mode
			);
			if($success) {
				$_REQUEST["clientDateCreated"] = mktime();
				
				$query = $this->getMBAPIQuery("SetClients", "update", array());
				$data = dispatchMBAPI($query, 1);
	
				$results =& $data["mbapi"][0]["results"][0];
				
				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
						redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
					} else {
						//$clientID = ((int) $data["mbapi"][0]["header"][0]["lastInsertID"][0]);
						redirect("clients.php", getActionID("ShowClientDetails"), array("clientID"=>$clientID));
					}
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} // execute

} // MB_Action
?>