<?php
// $Id: ForwardToClientInterface.php,v 1.2 2006/06/29 15:16:55 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. When the clientContactID and clientID is passed
 * and the user is an administrator type, then the admin will be "droped" into the client
 * interface for clientContactID.
 *
 * @author  Brian Smith
 */
class ForwardToClientInterface extends MB_Action {

	function ForwardToClientInterface() {
		parent::MB_Action();
		$this->stringRep = "ForwardToClientInterface";
		$this->params = array
		(
			"clientID",
			"clientContactID"
		);
	}

	function execute() {
		global $CONF;
		parent::execute();
		
		$clientID = (int)$_REQUEST["clientID"];
		$clientContactID = (int)$_REQUEST["clientContactID"];

		if(!notZero($clientID) || !notZero( $clientContactID)) {
			$this->addError(TRANS_ACTIONERROR, "Client ID and Client Contact ID are required.");
		} else {
			$getUrl =& new MBQuery("GetClients", "", array(
							"clientID" => $clientID,
							"getCompanyData" => 1));
			$urlResult = $getUrl->getResult();
			
			$clientInterfaceLocation = "";
			if ($urlResult->getErrorCount()) {
				$this->addError(TRANS_ACTIONERROR, "Failed to fetch Client URL information.");
			} else {
				$urlResult = grabSimpleMBAPIResults( $urlResult->getStructure() );
				$clientInterfaceLocation = $urlResult[0]["companyClientURL"];
			}
			unset( $urlResult, $getUrl );
	
			if (!notNull( $clientInterfaceLocation )) {
				$this->addError(TRANS_ACTIONERROR, "Client interface location is not set in the system configuration.");
			} elseif ($this->getErrors()) {
				// do nothing
				
			} else {
				if ((int)$CONF["user"]["type"] == 2) { // The current user IS an admin
					$clientQuery =& new MBQuery("GetClients", "", array(
										"clientID" => $clientID,
										"clientContactID" => $clientContactID,
										"getContactData" => 4));
					$clientResult = $clientQuery->getResult();
					unset($clientQuery);
					if (!$clientResult->getErrorCount()) {
						// golden
						$clientResults = grabSimpleMBAPIResults($clientResult->getStructure());
						$clientResults = $clientResults[0];
						unset($clientResult);
	
						if (notZero( $clientResults["clientID"] ) && notZero( $clientResults["contacts"][0]["contact"][0]["clientContactID"] )) {
							// destroy any existing shell so that we may log in.
							$destroySessionQuery =& new MBQuery("SetSession", "delete", array(
													"userType" => 1,
													"userID" => $clientContactID));
							$destroySessionQuery->getResult(); // run the query
							unset($destroySessionQuery);
	
							$newSid = sha1(strval(mt_rand(0, 200000000)).strval(microtime()).strval(mt_rand(0, 200000000)));
							
							$newSessionQuery =& new MBQuery("SetSession", "insert", array(
													"userID" => $clientContactID,
													"userType" => 1, // regular user type
													"sessionIP" => ip2long($CONF["user"]["ip"]),
													"sessionActive" => 1,
													"sessionID" => $newSid,
													"sessionDateActive" => mktime(),
													"sessionDateCreated" => mktime(),
													"sessionDateExpired" => (int)(mktime()+$CONF["system"]["sessions"]["adminSessionLength"])));
							$newSessionQuery->getResult();	// create the new session
							unset($newSessionQuery);
					
							$addr = str_replace(array("//",":/"), array("/","://"),$clientInterfaceLocation."/dashboard.php?action=".getActionID("ShowDashboard")."&sid=".$newSid);
							dbg("SENDING TO:\t".$addr);
							
							if (headers_sent()) {
								dbg("Redirecting VIA Javascript");
								echo "<script language=\"javascript\" type=\"text/javascript\">"
									."//<![[CDATA][\n"
									."\tdocument.location.href = '$addr';\n"
									."//]]>\n"
									."</script>";
							} else {
								dbg("Redirecting VIA Header Redirect");
								header("Location: ".$addr);
							}
						}
					} else {
						$this->addError(TRANS_ACTIONERROR, "Unable to fetch Client Information.");
					}
				} else {
					$this->addError(TRANS_ACTIONERROR, "Must be an admin to process.");
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}

?>