<?php
// $Id: ManageClientNotesResponse.php,v 1.5 2006/03/22 20:40:52 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It handles the data from ManageClientNotes actions
 *
 * @author  Ben Woolley
 */
class ManageClientNotesResponse extends MB_Action {

	function ManageClientNotesResponse() {
		parent::MB_Action();
		$this->stringRep = "ManageClientNotesResponse";

		// set all possible xml params here, $_REQUEST is already cleaned
		$this->params = array
		(
			"clientID",
			"clientNoteID",
			"clientNoteText",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();

		$this->setReferralActionID(getActionID("ManageClientNotes"));
		$this->setReferralActionFile("clients.php");
		$success = $this->validateMultiInputs(
			array(
				"clientID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"clientNoteText" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
			)
		);
		if($success) {
			$clientID = ((int) $_REQUEST["clientID"]);
			if(!$clientID) {
				$this->addError(TRANS_ACTIONERROR, "No client ID given.");
			} elseif($success) {
	
				$adminID = $CONF["user"]["id"];
				$adminQuery = $this->getMBAPIQuery("GetAdmins","",array("adminID"=>$adminID),0,0,0,0,0,$this->params);
				$adminData = dispatchMBAPI($adminQuery, 1);
				$adminResults =& $adminData["mbapi"][0]["results"][0];

				$admin = collapseArrayElements($adminResults["admins"][0]["admin"][0]);
				$clientNoteID = ((int) $_REQUEST["clientNoteID"]);

				if($clientNoteID) {
					$editXML = '<clientNoteID>'.$clientNoteID.'</clientNoteID>';
					$createdXML = '';
					$modifiedXML = "<clientNoteDateModified>".mktime()."</clientNoteDateModified>";
				} else {
					$editXML = '';
					$createdXML = "<clientNoteDateCreated>".mktime()."</clientNoteDateCreated>";
					$modifiedXML = '<clientNoteDateModified>0</clientNoteDateModified>';
				}

				// create sanatized xml command
				$cmd = "
				<mbapi>
				    <command>SetClients</command>
				    <subCommand>insert</subCommand>
					<params>
						<clientID>$clientID</clientID>
						<clientNotes>
							<clientNote>
								$editXML
								<adminID>".$admin["adminID"]."</adminID>
								<clientNoteText>".$_REQUEST["clientNoteText"]."</clientNoteText>
								$createdXML
								$modifiedXML
							</clientNote>
						</clientNotes>
					</params>
				</mbapi>
				";
				
				//echo '<pre>'.htmlentities($cmd).'</pre>';
				//exit;
				
				$CONF["debug"]->add("Action Command", htmlentities($cmd), __FILE__, __LINE__);
				$data = dispatchMBAPI($cmd, 1);
				$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
	
				$results =& $data["mbapi"][0]["results"][0];
				
				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
						redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
					} else {
						$clientNoteID = $data["mbapi"][0]["header"][0]["lastInsertID"][0];
						redirect("clients.php", getActionID("ManageClientNotes"), array("clientID"=>$clientID));
					}
				}
	
			}
		
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	}

} // MB_Action
?>