<?php
// $Id: RemoveBillingAccountResponse.php,v 1.11 2006/06/19 17:40:36 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. Remove client billing account record.
 *
 * @author  Michael Fountain
 */
class RemoveBillingAccountResponse extends MB_Action {

	function RemoveBillingAccountResponse() {
		parent::MB_Action();
		$this->stringRep = "RemoveBillingAccountResponse";
	}

	function execute() {
		global $CONF;
		parent::execute();

		$billingAccountID = ((int) $_REQUEST["billingAccountID"]);
		if(!$billingAccountID) {
			$this->addError(TRANS_ACTIONERROR, "No billing account ID given.");
		} else {

			// fetch client ID for this contact first
			$query = "
			<mbapi>
			    <command>GetClients</command>
				<params>
					 <billingAccountID>$billingAccountID</billingAccountID>
				</params>
			</mbapi>
			";
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			$clientID = $data["mbapi"][0]["results"][0]["clients"][0]["client"][0]["clientID"][0];

			// remove shares
			$cmd = "<mbapi>
					<command>SetBillingAccountShare</command>
					<subCommand>delete</subCommand>
					<params>
						<billingAccountID>$billingAccountID</billingAccountID>
					</params>
				</mbapi>";
			$CONF["debug"]->add("Action Command", htmlentities($cmd), __FILE__, __LINE__);
			$data = dispatchMBAPI($cmd, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			// "delete" account
			$cmd = "<mbapi>
					<command>SetBillingAccounts</command>
					<subCommand>update</subCommand>
					<params>
						<billingAccountID>$billingAccountID</billingAccountID>
						<billingAccountStatus>".getAPIStatusID("billingAccount", "deleted")."</billingAccountStatus>
					</params>
				</mbapi>";
			$CONF["debug"]->add("Action Command", htmlentities($cmd), __FILE__, __LINE__);
			$data = dispatchMBAPI($cmd, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				redirect("clients.php?sid=".$_REQUEST["sid"]."&action=".getActionID("ShowClientDetails")."&clientID=$clientID");
				
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	} // execute

} // MB_Action
?>
