<?php
// $Id: RemoveClientResponse.php,v 1.13 2006/03/22 20:40:52 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It handles the data from EditClient action
 * and modifies an existing client record if data is valid; else redirects back to EditClient.
 *
 * @author  modernbill
 */
class RemoveClientResponse extends MB_Action {

	function RemoveClientResponse() {
		parent::MB_Action();
		$this->stringRep = "RemoveClientResponse";
		$this->params = array("clientID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$clientID = ((int) $_REQUEST["clientID"]);
		if(!$clientID) {

			// Assign smarty variables
			$smartyVars = array();
			$smartyVars["errors"][] = array
			(
				"title" => TRANS_ACTIONERROR,
				"message" => "No client ID given."
			);
			// Set the templete for output
			$this->addTemplate("clients/ShowErrors", $smartyVars);

		} else {

			$query = $this->getMBAPIQuery("SetClients", "delete", array("applyToChildren"=>1));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			// check for errors
			if ($data["mbapi"]["header"]["errorCount"] > 0) {

				// set master array for each error
				$dataErrors = fixXMLMultiElements
				(
					$data["mbapi"]["header"]["errors"]["error"],
					$data["mbapi"]["header"]["errorCount"]
				);

				// Assign smarty variables
				$smartyVars = array();
				$smartyVars["errors"] = $dataErrors;

				// Set the templete for output
				$this->addTemplate("clients/ShowErrors", $smartyVars);

			} else {
				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
						redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
					} else {
						$clientID = ((int) $data["mbapi"][0]["header"][0]["lastInsertID"][0]);
						redirect("clients.php", getActionID("ShowClients"), array());
					}
				}
			}

		}

		return $this->hasExecutedSuccessfully();

	} // execute

} // MB_Action
?>