<?php
// $Id: SendClientEmailResponse.php,v 1.4 2006/05/05 18:19:16 bwoolley Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It displays a form to add a new client record.
 *
 * @author  modernbill
 */
class SendClientEmailResponse extends MB_Action {

	function SendClientEmailResponse() {
		parent::MB_Action();
		$this->stringRep = "SendClientEmail";
	}

	function execute() {
		global $CONF;
		parent::execute();

	if((int) $_REQUEST["clientID"]) {
		$clientID = $_REQUEST["clientID"];
		$contacts = $contactPrimary = NULL;
		if(is_array($_REQUEST["addClientContactIDs"])) {
			$clientContactIDs = $_REQUEST["addClientContactIDs"];
			$query = $this->getMBAPIQuery("GetClients", "", array("clientID" => (int) $_REQUEST["clientID"], "getContactData" => 1, "mergePrimaryContact" => 1));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			if($data["mbapi"][0]["results"][0]["clients"][0]["client"][0]["contacts"][0]) {
				$results = $data["mbapi"][0]["results"][0]["clients"][0]["client"][0]["contacts"][0]["contact"];
				foreach($results as $key => $value) {
					if(in_array($value["clientContactID"][0], $clientContactIDs)) {
						$contacts[$value["contactEmail"][0]] = $value["contactFirstName"][0] ." " .$value["contactLastName"][0];
					}
					if($value["contactPrimary"][0]) {
						$contactPrimary = $value["clientContactID"][0];
					}

				}
			} else {
				//No contacts found
			}
		}
		if(!$contactPrimary) {
			$contactPrimary = $clientContactIDs[0];
		}
		//Look for CC and BCC
		$ccAddresses = $bccAddresses = $body = $subject = NULL;
		if($_REQUEST["emailCC"]) {
			$ccAddresses =explode(",",$_REQUEST["emailCC"]);
		}
		if($_REQUEST["emailBCC"]) {
			$bccAddresses =explode(",",$_REQUEST["emailBCC"]);
		}
		if($_REQUEST["emailBody"]) {
			$body = $_REQUEST["emailBody"];
		}
		if($_REQUEST["emailSubject"]) {
			$subject = $_REQUEST["emailSubject"];
		}
		//This will only allow messages to go out to e-mail addresses inside our system
		if($contacts && ($body || $subject)) {
			$message = array();
			$message["emailSubject"] = $subject;
			//$message["emailBody"] = $body;
			$message["emailTextBody"] = $body;
			$message["emailFromAddress"] = $CONF["user"]["email"];
			$message["emailFromName"] = $CONF["user"]["firstName"] ." " .$CONF["user"]["lastName"];
			$message["emailDateCreated"] = mktime();
			$message["emailDateSent"] = mktime();
			$message["emailActive"] = 1;
			$message["emailContactID"] = $contactPrimary;

			$messageXML = NULL;
			foreach($message as $key => $value) {
				$messageXML .= "<$key>$value</$key>\n";
			}

			$to = "<emailToAddresses>\n";
			foreach($contacts as $key => $value) {
				$to .= "<emailAddress>\n
							<address>$key</address>
							<name>$value</name>
						</emailAddress>";
			}
			$to .= "</emailToAddresses>";
			$messageXML .= $to;

			if($ccAddresses) {
				$cc = "<emailCCAddresses>\n";
				foreach($ccAddresses as $key => $value) {
					$cc .= "<emailAddress>\n
								<address>$value</address>
							</emailAddress>";
				}
				$cc .= "</emailCCAddresses>";
				$messageXML .= $cc;
			}

			if($bccAddresses) {
				$bcc = "<emailBCCAddresses>\n";
				foreach($bccAddresses as $key => $value) {
					$bcc .= "<emailAddress>\n
								<address>$value</address>
							</emailAddress>";
				}
				$bcc .= "</emailBCCAddresses>";
				$messageXML .= $bcc;
			}

			$messageXML = "<mbapi><command>ProcessEmail</command><params>$messageXML</params></mbapi>";
			$data = dispatchMBAPI($messageXML, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

		redirect("clients.php", getActionID("ShowClientDetails"), array("clientID"=>$clientID));

		} else {
			$this->addError(TRANS_ACTIONERROR, "No Subject or Body given.");
		}
	} else {
		//No Client ID passed int
		$this->addError(TRANS_ACTIONERROR, "No client ID given.");
	}


	$this->addErrorTemplates();
	return $this->hasExecutedSuccessfully();
	} // execute

} // MB_Action SendClientEmailResponse
?>
