<?php
// $Id: ShowBillingAccounts.php,v 1.20 2006/05/05 18:19:16 bwoolley Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/types.php");

/**
 * This class is a child class of MB_Action. It lists all client billing accounts
 * that match any of the input params.
 *
 * @author  Michael Fountain
 */
class ShowBillingAccounts extends MB_Action {
	/**
	 * The constructor for a ShowBillingAccounts action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowBillingAccounts() {
		parent::MB_Action();
		$this->stringRep = "ShowBillingAccounts";
		$this->params = array("clientID");
	}

	/**
	 * The main method of this class that executes the ShowBillingAccounts action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$clientID = ((int) $_REQUEST["clientID"]);
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else {

			$clientContactID = (int) $_REQUEST["clientContactID"];
			if($clientContactID) {
				// we want only information associated with this client contact
				$getBillingData = 3;
				$getContactData = 4;
				$displayAll = 0;
				$query = $this->getMBAPIQuery("GetClients", "", array("getBillingData"=>$getBillingData, "getContactData"=>$getContactData, "clientContactID"=>$clientContactID, "mergePrimaryContact" => 1), 1, 1, 1, 1);
			} else {
				// we want information for all client contacts
				$getBillingData = 1;
				$getContactData = 1;
				$displayAll = 1;
				$query = $this->getMBAPIQuery("GetClients", "", array("getBillingData"=>$getBillingData, "getContactData"=>$getContactData), 1, 1, 1, 1);
			}

			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$this->smartyVars["displayAll"] = $displayAll;
				$this->smartyVars["client"] = collapseArrayElements($results["clients"][0]["client"][0]);
				$this->smartyVars["contacts"] = collapseArrayElements(protectArray($results["clients"][0]["client"][0]["contacts"][0]["contact"]));
				$this->smartyVars["billingAccounts"] = collapseArrayElements(protectArray($results["clients"][0]["client"][0]["billingAccounts"][0]["billingAccount"]));
				$this->smartyVars["billingAccountTypes"] = $CONF["types"]["billingAccount"];
				$this->smartyVars["bankAccountTypes"] = $CONF["types"]["bankAccount"];
				$this->smartyVars["cardTypes"] = $CONF["types"]["card"];
				$this->smartyVars["cardExtraTypes"] = $CONF["types"]["cardExtraIDs"];
				
				$contacts =& $this->smartyVars["contacts"];
				$billingAccounts =& $this->smartyVars["billingAccounts"];
				$billingAccountsByContact = associateArrayRowsByID($billingAccounts, "clientContactID");
				//echo 'test';
				//print_r($billingAccountsByContact);
				$this->smartyVars["billingAccountsByContact"] = $billingAccountsByContact;
				
				$this->addTemplate("clients/ShowBillingAccounts", $this->smartyVars);
				
				
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // MB_Action
?>
