<?php
// $Id: ShowClientDetails.php,v 1.38 2006/06/08 23:22:39 bwoolley Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/statuses.php");
require_once mb_path("/lib-modernbill/include/config/internal/types.php");

/**
 * This class is a child class of MB_Action. It takes $_REQUEST["clientID"] and displays all
 * the client detail information.
 *
 * @author  Michael Fountain
 */
class ShowClientDetails extends MB_Action {

	function ShowClientDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowClientDetails";
		$this->params = array("clientID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$clientID = ((int) $_REQUEST["clientID"]);
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else {

			$params = array
			(
				"mergePrimaryContact" => 1,
				"getPackageData" => 2,
				"getDomainData" => 2,
				//"getInvoiceData" => 1, // check up on this later with Mike.
				"getAccountingData" => 1,
				"getCertData" => 2,
				"getCreditData" => 1,
				"getContactData" => 3,
				"getBillingData" => 2,
				"getBookmarkData" => 1,
				//"getCompanyData" => 1,
				"getClientGroupData" => 1,
				"getSessionData" => 1,
				"getTicketData" => 2, // (0=None, 1=All Data, 2=Last 5, 3=Last)
				"getNoteData" => 2, // (0=None, 1=All Data, 2=Last 5, 3=Last)
				"mergePrimaryContact" => 1,
			);
			$query = $this->getMBAPIQuery("GetClients", "", $params);
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$this->smartyVars["clientID"] = $clientID;
				$this->smartyVars["client"] = collapseArrayElements($results["clients"][0]["client"]);
				$this->smartyVars["primaryContact"] = collapseArrayElements($results["clients"][0]["client"][0]["contacts"][0]["contact"][0]);
				
				$this->smartyVars["clientGroups"] = collapseArrayElements(protectArray($results["clients"][0]["client"][0]["clientGroups"][0]["clientGroup"]));
				$this->smartyVars["noteList"] = collapseArrayElements(protectArray($results["clients"][0]["client"][0]["notes"][0]["note"]));

				$this->smartyVars["paymentList"] = getTypes("payments");
				$this->smartyVars["statusList"] = getStatuses("client");
				
				if ($results["clients"][0]["client"][0]["countriesISO2"][0]) {
					$this->smartyVars["clientCountry"] = constant("TRANS_ISO_3166_".$results["clients"][0]["client"][0]["countriesISO2"][0]);
					$this->smartyVars["primaryContactCountry"] = constant("TRANS_ISO_3166_".$results["clients"][0]["client"][0]["contacts"][0]["contact"][0]["countriesISO2"][0]);
				}
                // accounting data we got
                $this->smartyVars["accountingData"] = collapseArrayElements($results["clients"][0]["client"][0]["accountingGeneralLedgers"][0]["accountingGeneralLedger"]);
                if ($this->smartyVars["accountingData"]["currencyID"]){ // clean it up
                    $this->smartyVars["accountingData"] = array($this->smartyVars["accountingData"]);
                }

                // now we can get the totals for each currency of a specific ledger account.
                // ledger accounts you may want totals for are:
                //      "cash", "cash_1", "cash_2" -> the bank accounts, basically, how much money has this client paid us
                //      "accounts_receivable" -> how much this client owes us
                //      "accounts_payable" -> how much misc things (remaining) we have to pay someone else for this client
                //      "domains_payable" -> how much money you have (remaining) to pay registrars for this client
                //      "certs_payable" -> how much money you have (remaining) to pay geotrust for this client
                //      "taxes_payable" -> how much taxes (remaining) you charged this customer to pay to x tax zone
                //      "customer_credits" -> how much money this customer has on credit with you
                //      "revenue" -> how much money you have made off this customer (counts money they paid you and money they still owe you)
                //      "cogs" -> cost of goods, how much money the things you sold this customer have cost you total
                //      "domain_cogs" -> how much money total you have paid for domains you have sold to this customer
                //      "certs_cogs" -> how much money total you have paid for certs you have sold to this customer
                //      "setup_cogs" -> how much money total you have paid in setup fees for things you have sold to this customer
                //      "usage_cogs" -> not implemented yet
                //      "expense" -> misc expenses you have incurred due to this client
                //      "refund_expense" -> how much money you have refunded to this customer
                //
                //      basically, you do:
                //       $var = $this->getAccountingCurrencyTotals($this->smartyVars["accountingData"], "ACCOUNT_NAME_HERE");
                //
                //      and $var will be an array of arrays of form: currencyID=>total, currencyID=>total
                //      example:
                //      array('USD'=>123.45,
                //            'AUD'=>234.56,
                //            'GBP'=>345.67
                //      )
                //
                // below I will do a few accounts we will want by default

                // accounts receivable, what they owe us
                $this->smartyVars["accountingAccountsReceivable"] = $this->getAccountingCurrencyTotals($this->smartyVars["accountingData"], "accounts_receivable");
                // auth only stuff, what we can get by a prior auth capture
                $this->smartyVars["accountingAuthorized"] = $this->getAccountingCurrencyTotals($this->smartyVars["accountingData"], "authorized_payments");
                // customers credits, what we owe them
                $this->smartyVars["accountingCustomerCredits"] = $this->getAccountingCurrencyTotals($this->smartyVars["accountingData"], "customer_credits");
                // revenue, what we have made off them
                $this->smartyVars["accountingRevenue"] = $this->getAccountingCurrencyTotals($this->smartyVars["accountingData"], "revenue");
                // payables, what we owe someone currently for this customer
                $this->smartyVars["accountingPayables"] = $this->getAccountingCurrencyTotals($this->smartyVars["accountingData"], array("accounts_payable", "domains_payable", "certs_payable", "taxes_payable"));
                // cogs, what we have paid other people for this customer
                $this->smartyVars["accountingCogs"] = $this->getAccountingCurrencyTotals($this->smartyVars["accountingData"], array("cogs", "domains_cogs", "certs_cogs", "setup_cogs"));
                // refund, what we have refunded this customer
                $this->smartyVars["accountingRefunds"] = $this->getAccountingCurrencyTotals($this->smartyVars["accountingData"], "refund_expense");
                // expense, misc expenses we have incurred for this customer
                $this->smartyVars["accountingExpenses"] = $this->getAccountingCurrencyTotals($this->smartyVars["accountingData"], "expense");

                ksort($this->smartyVars["accountingAccountsReceivable"]);
                ksort($this->smartyVars["accountingCustomerCredits"]);
                ksort($this->smartyVars["accountingRevenue"]);
                ksort($this->smartyVars["accountingPayables"]);
                ksort($this->smartyVars["accountingCogs"]);
                ksort($this->smartyVars["accountingRefunds"]);
                ksort($this->smartyVars["accountingExpenses"]);


				//$this->mergeCountryData();
				//$this->mergeLanguageData();
				$this->mergeThemeData();

				$packageStatuses = getStatuses("package");
				$domainStatuses = getStatuses("domain");
				$certStatuses = getStatuses("cert");
				$billingAccountTypes = getTypes("billingAccount");
				
				// init package statuses (first)
				foreach($packageStatuses as $key => $value) {
					$this->smartyVars["packageStatuses"][$key] = 0;
				}
				// count package status
				if (is_array($results["clients"][0]["client"][0]["packages"][0]["package"])) {
					foreach($results["clients"][0]["client"][0]["packages"][0]["package"] as $package) {
						$this->smartyVars["packageStatuses"][$package["packageStatus"][0]] = $package["packageCount"][0];
					}
				}

				// init domain statuses (first)
				foreach($domainStatuses as $key => $value) {
					$this->smartyVars["domainStatuses"][$key] = 0;
				}
				// count domain status
				if (is_array($results["clients"][0]["client"][0]["domains"][0]["domain"])) {
					foreach($results["clients"][0]["client"][0]["domains"][0]["domain"] as $domain) {
						$this->smartyVars["domainStatuses"][$domain["packageStatus"][0]] = $domain["domainPackageCount"][0];
					}
				}

				// init cert statuses (first)
				foreach($certStatuses as $key => $value) {
					$this->smartyVars["certStatuses"][$key] = 0;
				}
				// count cert status
				if (is_array($results["clients"][0]["client"][0]["certs"][0]["cert"])) {
					foreach($results["clients"][0]["client"][0]["certs"][0]["cert"] as $cert) {
						$this->smartyVars["certStatuses"][$cert["packageStatus"][0]] = $cert["certPackageCount"][0];
					}
				}

				// init billing account types (first)
				foreach($billingAccountTypes as $key => $value) {
					$this->smartyVars["billingAccountTypes"][$key] = 0;
				}
				// count billing account types
				if (is_array($results["clients"][0]["client"][0]["billingAccounts"][0]["billingAccount"])) {
					foreach($results["clients"][0]["client"][0]["billingAccounts"][0]["billingAccount"] as $billingAccount) {
						$this->smartyVars["billingAccountTypes"][$billingAccount["billingAccountType"][0]] = $billingAccount["billingAccountCount"][0];
					}
				}

				$currencyIDs = collapseArrayElements(dispatchMBAPI($this->getMBAPIQuery("GetCurrencyIDs", "", array()), 1));
				dbg($currencyIDs);
				$currencyIDs = $currencyIDs["mbapi"]["results"]["currencyID"];
				if (!is_array($currencyIDs)){
					$currencyIDs = array($currencyIDs);
				}
				foreach ($currencyIDs as $cid){
					$this->smartyVars["currencyIDs"][$cid] = $cid;
				}
                $tmp = explode(";", $CONF["user"]["locale"]->localeArray["locale_pattern_currency"]);
                $tmp[0] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[0]);
                $tmp[1] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[1]);
                $CONF["user"]["locale"]->localeArray["locale_pattern_currency"] = $tmp[0].";".$tmp[1];
                $this->smartyVars["localeArray"] =  $CONF["user"]["locale"]->localeArray;

				$this->smartyVars["ledgerAccountNames"] = array(
																"customer_expense" => TRANS_CUSTOMER_EXPENSE,
																"refund_expense" => TRANS_REFUND_EXPENSE,
																"colocation_expense" => TRANS_COLOCATION_EXPENSE,
																"affiliate_commissions_expense" => TRANS_AFFILIATE_COMMISSIONS,
																"affiliate_commissions_payable" => TRANS_AFFILIATE_COMMISSIONS_PAYABLE
																);

				$this->smartyVars["includeAjaxJS"] = 1;
				
				$this->smartyVars["clientAttributes"] = arrayFor(
					"clientAttributes",
					array(
						"clientID" => $clientID,
						"attribute" => array(),
					)
				);
				
				$this->addTemplate("clients/ShowClientDetails", $this->smartyVars);
				
				
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // MB_Action
?>
