<?php
// $Id: ShowClientStats.php,v 1.16 2006/05/05 18:27:48 bwoolley Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/statuses.php");

require_once mb_path("/lib-tk/toolkit.php");


/**
 * This class is a child class of MB_Action. It will display a mini client report using the reports wizard.
 *
 * @author  Michael Fountain
 */
class ShowClientStats extends MB_Action {
	/**
	 * The constructor for a ShowClientStats action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowClientStats() {
		parent::MB_Action();
		$this->stringRep = "ShowClientStats";
		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the ShowClientStats action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();


 		$getMoreData = array
		(
			"getClientStats" => 1,
			"clientActive" => 1,
		);
		$query = $this->getMBAPIQuery("GetClients", "", $getMoreData, 1, 1, 1, 1);
		$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
		$data = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {
			$s = array();
			$s["clientStats"] = ($data["mbapi"][0]["header"][0]["numResults"][0]==1) ?
				array(0=>$results["clients"][0]["client"]) : $results["clients"][0]["client"];
			$clientStats = collapseArrayElements($s['clientStats']);
						
			// get statuses from config
			$statusLabels = getStatuses("client");
			$s['statusLabels'] = $statusLabels;

			// arrange statuses by status instead of row
			$statusByStatus = array();
			$c = count($clientStats);
			if($clientStats) {
				for($i = 0; $i < $c; $i++) {
					$statusByStatus[$clientStats[$i]["clientStatus"]] = $clientStats[$i]["numClients"];
				}
			}	
	
			// arrange stats for all statuses and total
			$statusValues = array();
			$statusTotal = 0;
			$c = count($statusLabels);
			for($i = 0; $i < $c; $i++) {
				$num = array_key_exists($i, $statusByStatus) ? (int) $statusByStatus[$i]: 0;
				$statusTotal += $num;
				$statusValues[$i] = $num;
			}
			$s['statusValues'] = $statusValues;
			$s['statusTotal'] = $statusTotal;
			
			$this->addTemplate("clients/ShowClientStats", collapseArrayElements($s));	
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} // execute
} // MB_Action
?>
