<?php
// $Id: EditEncryptionConfigs.php,v 1.2 2006/07/25 23:08:13 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class gets the info for encryption settings and displays it for editing.
 *
 * @author  Kris Bailey
 */
class EditEncryptionConfigs extends MB_Action {

	function EditEncryptionConfigs() {
		parent::MB_Action();
		$this->stringRep = "EditEncryptionConfigs";
	}

	function execute() {
		global $CONF;
		parent::execute();

		loadConfigs("system", "encryption");

		$this->smartyVars["agree"] = $CONF["system"]["encryption"]["encryption_agree"];
		$this->smartyVars["key"] = $CONF["system"]["encryption"]["encryption_hash"];
		$this->smartyVars["genericType"] = "editobject";
		$this->smartyVars["parentName"] = "TRANS_SYSTEM";
		$this->smartyVars["childName"] = "TRANS_SETTINGS";
		$this->smartyVars["grandchildName"] = "TRANS_ENCRYPTION_SETTINGS";
		$this->smartyVars["sideNavMajor"] = "system";

		$this->smartyVars["saved"] = (int)$_REQUEST["saved"];

		/** AUTO GENERATE FORM DATA BEGIN **/
		$this->smartyVars["editForm"] =& new MBAutoFormFields();
		$this->smartyVars["editForm"]->addFields(array(
			"encryptionAgree" => array("text", "TRANS_ENCRYPTION_AGREE"),
			"encryptionHash" => array("textarea", "TRANS_ENCRYPTION_HASH"),
			"lekPin" => array("password", "TRANS_LEK_PIN"),
		));

		$this->smartyVars["editForm"]->addFieldValue("encryptionAgree", $this->smartyVars["agree"]);
		$this->smartyVars["editForm"]->addFieldValue("encryptionHash", $this->smartyVars["key"]);
		$this->smartyVars["editForm"] = $this->smartyVars["editForm"]->getData();

		$this->addTemplate("widgets/genericTemplate", $this->smartyVars, 1);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} // execute
} // EditEncryptionConfigs
?>