<?php
// $Id: ShowConfigs.php,v 1.6 2006/03/22 20:41:10 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It displays all config groups recursively. If we are at the root
 * config group, then display the root groups & their first level children in the ShowConfigsMenu.tpl template.
 * The we are displaying any other group that is not root, use the ShowConfigs.tpl template to display the nested
 * groups and its params for editing.
 *
 * @author  Michael Fountain
 */
class ShowConfigs extends MB_Action {

	function ShowConfigs() {
		parent::MB_Action();
		$this->stringRep = "ShowConfigs";
		$this->params = array("configGroupID","parentConfigGroupID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		// --------------------------------------
		// Fetch config_groups for the nav menu
		// --------------------------------------
		$xmlParams = array
		(
			"parentConfigGroupID"=>0,
			"getNumChildren"=>1,
			"getLevelOneChildren"=>1
		);
		$tmp = $this->params;
		$this->params = array();
		$query = $this->getMBAPIQuery("GetConfigGroups","",$xmlParams);
		$this->params = $tmp;
		$CONF["debug"]->add("Action Command (Nav)", htmlentities($query), __FILE__, __LINE__);
		$navConfigGroupData = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result (Nav)", $navConfigGroupData, __FILE__, __LINE__);
		$navConfigGroupsResults =& $navConfigGroupData["mbapi"][0]["results"][0];
		// fix child config groups structure when only 1 child group exists
		$numNavGroups = $navConfigGroupData["mbapi"][0]["header"][0]["numResults"][0];
		for($i=0;$i<$numNavGroups;$i++) {
			$c =& $navConfigGroupsResults["configGroups"][0]["configGroup"][$i];
			if((int) $c["numChildren"][0]) {
				$c["levelOneConfigGroups"][0]["levelOneConfigGroup"][0] =
					array(@$c["levelOneConfigGroups"][0]["levelOneConfigGroup"][0]);
			}
		}

		// --------------------------------------
		// Fetch config_groups for this configGroupID or parentConfigGroupID
		// --------------------------------------
		if (!isset($_REQUEST["configGroupID"]) && !isset($_REQUEST["parentConfigGroupID"])) {
			$_REQUEST["parentConfigGroupID"] = 0;
		}
		$xmlParams = array
		(
			"getNumChildren"=>1,
			"getLevelOneChildren"=>1
		);
		$query = $this->getMBAPIQuery("GetConfigGroups","",$xmlParams);
		$CONF["debug"]->add("Action Command (This)", htmlentities($query), __FILE__, __LINE__);
		$configGroupsData = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result (This)", $configGroupsData, __FILE__, __LINE__);
		$configGroupsResults =& $configGroupsData["mbapi"][0]["results"][0];
		// fix child config groups structure when only 1 child group exists
		$numGroups = $configGroupsData["mbapi"][0]["header"][0]["numResults"][0];
		for($i=0;$i<$numGroups;$i++) {
			$c =& $configGroupsResults["configGroups"][0]["configGroup"][$i];
			if((int) $c["numChildren"][0]) {
				$c["levelOneConfigGroups"][0]["levelOneConfigGroup"][0] =
					array(@$c["levelOneConfigGroups"][0]["levelOneConfigGroup"][0]);
			}
		}

		// --------------------------------------
		// Fetch config_group_params for this config_group_id
		// --------------------------------------
		$xmlParams = array
		(
			"getFormAttributes"=>1
		);
		$query = $this->getMBAPIQuery("GetConfigs", "", $xmlParams);
		$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
		$configParamData = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result", $configParamData, __FILE__, __LINE__);
		$configParamDataResults =& $configParamData["mbapi"][0]["results"][0];
		// fix child config param values structure when only 1 child config param value exists
		$numParams = $configParamData["mbapi"][0]["header"][0]["numResults"][0];
		// loop through all params to test for param values
		for($i=0;$i<$numParams;$i++) {
			$p =& $configParamDataResults["configs"][0]["config"][$i]["paramValues"][0]["paramValue"];
			// loop through param values if they exist
			$numParamValues = count($p);
			for($j=0;$j<$numParamValues;$j++) {
				// define the translation key or display it raw if not defined
				$translatedName = (defined($p[$j]["configParamValueTransKey"][0])) ?
					constant($p[$j]["configParamValueTransKey"][0]) :
					$p[$j]["configParamValueTransKey"][0];
				// shorten the ID
				$configParamID = $configParamDataResults["configs"][0]["config"][$i]["configParamID"][0];
				// create a new smooshed array for html_options in smarty
				$configParamValueName = $p[$j]["configParamValueName"][0];
				if ($j ==0 && $configParamValueName == '0') {
					// hack to pad the array with a 0 if the name = "0"
					$configParamValues[$configParamID][0][$configParamValueName] = $translatedName;
				} else {
					$configParamValues[$configParamID][$configParamValueName] = $translatedName;
				}
			}
		}

		// --------------------------------------
		// Start Display
		// --------------------------------------
		if($this->addMBAPIErrors($configGroupsData) === 0) {

            // more logic should be here to determine if the save was good or bad
            // assumption now is that the save is ALWAYS good - MF
            $this->smartyVars["saved"] = ($_REQUEST["saved"]) ? 1 : 0 ;

			// setup vars for config navs
			// + 1 is to account for the support category in navNumDisplayResults
			$this->smartyVars["navNumDisplayResults"] = $numNavGroups + 1;
			$this->smartyVars["navNumDisplayRows"] = ceil($this->smartyVars["navNumDisplayResults"]/4);
			$this->smartyVars["navConfigGroups"] = collapseArrayElements($navConfigGroupsResults["configGroups"][0]["configGroup"]);
            if ($this->smartyVars["navConfigGroups"]["configGroupID"]){
                $this->smartyVars["navConfigGroups"] = array($this->smartyVars["navConfigGroups"]);
            }

			// setup this config group & its children groups & its params
			$this->smartyVars["configGroups"] = ($configGroupsData["mbapi"][0]["header"][0]["numResults"][0]==1) ?
				array(collapseArrayElements($configGroupsResults["configGroups"][0]["configGroup"])) :
				collapseArrayElements($configGroupsResults["configGroups"][0]["configGroup"]);

			// setup this group's config params
			$this->smartyVars["configParams"] = ($configParamData["mbapi"][0]["header"][0]["numResults"][0]==1) ?
				array(collapseArrayElements($configParamDataResults["configs"][0]["config"])) :
				collapseArrayElements($configParamDataResults["configs"][0]["config"]);
			$this->smartyVars["configParamValues"] = collapseArrayElements($configParamValues);
            if ($this->smartyVars["configParamValues"]["configParamValueID"]){
                $this->smartyVars["configParamValues"] = array($this->smartyVars["configParamValues"]);
            }

			// show the menu if the parent group is 0
			$tmpFile = ($_REQUEST["parentConfigGroupID"]<1 && !isset($_REQUEST["configGroupID"])) ? "ShowConfigMenu" : "ShowConfigs" ;
			$this->addTemplate("configs/$tmpFile", $this->smartyVars);

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	} // execute
} // MB_Action
?>