<?php
// $Id: EditDomainContactData.php,v 1.13 2006/03/27 23:47:56 achrist Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on domains that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Michael Fountain
 */
class EditDomainContactData extends MB_Action {
	/**
	 * The constructor for a EditDomainContactData action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function EditDomainContactData() {
		parent::MB_Action();
		$this->stringRep = "EditDomainContactData";
		$this->params = array("domainID");
	}

	/**
	 * The main method of this class that executes the EditDomainContactData action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$domainID = ((int) $_REQUEST["domainID"]);
		if(!$domainID) {
			$this->addError(TRANS_ACTIONERROR, "No domain ID given.");
		} else {

		 	// fetch this domains information
			$query = $this->getMBAPIQuery("GetDomains", "", array("packageType" => getTypeID("products",TRANS_DOMAIN_PRODUCT)));
			$mbapiData = dispatchMBAPI($query, 1);

			// is the domainID valid?
			if ($mbapiData["mbapi"][0]["header"][0]["numResults"][0]!=1) {
				$this->addError(TRANS_ACTIONERROR, "Invalid domain ID.");
			} else {

			 	// build XML for fetching domain data from the registrar
			 	$domainSLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainSLD"][0];
				$domainTLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainTLD"][0];

				$x = "
				<mbapi>
				  <command>ProcessRegistrar</command>
				  <showXMLHeader>0</showXMLHeader>
				  <params>
				    <subCommand>getDomainContactData</subCommand>
				    <configID>0</configID>
					<domainSLD>".$domainSLD."</domainSLD>
					<domainTLD>".$domainTLD."</domainTLD>
				  </params>
				</mbapi>";

				$registrarData = dispatchMBAPI($x,1);
				$registrarResults =& $registrarData["mbapi"][0]["results"][0];

				if($this->addMBAPIErrors($registrarData) === 0) {

					$smartyVars = array();
					$smartyVars["domain"] = collapseArrayElements($mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]);
					$smartyVars["domainData"] = collapseArrayElements($registrarResults["DomainData"]);
					$smartyVars["registrantContactData"] = collapseArrayElements($registrarResults["RegistrantContactData"]);
					$smartyVars["auxBillingContactData"] = collapseArrayElements($registrarResults["AuxBillingContactData"]);
					$smartyVars["techContactData"] = collapseArrayElements($registrarResults["TechContactData"]);
					$smartyVars["adminContactData"] = collapseArrayElements($registrarResults["AdminContactData"]);
					$smartyVars["billingContactData"] = collapseArrayElements($registrarResults["BillingContactData"]);

					$smartyVars["states"] = getStates("us");
					$smartyVars["countries"] = getCountries();
					$smartyVars["countryPhoneCodes"] = getCountryPhoneCodes();

					$this->addTemplate("domains/EditDomainContactData", collapseArrayElements($smartyVars));

				} // if($this->addMBAPIErrors($data) === 0) {

			} // if ($data["mbapi"][0]["header"][0]["numResults"][0]!=1) {

		} // if(!$domainID) {

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowDomainContactData
?>