<?php
// $Id: RegisterDomainConfirm.php,v 1.5 2006/03/22 20:40:52 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object displays the domains that need to be ordered and allows the user to
 * select registration years and confirm the order.
 *
 * @author  Michael Fountain
 */
class RegisterDomainConfirm extends MB_Action {
	/**
	 * The constructor for a RegisterDomainConfirm action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function RegisterDomainConfirm() {
		parent::MB_Action();
		$this->stringRep = "RegisterDomainConfirm";
		$this->params = array
		(
			"buyDomains",
		);
	}

	/**
	 * The main method of this class that executes the RegisterDomainConfirm action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$c = count($_REQUEST["buyDomains"]);

        if (!(int) $_REQUEST["configGroupID"]) {
			$this->addError(TRANS_ACTIONERROR, "Missing required configGroupID.");
        } else if(!$c) {
			$this->addError(TRANS_ACTIONERROR, "No domains selected to purchase.");
		} else {

			$this->smartyVars["configGroupID"] = (int) $_REQUEST["configGroupID"];
			$this->smartyVars["numDomainsToConfirm"] = $c;

			$this->smartyVars["domainRenewDefaultYears"] = 1;
			$this->smartyVars["domainRenewMaxYears"] = 10;
			for($i=1;$i<=$this->smartyVars["domainRenewMaxYears"];$i++){
				$this->smartyVars["domainRenewYears"][$i] = $i;
		 	}

			$this->smartyVars["buyDomains"] = ($c==1) ? array($_REQUEST["buyDomains"]) : $_REQUEST["buyDomains"] ;


			$this->addTemplate("domains/RegisterDomainConfirm", collapseArrayElements($this->smartyVars));

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RegisterDomainConfirm
?>