<?php
// $Id: SyncDomainDatesResponse.php,v 1.3 2006/03/22 20:40:52 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the SyncDomainDates action, and sends
 * it to the registrar class for processing.
 *
 * @author  Michael Fountain
 */
class SyncDomainDatesResponse extends MB_Action {
	/**
	 * The constructor for an SyncDomainDatesResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function SyncDomainDatesResponse() {
		parent::MB_Action();
		$this->stringRep = "SyncDomainDatesResponse";
		$this->params = array
		(
			"domainID",
			"domainDateExpires",
		);
	}

	/**
	 * The main method of this class that executes the SyncDomainDatesResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$domainID = ((int) $_REQUEST["domainID"]);
		if(!$domainID) {
			$this->addError(TRANS_ACTIONERROR, "No domain ID given.");
		} else {
			$query = $this->getMBAPIQuery("SetDomains", "update", array());
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				redirect("domains.php",getActionID("ShowDomainDetails"), array("domainID"=>$domainID));
			}
		} // if(!$domainID)

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	} // execute

} // EditDomainResponse
?>