<?php
// $Id: EditEmailTemplate.php,v 1.13 2006/03/30 22:39:24 mgarrett Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/regions.php");

/**
 * This Action object collects information on a email template so that that the emailtemplate may be modified 
 * in the database.
 *
 * @author  getActionFiles.php (Automatically Generated)
 * @author  Vic Fryzel
 */
class EditEmailTemplate extends MB_Action {
	/**
	 * The constructor for a EditEmailTemplate action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditEmailTemplate() {
		parent::MB_Action();
		$this->stringRep = "EditEmailTemplate";
		$this->params = array("emailTplID");
	}

	/**
	 * The main method of this class that executes the EditEmailTemplate action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		if(!((int) $_REQUEST["emailTplID"])) {
			$this->addError(TRANS_ACTIONERROR, "No email template ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetEmailTemplates", "", array());
			$data = dispatchMBAPI($query, 1);
			
			if($data["mbapi"][0]["header"][0]["numResults"][0] != 1) {
				$this->addError(TRANS_ACTIONERROR, "Email template ID not found.");
			}
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$this->smartyVars["emailTemplate"] = correctArray($data["mbapi"][0]["results"][0]
					["emailTemplates"][0]["emailTemplate"][0]);
				$this->smartyVars["countryTypes"] = getTypes("countryTypes");
				$this->smartyVars["regionNames"] = getRegions("names");
				$this->smartyVars["nestedRegions"] = getRegions("nested");
				$this->mergeCountryData($CONF["user"]["locale"]->country);
				$this->mergeLanguageData();

				$this->addTemplate("emails/EditEmailTemplate", $this->smartyVars);
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditEmailTemplate
?>