<?php
// $Id: EditEmailTemplateGroup.php,v 1.7 2006/04/17 23:35:31 mgarrett Exp $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");
require_once mb_path("/lib-modernbill/include/config/internal/regions.php");

/**
 * This action collects information on an email template group so that that the email template group may be modified
 * in the database.
 *
 * @author  Mark Garrett
 */
class EditEmailTemplateGroup extends MB_Action {
	/**
	 * The constructor for a EditEmailTemplateGroup action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditEmailTemplateGroup() {
		parent::MB_Action();
		$this->stringRep = "EditEmailTemplateGroup";
		$this->params = array("emailTplGroupID");
	}

	/**
	 * The main method of this class that executes the EditEmailTemplateGroup action, and returns success or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		if(!((int) $_REQUEST["emailTplGroupID"])) {
			$this->addError(TRANS_ACTIONERROR, "No email template group ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetEmailTemplateGroups", "", array("getEmailTemplates" => 2));
			$data = dispatchMBAPI($query, 1);

			if($data["mbapi"][0]["header"][0]["numResults"][0] != 1) {
				$this->addError(TRANS_ACTIONERROR, "Email template group not found.");
			}
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$this->smartyVars["emailActions"] = $CONF["types"]["emailAction"];
				$this->smartyVars["emailTplGroup"] = correctArray($data["mbapi"][0]["results"][0]
					["emailTplGroups"][0]["emailTplGroup"][0]);
				$this->smartyVars["emailTemplates"] = correctArray($data["mbapi"][0]["results"][0]
					["emailTplGroups"][0]["emailTplGroup"][0]["emailTemplates"][0]["emailTemplate"]);
				$this->smartyVars["countryTypes"] = getTypes("countryTypes");
				$this->smartyVars["countryRegions"] = getRegions("names");
				$this->smartyVars["saved"] = (int)$_REQUEST["saved"];
				$this->mergeCountryData($CONF["user"]["locale"]->country);

				$this->addTemplate("emails/EditEmailTemplateGroup", $this->smartyVars);
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditEmailTemplateGroup
?>