<?php
// $Id: EditEmailTemplateGroupResponse.php,v 1.5 2006/04/17 22:54:50 mgarrett Exp $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action records changes made to an email action group. The data is provided by the EditEmailTemplateGroup action.
 *
 * @author  Vic Fryzel
 */
class EditEmailTemplateGroupResponse extends MB_Action {
	/**
	 * The constructor for an EditEmailTemplateGroupResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditEmailTemplateGroupResponse() {
		parent::MB_Action();
		$this->stringRep = "EditEmailTemplateGroupResponse";
		$this->params = array(
			"emailTplGroupID",
			"emailTplGroupName",
			"emailActionID",
			"emailTplGroupPriority",
			"emailTplGroupName",
			"emailTplGroupFromName",
			"emailTplGroupFromAddress",
			"emailTplGroupReplyName",
			"emailTplGroupReplyAddress",
			"emailTplGroupCCAddress",
			"emailTplGroupBCCAddress"
			);
	}

	/**
	 * The main method of this class that executes the EditEmailTemplateGroupResponse action, and returns success
	 * or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$emailTplGroupID = ((int) $_REQUEST["emailTplGroupID"]);
		if(!$emailTplGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No email template group ID given.");
		} else {
			$query = $this->getMBAPIQuery("SetEmailTemplateGroups", "update");
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				redirect("emails.php", getActionID("EditEmailTemplateGroup"),
					array("emailTplGroupID" => $emailTplGroupID, "saved"=>1));
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditEmailTemplateGroupResponse
?>