<?php
// $Id: EditEmailTemplateResponse.php,v 1.16 2006/04/11 16:34:26 mgarrett Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action records changes made to an email template. The data is provided by the EditEmailTemplate action.
 *
 * @author Mark Garrett
 */
class EditEmailTemplateResponse extends MB_Action {
	/**
	 * The constructor for an EditEmailTemplateResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditEmailTemplateResponse() {
		parent::MB_Action();
		$this->stringRep = "EditEmailTemplateResponse";
		$this->params = array(
			"emailTplID",
			"emailTplPrimary",
			"emailTplGroupID",
			"languageID",
			"countryType",
			"countriesID",
			"regionsID",
			"emailTplSubject",
			"emailTplBody",
			"emailTplTextBody");
	}

	/**
	 * The main method of this class that executes the EditEmailTemplateResponse action, and returns success
	 * or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		// Make sure the given text bodies are valid for XML

		$emailTplID = ((int) $_REQUEST["emailTplID"]);
		$emailTplGroupID = ((int) $_REQUEST["emailTplGroupID"]);
		if(!$emailTplID) {
			$this->addError(TRANS_ACTIONERROR, "No email template ID given.");
		} else {
			$query = $this->getMBAPIQuery("SetEmailTemplates", "update");
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				redirect("emails.php",getActionID("EditEmailTemplateGroup"),array("emailTplGroupID" => $emailTplGroupID));
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditEmailTemplateResponse
?>