<?php
// $Id: ShowEmailTemplateDetails.php,v 1.11 2006/03/22 20:41:01 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. Using $_REQUEST["emailTplID"] it displays all
 * the details for the found email template, and only displays the details of a single email template.
 *
 * @author  getActionFiles.php (Automatically Generated)
 * @author  Vic Fryzel
 */
class ShowEmailTemplateDetails extends MB_Action {
	/**
	 * The constructor for a ShowEmailTemplateDetails object. This merely sets up our string represenation, calls 
	 * the parent constructor, and sets up $this->params.
	 */
	function ShowEmailTemplateDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowEmailTemplateDetails";
		$this->params = array("emailTplID");
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$emailTplID = ((int) $_REQUEST["emailTplID"]);
		if(!$emailTplID) {
			$this->addError(TRANS_ACTIONERROR, "No email template ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetEmailTemplates", "", array());
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$smartyVars = array();
					$smartyVars["emailTemplate"] = 
						collapseArrayElements($data["mbapi"][0]["results"][0]
						["emailTemplates"][0]["emailTemplate"][0]);
					$this->addTemplate("emails/ShowEmailTemplateDetails", $smartyVars);
					
				} else {
					$this->addError(TRANS_ACTIONERROR, "Email template does not exist.");
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowEmailTemplateDetails
?>