<?php
// $Id: ShowEmailTemplateGroups.php,v 1.7 2006/04/17 22:55:22 mgarrett Exp $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");

/**
 * This action displays a list of email template groups, and links to manage those template groups accordingly.
 *
 * @author	Mark Garrett
 */
class ShowEmailTemplateGroups extends MB_Action {
	/**
	 * The constructor for a ShowEmailTemplateGroups action object. This calls the parent constructor, sets up
	 * the string representation, and sets up $this->params and $this->sortColumns.
	 */
	function ShowEmailTemplateGroups() {
		parent::MB_Action();
		$this->stringRep = "ShowEmailTemplateGroups";

		$this->params = array("emailTplGroupName");
		$this->sortColumns = array("emailTplGroupID", "emailTplGroupName", "emailActionID");
	}

	/**
	 * The main method of this class that executes the ShowEmailTemplateGroups action, and returns success or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$query = $this->getMBAPIQuery("GetEmailTemplateGroups", "", array("getEmailTemplates" => 1));
		$data = dispatchMBAPI($query, 1);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {

			$this->smartyVars["emailActions"] = $CONF["types"]["emailAction"];
			$this->smartyVars["emailActions"] += $CONF["types"]["admin"]["emailAction"];
			$this->smartyVars["emailTplGroups"] = $results["emailTplGroups"][0]["emailTplGroup"];
			if($data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
				$this->smartyVars["emailTplGroups"] = array(0 => $results["emailTplGroups"][0]["emailTplGroup"]);
			}
			$this->smartyVars["paginationLinks"] = $results["paginationLinks"][0];
			$this->smartyVars = collapseArrayElements($this->smartyVars);
			
			if (is_array($this->smartyVars["emailTplGroups"])){
				foreach ($this->smartyVars["emailTplGroups"] as $tplGroup){
					$this->smartyVars["assocTplGroup"][$tplGroup["emailActionID"]][] = $tplGroup;				
				}
				ksort($this->smartyVars["assocTplGroup"]);
				$this->smartyVars = collapseArrayElements($this->smartyVars);
				foreach ($this->smartyVars["assocTplGroup"] as $key=>$atplGroup){
					if ($atplGroup["emailTplGroupID"]){
						$this->smartyVars["assocTplGroup"][$key] = array($atplGroup);
					}
				}
			}
			$this->addTemplate("emails/ShowEmailTemplateGroups", $this->smartyVars);
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowEmailTemplateGroups
?>