<?php
// $Id: EditEventResponse.php,v 1.9 2006/07/31 21:47:40 achrist Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can event you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action applies the data given via REQUEST to the system queue event associated with the given system queue ID.
 *
 * @package  modernbill
 * @subpackage  action
 * @author  Vic Fryzel
 */
class EditEventResponse extends MB_Action {
	/**
	 * Call the parent constructor, set our string representation, and setup our allowed parameters.
	 */
	function EditEventResponse() {
		parent::MB_Action();
		$this->stringRep = "EditEventResponse";
		$this->params = array(
			"packageID",
			"systemQueueParentID",
			"configGroupID",
			"serverGroupID",
			"systemQueueID",
			"systemQueueCommand",
			"systemQueueCommandInput",
			"systemQueueMinute",
			"systemQueueHour",
			"systemQueueDay",
			"systemQueueMonth",
			"systemQueueYear",
			"systemQueueIsRecurring",
			"systemQueueDateToRun",
			"systemQueueDateFinished",
			"systemQueueStatus",
		);
	}

	/**
	 * Execute this action and return 1 for a successful execution or 0 if otherwise.
	 *
	 * @return  int  1 if this action has executed successfully, or 0 if otherwise.
	 */
	function execute() {
		parent::execute();

		if(!((int) $_REQUEST["systemQueueID"])) {
			$this->addError(TRANS_ACTIONERROR, "No system queue event ID was given for removal.");
		} else {
			if($_REQUEST["systemQueueCommandInput"]) {
				$_REQUEST["systemQueueCommandInput"] = htmlentities(unsecureInput($_REQUEST["systemQueueCommandInput"]));
			}

			$query = $this->getMBAPIQuery("SetSystemQueue", "update");
			//echo '<pre>';
			//echo htmlentities($query);
			//echo '</pre>';
			//exit;
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
				} else {
					redirect("events.php", getActionID("ShowEvents"));
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditEventResponse
?>