<?php
// $Id: RemoveEvent.php,v 1.4 2006/06/22 20:33:39 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can event you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action confirms the removal of an event from the queue. The event is not literally removed, but rather set to a state
 * of inactive. The queue is always malleated in place, but never removed from, as it doubles as an ultimate state log.
 *
 * @package  modernbill
 * @subpackage  action
 * @author  Vic Fryzel
 */
class RemoveEvent extends MB_Action {
	/**
	 * Call the parent constructor, setup a string representation for ourselves, and setup the allowed parameters.
	 */
	function RemoveEvent() {
		parent::MB_Action();
		$this->stringRep = "RemoveEvent";
		$this->params = array("systemQueueID");
	}

	/**
	 * Execute this action and return 1 for success, or 0 for failure.
	 *
	 * @return  int  1 if execution succeeded or 0 if otherwise.
	 */
	function execute() {
		parent::execute();
		if(!((int) $_REQUEST["systemQueueID"])) {
			$this->addError(TRANS_ACTIONERROR, "No event ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetSystemQueue");
			$data = dispatchMBAPI($query, 1);

			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$results = grabSimpleMBAPIResults($data);
				$this->smartyVars["event"] = $results[0];
				
				$this->addTemplate("events/RemoveEvent");
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveEvent
?>