<?php
// $Id: RunEvents.php,v 1.29 2006/07/10 04:05:20 mfountain Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-action/include/url/url.php");

/**
 * This action runs the system event queue. It can either run a single event (given by systemQueueID), or the entire event
 * queue (all events created before the start of the process tree and due for processing). This action is recursive, it 
 * calls itself in order to spawn threads that run system queue events.
 *
 * @author  Vic Fryzel
 * @author	Michael Fountain
 */
class RunEvents extends MB_Action {
	/**
	 * The constructor for a RunEvents action object. Call parent constructor, setup string representation and params.
	 */
	function RunEvents() {
		parent::MB_Action();
		$this->stringRep = "RunEvents";
	}



	/**
	 * The main method of this class that executes the RunEvents action, and returns success or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute(){
		global $CONF;
		
		$tempSid = $_REQUEST["sid"];
		
		dbg("At top of execute call.");
		// test if we need
		if ($_REQUEST["forceClear"] || (!$_REQUEST["continue"] && !$CONF["system"]["internal"]["systemQueueRunning"])) {
			dbg("did forceClear or not continue or its not running in conf.");
			$this->resetInternalCounters();
		}
		
		// Somone wants to stop the queue, kill this process now.
		if ($CONF["system"]["internal"]["systemQueueStop"]) {
			dbg("was told to stop it 1.");
			$this->resetInternalCounters();

			dbg("redirecting due to lack of continue");
			if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
				redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
			} else {
				redirect("events.php", "ShowEvents");
			}

		} else {

			dbg("we dont need to stop, so what do we need to do?");

			// we aren't going to kill the queue, so go....
			
			// if there is a system queue id being passed lets allow it through to the command
			// (by adding the systemQueueID param to the params array)
			if((int) $_REQUEST["systemQueueID"]) {
				dbg("added system queue id into params");
				$this->params[] = "systemQueueID";
			}

			// When was this chain of processes started?
			$this->started = $_REQUEST["started"];

			// if there's no continue or no started timestamp then make one
			if(!$_REQUEST["continue"] || !(int)$this->started) {
				dbg("no continue, so create out start timestamp");
				// We're the parent of all upcoming processes, tell them when the family was started
				$this->started = mktime();
			} else {
				dbg("we got the started command");
			}


			// Did the original thread start X or more minutes ago? If yes, kill it to prevent overloading
			// the server with parent-child processes!
			if (mktime()-$this->started>(int)$CONF["killOldQueueThreadsLimit"] && (int)$CONF["killOldQueueThreads"]){

				dbg("thread ran too long, not continuing");
				$this->resetInternalCounters();
				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
				} else {
					redirect("events.php", "ShowEvents");
				}
	
			} else { 

				dbg("we dont need to kill the thread, what do we need to do?");

////////////////////////////////////////// running stuff

				// Are we a child thread? If so, run some events...
				if ($_REQUEST["continue"]){

					dbg("we need to continue");

					if ($_REQUEST["sid"]==$CONF["system"]["internal"]["systemQueueSessionID"]){
				
						dbg("we are a child");
						loadConfigs("automation", "systemQueue");
						// Remember that if a systemQueueID is given, we will run twice, but only run the event for that ID once
						// We run twice in that this process we have our spawning process, and the process that literally runs the event
						$params = array("runMax" => $CONF["automation"]["systemQueue"]["max_system_queue_events"], "systemQueueDateToRunLessThan" => $_REQUEST["started"], "systemQueueDateFinished" => 0);
						$query = $this->getMBAPIQuery("ProcessSystemQueue", "", $params);
						$data = dispatchMBAPI($query, 1);
						dbg("RUN query we are running: ".$query);
						dbg($data);
						if($this->addMBAPIErrors($data) === 0) {
							dbg("we dont have errors");
							// Have we run all commands we were supposed to?
							// -- If yes, stop the queue & die gracefully.
							// -- If no, tell the system the queue is still running and continue.
							if(!((int) $data["mbapi"][0]["results"][0]["numExecutedCommands"][0])) {
								dbg("setting running as 0 and stop as 1");
								$CONF["system"]["internal"]["systemQueueRunning"] = 0;
								$CONF["system"]["internal"]["systemQueueStop"] = 1;
								$CONF["system"]["internal"]["systemQueueSessionID"] = "";
								storeConfigs("system","internal");
								return 1;
							} else {
								dbg("setting running as 1");
								$CONF["system"]["internal"]["systemQueueRunning"] = 1;
								storeConfigs("system","internal");
							}	

							// Don't overload the server
							// This would ideally be < 1 second, but PHP on Windows doesn't support usleep() until PHP 5
							dbg("sleeping 3");
							sleep(3);
							$this->startNewThread();
						}

					} else {
						dbg("out sid didnt match the one in conf: ".$_REQUEST["sid"]. " != ". $CONF["system"]["internal"]["systemQueueSessionID"]);
					}

				// No, this is not a child thread, run me as the parent thread!
				} else {

					dbg("we are a parent.");

					loadConfigs("system", "internal");
					// another process running?
					if (strlen($CONF["system"]["internal"]["systemQueueSessionID"])==0 && !(int)$CONF["system"]["internal"]["systemQueueRunning"]){

						// Inform the system of the total number of events that will be run and tell it
						// it's ok for the system queue to run.
						dbg("running a parent run");
						$params = array("systemQueueDateToRunLessThan" => $_REQUEST["started"], "systemQueueDateFinished" => 0);
						$query = $this->getMBAPIQuery("GetSystemQueue", "", $params);
						$data = dispatchMBAPI($query, 1);
						dbg("parent query: ".$query);
						dbg($data);
						// errors?
						if($this->addMBAPIErrors($data) === 0) {
							loadConfigs("system", "internal");
							// another process running now?
							if (strlen($CONF["system"]["internal"]["systemQueueSessionID"])==0 && !(int)$CONF["system"]["internal"]["systemQueueRunning"]){
								dbg("no errors, setting num events to whatever and running to 1");
								$_REQUEST["sid"] = $this->cloneSession($_REQUEST["sid"]);
								$CONF["system"]["internal"]["systemQueueNumEvents"] = (int) $data["mbapi"][0]["header"][0]["numResults"][0];
								$CONF["system"]["internal"]["systemQueueRunning"] = 1;
								$CONF["system"]["internal"]["systemQueueSessionID"] = $_REQUEST["sid"];
								storeConfigs("system","internal");
								$this->startNewThread();
							} else { // is there another process after we went through all this? check one more time...
								dbg("3 out sid didnt match the one in conf: ".$_REQUEST["sid"]. " != ". $CONF["system"]["internal"]["systemQueueSessionID"]);
							}
						} // end errors
					} else { // end other process check
						dbg("2 out sid didnt match the one in conf: ".$_REQUEST["sid"]. " != ". $CONF["system"]["internal"]["systemQueueSessionID"]);
					}
				} // end parent exec
			}
		}
		
		// if there is no request continue variable we need to redirect, else just return.
		if (!$_REQUEST["continue"]){
			dbg("the user has dispatched us, display the run events template for them");
			$_REQUEST["sid"] = $tempSid;
			if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
				redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
			} else {
			 	redirect("events.php", "ShowEvents");
			}
			$this->addErrorTemplates();
		}

		return $this->hasExecutedSuccessfully();
	
	} // end execute


	/**
	 * This function clones the session of the sessionid you give it and returns the new session id.
	 *
	 * @param sid The session id to clone.
	 * @return sid The new session id.
	 */
	function cloneSession($sid){
		global $CONF;
		dbg("cloning session");
		// It is important to clone our session in case we logout. This will ensure that our child
		// processes live and continue until they are completed or stopped by the system.
		$sessGetXML = "
			<mbapi>
				<command>GetSessions</command>
				<showXMLHeader></showXMLHeader>
				<params>
					<sessionID>".$sid."</sessionID>
				</params>
			</mbapi>
			";
		$sessionInfo = dispatchMBAPI($sessGetXML, 1);
		dbg("got session info");
		if (isset($sessionInfo["mbapi"][0]["results"][0]["sessions"][0]["session"])){
			dbg("have valid session info");
			$sessionInfo = correctArray($sessionInfo["mbapi"][0]["results"][0]["sessions"][0]["session"][0]);
			$sid = sha1(strval(mt_rand(0, 200000000)).strval(microtime()).strval(mt_rand(0, 200000000)));
			$setSessXML = "
				<mbapi>
					<command>SetSession</command>
					<subCommand>insert</subCommand>
					<showXMLHeader></showXMLHeader>
					<params>
						<sessionID>$sid</sessionID>
						<userID>".$sessionInfo["userID"]."</userID>
						<userType>".$sessionInfo["userType"]."</userType>
						<sessionDateCreated>".$sessionInfo["sessionDateCreated"]."</sessionDateCreated>
						<sessionDateAccessed>".$sessionInfo["sessionDateAccessed"]."</sessionDateAccessed>
						<sessionDateExpired>".$sessionInfo["sessionDateExpired"]."</sessionDateExpired>
						<sessionIP>".$sessionInfo["sessionIP"]."</sessionIP>
						<sessionActive>".$sessionInfo["sessionActive"]."</sessionActive>
					</params>
				</mbapi>
				";
			$result = dispatchMBAPI($setSessXML, 1);
			dbg("set session: ".$setSessXML);
			dbg($result);
			if ((int)$result["mbapi"][0]["header"][0]["success"][0]){
				dbg("got result sid");
			}
		}
		return $sid;
	}


	/**
	 * This method resets the internal systemQueue counters
	 */
	function resetInternalCounters($mungeSessionID=0) {
		global $CONF;
		dbg("resetting system queue internals");
		$CONF["system"]["internal"]["systemQueueParentID"] = 0;
		$CONF["system"]["internal"]["systemQueueCommand"] = "";
		$CONF["system"]["internal"]["systemQueueCount"] = 0;
		$CONF["system"]["internal"]["systemQueueNumEvents"] = 0;
		$CONF["system"]["internal"]["systemQueueRunning"] = 0;
		$CONF["system"]["internal"]["systemQueueStop"] = 0;
		$CONF["system"]["internal"]["systemQueueSessionID"] = "";
		storeConfigs("system","internal");
		loadConfigs("system");
	}


	/**
	 * This method starts another thread.
	 *
	 * @param none
	 * @return none
	 */
	function startNewThread(){
		global $CONF;
		
		$urlProtocol = $CONF["secureURLProtocol"];
		$urlHostnameSecure = $CONF["secureURL"];	
		$urlHostnameStandard = $CONF["standardURL"];	

		// override if using a local IP
		if ($CONF["localURL"]) {
			$urlProtocol = "http";
			$urlHostnameStandard = $CONF["localURL"];
		}
		
		// Time to start a child process with the new session and let it do its thing!
		if ($urlProtocol=="http"){
			$url = new URL($urlProtocol."://".$urlHostnameSecure);
			dbg("going to open a connection to: ".$url->getHost().":".$url->getPort());
			$fp = fsockopen($url->getHost(), $url->getPort());
			if(!$fp) {
				dbg("failed to connect");
				$this->addError(TRANS_ACTIONERROR, "Failed to connect to host to continue running system queue.");
			} else {
				dbg("making get string");
				dbg("STRING WE START WITH: ".$url->getPath());
				$file = $url->getPath()."/".mb_path_convert_name("app-modernbill-admin")."/events.php?action=".getActionID("RunEvents")."&sid=".$_REQUEST["sid"]
					."&ajax=1&systemQueueID=".((int) $_REQUEST["systemQueueID"])."&continue=1&started=".((int) $this->started);
				$out = "GET $file HTTP/1.1\r\n";
				$out .= "Host: ".$url->getHost()."\r\n";
				$out .= "Connection: close\r\n\r\n";
				dbg($out);
				if(fwrite($fp, $out) === false) {
					dbg("failed to write to socket.");
					$this->addError(TRANS_ACTIONERROR, "Failed to write data to socket when running system queue.");
				} else {
					//dbg("fread: ".fread($fp, 10000));
				}

			}
			@fclose($fp);
		} else {
			$url = new URL($urlProtocol."://".$urlHostnameStandard);
			dbg("going to open a connection to: ".$url->getHost().":".$url->getPort());
			$file = $urlProtocol."://".$urlHostnameStandard."/".mb_path_convert_name("app-modernbill-admin")."/events.php?action=".getActionID("RunEvents")."&sid=".$_REQUEST["sid"]
					."&ajax=1&systemQueueID=".((int) $_REQUEST["systemQueueID"])."&continue=1&started=".((int) $this->started);
			$fp = fopen($file, "r");
			if(!$fp) {
				dbg("failed to connect");
				$this->addError(TRANS_ACTIONERROR, "Failed to connect to host to continue running system queue.");
			} else {
				dbg("fread: ".fread($fp, 10));
				@fclose($fp);
			}
		}

	}


} // RunEvents
?>