<?php
// $Id: ShowEmailQueue.php,v 1.9 2006/04/16 04:52:14 mgarrett Exp $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action displays a list of outgoing, sent, or failed emails in the email queue. From this action, the user
 * can add, edit, or remove items from the queue. The user can also send all, or some of the emails in the queue.
 *
 * @package  modernbill
 * @subpackage  action
 * @author  Vic Fryzel
 */
class ShowEmailQueue extends MB_Action {
	/**
	 * The constructor for a ShowEmailQueue action object. Call the parent constructor, and setup data to allow the user to 
	 * limit their result set.
	 */
	function ShowEmailQueue() {
		parent::MB_Action();
		$this->stringRep = "ShowEmailQueue";

		$this->params = array("emailID", "emailFromAddress", "emailFromName", "emailSubject", "emailSent", "emailFailed", "emailActive");
		$this->sortColumns = array("emailQueueID", "emailFromAddress", "emailFromName", "emailSubject");
	}

	/**
	 * The main method of this class that executes the ShowEmailQueue action, and returns success or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$additional = array();
		// They might be searching on one of these (add more search params later)
		if($_REQUEST["emailToAddress"]) {
			$additional["emailToAddresses"] = array("emailAddress" => $_REQUEST["emailToAddress"]);
		}

		if(!isset($_REQUEST["emailActive"])) {
			$_REQUEST["emailActive"] = 1;
		}

		$query = $this->getMBAPIQuery("GetEmailQueue", "", $additional, 1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);
		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {
			$this->smartyVars["emails"] = $results["emails"][0]["email"];
			$this->smartyVars["paginationLinks"] = $results["paginationLinks"][0];
			$this->smartyVars["sortColumns"] = array();
			
			$this->addTemplate("events/ShowEmailQueue", correctArray($this->smartyVars));
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowEmailQueue
?>