<?php
// $Id: ShowEventOutputDetails.php,v 1.4 2006/03/22 20:41:10 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action parses an MBAPI command execution log and displays the details in an easy to read format.
 * For widget display only.
 *
 * @author  Michael Fountain
 */
class ShowEventOutputDetails extends MB_Action {
	/**
	 * The constructor for a ShowEventOutputDetails action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowEventOutputDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowEventOutputDetails";
		$this->params = array("systemQueueID");
	}

	/**
	 * The main method of this class that executes the ShowEventOutputDetails action, and returns success or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		parent::execute();

		$query = $this->getMBAPIQuery("GetSystemQueue", "", array("getSystemQueueLogData" => 1));
		$data = dispatchMBAPI($query, 1);
		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {

			$smartyVars = array();

            $systemQueueLogsDirty = $results["systemQueue"][0]["systemQueueEvent"][0]["systemQueueLogs"][0]["systemQueueLog"];

			$c = count($systemQueueLogsDirty);
			for($i=0; $i<$c; $i++) {
			 	$systemQueueLogMessageParsed = "";
				if ($systemQueueLogsDirty[$i]["systemQueueLogMessage"][0]) {
            		$xmldoc =& new MBXML(html_entity_decode($systemQueueLogsDirty[$i]["systemQueueLogMessage"][0]));
            		$systemQueueLogMessageParsed = secureInput($xmldoc->toArray());
            		if(!$xmldoc->isValid()) {
						$systemQueueLogMessageParsed = array("Error"=>"XML is corrupt!");
					}
            	} else {
					$systemQueueLogMessageParsed = array("Error"=>"systemQueueLogMessage is empty!");
				}
           		$systemQueueLogsDirty[$i]["systemQueueLogMessageParsed"][0] = $systemQueueLogMessageParsed;
			}

			$smartyVars["eventLogs"] = ($c == 1) ? array(0 => $systemQueueLogsDirty) : $systemQueueLogsDirty;

			$this->addTemplate("widgets/showEventOutputDetails", collapseArrayElements($smartyVars));
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowEventOutputDetails
?>