<?php
// $Id: EditFAQ.php,v 1.5 2006/03/22 20:41:01 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This action displays a form to edit the FAQ associated with the given FAQ ID. If the
 * given FAQ ID is not found, an error is displayed. Once the information for the FAQ
 * has been collected, the displayed form should post to the action EditFAQResponse.
 *
 * @author  Mark Garrett
 * @author  Vic Fryzel
 */
class EditFAQ extends MB_Action {
	/**
	 * The constructor for an EditFAQ action object. This calls the parent constructor,
	 * sets the string representation of this object, and sets $this->params to allow an incoming
	 * faqID.
	 */
	function EditFAQ() {
		parent::MB_Action();
		$this->stringRep = "EditFAQ";
		$this->params = array("faqID");
	}

	/**
	 * The main method of this class that executes the EditFAQ action, and returns success or
	 * failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$faqID = ((int) $_REQUEST["faqID"]);
		if(!$faqID) {
			$this->addError(TRANS_ACTIONERROR, "No FAQ ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetFAQs");
			$data = dispatchMBAPI($query, 1);
			$header =& $data["mbapi"][0]["header"][0];
			$results =& $data["mbapi"][0]["results"][0];

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$smartyVars = array();
				$smartyVars["faq"] = collapseArrayElements($results["FAQs"][0]["FAQ"][0]);
				$categoriesArray = $this->getMBAPIData("GetFAQCategories", "faqCategories", "faqCategory");
				foreach($categoriesArray as $category) {
					$smartyVars["faqCategories"][] = collapseArrayElements($category);
				}

				$this->addTemplate("faqs/EditFAQ", $smartyVars, 1);
				$CONF["debug"]->add("Array to Template", $smartyVars, __FILE__, __LINE__);
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditFAQ
?>