<?php
// $Id: EditFAQCategory.php,v 1.18 2006/05/19 20:58:44 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This action displays a form to edit the FAQ category associated with the given FAQ Category ID. If the
 * given FAQ Category ID is not found, an error is displayed. Once the information for the FAQ Category
 * has been collected, the displayed form should post to the action EditFAQCategoryResponse.
 *
 * @author  Mark Garrett
 * @author  Vic Fryzel
 */
class EditFAQCategory extends MB_Action {
	/**
	 * The constructor for a EditFAQCategory action object. This calls the parent constructor,
	 * sets the string representation of this object, and sets $this->params to allow an incoming
	 * faqCategoryID.
	 */
	function EditFAQCategory() {
		parent::MB_Action();
		$this->stringRep = "EditFAQCategory";
		$this->params = array("faqCategoryID");
	}

	/**
	 * The main method of this class that executes the EditFAQCategory action, and returns success or
	 * failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$faqCategoryID = ((int) $_REQUEST["faqCategoryID"]);
		if(!$faqCategoryID) {
			$this->addError(TRANS_ACTIONERROR, "No FAQ category ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetFAQCategories");
			$data = dispatchMBAPI($query, 1);
			$header =& $data["mbapi"][0]["header"][0];
			$results =& $data["mbapi"][0]["results"][0];

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$smartyVars = array();
				$smartyVars["faqCategory"] = collapseArrayElements($results["faqCategories"][0]["faqCategory"][0]);
				$smartyVars["faqCategoryTypes"] = getStatuses( "faqs" );

				$this->addTemplate("faqs/EditFAQCategory", $smartyVars, 1);
				$CONF["debug"]->add("Array to Template", $smartyVars, __FILE__, __LINE__);
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditFAQCategory
?>