<?php
// $Id: RemoveFAQCategory.php,v 1.3 2006/03/22 20:41:01 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action displays a form asking for confirmation for the removal of a FAQ category.
 *
 * @author  Vic Fryzel
 */
class RemoveFAQCategory extends MB_Action {
	/**
	 * The constructor for a RemoveFAQCategory action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function RemoveFAQCategory() {
		parent::MB_Action();
		$this->stringRep = "RemoveFAQCategory";
		$this->params = array("faqCategoryID");
	}

	/**
	 * The main method of this class that executes the RemoveFAQCategory action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		if(!((int) $_REQUEST["faqCategoryID"])) {
			$this->addError(TRANS_ACTIONERROR, "No FAQ category ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetFAQCategories");
			$data = dispatchMBAPI($query, 1);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$s = array();
					$s["faqCategory"] = $data["mbapi"][0]["results"][0]["faqCategories"][0]
						["faqCategory"][0];
					$this->addTemplate("faqs/RemoveFAQCategory", collapseArrayElements($s));

				} else {
					$this->addError(TRANS_ACTIONERROR, "FAQ category not found.");
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveFAQCategory
?>