<?php
// $Id: EditFraudCountryThreshold.php,v 1.7 2006/03/22 20:41:01 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/regions.php");

/**
 * This action displays the edit screen for a fraud country threshold.
 *
 * @author Michael Fountain
 */
class EditFraudCountryThreshold extends MB_Action {
	/**
	 * The constructor for a EditFraudCountryThreshold action object. This method calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditFraudCountryThreshold() {
		parent::MB_Action();
		$this->stringRep = "EditFraudCountryThreshold";
        $this->params = array("thresholdID");
	}

	/**
	 * The main method of this class that executes the EditFraudCountryThreshold action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$thresholdID = getParam("thresholdID");
		if(!$thresholdID) {
			$this->addError(TRANS_ACTIONERROR, "No threshold ID given.");
		} else {

			$query = $this->getMBAPIQuery("GetFraudCountryThresholds", "", array());
			$data = dispatchMBAPI($query, 1);

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

                $this->smartyVars["thresholdData"] = collapseArrayElements($results["countryThresholds"][0]["countryThreshold"]);

                // set default triggers
                $triggers = array
                (
                    "freeEmailWeight",
                    "countryMatchWeight",
                    "anonProxyWeight",
                    "countryRiskWeight",
                    "ipDistanceWeight",
                    "binMatchWeight",
                    "binBankMatchWeight",
                    "highRiskEmailWeight",
                    "highRiskShippingWeight",
                    "openProxyWeight"
                );
                $c = count($triggers);
                for($i=0;$i<$c;$i++) {
                    if (empty($this->smartyVars["thresholdData"][$triggers[$i]])) {
                        $this->smartyVars["thresholdData"][$triggers[$i]] == "0.0";
                    }
                }

                // set default scores
                $scoreScale = array();
                for($i=0;$i<=10;$i++){
                    for($j=0;$j<10;$j++){
                        if ($i<10) {
                            $scoreScale[] = $i.".".$j;
                        } else {
                            $scoreScale[] = "10.0";
                            break;
                        }
                    }
                }
                $this->smartyVars["scoreScale"] = $scoreScale;
                $this->smartyVars["fraudLevelActions"] = getStatuses("fraudLevelActions");
				$this->smartyVars["countryRegions"] = getRegions("names");
				$this->mergeCountryData($CONF["user"]["locale"]->country);
				$smartyVars["countryList"] = $this->smartyVars["countryList"];
				$smartyVars["selectedCountry"] = $this->smartyVars["selectedCountry"];

                $this->mergeSystemNavData();
				$this->addTemplate("fraudsets/EditFraudCountryThreshold", $this->smartyVars);

			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditFraudCountryThreshold
?>