<?php
// $Id: EditFraudCountryThresholdResponse.php,v 1.4 2006/03/22 20:41:01 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/types.php");

/**
 * This action edits an existing fraud country threshold. The threshold may or may not be
 * is not associated with a fraud set YET.
 *
 * @author Michael Fountain
 */
class EditFraudCountryThresholdResponse extends MB_Action {
	/**
	 * The constructor for an EditFraudCountryThresholdResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditFraudCountryThresholdResponse() {
		parent::MB_Action();
		$this->stringRep = "EditFraudCountryThresholdResponse";
		$this->params = array
		(
            "thresholdID",
            "thresholdName",
            "countryType",
            "countriesID",
            "regionsID",
            "levelOneScore",
            "levelTwoScore",
            "levelThreeScore",
            "levelOneAction",
            "levelTwoAction",
            "levelThreeAction",
            "catchAllAction",
            "overrideOneAmount",
            "overrideTwoAmount",
            "overrideThreeAmount",
            "overrideOneAction",
            "overrideTwoAction",
            "overrideThreeAction",
            "primaryScoreToUse",
            "freeEmailWeight",
            "countryMatchWeight",
            "anonProxyWeight",
            "countryRiskWeight",
            "ipDistanceWeight",
            "binMatchWeight",
            "binBankMatchWeight",
            "highRiskEmailWeight",
            "highRiskShippingWeight",
            "openProxyWeight"
		);
	}

	/**
	 * The main method of this class that executes the EditFraudCountryThresholdResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$thresholdID = ((int) $_REQUEST["thresholdID"]);
		if(!$thresholdID) {
			$this->addError(TRANS_ACTIONERROR, "No threshold ID given.");
		} else {

		    $query = $this->getMBAPIQuery("SetFraudCountryThresholds", "update", array());
		    $data = dispatchMBAPI($query, 1);

		    if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
			    redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
		    } else {
                if (!$adminGroupID && (int) $data["mbapi"][0]["header"][0]["lastInsertID"][0]) {
				    $adminGroupID = ((int) $data["mbapi"][0]["header"][0]["lastInsertID"][0]);
                }
			    redirect("fraudsets.php",getActionID("ShowFraudSets"), array("thresholdID"=>$thresholdID));
		    }

        }
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditFraudCountryThresholdResponse
?>