<?php
// $Id: ShowFraudSets.php,v 1.7 2006/03/24 17:20:58 mgarrett Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/regions.php");

/**
 * This action displays the fraud sets overview page.
 *
 * @author Michael Fountain
 */
class ShowFraudSets extends MB_Action {
	/**
	 * The constructor for a ShowFraudSets action object. This method calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function ShowFraudSets() {
		parent::MB_Action();
		$this->stringRep = "ShowFraudSets";
	}

	/**
	 * The main method of this class that executes the ShowFraudSets action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$query = $this->getMBAPIQuery("GetFraudSets", "", array());
		$data = dispatchMBAPI($query, 1);
		$fraudSets =& $data["mbapi"][0]["results"][0];

		if($this->addMBAPIErrors($data) === 0) {

            // GetFraudSets
			$this->smartyVars["fraudSets"] = protectArray($fraudSets["fraudSets"][0]["fraudSet"]);

            // GetFraudCountryThresholds
		    $query2 = $this->getMBAPIQuery("GetFraudCountryThresholds", "", array());
		    $data2 = dispatchMBAPI($query2, 1);
		    $countryThresholds =& $data2["mbapi"][0]["results"][0];
			$this->smartyVars["countryThresholds"] = protectArray($countryThresholds["countryThresholds"][0]["countryThreshold"]);

			// Set the templete for output
            $this->smartyVars = collapseArrayElements($this->smartyVars);

            $this->smartyVars["countryTypes"] = getTypes("countryTypes");
            $this->smartyVars["regionNames"] = getRegions("names");
            $this->smartyVars["nestedRegions"] = getRegions("nested");
            $this->mergeCountryData($CONF["user"]["locale"]->country);
            $smartyVars["countryList"] = $this->smartyVars["countryList"];
            $smartyVars["selectedCountry"] = $this->smartyVars["selectedCountry"];

			$this->mergeSystemNavData();
			$this->addTemplate("fraudsets/ShowFraudSets",$this->smartyVars, 1);

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowFraudSets
?>