<?php
// $Id: ShowGraph.php,v 1.4 2006/03/22 20:41:17 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-action/include/jpgraph/jpgraph.php");

/**
 * Generate and return a graph image to the user. If a graph for the given credentials has already been generated, and the 
 * cached image is within its lifetime, the cached image will be returned.
 *
 * @author  Vic Fryzel
 */
class ShowGraph extends MB_Action {
	/**
	 * The constructor for a EditConfigParams action object. This calls the parent constructor and sets our string 
	 * representation.
	 */
	function ShowGraph() {
		parent::MB_Action();
		$this->stringRep = "ShowGraph";
	}

	/**
	 * The main method of this class that executes the ShowGraph action, and returns success or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
$t =& new Timer();
		define("DEFAULT_GFORMAT", "auto");

		// Setup data
		$data =& $_REQUEST["data"];
		$h =& new QueryMaster("select");
		$results = NULL;
		if(is_array($data) && count($data)) {
			$c = count($data);
			for($i=0; $i<$c; $i++) {
				$h->addColumns($data[$i]);
			}
			if(is_array($_REQUEST["andClauses"])) {
				foreach($_REQUEST["andClauses"] as $clause) {
					$h->addCustomAndClause($clause);
				}
			}

			$h = NULL;
			$day = 1;
			$month = 8;
			$year = 2005;
			$results = array();
			for($i=$day; $i<=31; $i++) {
				$h =& new QueryMaster("select", "$i as client_date_created", "COUNT(clients.client_id) as numClients");
				$h->addAndClause("clients.client_date_created", ">", mktime(0,0,0,$month,$i,$year), "i");
				$h->addAndClause("clients.client_date_created", "<", mktime(23,59,59,$month,$i,$year), "i");
				$h->addGroupByColumns("clients.client_id");
//  			echo $h->getQuery();
// 				print_r($h->getResults());
				$results = array_merge($results, $h->getResults());
			}
		} else {
			$h->addColumns($data);
			$results = $h->getCol();
		}
		if($results === false || !is_array($results) || !count($results)) {
			$results = array();
		}

		// What width & height should our graph have?
		$width = (int) $_REQUEST["width"];
		if($width < 1) {
			$width = 400;
		}
		$height = (int) $_REQUEST["height"];
		if($height < 1) {
			$height = 300;
		}

		// How long (in seconds) should we cache the generated graph for?
		$cacheLength = (int) $_REQUEST["cacheLength"];
		if($cacheLength < 0) {
			$cacheLength = 0;
		}

		// Setup graph
		$graph =& new Graph($width, $height, "auto"/*, $cacheLength*/);
		if($_REQUEST["title"]) {
			$graph->title->Set($_REQUEST["title"]);
		}
		if($_REQUEST["titleBold"]) {
			$graph->title->SetFont(FF_FONT1, FS_BOLD);
		}
		$leftMargin = $rightMargin = $topMargin = $bottomMargin = -1;
		$keys = array("leftMargin", "rightMargin", "topMargin", "bottomMargin");
		foreach($keys as $key) {
			if(isset($_REQUEST[$key])) {
				$$key = (int) $_REQUEST[$key];
			}
		}
		$graph->SetMargin(100,40,30,140);
		
		$type = "";
		$plot = NULL;
		// What type of graph should we generate?
		if(eregi("bar", $_REQUEST["type"])) {
			$type = "bar";
			require_once mb_path("/lib-action/include/jpgraph/jpgraph_bar.php");
		} else if(eregi("pie", $_REQUEST["type"])) {
			$type = "pie";
			require_once mb_path("/lib-action/include/jpgraph/jpgraph_pie.php");
		} else {
			$type = "line";
			require_once mb_path("/lib-action/include/jpgraph/jpgraph_line.php");
			
			$yData = $xData = array();
			// Setup the data
			$xScale = $yScale = "lin";
			if(is_array($results[0]) && count($results[0]) > 1) {
				// Multiple columns back
				$c = count($results);
				for($i=0; $i<$c; $i++) {
					$yData[] = array_pop($results[$i]);
					$xData[] = array_pop($results[$i]);
				}
				// Set the type of scale for the x axis
// 				if(eregi("date", $data[0])) {
// 					require_once mb_path("/lib-action/include/jpgraph/jpgraph_date.php");
// 					$xScale = "dat";
// 				}
// 				// Set the type of scale for the y axis
// 				if(eregi("date", $data[1])) {
// 					require_once mb_path("/lib-action/include/jpgraph/jpgraph_date.php");
// 					$yScale = "dat";
// 				}
				$graph->SetScale($xScale.$yScale, min($yData), max($yData), min($xData), max($xData));
			} else if(!is_array($results[0]) && count($results)) {
				// Single column back
				$yData =& $results;
				$xData = false;
				$graph->SetScale("textlin", min($yData), max($yData));
			}

			if($xScale == "dat") {
				$graph->xaxis->scale->SetDateFormat("M j, Y");
				$graph->xaxis->SetLabelAngle(90);
			}
			if($yScale == "dat") {
// 				$graph->yaxis->scale->SetDateFormat("n j, Y");
				$graph->yaxis->SetLabelAngle(90);
			}

			// Setup plot
			$plot =& new LinePlot($yData, $xData);
			if($_REQUEST["lineColor"]) {
				$plot->SetColor($_REQUEST["lineColor"]);
			}
			if($_REQUEST["lineValues"]) {
				$plot->value->Show();
			}
			if($_REQUEST["lineValueFormat"]) {
				$plot->value->SetFormat($_REQUEST["lineValueFormat"]);
			}

			// Setup axes
			$axes = array("x", "y");
			foreach($axes as $axis) {
				$varName = $axis."axis";
				if($_REQUEST[$axis."Title"]) {
					$graph->$varName->title->Set($_REQUEST[$axis."Title"]);
				}
				if($_REQUEST[$axis."TitleBold"]) {
					$graph->$varName->title->SetFont(FF_FONT1, FS_BOLD);
				}
				if($_REQUEST[$axis."Color"]) {
					$graph->$varName->SetColor($_REQUEST[$axis."Color"]);
				}
				if($_REQUEST[$axis."DateFormat"]) {
					$graph->$varName->scale->SetDateFormat($_REQUEST[$axis."DateFormat"]);
				}
			}
		}
		
		// Add the plot to the graph
		$graph->Add($plot);

$time = $t->getElapsedTime();
`echo "Time to gen graph: $time" | write vic`;

		// Display the graph
		$graph->Stroke();
		
		return $this->hasExecutedSuccessfully();
	}
} // ShowGraph

$a =& new ShowGraph();
$a->execute();
?>