<?php
// $Id: CancelAuthTransaction.php,v 1.3 2006/03/22 20:41:02 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on a transaction for the purpose of processing a manual payment
 *
 * @author  Kris Bailey
 */
class CancelAuthTransaction extends MB_Action {
	/**
	 * The constructor for a CancelAuthTransaction action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.x
	 */

	function CancelAuthTransaction() {
		parent::MB_Action();
		$this->stringRep = "CancelAuthTransaction";
	}

	/**
	 * The main method of this class that executes the CancelAuthTransaction action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$transactionID = (int)$_REQUEST["transactionID"];
		$invoiceID = (int)$_REQUEST["invoiceID"];

	 	$cancelXML = "	<mbapi>
	 						<command>ProcessAuthCancel</command>
	 						<params>
	 							<transactionID>".$transactionID."</transactionID>
	 						</params>
	 					</mbapi>";
		$cancelReturn = dispatchMBAPI($cancelXML, 1);

        if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
            redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
        } else {
            redirect("invoices.php?action=".getActionID("ShowInvoiceDetails")."&invoiceID=".$invoiceID."&sid=".secureInput($_REQUEST["sid"]));
        }

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}



} // CancelAuthTransaction
?>