<?php
// $Id: ConfirmCreditNoteResponse.php,v 1.3 2006/03/22 20:41:02 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the EditInvoice action, applies that information to
 * records in the database, and redirects to the ShowInvoiceDetails action for the given invoice.
 *
 * @author  Kris Bailey
 */
class ConfirmCreditNoteResponse extends MB_Action {
	/**
	 * The constructor for an ConfirmCreditNoteResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function ConfirmCreditNoteResponse() {
		parent::MB_Action();
		$this->stringRep = "ConfirmCreditNoteResponse";
		$this->params = array(
			"invoiceID");
	}

	/**
	 * The main method of this class that executes the EditInvoiceResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$invoiceID = ((int) $_REQUEST["invoiceID"]);
		if(!$invoiceID) {
			$this->addError(TRANS_ACTIONERROR, "No invoice ID given.");
		} else {

            $result = dispatchMBAPI("
                    <mbapi>
                        <command>ProcessCreditNote</command>
                        <params>
                            <invoiceID>".$invoiceID."</invoiceID>
                        </params>
                    </mbapi>
            ", 1);
            $CONF["debug"]->debugMessage($result);

            if (!$this->getNumErrors()) {

                if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
                    redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
                } else {
                    redirect("invoices.php?action=".getActionID("ShowInvoiceDetails")."&invoiceID=".$result["mbapi"][0]["results"][0]["invoiceID"][0]."&sid=".secureInput($_REQUEST["sid"]));
                }

            }
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ConfirmCreditNoteResponse
?>