<?php
// $Id: ProcessTransactionRefund.php,v 1.3 2006/03/22 20:41:02 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on a transaction for the purpose of processing a refund
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ProcessTransactionRefund extends MB_Action {
	/**
	 * The constructor for a ProcessTransactionRefund action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.x
	 */

	function ProcessTransactionRefund() {
		parent::MB_Action();
		$this->stringRep = "ProcessTransactionRefund";
	}

	/**
	 * The main method of this class that executes the ProcessTransactionRefund action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

        $this->smartyVars = array();

        $invoiceID = ((int) $_REQUEST["invoiceID"]);
        $transactionID = ((int) $_REQUEST["transactionID"]);

        $query = "
            <mbapi>
                <command>GetTransactions</command>
                <params>
                    <getGatewayNames>1</getGatewayNames>
                    <transactionIDs>
                        <transactionID>".$transactionID."</transactionID>
                    </transactionIDs>
                </params>
            </mbapi>
        ";

        $CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
        $data = dispatchMBAPI($query, 1);
        $CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

        $this->smartyVars["invoiceID"] = (int)$_REQUEST["invoiceID"];

        if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

            $this->smartyVars["transaction"] = collapseArrayElements($data["mbapi"][0]["results"][0]["transactions"][0]["transaction"][0]);

            $this->addTemplate("invoices/ProcessTransactionRefund", $this->smartyVars);

        }

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditInvoice
?>