<?php
// $Id: ProcessTransactionRefundResponse.php,v 1.9 2006/07/25 23:08:13 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/accounting/Refund.php");

/**
 * This Action object takes information provided by the ProcessTransactionRefund action,
 * and uses it to refund the transaction amount to the customer.
 *
 * @author  Kris Bailey
 */
class ProcessTransactionRefundResponse extends MB_Action {
	/**
	 * The constructor for an ProcessTransactionRefundResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function ProcessTransactionRefundResponse() {
		parent::MB_Action();
		$this->stringRep = "ProcessTransactionRefundResponse";
	}

	/**
	 * The main method of this class that executes the ProcessTransactionRefundResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

        $transactionID = ((int) $_REQUEST["transactionID"]);
        $invoiceID = ((int) $_REQUEST["invoiceID"]);
        $key = secureInput($_REQUEST["key"]);
		
		$results = dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "GetEncryptedText",
				"params" => array(
					"text" => $key,
				),
			),
		)), 1);
		$key = ($results["mbapi"] && $results["mbapi"][0] && $results["mbapi"][0]["results"] && $results["mbapi"][0]["results"][0] && $results["mbapi"][0]["results"][0]["text"])?$results["mbapi"][0]["results"][0]["text"][0]:"";

        if(!$transactionID) {
            $this->addError(TRANS_ACTIONERROR, "No transaction ID given.");
        } elseif (!$key){
            $this->addError(TRANS_ACTIONERROR, "No key given.");
        } else {

            $query = "
                <mbapi>
                    <command>GetTransactions</command>
                    <params>
                        <getGatewayNames>1</getGatewayNames>
                        <transactionIDs>
                            <transactionID>".$transactionID."</transactionID>
                        </transactionIDs>
                    </params>
                </mbapi>
            ";

            $CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
            $data = dispatchMBAPI($query, 1);
            $CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

            $transaction = collapseArrayElements($data["mbapi"][0]["results"][0]["transactions"][0]["transaction"][0]);


            $refundXML = "
                        <mbapi>
                          <command>ProcessGateway</command>
                          <showXMLHeader>0</showXMLHeader>
                          <params>
                              <gateway>
                                <".$transaction["gatewayClassName"].">
                                  <params>
                                    <configGroupName>".$transaction["configGroupName"]."</configGroupName>
                                    <subCommand>refund</subCommand>
                                    <transactionCode>".$transaction["transactionCode"]."</transactionCode>
                                    <billingAccountID>".$transaction["billingAccountID"]."</billingAccountID>
                                    <paymentDescription>".TRANS_REFUND."</paymentDescription>
                                    <paymentAmount>".$transaction["transactionAmount"]."</paymentAmount>
                                    <key>".$key."</key>
                                  </params>
                                </".$transaction["gatewayClassName"].">
                              </gateway>
                          </params>
                        </mbapi> ";

            $CONF["debug"]->add("Action Command", htmlentities($refundXML), __FILE__, __LINE__);
            $refundReturn = dispatchMBAPI($refundXML, 1);
            $CONF["debug"]->debugMessage($refundReturn);

            if ($refundReturn["mbapi"][0]["results"][0]["gatewayReturn"][0]["status"][0]!=1){
                $this->addError(TRANS_ACTIONERROR, "Refund Unsuccessful, invalid key perhaps?.");
            } else {

                $getInvoiceXML = "
                    <mbapi>
                        <command>GetInvoices</command>
                        <params>
                            <invoiceID>".$invoiceID."</invoiceID>
                            <getInvoiceLineItemsData>1</getInvoiceLineItemsData>
                        </params>
                    </mbapi>
                ";
                $invoiceData = collapseArrayElements(dispatchMBAPI($getInvoiceXML, 1));
                $invoiceData = $invoiceData["mbapi"]["results"]["invoices"]["invoice"];
                $CONF["debug"]->debugMessage($invoiceData);
                $clientID = $invoiceData["lineItems"]["lineItem"][0]["clientID"];

                $transUpdateXML = "
                                <mbapi>
                                    <command>SetTransaction</command>
                                    <subCommand>update</subCommand>
                                    <params>
                                        <transactionID>".$transactionID."</transactionID>
                                        <authReturn>150</authReturn>
                                    </params>
                                </mbapi>
                                ";
                $ret = dispatchMBAPI($transUpdateXML, 1);

                $return = dispatchMBAPI("<mbapi>
                                            <command>ProcessRefundAccounting</command>
                                            <params>
                                                <transactionID>".$transactionID."</transactionID>
                                            </params>
                                        </mbapi>", 1);
                if (!$return["mabpi"][0]["header"][0]["success"][0]){
                    $CONF["debug"]->debugMessage($return);
                }

                if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
                    redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
                } else {
                    redirect("invoices.php?action=".getActionID("ShowInvoices")."&sid=".secureInput($_REQUEST["sid"]));
                }

            }



		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditInvoiceResponse
?>