<?php
// $Id: RemoveInvoiceTransaction.php,v 1.1 2006/07/27 15:52:27 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object takes a transaction id and asks you whether you really want to remove it or not.
 *
 * @author  Kris Bailey
 */
class RemoveInvoiceTransaction extends MB_Action {
	/**
	 * The constructor for a RemoveInvoiceTransaction action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.x
	 */

	function RemoveInvoiceTransaction() {
		parent::MB_Action();
		$this->stringRep = "RemoveInvoiceTransaction";
		$this->params = array("transactionID");
	}

	/**
	 * The main method of this class that executes the RemoveInvoiceTransaction action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
        $this->smartyVars = array();

		$transactionID = ((int) $_REQUEST["transactionID"]);
		$invoiceID = ((int) $_REQUEST["invoiceID"]);
		if(!$invoiceID || !$transactionID) {
			$this->addError(TRANS_ACTIONERROR, "Invalid invoice or transaction specified.");
		} else {
			
			$this->smartyVars["invoiceInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetInvoices",
					"params" => array(
						"invoiceID" => $invoiceID,
						"getInvoiceLineItemsData" => 1,
					),
				),
			)));
			
			$this->smartyVars["transactionInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetTransactions",
					"params" => array(
						"transactionIDs" => array(
							"transactionID" => $transactionID,
						),
					),
				),
			)));
			
			$this->smartyVars["genericType"] = "remove";
			$this->smartyVars["parentName"] = "TRANS_FINANCES";
			$this->smartyVars["childName"] = "TRANS_MANAGE_INVOICES";
			$this->smartyVars["grandchildName"] = "TRANS_REMOVE_TRANSACTION";
			$this->smartyVars["sideNavMajor"] = "finances";
			$this->smartyVars["sideNavMinor"] = "invoices";
			$this->smartyVars["headerMessage"] = "TRANS_CONFIRM_TRANSACTION_REMOVE";

			$this->smartyVars["inForm"] = "no";
			$this->smartyVars["removeResponseAction"] = "RemoveInvoiceTransactionResponse";
			$this->smartyVars["hiddenFields"] = array(
				"invoiceID" => $invoiceID,
				"transactionID" => $transactionID,
			);

			/** AUTO GENERATE FORM DATA BEGIN **/
			$this->smartyVars["editForm"] =& new MBAutoFormFields();
			$this->smartyVars["editForm"]->addFields(array(
				/*"invoiceNumber" => array("text", "TRANS_INVOICE_NUMBER"),*/
				"transactionID" => array("text", "TRANS_TRANSACTION_ID"),
				"transactionCode" => array("text", "TRANS_TRANSACTION_CODE"),
				"transactionAmount" => array("text", "TRANS_AMOUNT"),
			));
	
			$this->smartyVars["editForm"]->addFieldValue("invoiceNumber", $this->smartyVars["invoiceInfo"]["invoiceNumber"]);
			$this->smartyVars["editForm"]->addFieldValue("transactionID", $transactionID);
			$this->smartyVars["editForm"]->addFieldValue("transactionCode", $this->smartyVars["transactionInfo"]["transactionCode"]);
			$this->smartyVars["editForm"]->addFieldValue("transactionAmount", $this->smartyVars["transactionInfo"]["transactionAmount"]);
			
			$this->smartyVars["editForm"]->setFieldData("invoiceNumber", "showOnly", 1);
			$this->smartyVars["editForm"]->setFieldData("transactionID", "showOnly", 1);
			$this->smartyVars["editForm"]->setFieldData("transactionCode", "showOnly", 1);
			$this->smartyVars["editForm"]->setFieldData("transactionAmount", "showOnly", 1);
			$this->smartyVars["editForm"]->setFieldData("transactionAmount", "currencyID", $this->smartyVars["transactionInfo"]["currencyID"]);
			
			$this->smartyVars["editForm"] = $this->smartyVars["editForm"]->getData();
			$this->smartyVars["editFields"] =& $this->smartyVars["editForm"]["fields"];
			
			$this->addTemplate("widgets/genericTemplate", $this->smartyVars);
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveInvoiceTransaction
?>