<?php
// $Id: ShowInvoices.php,v 1.28 2006/06/12 18:10:39 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all invoices that match the given parameters, and
 * generates the display of that information.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ShowInvoices extends MB_Action {
	/**
	 * The constructor for a ShowInvoices action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowInvoices() {
		parent::MB_Action();
		$this->stringRep = "ShowInvoices";
		
		$this->params = array
		(
			"invoiceID",
			"clientID",

            "invoiceNumber",

			// invoiceAmount options
			"invoiceAmount",
			"invoiceAmountLessThan",
			"invoiceAmountGreaterThan",

			// invoiceDateEntered options
			"invoiceDateEntered",
			"invoiceDateEnteredLessThan",
			"invoiceDateEnteredGreaterThan",

			// invoiceDateDue options
			"invoiceDateDue",
			"invoiceDateDueLessThan",
			"invoiceDateDueGreaterThan",

		);

        // handle date searches and correct mismatch of amount labels
        $this->setupDateRequestArgs();

        // handle amount searches and correct mismatch of amount labels
        if ($_REQUEST["amountColumn"]!="") {
            for ($i = 0; $i < count($_REQUEST["amountCompare"]); $i++){
                if ($_REQUEST["amountCompare"][$i]!="Greatest" && $_REQUEST["amountCompare"][$i]!="Least" && $_REQUEST["amountCompare"][$i]!="LessThan" && $_REQUEST["amountCompare"][$i]!="GreaterThan"){
                    $_REQUEST[$_REQUEST["amountColumn"]] = (double) $_REQUEST["amountQuery"][$i];
                } else {
                    $_REQUEST["amountCompare"][$i] = (eregi("Than", $_REQUEST["amountCompare"][$i])) ?
                        $_REQUEST["amountCompare"][$i] :
                        ($_REQUEST["amountCompare"][$i]=="Greatest")?"LessThan":"GreaterThan";
                    $_REQUEST[$_REQUEST["amountColumn"].$_REQUEST["amountCompare"][$i]] = (double) $_REQUEST["amountQuery"][$i];
                }
            }
        }

        // search in a specific column
        if ($_REQUEST["queryColumn"]!="") {
            $isDate = (ereg("Date",$_REQUEST["queryColumn"])) ? true : false ;
            if ($_REQUEST["queryGreatest"]!="") {
                $_REQUEST[$_REQUEST["queryColumn"]."Greatest"] = $_REQUEST["queryGreatest"];
                if ($isDate) {
                    list($m,$d,$y) = explode("/",$_REQUEST["queryGreatest"]);
                    $_REQUEST[$_REQUEST["queryColumn"]."Greatest"] = mktime(23,59,59,$m,$d,$y);
                }
            }
            if ($_REQUEST["queryLeast"]!="") {
                $_REQUEST[$_REQUEST["queryColumn"]."Least"] = $_REQUEST["queryLeast"];
                if ($isDate) {
                    list($m,$d,$y) = explode("/",$_REQUEST["queryLeast"]);
                    $_REQUEST[$_REQUEST["queryColumn"]."Least"] = mktime(0,0,0,$m,$d,$y);
                }
            }
            if ($_REQUEST["query"]!="") {
                $_REQUEST[$_REQUEST["queryColumn"]] = $_REQUEST["query"];
                if ($isDate) {
                    list($m,$d,$y) = explode("/",$_REQUEST["query"]);
                    $_REQUEST[$_REQUEST["queryColumn"]] = null;
                    $_REQUEST[$_REQUEST["queryColumn"]."Least"] = mktime(0,0,0,$m,$d,$y);
                    $_REQUEST[$_REQUEST["queryColumn"]."Greatest"] = mktime(23,59,59,$m,$d,$y);
                }
            }
        } else if ($_REQUEST["query"]!="") {
            $_REQUEST["invoiceNumber"] = $_REQUEST["query"];
            $_REQUEST["invoiceComments"] = $_REQUEST["query"];
        }

		// add filtered columns to $this->params LAST, they are NOT searchable
		if (is_numeric($_REQUEST["invoiceStatus"])) {
			$this->params[] = "invoiceStatus";
		}

		$this->sortColumns = array
		(
			"invoiceID",
			"invoiceAmount",
			"invoiceDateEntered",
			"invoiceDateDue",
			"invoiceStatus",
			"clientLastName"
		);
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

        $this->smartyVars = array();

		$xmlParams = array
		(
			"getInvoiceLineItemsData" => 1,
		);
		$query = $this->getMBAPIQuery("GetInvoices", "",  $xmlParams, 1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {

			// set master invoices data array
			$this->smartyVars["invoices"] = collapseArrayElements(
                                                protectArray($results["invoices"][0]["invoice"])
                                            );

			if($this->smartyVars["invoices"]) {
				for ($i = 0; $i < count($this->smartyVars["invoices"]); $i++){
					if (!$this->smartyVars["invoices"][$i]["lineItems"]["lineItem"][0]["clientID"]){
						$this->smartyVars["invoices"][$i]["lineItems"]["lineItem"] = array($this->smartyVars["invoices"][$i]["lineItems"]["lineItem"]);
					}
				}
			}


			// set master invoices line item data array
			$lineItems = array();
			$c = count($results["invoices"][0]["invoice"]);
			for($i = 0; $i < $c; $i++) {
				// leave this uncollapsed so that the template code can work with both singular and plural results;
				// see the comment in the template for details
				$lineItemsData =& $results["invoices"][0]["invoice"][$i]["lineItems"][0]["lineItem"];
				$lineItems[$results["invoices"][0]["invoice"][$i]["invoiceID"][0]] = collapseArrayElements(protectArray($lineItemsData));
			}
			$this->smartyVars["lineItems"] = $lineItems;

			// set pagination links data
			$this->smartyVars["paginationLinks"] = collapseArrayElements($results["paginationLinks"][0]);

			// assign filtered columns
			if (is_numeric($_REQUEST["invoiceStatus"])) {
				$this->smartyVars["invoiceStatus"] = ((int) $_REQUEST["invoiceStatus"]);
			}

			// assign sortable columns for advanced options
			$this->smartyVars["sortColumns"] = array
			(
				"invoiceNumber" => TRANS_INVOICE_NUMBER,
				"invoiceAmount" => TRANS_INVOICE_AMOUNT,
				"invoiceDateEntered" => TRANS_DATE_ENTERED,
				"invoiceDateDue" => TRANS_DATE_DUE,
			);

			// call the display template
			$this->addTemplate("invoices/ShowInvoices", $this->smartyVars);
			
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowInvoices
?>
