<?php
// $Id: LoginResponse.php,v 1.19 2006/05/03 15:59:10 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the ShowLogin action, and checks that information against 
 * the database. If the provided username and password are correct, this action will establish an admin session.
 * Additionally, if the user requested to be "remembered" in the previous session, a cookie will be set storing 
 * the session ID for the duration of the session. Remember that this version of LoginResponse executes an 
 * ADMIN login.
 *
 * @author  Vic Fryzel
 */
class LoginResponse extends MB_Action {
	/**
	 * The constructor for a LoginResponse action object. This calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function LoginResponse() {
		parent::MB_Action();
		$this->stringRep = "LoginResponse";
		$this->params = array("adminUsername", "adminPassword", "adminRemoteAccessHash");
	}

	/**
	 * The main method of this class that executes the LoginResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$adminRemoteAccessHash = secureInput($CONF["user"]["remoteAccessHash"]);

		if($CONF["user"]["remoteSessionID"]) {
			$isSessionActive = setSession($CONF["user"]["remoteSessionID"]);
			if($isSessionActive) {
				$this->hasExecutedSuccessfully = 1;
				$CONF["user"]["sessionID"] = $_REQUEST["sid"] = $CONF["user"]["remoteSessionID"];
				return $this->hasExecutedSuccessfully();
			}
		}

		$query = $this->getMBAPIQuery("ProcessAdminLogin", "",
			array("adminIP" => $CONF["user"]["ip"], "adminRemoteAccessHash" => $adminRemoteAccessHash));
		$data = dispatchMBAPI($query, 1);
		dbg("admin login response:");
		dbg($data);

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

			if(is_array($data["mbapi"][0]["results"][0]) && count($data["mbapi"][0]["results"][0])) {
			 	dbg("inside");
				$_REQUEST["sid"] = $data["mbapi"][0]["results"][0]["sessionID"][0];

				// Allow expired users to resume a new session from where their last one left off
				if($_REQUEST["redirectActionID"] && $_REQUEST["redirectActionFile"]) {
					$numMatches = preg_match("/[a-zA-Z0-9\-\_]*\.php/", $_REQUEST["redirectActionFile"], $matches);
					if($numMatches === 1 && $matches[0]) {
						redirect($matches[0]."?action=".((int) $_REQUEST["redirectActionID"])."&".$_REQUEST["redirectArgs"]);
					}
				} else {
					//If it's a remote API call, let it bubble back instead of redirect
					if($adminRemoteAccessHash) {
						$_REQUEST["adminID"] = $data["mbapi"][0]["results"][0]["adminID"][0];
						$CONF["user"]["type"] = 2;
						$CONF["user"]["sessionID"] = $_REQUEST["sid"];
						$this->hasExecutedSuccessfully = 1;
						return $this->hasExecutedSuccessfully();
					} else {
						// a change in login process
						//redirect("clients.php", getActionID("ShowClientStats"));
						redirect("todos.php", getActionID("ShowTodos"));
					}
				}
			} else {
				redirect("login.php",getActionID("ShowLogin"), array("msg" => urlencode(TRANS_LOGINFAILURE)));
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // LoginResponse
?>