<?php
// $Id: ShowLogin.php,v 1.14 2006/03/21 23:01:06 ben Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once mb_path("/lib-action/action.php");

/**
 * This action displays a login form to the user. This instance of this action is hit whenever an admin user's session
 * has expired. To alleviate frustration, when posting to the admin/login/LoginResponse action, the redirectActionID 
 * and redirectActionFile request parameters should also be passed, so that LoginResponse can redirect accordingly. This 
 * is not a security issue, because the admin is required to authenticate before redirect, and even if they hit the 
 * given action file and action ID, they'd be denied access unless their user is allowed access by the system.
 *
 * @author  Vic Fryzel
 */
class ShowLogin extends MB_Action {
	/**
	 * The constructor for a ShowLogin action object. This method calls the parent constructor, and sets the string
	 * representation of this object.
	 */
	function ShowLogin() {
		parent::MB_Action();
		$this->stringRep = "ShowLogin";
	}

	/**
	 * The main method of this class that executes the ShowLogin action, and returns success or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		// force usage of the admin login template since we are not logged in yet
		$CONF["theme"]["type"] = "admin";

		// We allow for action redirects here, so if someone's session expired, they can at least get to the same 
		// page immediately
		if($_REQUEST["redirectActionID"] && $_REQUEST["redirectActionFile"]) {
			$smartyVars = array("redirectActionID" => $_REQUEST["redirectActionID"],
				"redirectActionFile" => $_REQUEST["redirectActionFile"], "redirectArgs" => $_REQUEST["redirectArgs"]);
		}
		$this->hasExecutedSuccessfully = ((int) $this->addTemplate("login/ShowLogin", $smartyVars));
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowLogin
?>
