<?php
// $Id: MigrateConfigAssociate.php,v 1.15 2006/07/20 20:27:39 bwoolley Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-tk/toolkit.php");

class MigrateConfigAssociate extends GenericAction {
	function MigrateConfigAssociate() {
		parent::SourceAction();
		$this->stringRep = "MigrateConfigAssociate";
	}
	
	function execute() {
		parent::execute();
		
		if(!$migrationConfig = oneByID("migrationConfigs", (int) $_REQUEST["migrationConfigID"])) {
			redirect("migrate.php", getActionID("ShowMigrationConfigs"));
			exit;
		}
		$this->smartyVars["migrationConfig"] = $migrationConfig;
		//show($migrationConfig);
		
		do {

			$dbr =& ADONewConnection(getAPITypeName("DBDriver", $migrationConfig["migrationDBDRIVERType"]));
			$dbr->autoRollback = true;
			$dbr->Connect($migrationConfig["migrationDBHOST"], $migrationConfig["migrationDBUSERNAME"], $migrationConfig["migrationDBPASSWORD"], $migrationConfig["migrationDBNAME"]);
			//show($dbr);
			if(!$dbr->IsConnected()) {
				redirect("migrate.php", getActionID("MigrateError"), array("migrationErrorCode" => 1));
				exit;
			}
			
			/*
			$q =& new QueryMaster("select", $dbr);
			$q->enableManualJoining();
			$q->addTables("config");
			$q->addColumns("config_59");
			$q->addAndClause("config_type", "=", "main", "s");
			list($version) = explode(":", $q->getOne());
			if(version_compare($version, "4.4", "<")) {
				redirect("migrate.php", getActionID("MigrateError"), array("migrationErrorCode" => 2, "migrationErrorMessage" => $version));
				exit;
			}
			/**/

			$q =& new QueryMaster("select", $dbr);
			$q->enableManualJoining();
			$q->addTables("package_type");
			$q->addColumns("pack_id", "pack_name");
			$t =& $q->getTable(-1, 0, "pack_id", "pack_name");
			$productOptions = $t->getOptions();
			//show("from products");
			//show($productOptions);

			$q =& new QueryMaster("select", $dbr);
			$q->enableManualJoining();
			$q->addTables("account_details");
			$q->addColumns("server");
			$q->addDistinctColumn("server");

			//show($q->getQuery());
			$t =& $q->getTable();
			$r = array_filter($t->getColumnDistinct("server"));
			$panelOptions = array();
			foreach($r as $panel) $panelOptions[$panel] = $panel;
			//show("from panels");
			//show($panelOptions);

			$registrars = array(
				2 => "mod_opensrs",
				3 => "mod_emailregister",
				4 => "mod_enom",
				9 => "mod_nominet",
				11 => "mod_onlinenic",
				12 => "mod_srsplus",
				14 => "mod_registercom",
			);
			$registrarOptions = array();
			$q =& new QueryMaster("select", $dbr);
			$q->enableManualJoining();
			$q->addTables("domain_names");
			$q->addColumns("registrar_id");
			$q->addDistinctColumn("registrar_id");

			//show($q->getQuery());
			$t =& $q->getTable();
			$r = array_filter($t->getColumnDistinct("registrar_id"));
			$registrarOptions = array();
			foreach($registrars as $registrar_id => $registrar_name) if(in_array($registrar_id, $r)) $registrarOptions[$registrar_id] = $registrar_name;
			//show("from registrars");
			//show($registrarOptions);

			/*
			$d =& new DataSource("products", array("getNonAddons" => 1));
			$t =& $d->getTable();
			$products = $t->getTable();
			$toProductOptions = $toDomainProductOptions = array();
			foreach($products as $product) {
				if($product["productType"] == getAPITypeID("products", "domain")) {
					$toDomainProductOptions[$product["productID"]] = $product["productName"];
				} else {
					$toProductOptions[$product["productID"]] = $product["productName"];
				}
			}
			*/
			$toProductOptions = $toDomainProductOptions = optionsFor("products", array("getNonAddons" => 1));
			//show($d);
			//show("to products");
			//show($toProductOptions);
			$toPanelOptions = $this->getPanelOptions();
			//show("to panels");
			//show($toPanelOptions);
			$toRegistrarOptions = $this->getRegistrarOptions();
			//show("to registrars");
			//show($toRegistrarOptions);


			$this->smartyVars["productOptions"] = $productOptions;
			$this->smartyVars["panelOptions"] = $panelOptions;
			$this->smartyVars["registrarOptions"] = $registrarOptions;

			$this->smartyVars["toProductOptions"] = $toProductOptions;
			$this->smartyVars["toDomainProductOptions"] = $toDomainProductOptions;
			$this->smartyVars["toPanelOptions"] = $toPanelOptions;
			$this->smartyVars["toRegistrarOptions"] = $toRegistrarOptions;
			SourceAction::addTemplate("migrate/MigrateConfigAssociate");
		} while(0);
		$this->addErrorTemplates();
	}
}

?>
