<?php
// $Id: MigrateConfigAssociateResponse.php,v 1.6 2006/06/19 18:50:59 bwoolley Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-tk/toolkit.php");

class MigrateConfigAssociateResponse extends SourceAction {
	function MigrateConfigAssociateResponse() {
		parent::SourceAction();
		$this->stringRep = "MigrateConfigAssociateResponse";
	}
	
	function execute() {
		//show($_REQUEST);

		if(!$migrationConfig = oneByID("migrationConfigs", (int) $_REQUEST["migrationConfigID"])) {
			redirect("migrate.php", getActionID("ShowMigrationConfigs"));
			exit;
		}
		
		$migrationConfigID = $migrationConfig["migrationConfigID"];
		
		$products = $panels = $registrars = array();
		foreach($_REQUEST as $param => $val) {
			list($type, $extVal) = explode(":", $param);
			switch($type) {
				case "product":
					$products[$extVal] = $val;
					break;
				case "panel":
					$panels[$extVal] = $val;
					break;
				case "registrar":
					$registrars[$extVal] = $val;
					break;
			}
		}
		//show($products);
		//show($panels);
		//show($registrars);
		deleteFor("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "products"));
		deleteFor("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "panels"));
		deleteFor("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "registrars"));
		deleteFor("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationExtObjName" => "panels"));
		deleteFor("migrationMappings", array("migrationConfigID" => $migrationConfigID));
		
		$migrationObjID = insertFor(
			"migrationObjs",
			array(
				"migrationConfigID" => $migrationConfigID,
				"migrationObjName" => "products",
				"migrationIntObjName" => "products",
				"migrationIntObjKey" => "productID",
				"migrationExtObjName" => "package_info",
				"migrationExtObjKey" => "pack_id",
			)
		);

		foreach($products as $extID => $intID) {
			insertFor(
				"migrationMappings",
				array(
					"migrationConfigID" => $migrationConfigID,
					"migrationObjID" => $migrationObjID,
					"migrationExtID" => $extID,
					"migrationIntID" => $intID,
				)
			);
		}

		$migrationObjID = insertFor(
			"migrationObjs",
			array(
				"migrationConfigID" => $migrationConfigID,
				"migrationObjName" => "panels",
				"migrationIntObjName" => "configGroups",
				"migrationIntObjKey" => "configGroupID",
				"migrationExtObjName" => "account_details",
				"migrationExtObjKey" => "server",
			)
		);

		foreach($panels as $extID => $intID) {
			$virtualExtID = insertFor(
				"migrationObjs",
				array(
					"migrationConfigID" => $migrationConfigID,
					"migrationObjName" => $extID,
					"migrationExtObjName" => "panels",
				)
			);

			insertFor(
				"migrationMappings",
				array(
					"migrationConfigID" => $migrationConfigID,
					"migrationObjID" => $migrationObjID,
					"migrationExtID" => $virtualExtID,
					"migrationIntID" => $intID,
				)
			);
		}
		
		$migrationObjID = insertFor(
			"migrationObjs",
			array(
				"migrationConfigID" => $migrationConfigID,
				"migrationObjName" => "registrars",
				"migrationIntObjName" => "configGroups",
				"migrationIntObjKey" => "configGroupID",
				"migrationExtObjName" => "domain_names",
				"migrationExtObjKey" => "registrar_id",
			)
		);

		foreach($registrars as $extID => $intID) {
			insertFor(
				"migrationMappings",
				array(
					"migrationConfigID" => $migrationConfigID,
					"migrationObjID" => $migrationObjID,
					"migrationExtID" => $extID,
					"migrationIntID" => $intID,
				)
			);
		}
		
		if(!empty($_REQUEST["lek_passphrase"])) {
			$migrationObjID = insertFor(
				"migrationObjs",
				array(
					"migrationConfigID" => $migrationConfigID,
					"migrationObjName" => "lek",
					"migrationExtObjName" => $_REQUEST["lek_passphrase"],
				)
			);
		}

		redirect("migrate.php", getActionID("MigrateManager"), array("migrationConfigID" => $migrationConfig["migrationConfigID"]));
	}
}

?>
