<?php
// $Id: MigrateManager.php,v 1.6 2006/06/20 22:28:42 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-tk/toolkit.php");

define("CLIENT_PROCESS_STEP", 5);
define("CONTAINER_WIDTH", 750);

class MigrateManager extends SourceAction {
	function MigrateManager() {
		parent::SourceAction();
		$this->stringRep = "MigrateManager";
	}
	
	function execute() {
		do  {
			$migrationConfigID = (int) $_REQUEST["migrationConfigID"];
			if(!$migrationConfig = oneByID("migrationConfigs", $migrationConfigID)) {
				redirect("migrate.php", getActionID("ShowMigrationConfigs"));
				break;
			}
			$this->migrationConfig = $migrationConfig;
			
			// get our client migration information, or initialize it if necessary
			if(!$clientMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "clients"))) {
				if(!$clientMigrationID = insertFor(
						"migrationObjs",
						$clientMigration = array(
							"migrationConfigID" => $migrationConfigID, 
							"migrationObjName" => "clients",
							"migrationExtObjName" => "client_info",
							"migrationExtObjKey" => "client_id",
							"migrationExtSeqID" => 0,
							"migrationIntObjName" => "clients",
							"migrationIntObjKey" => "clientID",
							"migrationIntSeqID" => 0,
						)
					)
				) {
					$e = "Could not initialize client migration state.";
					break;
				}
				$clientMigration["migrationObjID"] = $clientMigrationID;
			} else {
				$clientMigrationID = $clientMigration["migrationObjID"];
			}
			//show($migrationConfig);
			//show($clientMigration);

			// get our client migration information, or initialize it if necessary
			if(!$packageMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "packages"))) {
				if(!$packageMigration = insertFor(
						"migrationObjs",
						$packageMigration = array(
							"migrationConfigID" => $migrationConfigID, 
							"migrationObjName" => "packages",
							"migrationExtObjName" => "client_packages",
							"migrationExtObjKey" => "cp_id",
							"migrationExtSeqID" => 0,
							"migrationIntObjName" => "packages",
							"migrationIntObjKey" => "packageID",
							"migrationIntSeqID" => 0,
						)
					)
				) {
					$e = "Could not initialize client migration state.";
					break;
				}
				$packageMigration["migrationObjID"] = $packageMigrationID;
			} else {
				$packageMigrationID = $packageMigration["migrationObjID"];
			}
			
			// connect to v4
			$this->dbr =& ADONewConnection(getAPITypeName("DBDriver", $migrationConfig["migrationDBDRIVERType"]));
			$this->dbr->autoRollback = true;
			$this->dbr->Connect($migrationConfig["migrationDBHOST"], $migrationConfig["migrationDBUSERNAME"], $migrationConfig["migrationDBPASSWORD"], $migrationConfig["migrationDBNAME"]);
			//show($dbr);
			if(!$this->dbr->IsConnected()) {
				$e = "Could not connect to the database, please check your config options.";
				break;
			}
			
			$totalClients = $this->dbr->GetOne("SELECT COUNT(*) FROM client_info");
			$finishedClients = (int) countFor(
				"migrationMappings",
				array(
					"migrationConfigID" => $migrationConfigID,
					"migrationObjID" => $clientMigrationID,
				)
			);
			$remainingClients = $totalClients - $finishedClients;

			$this->smartyVars["migrationConfigID"] = $migrationConfigID;
			$this->smartyVars["clientMigrationID"] = $clientMigrationID;
			$this->smartyVars["clientMigration"] = $clientMigration;
			$this->smartyVars["totalClients"] = $totalClients;
			$this->smartyVars["remainingClients"] = $remainingClients;
			$this->smartyVars["finishedClients"] = $finishedClients;
			
			$barWidth = (int) (CONTAINER_WIDTH * ($finishedClients / $totalClients));
			if(!$barWidth) $barWidth = 1;
			
			$this->smartyVars["containerWidth"] = CONTAINER_WIDTH;
			$this->smartyVars["barWidth"] = $barWidth;

			SourceAction::addTemplate("migrate/MigrateManager");
		} while(0);
		if($e) {
			$this->addError(TRANS_ACTIONERROR, $e);
			$this->addErrorTemplates();
		}
	}
}
