<?php
// $Id: MigrateProcess.php,v 1.27 2006/06/27 21:41:44 achrist Exp $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

set_time_limit(0);
ignore_user_abort();

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-tk/toolkit.php");
require_once mb_path("/lib-modernbill/include/migration/migrationFunctions.php");
require_once mb_path("/lib-modernbill/include/accounting/Sale.php");
require_once mb_path("/lib-modernbill/include/accounting/Payment.php");
require_once mb_path("/lib-tk/include/crypt/crypt.php");
//header("Content-Type: text/html; charset=utf-8");

define("CLIENT_PROCESS_STEP", 5);

class MigrateProcess extends SourceAction {
	function MigrateProcess() {
		parent::SourceAction();
		$this->stringRep = "MigrateProcess";
	}
	
	function execute() {
		do  {
			$e = "";

			$migrationConfigID = (int) $_REQUEST["migrationConfigID"];
			$clientProcessStep = (int) $_REQUEST["clientProcessStep"] ? (int) $_REQUEST["clientProcessStep"] : CLIENT_PROCESS_STEP;
		
			if(!$migrationConfig = oneByID("migrationConfigs", $migrationConfigID)) {
				redirect("migrate.php", getActionID("ShowMigrationConfigs"));
				exit;
			}
			$this->migrationConfig = $migrationConfig;
			$this->migrationConfigID = $migrationConfigID;

			// get our client migration information
			if(!$clientMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "clients"))) {
				$e = "Could not get client migration state. Must be called from the Migration Manager, which will initialize the client migration state.";
				break;
			} else {
				$clientMigrationID = $clientMigration["migrationObjID"];
			}

			// get our client migration information
			if(!$packageMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "packages"))) {
				$e = "Could not get client migration state. Must be called from the Migration Manager, which will initialize the package migration state.";
				break;
			} else {
				$packageMigrationID = $packageMigration["migrationObjID"];
			}

			// get our client migration information
			if(!$productMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "products"))) {
				$e = "Could not get product migration state. Must be called from the migration association page, which will initialize the product migration state.";
				break;
			} else {
				$productMigrationID = $productMigration["migrationObjID"];
			}

			// get our panel migration information
			if(!$panelMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "panels"))) {
				$e = "Could not get panel migration state. Must be called from the migration association page, which will initialize the panel migration state.";
				break;
			} else {
				$panelMigrationID = $panelMigration["migrationObjID"];
			}

			// get our panel migration information
			if(!$registrarMigration = oneOf("migrationObjs", array("migrationConfigID" => $migrationConfigID, "migrationObjName" => "registrars"))) {
				$e = "Could not get registrar migration state. Must be called from the migration association page, which will initialize the registrar migration state.";
				break;
			} else {
				$registrarMigrationID = $registrarMigration["migrationObjID"];
			}

			//show($clientMigration);

			// connect to v4
			$this->dbr =& ADONewConnection(getAPITypeName("DBDriver", $migrationConfig["migrationDBDRIVERType"]));
			$this->dbr->autoRollback = true;
			$this->dbr->Connect($migrationConfig["migrationDBHOST"], $migrationConfig["migrationDBUSERNAME"], $migrationConfig["migrationDBPASSWORD"], $migrationConfig["migrationDBNAME"]);
			//show($dbr);
			if(!$this->dbr->IsConnected()) {
				$e = "Could not connect to the database, please check your config options.";
				break;
			}

			// get the system lek info
			$q =& new QueryMaster("select", $this->dbr);
			$q->enableManualJoining();
			$q->addTables("config");
			$q->addColumns("config_1 as agree", "config_2 as lek_enabled", "config_3 as lek_pin", "config_4 as lek_type", "config_41 as lek_hash");
			$q->addAndClause("config_type", "=", "lek", "s");
			$lek = $q->getRow();
			
			//show($lek);

			// get the system language ID
			$q =& new QueryMaster("select", $this->dbr);
			$q->enableManualJoining();
			$q->addTables("config");
			$q->addColumns("config_3");
			$q->addAndClause("config_type", "=", "main", "s");
			$systemlanguageISO2 = $q->getOne();
			$language = oneOf("languages", array("languageISO2" => $systemlanguageISO2));
			$languageID = $language["languageID"];
			
			//show($systemlanguageISO2);
			//show($languageID);

			// find out which clients to migrate in this process
			$q =& new QueryMaster("select", $this->dbr);
			$q->enableManualJoining();
			$q->addTables("client_info");
			$q->addColumns("client_info.*");
			$lastExtClientID = $clientMigration["migrationExtSeqID"];
			$q->addAndClause("client_id", ">", $lastExtClientID);
			$t =& $q->getTable($clientProcessStep, 0, "client_id", "client_email");
			$extClients = $t->getAssociated();

			
			$finishedClients = (int) countFor(
				"migrationMappings",
				array(
					"migrationConfigID" => $migrationConfigID,
					"migrationObjID" => $clientMigrationID,
				)
			);
			echo '<script language="javascript">parent.updateNumClients(' . $finishedClients . ');</script>';
			flush();
			
			//show($extClients);
			
			// migrate each client
			foreach($extClients as $extClientID => $extClient) {
			
				/**
				 * actually migrate the data
				 */
				switch($extClient["client_status"]) {
					case "1":
						$clientStatus = getAPIStatusID("client", "pending");
						$clientActive = 0;
						break;
					case "2":
						$clientStatus = getAPIStatusID("client", "none");
						$clientActive = 1;
						break;
					case "3":
						$clientStatus = getAPIStatusID("client", "pending");
						$clientActive = 1;
						break;
					case "4":
						$clientStatus = getAPIStatusID("client", "canceled");
						$clientActive = 1;
						break;
					case "5":
						$clientStatus = getAPIStatusID("client", "fraudulent");
						$clientActive = 1;
						break;
				}
				$country = oneOf("countries", array("countriesISO2" => strtoupper($extClient["client_country"])));
				if(!$country) {
					$country  = oneOf("countries", array("countriesISO2" => "US"));
				}
				$countriesID = $country["countriesID"];
				$taxIDNumber = "";
				
				/*
				1 cc batch
				2 regular check
				3 cc single
				4 echeck
				5 paypal
				6 worldpay
				50 other
				*/
				switch($extClient["billing_method"]) {
					case 1:
					case 3:
						$billingCardType = getAPITypeID("billingAccount", "card");
						break;
					case 4:
						$billingCardType = getAPITypeID("billingAccount", "echeck");
						break;
					case 2:
						$billingCardType = getAPITypeID("billingAccount", "manual");
						break;
					case 3:
					case 5:
					case 6:
						$billingCardType = getAPITypeID("billingAccount", "secondary");
						break;
					case "something else":
						$billingCardType = getAPITypeID("billingAccount", "bank");
						break;
				}
				if($lek) {
                    $billingCardNum = v4encrypt($extClient["client_stamp"].getv4EncryptionKeyFromLek($lek["lek_hash"], $lek["lek_pin"]),$extClient["billing_cc_num"],1,0,$lek["lek_type"]);              
                } else {
					$lekObject = oneOf("migrationObjs", array("migrationConfigID" => $clientMigrationID, "migrationObjName" => "lek"));
                    $billingCardNum = v4encrypt($extClient["client_stamp"].md5($lekObject["migrationObjExtName"]),$extClient["billing_cc_num"],1,0,$lek["lek_type"]);               
                }

				$billingCardNum = preg_replace("/[^0-9]/", "", $billingCardNum);
				//show($billingCardNum);
				//exit;
				$lastFour = substr($billingCardNum, -4);
				
				list($billingCardExpMonth, $billingCardExpYear) = explode("/", $extClient["billing_cc_exp"]);
				
				$intClient = array(
					"clientCompany" => quoteXML($extClient["client_company"]),
					"companyID" => 1,
					"clientStatus" => $clientStatus,
					"applyTax" => $extClient["apply_tax"],
					"taxIDNumber" => $taxIDNumber,
					"themeID" => 1,
					"countriesID" => $countriesID,
					"clientActive" => $clientActive,
					"clientDateCreated" => $extClient["client_stamp"],
					"clientContacts" => array(
						"clientContact" => array(
							$intPrimaryContact = array(
								"contactPrimary" => 1,
								"contactUsername" => quoteXML($extClient["client_username"]),
								"contactPassword" => $extClient["client_password"], // md5, but login script will fix it
								"contactFirstName" => quoteXML($extClient["client_fname"]),
								"contactLastName" => quoteXML($extClient["client_lname"]),
								"contactEmail" => quoteXML($extClient["client_email"]),
								"contactEmailFormat" => (bool) $extClient["send_email_type"],
								"contactCompany" => quoteXML($extClient["client_company"]),
								"contactAddress1" => quoteXML($extClient["client_address"]),
								"contactAddress2" => quoteXML($extClient["client_address_2"]),
								"contactCity" => quoteXML($extClient["client_city"]),
								"contactState" => quoteXML($extClient["client_state"]),
								"contactZip" => quoteXML($extClient["client_zip"]),
								"languageID" => $languageID,
								"countriesID" => $countriesID,
								"contactPhone1" => quoteXML($extClient["client_phone1"]),
								"contactPhone2" => quoteXML($extClient["client_phone2"]),
								"contactFax" => "",
								"contactDateCreated" => $extClient["client_stamp"],
								"contactActive" => 1, // Kris says client being inactive is enough
								"clientBillingAccounts" => array(
									"clientBillingAccount" => array(
										$intBillingAccount = array(
											"billingCardNameOnCard" => quoteXML($extClient["client_fname"] . " " . $extClient["client_lname"]),
											"billingCardType" => $billingCardType,
											"billingCardNum" => quoteXML($billingCardNum),
											"billingCardExpYear" => quoteXML($billingCardExpYear),
											"billingCardExpMonth" => quoteXML($billingCardExpMonth),
											"billingCardIssueNum" => quoteXML($extClient["billing_cc_issue_num"]),
											"billingCardStartDate" => quoteXML($extClient["billing_cc_start_date"]),
											
											"billingBankType" => getAPITypeID("bankAccount", "checking"),
											"billingBankName" => quoteXML($extClient["x_Bank_Name"]),
											"billingBankAbaCode" => quoteXML($extClient["x_Bank_ABA_Code"]),
											"billingBankAccountNum" => quoteXML($extClient["x_Bank_Acct_Num"]),
											"billingBankLicenseNum" => quoteXML($extClient["x_Drivers_License_Num"]),
											"billingBankLicenseState" => quoteXML($extClient["x_Drivers_License_State"]),
											"billingBankDob" => quoteXML($extClient["x_Drivers_License_DOB"]),
											"billingBankState" => quoteXML($extClient["client_state"]),
											
											"billingAccountNumLastFour" => quoteXML($lastFour),
											
											"billingAccountType" => "",
											"secGatewayConfigGroupID" => "",
										),
									),
								),
							),
						),
					),
				);
				//show($intClient);
				if(!$intClientID = insertFor("clients", $intClient)) {
					$e = "Problem inserting client.";
					show($intClient);
					show(toXML($intClient));
					break 2;
				}
				
				//show($intClientID);
				
				$this->migrateClientFinances(
					$intClientID,
					$extClientID,
					$this->dbr,
					$this->migrationConfig["migrationProductID"],
					$this->migrationConfig["migrationPaymentGroupID"]
				);
				
				// find out which domains to migrate in this process
				$q =& new QueryMaster("select", $this->dbr);
				$q->enableManualJoining();
				$q->addTables("domain_names");
				$q->addColumns("domain_names.*");
				$q->addAndClause("client_id", "=", $extClientID);
				$t =& $q->getTable(-1, 0, "domain_name");
				$extDomains = $t->getAssociated();

				// migrate domains
				$intDomains = array();
				foreach($extDomains as $domainName => $extDomain) {
					list($domainSLD, $domainTLD) = explode(".", $domainName, 2);
					$extRegistrarID = $extDomain["registrarID"];
					if($extRegistrarID == 1) {
						$intRegistrarID = "";
					} else {
						$registrarMappings = oneOf(
							"migrationMappings",
							array(
								"migrationConfigID" => $migrationConfigID,
								"migrationObjName" => "registrars",
								"migrationExtID" => $extRegistrarID,
							)
						);
						$intRegistrarID = $registrarMappings["migrationIntID"];
					}
					$q =& new MBQuery(
						"SetDomains",
						"insert",
						$intDomain = array(
							"domainSLD" => $domainSLD,
							"domainTLD" => $domainTLD,
							"registrarID" => $intRegistrarID,
							"domainDateCreated" => $extDomain["domain_created"],
							"domainDateExpires" => $extDomain["domain_expires"],
							"domainRenewType" => getAPITypeID("tldRenew", "disabled"),
						)
					);
					$r =& $q->getResult();
					if($r->getSuccess()) {
						$intDomainID = $r->getLastInsertID();
						$intDomain["domainID"] = $intDomainID;
						$intDomains[$domainName] = $intDomain;
						echo "Migrated domain $domainName ID $extDomainID as $intDomainID <br />";
						flush();
					} else {
						$intDomainID = NULL;
					}
				}
				
				// find out which packages to migrate for this client
				$q =& new QueryMaster("select", $this->dbr);
				$q->enableManualJoining();
				$q->addTables("client_package");
				$q->addColumns("client_package.*");
				$q->addAndClause("client_id", "=", $extClientID);
				$t =& $q->getTable(-1, 0, "cp_id");
				$clientPackages = $t->getAssociated();

				// find out which client package variables (add-on descriptions) to migrate for this client
				$q =& new QueryMaster("select", $this->dbr);
				$q->addColumns("client_package_variables.*", "package_variables.variable_caption");
				$q->addJoin("client_package_variables", "cp_id", "client_package");
				$q->addJoin("package_variables", "var_id", "client_package_variables");
				$q->addAndClause("client_package.client_id", "=", $extClientID);
				$t =& $q->getTable(-1, 0, "cp_id");
				$clientPackageVariablesByCPID = $t->getAssociatedTables();
				//show($q->getQuery());
				//show($t);
				//show("variables");
				//show($clientPackageVariablesByCPID);

				// migrate packages
				foreach($clientPackages as $extPackageID => $extPackage) {
					$packageComments = "";
					if(isset($clientPackageVariablesByCPID[$extPackageID])) {
						$variableT =& $clientPackageVariablesByCPID[$extPackageID];
						$variableT->setKey("variable_caption");
						$variableT->setname("variable_value");
						if($variables = $variableT->getOptions()) {
							$packageComments .= "<dl>\n";
							foreach($variables as $caption => $value) {
								$packageComments .= "<dt>" . htmlspecialchars($caption) . "</dt><dd>" . htmlspecialchars($value) . "</dd>\n";
							}
							$packageComments .= "</dl>\n";
						}
					}
					//show($packageComments);
				
					$extProductID = $extPackage["pack_id"];
					$productMapping = oneOf(
						"migrationMappings",
						array(
							"migrationConfigID" => $migrationConfigID,
							"migrationObjName" => "products",
							"migrationExtID" => $extProductID,
						)
					);
					$intProductID = $productMapping["migrationIntID"];
					$intProduct = oneByID("products", $intProductID);
				
					$extDomain = $extPackage["domain"];
					list($domainSLD, $domainTLD) = explode(".", $extDomain, 2);
					if($domainTLD) {
						$intTLD = oneOf("TLDs", array("tldExtension" => $domainTLD));
						$intTLDID = $intTLD["tldID"];
						
						$intVariant = oneOf("productVariants", array("productID" => $intProductID, "tldID" => $intTLDID));
					} else {
						$intTLD = NULL;
				
						$intVariant = oneOf("productVariants", array("productID" => $intProductID));
					}
					$taxZoneGroupID = $intVariant["taxZoneGroupID"];
					
					$packageActive = 0;
					$packageStatus = getAPIStatusID("package", "none");
					switch($extPackage["cp_status"]) {
						case 1: // suspended
							$packageActive = 1;
							$packageStatus = getAPIStatusID("package", "supended");
							break;
						case 2: // active/on
							$packageActive = 1;
							$packageStatus = getAPIStatusID("package", "none");
							break;
						case 3: // new/still in queue
							$packageActive = 1;
							$packageStatus = getAPIStatusID("package", "pending");
							break;
						case 4: // canceled
							$packageActive = 1;
							$packageStatus = getAPIStatusID("package", "canceled");
							break;
						case 5: // fraud
							$packageActive = 0;
							$packageStatus = getAPIStatusID("package", "fraudulent");
							break;
						case 6: // error
							$packageActive = 1;
							$packageStatus = getAPIStatusID("package", "failed");
							break;
						case 7: // pending rewnewal
							$packageActive = 1;
							$packageStatus = getAPIStatusID("package", "pending_renewal");
							break;
					}
					
					$extCycleMonths = $extPackage["cp_billing_cycle"];
					if(!$intCycle = oneOf(
						"cycles",
						array(
							"cycleNumSeconds" => 0,
							"cycleNumMinutes" => 0,
							"cycleNumHours" => 0,
							"cycleNumDays" => 0,
							"cycleNumMonths" => $extCycleMonths,
							"cycleNumYears" => 0,
						)
					)) {
						$intCycle = oneOf(
							"cycles",
							array(
								"cycleNumSeconds" => 0,
								"cycleNumMinutes" => 0,
								"cycleNumHours" => 0,
								"cycleNumDays" => 0,
								"cycleNumMonths" => 0,
								"cycleNumYears" => $extCycleMonths / 12,
							)
						);
					}
					$intCycleID = $intCycle["cycleID"];
					
					$intPackage = array(
						"clientID" => $intClientID,
						"productID" => $intProductID,
						"taxZoneGroupID" => $taxZoneGroupID,
						"packageName" => quoteXML($intProduct["productName"]),
						"packageQuantity" => $extPackage["cp_qty"],
						"packageComments" => quoteXML($packageComments),
						"packageProratable" => 0,
						"packageDateCreated" => $extPackage["cp_stamp"],
						"packageDateBeginRenewal" => $extPackage["cp_start_stamp"],
						"packageDateLastRenewal" => $extPackage["cp_renew_on"],
						"packageDateNextRenewal" => $extPackage["cp_renew_stamp"],
						"packageActive" => $packageActive,
						"packageStatus" => $packageStatus,
						"packageType" => $intProduct["productType"],
						"packageOriginalPrice" => (float) $extPackage["pack_price"],
						"packagePrice" => (float) $extPackage["pack_price"],
						"packageSetup" => 0,
						"packagePriceLock" => 0,
						"cycleID" => $intCycleID,
						"AffCode" => quoteXML($extPackage["aff_code"]),
						"AffDateLastPaid" => $extPackage["aff_last_paid"],
						"paymentGroupID" => $migrationConfig["migrationPaymentGroupID"],
						"packageCancellationType" => getAPITypeID("cancellation", "admin_suspend"),
					);
					$packageQuery =& new MBQuery("SetPackages", "insert", $intPackage);
					$packageResult =& $packageQuery->getResult();
					//show($packageQuery);
					//show($packageResult);
					//exit;
					if(!$intPackageID = $packageResult->getLastInsertID()) {
						$e = "Problem inserting package.";
						//show($intPackage);
						//show(toXML($intPackage));
						break 3;
					}

					if($extDomain && isset($intDomains[$extDomain])) {
						$intDomain = $intDomains[$extDomain];
						$intDomainID = $intDomain["domainID"];
						
						$extRenewType = $extDomains[$extDomain]["monitor"];
						switch($extRenewType) {
							case 1:
								$intRenewType = getAPITypeID("tldRenew", "registrar");
								break;
							case 2:
								$intRenewType = getAPITypeID("tldRenew", "internal");
								break;
							default:
								$intRenewType = getAPITypeID("tldRenew", "disabled");
								break;
						}
						
						$q =& new MBQuery(
							"SetDomains",
							"update",
							array(
								"domainID" => $intDomainID,
								"domainRenewType" => $intRenewType,
								"packageIDs" => array(
									"packageID" => $intPackageID,
								),
							)
						);
						$r =& $q->getResult();
						if(!$r->getSuccess()) {
							$e = "Problem updating domain renew type and package association.";
							show($q);
							show($r);
							break 3;
						}
						
						echo "Associated domain $intDomainID with package $intPackageID <br />";
						flush();
					}
					
					if(!$intClientContact = oneOf("clientContacts", array("clientID" => $intClientID))) {
						$e = "Problem getting client contacts for its ID for client $intClientID";
						break 3;
					}
					$intClientContactID = $intClientContact["clientContactID"];					
					
					if(!$intBillingAccount = oneOf("billingAccounts", array("clientContactID" => $intClientContactID))) {
						$e = "Problem getting billing account for its ID for client $intClientContactID";
						break 3;
					}
					$intBillingAccountID = $intBillingAccount["billingAccountID"];
					
					$q =& new MBQuery(
						"SetBillingAccountShare",
						"insert",
						array(
							"billingAccountID" => $intBillingAccountID,
							"packageID" => $intPackageID,
							"billingAccountShareGroup" => 0,
							"billingAccountShareValue" => 1,
							"billingAccountFallbackGroup" => 1,
						)
					);
					$r =& $q->getResult();
					if(!$r->getSuccess()) {
						$e = "Problem setting billing account shares for billing account ID $intBillingAccountID for package ID $intPackageID for client ID $intClientID";
						break 3;
					}
					
					echo "Associated billing account $intBillingAccountID with with package $intPackageID <br />";
					flush();

					// find out which package attributes to migrate in this process
					$q =& new QueryMaster("select", $this->dbr);
					$q->enableManualJoining();
					$q->addTables("account_details");
					$q->addColumns("account_details.*");
					$q->addAndClause("cp_id", "=", $extPackageID);
					$t =& $q->getTable(-1, 0, "details_id");
					$packageDetails = $t->getAssociated();
					foreach($packageDetails as $detailsID => $details) {
						$extPanel = $details["server"];
						
						$panelIDMapping = oneOf(
							"migrationObjs",
							array(
								"migrationConfigID" => $migrationConfigID,
								"migrationObjName" => $extPanel,
							)
						);
						$extPanelID = $panelIDMapping["migrationObjID"];
						
						$panelMapping = oneOf(
							"migrationMappings",
							array(
								"migrationConfigID" => $migrationConfigID,
								"migrationObjID" => $panelMigrationID,
								"migrationExtID" => $extPanelID,
							)
						);
						$configGroupID = $panelMapping["migrationIntID"];
						
						$serverGroup = oneOf("serverGroups", array("configGroupID" => $configGroupID));
						$serverGroupID = $serverGroup["serverGroupID"];
						
						$basePackageAttribute = array(
							"packageID" => $intPackageID,
							"serverGroupID" => $serverGroupID,
							"configGroupID" => $configGroupID,
							"packageAttributeDateCreated" => mktime(),
						);
						$c = new Crypt(getPasswordHash(PANELENCRYPTIONKEY), "blowfish", NULL);
						$password = $c->encrypt($details["password"]);
						$attributes = array(
							"ip" => $details["ip"],
							"clientUserName" => $details["username"],
							"domainUserName" => $details["username"],
							"clientPassword" => $password,
							"domainPassword" => $password,
						);
						
						foreach($attributes as $name => $value) {
							$packageAttribute = $basePackageAttribute;
							$packageAttribute["packageAttributeName"] = $name;
							$packageAttribute["packageAttributeValue"] = $value;
							if(!$packageAttributeID = insertFor("packageAttributes", $packageAttribute)) {
								$e = "Problem inserting package attribute.";
								break 4;
							}
							
							echo "Migrated package attribute ID $packageAttributeID for an account detail<br />";
							flush();
						}
					}
					

					/** 
					 * deal with migration state for the package
					 */

					// we are done migrating this package; now associate the external and internal IDs for archival purposes		
					insertFor(
						"migrationMappings",
						array(
							"migrationConfigID" => $migrationConfigID,
							"migrationObjID" => $packageMigrationID,
							"migrationIntID" => $intPackageID,
							"migrationExtID" => $extPackageID,
						)
					);
					// signifies that we are done with this client
					updateFor(
						"migrationObjs",
						array(
							"migrationObjID" => $packageMigrationID,
							"migrationExtSeqID" => $extPackageID,
						)
					);

					echo "Migrated package $extPackageID as $intPackageID <br />";
					flush();
				}
				
				/** 
				 * deal with migration state for the client
				 */

				// we are done migrating this client; now associate the external and internal IDs for archival purposes		
				insertFor(
					"migrationMappings",
					array(
						"migrationConfigID" => $migrationConfigID,
						"migrationObjID" => $clientMigrationID,
						"migrationIntID" => $intClientID,
						"migrationExtID" => $extClientID,
					)
				);
				// signifies that we are done with this client
				updateFor(
					"migrationObjs",
					array(
						"migrationObjID" => $clientMigrationID,
						"migrationExtSeqID" => $extClientID,
					)
				);
				
				echo "Migrated client $extClientID as $intClientID <br />";
				flush();

				echo '<script language="javascript">parent.updateNumClients(' . ++$finishedClients . ');</script>';
				flush();
			}

			if($extClients) {
				echo '<script language="javascript">parent.runMigrationLoad();</script>';
				flush();
			}
			
			//redirect("migrate.php", getActionID("MigrateManager"), array("migrationConfigID" => $migrationConfig["migrationConfigID"]));
		
		} while(0);
		if($e) {
			$this->addError(TRANS_ACTIONERROR, $e);
			$this->addErrorTemplates();
		}
		echo '<script language="javascript">parent.enableStartFormElements();</script>';
		flush();
	}

	function migrateClientFinances($clientID, $v4clientID, &$dbr, $productID=0, $paymentGroupID=0, $currencyID=0){

		$dbr = ($dbr!=0)?$dbr:$this->dbr; // get the adodb connection
		$paymentGroupID = ((int)$paymentGroupID)?$paymentGroupID:$this->migrationConfig["migrationPaymentGroupID"]; // get the payment group id
		$productID = ((int)$productID)?$productID:$this->migrationConfig["migrationProductID"]; // get the product id

		if (!(int)$productID){
			updateFor(
				"migrationConfigs",
				array(
					"migrationConfigID" => $this->migrationConfig["migrationConfigID"],
					"migrationProductID" => $this->migrationConfig["migrationProductID"] = insertFor(
						"products",
						array(
							"productName" => TRANS_PRIOR_BALANCE_PRODUCT_FOR . " " . $this->migrationConfig["migrationConfigID"],
							"productActive" => 0,
							"productStopNumCycles" => 1,
							"productCancellationType" => getAPITypeID("cancellation", "admin_only"),
						)
					),
				)
			);
			$productID = $this->migrationConfig["migrationProductID"];
		}

		if (!$currencyID){
			if ($this->currencyID){
				$currencyID = $this->currencyID;
			} else {
				$this->paymentGroupInfo = correctArray(grabFirstResultFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetPaymentGroups",
						"params" => array(
							"paymentGroupID" => $paymentGroupID,
							"suppressGatewayInfo" => 1,
						),
					),
				)));
				$this->currencyID = $currencyID = $this->paymentGroupInfo["paymentGroupCurrencyID"];
				dbg("GOT CURRENCY ID OF: ".$currencyID);
			}
		}

		// first get all invoices
		$h =& new QueryMaster("client_invoice.*", $dbr);
		$h->addAndClause("client_id", "=", $v4clientID, "i");
		$allInvoices = $h->getResults();

		// second get all the credits
		$h =& new QueryMaster("sum(credit_amount)", $dbr);
		$h->addTables("client_credits");
		$h->addAndClause("client_id", "=", $v4clientID, "i");
		$totalCredit = $h->getOne();

		$totalReceivable = 0;
		$packageComments = TRANS_PRIOR_INVOICES;
		foreach ($allInvoices as $invoice){

			if ($invoice["invoice_amount"]>$invoice["invoice_amount_paid"]){
				$totalReceivable += $invoice["invoice_amount"]-$invoice["invoice_amount_paid"];
				$packageComments .= "\n<br />".$invoice["invoice_snapshot"];
			}

			if ($invoice["invoice_amount_paid"]>0){

				$sale =& new Sale();
				$sale->setClientID($clientID);
				$sale->setInvoiceID(0);
				$sale->setDescription(TRANS_HISTORICAL_INVOICE_GENERATED);
				$sale->setInvoiceAmount(doubleval($invoice["invoice_amount_paid"]));
				$sale->setInvoiceDiscountAmount(0);
				$sale->setInvoiceCouponAmount(0);
				$sale->setInvoiceTaxAmount(0);
				$sale->setCurrencyID($currencyID);
				$sale->updateTimestamp = $invoice["invoice_date_entered"];
				$sale->execute();

				$receipt =& new Payment();
				$receipt->setClientID($clientID);
				$receipt->setInvoiceID(0);
				$receipt->setTransactionID(0);
				$receipt->setDescription(TRANS_HISTORICAL_PAYMENT);
				$receipt->setPaymentAmount(doubleval($invoice["invoice_amount_paid"]));
				$receipt->setCurrencyID($currencyID);
				$receipt->updateTimestamp = ($invoice["invoice_date_paid"]>0)?$invoice["invoice_date_paid"]:$invoice["invoice_date_entered"];
				$receipt->execute();

			}

		}

		if ($totalCredit>$totalReceivable){
			$totalCredit -= $totalReceivable;
			$totalReceivable = 0;
			$creditResult = dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "SetCreditAccounting",
					"params" => array(
						"clientID" => $clientID,
						"ledgerAccountName" => "customer_expense",
						"amount" => doubleval($totalCredit),
						"currencyID" => $currencyID,
						"description" => TRANS_OPENING_CREDIT_BALANCE,
					),
				),
			)), 1);
			dbg("added client credit");
			dbg($creditResult);

			return 0;

		} else {

			$totalReceivable -= $totalCredit;

			$now = time();

			if($totalReceivable) {
				$packageCommand = array(
					"mbapi" => array(
						"command" => "SetPackages",
						"subCommand" => "insert",
						"params" => array(
							"clientID" => $clientID,
							"productID" => $productID,
							"packageComments" => htmlspecialchars($packageComments),
							"packageName" => TRANS_PRIOR_BALANCE,
							"packageQuantity" => 1,
							"packageProratable" => 0,
							"packageDateCreated" => $now,
							"packageDateBeginRenewal" => $now,
							"packageDateLastRenewal" => 0,
							"packageDateNextRenewal" => $now,
							"packageDateStopRenewal" => $now+1,
							"packageActive" => 1,
							"packageStatus" => 0,
							"packageType" => 0,
							"packageOriginalPrice" => $totalReceivable,
							"packagePrice" => $totalReceivable,
							"packageSetup" => 0,
							"packagePriceLock" => 1,
							"cycleID" => 1,
							"paymentGroupID" => $paymentGroupID,
						),
					),
				);

				$results = correctArray(dispatchMBAPI(toXML($packageCommand), 1));
				dbg("opening balance package created, results:");
				dbg($results);
				return $results["mbapi"]["header"]["lastInsertID"];
			} else {
				return 0;
			}
		}

	} 


}
