<?php
// $Id: CheckServerLoad.php,v 1.3 2006/03/22 20:41:10 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on domains that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Andy Christ
 */
class CheckServerLoad extends MB_Action {
	/**
	 * The constructor for a CheckServerLoad action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function CheckServerLoad() {
		parent::MB_Action();
		$this->stringRep = "CheckServerLoad";
		$this->params = array
		("configGroupID");
	}

	/**
	 * The main method of this class that executes the getServerLoad action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$panel = strval($_REQUEST["panel"]);
		$configGroupID = int($_REQUEST["configGroupID"]);

		$xml = "
		<mbapi>
		  <command>ProcessPanel</command>
		  <subCommand>getServerLoad</subCommand>
		  <showXMLHeader>0</showXMLHeader>
		  <params>
			  <panel>
				<$panel>
				  <params>
					<configGroupID>$configGroupID</configGroupID>
				  </params>
				</$panel>
			  </panel>
		  </params>
		</mbapi>";

		$serverLoadData = dispatchMBAPI($xml,1);
		$serverLoadResults =& $serverLoadData["mbapi"][0]["results"][0];
#echo "<pre>".print_r($registrarResults,1);
		if($this->addMBAPIErrors($serverLoadData) === 0) {

			$smartyVars = array();
			$smartyVars["originalDomain"] = $registrarResults["OriginalDomain"][0];
#echo "<pre>".print_r(collapseArrayElements($smartyVars),1);
			$this->addTemplate("widgets/getServerLoad", collapseArrayElements($smartyVars));

		} // if($this->addMBAPIErrors($data) === 0) {

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // getServerLoad
?>