<?php
// $Id: AddRegistrarResponse.php,v 1.4 2006/06/19 16:17:53 achrist Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on a Panel so that that it can be
 * configured and saved to the database.
 *
 * @author Andy Christ
 */
class AddRegistrarResponse extends MB_Action {
	/**
	 * The constructor for a ShowRegistrars action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function AddRegistrarResponse() {
		parent::MB_Action();
		$this->stringRep = "ShowRegistrars";
		$this->params = array("configGroupID");
	}

	/**
	 * The main method of this class that executes the ShowRegistrars action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$configGroupName = secureInput($_REQUEST["registrarName"]);

		if (!( $configGroupName )) {
			$this->addError(TRANS_ACTIONERROR, "No Registrar given.");
		} else {

			$registrars = getAvailableModules("registrar");
			sort($registrars);

			$registrars = array_flip($registrars);
			if (is_array($registrars) && $registrars[$configGroupName.".php"]) {
				//Do some fliping so that we are not using the user input directly
				$arrayID = $registrars[$configGroupName.".php"];
				$registrars = array_flip($registrars);
				$fileName = $registrars[$arrayID];
	
				//Grab the parent config id
				
				$p = $this->getMBAPIQuery("GetConfigGroups", "", array("configGroupName" => "registrar"));
				$parent = grabSimpleMBAPIResults(dispatchMBAPI($p, 1));
				$parentID = $parent[0]["configGroupID"];

				$addNew =& new MBQuery("SetConfigGroups", "insert", array(
										"parentConfigGroupID" => $parentID,
										"addRegistrar" => basename($fileName, ".php")));
				
				$results = grabSimpleMBAPIResults($addNew->getResult());

				require_once mb_path("/lib-mbapi/include/modules/registrar/".secureInput($fileName));
				$moduleInfo = call_user_func( array(basename($fileName, ".php"), "getModuleInfo") );
				$this->smartyVars["registrars"][ basename($fileName, ".php") ] = $moduleInfo;
	
				$p = $this->getMBAPIQuery("GetConfigGroups", "", array("configGroupName" => $moduleInfo["displayName"]));
				$newRegistrar = grabSimpleMBAPIResults(dispatchMBAPI($p, 1));
				$configGroupID = $newRegistrar[0]["configGroupID"];

			}
			// now our job is done, redirect!
			redirect("modules.php", "EditRegistrarConfig", array("configGroupID" => $configGroupID));
		}
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>