<?php
// $Id: EditRegistrarConfig.php,v 1.8 2006/03/22 20:41:17 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/crypt/crypt.php");

/**
 * This Action object displays the modules menu.
 *
 * @author Andy Christ
 */
class EditRegistrarConfig extends MB_Action {
	/**
	 * The constructor for a ShowModulesMenu action object. This method calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditRegistrarConfig() {
		parent::MB_Action();
		$this->stringRep = "EditRegistrarConfig";
	}

	/**
	 * Pull the config items for this affiliate and pass them to the template.  The template
     * can return its data to process config file.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$configGroupID = (int) $_REQUEST["configGroupID"];

		if($_REQUEST["submit"]) {
			//The possible items depends on the Registrar
			$configItems = $_REQUEST["configParams"];
			foreach($configItems as $key => $value) {
				if($key == "modulePassword") {
					//Encrypt this password:
					$c =& new Crypt(getPasswordHash(PANELENCRYPTIONKEY), "blowfish", NULL);
					$_REQUEST["configParams"][$key]["configParamValue"] = $c->encrypt($value["configParamValue"]);
				}
				$params[] = $key;
			}
			$configParms = "  <configParams>\n";
			foreach($params as $v) {
				$configParamID =  $_REQUEST["configParams"][$v]["configParamID"];
				$configParms .= "    <configParam>\n";
				$configParms .= "       <configParamID>".$configParamID."</configParamID>\n";
				$configParms .= "       <configParamName>$v</configParamName>\n";
				$configParms .= "       <configParamValue>".$_REQUEST["configParams"][$v]["configParamValue"]."</configParamValue>\n";
				$configParms .= "    </configParam>\n";

			}
			$configParms .= "  </configParams>\n";
			$xml = "<mbapi>
						<command>SetConfigs</command>
						<subCommand>update</subCommand>
						<params>
							<configGroupID>$configGroupID</configGroupID>
							$configParms
						</params>
					</mbapi>";

			$CONF["debug"]->add("MBAPI Query (EditRegistrarConfig)",htmlentities($xml), __FILE__, __LINE__);
			$data = dispatchMBAPI($xml, 1);
			$CONF["debug"]->add("MBAPI Results (EditRegistrarConfig)", $data, __FILE__, __LINE__);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$configEditResult = TRANS_UPDATE_SUCCESSFUL;
				$displaySaved = 1;
			}
		}

		if(!$configGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No ID given for Registrar.");
		} else {
			loadConfigs("server");
		}
		$xml = $this->getMBAPIQuery("GetConfigs", "", array("configGroupID" => $configGroupID,"getFormAttributes" => 1));
		$data = dispatchMBAPI($xml, 1);
		$CONF["debug"]->add("MBAPI Results (EditRegistrarConfig)", $data, __FILE__, __LINE__);

		$configParamDataResults =& $data["mbapi"][0]["results"][0]["configs"][0]["config"];
		$configParamDataResults = collapseArrayElements($configParamDataResults);

		$parentConfigGroupID = $configParamDataResults[0]["parentConfigGroupID"];

		$xml = $this->getMBAPIQuery("GetConfigs", "", array("configGroupID" => $configGroupID,"getFormAttributes" => 1));
		$data = dispatchMBAPI($xml, 1);
		$CONF["debug"]->add("MBAPI Results (EditRegistrarConfig)", $data, __FILE__, __LINE__);

		$configParamValueResults =& $data["mbapi"][0]["results"][0];
		// fix child config param values structure when only 1 child config param value exists
		$numParams = $data["mbapi"][0]["header"][0]["numResults"][0];
		// loop through all params to test for param values
		for($i=0;$i<$numParams;$i++) {
			$p =& $configParamValueResults["configs"][0]["config"][$i]["paramValues"][0]["paramValue"];
			// loop through param values if they exist
			$numParamValues = count($p);
			for($j=0;$j<$numParamValues;$j++) {
				// define the translation key or display it raw if not defined
				$translatedName = (defined($p[$j]["configParamValueTransKey"][0])) ?
					constant($p[$j]["configParamValueTransKey"][0]) :
					$p[$j]["configParamValueTransKey"][0];
				// shorten the ID
				$configParamID = $configParamValueResults["configs"][0]["config"][$i]["configParamID"][0];
				// create a new smooshed array for html_options in smarty
				$configParamValueName = $p[$j]["configParamValueName"][0];
				$configParamValues[$configParamID][$configParamValueName] = $translatedName;
			}
		}

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			foreach($configParamDataResults as $key => $value) {
				if($value["configParamName"] == "modulePassword") {
					//Decrypt this password:
					$d =& new Crypt(getPasswordHash(PANELENCRYPTIONKEY), "blowfish", NULL);
					$rawPassword = $d->decrypt($value["configParamValue"]);
					$configParamDataResults[$key]["configParamValue"] = $rawPassword;
				}
			}
			$smartyVars = array();

			$smartyVars["configParams"] = $configParamDataResults;
			$smartyVars["displaySaved"] = $displaySaved;
			$smartyVars["configGroupID"] = $configGroupID;
			$smartyVars["configParamValues"] = $configParamValues;
			$smartyVars["parentConfigGroupID"] = $parentConfigGroupID;
			$this->addTemplate("modules/EditRegistrarConfig", $smartyVars, 1);

		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowModulesMenu
?>