<?php
// $Id: EditSSLFactoryConfig.php,v 1.4 2006/05/04 17:20:46 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object displays the SSLFactory module configs.
 *
 * @author Brian Smith
 */
class EditSSLFactoryConfig extends MB_Action {
	/**
	 * The constructor for a EditSSLFactoryConfig action object. This method calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditSSLFactoryConfig() {
		parent::MB_Action();
		$this->stringRep = "EditSSLFactoryConfig";
	}

	/**
	 * Pull the config items for this module.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

        	$configGroupID = (int) $_REQUEST["configGroupID"];
		
		if(!$configGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No ID given for SSLFactory.");
		} else {
			loadConfigs("other");
        	}
		
		$this->smartyVars["configGroupID"] = $configGroupID;
		$this->smartyVars["configParams"] = $CONF["other"]["ssl"]["sslfactory"];
		$this->addTemplate("modules/EditSSLFactoryConfig");

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditSSLFactoryConfig
?>