<?php
// $Id: AddNewsGroupResponse.php,v 1.8 2006/06/23 23:05:39 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action receives data posted by the AddNewsGroup action, and handles that data. Here we just take 
 * that data and insert it into the database, thus creating a new news group that will show up in the list 
 * of news groups when adding a news article.
 *
 * @author  Vic Fryzel
 */
class AddNewsGroupResponse extends MB_Action {
	/**
	 * The constructor for an AddNewsGroupResponse action object. This calls the parent constructor, 
	 * sets the string representation of this object, and sets $this->params.
	 */
	function AddNewsGroupResponse() {
		parent::MB_Action();
		$this->stringRep = "AddNewsGroupResponse";
		$this->params = array(
			"newsGroupName",
			"newsGroupDescription",
			"newsGroupActive");
	}

	/**
	 * The main method of this class that executes the AddNewsGroupResponse action, and returns success 
	 * or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->setReferralActionID( getActionID("AddNewsGroup") );
		$this->setReferralActionFile( "news.php" );
		
		$success = $this->validateMultiInputs(array(
					"newsGroupName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"newsGroupDescription" => INPUT_RESTRICTION_STRING,
					"newsGroupActive" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED));

		if ($success) {
			$query = $this->getMBAPIQuery("SetNewsGroups", "insert");
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(!redirect("news.php", "ShowNews")) {
					$this->addError(TRANS_ACTIONERROR, "Failed to redirect to news group listing.");
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddNewsGroupResponse
?>