<?php
// $Id: EditNews.php,v 1.14 2006/07/10 21:40:23 mgarrett Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This action displays a form to the user, prepopulated with news article information. The purpose 
 * of this action is to collect information for EditNewsResponse, to ultimately edit a news article. 
 * This action takes a newsID parameter from $_REQUEST as to know which news article to edit. If the 
 * given news article ID is not found, an error is thrown. If no news groups are found, an error is thrown. 
 * If no admins are found, and error is thrown.
 *
 * @author  Vic Fryzel
 */
class EditNews extends MB_Action {
	/**
	 * The constructor for a EditNews action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditNews() {
		parent::MB_Action();
		$this->stringRep = "EditNews";
		$this->params = array("newsID");
	}

	/**
	 * The main method of this class that executes the EditNews action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$newsID = ((int) $_REQUEST["newsID"]);
		if(!$newsID) {
			$this->addError(TRANS_ACTIONERROR, "No news article ID given.");
		} else {
			// Fetch data for the news article we're editing
			$query = $this->getMBAPIQuery("GetNews", "", array(), 1, 1, 1, 1);
			$articleData = dispatchMBAPI($query, 1);

			$newsGroupData = correctArray($this->getMBAPIData("GetNewsGroups", "newsGroups", "newsGroup"));
			
			if($newsGroupData === false) {
				$this->addError(TRANS_ACTIONERROR, "No news groups found. Please add a news group first.");
			} elseif ($adminData === false) {
				$this->addError(TRANS_ACTIONERROR, "No admin data found. Please add an admin first.");
			}
			
			if($this->addMBAPIErrors($articleData) === 0 && !$this->getNumErrors()) {
				$articleData = grabSimpleMBAPIResults($articleData);
				$this->smartyVars["newsArticle"] = $articleData[0];
				
				if (is_array($newsGroupData))
				foreach( $newsGroupData as $group) {
					$this->smartyVars["newsGroups"][ $group["newsGroupID"] ] = $group["newsGroupName"];
				}

				$this->mergeFormState($articleData[0]);
				
				$this->addTemplate("news/EditNews");
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditNews
?>