<?php
// $Id: EditNewsGroup.php,v 1.12 2006/06/23 23:05:39 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This action displays a form to edit the news group associated with the given news group ID. If the 
 * given news group ID is not found, an error is displayed. Once the information for the news group 
 * has been collected, the displayed form should post to the action EditNewsGroupResponse.
 *
 * @author  Vic Fryzel
 */
class EditNewsGroup extends MB_Action {
	/**
	 * The constructor for a EditNewsGroup action object. This calls the parent constructor, 
	 * sets the string representation of this object, and sets $this->params to allow an incoming 
	 * newsGroupID.
	 */
	function EditNewsGroup() {
		parent::MB_Action();
		$this->stringRep = "EditNewsGroup";
		$this->params = array("newsGroupID");
	}

	/**
	 * The main method of this class that executes the EditNewsGroup action, and returns success or 
	 * failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$newsGroupID = ((int) $_REQUEST["newsGroupID"]);
		if(!$newsGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No news group ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetNewsGroups");
			$data = dispatchMBAPI($query, 1);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$results = grabSimpleMBAPIResults( $data );
				
				if(!((int) $data["mbapi"][0]["header"][0]["numResults"][0])) {
					$this->addError(TRANS_ACTIONERROR, "News group not found.");
				} else {
					$this->mergeFormState($results[0]);
					$this->smartyVars["editMode"] = 1;
					$this->addTemplate("news/AddNewsGroup");
					
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditNewsGroup
?>