<?php
// $Id: EditNewsGroupResponse.php,v 1.11 2006/06/23 23:05:39 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action takes the information provided by the EditNewsGroup action, and applies the changes to the 
 * news group associated with the given news group ID. If the given news group ID is not found, an error 
 * is thrown. Once the changes have been applied, this action redirects to the ShowNewsGroups action.
 *
 * @author  Vic Fryzel
 */
class EditNewsGroupResponse extends MB_Action {
	/**
	 * The constructor for an EditNewsGroupResponse action object. This calls the parent constructor, 
	 * sets the string representation of this object, and sets $this->params.
	 */
	function EditNewsGroupResponse() {
		parent::MB_Action();
		$this->stringRep = "EditNewsGroupResponse";
		$this->params = array(
			"newsGroupID",
			"newsGroupName",
			"newsGroupDescription",
			"newsGroupActive");
	}

	/**
	 * The main method of this class that executes the EditNewsGroupResponse action, and returns success 
	 * or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$newsGroupID = ((int) $_REQUEST["newsGroupID"]);
		if(!$newsGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No news group ID given.");
		} else {
			$query = $this->getMBAPIQuery("SetNewsGroups", "update");
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				
				redirect("news.php", "ShowNews");
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditNewsGroupResponse
?>