<?php
// $Id: ShowNews.php,v 1.9 2006/06/23 23:05:39 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action displays a list of news articles to the user. This list can be filtered based upon 
 * the given parameters (passed via $_REQUEST). Those parameters are newsGroupID, adminID, newsActive, 
 * and priorityID. This action dispatches to the ShowNews template, and links to the actions AddNews,
 * EditNews, RemoveNews, and ShowNewsDetails.
 *
 * @author  Vic Fryzel
 */
class ShowNews extends MB_Action {
	/**
	 * The constructor for a ShowNews action object. This calls the parent constructor, 
	 * sets the string representation of this object, and sets up $this->params and $this->sortColumns 
	 * for use in $this->getMBAPIQuery().
	 */
	function ShowNews() {
		parent::MB_Action();
		$this->stringRep = "ShowNews";
		
		$this->params = array(
			"newsGroupID",
			"newsGroupName",
			"newsGroupDescription",
			"newsGroupActive");
		$this->sortColumns = $this->params;
	}

	/**
	 * The main method of this class that executes the ShowNews action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$query = $this->getMBAPIQuery("GetNewsGroups", "", array(), 1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);
		
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			$newsGroups = grabSimpleMBAPIResults($data);

			if (is_array($newsGroups))
			foreach( $newsGroups as $group ) {
				$query =& new MBQuery("GetNews", "", array("newsGroupID" => $group["newsGroupID"]));
				$result = $query->getResult();
				$result = grabSimpleMBAPIResults($result->getStructure());
				unset($query); // destroy query

				$this->smartyVars["news"][] = $group;
				$this->smartyVars["news"][ count($this->smartyVars["news"])-1 ]["articles"] = $result;
			}
			
			$this->smartyVars["paginationLinks"] = $data["mbapi"][0]["results"][0]["paginationLinks"][0];
			$this->addTemplate("news/ShowNews");
			
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowNews
?>