<?php
// $Id: AddOrderFormResponse.php,v 1.12 2006/03/22 20:41:10 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the AddOrderForm action, applies that information to
 * records in the database, and redirects to the ShowOrderFormDetails action for the given order form.
 *
 * @author Mark Garrett
 */ 
 
class AddOrderFormResponse extends MB_Action {
	/**
	 * The constructor for an AddOrderFormResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function AddOrderFormResponse() {
		parent::MB_Action();
		$this->stringRep = "AddOrderFormResponse";
	}

	/**
	 * The main method of this class that executes the AddOrderFormResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$query = $this->getMBAPIQuery("GetPaymentGroups");
		$data = dispatchMBAPI($query, 1);
		$results =& $data["mbapi"][0]["results"][0];
		
$newOrderFormXML = "
<mbapi>
	<command>SetOrderForms</command>
	<subCommand>insert</subCommand>
	<params>
		<orderFormName>".TRANS_ORDERFORM."</orderFormName>
		<companyID>1</companyID>
		<paymentGroupID>".$results["paymentGroups"][0]["paymentGroup"][0]["paymentGroupID"][0]."</paymentGroupID>
		<languageID>".$CONF["user"]["adminData"]["languageID"][0]."</languageID>
		<countriesID>".$CONF["user"]["adminData"]["countriesID"][0]."</countriesID>
		<orderFormParams>
			<orderFormParam>
				<orderFormParamName>dom_options</orderFormParamName>
				<orderFormParamValue>a:4:{i:0;s:9:\"dom_whois\";i:1;s:7:\"dom_reg\";i:2;s:12:\"dom_transfer\";i:3;s:12:\"dom_existing\";}</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDER_DOMAIN_OPTIONS</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDER_DOMAIN_OPTIONS_DESC</orderFormParamDescription>
				<orderFormParamInputType>c</orderFormParamInputType>
				<orderFormParamOrder>2</orderFormParamOrder>
				<orderFormValues>
					<orderFormValue>
						<orderFormValueName>dom_whois</orderFormValueName>
						<orderFormValueTransKey>TRANS_ORDER_WHOIS_LOOKUP</orderFormValueTransKey>
						<orderFormValueOrder>0</orderFormValueOrder>
					</orderFormValue>
					<orderFormValue>
						<orderFormValueName>dom_reg</orderFormValueName>
						<orderFormValueTransKey>TRANS_ORDER_DOMAIN_REGISTRATION</orderFormValueTransKey>
						<orderFormValueOrder>1</orderFormValueOrder>
					</orderFormValue>
					<orderFormValue>
						<orderFormValueName>dom_transfer</orderFormValueName>
						<orderFormValueTransKey>TRANS_ORDER_TRANSFER_DOMAIN</orderFormValueTransKey>
						<orderFormValueOrder>2</orderFormValueOrder>
					</orderFormValue>
					<orderFormValue>
						<orderFormValueName>dom_existing</orderFormValueName>
						<orderFormValueTransKey>TRANS_ORDER_EXISTING_DOMAIN</orderFormValueTransKey>
						<orderFormValueOrder>3</orderFormValueOrder>
					</orderFormValue>
					<orderFormValue>
						<orderFormValueName>dom_skip</orderFormValueName>
						<orderFormValueTransKey>TRANS_ORDER_SKIP_DOMAIN</orderFormValueTransKey>
						<orderFormValueOrder>4</orderFormValueOrder>
					</orderFormValue>
				</orderFormValues> 
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>email_banning</orderFormParamName>
				<orderFormParamValue>1</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDER_EMAIL_BANNING</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDER_EMAIL_BANNING_DESC</orderFormParamDescription>
				<orderFormParamInputType>r</orderFormParamInputType>
				<orderFormParamOrder>3</orderFormParamOrder>
				<orderFormValues>
					<orderFormValue>
						<orderFormValueName>1</orderFormValueName>
						<orderFormValueTransKey>TRANS_YES</orderFormValueTransKey>
						<orderFormValueOrder>0</orderFormValueOrder>
					</orderFormValue>
					<orderFormValue>
						<orderFormValueName>0</orderFormValueName>
						<orderFormValueTransKey>TRANS_NO</orderFormValueTransKey>
						<orderFormValueOrder>1</orderFormValueOrder>
					</orderFormValue>
				</orderFormValues> 
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>continue_shopping_url</orderFormParamName>
				<orderFormParamValue>".$CONF["secureURLProtocol"]."://".$CONF["secureURL"]."</orderFormParamValue>
				<orderFormParamTransKey>TRANS_CONTINUE_SHOPPING_URL</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_CONTINUE_SHOPPING_URL_DESC</orderFormParamDescription>
				<orderFormParamInputType>t</orderFormParamInputType>
				<orderFormParamOrder>4</orderFormParamOrder>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>email_banning_text</orderFormParamName>
				<orderFormParamValue>TRANS_ORDER_EMAIL_BANNING_MESSAGE</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDER_EMAIL_BANNING_TEXT</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDER_EMAIL_BANNING_TEXT_DESC</orderFormParamDescription>
				<orderFormParamInputType>a</orderFormParamInputType>
				<orderFormParamOrder>4</orderFormParamOrder>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>ip_banning_text</orderFormParamName>
				<orderFormParamValue>TRANS_ORDER_IP_BANNING_MESSAGE</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDER_IP_BANNING_TEXT</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDER_IP_BANNING_TEXT_DESC</orderFormParamDescription>
				<orderFormParamInputType>a</orderFormParamInputType>
				<orderFormParamOrder>4</orderFormParamOrder>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>payment_type_check</orderFormParamName>
				<orderFormParamValue>1</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDER_ENABLE_CHECK</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDER_ENABLE_CHECK_DESC</orderFormParamDescription>
				<orderFormParamInputType>r</orderFormParamInputType>
				<orderFormParamOrder>5</orderFormParamOrder>
				<orderFormValues>
					<orderFormValue>
						<orderFormValueName>1</orderFormValueName>
						<orderFormValueTransKey>TRANS_YES</orderFormValueTransKey>
						<orderFormValueOrder>0</orderFormValueOrder>
					</orderFormValue>
					<orderFormValue>
						<orderFormValueName>0</orderFormValueName>
						<orderFormValueTransKey>TRANS_NO</orderFormValueTransKey>
						<orderFormValueOrder>1</orderFormValueOrder>
					</orderFormValue>
				</orderFormValues> 
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>payment_type_invoice</orderFormParamName>
				<orderFormParamValue>1</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDER_ENABLE_INVOICE</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDER_ENABLE_INVOICE_DESC</orderFormParamDescription>
				<orderFormParamInputType>r</orderFormParamInputType>
				<orderFormParamOrder>6</orderFormParamOrder>
				<orderFormValues>
					<orderFormValue>
						<orderFormValueName>1</orderFormValueName>
						<orderFormValueTransKey>TRANS_YES</orderFormValueTransKey>
						<orderFormValueOrder>0</orderFormValueOrder>
					</orderFormValue>
					<orderFormValue>
						<orderFormValueName>0</orderFormValueName>
						<orderFormValueTransKey>TRANS_NO</orderFormValueTransKey>
						<orderFormValueOrder>1</orderFormValueOrder>
					</orderFormValue>
				</orderFormValues> 
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>payment_type_draft</orderFormParamName>
				<orderFormParamValue>1</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDER_ENABLE_BANK_DRAFT</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDER_ENABLE_BANK_DRAFT_DESC</orderFormParamDescription>
				<orderFormParamInputType>r</orderFormParamInputType>
				<orderFormParamOrder>7</orderFormParamOrder>
				<orderFormValues>
					<orderFormValue>
						<orderFormValueName>1</orderFormValueName>
						<orderFormValueTransKey>TRANS_YES</orderFormValueTransKey>
						<orderFormValueOrder>0</orderFormValueOrder>
					</orderFormValue>
					<orderFormValue>
						<orderFormValueName>0</orderFormValueName>
						<orderFormValueTransKey>TRANS_NO</orderFormValueTransKey>
						<orderFormValueOrder>1</orderFormValueOrder>
					</orderFormValue>
				</orderFormValues> 
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>username_min_length</orderFormParamName>
				<orderFormParamValue>6</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDERFORM_MIN_USERNAME</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDERFORM_MIN_USERNAME_DESC</orderFormParamDescription>
				<orderFormParamInputType>t</orderFormParamInputType>
				<orderFormParamOrder>8</orderFormParamOrder>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>username_max_length</orderFormParamName>
				<orderFormParamValue>15</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDERFORM_MAX_USERNAME</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDERFORM_MAX_USERNAME_DESC</orderFormParamDescription>
				<orderFormParamInputType>t</orderFormParamInputType>
				<orderFormParamOrder>9</orderFormParamOrder>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>password_min_length</orderFormParamName>
				<orderFormParamValue>6</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDERFORM_MIN_PASSWORD</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDERFORM_MIN_PASSWORD_DESC</orderFormParamDescription>
				<orderFormParamInputType>t</orderFormParamInputType>
				<orderFormParamOrder>10</orderFormParamOrder>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>password_max_length</orderFormParamName>
				<orderFormParamValue>15</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDERFORM_MAX_PASSWORD</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDERFORM_MAX_PASSWORD_DESC</orderFormParamDescription>
				<orderFormParamInputType>t</orderFormParamInputType>
				<orderFormParamOrder>11</orderFormParamOrder>
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>terms_url</orderFormParamName>
				<orderFormParamValue>http://".$_SERVER['SERVER_NAME']."</orderFormParamValue>
				<orderFormParamTransKey>TRANS_ORDERFORM_TERMS_URL</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_ORDERFORM_TERMS_URL_DESC</orderFormParamDescription>
				<orderFormParamInputType>t</orderFormParamInputType>
				<orderFormParamOrder>12</orderFormParamOrder>
			</orderFormParam>
		</orderFormParams>
	</params>
</mbapi>";
		
		$data = $query = $results = NULL;
		$data = dispatchMBAPI($newOrderFormXML, 1);
		$orderFormID = $data["mbapi"][0]["header"][0]["lastInsertID"][0];

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
				redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
			} else {
				redirect("orderforms.php", getActionID("EditOrderForm"), array("orderFormID" => $orderFormID));
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddOrderFormResponse

/*
			<orderFormParam>
				<orderFormParamName>saved_order_lock</orderFormParamName>
				<orderFormParamValue>1</orderFormParamValue>
				<orderFormParamTransKey>TRANS_SO_PRICE</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_SO_PRICE_DESC</orderFormParamDescription>
				<orderFormParamInputType>r</orderFormParamInputType>
				<orderFormParamOrder>0</orderFormParamOrder>
				<orderFormValues>
					<orderFormValue>
						<orderFormValueName>1</orderFormValueName>
						<orderFormValueTransKey>TRANS_YES</orderFormValueTransKey>
						<orderFormValueOrder>0</orderFormValueOrder>
					</orderFormValue>
					<orderFormValue>
						<orderFormValueName>0</orderFormValueName>
						<orderFormValueTransKey>TRANS_NO</orderFormValueTransKey>
						<orderFormValueOrder>1</orderFormValueOrder>
					</orderFormValue>
				</orderFormValues> 
			</orderFormParam>
			<orderFormParam>
				<orderFormParamName>saved_order_duration</orderFormParamName>
				<orderFormParamValue>90</orderFormParamValue>
				<orderFormParamTransKey>TRANS_SO_DURATION</orderFormParamTransKey>
				<orderFormParamDescription>TRANS_SO_DURATION_DESC</orderFormParamDescription>
				<orderFormParamInputType>t</orderFormParamInputType>
				<orderFormParamOrder>1</orderFormParamOrder>
			</orderFormParam>
*/
?>