<?php
// $Id: EditOrderForm.php,v 1.19 2006/06/13 00:53:17 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on a orderform so that that the orderform may be modified in the
 * database.
 *
 * @author  Mark Garrett
 */
class EditOrderForm extends MB_Action {
	/**
	 * The constructor for a EditPaymentgroup action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditPaymentgroup() {
		parent::MB_Action();
		$this->stringRep = "EditOrderForm";
		$this->params = array("orderFormID");
		
	}

	/**
	 * The main method of this class that executes the EditPaymentgroup action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$orderformID = ((int) $_REQUEST["orderFormID"]);
		if(!$orderformID) {
			$this->addError(TRANS_ACTIONERROR, "No Order Form ID given.");
		} else {
			
			$getOptions = array(
				"getOrderFormParams" => 1,
				"getOrderFormItems" => 1,
				"getCouponData" => 1,
				"orderFormID" => $orderformID
			);
			
			$query = $this->getMBAPIQuery("GetOrderForms", "", $getOptions, 1, 1, 1, 1);
			$ofdata = dispatchMBAPI($query, 1);

			if($this->addMBAPIErrors($ofdata) === 0 && !$this->getNumErrors()) {
				$smartyVars = array();
				
				$this->mergeCountryData();
				$smartyVars["countryList"] =& $this->smartyVars["countryList"];
				$this->mergeLanguageData();
				$smartyVars["languageList"] =& $this->smartyVars["languageList"];
				
				$query = $this->getMBAPIQuery("GetPaymentGroups", "", array());
				$paymentgroupdata = dispatchMBAPI($query, 1);
				$pgroups = $paymentgroupdata["mbapi"][0]["results"][0]["paymentGroups"][0]["paymentGroup"];

				$query = $this->getMBAPIQuery("GetCoupons", "", array());
				$coupondata = dispatchMBAPI($query, 1);
				dbg($coupondata);
				if (isset($coupondata["mbapi"][0]["results"][0]["coupons"]) && isset($coupondata["mbapi"][0]["results"][0]["coupons"][0]["coupon"]) && is_array($coupondata["mbapi"][0]["results"][0]["coupons"][0]["coupon"])){
					foreach ($coupondata["mbapi"][0]["results"][0]["coupons"][0]["coupon"] as $coup){
						$allcouponIDs[] = $coup["couponID"][0];
						$smartyVars["coupons"][$coup["couponID"][0]] = $coup;
					}
				}

				$query = $this->getMBAPIQuery("GetCompanies", "", array());
				$companydata = dispatchMBAPI($query, 1);
				$allcomps = $companydata["mbapi"][0]["results"][0]["companies"][0]["company"];
				
				$getOptions = array(
					"getProductAddonData" => 1,
					"productActive" => 1
				);
				
				$query = $this->getMBAPIQuery("GetProducts", "", $getOptions);
				$productdata = dispatchMBAPI($query, 1);
				//Get all productIDs
				if (is_array($productdata["mbapi"][0]["results"][0]["products"][0]["product"])){
					foreach ($productdata["mbapi"][0]["results"][0]["products"][0]["product"] as $prod){
						$allproductIDs[] = $prod["productID"][0];
						if(is_array($prod["productAddons"][0]["productAddon"])){
							foreach($prod["productAddons"][0]["productAddon"] as $padd){
								$allproductAddons[$prod["productID"][0]][$padd["productAddonID"][0]] = $padd["productAddonName"][0];
							}
						}
						$smartyVars["products"][$prod["productID"][0]] = $prod;
					}
				}
				
				// set orderForm smarty var (only one group returned)
				$smartyVars["orderForm"] =& $ofdata["mbapi"][0]["results"][0]["orderForms"][0]["orderForm"][0];

				// set productsInForm smarty var & correct offset if only 1 orderFormItem is returned
				// this will be an array of all orderFormItem data where the orderFormItem's are assigned to this group
				$smartyVars["productsInForm"] = array();
				if(is_array($smartyVars["orderForm"]["orderFormItems"][0]["orderFormItem"])) {
					$smartyVars["orderFormItemsInForm"] = $smartyVars["orderForm"]["orderFormItems"][0]["orderFormItem"];
					if(count($smartyVars["orderForm"]["orderFormItems"][0]["orderFormItem"])==1) {
						$smartyVars["orderFormItemsInForm"] = array($smartyVars["orderForm"]["orderFormItems"][0]["orderFormItem"][0]);
					}
				}

				// assign all orderFormItemIDs in the group to $productIDsInForm for later use
				$productIDsInForm = array();
				if(is_array($smartyVars["orderFormItemsInForm"])){
					foreach($smartyVars["orderFormItemsInForm"] as $orderFormItem) {
						if(is_array($orderFormItem["productID"]) && count($orderFormItem["productID"])) {
							$smartyVars["productsInForm"][$orderFormItem["productID"][0]] = $smartyVars["products"][$orderFormItem["productID"][0]]["productName"][0]." - ". getTypeName("products", $smartyVars["products"][$orderFormItem["productID"][0]]["productType"][0]);
						}
					}
				}
				
				
				// assign all orderFormItemIDs NOT in the group to $orderFormItemIDsNotInForm for later use
				$productIDsNotInForm = array();
				if(is_array($productdata["mbapi"][0]["results"][0]["products"][0]["product"])){
					foreach($productdata["mbapi"][0]["results"][0]["products"][0]["product"] as $product) {
						if (!in_array($product["productID"][0],array_flip($smartyVars["productsInForm"]))) {
							$smartyVars["productsNotInForm"][$product["productID"][0]] = $smartyVars["products"][$product["productID"][0]]["productName"][0]." - ". getTypeName("products", $smartyVars["products"][$product["productID"][0]]["productType"][0]);
						}
					}
				}
				if(is_array($allproductAddons)){
					foreach($allproductAddons as $key=>$prodaddNot){
						foreach($prodaddNot as $id=>$name){
							if (!in_array($id, array_flip($smartyVars["productAddonsInForm"]))) {
								$smartyVars["productAddonsNotInForm"][$id."|".$smartyVars["products"][$key]["productID"][0]] = $name." - ". $smartyVars["products"][$key]["productName"][0];
							}
						}
					}
				}
				
				$smartyVars["orderFormParams"] = $smartyVars["orderForm"]["orderFormParams"][0]["orderFormParam"];
				
				//Check for an array in order_form_param_value as that is how we store checkbox values
				$i = 0;
				if(is_array($smartyVars["orderFormParams"])){
					foreach ($smartyVars["orderFormParams"] as $paramcheck){
						if ($paramcheck["orderFormParamInputType"][0] == "c") {
							$smartyVars["orderFormParams"][$i]["orderFormParamValue"][0] = unserialize($paramcheck["orderFormParamValue"][0]);
						}
						$i++;
					}
				}
				$smartyVars["orderForm"]["coupons"][0]["coupon"] = protectArray($smartyVars["orderForm"]["coupons"][0]["coupon"]);
				$smartyVars = collapseArrayElements($smartyVars);
				
				if(is_array($smartyVars["orderForm"]["orderFormValues"]["orderFormValue"])){
					foreach ($smartyVars["orderForm"]["orderFormValues"]["orderFormValue"] as $value) {
						$smartyVars["orderFormValues"][$value["orderFormParamID"]][$value["orderFormValueName"]] = (defined($value["orderFormValueTransKey"])) ? constant($value["orderFormValueTransKey"]) : $value["orderFormValueTransKey"];
					}
				}

				if(is_array($pgroups)){
					foreach ($pgroups as $group) {
						$smartyVars["paymentgroups"][$group["paymentGroupID"][0]] = $group["paymentGroupName"][0]." (".$group["paymentGroupCurrencyID"][0].")";
					}
				}

				if(is_array($allcomps)){
					foreach ($allcomps as $comp) {
						$smartyVars["companies"][$comp["companyID"][0]] = $comp["companyName"][0];
					}
				}

				if(is_array($smartyVars["orderForm"]["coupons"]["coupon"])) {
					$coupons = $smartyVars["orderForm"]["coupons"]["coupon"];
				}

				if(is_array($coupons)){
					foreach($coupons as $coupon){
						$smartyVars["couponsInForm"][$coupon["couponID"]] = $coupon["couponCode"];
					}
				}else{
					$smartyVars["couponsInForm"] = array();
				}

				if(is_array($allcouponIDs)){
					foreach($allcouponIDs as $key=>$id){
						if (!in_array($id, array_flip($smartyVars["couponsInForm"]))) {
							$smartyVars["couponsNotInForm"][$id] = $smartyVars["coupons"][$id]["couponCode"];
						}
					}
				}

				// nuke nested orderFormItems data from orderForm param, this makes the smarty data easier to deal with
				unset($smartyVars["orderForm"]["orderFormItems"]);
				unset($smartyVars["orderForm"]["orderFormParams"]);
				unset($smartyVars["orderForm"]["orderFormValues"]);
				//unset($smartyVars["orderFormItemsInForm"]);
			
				$this->addTemplate("orderforms/EditOrderForm", $smartyVars, 1);
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditPaymentgroup
?>
