<?php
// $Id: EditOrderFormResponse.php,v 1.10 2006/07/28 16:44:23 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It handles the data from EditOrderForm action and modifies an existing
 * config param record if data is valid; else redirects back to EditOrderForm.
 *
 * @author  Mark Garrett
 */
class EditOrderFormResponse extends MB_Action {

	function EditOrderFormResponse() {
		parent::MB_Action();
		$this->stringRep = "EditOrderFormResponse";
		$this->params = array
		(
			"orderFormID",
			"orderFormName",
			"paymentGroupID",
			"companyID",
			"languageID",
			"countriesID",
			"orderFormVerifyVat",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();

		$updateOrderFormParams = array();
		
		$_REQUEST["orderFormVerifyVat"] = ((int)$_REQUEST["orderFormVerifyVat"])?1:0;

		foreach($_REQUEST["orderFormParams"] as $orderFormParam) {
			// find the orderFormID for these params

			$orderFormParamID = ((int) $orderFormParam["orderFormParamID"]);
			$orderFormParamValue = (!is_array($orderFormParam["orderFormParamValue"])) ?
				$orderFormParam["orderFormParamValue"] : serialize($orderFormParam["orderFormParamValue"]);

			$updateOrderFormParams[] =
				 "<orderFormParam>\n"
				."  <orderFormParamID>".$orderFormParamID."</orderFormParamID>\n"
				."  <orderFormParamValue>".$orderFormParamValue."</orderFormParamValue>\n"
				."</orderFormParam>\n";
		}

		if (count($updateOrderFormParams)==0) {
			$this->addError(TRANS_ACTIONERROR, "No order form params given.");
		} else {
			
			
			
			$getOptions = array(
				"getOrderFormItems" => 1,
				"getCouponData" => 1,
				"orderFormID" => $_REQUEST["orderFormID"]
			);
			
			$getquery = getMBAPIQuery("GetOrderForms", "", $getOptions);
			$getdata = dispatchMBAPI($getquery, 1);
			$ofdata =& $getdata["mbapi"][0]["results"][0]["orderForms"][0]["orderForm"][0];
			
			$ofitemsdata =& $ofdata["orderFormItems"][0]["orderFormItem"];
			$ofcoupondata =& $ofdata["coupons"][0]["coupon"];
			
			$allproductIDs = $alladdonIDs = $allcouponIDs = $ofProductIDs = $ofProductAddonIDs = $addCouponIDs = 
			$updateOrderFormItems = $removeItems = $addCoupons = $removeCoupons = $addProductAddons
			= array();
			

			//Get the order form inputs assigned to variables
			if(is_array($_REQUEST["addProductIDs"])){
				$ofProductIDs =& $_REQUEST["addProductIDs"];
			}else{
				$ofProductIDs = array();
			}

			if(is_array($_REQUEST["addCouponIDs"])){
				$ofCouponIDs =& $_REQUEST["addCouponIDs"];
			}else{
				$ofCouponIDs = array();
			}
			
			// Get existing items
			if (is_array($ofitemsdata)){
				foreach($ofitemsdata as $formitem) {
					$allproductIDs[$formitem["orderFormItemID"][0]] = $formitem["productID"][0];
				}
			}
			
			
			// Get the product data for all coupons in the system. This is needed so that we don't add coupons that have
			// no products associated with the order form.
			$getOptions = array(
				"getProductData" => 1
			);
			
			$cquery = getMBAPIQuery("GetCoupons", "", $getOptions);

			$cdata = dispatchMBAPI($cquery, 1);
			$couponData =& $cdata["mbapi"][0]["results"][0]["coupons"][0]["coupon"];
			
			if(is_array($couponData)){
				foreach ($couponData as $coupprod){
					if(is_array($coupprod["products"][0]["product"])){
						foreach($coupprod["products"][0]["product"] as $relprod){
							$possibleCouponProducts[$coupprod["couponID"][0]][] = $relprod["productID"][0];
						}
					}
				}
			}

			// Get existing coupons that are related to this OF
			if (is_array($ofcoupondata)){
				foreach($ofcoupondata as $coupon) {
					$allcouponIDs[] = $coupon["couponID"][0];
				}
			}

			
			// Update and remove products
			$updateitem = NULL;
			foreach ($ofProductIDs as $key=>$id){
				if (in_array($id, $allproductIDs)){
					$ofitemids = array_flip($allproductIDs);
					$updateitem ="  <orderFormItemID>".$ofitemids[$id]."</orderFormItemID>\n";
				}
				$updateOrderFormItems[] =
					 "<orderFormItem>\n"
					.$updateitem
					."  <productID>".$id."</productID>\n"
					."  <orderFormItemOrder>".$key."</orderFormItemOrder>\n"
					."</orderFormItem>\n";
				$updateitem = NULL;
			}

			foreach (array_diff($allproductIDs, $ofProductIDs) as $key=>$id){
				$removeItems[] = "  <productID>".$id."</productID>\n";
			}

			// Add and remove coupons - check to see if the coupon to be added relates to any of the products on the form first
			foreach (array_diff($ofCouponIDs, $allcouponIDs) as $key=>$id){
				if(in_array($id, array_keys($possibleCouponProducts)) && count(array_intersect($possibleCouponProducts[$id], $ofProductIDs))){
					$addCoupons[] = "  <couponID>".$id."</couponID>\n";
				}
			}

			foreach (array_diff($allcouponIDs, $ofCouponIDs) as $key=>$id){
				$removeCoupons[] = "  <couponID>".$id."</couponID>\n";
			}		
		
			// Generate the XML for the SetOrderForms call
			$xmlParams = array
			(
				"orderFormParams"  => implode("\n",$updateOrderFormParams),
				"orderFormItems"  => implode("\n",$updateOrderFormItems),
				"removeOrderFormItems"  => implode("\n",$removeItems),
				"couponIDs"  => implode("\n",$addCoupons),
				"removeCouponIDs"  => implode("\n",$removeCoupons),
				"productAddons"  => implode("\n",$addProductAddons)
			);

			$query = $this->getMBAPIQuery("SetOrderForms", "update", $xmlParams);
			$data = dispatchMBAPI($query, 1);
			dbg("update order form query:");
			dbg($query);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"]).
					"&".$_REQUEST["redirectArgs"]);
				} else {
					redirect("orderforms.php", getActionID("ShowOrderForms"));
				}
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	} // execute

} // MB_Action
?>
