<?php
// $Id: AddHistoricalPackage.php,v 1.33 2006/07/24 22:31:59 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__) . "/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-tk/toolkit.php");

class AddHistoricalPackage extends MB_Action {
	function AddHistoricalPackage() {
		parent::MB_Action();
		$this->stringRep = "AddHistoricalPackage";
		$this->params = array();		
	}
	function execute() {
		global $CONF;

		//echo '<pre>';
		//print_r($_REQUEST);
		//echo '</pre>';

		$mode = getParam("mode");
		$clientID = getParam("clientID");
		$orderFormID = getParam("orderFormID");
		$productID = getParam("productID");
		$productVariantID = getParam("productVariantID");
		$cycleID = getParam("cycleID");
		$response = getParam("response", "s");
	
		$historical = $mode == "2" ? true : false;
		$this->smartyVars["historical"] = $historical;

		do {
			$try = false;
			// get selected information
			if($mode) {
				$this->smartyVars["mode"] = $mode;
			}
			if($clientID) {
				$this->smartyVars["clientID"] = $clientID;
			}
			if($orderFormID && !isset($this->smartyVars["orderForm"])) {
				$this->smartyVars["orderFormID"] = $orderFormID;
				$oft =& $this->getTableFromSource(new DataSource("orderForms", array("orderFormID" => $orderFormID)));
				$this->smartyVars["orderForm"] = $oft->getOne();
				$this->smartyVars["orderFormName"] = $oft->getOneName();
			}
			if($productID && !isset($this->smartyVars["product"])) {
				$this->smartyVars["productID"] = $productID;
				$pt =& $this->getTableFromSource(new DataSource("products", array("productID" => $productID)));			
				$this->smartyVars["product"] = $pt->getOne();
				$this->smartyVars["productName"] = $pt->getOneName();
			}
			if($productVariantID && !isset($this->smartyVars["productVariant"])) {
				$this->smartyVars["productVariantID"] = $productVariantID;
				$pvt =& $this->getTableFromSource(new DataSource("productVariants", array("productVariantID" => $productVariantID)));
				$this->smartyVars["productVariant"] = $pvt->getOne();
				$this->smartyVars["productVariantPrimaryName"] = $pvt->getOneName();
			}
			if($cycleID && !isset($this->smartyVars["cycle"])) {
				$this->smartyVars["cycleID"] = $cycleID;
				$ct =& $this->getTableFromSource(new DataSource("cycles", array("cycleID" => $cycleID)));
				$this->smartyVars["cycle"] = $ct->getOne();
				$this->smartyVars["cycleDisplayName"] = $ct->getOneName();
			}

			// get selection information
			if($clientID && $orderFormID && $productID && $productVariantID && $cycleID) {
				// cycleID
				$this->smartyVars["cycle"] = $ct->getOne();
			
				// productVariantID
				$firstPV = $pvt->getOne();
				
				$priced =& new DataSource("productVariantPrices", array("productVariantID" => $productVariantID, "orderFormID" => $orderFormID, "cycleID" => $cycleID));
				$pricet =& $this->getTableFromSource($priced);
				$pricet->alterState(TABLE_STATE_INTERNAL);
				$pricet->setKey("productVariantPriceType");
				$pricet->setName("productVariantPriceAmount");
				$prices = $pricet->getOptions();
				$this->smartyVars["prices"] = $prices;
				
				// productID
				//$productID = $firstPV["productID"];
				$this->smartyVars["productID"] = $productID;
				$this->smartyVars["productTypes"] = getTypes("products");

				$pd =& new DataSource("products", array("productID" => $productID));
				$pt =& $this->getTableFromSource($pd);
				$this->smartyVars["product"] = $pt->getOne();
				$this->smartyVars["productName"] = $pt->getOneName();

				$pt->alterState(TABLE_STATE_INTERNAL);
				$product = $pt->getOne();

				$type = $product["productType"];
				$this->smartyVars["productType"] = $type;
				
				// panels or tldID
				if($type == "domain") {
						$tldID = $firstPV["tldID"];
						$this->smartyVars["tldID"] = $tldID;
						$tldt =& $this->getTableFromSource(new DataSource("TLDs", array("tldID" => $tldID)));
						$TLD = $tldt->getOne();
						$this->smartyVars["TLD"] = $TLD;
						$this->smartyVars["tldName"] = $TLD["tldName"];
				} else {
						$sgd =& new DataSource("serverGroups", array("productID" => $productID, "getPanels" => 1));
						$sgt =& $this->getTableFromSource($sgd);
						//$sgt->alterState(TABLE_STATE_DISPLAY);
						$serverGroups = $sgt->getOptions();
						$this->smartyVars["serverGroups"] = $serverGroups;

						$s =& $sgd->getSubject();

						$panelSubjectsByServerGroupID = $s->getAdditionalDataByKey("panels", "panel", "configGroupID", "configParamValue");

						$panelsByServerGroupID = array();
						foreach($panelSubjectsByServerGroupID as $serverGroupID => $panelSubject) {
							$panelTable =& $panelSubject->getTable();
							$panelsByServerGroupID[$serverGroupID] = $panelTable->getOptions();
						}
						$this->smartyVars["panelsByServerGroupID"] = $panelsByServerGroupID;
				}
				
				// clientID
				switch($type) {
					case "domain":
					case "hosting":
						$this->smartyVars["associateDomain"] = true;
						$dd =& new DataSource("clientDomains", array("clientID" => $clientID, "getBillingData" => 1));
						$tldTable =& $this->getTableFromSource($dd);
						if($type == "domain") {
							$TLDsByExt =& $tldTable->getAssociatedTablesBy("domainTLD");
							$extension = $TLD["tldExtension"];
							if(isset($TLDsByExt[$extension])) {
								$tldTable =& $TLDsByExt[$extension];
								$this->smartyVars["clientDomains"] = $tldTable->getOptions();
							} else {
								$this->smartyVars["clientDomains"] = array();
							}
						} else {
							$this->smartyVars["clientDomains"] = $tldTable->getOptions();
						}
						$cd =& new DataSource("clients", array("clientID" => $clientID));
						
						// XXX: begin optimization hack
						// borrow the result from the previous query, which is a superset of what is needed
						$r =& $dd->getResult();
						$cd->result =& $r;
						$cd->resultPrepared = true;
						// end hack
						break;
					default:
						$this->smartyVars["associateDomain"] = false;
						$cd =& new DataSource("clients", array("clientID" => $clientID, "getBillingData" => 1));
						break;
				}
								
				$clt =& $this->getTableFromSource($cd);
				$client = $clt->getOne();
				$this->smartyVars["client"] = $client;
				$this->smartyVars["clientName"] = $clt->getOneName();
				
				$bd =& new DataSource("clientBillingAccounts", array("clientID" => $clientID, "getBillingData" => 1));
				// XXX: begin optimization hack
				// borrow the result from the previous query, which is a superset of what is needed
				$r =& $cd->getResult();
				$bd->result =& $r;
				$bd->resultPrepared = true;
				// end hack
				$this->smartyVars["clientBillingAccounts"] = $this->getOptionsFromSource($bd);
				 
				// orderFormID
				$orderForm = $oft->getOne();
				$this->smartyVars["orderForm"] = $orderForm;
				$this->smartyVars["currencyID"] = $orderForm["paymentGroupCurrencyID"];
				
				
				if($response) {
					//echo "<pre>";
					//print_r($_REQUEST);
					
					$billingAccountID = $_REQUEST["billingAccountID"];
					
					if($product["productStopNumCycles"] != 1) {
						$packageNextRenewal = $this->handleDateSelector("packageNextRenewal", mktime());
					}
					$packageStartDate = $this->handleDateSelector("packageStartDate", mktime());

					if($type == "domain") {
						$registerDomain = $this->handleDateSelector("registerDomain", false, !$historical);
					} else {
						$serverGroupData = array();
						foreach($serverGroups as $serverGroupID => $serverGroupName) {
							$key = "sg" . $serverGroupID;
							$serverGroupData[$serverGroupID] = array();
							$serverGroupData[$serverGroupID]["username"] = $_REQUEST[$key . "username"];
							$serverGroupData[$serverGroupID]["password"] = $_REQUEST[$key . "password"];
							$serverGroupData[$serverGroupID]["configGroupID"] = $_REQUEST[$key . "panel"];
							$serverGroupData[$serverGroupID]["provision"] = $this->handleDateSelector($key . "create", false, !$historical);
						}
					}
					//echo "next: " . $packageNextRenewal . "\n";
					//echo "start: " . $packageStartDate . "\n";
					//echo $registerDomain . "\n";
					//print_r($serverGroupData);
					//exit;
					
					$generalPrice = $this->getNumberFromInput($_REQUEST["generalPrice"]);
					$setupPrice = $this->getNumberFromInput($_REQUEST["setupPrice"]);
					
					$query = array();
					$query += array(
						"orderFormID" => $orderFormID,
						"paymentType" => 9999,
						"fraudLevelActionStatus" => 1,
						"disableInvoicing" => empty($_REQUEST["generateInvoice"]) ? 1 : 0,
						"disableCharging" => 1,
						"disableFraudguardian" => 1,
						"client" => array(
							"clientID" => $clientID,
						),
					);
					$product = array(
						"ID" => 14736251,
						"productID" => $productID,
						"productVariantID" => $productVariantID,
						"cycleID" => $cycleID,
						"quantity" => 1,
						"taxZoneGroupID" => $firstPV["taxZoneGroupID"],
						"comments" => "Manually created by admin " . $CONF["user"]["adminData"]["adminUsername"][0],
						"price" => (float) $generalPrice,
						"setup" => (float) $setupPrice,
						"packageDateNextRenewal" => $packageStartDate,
					);
					if($packageNextRenewal) $product["packageDateBeginRenewal"] = $packageNextRenewal;
					
					$servers = array();
					foreach($serverGroupData as $serverGroupID => $serverData) {
						$server = array();
						
						$server["serverGroupID"] = $serverGroupID;
						if($configGroupID = $serverData["configGroupID"]) $server["configGroupID"] = $configGroupID;
						$server["packageUsername"] = $serverData["username"];
						$server["packagePassword"] = $serverData["password"];
						
						$servers[] = $server;
					}
					if($servers) $product["servers"] = array("server" => $servers);
					
					if($billingAccountID) $query["clientBillingAccount"] = array("billingAccountID" => $billingAccountID);
					switch ($type) {
						case "domain":
							if($registerDomain) {
								if($billingAccountID) {
									$contactD =& new DataSource("clients", array("clientID" => $clientID, "getContactData" => 1));
									$clientS =& $contactD->getSubject();
									$contactS =& $clientS->newFrom(array("contacts", "contact"));
									$contactTable =& $contactS->getTable();

									$bad =& new DataSource("billingAccounts", array("billingAccountID" => $billingAccountID));
									$bat =& $bad->getTable();
									$ba = $bat->getOne();
									$contactID = $ba["clientContactID"];

									$contactsByID =& $contactTable->getAssociatedBy("clientContactID");

									$contact = $contactsByID[$contactID];
								} else {
									$contactD =& new DataSource("clients", array("clientID" => $clientID, "getContactData" => 3)); // get primary contact
									$clientS =& $contactD->getSubject();
									$contactS =& $clientS->newFrom(array("contacts", "contact"));
									$contactTable =& $contactS->getTable();

									$contact = $contactTable->getOne();

								}

								$query["domainRegistrant"] = array(
									"registrantFirstName" => $contact["contactFirstName"],
									"registrantLastName" => $contact["contactLastName"],
									"registrantAddress1" => $contact["contactAddress1"],
									"registrantAddress2" => $contact["contactAddress2"],
									"registrantCity" => $contact["contactCity"],
									"registrantStateProvince" => $contact["contactState"],
									"registrantPostalCode" => $contact["contactZip"],
									"registrantOrganizationName" => $client["clientCompany"],
									"registrantJobTitle" => "",
									"registrantEmail" => $contact["contactEmail"],
									"registrantPhone" => $contact["contactPhone1"],
									"registrantFax" => $contact["contactFax"],
									"registrantCountry" => $contact["countriesID"],
								);

								$query["provisionDateRule"] = array(
									"domainID" => (int) $_REQUEST["packageDomainID"],
									"provisionDate" => $registerDomain,
								);

								if($_REQUEST["packageDomainID"]) {
									$product["domain"] = array(
										"domainID" => (int) $_REQUEST["packageDomainID"],
										"domainType" => getAPITypeID("shoppingdomains", "existing"),
									);
								} else if($_REQUEST["domainName"] && $TLD["tldName"]) {
									$product["domain"] = array(
										"domainID" => 14736251,
										"domainType" => getAPITypeID("shoppingdomains", "new"),
										"domainSLD" => $_REQUEST["domainName"],
										"domainTLD" => $TLD["tldName"],
									);
								}
							} else {
								if($_REQUEST["packageDomainID"]) {
									$query["provisionRules"] = array(
										"disableDomainIDs" => array("domainID" => (int) $_REQUEST["packageDomainID"]),
									);
									$product["domain"] = array(
										"domainID" => (int)$_REQUEST["packageDomainID"],
										"domainType" => getAPITypeID("shoppingdomains", "existing"),
									);
								} else if($_REQUEST["domainName"] && ($TLD["tldName"] || $_REQUEST["domainTLD"])) {
									$query["provisionRules"] = array(
										"disableDomainIDs" => array("domainID" => 14736251),
									);
									$product["domain"] = array(
										"domainID" => 14736251,
										"domainType" => getAPITypeID("shoppingdomains", "new"),
										"domainSLD" => $_REQUEST["domainName"],
										"domainTLD" => ($TLD["tldName"])?$TLD["tldName"]:$_REQUEST["domainTLD"],
									);
								}
							}
							break;
					 	case "hosting":
							if($_REQUEST["packageDomainID"]) {
								$query["provisionRules"] = array(
									"disableDomainIDs" => array("domainID" => (int) $_REQUEST["packageDomainID"]),
								);
								$product["domain"] = array(
									"domainID" => (int)$_REQUEST["packageDomainID"],
									"domainType" => getAPITypeID("shoppingdomains", "existing"),
								);
							} else if($_REQUEST["domainName"] && $_REQUEST["domainTLD"]) {
								$query["provisionRules"] = array(
									"disableDomainIDs" => array("domainID" => 14736251),
								);
								$product["domain"] = array(
									"domainID" => 14736251,
									"domainType" => getAPITypeID("shoppingdomains", "manual"),
									"domainSLD" => $_REQUEST["domainName"],
									"domainTLD" => $_REQUEST["domainTLD"],
								);
							}
						default:
							$provisionDateRules = array();
							foreach($serverGroupData as $serverGroupID => $serverGroupAttrs) {
								if($serverGroupAttrs["provision"]) {
									$provisionDateRules[] = array(
										"serverGroupID" => $serverGroupID,
										"provisionDate" => $serverGroupAttrs["provision"],
									);
								} else {
									$provisionDateRules[] = array("disableProvisionIDs" => $serverGroupID);
								}
							}
							if($provisionDateRules) $query["provisionRules"] = array(
								"provisionDateRule" => $provisionDateRules,
							);
							break;
					}
					$query["products"] = $product;
										
					//echo '<pre>';
					//print_r($_REQUEST);
					//print_r($query);
					
					$q =& new MBQuery("ProcessCheckout", "process", $query);
					//show($q->getXMLQuery());
					//exit;
					//print_r(htmlentities($q->getXMLQuery()));
					//echo '</pre>';
					dbg($q->getXMLQuery());
					if(!$this->addErrorsFromResult($r =& $q->getResult())) break;
					
					$rs =& $r->getSubjectFrom(array("mbapi", "results", "packageID", 0));
					$packageID = $rs->getData();
					//echo "packageID: " . $packageID;
					
					//echo '<pre>';
					//print_r($r);
					//echo '</pre>';
					//exit;
					if(!$this->goBack()) redirect("packages.php", getActionID("EditPackage"), array("packageID" => $packageID));
					
							
					//echo "</pre>";
				} else {
					// dates
					if($product["productStopNumCycles"] != 1) {
						$this->formDefaults["packageNextRenewal"] = mktime();
						$this->setupDateSelector("packageNextRenewal");
					}
					$this->formDefaults["packageStartDate"] = mktime();
					$this->setupDateSelector("packageStartDate");

					if($type == "domain") {
						$this->formDefaults["registerDomain"] = mktime();
						$this->setupDateSelector("registerDomain", !$historical);
					} else {
						foreach($serverGroups as $serverGroupID => $serverGroupName) {
							$this->formDefaults["sg" . $serverGroupID . "create"] = mktime();
							$this->setupDateSelector("sg" . $serverGroupID . "create", !$historical);
						}
					}

					// prices
					$this->formDefaults["generalPrice"] = isset($this->smartyVars["prices"]["general"]) ? $this->smartyVars["prices"]["general"] : -1;
					$this->formDefaults["setupPrice"] = isset($this->smartyVars["prices"]["setup"]) ? $this->smartyVars["prices"]["setup"] : -1;
					$this->formDefaults["transferPrice"] = isset($this->smartyVars["prices"]["transfer"]) ? $this->smartyVars["prices"]["transfer"] : -1;

					$this->mergeFormState();
					/*
					echo '<pre>';
					print_r($this->smartyVars);
					echo '</pre>';
					/**/
				$this->addTemplate("packages/AddHistoricalPackage");
				}
			} else if($clientID && $orderFormID && $productID && $productVariantID) {
				// get cycles associated with the product of the selected product variant
				$this->smartyVars["cycleOptions"] = $this->getOptionsFromSource(new DataSource("productCycles", array("productVariantID" => $productVariantID, "productActive" => 1)));
				/*
				if(count($this->smartyVars["cycleOptions"]) == 1) {
					$try = true;
					$cycleID = current($phpsucks = array_keys($this->smartyVars["cycleOptions"]));
					unset($this->smartyVars["cycleOptions"]);
					continue;
				}
				*/
				$this->addTemplate("packages/AddHistoricalPackageMenu");
			} else if($clientID && $orderFormID && $productID) {
				// get product variants of the products associated with the order form
				$this->smartyVars["productVariantOptions"] = $this->getOptionsFromSource(new DataSource("productVariants", array("orderFormID" => $orderFormID, "productID" => $productID, "productVariantActive" => 1)));
				if(count($this->smartyVars["productVariantOptions"]) == 1) {
					$try = true;
					$productVariantID = current($phpsucks = array_keys($this->smartyVars["productVariantOptions"]));
					unset($this->smartyVars["productVariantOptions"]);
					continue;
				} 
				$this->addTemplate("packages/AddHistoricalPackageMenu");
			} else if($clientID && $orderFormID) {
				// get product variants of the products associated with the order form
				$this->smartyVars["productOptions"] = $this->getOptionsFromSource(new DataSource("products", array("orderFormID" => $orderFormID, "productActive" => 1)));
				if(count($this->smartyVars["productOptions"]) == 1) {
					$try = true;
					$productID = current($phpsucks = array_keys($this->smartyVars["productOptions"]));
					unset($this->smartyVars["productOptions"]);
					continue;
				} 
				$this->addTemplate("packages/AddHistoricalPackageMenu");
			} else if($clientID) {
				// get order forms
				$this->smartyVars["orderFormOptions"] = $this->getOptionsFromSource(new DataSource("orderForms"));
				if(count($this->smartyVars["orderFormOptions"]) == 1) {
					$try = true;
					$orderFormID = current($phpsucks = array_keys($this->smartyVars["orderFormOptions"]));
					unset($this->smartyVars["orderFormOptions"]);
					continue;
				} 
				$this->addTemplate("packages/AddHistoricalPackageMenu");
			} else {
				$this->addError(TRANS_ACTIONERROR, "Needs at least a client ID to get started.");
				break;
			}
			
			/*
			echo '<pre>';
			print_r($this->smartyVars);
			echo '</pre>';
			/**/
			

		} while($try);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}

?>
