<?php
// $Id: AddPackageAddon.php,v 1.1 2006/06/15 22:52:43 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");

/**
 * This Action object collects information on all packages that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Michael Fountain
 */
class AddPackageAddon extends MB_Action {
	/**
	 * The constructor for a AddPackageAddon action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function AddPackageAddon() {
		global $CONF;
		parent::MB_Action();
		$this->stringRep = "AddPackageAddon";

		// define all possible params that we will accept
		$this->params = array
		(
			"packageID",
		);
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		define("SUPPRESS_SIMPLE_MBAPI_DEBUG", 1);
		$this->smartyVars = array();
		$this->smartyVars["types"] = getTypes("products");

		$this->smartyVars["rawPackageAddons"] = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackageAddons",
				"params" => array(
					"packageID" => (int)$_REQUEST["packageID"],
					"packageAddonActive" => 1,
				),
			),
		)));
		dbg($this->smartyVars["rawPackageAddons"]);
		
		$this->smartyVars["packageAddons"] = array();
		foreach ((array)$this->smartyVars["rawPackageAddons"] as $k=>$pkga){
			$this->smartyVars["packageAddons"][$pkga["packageAddonProductID"]] =& $this->smartyVars["rawPackageAddons"][$k];
		}
		
		dbg("package addons keyed by product id:");
		dbg($this->smartyVars["packageAddons"]);
		
		$this->smartyVars["packageInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackages",
				"params" => array(
					"packageID" => (int)$_REQUEST["packageID"],
				),
			),
		)));
		
		dbg("got package info");
		
		$productsInfo = correctArray(grabSimpleMBAPIResults(dispatchMBAPI("
			<mbapi>
				<command>GetProducts</command>
				<params>
					<parentProductID>".$this->smartyVars["packageInfo"]["productID"]."</parentProductID>
					<productActive>1</productActive>
					<getProductAttributeData>1</getProductAttributeData>
					<getCouponData>1</getCouponData>
					<getAllOrderFormItemData>1</getAllOrderFormItemData>
					<getOrderFormItemData>1</getOrderFormItemData>
					<getOrderFormData>1</getOrderFormData>
					<getProductVariantData>1</getProductVariantData>
					<getProductVariantPriceData>1</getProductVariantPriceData>
					<getTLDData>1</getTLDData>
					<getCycleData>1</getCycleData>
				</params>
			</mbapi>", 1)));
			
		$addonGroupIDs = array();
		$this->smartyVars["productAddons"] = array();
		foreach ((array)$productsInfo as $k=>$addon){
			$this->smartyVars["productAddons"][$addon["productID"]] =& $productsInfo[$k];
			$addonGroupIDs[] = $addon["productAddonGroupID"];
		}

		$this->smartyVars["rawProductAddonGroups"] = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetProductAddonGroups",
				"params" => array(
					"productAddonGroupID" => $addonGroupIDs,
				),
			),
		)));

		$this->smartyVars["productAddonGroups"] = array();
		foreach ((array)$this->smartyVars["rawProductAddonGroups"] as $k=>$addonGroup){
			$this->smartyVars["productAddonGroups"][$addonGroup["productAddonGroupID"]] =& $this->smartyVars["rawProductAddonGroups"][$k];
		}
		
		
		foreach ($this->smartyVars["packageAddons"] as $productID=>$packageAddon){
			$groupID = $this->smartyVars["productAddons"][$productID]["productAddonGroupID"];
			dbg("package addon: ".$packageAddon["packageAddonDisplayName"]." has product id of: ".$productID);
			dbg("matching product info:");
			dbg($this->smartyVars["productAddons"][$productID]);
			if ($this->smartyVars["productAddonGroups"][$groupID]["productAddonGroupInputType"]!=getAPITypeID("addoninputs", "checkbox")){
				unset($this->smartyVars["productAddonGroups"][$groupID]);
			}
		}
		
		foreach ((array)$productsInfo as $k=>$addon){
			if ((int)$this->smartyVars["packageAddons"][$addon["productID"]]["packageID"]){
				dbg("unset product id: ".$addon["productID"]);
				unset($productsInfo[$k]);
				unset($this->smartyVars["productAddons"][$addon["productID"]]);
			}
		}

		dbg("groups we dont have an addon in:");
		dbg($this->smartyVars["productAddonGroups"]);
		
		
		foreach ((array)$productsInfo as $k=>$v){
			$prices = array();
		 	if (isset($productsInfo[$k]["productVariantPrices"])){
				foreach ($productsInfo[$k]["productVariantPrices"] as $price){
				 	//dbg("compared: ");
				 	//dbg("currency id: ".$price["currencyID"]);
				 	//dbg("cycle id: ".$price["cycleID"]);
					//dbg("match to cycle: ".$this->smartyVars["packageInfo"]["cycleID"]);
					//dbg("match to currency: ".$this->smartyVars["packageInfo"]["paymentGroupCurrencyID"]);
					//dbg("");
					//dbg("");
					//dbg("");
					if ($price["currencyID"]==$this->smartyVars["packageInfo"]["paymentGroupCurrencyID"] && $price["cycleID"]==$this->smartyVars["packageInfo"]["cycleID"]){
						$prices[$price["productVariantPriceType"]] = $price;
					}
				}
			} else {
				dbg("variant price not set");
			}
			$productsInfo[$k]["prices"] = $prices;
			if (count($productsInfo[$k]["prices"])){
				unset($productsInfo[$k]["productVariantPrices"]);
			} else {
			 	unset($productsInfo[$k]);
			}
		}

		$keyedAddons = array();
		foreach ($productsInfo as $k=>$row){
		 	$keyedAddons[$row["productAddonGroupID"]][] = &$productsInfo[$k];
		}
		
		$this->smartyVars["addonGroups"] =& $this->smartyVars["productAddonGroups"];
		foreach ($keyedAddons as $groupID=>$data){
			if (!$this->smartyVars["addonGroups"][$groupID]){
				unset($keyedAddons[$groupID]);
			}
		}

		$this->smartyVars["products"] = $keyedAddons;
		
		$this->addTemplate("packages/AddPackageAddon", $this->smartyVars);


	}
} // AddPackageAddon
?>
