<?php
// $Id: AddPackageAddonResponse.php,v 1.2 2006/06/16 03:42:44 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");

/**
 * This Action object collects information on all packages that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class AddPackageAddonResponse extends MB_Action {
	/**
	 * The constructor for a AddPackageAddon action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function AddPackageAddonResponse() {
		global $CONF;
		parent::MB_Action();
		$this->stringRep = "AddPackageAddon";

		// define all possible params that we will accept
		$this->params = array
		(
			"packageID",
		);
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		define("SUPPRESS_SIMPLE_MBAPI_DEBUG", 1);
		$productIDs = $_REQUEST["addons"];

		if (!count($productIDs)){
			dbg("NO PRODUCT IDS GIVEN TO CREATE NEW ADDONS");
		} else {

			$productsInfo = correctArray(grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetProducts",
					"params" => array(
						"productID" => $productIDs,
						"productActive" => 1,
						"getProductAttributeData" => 1,
						"getCouponData" => 1,
						"getAllOrderFormItemData" => 1,
						"getOrderFormItemData" => 1,
						"getOrderFormData" => 1,
						"getProductVariantData" => 1,
						"getProductVariantPriceData" => 1,
						"getTLDData" => 1,
						"getCycleData" => 1,
					),
				)
			)));


			$prices = (array)$_REQUEST["prices"];

			$addons = array("packageAddon" => array());
			foreach ((array)$productsInfo as $addon){
			
				$addons["packageAddon"][] = array(
					"packageAddonDisplayName" => $addon["productName"],
					"packageAddonOriginalPrice" => $this->getNumberFromInput($prices[$addon["productID"]]["general"]),
					"packageAddonPrice" => $this->getNumberFromInput($prices[$addon["productID"]]["general"]),
					"packageAddonSetup" => $this->getNumberFromInput($prices[$addon["productID"]]["setup"]),
					"packageAddonPriceLock" => 1,
					"packageAddonActive" => 1,
					"packageAddonProductID" => $addon["productID"],
					"taxZoneGroupID" => $addon["taxZoneGroupID"],
					"couponPrice" => $this->getNumberFromInput($prices[$addon["productID"]]["coupon"]),
					"couponNumCycles" => $this->getNumberFromInput($prices[$addon["productID"]]["couponcycles"]),
					"copyLedgerEntries" => 1,
				);
			
			}

			dbg($addons);

			$commandArray = array(
				"mbapi" => array(
					"command" => "SetPackages",
					"subCommand" => "update",
					"params" => array(
						"packageID" => (int)$_REQUEST["packageID"],
						"packageAddons" => array(
							$addons,
						),
					),
				),
			);
			
			dbg(toXML($commandArray));
			
			$result = dispatchMBAPI(toXML($commandArray), 1);
			dbg("RESULTS:");
			dbg($results);

		}

		redirect("packages.php?action=".getActionID("ShowPackageAddons")."&packageID=".(int)$_REQUEST["packageID"]);

	}
} // AddPackageAddon
?>
