<?php
// $Id: EditPackageAddon.php,v 1.2 2006/06/16 19:10:08 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");

/**
 * This Action object collects information on all packages that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class EditPackageAddon extends MB_Action {
	/**
	 * The constructor for a EditPackageAddon action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function EditPackageAddon() {
		global $CONF;
		parent::MB_Action();
		$this->stringRep = "EditPackageAddon";

		// define all possible params that we will accept
		$this->params = array
		(
			"packageID",
			"packageAddonID",
		);
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		define("SUPPRESS_SIMPLE_MBAPI_DEBUG", 1);
		$this->smartyVars = array();
		$this->smartyVars["types"] = getTypes("products");

		$this->smartyVars["packageAddon"] = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackageAddons",
				"params" => array(
					"packageAddonID" => (int)$_REQUEST["packageAddonID"],
					"packageAddonActive" => 1,
				),
			),
		)));
		
		$allPackageAddons = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackageAddons",
				"params" => array(
					"packageID" => (int)$_REQUEST["packageID"],
					"packageAddonActive" => 1,
				),
			),
		)));
		$this->smartyVars["packageAddons"] = array();
		foreach ((array)$allPackageAddons as $addon){
			$this->smartyVars["packageAddons"][$addon["packageAddonProductID"]] = $addon;
		}

		
		$this->smartyVars["packageInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackages",
				"params" => array(
					"packageID" => (int)$_REQUEST["packageID"],
				),
			),
		)));
		
		dbg("got package info");
		
		$productsInfo = correctArray(grabSimpleMBAPIResults(dispatchMBAPI("
			<mbapi>
				<command>GetProducts</command>
				<params>
					<parentProductID>".$this->smartyVars["packageInfo"]["productID"]."</parentProductID>
					<productActive>1</productActive>
					<getProductAttributeData>1</getProductAttributeData>
					<getCouponData>1</getCouponData>
					<getAllOrderFormItemData>1</getAllOrderFormItemData>
					<getOrderFormItemData>1</getOrderFormItemData>
					<getOrderFormData>1</getOrderFormData>
					<getProductVariantData>1</getProductVariantData>
					<getProductVariantPriceData>1</getProductVariantPriceData>
					<getTLDData>1</getTLDData>
					<getCycleData>1</getCycleData>
				</params>
			</mbapi>", 1)));
			
		$addonGroupIDs = array();
		$this->smartyVars["productAddons"] = array();
		foreach ((array)$productsInfo as $k=>$addon){
			if ($this->smartyVars["packageAddon"]["packageAddonProductID"]==$addon["productID"]){
				$addonGroupID = $addon["productAddonGroupID"];
			}
			$this->smartyVars["productAddons"][$addon["productID"]] =& $productsInfo[$k];
		}

		$this->smartyVars["addonGroups"] = array($addonGroupID => correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetProductAddonGroups",
				"params" => array(
					"productAddonGroupID" => $addonGroupID,
				),
			),
		))));

		
		foreach ((array)$productsInfo as $k=>$v){
			$prices = array();
		 	if (isset($productsInfo[$k]["productVariantPrices"])){
				foreach ($productsInfo[$k]["productVariantPrices"] as $price){
					if ($price["currencyID"]==$this->smartyVars["packageInfo"]["paymentGroupCurrencyID"] && $price["cycleID"]==$this->smartyVars["packageInfo"]["cycleID"]){
						$prices[$price["productVariantPriceType"]] = $price["productVariantPriceAmount"];
					}
				}
			} else {
				dbg("variant price not set");
			}
			$prices["general"] = $prices[0];
			$prices["setup"] = $prices[1];
			$prices["coupon"] = $prices["general"];
			$prices["couponcycles"] = 0;
			$productsInfo[$k]["prices"] = $prices;
			if (count($productsInfo[$k]["prices"])){
				unset($productsInfo[$k]["productVariantPrices"]);
			} else {
			 	unset($productsInfo[$k]);
			}
		}

		foreach ((array)$productsInfo as $k=>$addon){
			if ($this->smartyVars["packageAddons"][$addon["productID"]]["packageID"]){
				$productsInfo[$k]["prices"]["general"] = $this->smartyVars["packageAddons"][$addon["productID"]]["packageAddonPrice"];
				$productsInfo[$k]["prices"]["setup"] = $this->smartyVars["packageAddons"][$addon["productID"]]["packageAddonSetup"];
				$productsInfo[$k]["prices"]["coupon"] = $this->smartyVars["packageAddons"][$addon["productID"]]["couponPrice"];
				$productsInfo[$k]["prices"]["couponcycles"] = $this->smartyVars["packageAddons"][$addon["productID"]]["couponNumCycles"];
				$productsInfo[$k]["selected"] = 1;
				$productsInfo[$k]["packageAddonID"] = $this->smartyVars["packageAddons"][$addon["productID"]]["packageAddonID"];
			}
		}


		$keyedAddons = array();
		foreach ($productsInfo as $k=>$row){
		 	if ($row["productAddonGroupID"]==$addonGroupID){
				//if ($this->smartyVars["packageAddons"][$row["productID"]]["packageID"]){
				//	$this->smartyVars["oldAddonIDs"][] = $this->smartyVars["packageAddons"][$row["productID"]]["packageAddonID"];
				//}
				$keyedAddons[$row["productAddonGroupID"]][] = &$productsInfo[$k];
			}
		}

		$this->smartyVars["products"] = $keyedAddons;
				
		$this->addTemplate("packages/EditPackageAddon", $this->smartyVars);


	}
} // AddPackageAddon
?>
