<?php
// $Id: EditPackageResponse.php,v 1.27 2006/08/02 21:46:51 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * This Action object takes information provided by the EditPackage action, applies that information to
 * records in the database, and redirects to the ShowPackageDetails action for the given package.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class EditPackageResponse extends MB_Action {
	/**
	 * The constructor for an EditPackageResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditPackageResponse() {
		parent::MB_Action();
		$this->stringRep = "EditPackageResponse";
		$this->params = array(
			"packageID", 
			"taxZoneGroupID", 
			"packageName", 
			"packageQuantity", 
			"packageProratable",
			"packageDateNextRenewal",
			"packageDateStopRenewal",
			"packageActive",
			"packageStatus",
			"packageComments",
			"packageType",
			"packagePrice",
			"packageDiscount",
			"packageSetup",
			"packagePriceLock",
			"packageCancellationType",
			"cycleID",
			"usageDateNextRenewal",
			"usageCycleID",
			"usageCalculateOnly",
			"couponNumCycles",
			"packageClientPermissions",
			"couponPrice",
		);
		$this->setupDateRequestArgs();
		$this->filterAmountArgs(array("packagePrice", "packageSetup", "couponPrice"));
		if ($_REQUEST["packageDateNextRenewalYear"])$this->reconstructDateRequest(array("packageDateNextRenewal"));
		if ($_REQUEST["usageDateNextRenewalYear"])$this->reconstructDateRequest(array("usageDateNextRenewal"));
		if ($_REQUEST["packageDateStopRenewalYear"])$this->reconstructDateRequest(array("packageDateStopRenewal"));
}

	/**
	 * The main method of this class that executes the EditPackageResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$this->setReferralActionID(getActionID("EditPackage"));
		$this->setReferralActionFile("packages.php");

		do {
			if($this->err($packageID = $this->validateParam("packageID", INPUT_RESTRICTION_POSITIVE_INT|INPUT_RESTRICTION_REQUIRED), "No appropriate package ID given")) break;
			$configGroupID = $this->validateParam("configGroupID", INPUT_RESTRICTION_POSITIVE_INT|INPUT_RESTRICTION_REQUIRED);
			if($this->err($configGroupID)) {
				

				$packageQuery =& new MBQuery(
					"GetPackages", "",
					array(
						"packageID" => $packageID,
						"getPackageAttributeData" => 1,
						"getPackageAddonData" => 1,
						"getDomainData" => 1,
					)
				);
				if(!$this->addErrorsFromResult($packageResult =& $packageQuery->getResult())) break;
				$packageTable =& $packageResult->getTableFrom(
					array("mbapi", "results", "packages", "package", 0),
					"packageID", "packageName"
				);
				$package = $packageTable->getOne();
				
				$domainTable =& $packageResult->getTableFrom(
					array("mbapi", "results", "packages", "package", "domains", "domain"),
					"domainID", "domainSLD"
				);
				$domain = $domainTable->getOne();
				

				$domainParams = array();
				if ((int)$_REQUEST["packageDomainID"]){
					// if this one is already selected
					if ((int)$_REQUEST["packageDomainID"]==$domain["domainID"]){
					} else { // if its not selected we need to unset the one we have and set the new one
						$domainParams["domainIDs"] = array("domainID" => (int)$_REQUEST["packageDomainID"]);
						if ($domain["domainID"])$domainParams["removeDomainIDs"] = array("domainID" => $domain["domainID"]);
					}
				} elseif (isset($_REQUEST["packageDomainID"])){
					if ($domain["domainID"]){
						$domainParams["removeDomainIDs"] = array("domainID" => $domain["domainID"]);
					}
					if (strlen($_REQUEST["newDomainSLD"]) && strlen($_REQUEST["newDomainTLD"])){
						$newDomainID = insertFor("packageDomains", array(
							"domainSLD" => $_REQUEST["newDomainSLD"],
							"domainTLD" => $_REQUEST["newDomainTLD"],
							"domainIDNLanguage" => "en",
							"domainDateCreated" => time(),
						));
						if ((int)$newDomainID)$domainParams["domainIDs"] = array("domainID" => $newDomainID);
					}
				}

				// base editing
				$this->invalidParams = array();
			
				$params = array();
				dbg("before it");
				dbg($_REQUEST);
				if (isset($_REQUEST["packageActive"]))$params["packageActive"] = $this->validateParam("packageActive", INPUT_RESTRICTION_BOOL);
				if (isset($_REQUEST["cycleID"]))$params["cycleID"] = $this->validateParam("cycleID", INPUT_RESTRICTION_INT);
				if (isset($_REQUEST["packageStatus"]))$params["packageStatus"] = $this->validateParam("packageStatus", INPUT_RESTRICTION_INT);
				if (isset($_REQUEST["packageName"]))$params["packageName"] = $this->validateParam("packageName", INPUT_RESTRICTION_STRING);
				if (isset($_REQUEST["taxZoneGroupID"]))$params["taxZoneGroupID"] = $this->validateParam("taxZoneGroupID", INPUT_RESTRICTION_NULL);
				if (isset($_REQUEST["packageQuantity"]))$params["packageQuantity"] = $this->validateParam("packageQuantity", INPUT_RESTRICTION_INT);
				if (isset($_REQUEST["packageProratable"]))$params["packageProratable"] = $this->validateParam("packageProratable", INPUT_RESTRICTION_BOOL);
				if (isset($_REQUEST["packageComments"]))$params["packageComments"] = $this->validateParam("packageComments", INPUT_RESTRICTION_STRING);
				if (isset($_REQUEST["packageType"]))$params["packageType"] = $this->validateParam("packageType", INPUT_RESTRICTION_INT);
				if (isset($_REQUEST["packagePrice"]))$params["packagePrice"] = $this->validateParam("packagePrice", INPUT_RESTRICTION_DOUBLE);
				if (isset($_REQUEST["packageDiscount"]))$params["packageDiscount"] = $this->validateParam("packageDiscount", INPUT_RESTRICTION_DOUBLE);
				if (isset($_REQUEST["packageSetup"]))$params["packageSetup"] = $this->validateParam("packageSetup", INPUT_RESTRICTION_DOUBLE);
				if (isset($_REQUEST["couponPrice"]))$params["couponPrice"] = $this->validateParam("couponPrice", INPUT_RESTRICTION_DOUBLE);
				if (isset($_REQUEST["packageDateNextRenewal"]))$params["packageDateNextRenewal"] = $this->validateParam("packageDateNextRenewal", INPUT_RESTRICTION_INT);
				if (isset($_REQUEST["packageDateStopRenewal"]))$params["packageDateStopRenewal"] = $this->validateParam("packageDateStopRenewal", INPUT_RESTRICTION_INT);
				if (isset($_REQUEST["usageDateNextRenewal"]))$params["usageDateNextRenewal"] = $this->validateParam("usageDateNextRenewal", INPUT_RESTRICTION_INT);
				if (isset($_REQUEST["couponNumCycles"]))$params["couponNumCycles"] = $this->validateParam("couponNumCycles", INPUT_RESTRICTION_INT);
				if (isset($_REQUEST["usageCalculateOnly"]))$params["usageCalculateOnly"] = $this->validateParam("usageCalculateOnly", INPUT_RESTRICTION_BOOL);
				if (isset($_REQUEST["packagePendingCancellation"]))$params["packagePendingCancellation"] = $this->validateParam("packagePendingCancellation", INPUT_RESTRICTION_INT);
				if (isset($_REQUEST["packageClientPermissions"]))$params["packageClientPermissions"] = $this->validateParam("packageClientPermissions", INPUT_RESTRICTION_INT);
				if (isset($_REQUEST["packageCancellationType"]))$params["packageCancellationType"] = $this->validateParam("packageCancellationType", INPUT_RESTRICTION_INT);

				if (count($this->invalidParams)){
					dbg("doing validation redirect");
					$this->validationRedirect(array("packageID" => (int)$_REQUEST["packageID"]));
					break;
				} else {
					dbg("got past it.");
					dbg($params);
					$params["packageID"] = $packageID;
					$packageQuery =& new MBQuery("SetPackages", "update", (array)$params+(array)$domainParams);
					dbg($packageQuery->getXMLQuery());
					if(!$this->addErrorsFromResult($packageResult =& $packageQuery->getResult())) break;
				}

			} else {
				// panel editing
				
				if($this->err($selectedPanelStatus = $this->validateParam("packageStatus", INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED), "No appropriate package status ID given")) break;

				$packageQuery =& new MBQuery(
					"GetPackages", "",
					array(
						"packageID" => $packageID,
						"getPackageAttributeData" => 1,
					)
				);
				if(!$this->addErrorsFromResult($packageResult =& $packageQuery->getResult())) break;
				$packageTable =& $packageResult->getTableFrom(
					array("mbapi", "results", "packages", "package", 0),
					"packageID", "packageName"
				);
				$package = $packageTable->getOne();

				$packageAttributeTable =& $packageResult->getTableFrom(
					array("mbapi", "results", "packages", "package", "packageAttributes", "packageAttribute"),
					"packageAttributeName", "packageAttributeValue"
				);
				$packageAttributes = $packageAttributeTable->getTable();
				$configGroupPackageAttributeTables =& $packageAttributeTable->getAssociatedTablesBy("configGroupID");
				$ourPackageAttributeTable =& $configGroupPackageAttributeTables[$configGroupID];
				$panelAttributes = $ourPackageAttributeTable->getOptions();
				$panelStatus = $panelAttributes["panel_status"];
				$panelStatusID = getAPIStatusID("package", $panelStatus);

				//echo '<pre>';
				if($panelStatusID != $selectedPanelStatus) {				
					$selectedStatusName = getAPIStatusName("package", $selectedPanelStatus);
					//echo $selectedStatusName;

					$subCommand = "";
					switch($selectedStatusName) {
						case "none":
							$subCommand = "panelUnsuspend";
							break;
						case "suspended":
							$subCommand = "panelSuspend";
							break;
						case "canceled":
							$subCommand = "panelDelete";
							break;
					}

					$panelQuery =& new MBQuery(
						"ProcessPanel", $subCommand,
						array(
							'subCommand' => $subCommand,
							'configGroupID' => $configGroupID,
							'packageID' => $packageID,
						)
					);
					$panelXML = $panelQuery->getXMLQuery();

					$panelQuery =& new MBQuery(
						"SetSystemQueue", "insert",
						array(
							"systemQueueCommand" => "ProcessPanel",
							"configGroupID" => $configGroupID,
							"packageID" => $packageID,
							"systemQueueCommandInput" => htmlentities($panelXML),
							"systemQueueDateToRun" => mktime(),
							"systemQueueDateFinished" => 0,
						)
					);

					//echo '<pre>';
					//echo htmlentities($panelQuery->getXMLQuery());
					//echo '</pre>';
					//exit;
					if(!$this->addErrorsFromResult($panelResult =& $panelQuery->getResult())) break;				
				}

				//print_r($_REQUEST);
				//print_r($ourPackageAttributeTable);
				//print_r($panelAttributes);
				//print_r($configGroupID);
				//print_r($panelStatus);
				//print_r($panelStatusID);
				//echo '</pre>';

			}

			if(!$this->goBack()) redirect("packages.php", getActionID("EditPackage"), array("packageID" => $packageID));
		} while(false);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditPackageResponse
?>