<?php
// $Id: AddPaymentGroupResponse.php,v 1.7 2006/03/22 20:41:10 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the AddPaymentgroup action, applies that information to  * records in the database, and redirects to the ShowPaymentgroupDetails action for the given paymentgroup.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class AddPaymentgroupResponse extends MB_Action {
	/**
	 * The constructor for an AddPaymentgroupResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function AddPaymentgroupResponse() {
		parent::MB_Action();
		$this->stringRep = "AddPaymentgroupResponse";
		$this->params = array(
			"paymentGroupName",
			"paymentGroupCurrencyID"
			);
	}

	/**
	 * The main method of this class that executes the AddPaymentgroupResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		$addGatewayArray = NULL;
		if ($_REQUEST["primaryGateway"] != "") {
			$addGateway = "<primaryGateway>".$_REQUEST["primaryGateway"]."</primaryGateway>";
		}
		if ($_REQUEST["secondaryGateway"] != "") {
			$addGateway .= "<secondaryGateways>
					<secondaryGateway>".$_REQUEST["secondaryGateway"]."</secondaryGateway>
				</secondaryGateways>";
		}
		$query = "<mbapi>
			<command>SetPaymentGroups</command>
			<subCommand>insert</subCommand>
			<params>
				<paymentGroupName>".secureInput($_REQUEST["paymentGroupName"])."</paymentGroupName>
				<paymentGroupCurrencyID>".secureInput($_REQUEST["paymentGroupCurrencyID"])."</paymentGroupCurrencyID>
				".$addGateway."
			</params>
		</mbapi>";
		$data = dispatchMBAPI($query, 1);

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			

			if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
				redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
			} else {
				redirect("paymentgroups.php", getActionID("ShowPaymentGroups"));
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddPaymentgroupResponse
?>