<?php
// $Id: ChargeVirtualTerminal.php,v 1.1 2006/07/03 22:31:30 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all paymentGroups that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class ChargeVirtualTerminal extends MB_Action {
	/**
	 * This class gets the info for and displays the page where you put in info to charge
	 * a credit card.
	 */
	function ChargeVirtualTerminal() {
		parent::MB_Action();
		$this->stringRep = "ShowVirtualTerminals";
		
		$this->params = array(
			"paymentGroupID",
			"paymentGroupName",
			"paymentGroupCurrencyID");
		$this->sortColumns = array("paymentGroupID", "paymentGroupName", "paymentGroupCurrencyID");
	}

	/**
	 * The main method of this class that executes the ShowPaymentGroups action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->smartyVars = array();
		$this->smartyVars["doaccounting"] = (int)$_REQUEST["doaccounting"];
		loadConfigs("payment");

		$paymentGroups = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPaymentGroups",
				"params" => array(
				),
			),
		)));
		$this->smartyVars["gatewayInfo"] = array();
		foreach ((array)$paymentGroups as $pg){
			foreach ((array)$pg["gateways"] as $gw){
				if ($gw["configGroupID"]==(int)$_REQUEST["gateway"]){
					$this->smartyVars["gatewayInfo"] = $gw;
					$this->smartyVars["currencyID"] = $pg["paymentGroupCurrencyID"];
				}
			}
		}

		//$this->smartyVars["cardTypes"] = getTypes("card");
		$this->smartyVars["cardTypes"] = $this->getAcceptedCardTypesByID($this->smartyVars["gatewayInfo"]["configGroupID"]);
		$this->smartyVars["accepteCheck"] = $this->getGatewayeCheckByID($this->smartyVars["gatewayInfo"]["configGroupID"]);

		$this->smartyVars["billingCardExpYear"] = array();
		for ($i=date("Y"); $i<date("Y")+21; $i++){
			$this->smartyVars["billingCardExpYear"][$i] = $i;
		}
		$this->smartyVars["billingCardExpMonth"] = array();
		for ($i=1; $i<13; $i++){
			$this->smartyVars["billingCardExpMonth"][$i] = $i;
		}
		$this->smartyVars["accounttypes"] = getTypes("bankAccount");

		$this->smartyVars["invoiceInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetInvoices",
				"params" => array(
					"invoiceID" => (int)$_REQUEST["invoiceID"],
					"getInvoiceLineItemsData" => 1,
					"getInvoiceLineItemsPaymentsData" => 1,
					"getTaxZonesData" => 1,
				),
			),
		)));
		$this->smartyVars["invoiceInfo"]["amountDue"] = $this->smartyVars["invoiceInfo"]["invoiceAmount"]-$this->smartyVars["invoiceInfo"]["invoiceAmountPaid"];
		if ($this->smartyVars["invoiceInfo"]["lineItems"]){
			$this->smartyVars["clientInfo"] =& $this->smartyVars["invoiceInfo"]["lineItems"][0];
		}

		$this->smartyVars["gatewayInfo"]["parentName"] = $this->getGatewayParentNameByID($this->smartyVars["gatewayInfo"]["configGroupID"]);

		foreach ((array)$_REQUEST["lineItemPayments"] as $k=>$pm){
			$_REQUEST["lineItemPayments"][$k] = $this->getNumberFromInput($pm);
		}

		$this->smartyVars["formValues"] = array(
			"invoiceID" => (int)$_REQUEST["invoiceID"],
			"gateway" => (int)$_REQUEST["gateway"],
			"paymentAmount" => $this->getNumberFromInput($_REQUEST["paymentAmount"]),
			"paymentComments" => $_REQUEST["paymentComments"],
			"paymentMethod" => ($_REQUEST["paymentMethod"]!="echeck")?"card":"echeck",
			"billingCardNameOnCard" => ($_REQUEST["billingCardNameOnCard"])?$_REQUEST["billingCardNameOnCard"]:($this->smartyVars["clientInfo"]["clientID"])?$this->smartyVars["clientInfo"]["contactFirstname"]." ".$this->smartyVars["clientInfo"]["contactLastname"]:"",
			"billingCardType" => (int)$_REQUEST["billingCardType"],
			"billingCardNum" => $_REQUEST["billingCardNum"],
			"billingCardExpMonth" => (int)$_REQUEST["billingCardExpMonth"],
			"billingCardExpYear" => (int)$_REQUEST["billingCardExpYear"],
			"cardCVV2" => $_REQUEST["cardCVV2"],
			"billingBankName" => $_REQUEST["billingBankName"],
			"billingBankState" => $_REQUEST["billingBankState"],
			"billingBankType" => $_REQUEST["billingBankType"],
			"billingBankAbaCode" => $_REQUEST["billingBankAbaCode"],
			"billingBankAccountNum" => $_REQUEST["billingBankAccountNum"],
			"billingBankLicenseNum" => $_REQUEST["billingBankLicenseNum"],
			"billingBankLicenseState" => $_REQUEST["billingBankLicenseState"],
			"billingBankDob" => $_REQUEST["billingBankDob"],
			"applyPaymentTo" => ($_REQUEST["applyPaymentsTo"]!="lineitems")?"invoice":"lineitems",
			"lineItemPayments" => $_REQUEST["lineItemPayments"],
			"paymentComments" => $_REQUEST["paymentComments"],
			"contactFirstName" => ($_REQUEST["contactFirstName"])?$_REQUEST["contactFirstName"]:$this->smartyVars["clientInfo"]["contactFirstName"],
		);

		$contactFields = array("contactFirstName", "contactLastName", "contactAddress", "contactCity", "contactState", "contactZip", "contactPhone", "contactFax");
		foreach ($contactFields as $field){
			$this->smartyVars["formValues"][$field] = ($_REQUEST[$field])?$_REQUEST[$field]:$this->smartyVars["clientInfo"][$field];
		}

		$this->addTemplate("modules/ChargeVirtualTerminal", $this->smartyVars, 1);
			
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ChargeVirtualTerminal
?>