<?php
// $Id: ChargeVirtualTerminalResponse.php,v 1.2 2006/07/05 17:49:53 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-tk/include/creditcard/validate.php");
require_once mb_path("/lib-modernbill/include/accounting/General.php");
require_once mb_path("/lib-modernbill/include/accounting/Payment.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-mbapi/include/modules/gateway/gateway.php");

/**
 * This Action object collects information on all paymentGroups that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class ChargeVirtualTerminalResponse extends MB_Action {
	/**
	 * This class gets the info for and displays the page where you put in info to charge
	 * a credit card.
	 */
	function ChargeVirtualTerminalResponse() {
		parent::MB_Action();
		$this->stringRep = "ChargeVirtualTerminalResponse";
		
		$this->params = array(
			"paymentGroupID",
			"paymentGroupName",
			"paymentGroupCurrencyID");
		$this->sortColumns = array("paymentGroupID", "paymentGroupName", "paymentGroupCurrencyID");
	}

	/**
	 * The main method of this class that executes the ChargeVirtualTerminalResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		loadConfigs("payment");

		$this->smartyVars = array();
		$this->smartyVars["formValues"] = $_REQUEST;

		$paymentGroups = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPaymentGroups",
				"params" => array(
				),
			),
		)));
		$this->smartyVars["gatewayInfo"] = array();
		foreach ((array)$paymentGroups as $pg){
			foreach ((array)$pg["gateways"] as $gw){
				if ($gw["configGroupID"]==(int)$_REQUEST["gateway"]){
					$this->smartyVars["gatewayInfo"] = $gw;
					$this->smartyVars["currencyID"] = $pg["paymentGroupCurrencyID"];
				}
			}
		}

		//$this->smartyVars["cardTypes"] = getTypes("card");
		$this->smartyVars["cardTypes"] = $this->getAcceptedCardTypesByID($this->smartyVars["gatewayInfo"]["configGroupID"]);
		$this->smartyVars["accepteCheck"] = $this->getGatewayeCheckByID($this->smartyVars["gatewayInfo"]["configGroupID"]);

		$this->smartyVars["billingCardExpYear"] = array();
		for ($i=date("Y"); $i<date("Y")+21; $i++){
			$this->smartyVars["billingCardExpYear"][$i] = $i;
		}
		$this->smartyVars["billingCardExpMonth"] = array();
		for ($i=1; $i<13; $i++){
			$this->smartyVars["billingCardExpMonth"][$i] = $i;
		}
		$this->smartyVars["accounttypes"] = getTypes("bankAccount");

		$this->smartyVars["invoiceInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetInvoices",
				"params" => array(
					"invoiceID" => (int)$_REQUEST["invoiceID"],
					"getInvoiceLineItemsData" => 1,
					"getInvoiceLineItemsPaymentsData" => 1,
					"getTaxZonesData" => 1,
				),
			),
		)));
		$this->smartyVars["invoiceInfo"]["amountDue"] = $this->smartyVars["invoiceInfo"]["invoiceAmount"]-$this->smartyVars["invoiceInfo"]["invoiceAmountPaid"];
		if ($this->smartyVars["invoiceInfo"]["lineItems"]){
			$this->smartyVars["clientInfo"] =& $this->smartyVars["invoiceInfo"]["lineItems"][0];
		}

		$this->smartyVars["gatewayInfo"]["parentName"] = $this->getGatewayParentNameByID($this->smartyVars["gatewayInfo"]["configGroupID"]);

		dbg($this->smartyVars["gatewayInfo"]);

		foreach ((array)$_REQUEST["lineItemPayments"] as $k=>$pm){
			$_REQUEST["lineItemPayments"][$k] = $this->getNumberFromInput($pm);
		}


		do {

			if ((int)$_REQUEST["invoiceID"]){
				if ($_REQUEST["applyPaymentTo"]=="lineitems"){
					$chargeAmount = 0;
					foreach ((array)$_REQUEST["lineItemPayments"] as $pymt){
						$chargeAmount += $this->getNumberFromInput($pymt);
					}
				} else {
					$chargeAmount = $this->getNumberFromInput($_REQUEST["paymentAmount"]);
				}
			} else {
				$chargeAmount = $this->getNumberFromInput($_REQUEST["paymentAmount"]);
			}


			if ($_REQUEST["paymentMethod"]=="card"){
				$c =& new CreditCard($_REQUEST["billingCardNum"], array());
				if (!$c->isValid()){
					$this->smartyVars["errorMessage"] = TRANS_INVALID_CREDIT_CARD_NUMBER;
					break;
				}
			} else {
				if ($_REQUEST["billingBankAbaCode"]==""){
					$this->smartyVars["errorMessage"] = TRANS_INVALID_BANK_ROUTING_NUMBER;
					break;
				} elseif ($_REQUEST["billingBankAccountNum"]==""){
					$this->smartyVars["errorMessage"] = TRANS_INVALID_BANK_ACCOUNT_NUMBER;
					break;
				}
			}

			$mergeParams = array(
				"contactFirstName",
				"contactLastName",
				"contactAddress",
				"contactCity",
				"contactState",
				"contactZip",
				"contactPhone",
				"contactFax",
				"billingCardNameOnCard",
				"billingCardType",
				"billingCardNum",
				"billingCardExpMonth",
				"billingCardExpYear",
				"billingBankName",
				"billingBankState",
				"billingBankType",
				"billingBankAbaCode",
				"billingBankAccountNum",
				"billingBankLicenseNum",
				"billingBankLicenseState",
				"billingBankDob",
			);

			$gatewayParams = array();
			foreach ($mergeParams as $param){
				$gatewayParams[$param] = $_REQUEST[$param];
			}

			$chargeCommand = array(
				"mbapi" => array(
					"command" => "ProcessGateway",
					"params" => array(
						"gateway" => array(
							$this->smartyVars["gatewayInfo"]["parentName"] => array(
								"configGroupName" => $this->smartyVars["gatewayInfo"]["configGroupName"],
								"subCommand" => "charge",
								"paymentDescription" => $_REQUEST["paymentComments"],
								"paymentAmount" => $chargeAmount,
								"paymentMethod" => ($_REQUEST["paymentMethod"]!="card")?"ECHECK":"CC",
								"cardNum" => $_REQUEST["billingCardNum"],
								"cardCVV2" => $_REQUEST["cardCVV2"],
							) + $gatewayParams,
						),
					),
				),
			);

			$chargeResults = dispatchMBAPI(toXML($chargeCommand), 1);
			dbg($chargeResults);
			if ($chargeResults["mbapi"][0]["results"] && $chargeResults["mbapi"][0]["results"][0]["gatewayReturn"]){
				$chargeResults = correctArray($chargeResults["mbapi"][0]["results"][0]["gatewayReturn"][0]);
				if ($chargeResults["status"]==GATEWAY_SUCCESS){
					$this->smartyVars["transaction"] = $chargeResults;
					$this->smartyVars["transactionAmount"] = $chargeAmount;
					$success = 1;


					if ((int)$_REQUEST["invoiceID"]){ // we have an invoice, lets apply it.

/*********************************************************************/
/********************* begin applying payment ************************/

						$invoiceID = ((int) $_REQUEST["invoiceID"]);
						$applyPaymentTo = secureInput($_REQUEST["applyPaymentTo"]);
						$lineItemPayments = $_REQUEST["lineItemPayments"];
						$paymentComments = $chargeResults["message"];
						$transactionCode = $chargeResults["transactionCode"];
				
						$paymentAmount = $chargeAmount;
						$transactionAmount = $paymentAmount;
						$authReturn = 200;
						$authReturn = 1;
						$paymentMethod = ($_REQUEST["paymentMethod"]=="card")?getAPITypeID("payments", "ccsingle"):getAPITypeID("payments", "echeck");
				
						$invoiceXML = "
							<mbapi>
								<command>GetInvoices</command>
								<params>
									<invoiceID>$invoiceID</invoiceID>
									<getInvoiceLineItemsData>1</getInvoiceLineItemsData>
									<getInvoiceLineItemsPaymentsData>1</getInvoiceLineItemsPaymentsData>
								</params>
							</mbapi>
						";
				
						$this->invoiceInfo = dispatchMBAPI($invoiceXML, 1);
				
						$this->invoiceInfo = $this->invoiceInfo["mbapi"][0]["results"][0]["invoices"][0]["invoice"][0];
						$this->lineItems = correctArray($this->invoiceInfo["lineItems"][0]["lineItem"]);
						$this->invoiceInfo = correctArray($this->invoiceInfo);
						$clientID = $this->lineItems[0]["clientID"];

						foreach ($this->lineItems as $k=>$v){
							$this->lineItems[$k]["lineItemAmountDue"] = $v["lineItemTotalAmount"]-$v["lineItemPaymentAmount"];
						}

						if ($applyPaymentTo!="invoice"){
							// apply the amounts listed to the line items in the requested manner
							// keep track of overages so we can distribute them in order
							$overage = 0;
							foreach ($this->lineItems as $k=>$v){
								if ($lineItemPayments[$v["lineItemID"]]>$v["lineItemAmountDue"]){
									$overage += $lineItemPayments[$v["lineItemID"]]-$v["lineItemAmountDue"];
									$this->lineItems[$k]["lineItemApplyAmount"] = $v["lineItemAmountDue"];
								} else {
									$this->lineItems[$k]["lineItemApplyAmount"] = $lineItemPayments[$v["lineItemID"]];
								}
							}
						} else { // end applying specific payments to line items
							$overage = $paymentAmount;
						}
			
						// apply the overage, or just the amount they listed, to line items in order.
						foreach ($this->lineItems as $k=>$v){
							if ($overage>0){
								if ($v["lineItemApplyAmount"]<$v["lineItemAmountDue"]){
									$diff = $v["lineItemAmountDue"]-$v["lineItemApplyAmount"];
									if ($overage<$diff){
										$diff = $overage;
										$overage = 0;
									} else {
										$overage -= $diff;
									}
									$this->lineItems[$k]["lineItemApplyAmount"] += $diff;
								}
							} else {
								break;
							}
						}
			
						if ($overage>0){
							$credit = round($overage, 3);
						}

						$amount = 0;
						$paidtotal = 0;
						foreach ($this->lineItems as $k=>$v){
							$amount += $v["lineItemApplyAmount"];
							$paidtotal += $v["lineItemApplyAmount"]+$v["lineItemPaymentAmount"];
						}
						if ($subaction=="applycredit"){
							$transactionAmount = $amount;
						}

						///////////// create the transaction
						$transXML = "
									<mbapi>
									<command>SetTransaction</command>
									<subCommand>insert</subCommand>
									<params>
										<transactionPaymentMethod>".$paymentMethod."</transactionPaymentMethod>
										<authReturn>".$authReturn."</authReturn>
										<transactionCode>".$transactionCode."</transactionCode>
										<transactionNotes>".$paymentComments."</transactionNotes>
										<transactionDateCreated>".time()."</transactionDateCreated>
										<authCode></authCode>
										<avsCode></avsCode>
										<transactionAmount>".$transactionAmount."</transactionAmount>
										<currencyID>".$this->invoiceInfo["currencyID"]."</currencyID>
										<configGroupID>0</configGroupID>
										<billingAccountID>0</billingAccountID>
										<invoiceIDs>
											<invoiceID>".$invoiceID."</invoiceID>
										</invoiceIDs>
									</params>
									</mbapi>";
				
						$transResponse = dispatchMBAPI($transXML, 1);
						$transactionID = $transResponse["mbapi"][0]["header"][0]["lastInsertID"][0];
				
						foreach ($this->lineItems as $k=>$v){
							if ($v["lineItemApplyAmount"]>0){
								$successRelXML = "
										<mbapi>
											<command>SetTransactionSuccessRel</command>
											<subCommand>insert</subCommand>
											<params>
												<transactionID>$transactionID</transactionID>
												<billingAccountShareID>0</billingAccountShareID>
												<lineItemID>".$v["lineItemID"]."</lineItemID>
												<lineItemPaymentAmount>".$v["lineItemApplyAmount"]."</lineItemPaymentAmount>
											</params>
										</mbapi>
										";
								$successRel = dispatchMBAPI($successRelXML, 1);
							} else {
								$CONF["debug"]->debugMessage("had a blank amount: $transactionID");
							}
						}

						$updateXML = "
									<mbapi>
										<command>SetInvoices</command>
										<subCommand>update</subCommand>
										<showXMLHeader>0</showXMLHeader>
										<params>
										<invoiceID>".$invoiceID."</invoiceID>
										<invoiceAmountPaid>".$paidtotal."</invoiceAmountPaid>
										<invoiceDatePaid>".time()."</invoiceDatePaid>
									".((doubleval($paidtotal)==doubleval($this->invoiceInfo["invoiceAmount"]))?"<invoiceStatus>1</invoiceStatus>":"")."
										</params>
									</mbapi>";
						$updateResponse = dispatchMBAPI($updateXML, 1);


						$receipt =& new Payment();
						$receipt->setClientID($clientID);
						$receipt->setInvoiceID($invoiceID);
						$receipt->setTransactionID($transactionID);
						$receipt->setDescription(TRANS_MANUAL_PAYMENT_FOR_INVOICE.": ".@constant(getTypeName("payment", $paymentMethod)));
						$receipt->setPaymentAmount($amount+$credit);
						if ($credit>0){
							$receipt->setClientCreditAmount($credit);
						}
						$receipt->setCurrencyID($this->invoiceInfo["currencyID"]);
						$receipt->execute();


/*********************************************************************/
/********************* end applying payment **************************/


					} elseif ((int)$_REQUEST["doaccounting"]){ // make income entry
						$entries = array();
						$entry = array();
						$entry["ledgerAccountID"] = getGeneralLedgerAccountID("cash");
						$entry["generalLedgerDescription"] = $_REQUEST["paymentComments"];
						$entry["generalLedgerDebitAmount"] = $chargeAmount;
						$entry["generalLedgerCreditAmount"] = 0;
						$entry["invoiceID"] = 0;
						$entry["clientID"] = 0;
						$entries[] = $entry;

						$entry = array();
						$entry["ledgerAccountID"] = getGeneralLedgerAccountID("revenue");
						$entry["generalLedgerDescription"] = $_REQUEST["paymentComments"];
						$entry["generalLedgerDebitAmount"] = 0;
						$entry["generalLedgerCreditAmount"] = $chargeAmount;
						$entry["invoiceID"] = 0;
						$entry["clientID"] = 0;
						$entries[] = $entry;

						$gen =& new General();
						$gen->setClientID(0);
						$gen->setInvoiceID(0);
						$gen->setDescription(TRANS_CHARGED_CARD);
						$gen->setTotalDebits($chargeAmount);
						$gen->setTotalCredits($chargeAmount);
						$gen->setCurrencyID($this->smartyVars["currencyID"]);
						$gen->setLedgerEntries($entries);
						$gen->execute();
					}


				} else {
					$success = 0;
					$this->smartyVars["errorMessage"] = TRANS_GATEWAY_RETURNED_ERROR.": ".$chargeResults["message"];
				}
			} else {
				$success = 0;
				$this->smartyVars["errorMessage"] = TRANS_GATEWAY_ERROR;
			}

		} while (false);

		if (!(int)$success){
			$this->addTemplate("modules/ChargeVirtualTerminal", $this->smartyVars, 1);
		} else {
			if ((int)$_REQUEST["invoiceID"]){
				redirect("invoices.php?action=".getActionID("ShowInvoiceDetails")."&sid=".$_REQUEST["sid"]."&invoiceID=".$_REQUEST["invoiceID"]);
			} else {
			$this->addTemplate("modules/ChargeVirtualTerminalResponse", $this->smartyVars, 1);
			}
		}
			
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ChargeVirtualTerminalResponse
?>