<?php
// $Id: ShowVirtualTerminals.php,v 1.1 2006/07/03 22:31:30 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all paymentGroups that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class ShowVirtualTerminals extends MB_Action {
	/**
	 * The constructor for a ShowVirtualTerminals action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowVirtualTerminals() {
		parent::MB_Action();
		$this->stringRep = "ShowVirtualTerminals";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the ShowPaymentGroups action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

        $this->smartyVars = array();

		$this->smartyVars["paymentGroups"] = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPaymentGroups",
				"params" => array(
					
				),
			),
		)));

		$this->smartyVars["invoiceInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetInvoices",
				"params" => array(
					"invoiceID" => (int)$_REQUEST["invoiceID"],
					"getInvoiceLineItemsData" => 1,
					"getInvoiceLineItemsPaymentsData" => 1,
					"getTaxZonesData" => 1,
				),
			),
		)));
		if ($this->smartyVars["invoiceInfo"]["lineItems"]){
			$this->smartyVars["clientInfo"] =& $this->smartyVars["invoiceInfo"]["lineItems"][0];
		}

		$this->addTemplate("modules/ShowVirtualTerminals", $this->smartyVars, 1);
			
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowVirtualTerminals
?>