<?php
// $Id: CaptureFunds.php,v 1.5 2006/07/25 17:38:05 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all paymentqueue that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class CaptureFunds extends MB_Action {
	/**
	 * The constructor for a CaptureFunds action object.
	 */
	function CaptureFunds() {
		parent::MB_Action();
		$this->stringRep = "CaptureFunds";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the ShowUncapturedFunds action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		loadConfigs("system", "encryption");

		$failedTransactions = array();

		if ($CONF["system"]["encryption"]["lek_pin"]!=''){
			$key = $CONF["system"]["encryption"]["lek_pin"];
		} else {
			$results = dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "GetEncryptedText",
					"params" => array(
						"text" => $_REQUEST["key"],
					),
				),
			)), 1);
			$key = ($results["mbapi"] && $results["mbapi"][0] && $results["mbapi"][0]["results"] && $results["mbapi"][0]["results"][0] && $results["mbapi"][0]["results"][0]["text"])?$results["mbapi"][0]["results"][0]["text"][0]:"";
		}


		$captureQuery = "		<mbapi>
									<command>ProcessCaptureFunds</command>
									<params>
										<key>$key</key>
										<transactionID>TID</transactionID>
									</params>
								</mbapi>";

		$transactions = $_REQUEST['captureIDs'];
		foreach ($transactions as $tid=>$v){
			if ($v=='y'){
				$query = str_replace("TID", $tid, $captureQuery);
				$results = dispatchMBAPI($query, 1);
				dbg($results);
				$result = $results["mbapi"][0]["results"][0]["result"][0];
				if ($result=="failure"){
					$failedTransactions[] = $tid;
				}
			}
		}

		if ((int)$_REQUEST["invoiceID"]){
	            redirect("invoices.php?action=".getActionID("ShowInvoiceDetails")."&invoiceID=".((int)$_REQUEST["invoiceID"])."&failedID=".$failedTransactions[0]."&sid=".secureInput($_REQUEST["sid"]));
		} else {
	        if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
	            redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
	        } else {
	            redirect("paymentqueue.php?action=".getActionID("ShowUncapturedFunds")."&failedID[]=".@implode("&failedID[]=", $failedTransactions)."&sid=".secureInput($_REQUEST["sid"]));
	        }
		}


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // CaptureFunds
?>