<?php
// $Id: EditPaymentQueue.php,v 1.9 2006/03/22 20:41:10 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on a payment so that that the payment may be modified in the
 * database.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class EditPaymentQueue extends MB_Action {
	/**
	 * The constructor for a EditPaymentQueue action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditPaymentQueue() {
		parent::MB_Action();
		$this->stringRep = "EditPaymentQueue";
		$this->params = array("paymentID");
	}

	/**
	 * The main method of this class that executes the EditPaymentQueue action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$paymentID = ((int) $_REQUEST["paymentID"]);
		if(!$paymentID) {
			$this->addError(TRANS_ACTIONERROR, "No payment ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetPaymentQueue", "", array());
			$data = dispatchMBAPI($query, 1);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$s = array();
				$s["payment"] = collapseArrayElements($data["mbapi"][0]["results"][0]["paymentqueue"][0]["payment"][0]);
				$this->addTemplate("paymentes/EditPaymentQueue", $s);
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditPaymentQueue
?>