<?php
// $Id: GeneratePaymentQueueResponse.php,v 1.11 2006/07/25 17:38:05 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the RemovePaymentQueue action, and removes the specified paymentqueue. *
 * @author  getActionFiles.php (Automatically Generated)
 */
class GeneratePaymentQueueResponse extends MB_Action {
	/**
	 * The constructor for a GeneratePaymentQueueResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function GeneratePaymentQueueResponse() {
		parent::MB_Action();
		$this->stringRep = "GeneratePaymentQueueResponse";
	}

	/**
	 * The main method of this class that executes the RemovePaymentQueueResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
        if (checkdate($_REQUEST["dueDateMonth"],$_REQUEST["dueDateDay"],$_REQUEST["dueDateYear"])) {
            if (intval($_REQUEST["dueDateHour"]) <= 23) {
                $dueDateHour = (int) $_REQUEST["dueDateHour"];
            } else {
                $dueDateHour = date("h");
            }
            if (intval($_REQUEST["dueDateMinute"]) <= 59) {
                $dueDateMinute = (int) $_REQUEST["dueDateMinute"];
            } else {
                $dueDateMinute = date("i");
            }
            $dueDate = mktime($dueDateHour,$dueDateMinute,0,$_REQUEST["dueDateMonth"],$_REQUEST["dueDateDay"],$_REQUEST["dueDateYear"]);
        } else {
            $dueDate = mktime();
        }


        if (checkdate($_REQUEST["laterDateMonth"],$_REQUEST["laterDateDay"],$_REQUEST["laterDateYear"]) && (int) $_REQUEST["runWhen"]==2) {
            if (intval($_REQUEST["laterDateHour"]) <= 23) {
                $laterDateHour = (int) $_REQUEST["laterDateHour"];
            } else {
                $laterDateHour = date("h");
            }
            if (intval($_REQUEST["laterDateMinute"]) <= 59) {
                $laterDateMinute = (int) $_REQUEST["laterDateMinute"];
            } else {
                $laterDateMinute = date("i");
            }
            $laterDate = mktime($laterDateHour,$laterDateMinute,0,$_REQUEST["laterDateMonth"],$_REQUEST["laterDateDay"],$_REQUEST["laterDateYear"]);
        } elseif ((int) $_REQUEST["runWhen"]==1) {
            $laterDate = mktime();
        }

        $xmlCmd = "<mbapi>\n";
        $xmlCmd .= "    <command>ProcessPaymentQueue</command>\n";
        $xmlCmd .= "    <params>\n";

        $xmlCmd .= "        <clearPaymentQueue>".(((int)$_REQUEST["clearPaymentQueue"]>0)?1:0)."</clearPaymentQueue>\n";
        if (in_array("new", $_REQUEST["generate"])){
            $xmlCmd .= "        <generateNew>1</generateNew>\n";
        }
        if (in_array("declined", $_REQUEST["generate"])){
            $xmlCmd .= "        <generateDeclined>1</generateDeclined>\n";
        }
        if (in_array("error", $_REQUEST["generate"])){
            $xmlCmd .= "        <generateError>1</generateError>\n";
        }

        $xmlCmd .= "        <generateDueDateOnly>".(((int)$_REQUEST["generateDueDateOnly"]>0)?1:0)."</generateDueDateOnly>\n";
        $xmlCmd .= "        <dueDateTimestamp>$dueDate</dueDateTimestamp>\n";
        $xmlCmd .= "        <numInvoicesToQueue>".( (int)$_REQUEST["numInvoicesToQueue"] )."</numInvoicesToQueue>\n";


        $xmlCmd .= "    </params>\n";
        $xmlCmd .= "</mbapi>\n";

        $generateReturn = dispatchMBAPI($xmlCmd, 1);

        if ( is_array($generateReturn["mbapi"][0]["results"][0]["successfulCharges"]) && count($generateReturn["mbapi"][0]["results"][0]["successfulCharges"][0]["currencies"]) > 0 ){
            $this->smartyVars["currencies"] = array();
            foreach ($generateReturn["mbapi"][0]["results"][0]["successfulCharges"][0]["currencies"] as $data){
                $this->smartyVars["currencies"][] = array("id"=>$data["paymentCurrency"][0], "number"=>$data["paymentQueueCount"][0], "amount"=>$data["paymentQueueAmount"][0]);
            }
        }


//        if ( !(int) $generateReturn["mbapi"][0]["header"][0]["success"][0] ){

//        }

		if ($_REQUEST["encryptionKey"]){
			$results = dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "GetEncryptedText",
					"params" => array(
						"text" => stripslashes($_REQUEST["encryptionKey"]),
					),
				),
			)), 1);
			$_REQUEST["encryptionKey"] = ($results["mbapi"] && $results["mbapi"][0] && $results["mbapi"][0]["results"] && $results["mbapi"][0]["results"][0] && $results["mbapi"][0]["results"][0]["text"])?$results["mbapi"][0]["results"][0]["text"][0]:"";
		}


        if ( ($CONF["system"]["internal"]["systemQueueCommand"] != "ProcessPaymentQueue" || !$CONF["system"]["internal"]["systemQueueRunning"])
                && (int) $_REQUEST["runWhen"] ){
            // its not running our process, so lets put it in the system queue, get the id, then run it and
            // redirect to the page that displays the progress.
            $processQueueXML = "<mbapi>
            <command>ProcessPaymentQueue</command>
            <params>
                <runPaymentQueue>1</runPaymentQueue>
                <transactionAction>".secureInput($_REQUEST["transactionAction"])."</transactionAction>
                <key>".$_REQUEST["encryptionKey"]."</key>
                <chargeLesserAmounts>".(((int)$_REQUEST["chargeLesserAmounts"]>0)?1:0)."</chargeLesserAmounts>
            </params>
        </mbapi>"; // run everything in the queue with a date charged of 0

/////////////////////
            $dateToRun = $laterDate;
            $timeData = explode(";", date("i;G;j;n;Y", $dateToRun));
            $cmdArgs = array
            (
                "systemQueueCommand" => "ProcessPaymentQueue",
                "systemQueueCommandInput" => htmlentities($processQueueXML),
                "systemQueueMinute" => $timeData[0],
                "systemQueueHour" => $timeData[1],
                "systemQueueDay" => $timeData[2],
                "systemQueueMonth" => $timeData[3],
                "systemQueueYear" => $timeData[4],
                "systemQueueIsRecurring" => 0,
                "systemQueueDateCreated" => mktime(),
                "systemQueueDateToRun" => $dateToRun,
                "systemQueueDateStarted" => 0,
                "systemQueueDateFinished" => 0
            );
            $query = $this->getMBAPIQuery("SetSystemQueue", "insert", $cmdArgs);
            $CONF["debug"]->add("GenerateInvoiceEvents::execute SetSystemQueue-Query", htmlentities($query), __FILE__, __LINE__);
            $data = dispatchMBAPI($query, 1);
            $CONF["debug"]->add("GenerateInvoiceEvents::execute SetSystemQueue-Result", $data, __FILE__, __LINE__);

            $this->smartyVars["systemQueueID"] = $data["mbapi"][0]["header"][0]["lastInsertID"][0];

/////////////////////

        }



        $this->addTemplate("paymentqueue/GeneratePaymentQueueResponse", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemovePaymentQueueResponse
?>