<?php
// $Id: RunPaymentQueue.php,v 1.8 2006/03/22 20:41:10 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object displays the run payment queue page with the status iframe in it
 *
 * @author  Kris Bailey
 */
class RunPaymentQueue extends MB_Action {
	/**
	 * The constructor for a RunPaymentQueue action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function RunPaymentQueue() {
		parent::MB_Action();
		$this->stringRep = "RunPaymentQueue";

	}

	/**
	 * The main method of this class that executes the RunPaymentQueue action which basically just displays a template
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		loadConfigs("payment");

        $this->smartyVars["hideEventStatusBar"] = 1;
		$this->smartyVars["transactionAction"] = $CONF["payment"]["paymentQueue"]["transactionAction"];
        $this->smartyVars["queueRunTime"] = time();
        $timeData = explode(";", date("i;G;j;n;Y"));


        if ( $CONF["system"]["internal"]["systemQueueCommand"] != "ProcessPaymentQueue" || !$CONF["system"]["internal"]["systemQueueRunning"]){

            $this->addTemplate("paymentqueue/RunPaymentQueue", $this->smartyVars);

        } else {

            $this->smartyVars["showStatus"] = "yes";
            // get anything from the queue
            $getQueueXML = "
    <mbapi>
        <command>GetSystemQueue</command>
        <params>
            <systemQueueID>".$CONF["system"]["internal"]["systemQueueID"]."</systemQueueID>
        </params>
    </mbapi>
            ";
            $queueItem = dispatchMBAPI($getQueueXML, 1);

            $this->smartyVars["queueRunTime"] = $queueItem["mbapi"][0]["results"][0]["systemQueue"][0]["systemQueueEvent"][0]["systemQueueDateToRun"][0];

            $this->addTemplate("paymentqueue/RunPaymentQueueResponse", $this->smartyVars);

        }


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RunPaymentQueue
?>