<?php
// $Id: ShowUncapturedFunds.php,v 1.5 2006/03/22 20:41:10 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all paymentqueue that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class ShowUncapturedFunds extends MB_Action {
	/**
	 * The constructor for a ShowUncapturedFunds action object.
	 */
	function ShowUncapturedFunds() {
		parent::MB_Action();
		$this->stringRep = "ShowUncapturedFunds";

		$this->params = array(
			"transactionID",
			"clientID",
			"billingAccountID");
		$this->sortColumns = array("transaction_date_created");
	}

	/**
	 * The main method of this class that executes the ShowUncapturedFunds action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();


		$this->smartyVars = array("invalidpoint"=>time()-(24*60*60*30));
		if ($CONF["system"]["encryption"]["lek_pin"]==''){
		 	$this->smartyVars["showPassword"] = 1;
		}

		if ($_REQUEST['failedID']){
			$this->smartyVars['failed'] = $_REQUEST['failedID'];
		}

		$transactionsQuery = "	<mbapi>
									<command>GetTransactions</command>
									<params>
										<authReturn>".getAPIStatusID("transactions", "authorized")."</authReturn>
										<getClientNames>1</getClientNames>
										<getGatewayNames>1</getGatewayNames>
									</params>
								</mbapi>";

		$data = dispatchMBAPI($transactionsQuery, 1);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {

		 	$this->smartyVars["transactions"] = collapseArrayElements($results["transactions"][0]["transaction"]);
			if ($this->smartyVars["transactions"]["transactionID"]) {
				$this->smartyVars["transactions"] = array($this->smartyVars["transactions"]);
			}
			$smartyVars["paginationLinks"] = $results["paginationLinks"][0];

			$this->addTemplate("paymentqueue/ShowUncapturedFunds", $this->smartyVars);

		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowUncapturedFunds
?>