<?php
// $Id: AddCouponResponse.php,v 1.9 2006/06/22 15:56:47 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the AddCoupon action, applies that information to
 * records in the database, and redirects to the ShowProductDetails action for the given product.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class AddCouponResponse extends MB_Action {
	/**
	 * The constructor for an AddCouponResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function AddCouponResponse() {
		parent::MB_Action();
		$this->stringRep = "AddCouponResponse";
		$this->params = array(
			"couponCode",
			"couponType",
			"couponDiscount",
			"couponComments",
			"couponActive",
			//"couponDateCreated",
			
			"couponDateStarted",
			
			"couponDateEnded",

			//"couponCount",
			"couponMaxCount",
			"couponNewOnly",
			"couponNumCycles",
		);
	}

	/**
	 * The main method of this class that executes the AddCouponResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$this->setReferralActionID(getActionID("AddCoupon"));
		$this->setReferralActionFile("products.php");
		
		if($_REQUEST['couponType'] === (string) getTypeID("coupon", TRANS_UNIT)) {
			$discountRestriction = INPUT_RESTRICTION_PRICE|INPUT_RESTRICTION_REQUIRED;
		} else if($_REQUEST['couponType'] === (string) getTypeID("coupon", TRANS_PERCENT)) {
			$discountRestriction = INPUT_RESTRICTION_PERCENT2|INPUT_RESTRICTION_REQUIRED;
		} else {
			$discountRestriction = INPUT_RESTRICTION_EMPTY;
		}
		
		$results = $this->getRootFromMBAPI("GetCoupons", "", array("couponCode" => secureInput($_REQUEST['couponCode'])));
		if(isset($results["mbapi"][0]["results"][0]["coupons"][0]["coupon"])) {
			$codeFlags = INPUT_RESTRICTION_UNIQUE|INPUT_RESTRICTION_REQUIRED;
		} else {
			$codeFlags = INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED;
		}
		
		$couponDateStarted = $this->handleDateSelector("couponDateStarted");
		$couponDateEnded = $this->handleDateSelector("couponDateEnded", 0, true);

		$success = $this->validateMultiInputs(
			array(
				"couponCode" => $codeFlags,

				"couponType" => array(INPUT_RESTRICTION_INSET|INPUT_RESTRICTION_REQUIRED, array('set' => $CONF['types']['coupon'])),
				"couponDiscount" => $discountRestriction,

				"couponComments" => INPUT_RESTRICTION_STRING,
				"couponActive" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				//"couponDateCreated" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"couponDateStarted" => INPUT_RESTRICTION_UNSIGNED_INT,
				"couponDateEnded" => INPUT_RESTRICTION_UNSIGNED_INT,
				//"couponCount" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"couponMaxCount" => INPUT_RESTRICTION_UNSIGNED_INT,
				"couponNewOnly" => INPUT_RESTRICTION_BOOL,
				"couponNumCycles" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				
				"couponDateStartedYear" => 0,
				"couponDateStartedMonth" => 0,
				"couponDateStartedDay" => 0,
				"couponDateStartedHours" => 0,
				"couponDateStartedMinutes" => 0,
				"couponDateEndedYear" => 0,
				"couponDateEndedMonth" => 0,
				"couponDateEndedDay" => 0,
				"couponDateEndedHours" => 0,
				"couponDateEndedMinutes" => 0,
				"couponDateEndedChecked" => 0,
			)
		);
		if($_REQUEST['couponPercentDiscount']) {
			unset($_REQUEST['couponUnitDiscount']);
		} else {
			unset($_REQUEST['couponPercentDiscount']);
		}

		if($success) {
			$query = $this->getMBAPIQuery("SetCoupons", "insert",
				array(
					'couponDateCreated' => time(),
					'couponCount' => 0,
					'couponDateStarted' => $couponDateStarted,
					'couponDateEnded' => $couponDateEnded,
				),
				0, 0, 0, 0, 0,
				array(
					"couponDateStartedYear",
					"couponDateStartedMonth",
					"couponDateStartedDay",
					"couponDateStartedHours",
					"couponDateStartedMinutes",
					"couponDateEndedYear",
					"couponDateEndedMonth",
					"couponDateEndedDay",
					"couponDateEndedHours",
					"couponDateEndedMinutes",
					"couponDateEndedChecked",
				)
			);
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			
			dbg($data);
			
			if ($data["mbapi"][0]["header"][0]["lastInsertID"][0]){
				dispatchMBAPI(toXML(array(
					"mbapi" => array(
						"command" => "SetCoupons",
						"subCommand" => "update",
						"params" => array(
							"couponID" => (int)$data["mbapi"][0]["header"][0]["lastInsertID"][0],
							"productIDs" => array(
								"productID" => (array)$_REQUEST["productIDs"],
							),
							"orderFormIDs" => array(
								"orderFormID" => (array)$_REQUEST["orderFormIDs"],
							),
						),
					),
				)),1);
			}
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
				} else {
					redirect("products.php", getActionID("ShowCoupons"), array());
				}
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddCouponResponse
?>
