<?php
// $Id: AddProductAddon.php,v 1.25 2006/08/01 17:58:14 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/app-modernbill-admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/types.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");
require_once mb_path("/lib-action/include/wizard/Wizard.php");

/**
 * This Action object collects information on a product so that that product may be added to the 
 * database.
 *
 * @author  Kris Bailey
 */
class AddProductAddon extends MB_ProductAction {
	/**
	 * The constructor for a AddProductAddon action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function AddProductAddon() {
		parent::MB_ProductAction("children");
		$this->stringRep = "AddProductAddon";
	}

	/**
	 * The main method of this class that executes the AddProductAddon action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		define("WIZARD_ADMIN_ADDON_DISPLAY", 1);

		if (!(int)$_REQUEST["productID"]){
			$this->addError(TRANS_ACTIONERROR, "No Product ID given.");
		} else {

			$this->productInfo = correctArray(grabFirstResultFromMBAPIArray(
				array(
					"mbapi" => array(
						"command" => "GetProducts",
						"params" => array(
							"productID" => (int)$_REQUEST["productID"],
							"getProductAttributeData" => 1,
							"getProductChildData" => 1,
							"getProductVariantPriceData" => 1,
							"getEmailTemplateData" => 1,
							"getEmailActionGroupData" => 1,
							"getCouponData" => 1,
							"getOrderFormData" => 1,
							"getProductVariantData" => 1,
							"getTLDData" => 1,
							"getCycleGhostData" => 1,
							"getServerGroupGhostData" => 1
						)
					)
				)
			));
			$this->smartyVars["product"] =& $this->productInfo;
			$this->setupTypeButtons($this->smartyVars["product"]["productType"]);
			$this->smartyVars["productButtons"] = $this->productButtons->getButtons();

			$this->serverGroups = correctArray(
				grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetServerGroups",
						"params" => array()
					)
				))
			);
			$this->keyedServerGroups = array("0" => array("serverGroupID"=>0,"serverGroupName"=>TRANS_CUSTOM));
			foreach ((array)$this->serverGroups as $k=>$group){
				if ((int)$group["serverGroupID"]){
					$this->keyedServerGroups[$group["serverGroupID"]] =& $this->serverGroups[$k];
				}
			}


			// price and cycle stuff
			$this->smartyVars["priceTypes"] = $CONF["types"]["price"];
			$this->smartyVars["allCycles"] = getCyclesArray();


			// locale currency stuff
			$tmp = explode(";", $CONF["user"]["locale"]->localeArray["locale_pattern_currency"]);
			$tmp[0] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[0]);
			$tmp[1] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[1]);
			$CONF["user"]["locale"]->localeArray["locale_pattern_currency"] = $tmp[0].";".$tmp[1];
 			$this->smartyVars["localeArray"] =  $CONF["user"]["locale"]->localeArray;


			$this->addonSteps =& new ProductButtons();
			$this->addonSteps->setupButtons(array("step1", "step2", "step3", "step4"));

			$this->addonSteps->setName("step1", TRANS_STEP1);
			$this->addonSteps->setEnabled("step1");
			$this->addonSteps->setIcon("step1", "checkslice.gif");
			$this->addonSteps->setLink("step1", "");
			$this->addonSteps->setWidget("step1", "");
			$this->addonSteps->setEnabled("step1", false);

			$this->addonSteps->setName("step2", TRANS_STEP2);
			$this->addonSteps->setEnabled("step2");
			$this->addonSteps->setIcon("step2", "checkslice.gif");
			$this->addonSteps->setLink("step2", "");
			$this->addonSteps->setWidget("step2", "");
			$this->addonSteps->setEnabled("step2", false);

			$this->addonSteps->setName("step3", TRANS_STEP3);
			$this->addonSteps->setEnabled("step3");
			$this->addonSteps->setIcon("step3", "checkslice.gif");
			$this->addonSteps->setLink("step3", "");
			$this->addonSteps->setWidget("step3", "");
			$this->addonSteps->setEnabled("step3", false);

			$this->addonSteps->setName("step4", TRANS_STEP4);
			$this->addonSteps->setEnabled("step4");
			$this->addonSteps->setIcon("step4", "checkslice.gif");
			$this->addonSteps->setLink("step4", "");
			$this->addonSteps->setWidget("step4", "");
			$this->addonSteps->setEnabled("step4", false);



			switch ((int)$_REQUEST["step"]){

				// step one, we need to get all the addon groups and display them, as well
				// as ask how many options they want
				default:
				case 1:

					$this->addonSteps->setEnabled("step1");
					$this->addonSteps->setSelected("step1");

					$this->smartyVars["step"] = 1;
					$this->smartyVars["selectedGroup"] = (int)$_REQUEST["addonGroupID"];
					$this->smartyVars["addonGroups"] = correctArray(grabResultsFromMBAPIArray(array(
						"mbapi" => array(
							"command" => "GetProductAddonGroups",
							"params" => array(
								"getGroupsByProductID" => (int)$_REQUEST["productID"]
							)
						)
					)));
					$this->smartyVars["chooseGroups"][0] = TRANS_NEW_ADDON;
					$groups = grabHTMLOpsFromArray($this->smartyVars["addonGroups"], "productAddonGroupID", "productAddonGroupName");
					if (count($groups)){
						$this->smartyVars["chooseGroups"] += $groups;
					}

					$this->smartyVars["invalidQuestions"] = "invalid";
					$sgarray = array("serverGroupID"=>0) + (array)$this->productInfo["ghostServerGroups"];
					foreach ($sgarray as $sg){
						$rawAttributes = $this->getAttributesForServerGroupID($sg["serverGroupID"], NULL, true);
						dbg($rawAttributes);
						if (is_array($rawAttributes)){
							$attributes = array();
							foreach ((array)$rawAttributes as $k=>$v){
								if (!$attributes[$v]){
									$this->smartyVars["invalidQuestions"] = "valid";
									$this->smartyVars["chooseAttributes"][$sg["serverGroupID"]."|".$k] = $sg["serverGroupName"]." >> ".$v;
									$attributes[$v] = 1;
								}
							}
						}
					}

				break;

				case 2:

					$this->addonSteps->setEnabled("step1");
					$this->addonSteps->setEnabled("step2");
					$this->addonSteps->setSelected("step2");

					$this->smartyVars["step"] = 2;
					
					$info = explode("|", $_REQUEST["attributeID"]);
					
					$panelAttributes = $this->getAttributesForServerGroupID($info[0], NULL);

					if ($panelAttributes===false){
					} else {

						dbg("attributes data");
						dbg($panelAttributes[$info[1]]);

						$question =& $panelAttributes[$info[1]]["question"];

						$panelStep =& new WizardStep("", "");
						$panelStep->setID($info[0]);
						$panelStep->addQuestion($question);

						$this->smartyVars["questionHTML"] = $panelStep->display(false, true);

						$this->smartyVars["choices"] = array();
						for ($i=0;$i<(int)$_REQUEST["numAddons"]; $i++){
							$this->smartyVars["choices"][] = array("num"=>$i,"question"=>str_replace("{ID}", $i, $this->smartyVars["questionHTML"]));
						}

						$this->smartyVars["addonGroupID"] = (int)$_REQUEST["addonGroupID"];
						$this->smartyVars["attributeID"] = $_REQUEST["attributeID"];
						$this->smartyVars["newGroupLabel"] = $_REQUEST["newGroupLabel"];
						$this->smartyVars["newGroupDisplayType"] = $_REQUEST["newGroupDisplayType"];
						$this->smartyVars["numAddons"] = (int)$_REQUEST["numAddons"];

					}

				break;

				case 3:

					$this->addonSteps->setEnabled("step1");
					$this->addonSteps->setEnabled("step2");
					$this->addonSteps->setEnabled("step3");
					$this->addonSteps->setSelected("step3");

					$this->smartyVars["step"] = 3;
					
					$variantID = $this->productInfo["productVariants"][0]["productVariantID"];
					
					$this->smartyVars["addonGroupID"] = (int)$_REQUEST["addonGroupID"];
					$this->smartyVars["attributeID"] = $_REQUEST["attributeID"];
					$this->smartyVars["newGroupLabel"] = $_REQUEST["newGroupLabel"];
					$this->smartyVars["newGroupDisplayType"] = $_REQUEST["newGroupDisplayType"];
					$this->smartyVars["numAddons"] = (int)$_REQUEST["numAddons"];
					$this->smartyVars["addonNames"] = $_REQUEST["addonNames"];
					$this->smartyVars["addonValues"] = array();
					foreach ((array)$_REQUEST["addonValues"] as $value){
						$this->smartyVars["addonValues"][] = base64_encode(serialize($value));
					}

					foreach ((array)$this->productInfo["ghostCycles"] as $cycle){
						$cycles[] = $cycle["cycleID"];
					}
					foreach ((array)$this->productInfo["orderForms"] as $of){
						$currencies[] = $of["paymentGroupCurrencyID"];
					}
					
					$this->smartyVars["cycles"] = array_unique((array)$cycles);
					$this->smartyVars["currencies"] = array_unique((array)$currencies);
					
					

				break;

				case 4:

					$this->addonSteps->setEnabled("step1");
					$this->addonSteps->setEnabled("step2");
					$this->addonSteps->setEnabled("step3");
					$this->addonSteps->setEnabled("step4");
					$this->addonSteps->setSelected("step4");

					$this->smartyVars["step"] = 4;

					$this->smartyVars["addonGroupID"] = (int)$_REQUEST["addonGroupID"];
					$this->smartyVars["attributeID"] = $_REQUEST["attributeID"];
					$this->smartyVars["newGroupLabel"] = $_REQUEST["newGroupLabel"];
					$this->smartyVars["newGroupDisplayType"] = $_REQUEST["newGroupDisplayType"];
					$this->smartyVars["numAddons"] = (int)$_REQUEST["numAddons"];
					$this->smartyVars["addons"] = base64_encode(serialize($_REQUEST["addons"]));
					
					$orderForms = array();
					$cycles = array();
					$serverGroups = array();
					foreach ((array)$this->productInfo["orderForms"] as $of){
						$orderForms[] = $of["orderFormID"];
					}
					foreach ((array)$this->productInfo["ghostCycles"] as $cycle){
						$cycles[] = $cycle["cycleID"];
					}
					foreach ((array)$this->productInfo["ghostServerGroups"] as $group){
						$serverGroups[] = $group["serverGroupID"];
					}
					
					$this->otherProducts = correctArray(grabResultsFromMBAPIArray(
						array(
							"mbapi" => array(
								"command" => "GetProducts",
								"params" => array(
									"orderFormID" => $orderForms[0],
									"getOrderFormData" => 1,
									"getCycleGhostData" => 1,
									"getServerGroupGhostData" => 1,
									"productAddonGroupID" => 0
								)
							)
						)
					));
					
					$this->smartyVars["otherProducts"] = array();
					
					foreach ($this->otherProducts as $product){

						$otherOrderForms = array();
						$otherCycles = array();
						$otherServerGroups = array();
						foreach ((array)$product["orderForms"] as $of){
							$otherOrderForms[] = $of["orderFormID"];
						}
						foreach ((array)$product["ghostCycles"] as $cycle){
							$otherCycles[] = $cycle["cycleID"];
						}
						foreach ((array)$product["ghostServerGroups"] as $group){
							$otherServerGroups[] = $group["serverGroupID"];
						}
						
						dbg($product["productName"]);
						dbg(array_diff($orderForms, $otherOrderForms));
						dbg(array_diff($cycles, $otherCycles));
						dbg(array_diff($serverGroups, $otherServerGroups));
						
						if (count(array_diff($orderForms, $otherOrderForms))==0 // if we have the same order forms, cycles, and server groups
						 && count(array_diff($cycles, $otherCycles))==0
						 && count(array_diff($serverGroups, $otherServerGroups))==0){
							if ($this->productInfo["productType"]==$product["productType"]
							 && !(int)$product["productAddonGroupID"]
							 && $product["productID"]!=$this->productInfo["productID"]){
								$this->smartyVars["otherProducts"][] = array("productID"=>$product["productID"], "productName"=>$product["productName"]);
							}
						}
					
					}

					
					

				break;


			}

			$this->smartyVars["addonButtons"] = $this->addonSteps->getButtons();

			$this->addTemplate("widgets/products/AddProductAddon", $this->smartyVars);

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddProduct

// callback function to construct the html ops array for attribute names
function addProductAddonsAttributeCallback($x){
	return $x["serverGroupName"]." > ".$x["productAttributeName"];
}

?>
