<?php
// $Id: AddSkeletonProduct.php,v 1.13 2006/06/08 15:27:24 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/toolkit.php");
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");

/**
 * This Action object takes information provided by the AddSkeletonProduct action, applies that information to
 * records in the database, and redirects to the AddSkeletonProduct action for the given package.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class AddSkeletonProduct extends MB_Action {
	/**
	 * The constructor for an AddSkeletonProduct action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function AddSkeletonProduct() {
		parent::MB_Action();
		$this->stringRep = "AddSkeletonProduct";
		$this->params = array();
	}

	/**
	 * The main method of this class that executes the AddSkeletonProduct action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		do {
			$skeleton = array(
				"productName" => TRANS_SKELETON_PRODUCT,
				"productType" => getTypeID("products", TRANS_UNDEFINED_PRODUCT),
				"productComments" => "",
				"productStopNumCycles" => 0,
				"productActive" => 0,
				"productProratable" => 1,
				"productDomainRequired" => getAPIStatusID("productdependencyrules", "can"),
				"productAddonRequired" => getAPIStatusID("productdependencyrules", "can"),
				"productDateCreated" => mktime(),
			);

			/*
			$emailActionGroups = array();
			
			$q =& new MBQuery("GetEmailActionGroups", "", array("emailActionID" => getTypeID("emailAction", TRANS_SIGNUP)));
			if(!$this->addErrorsFromResult($r =& $q->getResult())) break;
			$t =& $r->getTableFrom(
				array("mbapi", "results", "emailActionGroups", "emailActionGroup"),
				"emailActionGroupID", "emailActionGroupName"
			);
			$IDs = $t->getKeys();
			if(isset($IDs[0])) $emailActionGroups[] =$IDs[0];

			$q =& new MBQuery("GetEmailActionGroups", "", array("emailActionID" => getTypeID("emailAction", TRANS_WELCOME)));
			if(!$this->addErrorsFromResult($r =& $q->getResult())) break;
			$t =& $r->getTableFrom(
				array("mbapi", "results", "emailActionGroups", "emailActionGroup"),
				"emailActionGroupID", "emailActionGroupName"
			);
			$IDs = $t->getKeys();
			if(isset($IDs[0])) $emailActionGroups[] = $IDs[0];
			
			if($emailActionGroups) $skeleton['emailActionGroupIDs'] = array('emailActionGroupID' => $emailActionGroups);
			*/
			
			$q =& new MBQuery("SetProducts", "insert", $skeleton);
		
			//echo '<pre>' . htmlentities($q->getXMLQuery()) . '</pre>'; exit;
		
			if(!$this->addErrorsFromResult($r =& $q->getResult())) break;
			
			$productID = $r->getLastInsertID();
			
			$this->syncProductVariants($productID, getTypeID("products", TRANS_UNDEFINED_PRODUCT));
			
			if (!$this->goBack()){
				redirect("products.php?action=".getActionID("ShowProductDetails")."&advanced=1&productID=".$r->getLastInsertID());
			}
		} while (false);
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddSkeletonProduct
?>
