<?php
// $Id: AddTLDResponse.php,v 1.18 2006/06/22 19:36:18 achrist Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/datasources.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * This Action object takes information provided by the AddTLD action, applies that information to
 * records in the database, and redirects to the ShowProductDetails action for the given product.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class AddTLDResponse extends MB_Action {
	/**
	 * The constructor for an AddTLDResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function AddTLDResponse() {
		parent::MB_Action();
		$this->stringRep = "AddTLDResponse";
		$this->params = array(
			"tldName",
			"tldExtension",
			"registrarID",
			"tldActive",
			"tldWhoisServer",
			"tldWhoisResp",
			"tldAutoSearch",
			"tldTransferMinimumCycleID",
			"tldMinimumCycleID",
			"tldMaximumCycleID",
			"tldRenewType",
			"tldIsTransferable",
			"tldTransferType",
			"tldIDNSupport",
			"tldIDNType",
			"tldRemoteLockEnabled",
			"tldNotSupported"
		);
	}

	/**
	 * The main method of this class that executes the AddTLDResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
				
		$this->setReferralActionID(getActionID("AddTLD"));
		$this->setReferralActionFile("products.php");

		$thisTLD = $_REQUEST["tldExtension"];
		$registrarID = $_REQUEST["registrarID"];
		loadConfigs("domain");
		$registrarData = $CONF["domain"]["registrar"];


		$tldNotSupported = 0;
		$_REQUEST["tldNotSupported"] = 0;
		/* Remove TLD limit
		$registrars = array();
		foreach($registrarData as $registrar => $attrs) {
			if($attrs["configGroupID"] == $registrarID) {
				//See if this registrar is capable of registering this TLD
				if($registrar) {
					$registrarFile = secureinput(strtolower($registrar));
					if(file_exists(mb_path("/lib-mbapi/include/modules/registrar/$registrarFile.php"))) {
						require_once mb_path("/lib-mbapi/include/modules/registrar/$registrarFile.php");

						$r =& new $registrar("nothing");
						$tlds = $r->capabilities[REGISTRAR_TLDS];

						if(!in_array($thisTLD, (array) $tlds)) {
							//$_REQUEST["registrarID"] = -1;
							$_REQUEST["invalidRegistrarID"] = 1;
							$_REQUEST["tldNotSupported"] = -1;
							$tldNotSupported = 1;
						}
					}
				}
			}
		}
		*/

		$success = $this->validateMultiInputs(
			array(
				"tldName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"tldExtension" => INPUT_RESTRICTION_TLD|INPUT_RESTRICTION_REQUIRED,
				"registrarID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldActive" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"tldWhoisServer" => INPUT_RESTRICTION_STRING,
				"tldWhoisResp" => INPUT_RESTRICTION_STRING,
				"tldAutoSearch" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"tldTransferMinimumCycleID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldMinimumCycleID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldMaximumCycleID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldRenewType" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldIsTransferable" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"tldTransferType" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldIDNSupport" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"tldIDNType" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldRemoteLockEnabled" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"tldNotSupported" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED
			), array(), array(), 0, array("tldNotSupported" => $tldNotSupported)
		);

		if($success) {
			$params = array();
			$this->applyRequestTo($params);
			
			$setQuery =& new MBQuery("SetTLDs", "insert", $params);
			if($this->addErrorsFromResult($r =& $setQuery->getResult())) {
				$tldID = $r->getLastInsertID();
				//print_r($tldID);
			
				$pd =& new DataSource("products");
				$ps =& $pd->getSubject();
				$pt =& $ps->getTable();
				$productOptions = $pt->getOptions();
				if($productOptions) {
					$ptByType =& $pt->getAssociatedTablesBy("productType");
					$productIDs =
						  isset($ptByType[getTypeID("products", TRANS_DOMAIN_PRODUCT)])
						? $ptByType[getTypeID("products", TRANS_DOMAIN_PRODUCT)]->getKeys()
						: array();
					//print_r($productIDs);
					$productVariants = array();
					foreach($productIDs as $productID) {
						$productVariant = array(
							"productID" => $productID,
							"productVariantActive" => 0,
							"productVariantDisplayName" => TRANS_OF . " " . $productOptions[$productID] . " " . TRANS_FOR . " " . $TLDs[$tldID]['tldName'] . " " . TRANS_TLD,
							"tldID" => $tldID,
						);
						$productVariants[] = $productVariant;
					}
					//print_r($productVariants);

					if($productVariants) {
						$setVariantQuery =& new MBQuery(
							"SetProducts", "insert",
							array(
								"productVariants" => array(
									"productVariant" => $productVariants,
								),
							)
						);
						if(!$this->addErrorsFromResult($r =& $setVariantQuery->getResult()))  break;
						//echo '<pre>';
						//echo htmlentities($setVariantQuery->getXMLQuery());
						//echo '</pre>';
					}
				}
				if(!$this->goBack()) redirect("products.php", getActionID("ShowTLDs"), array());
				
				//exit;
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditTLDResponse
?>