<?php
// $Id: AddWizardQuestion.php,v 1.9 2006/03/22 20:40:52 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/types.php");
require_once mb_path("/lib-action/include/wizard/WizardResolver.php");

/**
 * This Action object collects information on a product so that that product may be added to the 
 * database.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class AddWizardQuestion extends MB_Action {
	/**
	 * The constructor for a AddWizardQuestion action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function AddWizardQuestion() {
		parent::MB_Action();
		$this->stringRep = "AddWizardQuestion";
	}

	/**
	 * The main method of this class that executes the AddWizardQuestion action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$w =& new Wizard(intval($_REQUEST["wizardID"]), TRANS_ADD_WIZARD_QUESTION, TRANS_ADD_WIZARD_QUESTION_MESG);
		$s =& new WizardStep(TRANS_ADD_QUESTION, TRANS_ADD_QUESTION_MESG);

		$wr =& new WizardResolver(
			"stepID",
			"order",
			"question",
			"description",
			"type",
			"restrictions",
			"answers",
			"values",
			"selected",
			"size",
			"maxlength",
			"minlen",
			"maxlen",
			"password"
		);
		$wr->addQuestionRel("type", "answers");
		$wr->addQuestionRel("type", "size");
		$wr->addQuestionRel("type", "maxlength");
		$wr->addQuestionRel("restrictions", "minlen");
		$wr->addQuestionRel("restrictions", "maxlen");
		$wr->addQuestionRel("answers", "values");
		$wr->addQuestionRel("answers", "selected");
				
		$wr->setWizard($w);
		$wr->setWizardStep($s);
		$wr->processForQuestionsReady();

		$questionAnswers = $wr->getQuestionAnswers();

		if($wr->isReady("stepID")) {
			$q =& new WizardQuestion(QUESTION_INPUT_SELECT, TRANS_STEP);
			$q->setID($wr->getQuestionID("stepID"));
			$query = "<mbapi>
	<command>GetWizardSteps</command>
	<showXMLHeader>0</showXMLHeader>
	<params>
	</params>
</mbapi>";
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			$steps = collapseArrayElements(protectArray($data["mbapi"][0]["results"][0]["steps"][0]["step"]));
			$c = count($steps);
			for($i = 0; $i < $c; $i++) {
				$step =& $steps[$i];
				$q->addAnswer($step['stepName'], $step['stepID']);
			}
			$q->setRestrictions(INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED);
			$s->addQuestion($q);
		}
		
		if($wr->isReady("order")) {
			$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_DISPLAY_ORDER);			
			$q->setID($wr->getQuestionID("order"));
			$q->setSize(12);
			$q->setMaxLength(12);
			$q->addAnswer("0");
			$q->setRestrictions(INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED);	
			$s->addQuestion($q);		
		}
		
		if($wr->isReady("question")) {
			$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_QUESTION);
			$q->setID($wr->getQuestionID("question"));
			$q->setSize(64);
			$q->setMaxLength(256);
			$q->setRestrictions(INPUT_RESTRICTION_REQUIRED);		
			$s->addQuestion($q);			
		}
		
		if($wr->isReady("description")) {
			$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_DESCRIPTION);
			$q->setID($wr->getQuestionID("description"));
			$q->setSize(64);
			$q->setMaxLength(256);
			$q->setRestrictions(INPUT_RESTRICTION_REQUIRED);
			$s->addQuestion($q);
		}
		
		if($wr->isReady("type")) {
			$q =& new WizardQuestion(QUESTION_INPUT_SELECT, TRANS_TYPE);
			$q->setID($wr->getQuestionID("type"));
			$q->addAnswer(TRANS_HIDDEN, "1", 1);
			$q->addAnswer(TRANS_TEXT, "2", 0);
			$q->addAnswer(TRANS_PASSWORD, "3", 0);
			$q->addAnswer(TRANS_TEXTAREA, "4", 0);
			$q->addAnswer(TRANS_SELECT, "5", 0);
			$q->addAnswer(TRANS_MULTISELECT, "6", 0);
			$q->addAnswer(TRANS_CHECKBOX, "7", 0);
			$q->addAnswer(TRANS_RADIO, "8", 0);
			$q->setRestrictions(INPUT_RESTRICTION_INT);		
			$s->addQuestion($q);
		}
		
		if($wr->isReady("restrictions")) {
			global $inputRestrictionNames;
			$q =& new WizardQuestion(QUESTION_INPUT_MULTISELECT, TRANS_INPUT_RESTRICTIONS);
			$q->setID($wr->getQuestionID("restrictions"));
			foreach($inputRestrictionNames as $flag => $name) {
				$constantName = defined("TRANS_" . $name) ? constant("TRANS_" . $name) : "TRANS_" . $name;
				$q->addAnswer($constantName, $flag, 0);
			}
			$q->setRestrictions(INPUT_RESTRICTION_INT);		
			$s->addQuestion($q);
		}
		
		if($wr->isReady("answers")) {
			// multi-answer types
			if(in_array($questionAnswers["type"], array("5","6","7","8",))) {
				$q =& new WizardQuestion(QUESTION_INPUT_TEXTAREA, TRANS_ANSWERS);
				$q->setSize(5);
				$q->setMaxLength(80);
				$q->setRestrictions(INPUT_RESTRICTION_REQUIRED);
			} else {
				$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_DEFAULT_VALUE);
				$q->setSize(12);
				$q->setMaxLength(256);
			}
			$q->setID($wr->getQuestionID("answers"));
			$s->addQuestion($q);
		}
		
		if($wr->isReady("values")) {
		
			// multi-answer types
			if(in_array($questionAnswers["type"], array("5","6","7","8",))) {
				// because array_filter won't work for "0" due to the boolean coersion rule
				$answersTmp = explode("\n", $questionAnswers["answers"]);
				$answertext = array();
				$answernum = 0;
				foreach($answersTmp as $answer) {
					$answer = trim($answer);
					if($answer !== "") {
						$answernum++;
						$answertext[] = $answer . "=";
					}
				}
				$answers = implode("\n", $answertext);
				$q =& new WizardQuestion(QUESTION_INPUT_TEXTAREA, TRANS_VALUES);
				$q->setID($wr->getQuestionID("values"));
				$q->addAnswer($answers);
				$q->setSize($answernum);
				$q->setMaxLength(80);
				$q->setRestrictions(INPUT_RESTRICTION_REQUIRED);
				$s->addQuestion($q);
			} else {
				$wr->addQuestionIgnored("values");
			}
		}
		
		if($wr->isReady("selected")) {
			// multi-select types
			if(in_array($questionAnswers["type"], array("6","7",))) {
				$q =& new WizardQuestion(QUESTION_INPUT_MULTISELECT, TRANS_SELECTED);
				$q->setID($wr->getQuestionID("selected"));
				$answers = explode("\n", $questionAnswers["answers"]);
				$i = 0;
				foreach($answers as $answer) {
					$q->addAnswer($answer, ++$i, 0);
				}
				$s->addQuestion($q);
			// single-select types
			} else if(in_array($questionAnswers["type"], array("5","8",))) {
				$q =& new WizardQuestion(QUESTION_INPUT_SELECT, TRANS_SELECTED);
				$q->setID($wr->getQuestionID("selected"));
				$answers = explode("\n", $questionAnswers["answers"]);
				$i = 0;
				foreach($answers as $answer) {
					$q->addAnswer($answer, ++$i, 0);
				}
				$s->addQuestion($q);
			} else {
				$wr->addQuestionIgnored("selected");
			}
		}
		
		if($wr->isReady("size")) {
			// textarea type
			if($questionAnswers["type"] == "4") {
				$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_ROWS);			
				$q->setID($wr->getQuestionID("size"));
				$q->setSize(12);
				$q->setMaxLength(12);
				$s->addQuestion($q);
			// text field types
			} else if(in_array($questionAnswers["type"], array("2","3",))) {
				$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_SIZE);			
				$q->setID($wr->getQuestionID("size"));
				$q->setSize(12);
				$q->setMaxLength(12);
				$s->addQuestion($q);
			} else {
				$wr->addQuestionIgnored("size");
			}

		}
		
		if($wr->isReady("maxlength")) {
			// textarea type
			if($questionAnswers["type"] == "4") {
				$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_COLS);			
				$q->setID($wr->getQuestionID("maxlength"));
				$q->setSize(12);
				$q->setMaxLength(256);
				$s->addQuestion($q);
			// text field types
			} else if(in_array($questionAnswers["type"], array("2","3",))) {
				$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_MAX_LENGTH);			
				$q->setID($wr->getQuestionID("maxlength"));
				$q->setSize(12);
				$q->setMaxLength(256);
				$s->addQuestion($q);
			} else {
				$wr->addQuestionIgnored("maxlength");
			}
		}
		
		if($wr->isReady("minlen")) {
			if(in_array(INPUT_RESTRICTION_MINLEN, $questionAnswers['restrictions'])) {
				$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_MIN_ACCEPTABLE_LENGTH);			
				$q->setID($wr->getQuestionID("minlen"));
				$q->setSize(12);
				$q->setMaxLength(12);
				$s->addQuestion($q);
			} else {
				$wr->addQuestionIgnored("minlen");
			}
		}
		
		if($wr->isReady("maxlen")) {
			if(in_array(INPUT_RESTRICTION_MAXLEN, $questionAnswers['restrictions'])) {
				$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_MAX_ACCEPTABLE_LENGTH);			
				$q->setID($wr->getQuestionID("maxlen"));
				$q->setSize(12);
				$q->setMaxLength(12);
				$s->addQuestion($q);
			} else {
				$wr->addQuestionIgnored("maxlen");
			}
		}

		if($wr->isReady("password")) {
			if(in_array(INPUT_RESTRICTION_PASSWORD, $questionAnswers['restrictions'])) {
				$q =& new WizardQuestion(QUESTION_INPUT_TEXT, TRANS_PASSWORD);
				$q->setSize(12);
				$q->setMaxLength(12);
				$s->addQuestion($q);
			} else {
				$wr->addQuestionIgnored("password");
			}
		}

		$confirm = $_REQUEST['confirm'];
		
		if(!$confirm) {
			$this->addTemplate("products/AddWizardQuestion", $this->smartyVars);
		}
		
		$questionOrder = 0;
		if($confirm || !$wr->display()) {
			$summary = array();
			$questionParams = array();
			$questionStep = 0;
			
			if(isset($questionAnswers['stepID'])) {
				$stepID = (int) $questionAnswers['stepID'];
				$query = "<mbapi>
	<command>GetWizardSteps</command>
	<showXMLHeader>0</showXMLHeader>
	<params>
		<stepID>$stepID</stepID>
	</params>
</mbapi>";
				$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
				$data = dispatchMBAPI($query, 1);
				$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
				$questionStep = $data["mbapi"][0]["results"][0]["steps"][0]["step"][0]["stepName"][0];
				
				$summary[] = array(TRANS_CUSTOM_QUESTIONS, $questionStep);
			}
			
			if(isset($questionAnswers['order'])) {
				$questionOrder = $questionAnswers['order'];
			}
			
			if(isset($questionAnswers['question'])) {
				$question = $questionAnswers['question'];
				$questionQuestion = preg_match("/^TRANS_/", $question) && defined($question) ? constant($question) : $question;
				$summary[] = array(TRANS_QUESTION, $questionQuestion);
			}
						
			if(isset($questionAnswers['description'])) {
				$desc = $questionAnswers['description'];
				$questionDesc = preg_match("/^TRANS_/", $desc) && defined($desc) ? constant($desc) : $desc;
				$summary[] = array(TRANS_DESCRIPTION, $questionDesc);
			}

			if(isset($questionAnswers['type'])) {
				$paramOrder = 0;
				$questionParams[] = array('setQuestion', $paramOrder++, array($questionAnswers['question']));
				switch ($questionAnswers['type']) {
					case 1:
						$summary[] = array(TRANS_TYPE, TRANS_HIDDEN);
						$q =& new WizardQuestion(QUESTION_INPUT_HIDDEN, $questionQuestion);
						$questionParams[] = array('setType', $paramOrder++, array("QUESTION_INPUT_HIDDEN"));
						break;
					case 2:
						$summary[] = array(TRANS_TYPE, TRANS_TEXT);
						$q =& new WizardQuestion(QUESTION_INPUT_TEXT, $questionQuestion);
						$questionParams[] = array('setType', $paramOrder++, array("QUESTION_INPUT_TEXT"));
						break;
					case 3:
						$summary[] = array(TRANS_TYPE, TRANS_PASSWORD);
						$q =& new WizardQuestion(QUESTION_INPUT_PASSWORD, $questionQuestion);
						$questionParams[] = array('setType', $paramOrder++, array("QUESTION_INPUT_PASSWORD"));
						break;
					case 4:
						$summary[] = array(TRANS_TYPE, TRANS_TEXTAREA);
						$q =& new WizardQuestion(QUESTION_INPUT_TEXTAREA, $questionQuestion);
						$questionParams[] = array('setType', $paramOrder++, array("QUESTION_INPUT_TEXTAREA"));
						break;
					case 5:
						$summary[] = array(TRANS_TYPE, TRANS_SELECT);
						$q =& new WizardQuestion(QUESTION_INPUT_SELECT, $questionQuestion);
						$questionParams[] = array('setType', $paramOrder++, array("QUESTION_INPUT_SELECT"));
						break;
					case 6:
						$summary[] = array(TRANS_TYPE, TRANS_MULTISELECT);
						$q =& new WizardQuestion(QUESTION_INPUT_MULTISELECT, $questionQuestion);
						$questionParams[] = array('setType', $paramOrder++, array("QUESTION_INPUT_MULTISELECT"));
						break;
					case 7:
						$summary[] = array(TRANS_TYPE, TRANS_CHECKBOX);
						$q =& new WizardQuestion(QUESTION_INPUT_CHECKBOX, $questionQuestion);
						$questionParams[] = array('setType', $paramOrder++, array("QUESTION_INPUT_CHECKBOX"));
						break;
					case 8:
						$summary[] = array(TRANS_TYPE, TRANS_RADIO);
						$q =& new WizardQuestion(QUESTION_INPUT_RADIO, $questionQuestion);
						$questionParams[] = array('setType', $paramOrder++, array("QUESTION_INPUT_RADIO"));
						break;
				}
				$q->setDescription($questionDesc);
				$questionParams[] = array('setDescription', $paramOrder++, array($questionAnswers['description']));

			}

			if(isset($questionAnswers['restrictions'])) {
				global $inputRestrictionNames;
				$restrictions = array();
				foreach($inputRestrictionNames as $flag => $name) {
					if(in_array($flag, $questionAnswers['restrictions'])) {
						$constantName = defined("TRANS_" . $name) ? constant("TRANS_" . $name) : "TRANS_" . $name;
						$restrictions[] = $constantName;
					}
				}
				$restrictions = implode('; ', $restrictions);
				$summary[] = array(TRANS_RESTRICTIONS, $restrictions);
				
				$restrictionBitmap = 0;
				foreach($restrictions as $restriction) {
					$restrictionBitmap |= $restriction;
				}
				$q->setRestrictions($restrictionBitmap);
				$questionParams[] = array('setRestrictions', $paramOrder++, array($restrictionBitmap));
			}

			if(isset($questionAnswers['answers'])) {
				$answers = array();
				if(in_array($questionAnswers["type"], array("5","6","7","8",))) {
					$lines = explode("\n", $questionAnswers['answers']);
					foreach($lines as $line) {
						$line = trim($line);
						if($line !== "") {
							$answers[] = $line;
						}
					}
					//$summary[] = array(TRANS_ANSWERS, implode(' - ', $answers));

					$optionsMesg = "";
					if(isset($questionAnswers['values'])) {
						// key values
						$keyedValues = array();
						$lines = explode("\n", $questionAnswers['values']);
						foreach($lines as $line) {
							$line = trim($line);
							if($line !== "") {
								list($key, $value) = explode('=', $line, 2);
								$key = trim($key);
								$value = trim($value);
								$keyedValues[$key] = $value;
								
								$thisOptionMesg = htmlentities($key) . " = " . htmlentities($value);
								if(
									isset($questionAnswers['selected']) && (
											is_array($questionAnswers['selected']) && in_array($value, $questionAnswers['selected'])
										||	$questionAnswers['selected'] == $value
									)
								) {
									$selected = 1;
									$optionsMesg .= "(" . $thisOptionMesg . "), ";
								} else {
									$selected = 0;
									$optionsMesg .= "" . $thisOptionMesg . ", ";
								}
								$q->addAnswer($key, $value, $selected);
								$questionParams[] = array('addAnswer', $paramOrder++, array($key, $value, $select));
							}
						}

						// order values
						$orderedValues = array();
						$c = count($answers);
						for($i = 0; $i < $c; $i++) {
							$answer = $answers[$i];
							$orderedValues[] = $keyedValues[$answer];

						}
						
						//$summary[] = array(TRANS_VALUES, implode(' - ', $orderedValues));
					}
					$optionsMesg .= "";
					
					$summary[] = array(TRANS_VALUES, $optionsMesg);
				} else {
					$q->addAnswer($questionAnswers['answers']);
					$questionParams[] = array('addAnswer', $paramOrder++, array($questionAnswers['answers']));
					$summary[] = array(TRANS_VALUE, $questionAnswers['answers']);
				}
			}
						
			if(isset($questionAnswers['size'])) {
				// textarea
				if($questionAnswers["type"] == "4") {
					$summary[] = array(TRANS_ROWS, $questionAnswers['size']);
				} else {
					$summary[] = array(TRANS_SIZE, $questionAnswers['size']);
				}
				$q->setSize($questionAnswers['size']);
				$questionParams[] = array('setSize', $paramOrder++, array($questionAnswers['size']));
			}
			
			if(isset($questionAnswers['maxlength'])) {
				// textarea
				if($questionAnswers["type"] == "4") {
					$summary[] = array(TRANS_COLS, $questionAnswers['maxlength']);
				} else {
					$summary[] = array(TRANS_MAX_LENGTH, $questionAnswers['maxlength']);
				}
				$q->setMaxLength($questionAnswers['maxlength']);
				$questionParams[] = array('setMaxLength', $paramOrder++, array($questionAnswers['maxlength']));
			}
			
			if(isset($questionAnswers['minlen'])) {
				$summary[] = array(TRANS_MIN_ACCEPTABLE_LENGTH, $questionAnswers['minlen']);
				$q->addRestrictionArg('minlen', $questionAnswers['minlen']);
				$questionParams[] = array('addRestrictionArg', $paramOrder++, array('minlen', $questionAnswers['minlen']));
			}
			
			if(isset($questionAnswers['maxlen'])) {
				$summary[] = array(TRANS_MAX_ACCEPTABLE_LENGTH, $questionAnswers['maxlen']);
				$q->addRestrictionArg('maxlen', $questionAnswers['maxlen']);
				$questionParams[] = array('addRestrictionArg', $paramOrder++, array('maxlen', $questionAnswers['maxlen']));
			}
			
			if(isset($questionAnswers['password'])) {
				$summary[] = array(TRANS_PASSWORD, $questionAnswers['password']);
				$q->addRestrictionArg('password', $questionAnswers['password']);
				$questionParams[] = array('addRestrictionArg', $paramOrder++, array('password', $questionAnswers['password']));
			}
			
			$sp =& new WizardStep(TRANS_QUESTION_PREVIEW, TRANS_QUESTION_PREVIEW_MESG);
			$sp->addQuestion($q);
			if(!$confirm) {
				$sp->display(true);
			}
			
			if(!$confirm) {
				$this->addTemplate("products/AddWizardQuestion2", array('summary' => $summary, 'wizardID' => $w->getID()));
			}
		}


		if(!$confirm) {
			//echo '<pre>';
			//print_r($_REQUEST);
			//print_r($wr);
			//print_r($w);
			//echo '</pre>';
		
			$this->addTemplate("footer", array());
		} else {
			// insert into database
			
			$questionCommand = "<mbapi>
	<command>SetWizardQuestions</command>
	<subCommand>insert</subCommand>
	<params>
		<stepID>" . $questionAnswers['stepID'] . "</stepID>
		<questionOrder>" . $questionOrder ."</questionOrder>
	</params>
</mbapi>";

			$CONF["debug"]->add("Action Command", htmlentities($questionCommand), __FILE__, __LINE__);
			$data = dispatchMBAPI($questionCommand, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			$questionID = $data["mbapi"][0]["header"][0]["lastInsertID"][0];
			$error = $this->addMBAPIErrors($data) === 0 ? $this->getNumErrors() : false;

			$questionParamsCommand = "<mbapi>
	<command>SetWizardQuestionParams</command>
	<subCommand>insert</subCommand>
	<params>
		<questionParams>";
		
			foreach($questionParams as $param) {
				list($paramName, $paramOrder, $paramValues) = $param;
				
				$questionParamsCommand .= "
			<questionParam>
				<questionID>" . $questionID . "</questionID>
				<questionParamName>" . $paramName . "</questionParamName>
				<questionParamOrder>" . $paramOrder . "</questionParamOrder>
				<questionParamValues>";
				
				foreach($paramValues as $value) {
					$questionParamsCommand .= "
					<questionParamValue>" . $value . "</questionParamValue>";
				}
				
				$questionParamsCommand .= "
				</questionParamValues>
			</questionParam>";
			
			}
			
			$questionParamsCommand .= "
		</questionParams>
	</params>
</mbapi>";
			
			$CONF["debug"]->add("Action Command", htmlentities($questionParamsCommand), __FILE__, __LINE__);
			$data = dispatchMBAPI($questionParamsCommand, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				redirect("products.php", getActionID("ShowWizardSteps"), array());
			}

			//echo '<pre>';
			//echo "Woo!\n";
			//echo "StepID: " . $questionStep . "\n";
			//echo "order: " . $questionOrder . "\n";
			//print_r($questionParams);
			//echo '</pre>';
			//exit;
		}


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddProduct
?>