<?php
// $Id: CloneProductAddonResponse.php,v 1.8 2006/03/22 20:40:52 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the RemoveProduct action, and removes the specified product. *
 * @author Andy Christ
 */
class CloneProductResponse extends MB_Action {
	/**
	 * The constructor for an RemoveProductResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function CloneProductResponse() {
		parent::MB_Action();
		$this->stringRep = "CloneProductResponse";
        $this->params = array("productID");
	}


	/**
	 * The main method of this class that executes the CloneProductResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$productID = ((int) $_REQUEST["productID"]);
		if(!$productID) {
			$this->addError(TRANS_ACTIONERROR, "No Product ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetProducts", "", array());
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);

			$query = $this->getMBAPIQuery("SetProducts", "insert", collapseArrayElements($data['mbapi'][0]['results'][0]['products'][0]['product'][0]));

			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				
				header("Location: products.php?action=".getActionID("ShowProductDetails")."&productID=".$data["mbapi"][0]["header"][0]["lastInsertID"][0]);
			}
	}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveProductResponse
?>