<?php
// $Id: EditCoupon.php,v 1.10 2006/06/22 15:56:47 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/types.php");

/**
 * @author  Ben Woolley
 */
class EditCoupon extends MB_Action {

	function EditCoupon() {
		parent::MB_Action();
		$this->stringRep = "EditCoupon";
		$this->params = array(
			"couponID",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();

		$couponID = getParam("couponID");
		if($couponID) {
			$this->formDefaults = correctArray($this->getPathFromMBAPI("GetCoupons", "", array('couponID' => $couponID, "getOrderFormData" => 1, "getProductData" => 1), array("mbapi", "results", "coupons", "coupon", 0)));
			dbg($this->formDefaults);
			if(!isset($this->formDefaults["couponID"])) {
				$this->addError(TRANS_ACTIONERROR, "No valid Coupon ID given.");
			}
		} else {
			$this->addError(TRANS_ACTIONERROR, "No Coupon ID given.");
		}
		if(!$this->getNumErrors()) {
			$this->smartyVars["coupon"] = $this->formDefaults;

			$this->setupDateSelector("couponDateStarted");
			$this->setupDateSelector("couponDateEnded", (bool) $this->formDefaults["couponDateEnded"]);
			
			$this->smartyVars['couponTypes'] = $CONF['types']['coupon'];

			$selectableOrderForms = grabHTMLOpsFromArray(grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetOrderForms",
					"params" => array(
					),
				),
			)), "orderFormID", "orderFormName");

			$selectableProducts = grabHTMLOpsFromArray(grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetProducts",
					"params" => array(
					),
				),
			)), "productID", "productName");

			$this->smartyVars["selectedProducts"] = array();
			$this->smartyVars["selectedOrderForms"] = array();
			$this->smartyVars["selectableProducts"] = array();
			$this->smartyVars["selectableOrderForms"] = array();
			foreach ((array)$this->formDefaults["orderForms"] as $ofr){
				$this->smartyVars["selectedOrderForms"][$ofr["orderFormID"]] = $selectableOrderForms[$ofr["orderFormID"]];
			}
			foreach ((array)$this->formDefaults["products"] as $pr){
				$this->smartyVars["selectedProducts"][$pr["productID"]] = $selectableProducts[$pr["productID"]];
			}
			foreach ((array)$selectableOrderForms as $orderFormID=>$orderFormName){
				if (!$this->smartyVars["selectedOrderForms"][$orderFormID]){
					$this->smartyVars["selectableOrderForms"][$orderFormID] = $orderFormName;
				}
			}
			foreach ((array)$selectableProducts as $productID=>$productName){
				if (!$this->smartyVars["selectedProducts"][$productID]){
					$this->smartyVars["selectableProducts"][$productID] = $productName;
				}
			}


			$this->mergeFormState();
			//echo '<pre>';
			//print_r($this->smartyVars);
			//echo '</pre>';
			$this->addTemplate("products/EditCoupon");
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // MB_Action
?>
