<?php
// $Id: EditGenericAttributeResponse.php,v 1.5 2006/03/22 20:40:52 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * This Action object takes information provided by the EditGenericAttribute action, applies that information to
 * records in the database, and redirects to the ShowProductDetails action for the given product.
 *
 * @author  Ben Woolley
 */
class EditGenericAttributeResponse extends MB_Action {
	/**
	 * The constructor for an EditGenericAttributeResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditGenericAttributeResponse() {
		parent::MB_Action();
		$this->stringRep = "EditGenericAttributeResponse";
		$this->params = array(
			"productID",
			"productAttributeID",
			"productAttributeName",
			"productAttributeValue",
		);
	}

	/**
	 * The main method of this class that executes the EditGenericAttributeResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->setReferralActionID(getActionID("ShowProductDetails"));
		$this->setReferralActionFile("products.php");
		$success = $this->validateMultiInputs(
			array(
				"productID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"productAttributeID" => INPUT_RESTRICTION_UNSIGNED_INT,
				"productAttributeName" => INPUT_RESTRICTION_STRING,
				"productAttributeValue" => INPUT_RESTRICTION_STRING,
			),
			array(),
			array(),
			0,
			array("loadActionFile"=>"products","loadActionID"=>getActionID("EditProductAttributes"))
		);
		if($success) {

			$productID = (int) $_REQUEST["productID"];
			$productAttributeID = (int) $_REQUEST["productAttributeID"];
			$productAttributeName = $_REQUEST["productAttributeName"];
			$productAttributeValue = $_REQUEST["productAttributeValue"];
			if(!$productID) {
				$this->addError(TRANS_ACTIONERROR, "No product ID given.");
			} else {
 				$params = array(
					'productID' => $productID,
					'productAttributes' => array(
						'productAttribute' => array()
					),
				);
				if($productAttributeID) {
					$params['productAttributes']['productAttribute']['productAttributeID'] = $productAttributeID;
				}
				if($productAttributeName) {
					$params['productAttributes']['productAttribute']['productAttributeName'] = $productAttributeName;
				}
				if($productAttributeValue) {
					$params['productAttributes']['productAttribute']['productAttributeValue'] = $productAttributeValue;
				}
				//$this->applyRequestTo($params);
				if(!$productAttributeID) {
					$params['productAttributes']['productAttribute']['productAttributeDateCreated'] = mktime();
					$q =& new MBQuery("SetProducts", "insert", $params);
				} else {
					$q =& new MBQuery("SetProducts", "update", $params);
				}
				$r =& $q->getResult();
				
				if($r->getSuccess()) {
					/*
					if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
						redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
					} else {
					*/
						redirect(
							"products.php", getActionID("ShowProductDetails"),
							array(
								"productID" => $productID,
								"loadActionFile" => "products",
								"loadActionID" => getActionID("EditProductAttributes"),
							)
						);
					/*
					}
					*/
				}
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>