<?php
// $Id: EditOneProductRelations.php,v 1.1 2006/06/22 23:14:51 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/app-modernbill-admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/types.php");
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * product <-> child product relation editor
 *
 * @author  Kris Bailey
 */
class EditOneProductRelations extends MB_ProductAction {
	/**
	 * The constructor for a EditOneProductRelations action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditOneProductRelations() {
		parent::MB_ProductAction("relations");
		$this->stringRep = "EditOneProductRelations";
		$this->params = array("productID");
	}

	/**
	 * The main method of this class that executes the EditOneProductRelations action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		dbg($this);
		
		$productID = getParam("productID");
		if(!$productID) {
			$this->addError(TRANS_ACTIONERROR, "No product ID given.");
		} else {
			$q =& new MBQuery("GetProducts", "", array("productID" => $productID, "getProductChildIDs" => 1));
			$r =& $q->getResult();
			if($r->getSuccess()) {
				$s =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product", 0),
					"productID", "productName"
				);
				
				$product = $s->getCollapsed();
				$types = $CONF["types"]["products"];

				$this->setupTypeButtons($product["productType"]);
				$this->smartyVars["productButtons"] = $this->productButtons->getButtons();

				$this->smartyVars['product'] = $product;
				$this->smartyVars['types'] = $types;

				
				$this->smartyVars["productsInfo"] = grabHTMLOpsFromArray(grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetProducts",
						"params" => array(
							"getNonAddons" => 1,
						),
					),
				)), "productID", "productName");
				
				/* stuff to get relations */
				$this->smartyVars["selectedUpgradeRelations"] = grabHTMLOpsFromArray(arrayFor("productRelations", array("subjectProductID" => $productID, "productRelationType" => getAPITypeID("productrelations", "upgrade"))), "relatedProductID", array($this, "grabProductName"));
				$this->smartyVars["selectedDowngradeRelations"] = grabHTMLOpsFromArray(arrayFor("productRelations", array("subjectProductID" => $productID, "productRelationType" => getAPITypeID("productrelations", "downgrade"))), "relatedProductID", array($this, "grabProductName"));

				$this->smartyVars["selectableUpgradeRelations"] = array();
				$this->smartyVars["selectableDowngradeRelations"] = array();
				foreach ($this->smartyVars["productsInfo"] as $pid=>$product){
					if ($pid!=$productID && !$this->smartyVars["selectedUpgradeRelations"][$pid]){
						$this->smartyVars["selectableUpgradeRelations"][$pid] = $product;
					}
				}				
				foreach ($this->smartyVars["productsInfo"] as $pid=>$product){
					if ($pid!=$productID && !$this->smartyVars["selectedDowngradeRelations"][$pid]){
						$this->smartyVars["selectableDowngradeRelations"][$pid] = $product;
					}
				}				


				$q =& new MBQuery("GetProducts", "", array());
				$childrenResult =& $q->getResult();
				$childrenSubject =& $childrenResult->getSubjectFrom(
					array("mbapi", "results", "products", "product"),
					"productID", "productName"
				);
				$r->setPath(array("mbapi", "results", "products", "product", "productChildren", "productChild"));
				$this->assignMultiOptionsFromSubject("children", $childrenSubject, "productChildren", $r, "childProductID");
				
				$formDefaults = $product;
				$this->mergeFormState($formDefaults);
				$this->addTemplate("widgets/products/EditOneProductRelations", $this->smartyVars);
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
	
	function grabProductName($row){
		return $this->smartyVars["productsInfo"][$row["relatedProductID"]];
	}
}
?>
