<?php
// $Id: EditPanelAttributeResponse.php,v 1.17 2006/07/06 00:08:48 bwoolley Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * This Action object takes information provided by the EditPanelAttributeResponse action, applies that information to
 * records in the database, and redirects to the ShowProductDetails action for the given product.
 *
 * @author  Ben Woolley
 */
class EditPanelAttributeResponse extends MB_Action {
	/**
	 * The constructor for an EditProductOrderFormsResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditProductOrderFormsResponse() {
		parent::MB_Action();
		$this->stringRep = "EditPanelAttributeResponse";
		$this->params = array(
			"productID",
		);
	}

	/**
	 * The main method of this class that executes the EditProductOrderFormsResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->setReferralActionID(getActionID("ShowProductDetails"));
		$this->setReferralActionFile("products.php");
		$success = $this->validateMultiInputs(
			array(
				"productID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
			),
			array(),
			array(),
			0,
			array(
				"loadActionFile" => "products",
				"loadActionID" => getActionID("EditProductAttributes"),
			)
		);
		if($success) {

			$productID = ((int) $_REQUEST["productID"]);
			if(!$productID) {
				$this->addError(TRANS_ACTIONERROR, "No product ID given.");
			} else {
				$q =& new MBQuery("GetProducts", "", array("productID" => $productID, "getProductAttributeData" => 1, "getServerGroupGhostData" => 1));
				$r =& $q->getResult();
				if($r->getSuccess()) {
				}
				//echo '<pre>';
				$ps =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product"),
					"productID", "productName"
				);
				$pt =& $ps->getTable();
				$product = $pt->getOne();

				$gs =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product", "ghostServerGroups", "ghostServerGroup"),
					"serverGroupID", "serverGroupName"
				);
				$serverGroups = $gs->getAssociated();
				$serverGroups[0] = array();
				
				$attributes = array();
				$invalidParams = array();
				$secure = array();
				foreach($serverGroups as $serverGroupID => $serverGroupData) {
					$attributes[$serverGroupID] = array();
					$serverGroupAttributeData =& $attributes[$serverGroupID];
					
					$panelAttributes = $this->getAttributesForServerGroupID($serverGroupID, $product);
					//show($_REQUEST);
					//show($panelAttributes);
					if($panelAttributes) {
						$iter = 0;
						foreach($panelAttributes as $attrName => $attrData) {
							$q =& $attrData['question'];
							if($attrData['secure']) {
								$secureArgs[] = $attrName;
							}
							
							$question = 'question_' . $serverGroupID . '_' . ++$iter;
							if(isset($_REQUEST[$question])) {
								$answers = $_REQUEST[$question];
								
								// handle input validation
								$errors = $q->validateFor($answers);
								if($errors) {
									$invalidParams[] = $question . '-' . dechex($errors);
								}
							} else {
								$answers = NULL;
							}

							$answerSet = (array) $answers;
							if(isset($attrData['valueMap'])) {
								$valueMap = $attrData['valueMap'];

								foreach($valueMap as $searchValue => $mappings) {
									foreach($mappings as $mappedAttributeName => $possibleValues) {
										list($matchValue, $noMatchValue) = $possibleValues;

										$serverGroupAttributeData[$mappedAttributeName] = in_array($searchValue, $answerSet) ? $matchValue : $noMatchValue;
									}
								}
							} else {
								$serverGroupAttributeData[$attrName] = end($answerSet);
							}
						}
					}
				}
				//show($attributes);
				//exit;
				if($invalidParams) {
					$referralArgs = array();
					foreach($_REQUEST as $defaultParam => $defaultValue) {
						if(!in_array($defaultParam, $secure) && preg_match("/^question_/", $defaultParam)) {
							$referralArgs[DEFAULT_PREFIX . $defaultParam] = requestArgSerialize($defaultValue);
						}
					}
					$referralArgs['invalid'] = implode('_', $invalidParams);
					
					redirect(
						"products.php", getActionID("EditProductAttributes"),
						array(
							"productID" => $productID,
							"loadActionFile" => "products",
							"loadActionID" => getActionID("EditProductAttributes"),
						) + $referralArgs
					);					
				} else {
					//print_r($attributes);

					$serverGroupIDs = $gs->getKeys();
					$as =& $r->getSubjectFrom(
						array("mbapi", "results", "products", "product", "productAttributes", "productAttribute"),
						"serverGroupID"
					);
					$oldAttributesByServerGroup = $as->getAssociatedSets();
					$oldAttributesByServerGroup[0] = array();
					//echo '<pre>';
					//print_r($r);
					//print_r($as);
					//print_r($oldAttributesByServerGroup);
					//echo '</pre>';
					$deleteParams = array();
					foreach($oldAttributesByServerGroup as $serverGroupID => $serverGroupAttrs) {
						if(!in_array($serverGroupID, $serverGroupIDs) && $serverGroupID !== NULL) {
							foreach($serverGroupAttrs as $attrData) {
								$deleteParams[] = $attrData['productAttributeID'];
							}
						}
					}


					//print_r($oldAttributesByServerGroup);

					$productAttributeParams = array();
					foreach($serverGroups as $serverGroupID => $serverGroupData) {
						$oldAttributesByName = associateArrayRowByID($oldAttributesByServerGroup[$serverGroupID], "productAttributeName");
						$newAttributesByName = $attributes[$serverGroupID];
						//print_r($oldAttributesByName);
						//print_r($newAttributesByName);
						foreach($oldAttributesByName as $attrName => $attrData) {
							$oldAttributeValue = $attrData['productAttributeValue'];
							$newAttributeValue = $newAttributesByName[$attrName];
							if($oldAttributeValue !== $newAttributeValue) {
								$productAttributeParams[] = array(
									'productAttributeID' => $attrData['productAttributeID'],
									'productAttributeValue' => $newAttributeValue,
								);
							}
						}

						foreach($newAttributesByName as $attrName => $attrVal) {
							if(!isset($oldAttributesByName[$attrName])) {
								$productAttributeParams[] = array(
									'serverGroupID' => $serverGroupID,
									'productAttributeName' => $attrName,
									'productAttributeValue' => $attrVal,
									'productAttributeDateCreated' => mktime(),
								);
							}
						}
					}
										
					//echo '<pre>';
					//echo "servers:\n";
					//print_r($serverGroupIDs);
					//echo "updated:\n";
					//print_r($productAttributeParams);
					//echo "deleted:\n";
					//print_r($deleteParams);

					if($productAttributeParams || $deleteParams) {
						$skipSuccess = false;
						$params = array(
							'productID' => $productID,
						);
						if($productAttributeParams) {
							$params += array(
								'productAttributes' => array(
									'productAttribute' => $productAttributeParams,
								),
							);
						}
						if($deleteParams) {
							$params += array(
								'removeProductAttributeIDs' => array(
									'productAttributeID' => $deleteParams,
								),
							);
						}

						$sq =& new MBQuery("SetProducts", "update", $params);
						
						//show($sq);
						//exit;
						
						$setResult =& $sq->getResult();
					} else {
						$skipSuccess = true;
					}
					//echo '</pre>';

					/*
					//print_r($_REQUEST);
					//print_r($params);
					print_r($setResult);
					echo '</pre>';
					exit;
					/**/


					if($skipSuccess || $setResult->getSuccess()) {
						redirect(
							"products.php", getActionID("EditProductAttributes"),
							array(
								"productID" => $productID,
								"loadActionFile" => "products",
								"loadActionID" => getActionID("EditProductAttributes"),
							)
						);
					}

				}
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

}
?>
