<?php
// $Id: EditProductChildren.php,v 1.10 2006/08/01 17:58:14 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/app-modernbill-admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/types.php");
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * product <-> child product relation editor
 *
 * @author  Ben Woolley
 */
class EditProductChildren extends MB_ProductAction {
	/**
	 * The constructor for a EditProductChildren action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditProductChildren() {
		parent::MB_ProductAction("children");
		$this->stringRep = "EditProductChildren";
		$this->params = array("productID", "productAddonGroupID");
	}

	/**
	 * The main method of this class that executes the EditProductChildren action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$productID = getParam("productID");
		if(!$productID) {
			$this->addError(TRANS_ACTIONERROR, "No product ID given.");
		} else {
			

			$product = grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetProducts",
					"params" => array(
						"productID" => $productID,
					),
				),
			));
			$types = $CONF["types"]["products"];

			$this->setupTypeButtons($product["productType"]);
			$this->smartyVars["productButtons"] = $this->productButtons->getButtons();

			$this->smartyVars['product'] = $product;
			$this->smartyVars['types'] = $types;				


			$this->smartyVars["selectedChildren"] = grabHTMLOpsFromArray(grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetProducts",
						"params" => array(
							"parentProductID" => $productID,
							"productAddonGroupID" => (int)$_REQUEST["productAddonGroupID"],
						),
					),
				)), "productID", "productName");
			
			$this->smartyVars["selectableChildren"] = grabHTMLOpsFromArray(grabResultsFromMBAPIArray(array(
					"mbapi" => array(
						"command" => "GetProducts",
						"params" => array(
							"productAddonGroupID" => (int)$_REQUEST["productAddonGroupID"],
						),
					),
				)), "productID", "productName", array_keys($this->smartyVars["selectedChildren"]));
				
			$this->addTemplate("widgets/products/EditProductChildren", $this->smartyVars);
		
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
