<?php
// $Id: EditProductChildrenResponse.php,v 1.9 2006/08/01 17:58:14 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * This Action object takes information provided by the EditProductChildren action, applies that information to
 * records in the database, and redirects to the ShowProductDetails action for the given product.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class EditProductChildrenResponse extends MB_Action {
	/**
	 * The constructor for an EditProductChildrenResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditProductChildrenResponse() {
		parent::MB_Action();
		$this->stringRep = "EditProductChildrenResponse";
		$this->params = array(
			"productID",
			"productChildren",
		);
	}

	/**
	 * The main method of this class that executes the EditProductChildrenResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		if ($_REQUEST["disassociateID"]){
			dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "SetProducts",
					"subCommand" => "update",
					"params" => array(
						"productID" => $_REQUEST["productID"],
						"removeProductChildrenIDs" => array(
							"productID" => (int)$_REQUEST["disassociateID"],
						),
					),
				),
			)));
			redirect(
				"products.php", getActionID("ShowProductAddons"),
				array(
					"productID" => $_REQUEST["productID"],
				)
			);
		} else {
		
			if ((int)$_REQUEST["productID"]){
				
				dispatchMBAPI(toXML(array(
					"mbapi" => array(
						"command" => "SetProducts",
						"subCommand" => "update",
						"params" => array(
							"productID" => (int)$_REQUEST["productID"],
							"productChildrenIDs" => array(
								"productID" => (array)$_REQUEST["productChildren"],
							),
							"removeProductChildrenIDs" => array(
								"productID" => (array)$_REQUEST["selectableProductChildren"],
							),
						),
					),
				)));

			}

		}
			
		redirect(
			"products.php", getActionID("ShowProductAddons"),
			array(
				"productID" => $_REQUEST["productID"],
			)
		);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
