<?php
// $Id: EditProductResponse.php,v 1.41 2006/07/31 23:40:48 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * This Action object takes information provided by the EditProduct action, applies that information to
 * records in the database, and redirects to the ShowProductDetails action for the given product.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class EditProductResponse extends MB_Action {
	/**
	 * The constructor for an EditProductResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditProductResponse() {
		parent::MB_Action();
		$this->stringRep = "EditProductResponse";
		$this->params = array(
			"productID",
			"productName",
			"productType",
			"productComments",
			"productActive",
			"productIsAddon",
			"productAddonGroupID",
			"productStopNumCycles",
			"productProratable",
			"productDateCreated",
			"productDomainRequired",
			"productCancellationType",
			"productAddonRequired",
		);
	}

	/**
	 * The main method of this class that executes the EditProductResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$this->setReferralActionID(getActionID("ShowProductDetails"));
		$this->setReferralActionFile("products.php");
		
		$this->productInfo = correctArray(grabFirstResultFromMBAPIArray(
			array(
				"mbapi" => array(
					"command" => "GetProducts",
					"params" => array(
						"productID" => (int)$_REQUEST["productID"],
						"getProductAttributeData" => 1,
					)
				)
			)
		));
		
		$attributeIDs = array();
		foreach ((array)$this->productInfo["productAttributes"] as $att){
			$attributeIDs[] = $att["productAttributeID"];
		}
		
		/*
		echo '<pre>';
		print_r($_REQUEST);
		echo '</pre>';
		exit;
		/**/

		if(isset($_REQUEST['billingPlan']) && ($billingPlan = $_REQUEST["billingPlan"])) {
			dbg($billingPlan);
			if((int)$billingPlan==1) {
				$_REQUEST["productStopNumCycles"] = 0;
			} else if((int)$billingPlan==2) {
				$_REQUEST["productStopNumCycles"] = 1;
			} else if (!$_REQUEST["productStopNumCycles"]){
				$_REQUEST["productStopNumCycles"] = 2;
			}
		}
		
		dbg($_REQUEST);
		
		if ($_REQUEST["addonAttribute"]!=0){
		
			dbg($attributeIDs);
		
			$info = explode("|", $_REQUEST["addonAttribute"]);
			$serverGroupID = $info[0];
			$productAttributeName = $info[1];
			if ((int)$serverGroupID && $productAttributeName){
				dbg("removing current ones and adding new one of \"$productAttributeName\"");
				dispatchMBAPI(toXML(array(
					"mbapi" => array(
						"command" => "SetProducts",
						"subCommand" => "update",
						"params" => array(
							"productID" => (int)$_REQUEST["productID"],
							"productAddonAttributeName" => $productAttributeName,
							"productAttributes" => array(
								"productAttribute" => array(
									"productAttributeName" => $productAttributeName,
									"productID" => (int)$_REQUEST["productID"],
									"productAttributeValue" => "",
									"serverGroupID" => $serverGroupID,
									"productAttributeDateCreated" => time(),
								),
							),
							"removeProductAttributeIDs" => array("productAttributeID" => $attributeIDs)
						)
					)
				)));
			} else {
				dbg("just removing current attributes");
				dispatchMBAPI(toXML(array(
					"mbapi" => array(
						"command" => "SetProducts",
						"subCommand" => "update",
						"params" => array(
							"productID" => (int)$_REQUEST["productID"],
							"productAddonAttributeName" => "",
							"removeProductAttributeIDs" => array("productAttributeID" => $attributeIDs)
						)
					)
				)));
			}
		}
		
		$success = $this->validateMultiInputs(
			array(
				"productID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"productName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"productType" => INPUT_RESTRICTION_UNSIGNED_INT,
				"productComments" => INPUT_RESTRICTION_STRING,
				"productActive" => INPUT_RESTRICTION_BOOL,
				"productIsAddon" => INPUT_RESTRICTION_BOOL,
				"productAddonGroupID" => INPUT_RESTRICTION_INT,
				"productStopNumCycles" => INPUT_RESTRICTION_UNSIGNED_INT,
				"productCancellationType" => INPUT_RESTRICTION_UNSIGNED_INT,
				"productProratable" => INPUT_RESTRICTION_BOOL,
				"productDateCreated" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
			),
			array(),
			array(),
			1
		);
		
		if($success) {

			$productID = ((int) $_REQUEST["productID"]);
			if(!$productID) {
				$this->addError(TRANS_ACTIONERROR, "No product ID given.");
			} else {

				if(isset($_REQUEST['productType'])) {
					$this->syncProductVariants($productID, $_REQUEST['productType']);
				}

 				$params = array();
				$this->applyRequestTo($params);
				if (!$params["productStopNumCycles"])$params["productStopNumCycles"] = 0;
				
				$setQuery =& new MBQuery("SetProducts", "update", $params);
				$setResult =& $setQuery->getResult();

				/*
				echo '<pre>';
				//print_r($_REQUEST);
				//print_r($pd);
				//print_r($pvd);
				print_r($product);
				print_r($productVariants);
				//print_r($setQuery);
				//print_r($setResult);
				echo '</pre>';
				exit;
				/**/
											
				if($setResult->getSuccess()) {
					if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
						redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
					} else {
						redirect("products.php", getActionID("ShowProductDetails"), array("productID"=>$productID));
					}
				}
			}
		}
		//exit;

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditProductResponse
?>
