<?php
// $Id: EditProductTLDsResponse.php,v 1.9 2006/06/01 01:14:03 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/toolkit.php");
require_once mb_path("/lib-modernbill/include/config/internal/datasources.php");

/**
 * This Action object takes information provided by the EditProductTLDs action, applies that information to
 * records in the database, and redirects to the ShowProductDetails action for the given product.
 *
 * @author  Ben Woolley
 */
class EditProductTLDsResponse extends MB_Action {
	/**
	 * The constructor for an EditProductTLDsResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditProductTLDsResponse() {
		parent::MB_Action();
		$this->stringRep = "EditProductTLDsResponse";
		$this->params = array(
			"productID",
			"TLDs",
		);
	}

	/**
	 * The main method of this class that executes the EditProductTLDsResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		//echo '<pre>';
		//print_r($_REQUEST);
		do {
			if($this->err($productID = $this->validateParam("productID", INPUT_RESTRICTION_POSITIVE_INT|INPUT_RESTRICTION_REQUIRED), "No appropriate product ID given")) break;

			$d =& new DataSource("productVariants", array("productID" => $productID));
			if(!$s =& $this->getSubjectFromSource($d)) return false;
			$t =& $s->getTable();
			$at =& $t->getAssociatedTablesBy("productVariantActive");
			$tt =& $at[1];
			$selectedIDs = (array) $_REQUEST["TLDs"];
			if(is_object($tt)) {
				$currentIDs = $tt->getColumnDistinct("productVariantID");
			} else {
				$currentIDs = array();
			}
			$changes = $this->getRelationUpdateIDs($selectedIDs, $currentIDs);
			//print_r($changes);
			
			$productVariants = array();
			foreach($changes['add'] as $id) {
				$productVariants[] = array(
					'productVariantID' => $id,
					'productVariantActive' => 1,
				);
			}
			foreach($changes['remove'] as $id) {
				$productVariants[] = array(
					'productVariantID' => $id,
					'productVariantActive' => 0,
				);
			}
			//print_r($productVariants);
			
			if($productVariants) {
				$setVariantQuery =& new MBQuery(
					"SetProducts",
					"update",
					array(
						"productID" => $productID,
						"productVariants" => array(
							"productVariant" => $productVariants,
						),
					)
				);
				//echo '<pre>';
				//echo htmlentities($setVariantQuery->getXMLQuery());
				//echo '</pre>';
				//exit;
			
				if(!$this->addErrorsFromResult($r =& $setVariantQuery->getResult())) break;
			}
			
			if(!$this->goBack()) {
				//exit;
				redirect(
					"products.php", getActionID("EditProductTLDs"),
					array(
						"productID" => $productID,
						"loadActionFile" => "products",
						"loadActionID" => getActionID("EditProductTLDs"),
					)
				);
			}
			
		} while(false);
		//print_r($r);
		//echo '</pre>';
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
