<?php
// $Id: EditProductVariantPrices.php,v 1.8 2006/06/16 03:42:44 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/datasources.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");
require_once mb_path("/lib-tk/toolkit.php");

class EditProductVariantPrices extends MB_Action {
	function EditProductVariantPrices() {
		parent::MB_Action();
		$this->stringRep = "EditProductVariantPrices";
		$this->params = array();
	}
	
	function execute() {
		global $CONF;
		parent::execute();
		
		//echo '<pre>';
		do {
			if($this->err($productVariantID = $this->validateParam("productVariantID", INPUT_RESTRICTION_POSITIVE_INT|INPUT_RESTRICTION_REQUIRED), "No appropriate product variant ID given")) break;
			
			$d =& new DataSource(
				"products",
				array(
					"productVariantID" => $productVariantID,
					"getProductVariantData" => 1,
					"getProductVariantPriceData" => 1,
					"getOrderFormData" => 1,
					"getCycleGhostData" => 1,
					"getTLDGhostData" => 1,
				)
			);
		
			if(!$s =& $this->getSubjectFromSource($d)) return false;
			$t =& $s->getTable();
			$product = $t->getOne();
			$domainType = (int) $product["productType"] === (int) getTypeID("products", TRANS_DOMAIN_PRODUCT) ? true : false;
			
			$pvs =& $s->newFrom(array("productVariants", "productVariant"));
			$pvps =& $s->newFrom(array("productVariantPrices", "productVariantPrice"));
			$os =& $s->newFrom(array("orderForms", "orderForm"));
			$cs =& $s->newFrom(array("ghostCycles", "ghostCycle"));
			if($domainType) {
				$ts =& $s->newFrom(array("ghostTLDs", "ghostTLD"));
			}
			
			$pvt =& $pvs->getTable();
			$productVariant =& $pvt->getOne();
			dbg("product variant data we have:");
			dbg($productVariant);
			
			$pvpt =& $pvps->getTable();
			$ot =& $os->getTable();
			$ct =& $cs->getTable();
			$ct->setKey("cycleID");
			$ct->setName("cycleDisplayName");
			if($domainType) {
				$tt =& $ts->getTable();
			}
			
			$currencyIDs = $ot->getColumnDistinct("paymentGroupCurrencyID");

			$TLD = $domainType ? $tt->getOne() : array();
			$this->smartyVars["TLD"] = $TLD;
			$this->smartyVars["transferPriceType"] = getTypeID("price", TRANS_TRANSFER);

			$ct->resolveNameConstants();
			if($domainType) {
				$minCycleID = $TLD["tldMinimumCycleID"];
				$maxCycleID = $TLD["tldMaximumCycleID"];
				$ctByID =& $ct->getAssociated();
				
				// get more cycles, if needed
				$neededCycleIDs = array();
				if(!isset($ctByID[$minCycleID])) $neededCycleIDs[] = $minCycleID;
				if(!isset($ctByID[$maxCycleID])) $neededCycleIDs[] = $maxCycleID;
				if($neededCycleIDs) {
					$cids = $neededCycleIDs;
					$ecd =& new DataSource("cycles", array("cycleID" => $cids));
					$ecs =& $ecd->getSubject();
					$ect =& $ecs->getTable();
					$act =& $ct->getMergedWith($ect);
					$actByID = $act->getAssociated();
				} else {
					$act =& $ct;
					$actByID =& $ctByID;
				}
				
				/*
				echo '<pre>';
				print_r($ct);
				print_r($ect);
				print_r($act);
				print_r($ecd);
				print_r($minCycleID);
				print_r($maxCycleID);
				print_r($ctByID);
				print_r($actByID);
				echo '</pre>';
				*/

				$this->minCycle = $actByID[$minCycleID];
				$this->maxCycle = $actByID[$maxCycleID];
				$callback = array();
				$callback[] =& $this;
				$callback[] = "validateCycle";
				$fct =& $ct->getFilteredTable($callback);
				
				/*
				echo '<pre>';
				print_r($TLD);
				print_r($this->minCycle);
				print_r($this->maxCycle);
				print_r($act);
				print_r($fct);
				echo '</pre>';
				*/
				
				$cycles = $fct->getOptions();
			} else {
				$cycles = $ct->getOptions();
			}
			//echo '<pre>';
			//print_r($s);
			//echo '</pre>';
			
			$neededPriceTypes = array(
				getTypeID("price", TRANS_GENERAL),
				getTypeID("price", TRANS_SETUP),
			);
			if($domainType) {
				$neededPriceTypes[] = getTypeID("price", TRANS_TRANSFER);
			}

			$questions = array();
			$currencyPrices =& $pvpt->getAssociatedTablesBy("currencyID");
			foreach($currencyIDs as $currencyID) {
				$questions[$currencyID] = array();
				if(isset($currencyPrices[$currencyID])) {
					$cyclePrices =& $currencyPrices[$currencyID]->getAssociatedTablesBy("cycleID");
				} else {
					$cyclePrices = false;
				}
				
				foreach($cycles as $cycleID => $cycleDisplayName) {
					$questions[$currencyID][$cycleID] = array();
					if($cyclePrices && isset($cyclePrices[$cycleID])) {
						$typePrices =& $cyclePrices[$cycleID]->getAssociatedTablesBy("productVariantPriceType");
					} else {
						$typePrices = false;
					}
					
					foreach($neededPriceTypes as $neededPriceType) {
						if($cyclePrices && $typePrices && isset($typePrices[$neededPriceType])) {
							$priceData = $typePrices[$neededPriceType]->getOne();
							$price = array(
								$priceData['productVariantPriceAmount'],
								$priceData['productVariantPriceID'],
							);
						} else {
							$price = array(
								"0.00",
								NULL,
							);
						}
						$questions[$currencyID][$cycleID][$neededPriceType] = $price;
					}

				}
			}


			// get all tax zone groups as simple results
			$taxZoneGroups = grabSimpleMBAPIResults(dispatchMBAPI("<mbapi><command>GetTaxZoneGroups</command></mbapi>", 1));
			// grab the selectable ones while passing the ignore ID array
			$this->smartyVars["selectableTaxZoneGroups"] = grabHTMLOpsFromArray($taxZoneGroups, "taxZoneGroupID", "taxZoneGroupName");


			$priceTypes = $CONF["types"]["price"];
			$productTypes = $CONF["types"]["products"];
			$this->smartyVars['priceTypes'] = $priceTypes;
			$this->smartyVars['productTypes'] = $productTypes;
			$this->smartyVars['productTypeIndex'] = array_flip($productTypes);

			$this->smartyVars['questions'] = $questions;
			$this->smartyVars['product'] = $product;
			$this->smartyVars['productVariant'] = $productVariant;
			$this->smartyVars['cycles'] = $cycles;
			$tmp = explode(";", $CONF["user"]["locale"]->localeArray["locale_pattern_currency"]);

			$tmp[0] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[0]);
			$tmp[1] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[1]);
			if (!$tmp[1])$tmp[1] = $tmp[0];
			$CONF["user"]["locale"]->localeArray["locale_pattern_currency"] = $tmp[0].";".$tmp[1];
 			$this->smartyVars["localeArray"] =  $CONF["user"]["locale"]->localeArray;
			
			/*
			print_r($d->getResult());
			print_r($t);
			print_r($pvt);
			print_r($pvpt);
			print_r($ot);
			print_r($ct);
			print_r($cycles);
			print_r($currencyIDs);
			print_r($neededPriceTypes);
			print_r($product);
			echo (int) $domainType;
			print_r($questions);
			*/

			$formDefaults = array(); //$prices;
			$this->mergeFormState($formDefaults);
			$this->addTemplate("widgets/products/EditProductVariantPrices");
			
			
			
		} while(false);
		//echo '</pre>';
	}
	
	/**
	 * validate the cycles, for filtering
	 *
	 * @param  array  cycle
	 */
	function validateCycle($cycle) {
		$minDuration = $this->getDuration($this->minCycle);
		$maxDuration = $this->getDuration($this->maxCycle);
		$ourDuration = $this->getDuration($cycle);
		/*
		echo '<pre>';
		echo print_r($this->minCycle, 1) . " 1= " . $minDuration . "\n";
		echo print_r($this->maxCycle, 1) . " 2= " . $maxDuration . "\n";
		echo print_r($cycle, 1) . " 3= " . $ourDuration . "\n";
		echo '</pre>';
		*/
		//echo '<pre>' . $ourDuration .' >= '. $minDuration .' && '. $ourDuration .' <= '. $maxDuration . "\n</pre>";
		
		return $ourDuration >= $minDuration && $ourDuration <= $maxDuration;
	}
	
	/**
	 * get cycle duration
	 *
	 * @param  array  of cycle data
	 */
	function getDuration($cycle) {
		return mktime(
			$cycle["cycleNumSeconds"],
			$cycle["cycleNumMinutes"],
			$cycle["cycleNumHours"],
			$cycle["cycleNumDays"],
			$cycle["cycleNumMonths"],
			$cycle["cycleNumYears"]
		);
	}
}

?>
