<?php
// $Id: EditProductVariantPricesResponse.php,v 1.7 2006/03/22 20:40:52 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/datasources.php");
require_once mb_path("/lib-tk/toolkit.php");

class EditProductVariantPricesResponse extends MB_Action {
	function EditProductPricesResponse() {
		parent::MB_Action();
		$this->stringRep = "EditProductVariantPricesResponse";
		$this->params = array(
			"productID",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();
		
		//echo '<pre>';
		do {

			$this->setReferralActionID(getActionID("EditProductVariantPrices"));
			$this->setReferralActionFile("products.php");

			if($this->err($productID = $this->validateParam("productID", INPUT_RESTRICTION_POSITIVE_INT|INPUT_RESTRICTION_REQUIRED), "Did not get appropriate product ID")) break;
			if($this->err($productVariantID = $this->validateParam("productVariantID", INPUT_RESTRICTION_POSITIVE_INT|INPUT_RESTRICTION_REQUIRED), "Did not get appropriate product variant ID")) break;

			$setTaxZoneXML	= "	<mbapi>
									<command>SetProducts</command>
									<subCommand>update</subCommand>
									<params>
										<productID>".$productID."</productID>
										<productVariants>
											<productVariant>
												<productVariantID>".$productVariantID."</productVariantID>
												<taxZoneGroupID>".(int)$_REQUEST["taxZoneGroupID"]."</taxZoneGroupID>
											</productVariant>
										</productVariants>
									</params>
								</mbapi>";
			$setTaxZone = dispatchMBAPI($setTaxZoneXML, 1);

			dbg("set cmd:");
			dbg($setTaxZoneXML);
			dbg("result of set:");
			dbg($setTaxZone);

			$byPrice = array();
			foreach($_REQUEST as $arg => $val) {
				$matches = array();
				if(preg_match("/^(price|id)_([A-Z]{3})_([0-9]+)_([0-9]+)$/", $arg, $matches)) {
					//print_r($matches);
					list($entirety, $field, $currencyID, $cycleID, $priceType) = $matches;
					if($field == "price") {
						$_REQUEST[$arg] = (float) $this->getNumberFromInput($val);
					}
					
					$this->validateParam($arg, $field == "id" ? INPUT_RESTRICTION_UNSIGNED_INT : INPUT_RESTRICTION_PRICE|INPUT_RESTRICTION_REQUIRED);
					$priceKey = serialize(array($currencyID, $cycleID, $priceType));
					if(!isset($byPrice[$priceKey])) $byPrice[$priceKey] = array();
					$byPrice[$priceKey][$field] = $_REQUEST[$arg];
				}
			}

			//print_r($_REQUEST);
			
			$productVariantPrices = array();		
			foreach($byPrice as $priceKey => $price) {
				list($currencyID, $cycleID, $priceType) = unserialize($priceKey);
			
				$productVariantPrice = array(
					'productVariantPriceType' => $priceType,
					'productVariantPriceAmount' => (float) $price['price'],
					'productVariantID' => $productVariantID,
					'currencyID' => $currencyID,
					'cycleID' => $cycleID,
				);
				if($price['id']) {
					$productVariantPrice['productVariantPriceID'] = (int) $price['id'];
				}
				$productVariantPrices[] = $productVariantPrice;
			}
			$newProductVariantPrices =& new Table($productVariantPrices, "productVariantPriceID");
			//$newProductVariantPricesByID =& $newProductVariantPrices->getAssociatedTables();
			
			//print_r($productVariantPrices);
			//print_r($newProductVariantPrices);
			//print_r($newProductVariantPricesByID);

			if(!$this->validationRedirect()) break;
			
			$d =& new DataSource(
				"products",
				array(
					"productVariantID" => $productVariantID,
					"getProductVariantPriceData" => 1,
				)
			);
		
			if(!$s =& $this->getSubjectFromSource($d)) return false;
			$t =& $s->getTable();
			$product = $t->getOne();
			//$domainType = (int) $product["productType"] === (int) getTypeID("products", TRANS_DOMAIN_PRODUCT) ? true : false;
			
			$pvps =& $s->newFrom(array("productVariantPrices", "productVariantPrice"));
			
			$oldProductVariantPrices =& $pvps->getTable();
			$oldProductVariantPrices->setKey("productVariantPriceID");
			$oldProductVariantPricesByID = $oldProductVariantPrices->getAssociated();
			
			//print_r($oldProductVariantPrices);
			
			$updateProductPriceVariants = array();
			foreach($productVariantPrices as $productVariantPrice) {
				if(isset($productVariantPrice["productVariantPriceID"])) {
					$productVariantPriceID = $productVariantPrice["productVariantPriceID"];
					$oldPrice = (array) $oldProductVariantPricesByID[$productVariantPriceID];
					$oldPrice['productVariantPriceAmount'] = (float) $oldPrice['productVariantPriceAmount'];
					$diffPrice = array_diff_assoc($productVariantPrice, $oldPrice);
					if($diffPrice) {
						$updateProductPriceVariants[] = $diffPrice + array("productVariantPriceID" => $productVariantPriceID);
					}
				} else {
					$updateProductPriceVariants[] = $productVariantPrice;
				}
			}
			
			//print_r($updateProductPriceVariants);
			
			$oldProductVariantPriceIDs = $oldProductVariantPrices->getKeys();
			$newProductVariantPriceIDs = $newProductVariantPrices->getKeys();
			$deleteProductPriceVariantIDs = array_diff($oldProductVariantPriceIDs, $newProductVariantPriceIDs);
			
			if($updateProductPriceVariants || $deleteProductPriceVariantIDs) {
				$setParams = array(
					"productID" => $productID,
				);
				if($updateProductPriceVariants) {
					$setParams += array(
						"productVariants" => array(
							"productVariant" => array(
								"productVariantID" => $productVariantID,
								"productVariantPrices" => array(
									"productVariantPrice" => $updateProductPriceVariants,
								),
							),
						),
					);
				}
				if($deleteProductPriceVariantIDs) {
					$setParams += array(
						"removeProductVariantPriceIDs" => array(
							"productVariantPriceID" => $deleteProductPriceVariantIDs,
						),
					);
				}
			} else {
				$setParams = false;
			}
			
			if($setParams) {
				$updateQuery =& new MBQuery("SetProducts", "update", $setParams);

				//echo "<pre>";
				//echo htmlentities($updateQuery->getXMLQuery());
				//echo "</pre>";
				//exit;

				if(!$this->addErrorsFromResult($updateResult =& $updateQuery->getResult())) break;
				//print_r($updateResult);

				//echo "</pre>";
			}
			if(!$this->goBack()) {
				//exit;
				redirect(
					"products.php", getActionID("ShowProductVariants"),
					array(
						"productID" => $productID,
						"productVariantActive" => 1,
						//"productVariantID" => $productVariantID,
					)
				);
			}
			
			
		} while(false);
		//echo '</pre>';
	}
}
?>