<?php
// $Id: EditUsagePricing.php,v 1.6 2006/06/01 01:14:03 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/app-modernbill-admin/include/lib-action/products/ShowProductDetailsAction.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/types.php");
require_once mb_path("/lib-modernbill/include/config/internal/emailactions.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * edit the prices for usage in each currency neccessary.
 *
 * @author  Kris Bailey
 */
class EditUsagePricing extends MB_ProductAction {
	/**
	 * The constructor for a EditUsagePricing action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditUsagePricing() {
		parent::MB_ProductAction("usage");
		$this->stringRep = "EditUsagePricing";
		$this->params = array("productID");
	}

	/**
	 * The main method of this class that executes the EditProductOrderForms action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$productID = getParam("productID");
		$this->smartyVars["productID"] = $productID;
		if(!$productID) {
			$this->addError(TRANS_ACTIONERROR, "No product ID given.");
		} else {
		 	$getUsagePriceXML = "
				<mbapi>
					<command>GetProductUsagePrices</command>
					<params>
						<productID>".$productID."</productID>
					</params>
				</mbapi>
		 		";
			$usagePriceData = dispatchMBAPI($getUsagePriceXML, 1);
			dbg("usage price data");
			dbg($usagePriceData);
			$usagePrices = array();
			if (isset($usagePriceData["mbapi"][0]["results"][0]["productUsagePrices"][0]["productUsagePrice"])){
				if(is_array($usagePriceData["mbapi"][0]["results"][0]["productUsagePrices"][0]["productUsagePrice"])) {
					foreach ($usagePriceData["mbapi"][0]["results"][0]["productUsagePrices"][0]["productUsagePrice"] as $row){
						$usagePrices[$row["currencyID"][0]] = $row["productUsagePriceAmount"][0];
					}
				}
			}
			$this->smartyVars["oldPrices"] = $usagePrices;
		 	$getProductXML = "
				<mbapi>
					<command>GetProducts</command>
					<params>
						<productID>".$productID."</productID>
						<getOrderFormData>1</getOrderFormData>
					</params>
				</mbapi>
		 		";
			$productInfo = dispatchMBAPI($getProductXML, 1);
			dbg("product info");
			dbg($productInfo);
			if (isset($productInfo["mbapi"][0]["results"][0]["products"][0]["product"][0]["orderForms"][0]["orderForm"][0])){
				$this->smartyVars["product"] = correctArray($productInfo["mbapi"][0]["results"][0]["products"][0]["product"][0]);
				$orderForms = collapseArrayElements($productInfo["mbapi"][0]["results"][0]["products"][0]["product"][0]["orderForms"][0]["orderForm"]);
				if ((int)$orderForms["orderFormID"]){
				 	$orderForms = array($orderForms);
				}

				$makeFields = array();

				foreach ($orderForms as $row){
				 	$makeFields[] = $row["paymentGroupCurrencyID"];
				}
				$this->smartyVars["makeFields"] = $makeFields;

			}
			$this->smartyVars["helpRowSpan"] = count($this->smartyVars["makeFields"]);
			


			$this->setupTypeButtons($this->smartyVars["product"]["productType"]);
			$this->smartyVars["productButtons"] = $this->productButtons->getButtons();


			$tmp = explode(";", $CONF["user"]["locale"]->localeArray["locale_pattern_currency"]);

			$tmp[0] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[0]);
			$tmp[1] = ereg_replace("^¤#0.00", "¤#,##0.00", $tmp[1]);
			$CONF["user"]["locale"]->localeArray["locale_pattern_currency"] = $tmp[0].";".$tmp[1];
 			$this->smartyVars["localeArray"] =  $CONF["user"]["locale"]->localeArray;
			$this->smartyVars["numPrices"] = count($this->smartyVars["makeFields"]);
			dbg($this->smartyVars);
			$this->addTemplate("widgets/products/EditUsagePricing", $this->smartyVars);

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
