<?php
// $Id: EditUsagePricingResponse.php,v 1.4 2006/06/01 01:14:03 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * This Action object takes information provided by the EditUsagePricingResponse action, applies that information to
 * records in the database, and redirects to the EditUsagePricingResponse action for the given product.
 *
 * @author  Kris Bailey
 */
class EditUsagePricingResponse extends MB_Action {
	/**
	 * The constructor for an EditUsagePricingResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditUsagePricingResponse() {
		parent::MB_Action();
		$this->stringRep = "EditUsagePricingResponse";
	}

	/**
	 * The main method of this class that executes the EditUsagePricingResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->setReferralActionID(getActionID("ShowProductDetails"));
		$this->setReferralActionFile("products.php");

		$productID = ((int) $_REQUEST["productID"]);
		if(!$productID) {
			$this->addError(TRANS_ACTIONERROR, "No product ID given.");
		} else {

			$delQueryXML = "
				<mbapi>
					<command>SetProductUsagePrice</command>
					<subCommand>delete</subCommand>
					<params>
						<productID>".$productID."</productID>
					</params>
				</mbapi>
				";
			$delResults = dispatchMBAPI($delQueryXML, 1);

			$prices = (array)$_REQUEST["usagePricing"];

			$setPrices = array();
			foreach ($prices as $k=>$v){
			 	$setPrices[] = array(secureInput($k), $this->getNumberFromInput($v));
			}

			foreach ($setPrices as $price){
			 	$setPriceXML = "
					<mbapi>
						<command>SetProductUsagePrice</command>
						<subCommand>insert</subCommand>
						<params>
							<productID>".$productID."</productID>
							<currencyID>".$price[0]."</currencyID>
							<productUsagePriceAmount>".$price[1]."</productUsagePriceAmount>
						</params>
					</mbapi>
			 		";
			 	$setResult = dispatchMBAPI($setPriceXML, 1);
			}


			if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
				redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
			} else {
				redirect(
					"products.php", getActionID("EditUsagePricing"),
					array(
						"productID" => $productID,
						"loadActionFile" => "products",
						"loadActionID" => getActionID("EditUsagePricing"),
					)
				);
			}

		}


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
