<?php
// $Id: RemoveLedgerGroup.php,v 1.3 2006/03/22 20:40:52 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This action checks to make sure they really want to delete this ledger group
 *
 * @author  Kris Bailey
 */
class RemoveLedgerGroup extends MB_Action {
	/**
	 * The constructor for a RemoveLedgerGroup action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This is also where $this->params is setup.
	 */
	function RemoveLedgerGroup() {
		parent::MB_Action();
		$this->stringRep = "RemoveLedgerGroup";
		$this->params = array("ledgerGroupID");
	}

	/**
	 * The main method of this class that executes the RemoveLedgerGroup action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$ledgerGroupID = getParam("ledgerGroupID");
		if(!$ledgerGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No Ledger Group ID given.");
		} else {

			$data = dispatchMBAPI("<mbapi><command>GetLedgerGroups</command><params><ledgerGroupID>".(int)$_REQUEST["ledgerGroupID"]."</ledgerGroupID></params></mbapi>", 1);
			dbg("group info:");
			dbg($data);
			$data = collapseArrayElements($data["mbapi"][0]["results"][0]["groups"][0]["group"]);

			$this->smartyVars["ledgerGroupName"] = $data["ledgerGroupName"];
			$this->smartyVars["productVariantID"] = (int)$_REQUEST["productVariantID"];
			$this->smartyVars["ledgerGroupID"] = (int)$_REQUEST["ledgerGroupID"];
			$this->addTemplate("products/RemoveLedgerGroup", $this->smartyVars);
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveLedgerGroup
?>