<?php
// $Id: RemoveLedgerGroupResponse.php,v 1.3 2006/03/22 20:40:52 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * removes a ledger group (response)
 *
 * @author  Kris Bailey
 */
class RemoveLedgerGroupResponse extends MB_Action {
	/**
	 * The constructor for a RemoveLedgerGroupResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function RemoveLedgerGroupResponse() {
		parent::MB_Action();
		$this->stringRep = "RemoveLedgerGroupResponse";
	}

	/**
	 * The main method of this class that executes the RemoveLedgerGroupResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$productVariantID = (int)$_REQUEST["productVariantID"];
		$ledgerGroupID = (int)$_REQUEST["ledgerGroupID"];
		dbg("request: ");
		dbg($_REQUEST);
		dbg("");
		if (!$ledgerGroupID){
			$this->addError(TRANS_ACTIONERROR, "No Ledger Group ID given.");
		} else {

			$removeXML = "	<mbapi>
								<command>SetLedgerGroups</command>
								<subCommand>delete</subCommand>
								<params>
									<ledgerGroupID>".$ledgerGroupID."</ledgerGroupID>
								</params>
							</mbapi>";

			$removeResult = dispatchMBAPI($removeXML, 1);

            if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
                redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
            } else {
                redirect("products.php?action=".getActionID("ShowProductVariants")."&queryColumn=productVariantID&query=".$productVariantID."&sid=".secureInput($_REQUEST["sid"]));
            }

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>