<?php
// $Id: ShowRegistrars.php,v 1.9 2006/06/23 21:06:20 mfountain Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on a Panel so that that it can be
 * configured and saved to the database.
 *
 * @author Brian Smith
 */
class ShowRegistrars extends MB_Action {
	/**
	 * The constructor for a ShowRegistrars action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function ShowRegistrars() {
		parent::MB_Action();
		$this->stringRep = "ShowRegistrars";
		$this->params = array("configGroupID");
	}

	/**
	 * The main method of this class that executes the ShowRegistrars action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$configGroupID = (int)$_REQUEST["configGroupID"];
		
		if(!$configGroupID) {
			$p = $this->getMBAPIQuery("GetConfigGroups", "", array("configGroupName" => "registrar"));
			$parent = grabSimpleMBAPIResults(dispatchMBAPI($p, 1));
			$configGroupID = $parentID = $parent[0]["configGroupID"];
		}

		if (!notZero( $configGroupID )) {
			$this->addError(TRANS_ACTIONERROR, "No Config Group ID given.");
		} else {
			$registrars = getAvailableModules("registrar");
			sort($registrars);
			$registrars = array_flip($registrars);
            
			loadConfigs("domain");

			if (is_array($CONF["domain"]["registrar"])) {
				$i=0;
				foreach($CONF["domain"]["registrar"] as $moduleName => $settings) {
					if($settings["configGroupID"] && isset($registrars[strtolower($moduleName).".php"])) {
						$configItems[$i]["configModuleName"] = $moduleName;
						$configItems[$i]["configGroupID"] = $settings["configGroupID"];
						$configItems[$i]["moduleDisplayName"] = $settings["moduleDisplayName"];
						$configItems[$i]["moduleEnabled"] = $settings["moduleEnabled"];
						$i ++;

						if(isset($registrars[strtolower($moduleName).".php"])) {
							unset($registrars[strtolower($moduleName).".php"]);
						}
					}
				}
			}

			$registrars = array_flip($registrars);
			if(count($registrars)) {
				foreach($registrars as $key => $value) {
					$registrars[$key] = basename($value, ".php");
				}
				$this->smartyVars["unusedRegistrars"] = $registrars;
			}
			$this->smartyVars["configGroups"] = $configItems;
			$this->mergeSystemNavData();
			$this->addTemplate("modules/ShowRegistrarModules", $this->smartyVars, 1);
		}
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>