<?php
// $Id: AddPanelResponse.php,v 1.4 2006/03/22 20:41:10 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the AddPaymentgroup action,
 * applies that information to  * records in the database, and redirects to the ShowServerGroups action.
 *
 * @author  Andy Christ
 */
class AddPanelResponse extends MB_Action {
	/**
	 * The constructor for an AddPanelResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function AddPanelResponse() {
		parent::MB_Action();
		$this->stringRep = "AddPanelResponse";
		$this->params = array("serverGroupID",
			"parentConfigGroupID");
	}

	/**
	 * The main method of this class that executes the AddPanelResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		$addGatewayArray = NULL;

		if ($_REQUEST["serverGroupID"]) {
			$serverGroupID = "<serverGroupID>".$_REQUEST["serverGroupID"]."</serverGroupID>";
		} else {
			$this->addError(TRANS_ACTIONERROR, "No ServerGroup ID given.");
		}
		if ($_REQUEST["parentConfigGroupID"] != "") {
			$parentConfigGroupID .= "<parentConfigGroupID>".$_REQUEST["parentConfigGroupID"]."</parentConfigGroupID>";
		} else if(!$_REQUEST["panelName"]) {
			$this->addError(TRANS_ACTIONERROR, "No Parent Config Group ID or Panel Name given.");
		} else if($_REQUEST["panelName"]) {
			$newPanel = secureInput($_REQUEST["panelName"]);
		}
		// Get the name of this panel
		if($serverGroupID && $parentConfigGroupID) {
			$h = &new QueryMaster("config_groups.config_group_name");
			$h->addCustomAndClause("config_group_id=".((int) $_REQUEST["parentConfigGroupID"]));
			$CONF["debug"]->add("MBAPI Query (AddPanelResponse)", $h->getQuery());
			$configGroupName = $h->getOne();
			if(!$configGroupName) {
				$this->addError(TRANS_ACTIONERROR, "Failed to find Panel Name.");
			} else {
				$parentConfigGroupName .= "<parentConfigGroupName>".$configGroupName."</parentConfigGroupName>";
			}

		}
		if($newPanel && !$parentConfigGroupID) {
			$parentConfigGroupName .= "<parentConfigGroupName>".$newPanel."</parentConfigGroupName>";
		}
		$query = "<mbapi>
					<command>SetPanels</command>
					<subCommand>insert</subCommand>
					<params>"
				.		$serverGroupID."\n"
				.		$parentConfigGroupID."\n"
				.		$parentConfigGroupName."\n
					</params>
				  </mbapi>";
		$data = dispatchMBAPI($query, 1);

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			
			if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
				redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
			} else {
				$id = $data["mbapi"][0]["header"][0]["lastInsertID"][0];
				if($id) {
					redirect("modules.php", getActionID("EditPanelConfig"), array("configGroupID"=>$id));
				} else {
					$this->addError(TRANS_ACTIONERROR, "Failed to find the New Panel ID.");
					redirect("servergroups.php", getActionID("ShowServerGroups"));
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddPanelResponse
?>