<?php
// $Id: CloneServerGroup.php,v 1.13 2006/03/22 20:41:10 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects the serverGroupID on a ServerGroup so that that ServerGroup can be cloned in the
 * database.  The original record is retrived and the details are sent back and created as a new record.
 *
 * @author  Andy Christ
 */
class CloneServerGroup extends MB_Action {
	/**
	 * The constructor for a EditServerGroup action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function CloneServerGroup() {
		parent::MB_Action();
		$this->stringRep = "EditServerGroup";
		$this->params = array("serverGroupID", "serverGroupFillType");
	}

	/**
	 * The main method of this class that executes the CloneServerGroup action asking the user to verify the clone
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$serverGroupID = ((int) $_REQUEST["serverGroupID"]);
		if(!$serverGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No ServerGroup ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetServerGroups");
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$s = array();
				$s["serverGroup"] = collapseArrayElements($data["mbapi"][0]["results"][0]["serverGroups"][0]["serverGroup"][0]);

				$this->addTemplate("servers/CloneServerGroup", $s, 1);
				

			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // CloneServerGroup
?>