<?php
// $Id: AddIPLog.php,v 1.12 2006/06/19 23:00:24 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object displays the add IP Log record template.
 *
 * @author  Andy Christ
 */
class AddIPLog extends MB_Action {
	/**
	 * The constructor for a AddIPLog action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function AddIPLog() {
		parent::MB_Action();
		$this->stringRep = "AddIPLog";
		
	}

	/**
	 * The main method of this class that executes the AddIPLog action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		//Get the Panel names for the select list
		$query =& new MBQuery("GetServerGroups", "", array("getPanels" => 1));
		$result = $query->getResult();
		
		if(!$result->getErrorCount()) {
			$serverGroups = grabSimpleMBAPIResults( $result->getStructure() );
			
			foreach($serverGroups as $key => $value) {
				if(is_array($value["panels"][0]["panel"])) {
					foreach($value["panels"][0]["panel"] as $panelItems) {
						if(notNull($panelItems["configParamValue"])) {
							$panels[ $panelItems["configGroupID"] ] = $panelItems["configParamValue"];
						} else {
							$panels[ $panelItems["configGroupID"] ] = $panelItems["configGroupID"];
						}
						unset($panelName);
					}
				} else {
					$panels[0] = TRANS_NO_SERVER_FOUND;
				}
			}
			
			$this->smartyVars["panels"] = $panels;
			
			$this->mergeSystemNavData();
		}
		
		$this->addTemplate("servers/AddIPLog");
		
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddIPLog
?>