<?php
// $Id: EditTaxZone.php,v 1.16 2006/03/22 20:41:10 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");

/**
 * This Action object collects information on a tax zone so that that the tax zone may be modified in the
 * database.
 *
 * @author  Mark Garrett
 */
class EditTaxZone extends MB_Action {
	/**
	 * The constructor for a EditTaxZone action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditTaxZone() {
		parent::MB_Action();
		$this->stringRep = "EditTaxZone";
		$this->params = array("taxZoneID");
	}

	/**
	 * The main method of this class that executes the EditTaxZone action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->smartyVars = array();
        $this->addLedgerAccounts();

		$taxZoneID = ((int) $_REQUEST["taxZoneID"]);
		if(!$taxZoneID) {
			$this->addError(TRANS_ACTIONERROR, "No taxzone ID given.");
		} else {
			$query = "	<mbapi>
							<command>GetTaxZones</command>
							<params>
								<taxZoneID>".$taxZoneID."</taxZoneID>
								<getTaxZoneGroupData>1</getTaxZoneGroupData>
							</params>
						</mbapi>";
 			$data = dispatchMBAPI($query, 1);
 			dbg("raw query:");
 			dbg($query);
 			dbg("raw data:");
 			dbg($data);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$this->mergeCountryData2();
				$this->smartyVars["taxzone"] = grabSimpleMBAPIResults($data); // grab the simple results
				$this->smartyVars["taxzone"] = $this->smartyVars["taxzone"][0]; // get the first of the simple results
				dbg($this->smartyVars["taxzone"]);
				if (isset($this->smartyVars["taxzone"]["taxZoneGroups"][0]["taxZoneGroup"])){ // if there are tax zone groups
					// get the selected tax zone groups for the multi select menu
					$this->smartyVars["selectedTaxZoneGroups"] = grabHTMLOpsFromArray($this->smartyVars["taxzone"]["taxZoneGroups"][0]["taxZoneGroup"], "taxZoneGroupID", "taxZoneGroupName");
				} else { // if there arent tax zone groups set some arrays
					dbg("didnt find tax zones");
					$this->smartyVars["taxzone"]["taxZoneGroups"][0]["taxZoneGroup"] = array();
					$this->smartyVars["selectedTaxZoneGroups"] = array();
				}

				// get all tax zone groups as simple results
				$taxZoneGroups = grabSimpleMBAPIResults(dispatchMBAPI("<mbapi><command>GetTaxZoneGroups</command></mbapi>", 1));
				// grab the selectable ones while passing the ignore ID array
				$this->smartyVars["selectableTaxZoneGroups"] = grabHTMLOpsFromArray($taxZoneGroups, "taxZoneGroupID", "taxZoneGroupName", array_keys($this->smartyVars["selectedTaxZoneGroups"]));

				// run the template...
				$this->addTemplate("taxes/EditTaxZone", $this->smartyVars, 1);

			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditTaxZone
?>