<?php
// $Id: RemoveTaxZone.php,v 1.14 2006/03/22 20:41:10 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object double checks that a user is sure they want to remove a TaxZone.
 *
 * @author  Mark Garrett
 */
class RemoveTaxZone extends MB_Action {
	/**
	 * The constructor for a RemoveTaxZone action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This is also where $this->params is setup.
	 */
	function RemoveTaxZone() {
		parent::MB_Action();
		$this->stringRep = "RemoveTaxZone";
		$this->params = array("taxZoneID");
	}

	/**
	 * The main method of this class that executes the RemoveTaxZone action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$taxZoneID = ((int) $_REQUEST["taxZoneID"]);
		if(!$taxZoneID) {
			$this->addError(TRANS_ACTIONERROR, "No Tax Zone ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetTaxZones");
			$data = dispatchMBAPI($query, 1);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$s = $smartyVars;
					$s["taxzone"] =
						collapseArrayElements($data["mbapi"][0]["results"][0]["taxZones"][0]["taxZone"][0]);

					$this->addTemplate("taxes/RemoveTaxZone", $s, 1);
					
				} else {
					$this->addError(TRANS_ACTIONERROR, "TaxZone not found.");
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveTaxZone
?>