<?php
// $Id: ShowTaxZoneDetails.php,v 1.15 2006/03/22 20:41:10 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. Using $_REQUEST["taxZoneID"] it displays all
 * the details for the found tax zone, and only displays the details of a single taxzone.
 *
 * @author  Mark Garrett
 */
class ShowTaxZoneDetails extends MB_Action {
	/**
	 * The constructor for a ShowTaxZoneDetails object. This merely sets up our string represenation, calls 
	 * the parent constructor, and sets up $this->params.
	 */
	function ShowTaxZoneDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowTaxZoneDetails";
		$this->params = array("taxZoneID");
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();


		$taxZoneID = ((int) $_REQUEST["taxZoneID"]);
		if(!$taxZoneID) {
			$this->addError(TRANS_ACTIONERROR, "No TaxZone ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetTaxZones");
			$data = dispatchMBAPI($query, 1);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$smartyVars["taxzone"] = $data["mbapi"][0]["results"][0]["taxZones"][0]["taxZone"][0];
					$smartyVars["taxzone"]["countryName"] = "TRANS_ISO_3166_".$smartyVars["taxzone"]["countriesISO2"][0];
					$this->addTemplate("taxes/ShowTaxZoneDetails", collapseArrayElements($smartyVars), 1);
					
				} else {
					$this->addError(TRANS_ACTIONERROR, "TaxZone does not exist.");
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowTaxZoneDetails
?>