<?php
// $Id: ShowTaxZones.php,v 1.13 2006/03/22 20:41:10 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all taxzones that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Mark Garrett
 */
class ShowTaxZones extends MB_Action {
	/**
	 * The constructor for a ShowTaxZones action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowTaxZones() {
		parent::MB_Action();
		$this->stringRep = "ShowTaxZones";
		
		$this->params = array(
			"taxZoneID",
			"countriesISO2",
			"taxZoneName",
			"taxZoneAmount",
			"taxZoneDescription",
			"taxZoneActive");
		$this->sortColumns = array("countriesISO2");
	}

	/**
	 * The main method of this class that executes the ShowTaxZones action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();



		$query = $this->getMBAPIQuery("GetTaxZones", "", array("getTaxZoneGroupData"=>1,"getLedgerAccountData"=>1), 1, 1, 1, 1);
		$results = dispatchMBAPI($query, 1);
		$data = grabSimpleMBAPIResults($results);

		$this->smartyVars = array();

		$this->smartyVars["taxzones"] = $data;

		if ($this->smartyVars["taxzones"]) {
			foreach($this->smartyVars["taxzones"] as $k=>$zone) {
				$this->smartyVars["taxzones"][$k]["countryName"] = constant("TRANS_ISO_3166_".$zone["countriesISO2"]);
			}
		}
		$this->smartyVars["paginationLinks"] = $results["mbapi"][0]["results"][0]["paginationLinks"][0];
		dbg("smarty Vars:");
		dbg($this->smartyVars);
		$this->addTemplate("taxes/ShowTaxZones", $this->smartyVars, 1);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowTaxZones
?>