<?php
// $Id: EditTheme.php,v 1.12 2006/05/31 20:40:40 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on a theme so that that the theme may be modified in the
 * database.
 *
 * @author  getActionFiles.php (Automatically Generated)
 * @author  Vic Fryzel
 */
class EditTheme extends MB_Action {
	/**
	 * The constructor for a EditTheme action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function EditTheme() {
		parent::MB_Action();
		$this->stringRep = "EditTheme";
		$this->params = array("themeID");
	}

	/**
	 * The main method of this class that executes the EditTheme action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$themeID = ((int) $_REQUEST["themeID"]);
		if(!$themeID) {
			$this->addError(TRANS_ACTIONERROR, "No theme ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetThemes", "", array());
			$data = dispatchMBAPI($query, 1);

			dbg("####################### GetThemes Results ######################");
			dbg($data);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$defaultFormValues = grabSimpleMBAPIResults( $data );
				$this->mergeFormState( $defaultFormValues[0] );
				
				$this->addTemplate("themes/EditTheme");
				
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditTheme
?>