<?php
// $Id: EditThemeResponse.php,v 1.11 2006/05/31 20:40:40 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the EditTheme action, applies that information to
 * records in the database, and redirects to the ShowThemeDetails action for the given theme.
 *
 * @author  getActionFiles.php (Automatically Generated)
 * @author  Vic Fryzel
 */
class EditThemeResponse extends MB_Action {
	/**
	 * The constructor for an EditThemeResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditThemeResponse() {
		parent::MB_Action();
		$this->stringRep = "EditThemeResponse";
		$this->params = array(
			"themeID",
			"themeName",
			"themeDisplayName",
			"themeActive");
	}

	/**
	 * The main method of this class that executes the EditThemeResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$themeID = ((int) $_REQUEST["themeID"]);
		if(!$themeID) {
			$this->addError(TRANS_ACTIONERROR, "No theme ID given.");
		} else {
			$this->setReferralActionID(getActionID("EditTheme"));
			$this->setReferralActionFile("themes.php");
			
			$success = $this->validateMultiInputs(array(
							"themeID" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED,
							"themeName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"themeDisplayName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
							"themeActive" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED),
							array(), array(), 0, array("themeID" => $themeID));

			if ($success) {
				$query = $this->getMBAPIQuery("SetThemes", "update", array());
				$data = dispatchMBAPI($query, 1);

				dbg("################ Returned from SetThemes ####################");
				dbg($data);
				
				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					if(!redirect("themes.php",getActionID("ShowThemes"))) {
						$this->addError(TRANS_ACTIONERROR, "Failed to redirect to theme list.");
					}	
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditThemeResponse
?>