<?php
// $Id: AddTodo.php,v 1.10 2006/05/02 20:00:37 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on a todo so that that todo may be added to the 
 * database.
 *
 * @author  Mark Garrett
 */
class AddTodo extends MB_Action {
	/**
	 * The constructor for a AddTodo action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object.
	 */
	function AddTodo() {
		parent::MB_Action();
		$this->stringRep = "AddTodo";
	}

	/**
	 * The main method of this class that executes the AddTodo action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		$this->smartyVars["todostatus"] = getStatuses("todo");

		$this->setupDateSelector("todoDateDue");

		// Get Admins data for select menu
		$this->smartyVars["adminsArray"] = correctArray( $this->getMBAPIData("GetAdmins", "admins", "admin", array("adminActive" => 1)) );

		foreach ($this->smartyVars["adminsArray"] as $admin) {
				$this->smartyVars["adminsList"][ $admin["adminID"] ] = $admin["adminFirstName"]." ".$admin["adminLastName"]." - ".$admin["adminUsername"];
		}
		
		$this->addTemplate("todos/AddTodo");
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddTodo
?>