<?php
// $Id: AddWebsiteWidget.php,v 1.4 2006/05/23 17:12:33 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action object collects info needed to display a website widget add form page.
 *
 * @author  Kris Bailey
 */
class AddWebsiteWidget extends MB_Action {
	/**
	 * The constructor for a AddWebsiteWidget action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function AddWebsiteWidget() {
		parent::MB_Action();
		$this->stringRep = "AddWebsiteWidget";
	}

	/**
	 * The main method of this class that executes the AddWebsiteWidget action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->smartyVars = array();

		$this->smartyVars["wwTemplates"] = array();

		if ($dh = opendir(mb_path("/lib-themes/".$CONF["theme"]["name"]."/app-modernbill-order/templates/website_widgets/"))) {
			while (($file = readdir($dh)) !== false) {
				if (strpos($file, ".tpl")){
					$this->smartyVars["wwTemplates"][str_replace(".tpl", "", $file)] = str_replace(".tpl", "", $file);
				}
			}
			closedir($dh);
		}

		$ofd = dispatchMBAPI("<mbapi><command>GetOrderForms</command></mbapi>", 1);
		$this->smartyVars["orderforms"] = grabHTMLOpsFromArray(grabSimpleMBAPIResults($ofd), "orderFormID", "orderFormName");
		dbg($this->smartyVars);
		$this->addTemplate("websitewidgets/AddWebsiteWidget", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddWebsiteWidget
?>
