<?php
// $Id: OrderCertCSRRequest.php,v 1.2 2006/06/08 21:32:52 bsmith Exp $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/certs.php");

/**
 *
 */
class OrderCertCSRRequest extends MB_Action {

	function OrderCertCSRRequest() {
		parent::MB_Action();
		$this->stringRep = "OrderCertCSRRequest";
		$this->params = array("certID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$certID = ((int) $_REQUEST["certID"]);
		if(!$certID) {
			$this->addError(TRANS_ACTIONERROR, "No Cert ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetCerts", "", array("certID" => $certID, "getProductPackage" => 1, "getClientData" => 1,"clientID"=>$CONF["user"]["id"]));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$this->smartyVars = array();
					$this->smartyVars["cert"] =
						collapseArrayElements($data["mbapi"][0]["results"][0]["certs"][0]["cert"][0]);

					$this->smartyVars["certID"] = $certID;
					$this->smartyVars["cert"]['ODProductCodeID'] = $this->smartyVars["cert"]['ODProductCode'];
					$this->smartyVars["cert"]['ODProductCode'] = getCertProductCode($this->smartyVars["cert"]['ODProductCode']);

					if (notNull( $_REQUEST["emptyCSR"] ))
						$this->smartyVars["emptyCSR"] = (int)$_REQUEST["emptyCSR"];
					
					// set vars based on product code
					switch ($this->smartyVars["cert"]["ODProductCodeID"]) {
				        case "QuickSSL":
				              $this->smartyVars["pageTitle"] = getCertName(0);
				              $this->smartyVars["agreementName"] = TRANS_QUICKSSL_AGREENAME;
				        break;
				        case "QuickSSLPremium":
				              $this->smartyVars["pageTitle"] = getCertName(1);
				              $this->smartyVars["agreementName"] = TRANS_QUICKSSL_PREMIUM_AGREENAME;
				        break;
				        case "TrueBizID":
				              $this->smartyVars["pageTitle"] = getCertName(2);
				              $this->smartyVars["agreementName"] = TRANS_TRUEBIZID_AGREENAME;
				        break;
				        case "RapidSSL":
				              $this->smartyVars["pageTitle"] = getCertName(3);
				              $this->smartyVars["agreementName"] = TRANS_RAPIDSSL_AGREENAME;
				        break;
					}
					
					$this->smartyVars["nextAction"] = "OrderCertCSRRequestResponse";
					
					$this->mergeFormState();
					
					$this->addTemplate("certs/OrderCertCSRRequest");
					
				} else {
					$this->addError(TRANS_ACTIONERROR, "Cert does not exist.");
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // OrderCertCSRRequest
?>