<?php
// $Id: OrderCertOrderSummary.php,v 1.2 2006/06/08 21:32:52 bsmith Exp $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+

require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/certs.php");

/**
 *
 */
class OrderCertOrderSummary extends MB_Action {

	function OrderCertOrderSummary() {
		parent::MB_Action();
		$this->stringRep = "OrderCertOrderSummary";
	}

	function execute() {
		global $CONF;
		parent::execute();

		$certID = (int)$_REQUEST["certID"];

		if (notZero( $certID )) {
			$query = $this->getMBAPIQuery("GetCerts", "", array("certID" => $certID,"clientID"=>$CONF["user"]["id"]));
			$data = grabSimpleMBAPIResults( dispatchMBAPI( $query, 1 ) );
			$data = $data[0];
			
			dbg( "#################### GetCerts  ####################" );
			dbg( $data );

			if (notZero( $data["certID"] )) {
				switch( $data["ODProductCode"] ) {
				case "QuickSSL":
					$this->smartyVars["pageTitle"] = getCertName(0);
					$this->smartyVars["show_order_info"] = true;
					$this->smartyVars["show_site_info"] = false;
					$this->smartyVars["show_csr_info"] = true;
					$this->smartyVars["show_org_info"] = false;
					$this->smartyVars["show_admin_info"] = true;
					$this->smartyVars["show_tech_info"] = true;
					$this->smartyVars["show_billing_info"] = false;
					$this->smartyVars["show_apvr_info"] = true;
				break;

				case "QuickSSLPremium":
					$this->smartyVars["pageTitle"] = getCertName(1);
					$this->smartyVars["show_order_info"] = true;
					$this->smartyVars["show_site_info"] = false;
					$this->smartyVars["show_csr_info"] = true;
					$this->smartyVars["show_org_info"] = false;
					$this->smartyVars["show_admin_info"] = true;
					$this->smartyVars["show_tech_info"] = true;
					$this->smartyVars["show_billing_info"] = false;
					$this->smartyVars["show_apvr_info"] = true;
				break;

				case "TrueBizID":
					$this->smartyVars["pageTitle"] = getCertName(2);
					$this->smartyVars["show_order_info"] = true;
					$this->smartyVars["show_site_info"] = false;
					$this->smartyVars["show_csr_info"] = true;
					$this->smartyVars["show_org_info"] = true;
					$this->smartyVars["show_admin_info"] = true;
					$this->smartyVars["show_tech_info"] = true;
					$this->smartyVars["show_billing_info"] = false;
					$this->smartyVars["show_apvr_info"] = false;
				break;

				case "RapidSSL":
					$this->smartyVars["pageTitle"] = getCertName(3);
					$this->smartyVars["show_order_info"] = true;
					$this->smartyVars["show_site_info"] = false;
					$this->smartyVars["show_csr_info"] = true;
					$this->smartyVars["show_org_info"] = false;
					$this->smartyVars["show_admin_info"] = true;
					$this->smartyVars["show_tech_info"] = true;
					$this->smartyVars["show_billing_info"] = false;
					$this->smartyVars["show_apvr_info"] = true;
				break;
				}

				

				$params = array(
						"subCommand" => "GetUserAgreement",
						"orID" => $data["orID"],
						"ProductCode" => $data["ODProductCode"],
						"UserAgreementProductCode" => $data["ODProductCode"],

						"ORG_OrganizationName" => $data["ORGOrganizationName"],
						"ORG_DUNS" => $data["ORGDUNS"],
						"ORG_Phone" => $data["ORGPhone"],
						"ORG_Fax" => $data["ORGFax"],
						"ORG_AddressLine1" => $data["ORGAddressLine1"],
						"ORG_AddressLine2" => $data["ORGAddressLine2"],
						"ORG_AddressLine3" => $data["ORGAddressLine3"],
						"ORG_City" => $data["ORGCity"],
						"ORG_Region" => $data["ORGRegion"],
						"ORG_PostalCode" => $data["ORGPostalCode"],
						"ORG_Country" => $data["ORGCountry"],

						"AC_FirstName" => $data["ACFirstName"],
						"AC_LastName" => $data["ACLastName"],
						"AC_Phone" => $data["ACPhone"],
						"AC_Email" => $data["ACEmail"]);

				switch( $data["orTechSameAsAdmin"] ) {
				case "new":
					$params["or_techSameAsAdmin"] = "false";
					$params["TC_FirstName"] = $data["TCFirstName"];
					$params["TC_LastName"] = $data["TCLastName"];
					$params["TC_Phone"] = $data["TCPhone"];
					$params["TC_Email"] = $data["TCEmail"];
				break;

				case "admin":
					$params["or_techSameAsAdmin"] = "true";
					$params["TC_FirstName"] = $data["ACFirstName"];
					$params["TC_LastName"] = $data["ACLastName"];
					$params["TC_Phone"] = $data["ACPhone"];
					$params["TC_Email"] = $data["ACEmail"];
				break;
				}

				switch( $data["orBillSameAsPrevious"] ) {
				case "new":
					$params["or_billSameAsPrevious"] = "false";
					$params["BC_FirstName"] = $data["BCFirstName"];
					$params["BC_LastName"] = $data["BCLastName"];
					$params["BC_Phone"] = $data["BCPhone"];
					$params["BC_Email"] = $data["BCEmail"];
				break;

				case "admin":
					$params["or_billSameAsPrevious"] = "admin";
					$params["BC_FirstName"] = $data["ACFirstName"];
					$params["BC_LastName"] = $data["ACLastName"];
					$params["BC_Phone"] = $data["ACPhone"];
					$params["BC_Email"] = $data["ACEmail"];
				break;

				case "tech":
					$params["or_billSameAsPrevious"] = "tech";
					$params["BC_FirstName"] = $data["TCFirstName"];
					$params["BC_LastName"] = $data["TCLastName"];
					$params["BC_Phone"] = $data["TCPhone"];
					$params["BC_Email"] = $data["TCEmail"];
				break;

				default:
					
				}
					
	
				dbg( "########## Params sent to ProcessSSLfactory ############" );
				dbg( $params );
	
				$query = $this->getMBAPIQuery( "ProcessSSLfactory", "", $params, 0, 0, 0, 0, 1, array_keys( $_REQUEST ) );
				$agreement = grabSimpleMBAPIResults( dispatchMBAPI( $query, 1 ) );
	
				dbg( "######### Returned from ProcessSSLfactory ###############" );
				dbg( $agreement );

				if (notNull( $agreement["RAWAGREEMENT"] )) {
					$params = array(
							"certID" => $certID,
							"getUseragreement" => addslashes($agreement["RAWAGREEMENT"]));
						$setQuery =& new MBQuery( "SetCerts", "update", $params );

					// record the agreement
					if ($this->addErrorsFromResult( $r =& $setQuery->getResult() )) {
						$data["getUseragreement"] = $agreement["RAWAGREEMENT"];
					}
				}

				$this->smartyVars["cert"] =& $data;
				
				$this->addTemplate("certs/OrderCertOrderSummary");
			}
		} else {
			$this->addError( TRANS_ACTIONERROR, "Cert ID not set" );
		}
		
		
		$this->addErrorTemplates();

		return $this->hasExecutedSuccessfully();
	}
} // OrderCertOrderSummary
?>