<?php
// $Id: ShowCerts.php,v 1.7 2006/06/08 01:32:37 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object collects information on all certs that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class ShowCerts extends MB_Action {
	/**
	 * The constructor for a ShowCerts action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowCerts() {
		parent::MB_Action();
		$this->stringRep = "ShowCerts";
		$this->params = array(
			"certID",
			"packageID",
			"domainName",
			"sortDir",
			"sortColumn",
			"recordOffset",
			"numRecords");
		$this->sortColumns = array("certID");
	}

	/**
	 * The main method of this class that executes the ShowCerts action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		$this->hasExecutedSuccessfully = 0;
		$this->hasExecuted = 1;
		$this->timestamp = mktime();
		
		$query = $this->getMBAPIQuery("GetCerts", "", array("clientID"=>$CONF["user"]["id"]), 1, 1, 1, 1);
		$CONF["debug"]->add("Action Command", htmlentities($query));
		$data = dispatchMBAPI($query, 1);
		$CONF["debug"]->add("Action Result", $data);

		dbg($data);

		$results = correctArray(grabSimpleMBAPIResults($data));
		dbg($results);
		if($this->addMBAPIErrors($data) === 0) {
			$smartyVars = array();
			$smartyVars["certs"] = $results["certs"];
			$smartyVars["paginationLinks"] = $results["paginationLinks"];
			
			$this->addTemplate("certs/ShowCerts", $smartyVars);
			
			$this->hasExecutedSuccessfully = 1;
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowCerts
?>
