<?php
// $Id: EditDomainDNS.php,v 1.3 2006/06/08 22:39:58 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on domains that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Michael Fountain
 */
class EditDomainDNS extends MB_Action {
	/**
	 * The constructor for a EditDomainDNS action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function EditDomainDNS() {
		parent::MB_Action();
		$this->stringRep = "EditDomainDNS";
		$this->params = array("domainID");
	}

	/**
	 * The main method of this class that executes the EditDomainDNS action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$domainID = ((int) $_REQUEST["domainID"]);
		if(!$domainID || !$this->confirmClientPermission("GetDomains", "domainID", $domainID, $CONF["user"]["id"])) {
			$this->addError(TRANS_ACTIONERROR, "No domain ID given.");
		} else {

		 	// fetch this domains information
			$query = $this->getMBAPIQuery("GetDomains", "", array("packageType" => getTypeID("products",TRANS_DOMAIN_PRODUCT)));
			$mbapiData = dispatchMBAPI($query, 1);

			// is the domainID valid?
			if ($mbapiData["mbapi"][0]["header"][0]["numResults"][0]!=1) {
				$this->addError(TRANS_ACTIONERROR, "Invalid domain ID.");
			} else {

			 	// build XML for fetching domain data from the registrar
			 	$domainSLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainSLD"][0];
				$domainTLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainTLD"][0];

				$x = "
				<mbapi>
				  <command>ProcessRegistrar</command>
				  <showXMLHeader>0</showXMLHeader>
				  <params>
				    <subCommand>getDomainDNS</subCommand>
				    <configID>0</configID>
					<domainSLD>".$domainSLD."</domainSLD>
					<domainTLD>".$domainTLD."</domainTLD>
				  </params>
				</mbapi>";

				$registrarData = dispatchMBAPI($x,1);
				$registrarResults =& $registrarData["mbapi"][0]["results"][0];

				if($this->addMBAPIErrors($registrarData) === 0) {
					
					$smartyVars = array();
					$smartyVars["domain"] = collapseArrayElements($mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]);
					$smartyVars["dnsCount"] = count($registrarResults["listDNS"]);
					//This is an experimental way to show 8 fields per domain.
					if(count($registrarResults["listDNS"]) < 8) {
						$smartyVars["dnsShowExtra"] = 8 - count($registrarResults["listDNS"]);
					} else {
						$smartyVars["dnsShowExtra"] = 0;
					}
					$smartyVars["listDNS"] = $registrarResults["listDNS"];
					$smartyVars["useDNS"] = collapseArrayElements($registrarResults["UseDNS"]);
					$smartyVars["host"] = correctArray($registrarResults["host"]);
					$smartyVars["domainServices"] = correctArray($registrarResults["DomainServices"][0]);
					//This is an array to loop over, a smarty helper
					$smartyVars["hostLoop"] = array("","","","","","","","","","");
					$smartyVars["dnsOptions"] = $registrarResults["dnsOptions"];
					$this->addTemplate("domains/EditDomainDNS", collapseArrayElements($smartyVars));

				} // if($this->addMBAPIErrors($data) === 0) {

			} // if ($data["mbapi"][0]["header"][0]["numResults"][0]!=1) {

		} // if(!$domainID) {

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditDomainDNS
?>
