<?php
// $Id: EditDomainRegistrarLockOptionsResponse.php,v 1.3 2006/06/08 22:39:58 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the EditDomainRegistrarLockOptions action, and sends
 * it to the registrar class for processing.
 *
 * @author  Michael Fountain
 */
class EditDomainRegistrarLockOptionsResponse extends MB_Action {
	/**
	 * The constructor for an EditDomainRegistrarLockOptionsResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function EditDomainRegistrarLockOptionsResponse() {
		parent::MB_Action();
		$this->stringRep = "EditDomainRegistrarLockOptionsResponse";
		$this->params = array
		(
			"domainID",
		);
	}

	/**
	 * The main method of this class that executes the EditDomainRegistrarLockOptionsResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$domainID = ((int) $_REQUEST["domainID"]);
		if(!$domainID || !$this->confirmClientPermission("GetDomains", "domainID", $domainID, $CONF["user"]["id"])) {
			$this->addError(TRANS_ACTIONERROR, "No domain ID given.");
		} else {

		 	// fetch this domains information
			$query = $this->getMBAPIQuery("GetDomains", "", array("packageType" => getTypeID("products",TRANS_DOMAIN_PRODUCT)));
			$mbapiData = dispatchMBAPI($query, 1);

			// is the domainID valid?
			if ($mbapiData["mbapi"][0]["header"][0]["numResults"][0]!=1) {
				$this->addError(TRANS_ACTIONERROR, "Invalid domain ID.");
			} else {

			 	// fetching domain data from the registrar
			 	$domainSLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainSLD"][0];
				$domainTLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainTLD"][0];

				$domainRegistrarLock = ($_REQUEST["domainRegistrarLock"]) ? 1 : 0 ;

				$xml = "
				<mbapi>
				  <command>ProcessRegistrar</command>
				  <subCommand>setDomainRegistrarLockOptions</subCommand>
				  <showXMLHeader>0</showXMLHeader>
				  <params>
				    <subCommand>setDomainRegistrarLockOptions</subCommand>
                    <configGroupName>0</configGroupName>
                    <configID>0</configID>
                    <domainSLD>".$domainSLD."</domainSLD>
                    <domainTLD>".$domainTLD."</domainTLD>
                    <domainRegistrarLock>".$domainRegistrarLock."</domainRegistrarLock>
				  </params>
				</mbapi>";
				$data = dispatchMBAPI($xml,1);

				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					redirect("domains.php",getActionID("ShowDomainDetails"), array("domainID"=>$domainID));
				}

			} // if ($mbapiData["mbapi"][0]["header"][0]["numResults"][0]!=1)

		} // if(!$domainID)

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	} // execute

} // EditDomainResponse
?>
