<?php
// $Id: ShowGenericBar.php,v 1.2 2006/07/06 00:03:36 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

if (PHP_5) {
	require_once mb_path("/lib-action/include/graph/core/php5/jpgraph.php");
	require_once mb_path("/lib-action/include/graph/core/php5/jpgraph_bar.php");
} else {
	require_once mb_path("/lib-action/include/graph/core/jpgraph.php");
	require_once mb_path("/lib-action/include/graph/core/jpgraph_bar.php");
}

/**
 * Generate and return a graph image to the user. If a graph for the given credentials has already been generated, and the 
 * cached image is within its lifetime, the cached image will be returned.
 *
 * @author  Brian Smith
 */
class ShowGenericBar extends MB_Action {
	/**
	 * The constructor for a EditConfigParams action object. This calls the parent constructor and sets our string 
	 * representation.
	 */
	function ShowGenericBar() {
		parent::MB_Action();
		$this->stringRep = "ShowGenericBar";
	}

	/**
	 * The main method of this class that executes the ShowGenericBar action, and returns success or failure.
	 *
	 * @return  int  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
$t =& new Timer();
		
		define("DEFAULT_GFORMAT", "auto");

		// Setup data


		
		// What width & height should our graph have?
		$width = (int) $_REQUEST["width"];
		if(!notZero($width)) {
			$width = 300;
		}
		$height = (int) $_REQUEST["height"];
		if(!notZero($height)) {
			$height = 40;
		}

		$limit = (int) $_REQUEST["limit"];
		if (!notZero($limit)) {
			$limit = 100;
		}

		$amount = (int) $_REQUEST["amount"];
		if (!notZero($amount)) {
			$amount = 0;
		}

		$tickCount = (int) $_REQUEST["tickCount"];
		if (!notZero( $tickCount )) {
			$tickCount = 5;
		}

		$tickInc = (int) $_REQUEST["tickInc"];

		// Setup graph
		$graph =& new Graph( $width, $height );
		//$graph->SetFrame(false);
		$graph->SetColor("gray");
		$graph->legend->Hide();
		
		
		
		if ($amount > $limit) {
			$under = $limit;
			$over = $amount - $limit;
			
			$graph->SetScale("int", 0, $amount);

			$a_under = (array)$under;
			$a_over = (array)$over;
			$bar1 = new BarPlot( $a_under );
			$bar1->SetLineWeight( 3 );
			$bar1->SetWidth( 1 );
			$bar1->SetFillGradient( "orange", "steelblue", GRAD_HOR );
			

			$bar2 = new BarPlot( $a_over );
			$bar2->SetLineWeight( 3 );
			$bar2->SetWidth( 1 );
			$bar2->SetFillGradient( "red", "orange", GRAD_HOR );

			$abPlot = new AccBarPlot( array($bar1, $bar2) );
			$abPlot->SetLineWeight( 3 );
			
			
			$plot = new GroupBarPlot(array($abPlot));
			$plot->SetWidth( 1 );

			
			$caption = new Text((string)sprintf("%01.1f%%",$amount), $height/2, ($width/2)-20);
			$caption->SetAlign("right");
			$caption->SetColor("navy");
			$caption->show();
			$graph->AddText( $caption );

		} else {
			$graph->SetScale("int", 0, $limit);
			
			$plot = new BarPlot( (array)$amount );
			$plot->SetAlign("left");
			$plot->SetLineWeight( 3 );
			$plot->value->Show();
			$plot->SetValuePos("bottom");
			$plot->value->SetFormat('%01.1f%%', '-%01.1f%%');
			
			$plot->SetFillGradient( "steelblue", "lightsteelblue", GRAD_HOR );
			$plot->SetWidth( 1 );
		}
		
		$graph->Add( $plot );
		
		$graph->yaxis->scale->ticks->Set( ( notZero($tickInc) ? $tickInc : ($limit/$tickCount) ) );
		
		$graph->SetAxisStyle(AXSTYLE_BOXIN);
		
		$adj = ($height - $width)/2;
		$graph->img->setMargin(10, 10, $adj, $adj);

		// set the center and rotate
		$graph->img->SetCenter(floor($width/2), floor($height/2));
		$graph->setAngle(90);

		$graph->xaxis->img->SetTranslation(0, -($adj+10));
		$graph->xaxis->img->right_margin = 5;
		$graph->xaxis->img->width = $height+( ($_REQUEST["count"]=="false") ? 15 : 0);

		
		
		// Display the graph
		$graph->Stroke();
		
		$time = $t->getElapsedTime();
		`echo "Time to gen graph: $time" | write vic`;
		
		return $this->hasExecutedSuccessfully();
	}
} // ShowGenericBar

$a =& new ShowGenericBar();
$a->execute();
?>
