<?php
// $Id: AddHelpdeskTicket.php,v 1.3 2006/03/22 20:43:50 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action gathers all the information needed to open a new helpdesk ticket and presents it to a template
 *
 * @author  Andy Christ
 */
class AddHelpdeskTicket extends MB_Action {
	/**
	 * The constructor for an AddHelpdeskTicket action object. This calls the parent constructor,
	 * sets the string representation of this object and sets up $this->params.
	 */
	function AddHelpdeskTicket() {
		parent::MB_Action();
		$this->stringRep = "AddHelpdeskTicket";

	}

	/**
	 * The main method of this class that executes the AddHelpdeskTicket action, and returns
	 * success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();


		$buckets = $this->getMBAPIData("GetHelpdeskDepartments", "helpdeskDepartments","helpdeskDepartment");
		$departments = collapseArrayElements($buckets);
		foreach($departments as $key => $value) {
			$hdDepartments[$value["hdDepartmentID"]] = $value["hdDepartmentName"];
		}

		$s["hdDepartments"] = $hdDepartments;
		$this->addTemplate("helpdesk/AddHelpdeskTicket", $s);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // AddHelpdeskTicket
?>