<?php
// $Id: ShowHelpdeskTicketDetails.php,v 1.10 2006/06/20 20:31:22 mgarrett Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. Using $_REQUEST["hdTicketID"] it displays all
 * the details for the found invoice, and only displays the details of a single invoice.
 *
 * @author  Vic Fryzel
 * @author  Andy Christ
 */
class ShowHelpdeskTicketDetails extends MB_Action {
	/**
	 * The constructor for a ShowHelpdeskTicketDetails object. This merely sets up our string represenation, calls
	 * the parent constructor, and sets up $this->params.
	 */
	function ShowHelpdeskTicketDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowHelpdeskTicketDetails";
		$this->params = array("hdTicketID");
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$departments = $this->getMBAPIData("GetHelpdeskDepartments", "helpdeskDepartments", "helpdeskDepartment");
		$buckets = $this->getMBAPIData("GetHelpdeskBuckets", "helpdeskBuckets", "helpdeskBucket");
		$respTpls = $this->getMBAPIData("GetHelpdeskResponseTemplates", "helpdeskResponseTemplates",
			"helpdeskResponseTempate");
		$query = $this->getMBAPIQuery("GetHelpdeskTickets", "",
			array("getHelpdeskDepartmentData" => 1,
					"getHelpdeskBucketData" => 1,
					"getUserData" => 1,
					"getHelpdeskTicketResponseData" => 1,
				//	"getHelpdeskTicketNoteData" => 1
					),
			1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);

		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			$results =& $data["mbapi"][0]["results"][0];
			$s = array();

			// Index departments and buckets on ID, for easy use in template
			$s["helpdeskDepartments"] = array();
			if(is_array($departments) && count($departments)) {
				foreach($departments as $dept) {
					$s["helpdeskDepartments"][$dept["hdDepartmentID"][0]] = collapseArrayElements($dept);
				}
			}
			$s["helpdeskBuckets"] = array();
			if(is_array($buckets) && count($buckets)) {
				foreach($buckets as $bucket) {
					$s["helpdeskBuckets"][$bucket["hdBucketID"][0]] = collapseArrayElements($bucket);
				}
			}

			// Assign response template data
			$s["helpdeskResponseTemplates"] = array();
			if(is_array($respTpls) && count($respTpls)) {
				if(is_array($respTpls["helpdeskResponseTemplate"]) && count($respTpls["helpdeskResponseTemplate"])) {
					$s["helpdeskResponseTemplates"] = $respTpls["helpdeskResponseTemplate"];
				} else {
					$s["helpdeskResponseTemplates"] = $respTpls;
				}
			}

			// Assign ticket data, this will be collapsed later
			if (is_array( $results["helpdeskTickets"][0])) {
				$s["helpdeskTicket"] = $results["helpdeskTickets"][0]["helpdeskTicket"][0];
			} else {
				$this->addError( TRANS_ACTIONERROR, "What's this? Natcho ticket! hahaha");
				$this->addErrorTemplates();
				return $this->hasExecutedSuccessfully();
			}

			// Assign specific department and bucket IDs to this ticket
			if(is_array($s["helpdeskTicket"]["hdDepartmentIDs"][0]["hdDepartmentID"])
					&& count($s["helpdeskTicket"]["hdDepartmentIDs"][0]["hdDepartmentID"])) {
				$deptRels = $s["helpdeskTicket"]["hdDepartmentIDs"][0]["hdDepartmentID"];
				$s["helpdeskTicket"]["hdDepartmentIDs"] = $deptRels;
			} else {
				$s["helpdeskTicket"]["hdDepartmentIDs"] = array();
			}
			if(is_array($s["helpdeskTicket"]["hdBucketIDs"][0]["hdBucketID"])
					&& count($s["helpdeskTicket"]["hdBucketIDs"][0]["hdBucketID"])) {
				$bucketRels = $s["helpdeskTicket"]["hdBucketIDs"][0]["hdBucketID"];
				$s["helpdeskTicket"]["hdBucketIDs"] = $bucketRels;
			} else {
				$s["helpdeskTicket"]["hdBucketIDs"] = array();
			}

			// Generate responses
			if(is_array($s["helpdeskTicket"]["helpdeskTicketResponses"][0]["helpdeskTicketResponse"])
					&& count($s["helpdeskTicket"]["helpdeskTicketResponses"][0]["helpdeskTicketResponse"])) {
				$s["helpdeskTicket"]["helpdeskTicketResponses"]
					= $s["helpdeskTicket"]["helpdeskTicketResponses"][0]["helpdeskTicketResponse"];
				if(count($s["helpdeskTicket"]["helpdeskTicketResponses"]) == 1) {
					$s["helpdeskTicket"]["helpdeskTicketResponses"]
						= array(0 => $s["helpdeskTicket"]["helpdeskTicketResponses"]);
				}
			} else {
				$s["helpdeskTicket"]["helpdeskTicketResponses"] = array();
			}

			// Generate notes
			if(is_array($s["helpdeskTicket"]["helpdeskTicketNotes"][0]["helpdeskTicketNote"])
					&& count($s["helpdeskTicket"]["helpdeskTicketNotes"][0]["helpdeskTicketNote"])) {
				$s["helpdeskTicket"]["helpdeskTicketNotes"]
					= $s["helpdeskTicket"]["helpdeskTicketNotes"][0]["helpdeskTicketNote"];
				if(count($s["helpdeskTicket"]["helpdeskTicketNotes"]) == 1) {
					$s["helpdeskTicket"]["helpdeskTicketNotes"]
						= array(0 => $s["helpdeskTicket"]["helpdeskTicketNotes"]);
				}
			} else {
				$s["helpdeskTicket"]["helpdeskTicketNotes"] = array();
			}

			// Parse response templates, and apply data to them
			$t =& $s["helpdeskTicket"];
			$fields = array();
			$fields["hdTicketID"] = $t["hdTicketID"][0];
			$fields["hdTicketKey"] = $t["hdTicketKey"][0];
			$fields["hdTicketSubject"] = $t["hdTicketSubject"][0];
			$fields["hdTicketBody"] = $t["hdTicketBody"][0];
			$fields["hdTicketPriority"] = getPriorityName($t["hdTicketPriorityID"][0]);
			$fields["hdTicketStatus"] = getStatusName("helpdesk", $t["hdTicketStatusID"][0]);
			$fields["userID"] = $t["userID"][0];
			if($t["userType"][0] == 1) {
				$fields["userFirstName"] = $t["admins"][0]["admin"][0]["adminFirstName"][0];
				$fields["userLastName"] = $t["admins"][0]["admin"][0]["adminLastName"][0];
				$fields["userEmail"] = $t["admins"][0]["admin"][0]["adminEmail"][0];
				$fields["username"] = $t["admins"][0]["admin"][0]["adminUsername"][0];
			} else {
				$fields["userFirstName"] = $t["clients"][0]["client"][0]["clientFirstName"][0];
				$fields["userLastName"] = $t["clients"][0]["client"][0]["clientLastName"][0];
				$fields["userEmail"] = $t["clients"][0]["client"][0]["clientEmail"][0];
				$fields["username"] = $t["clients"][0]["client"][0]["contactUsername"][0];
			}
			$search = array_keys($fields);
			$replace = array_values($fields);
			foreach($search as $key => $fieldName) {
				$search[$key] = "{".$fieldName."}";
			}
			$newBody = NULL;
			foreach($s["helpdeskResponseTemplates"] as $key => $respTpl) {
				$newBody = str_replace(array("\\{", "\\}"), array("[[[OPEN_CURLY_BRACE]]]", "[[[CLOSE_CURLY_BRACE]]]"),
					$respTpl["hdRespTplBody"]);
				$newBody = str_replace($search, $replace, $newBody);
				$newBody = str_replace(array("[[[OPEN_CURLY_BRACE]]]", "[[[CLOSE_CURLY_BRACE]]]"), array("\\{", "\\}"),
					$newBody);
				$s["helpdeskResponseTemplates"][$key]["hdRespTplParsedBody"] = $newBody;
			}

			// Generate status list, and fill it with the translated statuses
			$s["helpdeskStatuses"] = getStatuses("helpdesk");

			$openID = getStatusID("helpdesk", "open");
			$closedID = getStatusID("helpdesk", "closed");
			$s["helpdeskTicketStatus"] = array($openID => TRANS_OPEN, $closedID => TRANS_CLOSED);

			$s["paginationLinks"] = $results["paginationLinks"][0];
			$this->addTemplate("helpdesk/ShowHelpdeskTicketDetails", collapseArrayElements($s));
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // ShowHelpdeskTicketDetails
?>