<?php
// $Id: UpgradePackageResponse.php,v 1.5 2006/07/19 20:42:10 mgarrett Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");
require_once mb_path("/lib-modernbill/include/config/internal/statuses.php");
require_once mb_path("/lib-modernbill/include/config/internal/types.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");
require_once mb_path("/lib-modernbill/include/accounting/Accounting.php");
require_once mb_path("/lib-tk/toolkit.php");

/**
 * This upgrades a package based on request variables submitted from the previous page.
 *
 * @author  Kris Bailey
 */
class UpgradePackageResponse extends MB_Action {
	/**
	 * The constructor for a UpgradePackageResponse action object. 
	 */
	function UpgradePackageResponse() {
		parent::MB_Action();
		$this->stringRep = "UpgradePackage";
		$this->params = array("packageID");
	}

	/**
	 * The main method of this class that executes the UpgradePackageResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		dbg($_REQUEST);

		$packageInfo = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackages",
				"params" => array(
					"packageID" => (int)$_REQUEST["packageID"],
					"getPackageAttributeData" => 1,
					"getPackageDatabaseData" => 1,
					"getDomainData" => 1,
					"getCertData" => 1,
					"getPackageAddonData" => 1,
				),
			),
		)));

		$upgradeProducts = arrayFor(
			"productRelations", 
			array(
				"subjectProductID" => $packageInfo["productID"], 
				"productRelationType" => getAPITypeID("productrelations", "upgrade")
			)
		);
		$validProduct = false;
		foreach ((array)$upgradeProducts as $up){
			if ($up["relatedProductID"]==$_REQUEST["productID"]){
				$validProduct = true;
			}
		}

		if (!$packageInfo["packageID"] || !$validProduct || $packageInfo["clientID"]!=$CONF["user"]["id"]){
			$this->addError("TRANS_ACTIONERROR", "Invalid package id.");
		} else {

			loadConfigs("product", "managementrules");

			$copyAttributeNames = array(
				"packageUsername",
				"packagePassword",
				"ip",
				"externalID",
				"clientID",
				"domainID",
			);

			$updatePackageCommand = array(
				"mbapi" => array(
					"command" => "SetPackages",
					"subCommand" => "update",
					"params" => array(
						"packageID" => (int)$_REQUEST["packageID"],
						"packageActive" => 0,
						"packageStatus" => getAPIStatusID("package", "canceled"),
					),
				),
			);

			$billingShareInfo = correctArray(grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetBillingAccountShares",
					"params" => array(
						"packageID" => $packageInfo["packageID"],
					),
				),
			)));

			$productInfo = oneByID("products", (int)$_REQUEST["productID"], array(
				"getProductAttributeData" => 1,
				"getCouponData" => 1,
				"getProductVariantData" => 1,
				"getProductVariantPriceData" => 1,
				"getTLDData" => 1,
				"getCycleData" => 1));

			$productInfo["prices"] = array();
			foreach ((array)$productInfo["productVariantPrices"] as $price){
				if ($price["productVariantID"]==(int)$_REQUEST["productVariantID"] && $price["cycleID"]==$packageInfo["cycleID"] && $price["currencyID"]==$packageInfo["paymentGroupCurrencyID"]){
					$productInfo["prices"][$price["productVariantPriceType"]] = $price;
				}
			}

			$rawaddons = arrayFor("products", array(
				"parentProductID" => (int)$_REQUEST["productID"],
				"productActive" => 1,
				"getProductAttributeData" => 1,
				"getCouponData" => 1,
				"getProductVariantData" => 1,
				"getProductVariantPriceData" => 1,
				"getTLDData" => 1,
				"getCycleData" => 1));


			$keyedAddons = array();
			foreach ((array)$rawaddons as $k=>$addon){
				$rawaddons[$k]["prices"] = array();
				foreach ((array)$rawaddons[$k]["productVariantPrices"] as $price){
					if ($price["cycleID"]==$packageInfo["cycleID"] && $price["currencyID"]==$packageInfo["paymentGroupCurrencyID"]){
						$rawaddons[$k]["prices"][$price["productVariantPriceType"]] = $price;
					}
				}
				$keyedAddons[$addon["productID"]] =& $rawaddons[$k];
			}

			//dbg($packageInfo);
			//dbg($productInfo);
			//dbg($keyedAddons);
			//dbg($billingShareInfo);

			// lets get the tax zone group id's of the variants we are going to use
			$taxZoneGroupIDs = array();
			foreach ((array)$productInfo["productVariants"] as $variant){
				$taxZoneGroupIDs[$variant["productVariantID"]] = $variant["taxZoneGroupID"];
			}
			foreach ((array)$_REQUEST["addons"] as $addonID){
				foreach ((array)$keyedAddons[$addonID]["productVariants"] as $variant){
					$taxZoneGroupIDs[$variant["productVariantID"]] = $variant["taxZoneGroupID"];
				}
			}
			// ok, now we have tax zone group id's keyed on the variant id's
			// lets figure out the tax zone group id of the package now: (there is an easier way)
			foreach ((array)$productInfo["productVariantPrices"] as $price){
				if ($price["productVariantID"] == (int)$_REQUEST["productVariantID"]){
					$packageTaxZoneGroupID = $taxZoneGroupIDs[$price["productVariantID"]];
				}
			}

			// now lets get the tax zone group ids for the addons
			foreach ((array)$_REQUEST["addons"] as $addonID){
				foreach ((array)$keyedAddons[$addonID]["productVariantPrices"] as $price){
					if ($price["currencyID"]==$packageInfo["paymentGroupCurrencyID"] && $price["cycleID"]==$packageInfo["cycleID"]){
						$keyedAddons[$addonID]["taxZoneGroupID"] = $variant["taxZoneGroupID"];
					}
				}
			}


			// first lets make the attributes we need for the new package, which will include some of the old ones...
			$packageAttributes = $this->getPackageAttributesByName($packageInfo);
			$serverGroupMap = array();
			foreach ((array)$packageAttributes as $attr){
				$serverGroupMap[$attr["serverGroupID"]] = $attr["configGroupID"];
			}
			$productAttributes = $this->getProductAttributesByName($productInfo, $serverGroupMap);

			//dbg($packageAttributes);
			//dbg($productAttributes);

			foreach ($packageAttributes as $attribute){
				if (in_array($attribute["packageAttributeName"], $copyAttributeNames)){
					$row = array(
						"serverGroupID" => $attribute["serverGroupID"],
						"packageAttributeName" => $attribute["packageAttributeName"],
						"packageAttributeValue" => $attribute["packageAttributeValue"],
						"packageAttributeDateCreated" => $attribute["packageAttributeDateCreated"],
						"configGroupID" => $attribute["configGroupID"],
					);
					$productAttributes[$attribute["packageAttributeName"]] = $row;
				}
			}


			//dbg(toXML(array("packageAttributes"=>array("packageAttribute"=>array_values($productAttributes)))));
			// done making the attributes, just add into query when needed...


			// ok, lets make the addon array:
			$tempaddons = array();
			foreach ((array)$_REQUEST["addons"] as $addons){
				foreach ((array)$addons as $addon){
					$tempaddons[] = $addon;
				}
			}
			$_REQUEST["addons"] = $tempaddons;

			$packageAddons = array();
			foreach ((array)$_REQUEST["addons"] as $addonID){
				if ($keyedAddons[$addonID]){
					$packageAddons[] = array(
						"copyLedgerEntries" => 1,
						"packageAddonDisplayName" => $keyedAddons[$addonID]["productName"],
						"packageAddonProductID" => $keyedAddons[$addonID]["productID"],
						"taxZoneGroupID" => $keyedAddons[$addonID]["taxZoneGroupID"],
						"packageAddonPriceLock" => 1,
						"packageAddonActive" => 1,
						"couponID" => 0,
						"couponNumCycles" => 0,
						"couponPrice" => 0,
						"packageAddonPrice" => $keyedAddons[$addonID]["prices"][0]["productVariantPriceAmount"],
						"packageAddonSetup" => $keyedAddons[$addonID]["prices"][1]["productVariantPriceAmount"],
					);
				}
			}


			$packageArray = array(
				"packageName" => $productInfo["productName"],
				"packagePriorID" => $packageInfo["packageID"],
				"clientID" => $packageInfo["clientID"],
				"packageStatus" => $packageInfo["packageStatus"],
				"packageActive" => 1,
				"productID" => $productInfo["productID"],
				"taxZoneGroupID" => $packageTaxZoneGroupID,
				"packageProratable" => $productInfo["productProratable"],
				"packageDateCreated" => time(),
				"packageDateBeginRenewal" => $packageInfo["packageDateNextRenewal"],
				"packageDateLastRenewal" => 0,
				"packageDateNextRenewal" => $packageInfo["packageDateNextRenewal"],
				"packageDateStopRenewal" => $packageInfo["packageDateStopRenewal"],
				"packageComments" => $_REQUEST["packageComments"],
				"packageType" => $productInfo["productType"],
				"packageOriginalPrice" => $productInfo["prices"][0]["productVariantPriceAmount"],
				"packagePrice" => $productInfo["prices"][0]["productVariantPriceAmount"],
				"packageSetup" => $productInfo["prices"][1]["productVariantPriceAmount"],
				"couponPrice" => 0,
				"couponNumCycles" => 0,
				"cycleID" => $packageInfo["cycleID"],
				"packagePriceLock" => $packageInfo["packagePriceLock"],
				"usageCycleID" => $packageInfo["usageCycleID"],
				"usageCalculateOnly" => $packageInfo["usageCalculateOnly"],
				"paymentGroupID" => $packageInfo["paymentGroupID"],
				"domainIDs" => array("domainID"=> array()),
			);
			foreach ((array)$packageInfo["domains"] as $domain){
				$packageArray["domainIDs"]["domainID"][] = $domain["domainID"];
			}

			$packageArray["packageAddons"] = array("packageAddon"=>$packageAddons);
			$packageArray["packageAttributes"] = array("packageAttribute"=>array_values($productAttributes));


			if ((int)$CONF["product"]["managementrules"]["whenUpgrade"]){
				$_REQUEST["packageUpgradeType"] = 2;
			} else {
				$_REQUEST["packageUpgradeType"] = ((int)$CONF["product"]["managementrules"]["applyUpgradeCredits"])?0:1;
			}

			// lets get the percentage of the cycle we are through here.
			$now = time();
			$cycleStart = ((int)$packageInfo["packageDateLastRenewal"])?$packageInfo["packageDateLastRenewal"]:$packageInfo["packageDateBeginRenewal"];
			$cycleEnd = getNextBillingTimestamp($cycleStart, $packageInfo["cycleID"]);
			$cycleLength = $cycleEnd-$cycleStart;
			if ((int)$cycleLength){
				$through = $now-$cycleStart;
				$percentageThrough = $through/$cycleLength;
				$percentageLeft = 1-$percentageThrough;
				if ($percentageThrough>1 || $percentageLeft<0){
					$_REQUEST["packageUpgradeType"] = 2; // we didn't calculate a valid percentage
				}
			} else {
				$_REQUEST["packageUpgradeType"] = 2; // we didnt have a cycle length and couldn't get a percentage
								     // so we can't do any proration
			}

			$systemQueueDateToRun = $packageInfo["packageDateNextRenewal"];

			switch ((int)$_REQUEST["packageUpgradeType"]){

				case 0: // need to add proration credits
					$systemQueueDateToRun = time();
					$packageArray["packageDateBeginRenewal"] = ($packageInfo["packageDateLastRenewal"])?$packageInfo["packageDateLastRenewal"]:$packageInfo["packageDateBeginRenewal"];
					$packageArray["packageDateNextRenewal"] = ($packageInfo["packageDateLastRenewal"])?$packageInfo["packageDateLastRenewal"]:$packageInfo["packageDateBeginRenewal"];

					$creditAmount = 0;
					$creditAmount += ((int)$packageArray["couponNumCycles"])?$packageArray["couponPrice"]*$percentageThrough:$packageArray["packagePrice"]*$percentageThrough;
					foreach ((array)$packageArray["packageAddons"]["packageAddon"] as $addon){
						$creditAmount += ((int)$addon["couponNumCycles"])?$addon["couponPrice"]*$percentageThrough:$addon["packageAddonPrice"]*$percentageThrough;
					}
					// at this point we should have the amount we need to credit them for the new package's proration
					// we still need to add what we need to credit them for the old package:

					$creditAmount += $packageInfo["packagePrice"]*$percentageLeft;
					foreach ((array)$packageInfo["packageAddons"] as $addon){
						$creditAmount += $addon["packageAddonPrice"]*$percentageLeft;
					}
					$creditAmount = round($creditAmount, 2);

					dbg("credit amount for client: ".$creditAmount);

					if ($creditAmount>0){

						$creditCommand = array(
							"mbapi" => array(
								"command" => "SetCreditAccounting",
								"params" => array(
									"clientID" => $packageInfo["clientID"],
									"ledgerAccountName" => "revenue",
									"amount" => round($creditAmount, 2),
									"currencyID" => $packageInfo["paymentGroupCurrencyID"],
									"description" => TRANS_PACKAGE_UPGRADE_PRORATION_DISCOUNT,
								),
							),
						);

					}

				break;

				case 1: // don't need to add proration credits per request
					$systemQueueDateToRun = time();
					$packageArray["packageDateBeginRenewal"] = ($packageInfo["packageDateLastRenewal"])?$packageInfo["packageDateLastRenewal"]:$packageInfo["packageDateBeginRenewal"];
					$packageArray["packageDateNextRenewal"] = ($packageInfo["packageDateLastRenewal"])?$packageInfo["packageDateLastRenewal"]:$packageInfo["packageDateBeginRenewal"];

				break;

			}


			$packageResult = dispatchMBAPI(toXML(array(
				"mbapi" => array(
					"command" => "SetPackages",
					"subCommand" => "insert",
					"params" => $packageArray,
				),
			)), 1);

			if (!(int)$packageResult["mbapi"][0]["header"][0]["lastInsertID"][0]){
				$this->addError("TRANS_ACTIONERROR", "Error creating new package.");
			} else {
				$newPackageID = $packageResult["mbapi"][0]["header"][0]["lastInsertID"][0];

				dispatchMBAPI(toXML($updatePackageCommand));
				dispatchMBAPI(toXML($creditCommand));

				foreach ($billingShareInfo as $share){

					dispatchMBAPI(toXML(array(
						"mbapi" => array(
							"command" => "SetBillingAccountShare",
							"subCommand" => "insert",
							"params" => array(
								"packageID" => $newPackageID,
								"billingAccountID" => $share["billingAccountID"],
								"billingAccountFallbackGroup" => $share["billingAccountFallbackGroup"],
								"billingAccountShareGroup" => $share["billingAccountShareGroup"],
								"billingAccountShareValue" => $share["billingAccountShareValue"],
							),
						),
					)));

				}


				if ((int)$CONF["product"]["managementrules"]["generateUpgradeInvoice"]){
					$generateOptions = array(
						"getClients" =>  array("clientID" => $CONF["user"]["id"]),
						"getPackages" =>  array("packageID" => array($newPackageID)),
						"setBillingMode" =>  "anniversary",
						"packageDateNextRenewalLessThan" => mktime() +1,
						"domainDateNextRenewalLessThan" => -1
						);
					$invoiceInfo = grabResultsFromMBAPIArray(array(
						"mbapi" => array(
							"command" => "ProcessInvoices",
							"params" => $generateOptions,
						),
					));
					dbg("invoice Info:");
					dbg($invoiceInfo);
				}

				if ((int)$CONF["product"]["managementrules"]["provisionUpgrades"]){
					$timeData = explode(";", date("i;G;j;n;Y", $systemQueueDateToRun));
					dispatchMBAPI(toXML(array(
						"mbapi" => array(
							"command" => "SetSystemQueue",
							"subCommand" => "insert",
							"params" => array(
								"systemQueueCommand" => "ProcessPanel",
								"systemQueueCommandInput" => htmlentities(toXML(array(
									"mbapi" => array(
										"command" => "ProcessPanel",
										"subCommand" => "panelUpgrade",
										"params" => array(
											"subCommand" => "panelUpgrade",
											"packageID" => $newPackageID,
										),
									),
								))),
								"systemQueueMinute" => $timeData[0],
								"systemQueueHour" => $timeData[1],
								"systemQueueDay" => $timeData[2],
								"systemQueueMonth" => $timeData[3],
								"systemQueueYear" => $timeData[4],
								"systemQueueIsRecurring" => 0,
								"systemQueueDateCreated" => time(),
								"systemQueueDateToRun" => $dateToRun,
								"systemQueueDateStarted" => 0,
								"systemQueueDateFinished" => 0,
								"packageID" => $newPackageID,
							),
						),
					)));
				}


				redirect("packages.php", getActionID("ShowPackages"), array("clientID" => $packageInfo["clientID"]));
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	function getProductAttributesByName($productInfo, $serverGroupMap){
		$attributes = (array)$productInfo["productAttributes"];
		$ret = array();
		foreach ($attributes as $row){
			unset($row["productAttributeID"]);
			$row["packageAttributeName"] = $row["productAttributeName"];
			unset($row["productAttributeName"]);
			$row["packageAttributeValue"] = $row["productAttributeValue"];
			unset($row["productAttributeValue"]);
			$row["packageAttributeDateCreated"] = $row["productAttributeDateCreated"];
			unset($row["productAttributeDateCreated"]);
			$row["configGroupID"] = $serverGroupMap[$row["serverGroupID"]]; // add in the correct config group id
			$ret[$row["packageAttributeName"]] = $row;
		}
		return $ret;
	}

	function getPackageAttributesByName($packageInfo){
		$attributes = (array)$packageInfo["packageAttributes"];
		$ret = array();
		foreach ($attributes as $row){
			$ret[$row["packageAttributeName"]] = $row;
		}
		return $ret;
	}



} // UpgradePackageResponse
?>
