<?php
// $Id: RemoveBillingAccount.php,v 1.9 2006/07/04 07:15:55 bwoolley Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object double checks that a user is sure they want to remove a BillingAccount.
 *
 * @author  getActionFiles.php (Automatically Generated)
 */
class RemoveBillingAccount extends MB_Action {
	/**
	 * The constructor for a RemoveBillingAccount action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This is also where $this->params is setup.
	 */
	function RemoveBillingAccount() {
		parent::MB_Action();
		$this->stringRep = "RemoveBillingAccount";
		$this->params = array("billingaccountID");
	}

	/**
	 * The main method of this class that executes the RemoveBillingAccount action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		$this->hasExecutedSuccessfully = 1;
		$this->hasExecuted = 1;
		$this->timestamp = mktime();
		
		$billingaccountID = ((int) $_REQUEST["billingaccountID"]);
		if(!$billingaccountID) {
			$this->addError(TRANS_ACTIONERROR, "No BillingAccount ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetBillingAccounts", "", array("clientID"=>$CONF["user"]["id"]));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$s = array();
					$s["billingaccount"] = 
						collapseArrayElements($data["mbapi"][0]["results"][0]["billingaccounts"][0]["billingaccount"][0]);
					$this->addTemplate("profile/RemoveBillingAccount", $s);
					$this->hasExecutedSuccessfully = 1;
				} else {
					$this->addError(TRANS_ACTIONERROR, "BillingAccount not found.");
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveBillingAccount
?>
