<?php
// $Id: RemoveClientContactResponse.php,v 1.9 2006/03/22 20:43:50 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the RemoveClientContact action, and removes the specified clientcontact. *
 * @author  getActionFiles.php (Automatically Generated)
 */
class RemoveClientContactResponse extends MB_Action {
	/**
	 * The constructor for an RemoveClientContactResponse action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	function RemoveClientContactResponse() {
		parent::MB_Action();
		$this->stringRep = "RemoveClientContactResponse";
		$this->params = array("clientContactID");
	}

	/**
	 * The main method of this class that executes the RemoveClientContactResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;

		$this->hasExecutedSuccessfully = 1;
		$this->hasExecuted = 1;
		$this->timestamp = mktime();
		
		$clientContactID = ((int) $_REQUEST["clientContactID"]);
		if(!$clientContactID) {
			$this->addError(TRANS_ACTIONERROR, "No ClientContact ID given.");
		} else {
			$query = $this->getMBAPIQuery("SetClientContacts", "delete", array("clientID"=>$CONF["user"]["id"]));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);
			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$this->hasExecutedSuccessfully = 1;
				header("Location: clientcontacts.php?action=".getActionID("ShowClientContacts"));
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveClientContactResponse
?>