<?php
// $Id: ShowClientContacts.php,v 1.15 2006/06/07 21:32:41 achrist Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This class is a child class of MB_Action. It lists all client contacts that
 * match any of the input params.
 *
 * @author  Michael Fountain
 */
class ShowClientContacts extends MB_Action {
	/**
	 * The constructor for a ShowClientContacts action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowClientContacts() {
		parent::MB_Action();
		$this->stringRep = "ShowClientContacts";
		$this->params = array("clientID");
	}

	/**
	 * The main method of this class that executes the ShowClientContacts action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$clientID = ((int) $CONF["user"]["id"]);
		$clientContactID = ((int) $CONF["user"]["clientContactID"]);
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else {

			$_REQUEST["clientID"] = $clientID;

			$query = $this->getMBAPIQuery("GetClients", "", array(
					"clientContactID" => $clientContactID,
					"getContactData"=>1, "mergePrimaryContact" => 0),
					1, 1, 1, 1);
			$data = dispatchMBAPI($query, 1);

			$contacts = $data["mbapi"][0]["results"][0]["clients"][0]["client"][0]["contacts"][0]["contact"];

			//See if this is the primary contact, if so, show all contacts
			$isPrimary = $clientInfo = 0;
			if(is_array($contacts)) {
				foreach($contacts as $key => $value) {
					if($value["contactPrimary"][0] && $value["clientContactID"][0] == $clientContactID) {
						$isPrimary = 1;
						$clientInfo = $data["mbapi"][0]["results"][0]["clients"][0]["client"][0];
						unset($clientInfo["contacts"]);
					}
				}
	
				foreach($contacts as $key => $value) {
					if($isPrimary) {
						$contactData[] = $value;
					} else if($value["clientContactID"][0] == $clientContactID) {
						$contactData[0] = $value;
					}
				}
			}

			$results =& $data["mbapi"][0]["results"][0];
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

				//$this->mergeCountryData();
				$this->smartyVars["client"] = correctArray($clientInfo);
				$this->smartyVars["contacts"] = correctArray($contactData);
				$this->smartyVars["isPrimary"] = $isPrimary;
				$this->smartyVars["clientContactID"] = $clientContactID;

				$contacts = $this->smartyVars["contacts"];
				$contactCountries = array();
				$c = count($contacts);
				for($i = 0; $i < $c; $i++) {
					$contactCountries[$contacts[$i]["clientContactID"]] = constant("TRANS_ISO_3166_".$contacts[$i]["countriesISO2"]);
				}
				$this->smartyVars["contactCountries"] = $contactCountries;
				
				$this->addTemplate("profile/ShowClientContacts", $this->smartyVars);
				
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // MB_Action
?>
