<?php
// $Id: EditWebsiteWidget.php,v 1.1 2006/05/23 20:57:13 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This action object collects information on a website widget to display the edit form
 *
 * @author  Kris Bailey
 */
class EditWebsiteWidget extends MB_Action {
	/**
	 * The constructor for a EditWebsiteWidget action object. This merely calls the parent constructor,
	 * and sets the string representation of this object.
	 */
	function EditWebsiteWidget() {
		parent::MB_Action();
		$this->stringRep = "EditWebsiteWidget";
		$this->params = array("websiteWidgetID");
	}

	/**
	 * The main method of this class that executes the EditWebsiteWidget action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$this->smartyVars = array();

		$websiteWidgetID = ((int) $_REQUEST["websiteWidgetID"]);
		if(!$websiteWidgetID) {
			$this->addError(TRANS_ACTIONERROR, "No website widget ID given.");
		} else {

	       	if ($dh = opendir(mb_path("/app-modernbill-order/include/themes/".$CONF["theme"]["name"]."/templates/website_widgets/"))) {
				while (($file = readdir($dh)) !== false) {
					if (strpos($file, ".tpl")){
						$this->smartyVars["wwTemplates"][str_replace(".tpl", "", $file)] = str_replace(".tpl", "", $file);
					}
				}
				closedir($dh);
			}

		 	$this->smartyVars["websiteWidgetInfo"] = grabSimpleMBAPIResults(dispatchMBAPI("
		 						<mbapi>
		 							<command>GetWebsiteWidgets</command>
		 							<params>
										<websiteWidgetID>".$websiteWidgetID."</websiteWidgetID>
										<getProductInformation>1</getProductInformation>
		 							</params>
		 						</mbapi>", 1));
			$this->smartyVars["websiteWidgetInfo"] = $this->smartyVars["websiteWidgetInfo"][0];
			$this->smartyVars["selectedProducts"] = grabHTMLOpsFromArray($this->smartyVars["websiteWidgetInfo"]["products"][0]["product"], "productID", "productName");
			$products = grabSimpleMBAPIResults(dispatchMBAPI("<mbapi><command>GetProducts</command><params><orderFormID>".$this->smartyVars["websiteWidgetInfo"]["orderFormID"]."</orderFormID></params></mbapi>", 1));
	   		$this->smartyVars["selectableProducts"] = grabHTMLOpsFromArray($products, "productID", "productName", array_keys($this->smartyVars["selectedProducts"]));

			$this->addTemplate("websitewidgets/EditWebsiteWidget", $this->smartyVars);

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditWebsiteWidget
?>