<?php
// $Id: RemoveTodo.php,v 1.1 2006/05/23 20:57:13 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/xml/xml.php");

/**
 * This Action object double checks that a user is sure they want to remove a Todo.
 *
 * @author  Mark Garrett
 * @author  Brian Smith
 */
class RemoveTodo extends MB_Action {
	/**
	 * The constructor for a RemoveTodo action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This is also where $this->params is setup.
	 */
	function RemoveTodo() {
		parent::MB_Action();
		$this->stringRep = "RemoveTodo";
		$this->params = array("todoID");
	}

	/**
	 * The main method of this class that executes the RemoveTodo action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$todoID = ((int) $_REQUEST["todoID"]);
		if(!$todoID) {
			$this->addError(TRANS_ACTIONERROR, "No Todo ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetTodos", "", array("getAdminData"=>1, "getAssignedData" => 1));
			$data = dispatchMBAPI($query, 1);
			
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(((int) $data["mbapi"][0]["header"][0]["numResults"][0]) > 0) {
					$this->smartyVars["todostatus"] = getStatuses("todo");
					
					$this->smartyVars["todo"] = 
						correctArray($data["mbapi"][0]["results"][0]["todos"][0]["todo"][0]);

					if (is_array( $this->smartyVars["todo"]["assigned"][0]["assigned"][0])) {
						$this->smartyVars["todo"]["assigned"][0] = $this->smartyVars["todo"]["assigned"][0]["assigned"][0];
					}
					
					$this->addTemplate("todos/RemoveTodo");
					
				} else {
					$this->addError(TRANS_ACTIONERROR, "Todo not found.");
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // RemoveTodo
?>