<?php
// $Id: NewOrder.php,v 1.13 2006/03/24 18:21:50 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/app-modernbill-order/include/order/order.php");

/**
 * This Action object collects information on all orderForms that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Mark Garrett
 */
class NewOrder extends MB_Action {
	/**
	 * The constructor for a NewOrder action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function NewOrder() {
		parent::MB_Action();
		$this->stringRep = "NewOrder";
		
		$this->params = array(
			"ofid",
			"productID",
			"cycleID",
			"domainName",
			"sid",
			"set_locale",
			"afcode"
			);
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the NewOrder action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		
		$ofdata = NULL;
		
		$CONF["theme"]["type"] = "public";

		$getOptions = array(
			"getOrderFormParams" => 1,
			"getOrderFormItems" => 3,
			"getOrderFormProductAddons" => 1,
			"orderFormID" => $this->paramArgs["ofid"]
		);
		
		$query = $this->getMBAPIQuery("GetOrderForms", "", $getOptions);
		$ofdata = dispatchMBAPI($query, 1);
		$this->orderFormSessionID =& $ofdata["mbapi"][0]["header"][0]["remoteSessionID"][0];

		if($this->addMBAPIErrors($ofdata) === 0 && !$this->getNumErrors()) {
			$smartyVars = array();
			
			$smartyVars["orderForm"] =& $ofdata["mbapi"][0]["results"][0]["orderForms"][0]["orderForm"][0];
			$this->paramArgs["ofdata"] =& $ofdata["mbapi"][0]["results"][0]["orderForms"][0]["orderForm"][0];
			
			if (!$_COOKIE["orderobj"] || $this->paramArgs["productID"] || $this->paramArgs["domainName"]){
				$orderobj =& new Order($this->paramArgs);
			}else{
				$orderobj = unserialize(gzuncompress(base64_decode($_COOKIE["orderobj"])));
				if (!count($orderobj->orderDomains) && !count($orderobj->orderProducts)){
					$orderobj =& new Order($this->paramArgs);
				}
			}
			
			//Check to see if IP is banned
			$banned = $orderobj->checkBanning(1, ip2long(getRemoteIP()));
			if($banned){
				$orderobj->ipBanText = (defined($orderobj->ipBanText)) ? constant($orderobj->ipBanText) : $orderobj->ipBanText;
				$this->addError(TRANS_FATALERROR, $orderobj->ipBanText);
			}
			$languagesArray = $this->getMBAPIData2("GetLanguages", "languages", "language", array("languageISO2" => $CONF["user"]["locale"]->language));
			foreach ($languagesArray as $language) {
				$orderobj->orderFormLanguageID = $language["languageID"][0];
			}
			
			//Get Domain info from Object
			$smartyVars["domainInfo"] = $orderobj->getDomainInfo();
			$smartyVars["IDN"] = $this->createJSArray($smartyVars["domainInfo"]["idn"]);
			$smartyVars["sid"] = $orderobj->orderFormSessionID;
			$smartyVars["set_locale"] = $orderobj->orderFormLocale;
			$smartyVars["showProducts"] = count($orderobj->orderDomains) + count($orderobj->orderProducts);
			$smartyVars["ofDir"] =$orderobj->orderFormDir;
   			$smartyVars["ofCssDir"] =$CONF["relativeWebRoot"]."/app-modernbill-order/include/themes/".$CONF["theme"]["name"];

			$orderobj->orderFormData = NULL;
			if(!$banned){
				setcookie("orderobj", base64_encode(gzcompress(serialize($orderobj))));

				$this->addTemplate($orderobj->orderFormDir."/NewOrder", collapseArrayElements($smartyVars));
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
	
} // NewOrder
?>