<?php
// $Id: ProcessOrder.php,v 1.21 2006/05/05 04:15:51 mgarrett Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/app-modernbill-order/include/order/order.php");

/**
 * This Action object collects information on all orderForms that match the given parameters, and 
 * generates the display of that information.
 *
 * @author  Mark Garrett
 */
class ProcessOrder extends MB_Action {
	/**
	 * The constructor for a ProcessOrder action object. This merely calls the parent constructor, 
	 * and sets the string representation of this object. This method also sets up $this->params and 
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	 
	 var $orderobj;
	 var $clientID;
	 
	function ProcessOrder() {
		parent::MB_Action();
		$this->stringRep = "ProcessOrder";
		
		$this->params = array(
			"sid",
			"set_locale",
			"customerType",
			"clientFirstName",
			"clientLastName",
			"clientCompany",
			"contactAddress1",
			"contactAddress2",
			"contactCity",
			"contactState",
			"countriesID",
			"contactZip",
			"clientEmail",
			"contactPhone1",
			"contactPhone2",
			"contactFax",
			"registrantFirstName",
			"registrantLastName",
			"registrantEmail",
			"registrantOrganizationName",
			"registrantJobTitle",
			"registrantAddress1",
			"registrantAddress2",
			"registrantCity",
			"registrantStateProvince",
			"registrantPostalCode",
			"registrantCountry",
			"registrantPhone",
			"registrantFax",
			"extAttrib",
			"contactUsername",
			"contactPassword",
			"existContactUsername",
			"existContactPassword",
			"clientNoteText",
			"taxIDNumber",
			"paymentType",
			"CRM",
			"invoiceID",
			"billingCardNameOnCard",
		    "billingCardType",
			"billingCardNum",
			"billingCardExpMonth",
			"billingCardExpYear",
			"billingCardStartDate",
			"billingBankType",
		    "billingBankName",
			"billingBankAbaCode",
			"billingBankAccountNum",
			"billingBankLicenseNum",
			"billingBankLicenseState",
			"billingBankState",
			"billingBankDob",
			"billingAccountType",
			"billingAccountID",
			"cardCVV2",
			"clientID"
			);
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the ProcessOrder action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$ofdata = NULL;
				
		$CONF["theme"]["type"] = "public";

		if($_COOKIE["orderobj"]){
			$this->orderobj = unserialize(gzuncompress(base64_decode($_COOKIE["orderobj"])));
		}
		
		$this->orderobj->orderFormSessionID = $this->paramArgs["sid"];
		
		
		if($this->paramArgs["CRM"]){
            $this->paramArgs["CRM"] = rawurldecode($this->paramArgs["CRM"]);
        }

		if ($this->orderobj->processStep == "insert" && !$this->paramArgs["CRM"]){
            $CONF["debug"]->debugMessage("CRM isn't present, and we are 'inserting', so changing to update.");
            $this->orderobj->processStep = "update";
		}elseif($this->orderobj->processStep == "process" || !$this->orderobj || $this->orderobj->processStep == "reprocess"){
            $CONF["debug"]->debugMessage("we have processed and need to reprocess");
			$this->orderobj->processStep = "reprocess";
			$crm = unserialize(gzuncompress(base64_decode($this->paramArgs["CRM"])));
			$this->paramArgs = array_merge($crm, $this->paramArgs);
		}elseif($this->orderobj->processStep == NULL){
            $CONF["debug"]->debugMessage("first step: insert");
			$this->orderobj->processStep = "insert";
		}elseif($this->paramArgs["CRM"]){
            $CONF["debug"]->debugMessage("have insertted and done update, and have crm info - PROCESS!!");
			$crm = unserialize(gzuncompress(base64_decode($this->paramArgs["CRM"])));
			$this->paramArgs = array_merge($crm, $this->paramArgs);
			$this->orderobj->processStep = "process";
		}
		
		// Get customer Information for existing customers. We switch the processStep to update so that we don't enter in 
		// a new customer
		if($this->paramArgs["customerType"]){
			$clientInfo = $this->orderobj->getExistingCustomerInfo($this->paramArgs["existContactUsername"], $this->paramArgs["existContactPassword"]);

			if(!is_array($clientInfo)){
				$this->addError(TRANS_ACTIONERROR, TRANS_CLIENT_UNABLE_TO_LOGIN);
				$this->addErrorTemplates();
				return $this->hasExecutedSuccessfully();
			}

			$this->paramArgs["registrantFirstName"] = $clientInfo["contactFirstName"];
			$this->paramArgs["registrantLastName"] = $clientInfo["contactLastName"];
			$this->paramArgs["registrantEmail"] = $clientInfo["contactEmail"];
			$this->paramArgs["registrantOrganizationName"] = $clientInfo["contactCompany"];
			$this->paramArgs["registrantJobTitle"] = $clientInfo["contactCompany"];
			$this->paramArgs["registrantAddress1"] = $clientInfo["contactAddress1"];
			$this->paramArgs["registrantAddress2"] = $clientInfo["contactAddress2"];
			$this->paramArgs["registrantCity"] = $clientInfo["contactCity"];
			$this->paramArgs["registrantStateProvince"] = $clientInfo["contactState"];
			$this->paramArgs["registrantPostalCode"] = $clientInfo["contactZip"];
			$this->paramArgs["registrantCountry"] = $clientInfo["countriesISO2"];
			$this->paramArgs["registrantPhone"] = $clientInfo["contactPhone1"];
			$this->paramArgs["registrantFax"] = $clientInfo["contactFax"];

			//pull out billing accounts for latter display
			$billingAccounts = collapseArrayElements(protectArray($clientInfo["billingAccounts"][0]["billingAccount"]));
			dbg($billingAccounts);
			// Go through the billing accounts and create a pop-up menu for customer to select. We need to display something
			//differnet for each type of account. Most complicated is the secondary gateway (4).
			foreach($billingAccounts as $account){
				if($account[$CONF["system"]["encryption"]["lek_pin"]]!==''){
					
					switch ($account["billingAccountType"]){
					
						case 0: $smartyVars["billingAccounts"][$account["billingAccountID"]."|".$account["billingAccountType"]] = 
							getTypeName("card", $account["billingCardType"])." - ".$account["billingAccountNumLastFour"];
							break;
							
						case 1:
						case 2: $smartyVars["billingAccounts"][$account["billingAccountID"]."|".$account["billingAccountType"]] = 
							getTypeName("bankAccount", $account["billingBankType"])." - ".$account["billingAccountNumLastFour"];
							break;
						case 3: $smartyVars["billingAccounts"][$account["billingAccountID"]."|".$account["billingAccountType"]] = TRANS_MANUAL_PAYMENT_ACCOUNT;
								break;
						case 4: loadConfigs("payment");
								if (isset($CONF["payment"]["paymentGroups"]["gateway"])){
									$this->fixGatewayConfigGroups();
									foreach ($CONF["payment"]["paymentGroups"]["gateway"] as $name=>$children){
										if(is_array($children)){
											foreach ($children as $subName=>$content){
												if ($content['configGroupID']==$account["secGatewayConfigGroupID"]){
													$moduleName = $content["configGroupTransKey"];
												}
											}
										}
									}
								}
								$smartyVars["billingAccounts"][$account["billingAccountID"]."|".$account["billingAccountType"]] = $moduleName;
								break;
					}
				}
			}
			

			//Don't merge into paramargs
			unset($clientInfo["billingAccounts"]);
			
			$this->paramArgs = array_merge($this->paramArgs, $clientInfo);
			
			$this->paramArgs["contactPassword"] = $this->paramArgs["existcontactPassword"];
			$this->paramArgs["contactUsername"] = $this->paramArgs["existcontactUsername"];
			$this->paramArgs = collapseArrayElements($this->paramArgs);
			$this->orderobj->processStep = ($this->orderobj->processStep == "insert") ? "update": $this->orderobj->processStep;
	
		// We need to verify the data and make sure that there is no one else with that username
		}else{
			$clientInfo = $this->orderobj->getExistingCustomerInfo($this->paramArgs["contactUsername"], $this->paramArgs["contactPassword"], TRUE);
			
			if($this->orderobj->emailBan){
				$banResult = $this->orderobj->checkBanning(0, $this->paramArgs["clientEmail"]);
			}
			
			
//		echo "<PRE>HERE";	print_r($clientInfo);
		//////////
		/// Here be validation
		//////////
		
//		exit;
		
		}

		// Null this out after we have used it to set itself
		$this->paramArgs["CRM"] = NULL;

		$this->orderobj->orderFormSessionID = $this->paramArgs["sid"];
		
		// Set cookie so we can save the processStep with each load of the page
		setcookie("orderobj", base64_encode(gzcompress(serialize($this->orderobj))));
		
		// Get the clientID if there is one. It will either be in the order object or params
		if($this->paramArgs["clientID"]){
			$this->clientID = $this->paramArgs["clientID"];
		}elseif($this->orderobj->clientID){
			require_once mb_path("/lib-tk/include/crypt/crypt.php");
			$c =& new Crypt(getPasswordHash(PANELENCRYPTIONKEY), "blowfish", NULL);
			$this->clientID = $c->decrypt($this->orderobj->clientID); 
		}

		/////////////////////////////////////////////////
		// Generate the XML and process the MBAPI Command
		/////////////////////////////////////////////////
		$orderXML = $this->generateOrderXML();

		dbg("****************************** Order XML ******************************");
		dbg($orderXML);	

		$orderResponse = dispatchMBAPI($orderXML, 1);

		dbg("---------------------------- Order Response ---------------------------");
		dbg($orderResponse);	
    	/////////////////////////////////////////////////

		// Start setting up smartyvars for display
		$smartyVars["orderResponse"] = $orderResponse["mbapi"][0]["results"][0];

		// First, check the FraudGuardian Result
		if($smartyVars["orderResponse"]["fgReject"][0]){
			$smartyVars["failed"] = TRUE;
			$removeObject = TRUE;
			if ($smartyVars["orderResponse"]["fgReject"][0] == "rejectHard"){
				$smartyVars["rejectHard"] = TRUE;
			}else{
				$smartyVars["rejectSoft"] = TRUE;
			}
		}else{
			// Which payment response to show - credit card or other, success or failed
			if (isset($smartyVars["orderResponse"]["invoiceID"][0]) && $this->paramArgs["paymentType"] !=1 && $this->paramArgs["paymentType"] !=4){
				$smartyVars["success"] = TRUE;
				if((int) $this->paramArgs["paymentType"] == 2 && $smartyVars["orderResponse"]["gatewayReturn"][0]["status"][0] == 1){
					$smartyVars["displayPaymentLink"] = TRUE;
					$smartyVars["orderResponse"]["gatewayReturn"][0]["paymentForm"] = protectArray($smartyVars["orderResponse"]["gatewayReturn"][0]["paymentForm"]);
				}
				$removeObject = TRUE;
			}elseif((isset($smartyVars["orderResponse"]["transaction"][0]["authReturn"][0])) 
					&& ($smartyVars["orderResponse"]["transaction"][0]["authReturn"][0] == 1
					|| $smartyVars["orderResponse"]["transaction"][0]["authReturn"][0] == 40)){
				$smartyVars["success"] = TRUE;
				$smartyVars["ccTrans"] = TRUE;
				$removeObject = TRUE;
			}elseif((isset($smartyVars["orderResponse"]["transaction"][0]["authReturn"][0]))){
				$smartyVars["failed"] = TRUE;
			}
		}
		//Get the Payment Options for this order form
		$paymentOptions = $this->orderobj->getPaymentOptions();
		
		//We have a primary gateway - get the card type array
		if ($paymentOptions["cc"]){
			loadConfigs("payment");
			$paymentOptions["cardTypes"] = $this->getAcceptedCardTypesByID($paymentOptions["primaryConfigGroupID"]);
			$paymentOptions["echeck"] = $this->getGatewayeCheckByID($paymentOptions["primaryConfigGroupID"]);
		}
		
		$smartyVars["paymentOptions"] = $paymentOptions;

		//Set the clientID if we have one to teh order object so that if we use the Back button it will work
		if (isset($smartyVars["orderResponse"]["clientID"][0])){
			$this->paramArgs["clientID"] = $smartyVars["orderResponse"]["clientID"][0];
			require_once mb_path("/lib-tk/include/crypt/crypt.php");
			$c =& new Crypt(getPasswordHash(PANELENCRYPTIONKEY), "blowfish", NULL);
			$this->orderobj->clientID = $c->encrypt($smartyVars["orderResponse"]["clientID"][0]);
			setcookie("orderobj", base64_encode(gzcompress(serialize($this->orderobj))));
		}

		$smartyVars["CRM"] = rawurlencode(base64_encode(gzcompress(serialize($this->paramArgs))));
		$smartyVars["clientInfo"] = $this->paramArgs;
		$smartyVars["paymentType"] = $this->paramArgs["paymentType"];
		
		// A few misc vars needed for display
		$smartyVars["ip"] = $_SERVER['REMOTE_ADDR'];
		$smartyVars["accounttypes"] = $CONF["types"]["bankAccount"];
		
		unset($smartyVars["clientInfo"]["CRM"]);
		
		$smartyVars = collapseArrayElements($smartyVars);
		
		if (is_array($smartyVars["orderResponse"]) && isset($smartyVars["orderResponse"]["packages"]["package"]["packageID"])){
			$smartyVars["orderResponse"]["packages"]["package"] = array($smartyVars["orderResponse"]["packages"]["package"]);
		}
		
		if (is_array($smartyVars["orderResponse"]) && isset($smartyVars["orderResponse"]["taxZones"]["taxZone"]["taxZoneID"])){
			$smartyVars["orderResponse"]["taxZones"]["taxZone"] = array($smartyVars["orderResponse"]["taxZones"]["taxZone"]);
		}
		
		$smartyVars["ofDir"] =$this->orderobj->orderFormDir;
   		$smartyVars["ofCssDir"] =$CONF["relativeWebRoot"]."/app-modernbill-order/include/themes/".$CONF["theme"]["name"];
		
		if ($this->orderobj->processStep == "insert" || $this->orderobj->processStep == "update"){
			$this->addTemplate($this->orderobj->orderFormDir."/displayFinalOrder", $smartyVars);
		}else{
			if ($removeObject){
				setcookie("orderobj", "");
			}
			$this->addTemplate($this->orderobj->orderFormDir."/widgets/billInfo", $smartyVars);
		}
		
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
	
	function generateOrderXML(){
		
		$xml= "<mbapi>
			   <command>ProcessOrder</command>
			   <showXMLHeader></showXMLHeader>
			   <subCommand>".$this->orderobj->processStep."</subCommand>
			   <params>
			   		<orderFormID>".$this->orderobj->orderFormID."</orderFormID>
					<client>\n";
			if ($this->clientID){
				$xml .="<clientID>".$this->clientID."</clientID>";
			}
		
		$xml .=		  "<clientFirstName>".$this->paramArgs["clientFirstName"]."</clientFirstName> 
					  <clientLastName>".$this->paramArgs["clientLastName"]."</clientLastName> 
					  <clientEmail>".$this->paramArgs["clientEmail"]."</clientEmail> 
					  <clientCompany>".$this->paramArgs["clientCompany"]."</clientCompany> 
					  <countriesID>".$this->paramArgs["countriesID"]."</countriesID> 
					  <themeID>1</themeID>
					  <languageID>".$this->orderobj->orderFormLanguageID."</languageID> 
					  <taxIDNumber>".$this->paramArgs["taxIDNumber"]."</taxIDNumber> 
					  <applyTax>1</applyTax>
					</client>
					<clientNote>
					  <clientNoteText>".$this->paramArgs["clientNoteText"]."</clientNoteText> 
					</clientNote>
					<clientContact>
					  <contactAddress1>".$this->paramArgs["contactAddress1"]."</contactAddress1> 
					  <contactAddress2>".$this->paramArgs["contactAddress2"]."</contactAddress2> 
					  <contactUsername>".$this->paramArgs["contactUsername"]."</contactUsername> 
					  <contactPassword>".$this->paramArgs["contactPassword"]."</contactPassword> 
					  <contactCity>".$this->paramArgs["contactCity"]."</contactCity> 
					  <contactState>".$this->paramArgs["contactState"]."</contactState> 
					  <contactZip>".$this->paramArgs["contactZip"]."</contactZip> 
					  <contactPhone1>".$this->paramArgs["contactPhone1"]."</contactPhone1> 
					  <contactPhone2>".$this->paramArgs["contactPhone2"]."</contactPhone2> 
					  <contactFax>".$this->paramArgs["contactFax"]."</contactFax> 
					</clientContact>";
		if($this->orderobj->processStep == "process" || $this->orderobj->processStep == "reprocess"){
			
			if(strpos($this->paramArgs["paymentType"], "|")){
				$payArray = explode("|", $this->paramArgs["paymentType"]);
				$this->paramArgs["paymentType"] = $payArray[0];
				$secGatewayConfigGroupID = $payArray[1];
			}
			switch($this->paramArgs["paymentType"]) {
				case 1: $this->paramArgs["billingAccountType"] = 0; break;
				case 2: $this->paramArgs["billingAccountType"] = 4; break;
				case 3: $this->paramArgs["billingAccountType"] = 3; break;
				case 4: $this->paramArgs["billingAccountType"] = 1; break;
				case 5: $this->paramArgs["billingAccountType"] = 2; break;
				case 9999: $exp = explode("|", $this->paramArgs["billingAccountID"]); 
						$this->paramArgs["billingAccountType"] = $exp[1]; 
						$this->paramArgs["billingAccountID"] = $exp[0];
						
						switch($this->paramArgs["billingAccountType"]){
							case 0: $this->paramArgs["paymentType"] = 1; break;
							case 1: $this->paramArgs["paymentType"] = 4; break;
							case 2: $this->paramArgs["paymentType"] = 5; break;
							case 3: $this->paramArgs["paymentType"] = 0; break;
							case 4: $this->paramArgs["paymentType"] = 2; break;
						}
						break;
				default:  $this->paramArgs["billingAccountType"] = 3; break;
			}
			
			$xml .="	
					<clientBillingAccount>
						<billingCardNameOnCard>".$this->paramArgs["billingCardNameOnCard"]."</billingCardNameOnCard> 
						<billingCardType>".$this->paramArgs["billingCardType"]."</billingCardType> 
						<billingCardNum>".$this->paramArgs["billingCardNum"]."</billingCardNum> 
						<billingCardExpMonth>".$this->paramArgs["billingCardExpMonth"]."</billingCardExpMonth> 
						<billingCardExpYear>".$this->paramArgs["billingCardExpYear"]."</billingCardExpYear> 
						<billingCardStartDate>".$this->paramArgs["billingCardStartDate"]."</billingCardStartDate> 
						<billingBankType>".$this->paramArgs["billingBankType"]."</billingBankType> 
						<billingBankName>".$this->paramArgs["billingBankName"]."</billingBankName> 
						<billingBankAbaCode>".$this->paramArgs["billingBankAbaCode"]."</billingBankAbaCode> 
						<billingBankAccountNum>".$this->paramArgs["billingBankAccountNum"]."</billingBankAccountNum> 
						<billingBankLicenseNum>".$this->paramArgs["billingBankLicenseNum"]."</billingBankLicenseNum> 
						<billingBankLicenseState>".$this->paramArgs["billingBankLicenseState"]."</billingBankLicenseState> 
						<billingBankState>".$this->paramArgs["billingBankState"]."</billingBankState> 
						<billingBankDob>".$this->paramArgs["billingBankDob"]."</billingBankDob> 
						<billingAccountType>".$this->paramArgs["billingAccountType"]."</billingAccountType>\n";
			if($secGatewayConfigGroupID){
				$xml.="			<secGatewayConfigGroupID>".$secGatewayConfigGroupID."</secGatewayConfigGroupID>";
			}
			if($this->paramArgs["billingAccountID"]){
				$xml.="			<billingAccountID>".$this->paramArgs["billingAccountID"]."</billingAccountID>";
			}
			$xml.="			<cardCVV2>".$this->paramArgs["cardCVV2"]."</cardCVV2> 
					</clientBillingAccount>
			
					<domainRegistrant>
						<registrantFirstName>".$this->paramArgs["registrantFirstName"]."</registrantFirstName> 
						<registrantLastName>".$this->paramArgs["registrantLastName"]."</registrantLastName> 
						<registrantEmail>".$this->paramArgs["registrantEmail"]."</registrantEmail> 
						<registrantOrganizationName>".$this->paramArgs["registrantOrganizationName"]."</registrantOrganizationName> 
						<registrantJobTitle>".$this->paramArgs["registrantJobTitle"]."</registrantJobTitle> 
						<registrantAddress1>".$this->paramArgs["registrantAddress1"]."</registrantAddress1> 
						<registrantAddress2>".$this->paramArgs["registrantAddress2"]."</registrantAddress2> 
						<registrantCity>".$this->paramArgs["registrantCity"]."</registrantCity> 
						<registrantStateProvince>".$this->paramArgs["registrantStateProvince"]."</registrantStateProvince> 
						<registrantPostalCode>".$this->paramArgs["registrantPostalCode"]."</registrantPostalCode> 
						<registrantCountry>".$this->paramArgs["registrantCountry"]."</registrantCountry> 
						<registrantPhone>".$this->paramArgs["registrantPhone"]."</registrantPhone> 
						<registrantFax>".$this->paramArgs["registrantFax"]."</registrantFax> 
					</domainRegistrant>";
			}
			
			// Add on domain attributes if they are there
			if (is_array($this->paramArgs["extAttrib"])){
				$xml .="<domainAttributes>\n";
				foreach($this->paramArgs["extAttrib"] as $dom => $domAtt){
					$xml.="
					<domain>
					  <domainName>$dom</domainName>";
						foreach($domAtt as $key=>$value){
							$xml .="					  <$key>$value</$key>\n";
						}
					$xml .=
					"					  </domain>";
				}
				$xml .="</domainAttributes>\n";
			}			
			
			if (count($this->orderobj->orderProducts)){
				$xml .="<products>\n";
				foreach ($this->orderobj->orderProducts as $product){
					$xml .="
					<product>
					   <domainName>".$product["domainName"]."</domainName>
					   <domainLanguage>".$product["domainLanguage"]."</domainLanguage>
					   <productID>".$product["productID"]."</productID>
					   <cycleID>".$product["cycleID"]."</cycleID>
					 </product>
					";
				}
				$xml .="</products>\n";
			}			
			if (count($this->orderobj->orderCoupons)){
				$xml .="<coupons>\n";
				foreach ($this->orderobj->orderCoupons as $coupon=>$code){
					$xml .="
					<couponCode>".$code."</couponCode>
					";
				}
				$xml .="</coupons>\n";
			}			
			if ($this->orderobj->affiliateCode){
				$xml .="<affiliateCode>".$this->orderobj->affiliateCode."</affiliateCode>";
			}			
			
			if ($this->paramArgs["paymentType"]){
				$xml .="<paymentType>".$this->paramArgs["paymentType"]."</paymentType>";
			}			
			
			if ($this->paramArgs["invoiceID"]){
				$xml .="<invoiceID>".$this->paramArgs["invoiceID"]."</invoiceID>";
			}

			$xml .="	  
			   </params>
			 </mbapi>";
		
		return $xml;
	}
	
} // ProcessOrder
?>