<?php
// $Id: AddCartCouponResponse.php,v 1.7 2006/07/19 21:34:58 mgarrett Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/app-modernbill-order/include/order/order.php");

/**
 * This Action gets coupon info and applies a coupon to an order.
 *
 * @author  Kris Bailey
 */
class AddCartCouponResponse extends MB_Action {
	/**
	 * The constructor for a AddCartCouponResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function AddCartCouponResponse() {
		parent::MB_Action();
		$this->stringRep = "AddCartCouponResponse";

		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the AddCartCouponResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$CONF["theme"]["type"] = "public";
		dbg($_REQUEST);
		$this->smartyVars = array();

		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"], $_REQUEST["orderFormID"], 1);

		$orderObjectParams = array(
					"ofid" => $shoppingSessionData["orderFormID"],
					"sid" => $shoppingSessionData["shoppingSessionID"],
					"set_locale" => $_REQUEST["set_locale"],
					);
		$order =& new Order($orderObjectParams);

		$currencyID = $order->orderFormCurrency;

		dbg("order object:");
		dbg($order);

		$possibleCoupons = array();
		if (isset($order->orderFormData["coupons"][0]["coupon"][0]["couponID"][0])){
			foreach ($order->orderFormData["coupons"][0]["coupon"] as $coupon){
			 	$possibleCoupons[$coupon["couponID"][0]] = $coupon;
			}
		}

		dbg("possible coupons:");
		dbg($possibleCoupons);

		$couponCode = secureInput(stripslashes($_REQUEST["couponCode"]));
		$couponInfoXML = "	<mbapi>
								<command>GetCoupons</command>
								<params>
									<couponCode>".$couponCode."</couponCode>
								</params>
							</mbapi>";
		$couponInfo = dispatchMBAPI($couponInfoXML, 1);
		dbg("coupon info gotten from mbapi:");
		dbg($couponInfo);
		if (isset($couponInfo["mbapi"][0]["results"][0]["coupons"][0]["coupon"][0]["couponID"][0])){

			dbg("going to test validity");

			$couponInfo = collapseArrayElements($couponInfo["mbapi"][0]["results"][0]["coupons"][0]["coupon"][0]);

			dbg("collapsed coupon info:");
			dbg($couponInfo);

			if (($couponInfo["couponCount"]>=$couponInfo["couponMaxCount"] && $couponInfo["couponMaxCount"] > 0) || !(int)$possibleCoupons[$couponInfo["couponID"]]["couponID"][0] || $couponInfo["couponActive"]<1 || ($couponInfo["couponDateEnded"]>0 && $couponInfo["couponDateEnded"]<time()) || $couponInfo["couponDateStarted"]>time()){
				dbg("determined invalid");
				if (!$_REQUEST["redirectURL"]){
				 	$_REQUEST["redirectURL"] = "cart.php?sid=".secureInput($_REQUEST["sid"])."&invalidCoupon=yes";
				}
			} else {
				dbg("determined valid");
				$setCouponXML = "	<mbapi>
										<command>SetShoppingCoupon</command>
										<subCommand>insert</subCommand>
										<params>
										   <shoppingSessionID>".$shoppingSessionData["shoppingSessionID"]."</shoppingSessionID>
										   <couponID>".$couponInfo["couponID"]."</couponID>
										</params>
									</mbapi>";
				dbg("set coupon response");
				dbg(dispatchMBAPI($setCouponXML, 1));

			}

		} else {

			if (!$_REQUEST["redirectURL"]){
			 	$_REQUEST["redirectURL"] = "cart.php?sid=".secureInput($_REQUEST["sid"])."&invalidCoupon=yes";
			}

		}

        if ($_REQUEST["redirectURL"]!="") {
            redirect($_REQUEST["redirectURL"]);
        } else {
            redirect("cart.php?sid=".secureInput($_REQUEST["sid"]));
        }


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // AddCartCouponResponse
?>
