<?php
// $Id: AddCartDomain.php,v 1.12 2006/07/20 16:20:47 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/app-modernbill-order/include/order/order.php");

/**
 * This Action object collects information on a website widget that matches the given parameters, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class AddCartDomain extends MB_Action {
	/**
	 * The constructor for a AddCartDomain action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function AddCartDomain() {
		parent::MB_Action();
		$this->stringRep = "AddCartDomain";

		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the AddCartDomain action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$CONF["theme"]["type"] = "public";

		dbg("inside add cart domain");

		$this->smartyVars = array();

		if ($_REQUEST["wwid"]){
			if ($CONF["secureURLProtocol"]=="http"){
			 	$this->smartyVars["cartURL"] = $CONF["secureURLProtocol"]."://".$CONF["standardURL"].mb_path_convert_path("/app-modernbill-order")."/cart.php?sid=".$_REQUEST["sid"];
			 	$this->smartyVars["baseURL"] = $CONF["secureURLProtocol"]."://".$_SERVER["HTTP_HOST"];
			} else {
			 	$this->smartyVars["cartURL"] = $CONF["secureURLProtocol"]."://".$CONF["secureURL"].mb_path_convert_path("/app-modernbill-order")."/cart.php?sid=".$_REQUEST["sid"];
			 	$this->smartyVars["baseURL"] = $CONF["secureURLProtocol"]."://".$_SERVER["HTTP_HOST"];
			}
			$wwXML = "	<mbapi>
					<command>GetWebsiteWidgets</command>
					<params>
						<websiteWidgetID>".((int)$_REQUEST["wwid"])."</websiteWidgetID>
						<getProductInformation>1</getProductInformation>
						<getOrderFormData>1</getOrderFormData>
					</params>
					</mbapi>";
			$wwInfo = dispatchMBAPI($wwXML, 1);
			dbg("website widget info we got back:");
			dbg($wwInfo);

			dbg("at the top of website widget show action. 4");

			$wwInfo = grabSimpleMBAPIResults($wwInfo);
			$wwInfo = $wwInfo[0];
			$orderFormID = $wwInfo["orderFormID"];
		}


		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"], $orderFormID);

		$orderObjectParams = array(
									"ofid" => ($orderFormID)?$orderFormID:$shoppingSessionData["orderFormID"],
									"sid" => $shoppingSessionData["shoppingSessionID"],
									"set_locale" => $_REQUEST["set_locale"],
									);
		$order =& new Order($orderObjectParams);
		$this->smartyVars["domainInfo"] = $order->getDomainInfo();
		$this->smartyVars["IDN"] = $this->createJSArray($this->smartyVars["domainInfo"]["idn"]);

		$getItemsXML = "	<mbapi>
								<command>GetShoppingItems</command>
								<params>
									<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
								</params>
							</mbapi>";
		$items = dispatchMBAPI($getItemsXML, 1);
		dbg("items:");
		dbg($items);
		$availableDomains = array();
		if (isset($items["mbapi"][0]["results"][0]["shoppingItems"][0]) && isset($items["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"][0])){
			foreach ($items["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"] as $row){
			 	if ($row["shoppingItemTLD"][0]!=""){
					$availableDomains[] = array('id'=>$row["shoppingItemID"][0], 'sld'=>$row["shoppingItemSLD"][0], 'tld'=>$row["shoppingItemTLD"][0]);
				}
			}
		}

		$this->smartyVars["availableDomains"] = $availableDomains;
		$this->smartyVars["shoppingItemID"] = (int)$_REQUEST["shoppingItemID"];
		if (!(int)$_REQUEST["shoppingItemID"]){
			$this->smartyVars["suppressAvailable"] = 1;
		}

		if ((int)$_REQUEST["whoisWidget"]){
			$this->smartyVars["widgetCall"] = (int)$_REQUEST["whoisWidget"];
		}

		dbg("Smarty Vars:");
		dbg($this->smartyVars);

		$this->addTemplate("shopping/AddDomainCart", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // ShowWebsiteWidget
?>
