<?php
// $Id: AddCartProductResponse.php,v 1.14 2006/07/28 19:36:23 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/app-modernbill-order/include/order/order.php");

/**
 * This Action object collects information on a website widget that matches the given parameters, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class AddCartProductResponse extends MB_Action {
	/**
	 * The constructor for a AddCartProductResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function AddCartProductResponse() {
		parent::MB_Action();
		$this->stringRep = "AddCartProductResponse";

		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the AddCartProductResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$CONF["theme"]["type"] = "public";
		dbg($_REQUEST);
		$this->smartyVars = array();

		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"], $_REQUEST["orderFormID"], 1);

		$orderObjectParams = array(
									"ofid" => $shoppingSessionData["orderFormID"],
									"sid" => $shoppingSessionData["shoppingSessionID"],
									"set_locale" => $_REQUEST["set_locale"],
									);
		$order =& new Order($orderObjectParams);

		$currencyID = $order->orderFormCurrency;

		if ($_REQUEST["addType"]=="domain"){

			dbg($_REQUEST);

			if ($_REQUEST["existsld"]){ // existing
				$type = getAPITypeID("shoppingdomains", "manual");

				$setRelXML = "
					<mbapi>
						<command>SetShoppingItemsDomain</command>
						<subCommand>insert</subCommand>
						<params>
							<shoppingItemID>".(int)$_REQUEST["parentShoppingItemID"]."</shoppingItemID>
							<shoppingItemsDomainsType>".$type."</shoppingItemsDomainsType>
							<domainSLD>".secureInput($_REQUEST["existsld"])."</domainSLD>
							<domainTLD>".secureInput($_REQUEST["existtld"])."</domainTLD>
						</params>
					</mbapi>";
				dbg(dispatchMBAPI($setRelXML, 1)); // run it, dont worry about if we fail or not, we can't do anything even if we did...

			} else { // transfer

				$variantXML = "
						<mbapi>
							<command>GetProductVariants</command>
							<params>
								<productVariantID>".(int)$_REQUEST["productVariantID"]."</productVariantID>
								<getProductVariantPriceData>1</getProductVariantPriceData>
								<getTLDData>1</getTLDData>
							</params>
						</mbapi>";
				$variantInfo = dispatchMBAPI($variantXML, 1);
				if (isset($variantInfo["mbapi"][0]["results"][0]["productVariants"][0]["productVariant"][0])){
					$variantInfo = correctArray($variantInfo["mbapi"][0]["results"][0]["productVariants"][0]["productVariant"][0]);
					dbg("Variant Info for transfer:");
					dbg($variantInfo);

					if ($_REQUEST["cycleID"]=="-2"){
       					$type = 1;
						$_REQUEST["cycleID"] = $variantInfo["tldTransferMinimumCycleID"];
					} else {
						$type = 0;
					}


					$priceInfo = array();

					foreach ($variantInfo["productVariantPrices"] as $price){
					 	if ($price["currencyID"]==$currencyID && $price["cycleID"]==(int)$_REQUEST["cycleID"]){
							$priceInfo[$price["productVariantPriceType"]] = $price;
						}
					}

					$backLen = strlen($variantInfo["tldExtension"])+1;

					$domainSLD = substr($_REQUEST["domain"], 0, -$backLen);
					$domainTLD = $variantInfo["tldExtension"];

					$setItemXML = "
							<mbapi>
								<command>SetShoppingItem</command>
								<subCommand>insert</subCommand>
								<params>
									<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
									<productID>".(int)$_REQUEST["productID"]."</productID>
									<productVariantID>".(int)$_REQUEST["productVariantID"]."</productVariantID>
									<cycleID>".(int)$_REQUEST["cycleID"]."</cycleID>
									<currencyID>".$currencyID."</currencyID>
									<shoppingItemQuantity>1</shoppingItemQuantity>
									<shoppingItemSLD>".secureInput($domainSLD)."</shoppingItemSLD>
									<shoppingItemTLD>".secureInput($domainTLD)."</shoppingItemTLD>
									<shoppingItemDomainLanguage>".secureInput($_REQUEST["domainLanguage"])."</shoppingItemDomainLanguage>
									<shoppingItemDomainType>".$type."</shoppingItemDomainType>
									<shoppingItemPrice>".doubleval($priceInfo[0]["productVariantPriceAmount"])."</shoppingItemPrice>
									<shoppingItemSetupPrice>".doubleval($priceInfo[1]["productVariantPriceAmount"])."</shoppingItemSetupPrice>
									<shoppingItemDateAdded>".time()."</shoppingItemDateAdded>
								</params>
							</mbapi>";
					dbg($setItemXML);
					$setItem = dispatchMBAPI($setItemXML, 1);
					dbg("result:");
					dbg($setItem);
					if (isset($setItem["mbapi"][0]["header"][0]["lastInsertID"][0])){

						$setRelXML = "
							<mbapi>
								<command>SetShoppingItemsDomain</command>
								<subCommand>insert</subCommand>
								<params>
									<shoppingItemID>".(int)$_REQUEST["parentShoppingItemID"]."</shoppingItemID>
									<shoppingItemsDomainsType>".$type."</shoppingItemsDomainsType>
									<domainSLD>".secureInput($domainSLD)."</domainSLD>
									<domainTLD>".secureInput($domainTLD)."</domainTLD>
									<domainShoppingItemID>".$setItem["mbapi"][0]["header"][0]["lastInsertID"][0]."</domainShoppingItemID>
								</params>
							</mbapi>";
						dbg($setRelXML);
						dbg(dispatchMBAPI($setRelXML, 1)); // run it, dont worry about if we fail or not, we can't do anything even if we did...

					}

				} else {
					// do nothing since we couldnt find the variant
				}

			}

		} elseif ($_REQUEST["addType"]=="associateDomain"){

			dbg($_REQUEST);


			$setRelXML = "
				<mbapi>
					<command>SetShoppingItemsDomain</command>
					<subCommand>insert</subCommand>
					<params>
						<shoppingItemID>".(int)$_REQUEST["parentShoppingItemID"]."</shoppingItemID>
						<shoppingItemsDomainsType>0</shoppingItemsDomainsType>
						<domainSLD>".secureInput($_REQUEST["domainSLD"])."</domainSLD>
						<domainTLD>".secureInput($_REQUEST["domainTLD"])."</domainTLD>
						<domainShoppingItemID>".(int)$_REQUEST["domainShoppingItemID"]."</domainShoppingItemID>
					</params>
				</mbapi>";
			dbg($setRelXML);
			dbg(dispatchMBAPI($setRelXML, 1)); // run it, dont worry about if we fail or not, we can't do anything even if we did...


		} elseif ($_REQUEST["addType"]=="addons"){

			$productIDs = (array)$_REQUEST["addonID"];
			$cycleMap = array();
			foreach ($productIDs as $k=>$v){
				if (count(explode("|", $v))>1){
					$v = explode("|", $v);
					$cycleMap[$v[0]] = $v[1];
					$v = (int)$v[0];
				} else {
					$v = (int)$v;
				}
				$productIDs[$k] = $v;
			}

			dbg("product ids of the addons we chose:");
			dbg($productIDs);

			$shoppingItemInfoXML = "	<mbapi>
											<command>GetShoppingItems</command>
											<params>
												<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
												<shoppingItemID>".(int)$_REQUEST["shoppingItemID"]."</shoppingItemID>
											</params>
										</mbapi>";
			$shoppingItemInfo = dispatchMBAPI($shoppingItemInfoXML, 1);

			if (isset($shoppingItemInfo["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"][0])){
				$shoppingItemInfo = correctArray($shoppingItemInfo["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"][0]);

				$removeCurrentAddonsXML = "	<mbapi>
												<command>SetShoppingItem</command>
												<subCommand>delete</subCommand>
												<params>
													<parentShoppingItemID>".(int)$_REQUEST["shoppingItemID"]."</parentShoppingItemID>
												</params>
											</mbapi>";
				dbg("remove result:");
				dbg(dispatchMBAPI($removeCurrentAddonsXML, 1));

				$this->smartyVars["shoppingItemID"] = (int)$_REQUEST["shoppingItemID"];
				$this->smartyVars["productID"] = $shoppingItemInfo["productID"];
				$this->smartyVars["cycleID"] = $shoppingItemInfo["cycleID"];
				$this->smartyVars["productVariantID"] = $shoppingItemInfo["productVariantID"];
				dbg("smarty vars");
				dbg($this->smartyVars);

				$getAddonsXML = "	<mbapi>
										<command>GetProducts</command>
										<params>
											<parentProductID>".$this->smartyVars["productID"]."</parentProductID>
											<getProductAttributeData>1</getProductAttributeData>
											<getCouponData>1</getCouponData>
											<getAllOrderFormItemData>1</getAllOrderFormItemData>
											<getOrderFormItemData>1</getOrderFormItemData>
											<getOrderFormData>1</getOrderFormData>
											<getProductVariantData>1</getProductVariantData>
											<getProductVariantPriceData>1</getProductVariantPriceData>
											<getTLDData>1</getTLDData>
											<getCycleData>1</getCycleData>
										</params>
									</mbapi>";
				$productsInfo = dispatchMBAPI($getAddonsXML, 1);
				$productsInfo = correctArray($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"]);

				dbg("prods:");
				dbg($productsInfo);

				foreach ($productsInfo as $k=>$v){
					$prices = array();
					$cycleID = (isset($cycleMap[$v["productID"]]))?$cycleMap[$v["productID"]]:$this->smartyVars["cycleID"];
					if (in_array($v["productID"], $productIDs)){
					 	if (isset($productsInfo[$k]["productVariantPrices"])){
						 	foreach ($productsInfo[$k]["productVariantPrices"] as $price){
								if ($price["currencyID"]==$currencyID && $price["cycleID"]==$cycleID){
									$prices[$price["productVariantPriceType"]] = $price;
									$productsInfo[$k]["productVariantID"] = $price["productVariantID"];
								}
							}
						} else {
							dbg("variant price not set");
						}
						dbg("prices:");
						dbg($prices);
						$productsInfo[$k]["prices"] = $prices;
						if (count($productsInfo[$k]["prices"])){
							unset($productsInfo[$k]["productVariantPrices"]);
						} else {
					 		unset($productsInfo[$k]);
						}
					} else {
					 	dbg("product id: ".$v["productID"]." not in: ".print_r($productIDs, 1));
					 	unset($productsInfo[$k]);
					}
				}

				dbg("products info after filtering");

				foreach ($productsInfo as $k=>$v){
					// add each to cart
					$setItemXML = "
							<mbapi>
								<command>SetShoppingItem</command>
								<subCommand>insert</subCommand>
								<params>
									<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
									<productID>".(int)$v["productID"]."</productID>
									<productVariantID>".(int)$v["productVariantID"]."</productVariantID>
									<cycleID>".(int)$v["prices"][0]["cycleID"]."</cycleID>
									<currencyID>".$this->smartyVars["currencyID"]."</currencyID>
									<shoppingItemQuantity>1</shoppingItemQuantity>
									<shoppingItemSLD></shoppingItemSLD>
									<shoppingItemPrice>".doubleval($v["prices"][0]["productVariantPriceAmount"])."</shoppingItemPrice>
									<shoppingItemSetupPrice>".doubleval($v["prices"][1]["productVariantPriceAmount"])."</shoppingItemSetupPrice>
									<shoppingItemDateAdded>".time()."</shoppingItemDateAdded>
									<parentShoppingItemID>".(int)$this->smartyVars["shoppingItemID"]."</parentShoppingItemID>
								</params>
							</mbapi>";
					$setItem = dispatchMBAPI($setItemXML, 1);
					dbg("result:");
					dbg($setItem);

				}

			} else {
				// do nothing, we didn't get a valid shoppingItemID
			}

		} else {

			/////////////////////////////////////
	        		$productsInfoXML = "
							<mbapi>
								<command>GetProducts</command>
								<params>
										<productID>".(int)$_REQUEST["productID"]."</productID>
										<getCouponData>1</getCouponData>
										<getCouponIDs>1</getCouponIDs>
										<getProductVariantData>1</getProductVariantData>
										<getProductVariantIDs>1</getProductVariantIDs>
										<getProductVariantPriceData>1</getProductVariantPriceData>
										<getproductVariantPriceIDs>1</getproductVariantPriceIDs>
								</params>
							</mbapi>";
			$productsInfo = dispatchMBAPI($productsInfoXML, 1);
			$productsInfo = correctArray($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"]);

			$priceInfo = array();

			foreach ($productsInfo as $k=>$v){
				$prices = array();
				dbg($v);
			 	if (isset($productsInfo[$k]["productVariantPrices"])){
					foreach ($productsInfo[$k]["productVariantPrices"] as $price){
					 	if ($price["currencyID"]==$currencyID && $price["productVariantID"]==(int)$_REQUEST["productVariantID"] && $price["cycleID"]==(int)$_REQUEST["cycleID"]){
							$priceInfo[$price["productVariantPriceType"]] = $price;
						}
					}
				}
			}

			dbg($priceInfo);

			$setItemXML = "
					<mbapi>
						<command>SetShoppingItem</command>
						<subCommand>insert</subCommand>
						<params>
							<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
							<productID>".(int)$_REQUEST["productID"]."</productID>
							<productVariantID>".(int)$_REQUEST["productVariantID"]."</productVariantID>
							<cycleID>".(int)$_REQUEST["cycleID"]."</cycleID>
							<currencyID>".$currencyID."</currencyID>
							<shoppingItemQuantity>1</shoppingItemQuantity>
							<shoppingItemSLD></shoppingItemSLD>
							<shoppingItemPrice>".doubleval($priceInfo[0]["productVariantPriceAmount"])."</shoppingItemPrice>
							<shoppingItemSetupPrice>".doubleval($priceInfo[1]["productVariantPriceAmount"])."</shoppingItemSetupPrice>
							<shoppingItemDateAdded>".time()."</shoppingItemDateAdded>
						</params>
					</mbapi>";
			$setItem = dispatchMBAPI($setItemXML, 1);
			dbg("result:");
			dbg($setItem);

		} // end adding non domain product

        if ($_REQUEST["redirectURL"]!="") {
            redirect($_REQUEST["redirectURL"]);
        } else {
            redirect("cart.php?sid=".secureInput($_REQUEST["sid"]));
        }


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // ShowWebsiteWidget
?>
