<?php
// $Id: EditCartProduct.php,v 1.8 2006/04/19 17:07:39 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/app-modernbill-order/include/order/order.php");

/**
 * This Action object collects information on a products associated addon children products and displays it.
 *
 * @author  Kris Bailey
 */
class EditCartProduct extends MB_Action {
	/**
	 * The constructor for a EditCartProduct action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function EditCartProduct() {
		parent::MB_Action();
		$this->stringRep = "EditCartProduct";

		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the EditCartProduct action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$CONF["theme"]["type"] = "public";

		dbg("request:");
		dbg($_REQUEST);

		$this->smartyVars = array();
        $this->smartyVars["orderThemeDirectory"] = $CONF["relativeWebRoot"]."/app-modernbill-order/include/themes/".$CONF["theme"]["name"];
		$this->mergeCycleData();

		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"]);

		$orderObjectParams = array(
									"ofid" => $shoppingSessionData["orderFormID"],
									"sid" => $shoppingSessionData["shoppingSessionID"],
									"set_locale" => $_REQUEST["set_locale"],
									);
		$order =& new Order($orderObjectParams);
		$this->smartyVars["currencyID"] = $order->orderFormCurrency;

		$this->smartyVars["shoppingItemID"] = (int)$_REQUEST["shoppingItemID"];

		$getShoppingItemXML = "	<mbapi>
									<command>GetShoppingItems</command>
									<params>
										<shoppingItemID>".(int)$_REQUEST["shoppingItemID"]."</shoppingItemID>
										<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
									</params>
								</mbapi>";
		$shoppingItem = dispatchMBAPI($getShoppingItemXML, 1);
		if (isset($shoppingItem["mbapi"][0]["results"][0]["shoppingItems"][0]) && isset($shoppingItem["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"][0])){
			$shoppingItem = correctArray($shoppingItem["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"][0]);
		}

		dbg("shopping item");
		dbg($shoppingItem);

		if ($shoppingItem["shoppingItemID"]){


			$productsInfoXML = "
							<mbapi>
								<command>GetProducts</command>
								<params>
										<productID>".(int)$shoppingItem["productID"]."</productID>
										<getProductAttributeData>1</getProductAttributeData>
										<getCouponData>1</getCouponData>
										<getAllOrderFormItemData>1</getAllOrderFormItemData>
										<getOrderFormItemData>1</getOrderFormItemData>
										<getOrderFormData>1</getOrderFormData>
										<getProductVariantData>1</getProductVariantData>
										<getProductVariantPriceData>1</getProductVariantPriceData>
										<getTLDData>1</getTLDData>
										<getCycleData>1</getCycleData>
								</params>
							</mbapi>";
			$productsInfo = dispatchMBAPI($productsInfoXML, 1);
			dbg("products info");
			dbg($productsInfo);
			$productsInfo = correctArray($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"][0]);

			dbg("products info parsed");
			dbg($productsInfo);

			if ($productsInfo["productID"]){

			 	$this->smartyVars["productID"] = $productsInfo["productID"];
				$prices = array();

			 	if (isset($productsInfo["productVariantPrices"])){
					foreach ($productsInfo["productVariantPrices"] as $price){
				 		if ($shoppingItem["productVariantID"]==$price["productVariantID"]){
							$prices[$price["currencyID"]][$price["productVariantID"]."-".$price["cycleID"]][$price["productVariantPriceType"]] = $price;
						}
					}
				}
				foreach ($prices as $currency => $rows){
					$productsInfo["prices"][$currency] = array_values($rows);
				}
				unset($productsInfo[$k]["productVariantPrices"]);

				$this->smartyVars["products"] = $productsInfo;
				$this->smartyVars["shoppingItem"] = $shoppingItem;

				dbg("Smarty Vars:");
				dbg($this->smartyVars);
			} else {
				$this->smartyVars["productID"] = 0;
			}

		} else {
			$this->smartyVars["productID"] = 0;
		}

		$this->addTemplate("shopping/EditCartProduct", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // ShowWebsiteWidget
?>