<?php
// $Id: ProcessCartCheckout.php,v 1.26 2006/08/01 17:58:14 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."../../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-tk/include/crypt/crypt.php");
require_once mb_path("/lib-tk/functions.php");
require_once mb_path("/lib-action/include/wizard/Wizard.php");

/**
 * This Action object calls the ProcessCheckout command that creates their packages and invoice and billing
 *	accounts and shares and charges depending.
 *
 * @author  Kris Bailey
 */
class ProcessCartCheckout extends MB_Action {
	/**
	 * The constructor for a ProcessCartCheckout action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ProcessCartCheckout() {
		parent::MB_Action();
		$this->stringRep = "ProcessCartCheckout";

		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the ProcessCartCheckout action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$CONF["theme"]["type"] = "public";


		$fingerprint = getPasswordHash($_REQUEST["passVar"]);
		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"]);

		if ($shoppingSessionData["shoppingSessionFingerprint"]==""){
			redirect("cart.php");
			exit;
		}

		if ($shoppingSessionData["shoppingSessionFingerprint"]!=$fingerprint){
			dbg("FINGERPRINT MISMATCH!");
			unset($_REQUEST["passVar"]);
			$mergedSuccessfully = 0;
		} else {
			$tmp = unserialize(base64_decode($_REQUEST["passVar"]));
			if (is_array($tmp)){
				$_REQUEST = $_REQUEST + $tmp;
				$mergedSuccessfully = 1;
			} else {
				$mergedSuccessfully = 0;
			}
		}
		if (!$mergedSuccessfully){
			die(TRANS_FAILED_TAMPER_TEST);
		}

		$this->smartyVars = array();
		$this->smartyVars["checkoutFormInfo"] = $_REQUEST;
		$this->smartyVars["paymentType"] = $_REQUEST["paymentType"];
		//$this->smartyVars["orderThemeDirectory"] = $CONF["relativeWebRoot"]."/app-modernbill-order/include/themes/".$CONF["theme"]["name"];

		// take care of attribute based info
		$this->additionalInfo = array();
		foreach ($_REQUEST as $k=>$v){
			if (substr($k, 0, strlen("question_"))=="question_"){
				$ids = explode("_", $k);
				//     additionalInfo[shoppingItemID][questionID]
				$this->additionalInfo[$ids[1]][$ids[2]] = $v;
			}
		}
		dbg("wizard based input:");
		dbg($this->additionalInfo);


		$this->mergeCycleData();

/**********************************************************************************************
 * get cart info here, will use to create command.
 */

		$this->smartyVars["hasDomain"] = false;

		$orderObjectParams = array(
									"ofid" => $shoppingSessionData["orderFormID"],
									"sid" => $shoppingSessionData["shoppingSessionID"],
									"set_locale" => $_REQUEST["set_locale"],
									);
		$order =& new Order($orderObjectParams);
		$this->smartyVars["domainInfo"] = $order->getDomainInfo();
		$this->smartyVars["currencyID"] = $order->orderFormCurrency;
		$this->smartyVars["orderParams"] = $order->getOrderParams();

		$languagesArray = correctArray(grabSimpleMBAPIResults(dispatchMBAPI("<mbapi><command>GetLanguages</command><params><languageISO2>".$CONF["user"]["locale"]->language."</languageISO2></params></mbapi>", 1)));
		dbg("languages:");
		dbg($languagesArray);
		foreach ($languagesArray as $language) {
			$order->orderFormLanguageID = $language["languageID"];
		}

		$this->smartyVars["continueShoppingURL"] = str_replace("%SID%", $_REQUEST["sid"], $order->continueShoppingURL);

		$shoppingCouponsXML = "	<mbapi>
									<command>GetShoppingCoupons</command>
									<params>
										<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
										<getCouponsData>1</getCouponsData>
									</params>
								</mbapi>";
		$shoppingCoupons = (array)correctArray(grabSimpleMBAPIResults(dispatchMBAPI($shoppingCouponsXML, 1)));

		$this->smartyVars["coupons"] = $shoppingCoupons;

		$shoppingItemsXML = "
				<mbapi>
					<command>GetShoppingItems</command>
					<params>
						<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
						<getDomainsRelData>1</getDomainsRelData>
						<sortColumn>parentShoppingItemID</sortColumn>
						<sortDir>ASC</sortDir>
					</params>
				</mbapi>";

		$shoppingItems = dispatchMBAPI($shoppingItemsXML, 1);

		if (isset($shoppingItems["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"][0])){
			$shoppingItems = correctArray($shoppingItems["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"]);
		} else {
			$shoppingItems = array();
		}

		//dbg("shopping items:");
		//dbg($shoppingItems);

		$getProductIDs = array();
		$getProductIDs[0] = 1;
		foreach ($shoppingItems as $row){
		 	$getProductIDs[$row["productID"]] = 1;
		}

////////////////////////////////////////
		// get products info here:
   		$productsInfoXML = "
						<mbapi>
							<command>GetProducts</command>
							<params>
									<productID>".@implode("</productID><productID>", array_keys($getProductIDs))."</productID>
									<getProductAttributeData>1</getProductAttributeData>
									<getCouponData>1</getCouponData>
									<getAllOrderFormItemData>1</getAllOrderFormItemData>
									<getOrderFormItemData>1</getOrderFormItemData>
									<getOrderFormData>1</getOrderFormData>
									<getProductVariantData>1</getProductVariantData>
									<getProductVariantPriceData>1</getProductVariantPriceData>
									<getTLDData>1</getTLDData>
									<getCycleData>1</getCycleData>
							</params>
						</mbapi>";
		$productsInfo = dispatchMBAPI($productsInfoXML, 1);
		if (isset($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"][0])){
			$productsInfo = correctArray($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"]);
		} else {
			$productsInfo = array();
		}

		//dbg("products info");
		//dbg($productsInfo);

		$this->smartyVars["products"] = array();
		$this->smartyVars["productVariantTaxZoneGroupIDs"] = array();
		foreach ($productsInfo as $row){
			$coupons = array();
			if (isset($row["coupons"])){
				foreach ($row["coupons"] as $coupon){
					$coupons[$coupon["couponID"]] = $coupon;
				}
			}
			$row["coupons"] = $coupons;
		 	$this->smartyVars["products"][$row["productID"]] = $row;
			if (isset($row["productVariants"])){
				foreach ($row["productVariants"] as $variant){
					$this->smartyVars["productVariantTaxZoneGroupIDs"][$variant["productVariantID"]] = (int)$variant["taxZoneGroupID"];
				}
			}
		}

////////////////////////////////////////

		$keyedItems = array();
		$keyedDomains = array();
		$this->smartyVars["wizardShoppingItems"] = array();
		foreach ($shoppingItems as $row){
			$this->smartyVars["wizardShoppingItems"][$row["shoppingItemID"]] = $row["productID"];
			if ($this->smartyVars["products"][$row["productID"]]["productType"]==getAPITypeID("products", "domain")){
 				$this->smartyVars["hasDomain"] = true;
			}
		 	if (isset($row["domains"])){
		 		//dbg("DOMAIN EXISTED!");
				foreach ($row["domains"] as $row2){
				 	$keyedDomains[$row2["domainShoppingItemID"]] = $row2;
				}
			} else {
				$row["domains"] = array();
			}
			$appliedCoupons = array();
			$couponTotal = 0;
			foreach ($this->smartyVars["coupons"] as $k=>$coupon){
				if ((int)$this->smartyVars["products"][$row["productID"]]["coupons"][$coupon["couponID"]]["couponID"] && !count($appliedCoupons)){
					if ((int)$coupon["couponType"]){
					 	$coupon["discount"] = $coupon["couponDiscount"];
					} else {
						$coupon["discount"] = round(($coupon["couponDiscount"]/100)*$row["shoppingItemPrice"], 2);
					}
					$coupon["negdiscount"] = 0-$coupon["discount"];
					$appliedCoupons[] = $coupon;
					$this->smartyVars["coupons"][$k]["discountTotal"] = round($this->smartyVars["coupons"][$k]["discountTotal"]+$coupon["discount"], 2);
					$couponTotal = round($coupon["discount"]+$couponTotal, 2);
				}
			}
			$row["appliedCoupons"] = $appliedCoupons;
			$row["couponTotal"] = $couponTotal;

			$key = (int)$row["parentShoppingItemID"];

			if (!$this->smartyVars["products"][$row["productID"]]["productIsAddon"]){
				$key = 0;
			}

			$keyedItems[$key][] = $row;

		}
		//dbg("keyed domains:");
		//dbg($keyedDomains);

		$this->smartyVars["shoppingItems"] = (array)$keyedItems[0];

		foreach ($this->smartyVars["shoppingItems"] as $k=>$v){
			$addonTotal = 0;
			if (isset($keyedItems[$v["shoppingItemID"]])){
			   	foreach ($keyedItems[$v["shoppingItemID"]] as $row){
			   	 	$addonTotal = round($addonTotal+round($row["shoppingItemPrice"], 2), 2);
			   	 	$addonTotal = round($addonTotal+round($row["shoppingItemSetupPrice"], 2), 2);
			   	 	$addonTotal = round($addonTotal-round($row["couponTotal"], 2), 2);
				}
			}
		 	$this->smartyVars["shoppingItems"][$k]["children"] = $keyedItems[$v["shoppingItemID"]];
		 	$this->smartyVars["shoppingItems"][$k]["addonPrice"] = $addonTotal;
		}

		$this->smartyVars["paymentOptions"] = $order->getPaymentOptions();
		$this->smartyVars["paymentOptions"]["cardTypes"] = $this->getAcceptedCardTypesByID($this->smartyVars["paymentOptions"]["primaryConfigGroupID"]);
		$this->smartyVars["paymentOptions"]["echeck"] = $this->getGatewayeCheckByID($this->smartyVars["paymentOptions"]["primaryConfigGroupID"]);
		$this->smartyVars["accounttypes"] = $CONF["types"]["bankAccount"];
        for ($i=date("Y"); $i<date("Y")+21; $i++){
            $this->smartyVars["cardYears"][$i] = $i;
        }

		if ((int)$CONF["shoppingSession"]["id"]){

			$clientInfo = collapsePluralsAndSingulars(grabSimpleMBAPIResults(dispatchMBAPI("
				<mbapi>
					<command>GetClients</command>
					<params>
						<clientID>".(int)$CONF["shoppingSession"]["id"]."</clientID>
						<getContactData>1</getContactData>
						<getBillingData>1</getBillingData>
					</params>
				</mbapi>																   ", 1)));
			$clientInfo = $clientInfo[0];
			$contactInfo = $clientInfo["contacts"][0];
			dbg($clientInfo);

			$this->smartyVars["billingAccounts"] = array();
			$clientInfo["billingAccounts"] = (array)$clientInfo["billingAccounts"];
			foreach ($clientInfo["billingAccounts"] as $acct){
				if ($acct["billingAccountType"]==0 && !(int)$this->smartyVars["nolek"]){
					$this->smartyVars["billingAccounts"][$acct["billingAccountID"]] = getTypeName("billingAccount", $acct["billingAccountType"])." - ".getTypeName("card", $acct["billingCardType"])." - Last 4 Digits: ".$acct["billingAccountNumLastFour"]." - ".$acct["billingCardNameOnCard"];
				}
				if ($acct["billingAccountType"]==1){
					$this->smartyVars["billingAccounts"][$acct["billingAccountID"]] = getTypeName("billingAccount", $acct["billingAccountType"])." - ".$acct["billingBankName"]." - ".@substr($acct["billingBankAccountNum"], -4);
				}
			}
			$this->smartyVars["numBillingAccounts"] = count($this->smartyVars["billingAccounts"]);

			$this->smartyVars["suppressFields"] = $clientInfo["clientActive"];

		}
		//dbg("SMARTY VARS");
		//dbg($this->smartyVars);

/**********************************************************************************************
 * end get cart info here
 */

		define("WIZARD_CART_DISPLAY", 1);

		// errors.....
 		$inputErrors = array();

		$pidar = array_keys($getProductIDs);
		if (!count($pidar))$pidar = array(0);

		// get order form based attributes
		$attributes = grabSimpleMBAPIResults(dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "GetAttributes",
				"params" => array(
					"orderFormID" => $shoppingSessionData["orderFormID"]
					)
				)
			)), 1), 1);
		dbg("raw attributes");
		dbg($attributes);
		$keyed_product_attributes = array();
		$all_question_ids = array();
		$keyed_questions_array = array();
		foreach ((array)$attributes as $attribute){
			// we key these on 0 because they are for the order form not a product.
			$keyed_questions_array[$attribute["questionID"]] =& $attributes[$k];
			$keyed_product_attributes[0][] = $attribute["questionID"];
			$all_question_ids[] = $attribute["questionID"];
			$keyed_attribute_ids[0][$attribute["questionID"]] = $attribute["attributeID"];
		}

		// get products attributes stuff
		$attributes = grabSimpleMBAPIResults(dispatchMBAPI(toXML(array(
			"mbapi" => array(
				"command" => "GetAttributes",
				"params" => array(
					"productID" => $pidar
					)
				)
			)), 1), 1);
		dbg("raw attributes");
		dbg($attributes);
		foreach ((array)$attributes as $attribute){
			$keyed_questions_array[$attribute["questionID"]] =& $attributes[$k];
			$keyed_product_attributes[(int)$attribute["productID"]][] = $attribute["questionID"];
			$all_question_ids[] = $attribute["questionID"];
			$keyed_attribute_ids[(int)$attribute["productID"]][$attribute["questionID"]] = $attribute["attributeID"];
		}
		dbg("keyed attributes");
		dbg($keyed_product_attributes);


#################################################################################################


#################################################################################################
#################################################################################################


		$this->smartyVars["shoppingItemQuestions"] = array();



		$questions =& new MBQuery("GetWizardQuestions", "", array("questionID"=>$all_question_ids));
		if ($this->addErrorsFromResult($r =& $questions->getResult())){
			$s =& $r->getSubjectFrom(array("mbapi", "results", "questions", "question"));
			$t =& $s->getTable("questionID");
			$questionsByID = $t->getAssociatedBy("questionID");

			$questionParams =& new MBQuery("GetWizardQuestionParams", "", array("questionID" => $all_question_ids, "getParamValues" => 1));
			if(!$this->addErrorsFromResult($r =& $questionParams->getResult())) break;
			$s =& $r->getSubjectFrom(array("mbapi", "results", "questionParams", "questionParam"));
			$t =& $s->getTable("questionParamID");
			$questionParamTablesByID = $t->getAssociatedTablesBy("questionID");

			$questionParamValueSubjectsByID =& $s->getAdditionalDataBy("questionParamID", "questionParamValues", "questionParamValue");
			$questionParamValuesByID = array();
			foreach($questionParamValueSubjectsByID as $questionParamID => $paramSubject) {
				$questionParamValuesByID[$questionParamID] = $paramSubject->getStructure();
			}

			dbg("question objects and stuff");
			dbg($questionsByID);
			dbg($questionParamTablesByID);
			dbg($questionParamValuesByID);


			$this->smartyVars["showShoppingItemQuestions"] = 0;
			$this->smartyVars["showCustomerQuestions"] = 0;
			$this->smartyVars["wizardShoppingItems"][0] = 0; // for order form attributes

			foreach ($this->smartyVars["wizardShoppingItems"] as $shoppingItemID=>$productID){
				dbg("doing shopping item: ".$shoppingItemID);
				$questionIDs = $keyed_product_attributes[$productID];

				if (count($questionIDs)){

					$w =& new Wizard(TRANS_QUESTION_PREVIEW, TRANS_QUESTION_PREVIEW_MESG);
					$w->setID($shoppingItemID);
					$w->cached = true;

					$s =& new WizardStep(TRANS_QUESTION_PREVIEW, TRANS_QUESTION_PREVIEW_MESG);
					$s->setID($shoppingItemID);

					foreach ($questionIDs as $questionID){
						if (isset($questionParamTablesByID[$questionID])){
							$q =& new WizardQuestion(QUESTION_INPUT_HIDDEN, "");
							$q->setID($questionID);
							$params = $questionParamTablesByID[$questionID]->getTable();
							foreach($params as $param) {
								call_user_func_array(
									array(&$q, $param["questionParamName"]),
									array_map(
										array('ProcessCartCheckout', 'constantize'),
										$questionParamValuesByID[$param["questionParamID"]]
									)
								);
							}
							$questionType = $q->getType();
							if ($questionType!=QUESTION_INPUT_HIDDEN){
								if ($shoppingItemID){
									$this->smartyVars["showShoppingItemQuestions"] = 1;
								} else {
									$this->smartyVars["showCustomerQuestions"] = 1;
								}
							}
							switch($questionType) {
								case QUESTION_INPUT_MULTISELECT:
								case QUESTION_INPUT_SELECT:
								case QUESTION_INPUT_CHECKBOX:
								case QUESTION_INPUT_RADIO:
									dbg($this->additionalInfo[$shoppingItemID][$questionID]);
									$q->setSelected((array)$this->additionalInfo[$shoppingItemID][$questionID]);
								break;
								default:
									dbg($this->additionalInfo[$shoppingItemID][$questionID]);
									$q->setAnswers((array)$this->additionalInfo[$shoppingItemID][$questionID]);
								break;
							}
							$errors = $q->validateFor($this->additionalInfo[$shoppingItemID][$questionID]);
							dbg($errors);
							$s->erroredQuestions[$questionID] = $errors;
							$s->invalidQuestions[$questionID] = errorMesgsFor($errors);

							if ($errors && !in_array(TRANS_INVALID_ADDITIONAL_INFORMATION_PROVIDED, $inputErrors)){
				 				$inputErrors[] = TRANS_INVALID_ADDITIONAL_INFORMATION_PROVIDED;
							}
							$s->addQuestion($q);
						}
					}

					$w->addSteps($s);
					$w->fetch = true;
					$this->smartyVars["shoppingItemQuestion"][$shoppingItemID] = $w->displayNextStep();

				}

			}
		}


#################################################################################################
#################################################################################################



/**********************************************************************************************
 * lets do some input validation here and redirect back to the form if needed.
 */

 		$inputErrors = array();
		$this->smartyVars["invalidFields"] = array();

 		// check non-domain reg info

 		// first we need to know if this is a returning user or not:
		if ((int)$CONF["shoppingSession"]["id"]){

			$clientInfo = collapsePluralsAndSingulars(grabSimpleMBAPIResults(dispatchMBAPI("
				<mbapi>
					<command>GetClients</command>
					<params>
						<clientID>".(int)$CONF["shoppingSession"]["id"]."</clientID>
						<getContactData>1</getContactData>
						<getBillingData>1</getBillingData>
					</params>
				</mbapi>																   ", 1)));
			$clientInfo = $clientInfo[0];


		} else {
 			// check username and password info.
			if (strlen(stripslashes($_REQUEST["contactUsername"]))<$this->smartyVars["orderParams"]["usermin"] || strlen(stripslashes($_REQUEST["contactUsername"]))>$this->smartyVars["orderParams"]["usermax"]){
				$inputErrors[] = TRANS_USERNAME_INVALID_LENGTH;
				$this->smartyVars["invalidFields"]["contactUsername"] = 1;
			}
			if ($_REQUEST["contactPassword"]==$_REQUEST["confirmcontactPassword"]){
				if (strlen(stripslashes($_REQUEST["contactPassword"]))<$this->smartyVars["orderParams"]["passmin"] || strlen(stripslashes($_REQUEST["contactPassword"]))>$this->smartyVars["orderParams"]["passmax"]){
					$this->smartyVars["invalidFields"]["contactPassword"] = 1;
					$this->smartyVars["invalidFields"]["confirmcontactPassword"] = 1;
					$inputErrors[] = TRANS_PASSWORD_INVALID_LENGTH;
				}
			} else {
				$this->smartyVars["invalidFields"]["contactPassword"] = 1;
				$this->smartyVars["invalidFields"]["confirmcontactPassword"] = 1;
				$inputErrors[] = TRANS_PASSWORDS_DONT_MATCH;
			}

			$requiredFields = array(
								"clientFirstName",
								"clientLastName",
								"clientEmail",
								"contactAddress1",
								"contactCity",
								"contactState",
								"contactZip",
								"contactPhone1",
								);
			foreach ($requiredFields as $field){
				if (!strlen(ereg_replace("[[:space:]]", "", $_REQUEST[$field]))){
					$this->smartyVars["invalidFields"][$field] = 1;
					$inputErrors[] = TRANS_INVALID_PERSONAL_INFO;
				}
			}
		}

		if (strpos($_REQUEST["paymentType"], "|")){
			$pieces = explode("|", $_REQUEST["paymentType"]);
			$_REQUEST["paymentType"] = $pieces[0];
			$_REQUEST["secondary"] = $pieces[1];
		}
		$requiredFields = array();

		switch ($_REQUEST["paymentType"]){
			case "1":
				$requiredFields = array(
										"billingCardNameOnCard",
										"billingCardNum",
										);
				$billingAccountType = 0;
				$billingCardNum = $_REQUEST["billingCardNum"];
			break;
			case "2":
			case "3":
			break;
			case "4":
			case "5":
				$requiredFields = array(
										"billingBankName",
										"billingBankState",
										"billingBankAccountNum",
										"billingBankLicenseNum",
										"billingBankLicenseState",
										"billingBankDob",
										"billingBankAbaCode",
										);
			break;
			case "50":
			break;
			case "9999":
			break;
		}

		foreach ($requiredFields as $field){
			if (!strlen(ereg_replace("[[:space:]]", "", $_REQUEST[$field]))){
				$this->smartyVars["invalidFields"][$field] = 1;
				$inputErrors[] = TRANS_INVALID_PAYMENT_INFO;
			}
		}

		if (!(int)$_REQUEST["termAgreement"]){
			$inputErrors[] = TRANS_YOU_MUST_AGREE_TO_THE_TERMS;
			$this->smartyVars["termAgreement"] = 1;
		}

		if (count($inputErrors)){

			dbg($_REQUEST);

			$this->smartyVars = $_REQUEST["smartyRedisplay"];
			$this->smartyVars["inputErrors"] = array_unique($inputErrors);
			$this->smartyVars["passVar"] = $_REQUEST["passVar"];

			$this->mergeCountryData();

			dbg("smarty vars:");
			dbg($this->smartyVars);

			// ok, we didn't make it through, lets redisplay the form
			$this->addTemplate("shopping/ShowCartCheckoutConfirmForm", $this->smartyVars);

		} else {

/**********************************************************************************************
 * ok, aparently we got past the input validation, lets process the preview invoice
 */

 			$processCheckoutXML = "
	 <mbapi>
	   <command>ProcessCheckout</command>
	   <subCommand>process</subCommand>
	   <params>

			<orderFormID>".$shoppingSessionData["orderFormID"]."</orderFormID>
			<affiliateCode></affiliateCode>
			<paymentType>".(int)$_REQUEST["paymentType"]."</paymentType>
			<secondary>".(int)$_REQUEST["secondary"]."</secondary>
			<invoiceID>".$shoppingSessionData["invoiceID"]."</invoiceID>
			<fraudLevelAction>".$shoppingSessionData["fraudLevelAction"]."</fraudLevelAction>
			<fraudLevelActionStatus>".$shoppingSessionData["fraudLevelActionStatus"]."</fraudLevelActionStatus>
			";

			if ((int)$shoppingSessionData["clientID"]){
				if ($CONF["shoppingSession"]["clientInfo"]["clientActive"]){
					$processCheckoutXML .= "
				<client>
					<clientID>".$shoppingSessionData["clientID"]."</clientID>
				</client>";
				} else {
					$processCheckoutXML .= "
					<client>
						  <clientID>".$shoppingSessionData["clientID"]."</clientID>
						  <clientFirstName>".secureInput($_REQUEST["clientFirstName"])."</clientFirstName>
						  <clientLastName>".secureInput($_REQUEST["clientLastName"])."</clientLastName>
						  <clientEmail>".secureInput($_REQUEST["clientEmail"])."</clientEmail>
						  <clientCompany>".secureInput($_REQUEST["clientCompany"])."</clientCompany>
						  <clientComments>".secureInput($_REQUEST["clientComments"])."</clientComments>
						  <contactUsername>".secureInput($_REQUEST["contactUsername"])."</contactUsername>
						  <contactPassword>".secureInput($_REQUEST["contactPassword"])."</contactPassword>
						  <languageID>".$order->orderFormLanguageID."</languageID>
						  <countriesID>".secureInput($_REQUEST["countriesID"])."</countriesID>
						  <themeID>1</themeID>
						  <companyID>1</companyID>
					</client>
	                <clientContact>
						  <contactAddress1>".secureInput($_REQUEST["contactAddress1"])."</contactAddress1>
						  <contactAddress2>".secureInput($_REQUEST["contactAddress2"])."</contactAddress2>
						  <contactCity>".secureInput($_REQUEST["contactCity"])."</contactCity>
						  <contactState>".secureInput($_REQUEST["contactState"])."</contactState>
						  <contactZip>".secureInput($_REQUEST["contactZip"])."</contactZip>
						  <contactPhone1>".secureInput($_REQUEST["contactPhone1"])."</contactPhone1>
						  <contactPhone2>".secureInput($_REQUEST["contactPhone2"])."</contactPhone2>
						  <contactFax>".secureInput($_REQUEST["contactFax"])."</contactFax>
					</clientContact>
					";
				}
			} else {
					$processCheckoutXML .= "
					<client>
						  <clientFirstName>".secureInput($_REQUEST["clientFirstName"])."</clientFirstName>
						  <clientLastName>".secureInput($_REQUEST["clientLastName"])."</clientLastName>
						  <clientEmail>".secureInput($_REQUEST["clientEmail"])."</clientEmail>
						  <clientCompany>".secureInput($_REQUEST["clientCompany"])."</clientCompany>
						  <clientComments>".secureInput($_REQUEST["clientComments"])."</clientComments>
						  <contactUsername>".secureInput($_REQUEST["contactUsername"])."</contactUsername>
						  <contactPassword>".secureInput($_REQUEST["contactPassword"])."</contactPassword>
						  <languageID>".$order->orderFormLanguageID."</languageID>
						  <countriesID>".secureInput($_REQUEST["countriesID"])."</countriesID>
						  <themeID>1</themeID>
						  <companyID>1</companyID>
					</client>
	                <clientContact>
						  <contactAddress1>".secureInput($_REQUEST["contactAddress1"])."</contactAddress1>
						  <contactAddress2>".secureInput($_REQUEST["contactAddress2"])."</contactAddress2>
						  <contactCity>".secureInput($_REQUEST["contactCity"])."</contactCity>
						  <contactState>".secureInput($_REQUEST["contactState"])."</contactState>
						  <contactZip>".secureInput($_REQUEST["contactZip"])."</contactZip>
						  <contactPhone1>".secureInput($_REQUEST["contactPhone1"])."</contactPhone1>
						  <contactPhone2>".secureInput($_REQUEST["contactPhone2"])."</contactPhone2>
						  <contactFax>".secureInput($_REQUEST["contactFax"])."</contactFax>
					</clientContact>";
			}


			$processCheckoutXML .= "
  					<clientBillingAccount>
						<billingAccountType>$billingAccountType</billingAccountType>
  						<billingAccountID>".secureInput($_REQUEST["billingAccountID"])."</billingAccountID>
  						<billingCardNameOnCard>".secureInput($_REQUEST["billingCardNameOnCard"])."</billingCardNameOnCard>
  						<billingCardType>".secureInput($_REQUEST["billingCardType"])."</billingCardType>
  						<billingCardNum>".secureInput($_REQUEST["billingCardNum"])."</billingCardNum>
  						<billingCardExpMonth>".secureInput($_REQUEST["billingCardExpMonth"])."</billingCardExpMonth>
  						<billingCardExpYear>".secureInput($_REQUEST["billingCardExpYear"])."</billingCardExpYear>
  						<cardCVV2>".secureInput($_REQUEST["cardCVV2"])."</cardCVV2>
  						<billingBankName>".secureInput($_REQUEST["billingBankName"])."</billingBankName>
  						<billingBankState>".secureInput($_REQUEST["billingBankState"])."</billingBankState>
  						<billingBankAbaCode>".secureInput($_REQUEST["billingBankAbaCode"])."</billingBankAbaCode>
  						<billingBankAccountNum>".secureInput($_REQUEST["billingBankAccountNum"])."</billingBankAccountNum>
  						<billingBankLicenseNum>".secureInput($_REQUEST["billingBankLicenseNum"])."</billingBankLicenseNum>
  						<billingBankLicenseState>".secureInput($_REQUEST["billingBankLicenseState"])."</billingBankLicenseState>
  						<billingBankDob>".secureInput($_REQUEST["billingBankDob"])."</billingBankDob>
					</clientBillingAccount>
				<domainRegistrant>
						<registrantFirstName>".secureInput($_REQUEST["registrantFirstName"])."</registrantFirstName>
						<registrantLastName>".secureInput($_REQUEST["registrantLastName"])."</registrantLastName>
						<registrantAddress1>".secureInput($_REQUEST["registrantAddress1"])."</registrantAddress1>
						<registrantAddress2>".secureInput($_REQUEST["registrantAddress2"])."</registrantAddress2>
						<registrantCity>".secureInput($_REQUEST["registrantCity"])."</registrantCity>
						<registrantStateProvince>".secureInput($_REQUEST["registrantStateProvince"])."</registrantStateProvince>
						<registrantPostalCode>".secureInput($_REQUEST["registrantPostalCode"])."</registrantPostalCode>
						<registrantOrganizationName>".secureInput($_REQUEST["registrantOrganizationName"])."</registrantOrganizationName>
						<registrantJobTitle>".secureInput($_REQUEST["registrantJobTitle"])."</registrantJobTitle>
						<registrantEmail>".secureInput($_REQUEST["registrantEmail"])."</registrantEmail>
						<registrantPhone>".secureInput($_REQUEST["registrantPhone"])."</registrantPhone>
						<registrantFax>".secureInput($_REQUEST["registrantFax"])."</registrantFax>
						<registrantCountry>".secureInput($_REQUEST["registrantCountry"])."</registrantCountry>
				</domainRegistrant>
						";


			$processCheckoutXML .= "
				<packageUsername>".secureInput($_REQUEST["contactUsername"])."</packageUsername>
				<packagePassword>".secureInput($_REQUEST["contactPassword"])."</packagePassword>
				";

			if ($this->additionalInfo[0]){
				$processCheckoutXML .= "<attributes>\n";
				foreach ($this->additionalInfo[0] as $questionID=>$answers){
					$attributeID = $keyed_attribute_ids[0][$questionID];
					$processCheckoutXML .= "<attribute>
									<questionID>".$questionID."</questionID>
									<attributeID>".$attributeID."</attributeID>
									<answers>";
										
					foreach ((array)$answers as $answer){
						$processCheckoutXML .= "<answer>".$answer."</answer>\n";
					}
											
					$processCheckoutXML .= "	</answers>
								</attribute>\n";
				}
				$processCheckoutXML .= "</attributes>\n";
			}

			$this->smartyVars["packageDateNextRenewal"] = ((int)$_REQUEST["packageDateNextRenewal"]>time() && (int)$_REQUEST["packageDateNextRenewal"]<time()+(60*20))?(int)$_REQUEST["packageDateNextRenewal"]:time()-1;

			foreach ($this->smartyVars["shoppingItems"] as $shoppingItem){

 				$processCheckoutXML .= "
 				<products>
 					<ID>".$shoppingItem["shoppingItemID"]."</ID>
 					<productID>".$shoppingItem["productID"]."</productID>
					<parentProductID>".$shoppingItem["parentShoppingItemID"]."</parentProductID>
 					<productVariantID>".$shoppingItem["productVariantID"]."</productVariantID>
					<packageDateNextRenewal>".$this->smartyVars["packageDateNextRenewal"]."</packageDateNextRenewal>
 					<cycleID>".$shoppingItem["cycleID"]."</cycleID>
 					<couponID>".$shoppingItem["appliedCoupons"][0]["couponID"]."</couponID>
 					<couponPrice>".((isset($shoppingItem["appliedCoupons"][0]["discount"]))?(float)$shoppingItem["shoppingItemPrice"]-$shoppingItem["appliedCoupons"][0]["discount"]:0)."</couponPrice>
 					<couponNumCycles>".$shoppingItem["appliedCoupons"][0]["couponNumCycles"]."</couponNumCycles>
					<quantity>1</quantity>
					<taxZoneGroupID>".$this->smartyVars["productVariantTaxZoneGroupIDs"][$shoppingItem["productVariantID"]]."</taxZoneGroupID>
					<comments></comments>
					<price>".(float)$shoppingItem["shoppingItemPrice"]."</price>
					<setup>".(float)$shoppingItem["shoppingItemSetupPrice"]."</setup>
 					<addons>";


 				if (isset($shoppingItem["children"][0]["shoppingItemID"])){
 					foreach ($shoppingItem["children"] as $child){
 						$processCheckoutXML .= "
							<addon>
								<productID>".$child["productID"]."</productID>
								<productVariantID>".$child["productVariantID"]."</productVariantID>
								<couponID>".$child["appliedCoupons"][0]["couponID"]."</couponID>
								<couponPrice>".((isset($child["appliedCoupons"][0]["discount"]))?(float)$child["shoppingItemPrice"]-$child["appliedCoupons"][0]["discount"]:0)."</couponPrice>
								<couponNumCycles>".$child["appliedCoupons"][0]["couponNumCycles"]."</couponNumCycles>
								<quantity>1</quantity>
								<taxZoneGroupID>".$this->smartyVars["productVariantTaxZoneGroupIDs"][$child["productVariantID"]]."</taxZoneGroupID>
								<price>".(float)$child["shoppingItemPrice"]."</price>
								<setup>".(float)$child["shoppingItemSetupPrice"]."</setup>
							</addon>\n";
					}
				}

				$processCheckoutXML .= "
 					</addons>";

 				if ($this->smartyVars["products"][$shoppingItem["productID"]]["productType"]==getAPITypeID("products", "domain")){

					$processCheckoutXML .= "
						<domain>
							<domainType>".$keyedDomains[$shoppingItem["shoppingItemID"]]["shoppingItemsDomainsType"]."</domainType>
							<domainID>".$shoppingItem["shoppingItemID"]."</domainID>
							<domainSLD>".$shoppingItem["shoppingItemSLD"]."</domainSLD>
							<domainTLD>".$shoppingItem["shoppingItemTLD"]."</domainTLD>
							<domainIDNLanguage>en</domainIDNLanguage>\n";

					if (count($_REQUEST["extAttrib"][$shoppingItem["shoppingItemSLD"].".".$shoppingItem["shoppingItemTLD"]])){
						$processCheckoutXML .= toXML(array("extraInfo"=>$_REQUEST["extAttrib"][$shoppingItem["shoppingItemSLD"].".".$shoppingItem["shoppingItemTLD"]]));
					}

					$processCheckoutXML .= "
						</domain>";

				} else {

					if ($shoppingItem["domains"][0]["shoppingItemsDomainsRelID"]){
						switch ($shoppingItem["domains"][0]["shoppingItemsDomainsType"]){
							case getAPITypeID("shoppingdomains", "new"):
							case getAPITypeID("shoppingdomains", "transfer"):
							$processCheckoutXML .= "
								<domain>
									<domainType>".$shoppingItem["domains"][0]["shoppingItemsDomainsType"]."</domainType>
									<domainID>".$shoppingItem["domains"][0]["domainShoppingItemID"]."</domainID>
								</domain>";
							break;
							case getAPITypeID("shoppingdomains", "manual"):
							case getAPITypeID("shoppingdomains", "existing"):
							$processCheckoutXML .= "
								<domain>
									<domainType>".$shoppingItem["domains"][0]["shoppingItemsDomainsType"]."</domainType>
									<domainSLD>".$shoppingItem["domains"][0]["domainSLD"]."</domainSLD>
									<domainTLD>".$shoppingItem["domains"][0]["domainTLD"]."</domainTLD>
								</domain>";
							break;
						}
					}

				}

				if ($this->additionalInfo[$shoppingItem["shoppingItemID"]]){
					$processCheckoutXML .= "<attributes>\n";
					foreach ($this->additionalInfo[$shoppingItem["shoppingItemID"]] as $questionID=>$answers){
						$attributeID = $keyed_attribute_ids[$shoppingItem["productID"]][$questionID];
						$processCheckoutXML .= "<attribute>
										<questionID>".$questionID."</questionID>
										<attributeID>".$attributeID."</attributeID>
										<answers>";
										
						foreach ((array)$answers as $answer){
							$processCheckoutXML .= "<answer>".$answer."</answer>\n";
						}
											
						$processCheckoutXML .= "	</answers>
									</attribute>\n";
					}
					$processCheckoutXML .= "</attributes>\n";
				}

				$processCheckoutXML .= "
 				</products>";

			}

			$processCheckoutXML .= "
	   </params>
	 </mbapi>";

 			dbg("#########################################################################################");
 			dbg($processCheckoutXML);
 			dbg("#########################################################################################");

 			$result = dispatchMBAPI($processCheckoutXML, 1);
 			dbg("#########################################################################################
#########################################################################################
#########################################################################################
#########################################################################################");
			dbg($result);
 			dbg("#########################################################################################
#########################################################################################
#########################################################################################
#########################################################################################");

			if ($result["mbapi"][0]["results"][0]["clientID"][0]){

				$setSessionLoginXML = "	<mbapi>
											<command>SetShoppingSession</command>
											<subCommand>update</subCommand>
											<params>
												<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
												<clientID>".(int)$result["mbapi"][0]["results"][0]["clientID"][0]."</clientID>
												<clientContactID>".(int)$result["mbapi"][0]["results"][0]["clientContactID"][0]."</clientContactID>
												<invoiceID>".(int)$result["mbapi"][0]["results"][0]["invoiceID"][0]."</invoiceID>
												<billingAccountID>".(int)$result["mbapi"][0]["results"][0]["billingAccountID"][0]."</billingAccountID>
											</params>
										</mbapi>";
				$setResult = dispatchMBAPI($setSessionLoginXML, 1);
				dbg("set session client id result:");
				dbg($setResult);

				$this->smartyVars["invoiceID"] = $result["mbapi"][0]["results"][0]["invoiceID"][0];

				$this->smartyVars["invoiceInfo"] = correctArray(grabSimpleMBAPIResults(dispatchMBAPI("
														<mbapi>
															<command>GetInvoices</command>
															<params>
																<invoiceID>".$this->smartyVars["invoiceID"]."</invoiceID>
															</params>
														</mbapi>
																									 ", 1)));
				dbg("invoiceInfo:");
				$this->smartyVars["invoiceInfo"] = $this->smartyVars["invoiceInfo"][0];
				dbg($this->smartyVars["invoiceInfo"]);

				if ((int)$result["mbapi"][0]["results"][0]["transaction"][0]["result"][0]){

                    // Did they accept the PPC Offer?
                    if ((int) $_REQUEST["awo"] && (int) $_REQUEST["awid"]) {
                        $this->updatePPCStatus();
                    }

                    //* UNCOMMENT FOR TESTING TO ALLOW DUPLICATE ORDERS TO PROCESS
					$this->clearCart();
                    /**/

					$this->smartyVars["transaction"] = correctArray($result["mbapi"][0]["results"][0]["transaction"][0]);
					dbg("transaction info sent to template:");
					dbg($this->smartyVars["transaction"]);
					$this->smartyVars["transaction"]["secondary"][0]["form"] = (array)$this->smartyVars["transaction"]["secondary"][0]["form"];
					$this->smartyVars["transaction"]["secondary"][0]["link"] = (array)$this->smartyVars["transaction"]["secondary"][0]["link"];
					$this->smartyVars["transaction"]["secondary"][0]["linkurl"] = (array)$this->smartyVars["transaction"]["secondary"][0]["linkurl"];
					$this->addTemplate("shopping/CheckoutSuccess", $this->smartyVars);

				} else {

					$this->smartyVars["transaction"] = correctArray($result["mbapi"][0]["results"][0]["transaction"][0]);
					$this->addTemplate("shopping/CheckoutFailure", $this->smartyVars);

				}



			} else {

				$this->addError(TRANS_ACTIONERROR, "ProcessCheckout Command Failure.");

			}


	/////////// end command generation




	//        if ($_REQUEST["redirectURL"]!="") {
	  //          redirect($_REQUEST["redirectURL"]);
	    //    } else {
	      //     	redirect("cart.php?sid=".secureInput($_REQUEST["sid"])."&action=".getActionID("ShowCartCheckoutConfirmForm"));
	        //}

		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}


	function clearCart(){
		$setItemXML = "
				<mbapi>
					<command>SetShoppingItem</command>
					<subCommand>delete</subCommand>
					<params>
						<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
					</params>
				</mbapi>";
		$setItem = dispatchMBAPI($setItemXML, 1);
		dbg("result:");
		dbg($setItem);

		$setCouponXML = "
					<mbapi>
						<command>SetShoppingCoupon</command>
						<subCommand>delete</subCommand>
						<params>
							<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
						</params>
					</mbapi>";
		$setCoupon = dispatchMBAPI($setCouponXML, 1);
		dbg("coupon result:");
		dbg($setCoupon);
		$setSessionLoginXML = "	<mbapi>
									<command>SetShoppingSession</command>
									<subCommand>update</subCommand>
									<params>
										<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
										<shoppingSessionFingerprint></shoppingSessionFingerprint>
										<fraudLevelAction>0</fraudLevelAction>
										<fraudLevelActionStatus>0</fraudLevelActionStatus>
										<invoiceID>0</invoiceID>
										<billingAccountID>0</billingAccountID>
									</params>
								</mbapi>";
		$setResult = dispatchMBAPI($setSessionLoginXML, 1);
		setcookie("mb_domain_info", "", time()-10, "/");

	}

	/**
	 * Update the status of the PPC offer. Did they accept the offer or not?
	 */
    function updatePPCStatus() {
        global $CONF;
        // get the codeID
        $args = array
        (
            "codeRemoteID" => (int) $_REQUEST["awid"],
            "codeClientID" => (int) $CONF["shoppingSession"]["id"],
        );
		$query = getMBAPIQuery("GetPPCCodes", "", $args, 0, 0, 0, 0, 0, $this->params);
		$data = dispatchMBAPI($query, 1);
        dbg($data);
        // set the code to accepted
        if ($data["mbapi"][0]["results"][0]["ppcCodes"][0]["ppcCode"][0]["codeID"][0]) {
            $args = array
            (
                "codeID" => (int) $data["mbapi"][0]["results"][0]["ppcCodes"][0]["ppcCode"][0]["codeID"][0],
                "codeStatus" => getAPIStatusID("ppcCodes", "accepted"),
            );
		    $query = getMBAPIQuery("SetPPCCodes", "update", $args, 0, 0, 0, 0, 0, $this->params);
		    $data = dispatchMBAPI($query, 1);
            dbg($data);
        }
    }
	/**
	 * if a value is a constant, resolve it
	 *
	 * @param  string  value
	 * @return  string|constant  value or resolved value
	 */
	function constantize($value) {
		return defined($value) ? constant($value) : $value;
	}

} // ProcessCartCheckout
?>
