<?php
// $Id: ShowCart.php,v 1.23 2006/08/01 15:48:18 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/app-modernbill-order/include/order/order.php");

/**
 * This Action object collects information on a website widget that matches the given parameters, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class ShowCart extends MB_Action {
	/**
	 * The constructor for a ShowCart action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowCart() {
		parent::MB_Action();
		$this->stringRep = "ShowCart";

		$this->params = array();
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the ShowCart action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$CONF["theme"]["type"] = "public";

		$this->smartyVars = array();
		$this->smartyVars["orderThemeDirectory"] = $CONF["relativeWebRoot"]."/app-modernbill-order/include/themes/".$CONF["theme"]["name"];

		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"]);
		$this->mergeCycleData();

		$orderObjectParams = array(
			"ofid" => $shoppingSessionData["orderFormID"],
			"sid" => $shoppingSessionData["shoppingSessionID"],
			"set_locale" => $_REQUEST["set_locale"],
		);
		$order =& new Order($orderObjectParams);
		$this->smartyVars["domainInfo"] = $order->getDomainInfo();
		$this->smartyVars["currencyID"] = $order->orderFormCurrency;

		$this->smartyVars["skipDomain"] = (in_array("dom_skip", (array)$order->domainOptions))?1:0;

		$this->smartyVars["continueShoppingURL"] = str_replace("%SID%", $_REQUEST["sid"], $order->continueShoppingURL);

		$shoppingCouponsXML = "	<mbapi>
									<command>GetShoppingCoupons</command>
									<params>
										<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
										<getCouponsData>1</getCouponsData>
									</params>
								</mbapi>";
		$shoppingCoupons = (array)correctArray(grabSimpleMBAPIResults(dispatchMBAPI($shoppingCouponsXML, 1)));

		$this->smartyVars["coupons"] = $shoppingCoupons;

		$shoppingItemsXML = "
				<mbapi>
					<command>GetShoppingItems</command>
					<params>
						<shoppingSessionID>".secureInput($_REQUEST["sid"])."</shoppingSessionID>
						<getDomainsRelData>1</getDomainsRelData>
					</params>
				</mbapi>";

		$shoppingItems = dispatchMBAPI($shoppingItemsXML, 1);

		dbg("shopping items:");
		dbg($shoppingItems);

		if (is_array($shoppingItems["mbapi"][0]["results"][0]["shoppingItems"][0])){
			$shoppingItems = correctArray($shoppingItems["mbapi"][0]["results"][0]["shoppingItems"][0]["shoppingItem"]);
		} else {
			$shoppingItems = array();
		}


		$getProductIDs = array();
		$getProductIDs[0] = 1;
		foreach ($shoppingItems as $row){
		 	$getProductIDs[$row["productID"]] = 1;
		}

////////////////////////////////////////
		// get products info here:
   		$productsInfoXML = "
						<mbapi>
							<command>GetProducts</command>
							<params>
									<productID>".@implode("</productID><productID>", array_keys($getProductIDs))."</productID>
									<getProductAttributeData>1</getProductAttributeData>
									<getCouponData>1</getCouponData>
									<getAllOrderFormItemData>1</getAllOrderFormItemData>
									<getOrderFormItemData>1</getOrderFormItemData>
									<getOrderFormData>1</getOrderFormData>
									<getProductVariantData>1</getProductVariantData>
									<getProductVariantPriceData>1</getProductVariantPriceData>
									<getTLDData>1</getTLDData>
									<getCycleData>1</getCycleData>
									<getGhostCycleIDs>1</getGhostCycleIDs>
							</params>
						</mbapi>";
		$productsInfo = dispatchMBAPI($productsInfoXML, 1);
		if (isset($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"][0])){
			$productsInfo = correctArray($productsInfo["mbapi"][0]["results"][0]["products"][0]["product"]);
		} else {
			$productsInfo = array();
		}

		dbg("products info");
		dbg($productsInfo);

		$this->smartyVars["products"] = array();
		foreach ($productsInfo as $row){
			$coupons = array();
			if (isset($row["coupons"])){
				foreach ($row["coupons"] as $coupon){
					$coupons[$coupon["couponID"]] = $coupon;
				}
			}
			$row["coupons"] = $coupons;
			$row["numCycles"] = count($row["ghostCycles"]);

			$this->smartyVars["products"][$row["productID"]] = $row;
		}

////////////////////////////////////////




		$keyedItems = array();
		$keyedDomains = array();
		foreach ($shoppingItems as $row){
		 	if (isset($row["domains"])){
		 		dbg("DOMAIN EXISTED!");
				foreach ($row["domains"] as $row2){
				 	$keyedDomains[$row2["domainShoppingItemID"]] = $row2;
				}
			} else {
				$row["domains"] = array();
			}
			$appliedCoupons = array();
			$couponTotal = 0;
			foreach ($this->smartyVars["coupons"] as $k=>$coupon){
				if ((int)$this->smartyVars["products"][$row["productID"]]["coupons"][$coupon["couponID"]]["couponID"] && !count($appliedCoupons)){
					if ((int)$coupon["couponType"]){
					 	$coupon["discount"] = $coupon["couponDiscount"];
					} else {
						$coupon["discount"] = round(($coupon["couponDiscount"]/100)*$row["shoppingItemPrice"], 2);
					}
					$coupon["negdiscount"] = 0-$coupon["discount"];
					$appliedCoupons[] = $coupon;
					$this->smartyVars["coupons"][$k]["discountTotal"] = round($this->smartyVars["coupons"][$k]["discountTotal"]+$coupon["discount"], 2);
					$couponTotal = round($coupon["discount"]+$couponTotal, 2);
				}
			}
			$row["appliedCoupons"] = $appliedCoupons;
			$row["couponTotal"] = $couponTotal;

			$key = (int)$row["parentShoppingItemID"];

			if (!$this->smartyVars["products"][$row["productID"]]["productIsAddon"]){
			//	$key = 0; // uncomment to make it show as its own line item instead of a child entry
			}

			$keyedItems[$key][] = $row;
		}



		$this->smartyVars["shoppingItems"] = (array)$keyedItems[0];

		foreach ($this->smartyVars["shoppingItems"] as $k=>$v){
			$addonTotal = 0;
			if (isset($keyedItems[$v["shoppingItemID"]])){
			   	foreach ($keyedItems[$v["shoppingItemID"]] as $row){
			   	 	$addonTotal = round($addonTotal+round($row["shoppingItemPrice"], 2), 2);
			   	 	$addonTotal = round($addonTotal+round($row["shoppingItemSetupPrice"], 2), 2);
			   	 	$addonTotal = round($addonTotal-round($row["couponTotal"], 2), 2);
				}
			}
		 	$this->smartyVars["shoppingItems"][$k]["children"] = $keyedItems[$v["shoppingItemID"]];
		 	$this->smartyVars["shoppingItems"][$k]["addonPrice"] = $addonTotal;
		}

		$this->smartyVars["incorrectLogin"] = secureInput($_REQUEST["incorrectLogin"]);

		dbg("Smarty Vars:");
		dbg($this->smartyVars);

		if (eregi("safari", $_SERVER["HTTP_USER_AGENT"])){
			$this->addTemplate("shopping/ShowCartSafari", $this->smartyVars);
		} else {
			$this->addTemplate("shopping/ShowCart", $this->smartyVars);
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // ShowWebsiteWidget
?>
