<?php
// $Id: ShowWebsiteWidget.php,v 1.20 2006/07/07 18:09:36 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");
require_once mb_path("/lib-modernbill/include/config/internal/cycles.php");
require_once mb_path("/app-modernbill-order/include/order/order.php");

/**
 * This Action object collects information on a website widget that matches the given parameters, and
 * generates the display of that information.
 *
 * @author  Kris Bailey
 */
class ShowWebsiteWidget extends MB_Action {
	/**
	 * The constructor for a ShowWebsiteWidget action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. This method also sets up $this->params and
	 * $this->sortColumns for use in $this->getMBAPIQuery().
	 */
	function ShowWebsiteWidget() {
		parent::MB_Action();
		$this->stringRep = "ShowWebsiteWidget";

		$this->params = array("wwid");
		$this->sortColumns = array();
	}

	/**
	 * The main method of this class that executes the ShowWebsiteWidget action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		dbg("at the top of website widget show action.");

		$CONF["theme"]["type"] = "public";

		$this->smartyVars = array();
		$this->smartyVars["shoppingSession"] = $shoppingSessionData;
		$this->mergeCycleData();

		dbg("at the top of website widget show action. 2");

		if ($CONF["secureURLProtocol"]=="http"){
		 	$this->smartyVars["cartURL"] = $CONF["secureURLProtocol"]."://".$CONF["standardURL"].mb_path_convert_path("/app-modernbill-order")."/cart.php?sid=".$_REQUEST["sid"];
		} else {
		 	$this->smartyVars["cartURL"] = $CONF["secureURLProtocol"]."://".$CONF["secureURL"].mb_path_convert_path("/app-modernbill-order")."/cart.php?sid=".$_REQUEST["sid"];
		}

		dbg("at the top of website widget show action. 3");

		$wwInfo = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetWebsiteWidgets",
				"params" => array(
					"websiteWidgetID" => (int)$_REQUEST["wwid"],
					"getProductInformation" => 1,
					"getOrderFormData" => 1,
				),
			),
		)));
		dbg($wwInfo);

		dbg("at the top of website widget show action. 4");

		$this->smartyVars["orderFormID"] = $orderFormID = $wwInfo["orderFormID"];
		$this->smartyVars["currencyID"] = $wwInfo["paymentGroupCurrencyID"];

		$shoppingSessionData = $this->updateShoppingSession($_REQUEST["sid"], $orderFormID);

		dbg("at the top of website widget show action. 5");

		$productIDs = (array) $wwInfo["products"];
		dbg("product info");
		dbg($productIDs);

		$getProductIDs = array();
		foreach ($productIDs as $row){
		 	$getProductIDs[] = $row["productID"];
		}
        if (count($getProductIDs) == 0) {
            $getProductIDs = array(0);
        }

		dbg("at the top of website widget show action. 6");

		dbg("ids to get:");
		dbg($getProductIDs);

		$productsInfoXML = "
						<mbapi>
							<command>GetProducts</command>
							<params>
									<productID>".@implode("</productID><productID>", $getProductIDs)."</productID>
									<productActive>1</productActive>
									<getProductAttributeData>1</getProductAttributeData>
									<getCouponData>1</getCouponData>
									<getAllOrderFormItemData>1</getAllOrderFormItemData>
									<getOrderFormItemData>1</getOrderFormItemData>
									<getOrderFormData>1</getOrderFormData>
									<getProductVariantData>1</getProductVariantData>
									<getProductVariantPriceData>1</getProductVariantPriceData>
									<getTLDData>1</getTLDData>
									<getCycleData>1</getCycleData>
									<getCycleGhostIDs>1</getCycleGhostIDs>
							</params>
						</mbapi>";
		dbg("SEARCH FOR ME");
		$productsInfo = dispatchMBAPI($productsInfoXML, 1);
		$productsInfo = correctArray(grabSimpleMBAPIResults($productsInfo));

		dbg($productsInfo);

		dbg("at the top of website widget show action. 7");

        $this->smartyVars["numClients"] = (int) numClients;
        if ($this->smartyVars["numClients"] > 100) {
            $this->smartyVars["formDisabled"] = "disabled";
        }
		$this->smartyVars["configGroupID"] = $configGroupID;
		$this->smartyVars["configParams"] = $CONF["other"]["ppc"]["ppcfactory"];

		// Is PPCFactory enabled?
		loadConfigs("other");
		if ($CONF["other"]["ppc"]["ppcfactory"]["enablePPCfactory"]) {
			$monthlyCycles = getCyclesArray("monthly");
		}

		foreach ($productsInfo as $k=>$v){

			$validCycles = array();
			foreach ((array)$v["ghostCycles"] as $cycle){
				$validCycles[] = $cycle["cycleID"];
			}

			dbg("testing product: ".$v["productID"]);
			$prices = array();
		 	if (isset($productsInfo[$k]["productVariantPrices"])){
				foreach ($productsInfo[$k]["productVariantPrices"] as $price){
					if (in_array($price["cycleID"], $validCycles)){
						$prices[$price["currencyID"]][$price["productVariantID"]."-".$price["cycleID"]][$price["productVariantPriceType"]] = $price;
					}
				}
			} else {
				dbg("didnt find prices");
			}
			foreach ($prices as $currency => $rows){
				$productPrice = array_values($rows);
				$productsInfo[$k]["prices"][$currency] = $productPrice;

				// only run PPC logic if enabled
				if ($CONF["other"]["ppc"]["ppcfactory"]["enablePPCfactory"]) {

					// only run PPC logic if hosting product in USD currency
					if ($productsInfo[$k]["productType"] == 1 && $currency == "USD") {

						// set the current package cycleID
						$cycleID = $productPrice[0][0]["cycleID"];
			
						// only run the PPC logic if the cycleID is in the "monthly" group
						if (array_key_exists($cycleID, $monthlyCycles)) {

							// find the multiplier for this cycle
							$cycleMultiplier = $CONF["cycles"][$cycleID][1];

							// only run if we have a valid multiplier
							if ($cycleMultiplier) {

								// ** THESE ARE HARD CODED BUSINESS RULES FOR DISPLAY PURPOSES ONLY **
								// ** DO NOT EDIT **
								$monthlyPrice = round($productPrice[0][0]["productVariantPriceAmount"] / $cycleMultiplier);
								if ($monthlyPrice <= 25) {
									$codeValue = "25.00";
								} else if ($monthlyPrice <= 100) {
									$codeValue = "50.00";
								} else if ($monthlyPrice > 100) {
									$codeValue = "75.00";
								}
								$productsInfo[$k]["adWordsCredit"] = $codeValue;
								// ** DO NOT EDIT **
								// ** THESE ARE HARD CODED BUSINESS RULES FOR DISPLAY PURPOSES ONLY **
							} // $cycleMultiplier
						} // array_key_exists
					} // productType && USD
				} // enablePPCfactory

			}
			unset($productsInfo[$k]["productVariantPrices"]);
		}

		$this->smartyVars["products"] = $productsInfo;
		dbg("smarty vars:");
		dbg($this->smartyVars);

		dbg("at the top of website widget show action. 8");

		// count the number of products to help display differeny type of widgets
		$c = count($this->smartyVars["products"]);
		$this->smartyVars["numProducts"] = $c;
		$this->smartyVars["ceilProducts"] = ceil($c / 2);
		$this->smartyVars["evenProducts"] = ($c % 2) ? 1 : 0 ;
		$this->smartyVars["adWordsExpiresDate"] = date("m/d/Y",mktime(0,0,0,date("m"),date("d")+15,date("y")));
		
		$this->addTemplate("website_widgets/".$wwInfo["websiteWidgetTpl"], $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

} // ShowWebsiteWidget
?>
