<?php
// --------------------------------------------------------------------------
// MIGRATION SETTINGS
// --------------------------------------------------------------------------

	// Change this to 1 to enable migration
define("ALLOW_MIGRATION", 0);

// --------------------------------------------------------------------------
// MBAPI APP SETTINGS
// --------------------------------------------------------------------------

        // Define the MBAPI install type:
        // Set to "local" if accessing the local MBAPI (Default)
        // Set to "remote" if accessing a remote MBAPI
$CONF["installType"] = "local";

        // If "installType" = "remote", define the FULL MBAPI URL
        // If "installType" = "local", simply ignore (Default)
$CONF["remoteMBAPIURL"] = "http://ENTER_THE_URL_TO/lib-mbapi/remote.php";

	/**
	 * example of load distributing remote MBAPI url (REQUIRES ADVANCED MBAPI POOLING AND CLUSTERING)
* $CONF["remoteMBAPIURL"] = array("http://ENTER_THE_URL_TO_1/lib-mbapi/remote.php",
*				"http://ENTER_THE_URL_TO_2/lib-mbapi/remote.php",
*				"http://ENTER_THE_URL_TO_3/lib-mbapi/remote.php",
*				"http://ENTER_THE_URL_TO_4/lib-mbapi/remote.php",
*				);
	*/

        // If "installType" = "remote", define the MBAPI remote access hash (at the Admin level)
        // If "installType" = "local", simply ignore (Default)
$CONF["remoteAccessHash"] = "";

        // Define the MBAPI connection method to GET & POST or POST ONLY:
        // Set to "1" to allow external MBAPI calls using http GET & POST calls
        // Set to "0" to allow external MBAPI calls using http POST calls ONLY (Default)
$CONF["mbapi"]["allowGet"] = 0;

        // Define the IP addresses allowed to access this MBAPI install:
        // To allow MBAPI calls, you must add each IP address that you would like
        // to allow access to. Add one line per IP address. Examples:
        // $CONF["remoteIP"][] = "4.2.2.100"
        // $CONF["remoteIP"][] = "4.2.2.200"
$CONF["remoteIP"][] = NULL;

		// global cURL option overrides
$CONF["cURLoverrides"] = array(
		// verify valid certificate before initiating connection
		// by default, these are 0
	//"CURLOPT_SSL_VERIFYHOST" => 2,
	//"CURLOPT_SSL_VERIFYPEER" => 1,
	
		// one of the following:
	//"CURLOPT_CAINFO" => "/path/to/ca-bundle.crt"
	//"CURLOPT_CAPATH" => "/path/to/ca-bundle-folder/"
);

// --------------------------------------------------------------------------
// DATABASE SETTINGS
// --------------------------------------------------------------------------

        // Define the Database server type:
        // Set to one: "mysql" "postgres" "oci8po" "mssql"
$CONF["dbType"] = "mysql";

        // Define the Database host to connect to:
        // Set to: "localhost" or the IP address of the database host
$CONF["dbHost"] = "localhost";

        // Define the Database Name to connect to:
$CONF["dbName"] = "";

        // Define the Database Username to connect as:
$CONF["dbUser"] = "";

        // Define the Database Username's Password to connect with:
$CONF["dbPassword"] = "";

// --------------------------------------------------------------------------
// URL SETTINGS
// --------------------------------------------------------------------------

        // Define the HTTP URL to the directory containing your ModernBill applications and libraries.
        // ** Leave off the "http://"
        // ** No trailing slash!
        // Example: "www.yourhost.com/mb"
$CONF["standardURL"] = "";

        // Define the HTTPS URL to the directory containing your ModernBill applications and libraries.
        // ** Leave off the "https://"
        // ** No trailing slash!
        // Example: "secure.yourhost.com/mb"
$CONF["secureURL"] = "";

        // Define the protocol to use for web access to this Modernbill installation.
        // Set to "http" if you DO NOT HAVE an SSL certificate.
        // Set to "https" if you DO HAVE an SSL certificate.
        // ** Do NOT enter the "://" that you commonly see in URLs (i.e. "http://www...")
$CONF["secureURLProtocol"] = "http";

// --------------------------------------------------------------------------
// DIRECTORY SETTINGS
// --------------------------------------------------------------------------

        // Define the world writable directory in which your Modernbill
        // installation can store temporary files, with NO trailing slash.
        // Unix Example: "/tmp"
        // Windows Example: "C:\\Windows\\Temp"
$CONF["tempDirectory"] = "/tmp";

        // ** Oracle Only **
        // Define the absolute path to oracle.
        // Musth match your $ORACLE_HOME
$CONF["dbOracleHome"] = "/opt/oracle/product/10.1.0.3";

// --------------------------------------------------------------------------
// cURL SETTINGS (command line curl)
// --------------------------------------------------------------------------

        // Define the absolute path to your command line cURL if not using PHP's cURL
        // Unix Example: Use the environment path to curl "/usr/bin/env curl"
        // Windows Example: "C:\\path\\to\\curl\\bin\\curl.exe -k"
        // *nix Example: "/usr/bin/env curl" or "/usr/bin/curl -k"
$CONF["cliCurlPath"] = "/usr/bin/env curl";

// --------------------------------------------------------------------------
// QUEUE SETTINGS (advanced users only)
// --------------------------------------------------------------------------

        // If you server has a firewall where the remote IP is dispatched to a local IP,
        // then enter the local IP here. This will allow the events queue to call itself
        // locally instead of using the primary domain.
$CONF["localURL"] = "";

        // Define whether to let the system queue run till its dead or give it a limit.
        // Set to "1" and the system queue thread will be stopped as soon as it tries
        // to restart itsself. See "killOldQueueThreads" example usage below ...
$CONF["killOldQueueThreads"] = 0;

        // Define the time in seconds that a system queue thread can keep running.
        // This should be 45 seconds to a minute less then the time that cron waits to
        // hit the system.
        // If cron hits every 5 minutes, this should be 4 minutes, or 240 seconds.
        // If cron hits every minute, this needs to be like 15 seconds.
        // If cron hits every hour, this needs to be 59 minutes, or 59*60 seconds
$CONF["killOldQueueThreadsLimit"] = 240;

        // Example usage for "killOldQueueThreads" cont'd ...
        // If its originating thread is older then the limit below
        // Reason: If there are 100 things in the system queue to run that all
        // are supposed to run right now, we dont want the system queue to start
        // a new thread running them every 5 minutes if the cron runs the system
        // queue that often.
        //
        // An ascii art illistration would look as follows:
        //
        // Timeline is in minutes:
        //
        // IF "killOldQueueThreads" = 0:
        //
        //           0     5     10    15    20    25    30    35    40    45    50
        //           |-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|
        // thread 1: .............................................................
        // thread 2:       .......................................................
        // thread 3:             .................................................
        // thread 4:                   ...........................................   once we start running
        // thread 5:                         .....................................   this many threads at once
        // thread 6:                               ...............................   it will get cpu intense
        // thread 7:                                     .........................   and be taxing on the server
        // thread 8:                                           ...................
        // thread 9:                                                 .............
        // thread 10:                                                      .......
        //
        // IF "killOldQueueThreads" = 1:
        //
        //           0     5     10    15    20    25    30    35    40    45    50
        //           |-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|
        // thread 1: ......
        // thread 2:       ......
        // thread 3:             ......
        // thread 4:                   ......
        // thread 5:                         ......
        // thread 6:                               ......
        // thread 7:                                     ......
        // thread 8:                                           ......
        // thread 9:                                                 ......
        // thread 10:                                                      .......


// --------------------------------------------------------------------------
// ADDITIONAL SETTINGS - DO NOT CHANGE (advanced users only)
// --------------------------------------------------------------------------

if (!defined("MB_LIBPATH")){
	define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../.."));
	require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
}
require mb_path("/lib-modernbill/include/config/internal/ColumnMap.php");
require mb_path("/lib-modernbill/include/config/internal/QueryMasterMap.php");
if (substr($CONF["standardURL"], -1)=="/") {
	$CONF["standardURL"] = substr($CONF["standardURL"], 0, -1);
}
if (substr($CONF["secureURL"], -1)=="/") {
	$CONF["secureURL"] = substr($CONF["secureURL"], 0, -1);
}
if ($CONF["secureURLProtocol"]=="http"){
	$CONF["relativeWebRoot"] = substr($CONF["standardURL"], strpos($CONF["standardURL"], $_SERVER["HTTP_HOST"])+strlen($_SERVER["HTTP_HOST"]));
} else {
	$CONF["relativeWebRoot"] = substr($CONF["secureURL"], strpos($CONF["secureURL"], $_SERVER["HTTP_HOST"])+strlen($_SERVER["HTTP_HOST"]));
}

//$CONF["remoteMBAPIURL"] = array_rand((array)$CONF["remoteMBAPIURL"]);

// $Id: config.example.php,v 1.25 2006/07/15 00:04:40 kbailey Exp $
// +------------------------------------------------------------------------------+
// | MBAPI [TM] .:. Client Billing Engine                                         |
// +------------------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                                  |
// +------------------------------------------------------------------------------+
// | This source file is subject to the ModernGigabyte End User License Agreement |
// | (EULA), that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at http://www.mbapi.com/eula.php     |
// |                                                                              |
// | If you did not receive a copy of the MBAPI license and are unable to obtain  |
// | it through the world-wide-web, please send a note to license@mbapi.com so we |
// | can email you a copy immediately.                                            |
// +------------------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>                       |
// | Support: http://www.modernsupport.com/                                       |
// +------------------------------------------------------------------------------+
// | ModernGigabyte, ModernBill, and MBAPI are trademarks of ModernGigabyte, LLC. |
// +------------------------------------------------------------------------------+
?>
