<?php
// $Id: admins.php,v 1.11 2006/06/14 22:19:18 bsmith Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['admins'] = array(
	"names" => array(
		"singular" => "admin",
		"plural" => "admins",
		"file" => "admins",
	),
	"request" => array(
		"command" => "GetAdmins",
		"subCommand" => "",
		"params" => array("getAdminGroupData" => 1),
	),
	"response" => array(
		"path" => array("admins", "admin"),
	),
	"insert" => array(
		"command" => "SetAdmins",
		"subCommand" => "insert",
		"params" => array(), //$allParamsRoot,
	),
	"update" => array(
		"command" => "SetAdmins",
		"subCommand" => "update",
		"params" => array(), //$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetAdmins",
		"subCommand" => "delete",
		"params" => new Params(new Param("adminID")),
	),
	"columns" => array(
		"adminID" => COLUMN_PRIMARY_KEY|COLUMN_RESTRICT_MODIFY,
		"adminFirstName" => COLUMN_TEXT,
		"adminLastName" => COLUMN_TEXT,
		"adminEmail" => COLUMN_STRING,
		"adminUsername" => COLUMN_PRIMARY_NAME,
		"adminPassword" => COLUMN_PASSWORD,
		"adminRemoteAccessHash" => COLUMN_SEARCHABLE_STRING,
		"adminActive" => COLUMN_BOOL,
		"themeID" => COLUMN_ID,
		"languageID" => COLUMN_ID,
		"countriesID" => COLUMN_ID,
	),
	"relations" => array(
		"adminGroups" => array("admin_group_rel", "adminGroupIDs", "adminGroupID"),
	),
	"display" => array(
		"showTemplate" => "admins/ShowAdmins",
		"showDetailsTemplate" => "admins/ShowAdminDetails",
		"addTemplate" => "admins/AddAdmin",
		"editTemplate" => "admins/EditAdmin",
		"options" => array("themes", "languages", "countries", "adminGroups"),
		"context" => array(
			"themeID" => "themes",
			"languageID" => "langauges",
			"countriesID" => "countries",
		),
		"system" => true,
	),
);

?>
