<?php
// $Id: billingAccounts.php,v 1.14 2006/07/18 19:33:37 bwoolley Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

function refBillingAccountColumnGenerator(&$row) {
	switch (getAPITypeName("billingAccount", $row["billingAccountType"])) {
		case "card":
			$row["billingAccountDisplayName"] = getTypeName("card", $row["billingCardType"]) . " " . $row["billingAccountNumLastFour"] . ": " . $row["billingCardNameOnCard"];
			break;
		case "echeck":
		case "bank":
			$row["billingAccountDisplayName"] = $row["billingBankName"] . ": " . $row["billingAccountNumLastFour"];
			break;
		case "manual":
			$row["billingAccountDisplayName"] = TRANS_GENERAL_MANUAL_PAYMENT_ACCOUNT;
			break;
		case "secondary":
			$row["billingAccountDisplayName"] = TRANS_SECONDARYGATEWAY;
			break;
	}
	return true;
}

$CONF['sources']['billingAccounts'] = array(
	"names" => array(
		"displaySingular" => TRANS_BILLING_ACCOUNT,
		"displayPlural" => TRANS_BILLING_ACCOUNTS,
		"singular" => "billingAccount",
		"plural" => "billingAccounts",
		"file" => "clients",
	),
	"request" => array(
		'command' => "GetBillingAccounts",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("billingAccounts", "billingAccount"),
	),
	"insert" => array(
		'command' => "SetBillingAccounts",
		'subCommand' => "insert",
		'params' => array(),
	),
	"update" => array(
		'command' => "SetBillingAccounts",
		'subCommand' => "update",
		'params' => array(),
	),
	"delete" => array(
		'command' => "SetBillingAccounts",
		'subCommand' => "delete",
		'params' => array(),
	),
	"table" => "client_billing_accounts",
	"columns" => array(
		"billingAccountDisplayName" => COLUMN_PRIMARY_NAME,
		"billingAccountID" => COLUMN_PRIMARY_KEY,
		"priorBillingAccountID" => COLUMN_PRIOR_PRIMARY_KEY,
		"billingAccountHistorical" => COLUMN_HISTORICAL,
		"clientContactID" => COLUMN_ID,
		"billingCardNameOnCard" => COLUMN_TEXT,
		"billingCardType" => COLUMN_TYPE,
		"billingCardNum" => COLUMN_TEXT|COLUMN_ENCRYPT,
		"billingCardExpYear" => COLUMN_INT,
		"billingCardExpMonth" => COLUMN_INT,
		"billingCardIssueNum" => COLUMN_TEXT,
		"billingCardStartDate" => COLUMN_TEXT,
		
		"protxSecurityKey" => COLUMN_TEXT,
		"protxTransactionCode" => COLUMN_TEXT,
		"protxTransactionID" => COLUMN_TEXT,
		"protxAuthorizationCode" => COLUMN_TEXT,
		
		"velocitypayCrossReference" => COLUMN_TEXT,
		"velocitypayAuthAmount" => COLUMN_AMOUNT,
		
		"billingBankType" => COLUMN_TYPE,
		"billingBankName" => COLUMN_TEXT,
		"billingBankAbaCode" => COLUMN_TEXT,
		"billingBankAccountNum" => COLUMN_TEXT|COLUMN_ENCRYPT,
		"billingBankLicenseNum" => COLUMN_TEXT,
		"billingBankLicenseState" => COLUMN_TEXT,
		"billingBankDob" => COLUMN_TEXT,
		"billingBankState" => COLUMN_TEXT,
		
		"billingAccountNumLastFour" => COLUMN_TEXT,
		"billingAccountType" => COLUMN_TYPE,
		"billingAccountStatus" => COLUMN_STATUS,
		"secGatewayConfigGroupID" => COLUMN_ID,
	),
	"refColumnGenerator" => "refBillingAccountColumnGenerator",
	"types" => array(
		"billingCardType" => "card",
		"billingBankType" => "bankAccount",
		"billingAccountType" => "billingAccount",
	),
	"statuses" => array(
		"billingAccountStatus" => "billingAccount",
	),
	"display" => array(
		"context" => array(
			"clientContactID" => "clientContacts",
		),
	),
);

?>
