<?php
// $Id: cycles.php,v 1.6 2006/06/27 03:46:35 bwoolley Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['cycles'] = array(
	"names" => array(
		"singular" => "cycle",
		"plural" => "cycles",
		"file" => "products",
	),
	"request" => array(
		'command' => "GetCycles",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("cycles", "cycle"),
	),
	"insert" => array(
		"command" => "SetCycles",
		"subCommand" => "insert",
		"params" => array(), //$allParamsRoot,
	),
	"update" => array(
		"command" => "SetCycles",
		"subCommand" => "update",
		"params" => array(), //$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetCycles",
		"subCommand" => "delete",
		"params" => array(), //new Params(new Param("cycleID")),
	),
	"table" => "cycles",
	"columns" => array(
		"cycleID" => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		"cycleDisplayName" => COLUMN_PRIMARY_NAME|COLUMN_TRANSLATION_MESSAGE|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"cycleNumSeconds" => COLUMN_SEARCHABLE_INTEGER|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"cycleNumMinutes" => COLUMN_SEARCHABLE_INTEGER|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"cycleNumHours" => COLUMN_SEARCHABLE_INTEGER|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"cycleNumDays" => COLUMN_SEARCHABLE_INTEGER|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"cycleNumMonths" => COLUMN_SEARCHABLE_INTEGER|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"cycleNumYears" => COLUMN_SEARCHABLE_INTEGER|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		"cycleID" => "TRANS_ID",
		"cycleDisplayName" => "TRANS_NAME",
		"cycleNumSeconds" => "TRANS_SECONDS",
		"cycleNumMinutes" => "TRANS_MINUTES",
		"cycleNumHours" => "TRANS_HOURS",
		"cycleNumDays" => "TRANS_DAYS",
		"cycleNumMonths" => "TRANS_MONTHS",
		"cycleNumYears" => "TRANS_YEARS",
	),
	"relations" => array(
		"cycleGroups" => array("cycle_group_rel", "cycleGroupIDs", "cycleGroupID"),
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_PRODUCTS",
		"childName" => "TRANS_MANAGE_PRODUCTS",
		"sideNavMajor" => "products",
		"sideNavMinor" => "cycles",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_CYCLE",
			"show" => "TRANS_SHOW_CYCLES",
			"add" => "TRANS_ADD_CYCLE",
			//"showdetails" => "TRANS_CYCLE_DETAILS",
			"remove" => "TRANS_REMOVE_CYCLE",
		)
	),
	"display" => array(
		'showTemplate' => "1",
		//'showDetailsTemplate' => "1",
		'removeTemplate' => "1",
		'editTemplate' => "1",
		'addTemplate' => "1",
		"suppressActions" => array("showdetails"),
	),
);

?>
