<?php
// $Id: packageAddonAttributes.php,v 1.2 2006/08/02 05:51:02 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['packageAddonAttributes'] = array(
	"names" => array(
		"singular" => "packageAddonAttribute",
		"plural" => "packageAddonAttributes",
		"file" => "packages",
	),
	"request" => array(
		'command' => "GetPackageAddonAttributes",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("packageAddonAttributes", "packageAddonAttribute"),
	),
	"insert" => array(
		"command" => "SetPackageAddonAttributes",
		"subCommand" => "insert",
		"params" => array(), //$allParamsRoot,
	),
	"update" => array(
		"command" => "SetPackageAddonAttributes",
		"subCommand" => "update",
		"params" => array(), //$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetPackageAddonAttributes",
		"subCommand" => "delete",
		"params" => array(), //new Params(new Param("clientAttributeID")),
	),
	"table" => "package_addon_attributes",
	"columns" => array(
		"packageAddonAttributeID" => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		"packageAddonID" => COLUMN_ID|COLUMN_EDITABLE|COLUMN_HAS_FOREIGN_NAME,
		"serverGroupID" => COLUMN_ID|COLUMN_LISTABLE|COLUMN_EDITABLE,
		"configGroupID" => COLUMN_ID|COLUMN_LISTABLE,
		"packageAttributeName" => COLUMN_PRIMARY_NAME|COLUMN_LISTABLE|COLUMN_EDITABLE,
		"packageAttributeValue" => COLUMN_SEARCHABLE_STRING|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"packageAttributeDateCreated" => COLUMN_IS_DATE|COLUMN_LISTABLE|COLUMN_EDITABLE,
	),
	"columnLabels" => array(
		"packageAddonAttributeID" => "TRANS_ADDON_ATTRIBUTE_ID",
		"packageAddonID" => "TRANS_PACKAGE_ADDON",
		"serverGroupID" => "TRANS_SERVER_GROUP",
		"configGroupID" => "TRANS_SERVER",
		"packageAttributeName" => "TRANS_ATTRIBUTE_NAME",
		"packageAttributeValue" => "TRANS_ATTRIBUTE_VALUE",
		"packageAttributeDateCreated" => "TRANS_DATE_CREATED",
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_PACKAGES",
		"childName" => "TRANS_MANAGE_PACKAGES",
		"sideNavMajor" => "clients",
		"sideNavMinor" => "packages",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_ADDON_ATTRIBUTE",
			"show" => "TRANS_SHOW_ADDON_ATTRIBUTES",
			"add" => "TRANS_ADD_ADDON_ATTRIBUTE",
			"showdetails" => "TRANS_ADDON_ATTRIBUTE_DETAILS",
			"remove" => "TRANS_REMOVE_ADDON_ATTRIBUTE",
		)
	),
	"types" => array(
	),
	"statuses" => array(
	),
	"foreignNames" => array(
		'packageAddonID' => array(
			"command" => "GetPackageAddons",
			"nameParamName" => "packageAddonDisplayName",
			"idParamName" => "packageAddonID",
			"defaultParams" => array(
			),
		),
	),
	"display" => array(
		"options" => array("clients", "orderForms"),
		"context" => array(
			"serverGroupID" => "serverGroups",
			//"configGroupID" => "configGroups",
		),
		'showTemplate' => "1",
		'removeTemplate' => "1",
		'editTemplate' => "1",
		'addTemplate' => "1",
		"suppressActions" => array("showdetails", "edit", "remove"),
	),
);
