<?php
// $Id: productRelations.php,v 1.2 2006/06/22 23:14:51 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['productRelations'] = array(
	"names" => array(
		"singular" => "productRelation",
		"plural" => "productRelations",
		"file" => "products",
	),
	"request" => array(
		'command' => "GetProductRelations",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("productRelations", "productRelation"),
	),
	"insert" => array(
		"command" => "SetProductRelations",
		"subCommand" => "insert",
		"params" => array(),//$allParamsRoot,
	),
	"update" => array(
		"command" => "SetProductRelations",
		"subCommand" => "update",
		"params" => array(),//$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetProductRelations",
		"subCommand" => "delete",
		"params" => array(), 
	),
	"table" => "product_relations",
	"columns" => array(
		"productRelationID" => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		"subjectProductID" => COLUMN_INT|COLUMN_HAS_FOREIGN_NAME|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"relatedProductID" => COLUMN_INT|COLUMN_HAS_FOREIGN_NAME|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"productRelationType" => COLUMN_TYPE|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		"productRelationID" => "TRANS_PRODUCT_RELATION_ID",
		"subjectProductID" => "TRANS_SUBJECT_PRODUCT",
		"relatedProductID" => "TRANS_RELATED_PRODUCT",
		"productRelationType" => "TRANS_RELATION_TYPE",
	),
	"foreignNames" => array(
		'subjectProductID' => array(
			"command" => "GetProducts",
			"nameParamName" => "productName",
			"idParamName" => "productID",
			"defaultParams" => array(
				"getNonAddons" => 1
			),
		),
		'relatedProductID' => array(
			"command" => "GetProducts",
			"nameParamName" => "productName",
			"idParamName" => "productID",
			"defaultParams" => array(
				"getNonAddons" => 1
			),
		),
	),
	"types" => array(
		"productRelationType" => "productrelations",
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_PRODUCTS",
		"childName" => "TRANS_MANAGE_PRODUCTS",
		"sideNavMajor" => "products",
		"sideNavMinor" => "productsrelations",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_PRODUCT_RELATIONS",
			"show" => "TRANS_SHOW_PRODUCT_RELATIONS",
			"add" => "TRANS_ADD_PRODUCT_RELATION",
			"showdetails" => "TRANS_RELATION_DETAILS",
			"remove" => "TRANS_REMOVE_PRODUCT_RELATION",
		)
	),
	"display" => array(
		'showTemplate' => "1",
		'showDetailsTemplate' => "1",
		'removeTemplate' => "1",
		'editTemplate' => "1",
		'addTemplate' => "1",
		"revContext" => array(
			"migrationMappings" => "migrationMappingID",
			"migrationObjs" => "migrationObjID",
		),
	),
);
