<?php
// $Id: products.php,v 1.13 2006/07/05 17:49:53 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['products'] = array(
	"names" => array(
		"singular" => "product",
		"plural" => "products",
		"file" => "products",
	),
	"request" => array(
		'command' => "GetProducts",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("products", "product"),
	),
	"insert" => array(
		"command" => "SetProducts",
		"subCommand" => "insert",
		"params" => $allParamsRoot,
	),
	"update" => array(
		"command" => "SetProducts",
		"subCommand" => "update",
		"params" => $allParamsRoot,
	),
	"delete" => array(
		"command" => "SetProducts",
		"subCommand" => "delete",
		"params" => new Params(new Param("productID")),
	),
	"table" => "products",
	"columns" => array(
		"productID" => COLUMN_PRIMARY_KEY|COLUMN_RESTRICT_EDIT|COLUMN_RESTRICT_REMOVE,
		"productType" => COLUMN_TYPE|COLUMN_RESTRICT_MODIFY,
		"productIsLockable" => COLUMN_BOOL|COLUMN_RESTRICT_MODIFY,
		"productIsAddon" => COLUMN_INT,
		"productAddonGroupID" => COLUMN_ID|COLUMN_RESTRICT_MODIFY,
		"productName" => COLUMN_PRIMARY_NAME|COLUMN_RESTRICT_MODIFY,
		"productComments" => COLUMN_SEARCHABLE_STRING|COLUMN_RESTRICT_MODIFY,
		"productStopNumCycles" => COLUMN_NULL|COLUMN_RESTRICT_MODIFY,
		"productActive" => COLUMN_BOOL|COLUMN_RESTRICT_MODIFY,
		"productProratable" => COLUMN_BOOL|COLUMN_RESTRICT_MODIFY,
		"productDateCreated" => COLUMN_DATE|COLUMN_RESTRICT_MODIFY,
		"productDomainRequired" => COLUMN_STATUS|COLUMN_RESTRICT_MODIFY,
		"productAddonRequired" => COLUMN_STATUS|COLUMN_RESTRICT_MODIFY,
		"productIntroCycleID" => COLUMN_ID|COLUMN_RESTRICT_MODIFY,
		"productIntroNumCycles" => COLUMN_INT|COLUMN_RESTRICT_MODIFY,
		"emailTplGroupID" => COLUMN_ID|COLUMN_RESTRICT_MODIFY,
		"productCancellationType" => COLUMN_TYPE|COLUMN_RESTRICT_MODIFY,
	),
	"types" => array(
		"productType" => "products",
		"productCancellationType" => "cancellation",
	),
	"statuses" => array(
		"productDomainRequired" => "productdependencyrules",
		"productAddonRequired" => "productdependencyrules",
	),
	"display" => array(
		'showTemplate' => "products/ShowProducts",
		'showParams' => array(
			"getNonAddons" => 1
		),
		'showDetailsTemplate' => "products/ShowProductDetails",
		"context" => array(
			//"productAddonGroupID" => "productAddonGroups",
			"productIntroCycleID" => "cycles",
			//"emailTplGroupID" => "emailTemplateGroups",
		),
	),
);

?>
