<?php
// $Id: statuses.php,v 1.19 2006/06/19 17:40:36 kbailey Exp $
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2004 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";

/**
 * This file maintains the status constants that are used to describe various objects. This file also
 * contains functions to manage those constants. Note that the array keys of these constants must NEVER
 * change; as the system will break if those array keys change.
 *
 * @author  Vic Fryzel
 * @author  Ben Woolley
 */

$CONF["statuses"] = array();
$CONF["APIstatuses"] = array();

$CONF["statuses"]["todo"] = array();
$CONF["statuses"]["todo"][0] = TRANS_OPEN;
$CONF["statuses"]["todo"][1] = TRANS_CLOSED;

$CONF["APIstatuses"]["todo"] = array();
$CONF["APIstatuses"]["todo"][0] = "none";
$CONF["APIstatuses"]["todo"][1] = "closed";

$CONF["statuses"]["faqs"] = array();
$CONF["statuses"]["faqs"][0] = TRANS_USER;
$CONF["statuses"]["faqs"][1] = TRANS_ADMIN;

$CONF["APIstatuses"]["faqs"] = array();
$CONF["APIstatuses"]["faqs"][0] = 0;
$CONF["APIstatuses"]["faqs"][1] = 1;

$CONF["statuses"]["todopriorities"] = array();
$CONF["statuses"]["todopriorities"][0] = TRANS_TOP_PRIORITY;
$CONF["statuses"]["todopriorities"][1] = TRANS_SECOND_PRIORITY;
$CONF["statuses"]["todopriorities"][2] = TRANS_NORMAL_PRIORITY;
$CONF["statuses"]["todopriorities"][3] = TRANS_LOWER_PRIORITY;
$CONF["statuses"]["todopriorities"][4] = TRANS_LEAST_PRIORITY;

$CONF["APIstatuses"]["todopriorities"] = array();
$CONF["APIstatuses"]["todopriorities"][0] = "top";
$CONF["APIstatuses"]["todopriorities"][1] = "second";
$CONF["APIstatuses"]["todopriorities"][2] = "normal";
$CONF["APIstatuses"]["todopriorities"][3] = "lower";
$CONF["APIstatuses"]["todopriorities"][4] = "least";

$CONF["statuses"]["client"] = array();
$CONF["statuses"]["client"][0] = TRANS_ACTIVE;
$CONF["statuses"]["client"][1] = TRANS_PENDING;
$CONF["statuses"]["client"][2] = TRANS_CANCELED;
$CONF["statuses"]["client"][3] = TRANS_FRAUDULENT;
$CONF["statuses"]["client"][4] = TRANS_SUSPENDED;

$CONF["APIstatuses"]["client"] = array();
$CONF["APIstatuses"]["client"][0] = "none";
$CONF["APIstatuses"]["client"][1] = "pending";
$CONF["APIstatuses"]["client"][2] = "canceled";
$CONF["APIstatuses"]["client"][3] = "fraudulent";
$CONF["APIstatuses"]["client"][4] = "suspended";

$CONF["statuses"]["billingAccount"] = array();
$CONF["statuses"]["billingAccount"][0] = TRANS_ACTIVE;
$CONF["statuses"]["billingAccount"][1] = TRANS_DELETED;

$CONF["APIstatuses"]["billingAccount"] = array();
$CONF["APIstatuses"]["billingAccount"][0] = "active";
$CONF["APIstatuses"]["billingAccount"][1] = "deleted";

$CONF["statuses"]["package"] = array();
$CONF["statuses"]["package"][0] = TRANS_ACTIVE;
$CONF["statuses"]["package"][1] = TRANS_PENDING;
$CONF["statuses"]["package"][2] = TRANS_CANCELED;
$CONF["statuses"]["package"][3] = TRANS_FRAUDULENT;
$CONF["statuses"]["package"][4] = TRANS_COLLECTIONS;
$CONF["statuses"]["package"][5] = TRANS_WORKINPROGRESS;
$CONF["statuses"]["package"][6] = TRANS_SUSPENDED;
$CONF["statuses"]["package"][7] = TRANS_FAILED;
$CONF["statuses"]["package"][8] = TRANS_PENDINGRENEWAL;
$CONF["statuses"]["package"][9] = TRANS_EXPIRED;
$CONF["statuses"]["package"][10] = TRANS_STOPPED;

$CONF["APIstatuses"]["package"] = array();
$CONF["APIstatuses"]["package"][0] = "none";
$CONF["APIstatuses"]["package"][1] = "pending";
$CONF["APIstatuses"]["package"][2] = "canceled";
$CONF["APIstatuses"]["package"][3] = "fraudulent";
$CONF["APIstatuses"]["package"][4] = "collections";
$CONF["APIstatuses"]["package"][5] = "work_in_progress";
$CONF["APIstatuses"]["package"][6] = "suspended";
$CONF["APIstatuses"]["package"][7] = "failed";
$CONF["APIstatuses"]["package"][8] = "pending_renewal";
$CONF["APIstatuses"]["package"][9] = "expired";
$CONF["APIstatuses"]["package"][10] = "stopped";

$CONF["statuses"]["domain"] = array();
$CONF["statuses"]["domain"][0] = TRANS_ACTIVE;
$CONF["statuses"]["domain"][1] = TRANS_PENDING;
$CONF["statuses"]["domain"][2] = TRANS_PENDINGRENEWAL;
$CONF["statuses"]["domain"][3] = TRANS_EXPIRED;

$CONF["APIstatuses"]["domain"] = array();
$CONF["APIstatuses"]["domain"][0] = "none";
$CONF["APIstatuses"]["domain"][1] = "pending";
$CONF["APIstatuses"]["domain"][2] = "pending_renewal";
$CONF["APIstatuses"]["domain"][3] = "expired";

$CONF["statuses"]["cert"] = array();
$CONF["statuses"]["cert"][0] = TRANS_ACTIVE;
$CONF["statuses"]["cert"][1] = TRANS_STARTED;
$CONF["statuses"]["cert"][2] = TRANS_SUBMITTED;
$CONF["statuses"]["cert"][3] = TRANS_COMPLETED;
$CONF["statuses"]["cert"][4] = TRANS_CANCELED;

$CONF["APIstatuses"]["cert"] = array();
$CONF["APIstatuses"]["cert"][0] = "none";
$CONF["APIstatuses"]["cert"][1] = "started";
$CONF["APIstatuses"]["cert"][2] = "submitted";
$CONF["APIstatuses"]["cert"][3] = "completed";
$CONF["APIstatuses"]["cert"][4] = "canceled";

$CONF["statuses"]["invoice"] = array();
$CONF["statuses"]["invoice"][0] = TRANS_DUE; // invoice that is due (should suspend)
$CONF["statuses"]["invoice"][1] = TRANS_CLOSED; // invoice that is paid
$CONF["statuses"]["invoice"][2] = TRANS_VOID; // invoice that is void
$CONF["statuses"]["invoice"][3] = TRANS_BADDEBT; // invoice that is baddebt (should suspend)
$CONF["statuses"]["invoice"][4] = TRANS_REFUNDED; // invoice that is refunded
$CONF["statuses"]["invoice"][5] = TRANS_HAS_DECLINED_CHARGES; // invoice that is refunded  (should suspend)
$CONF["statuses"]["invoice"][6] = TRANS_HAS_ERRORED_CHARGES; // invoice that is refunded

$CONF["APIstatuses"]["invoice"] = array();
$CONF["APIstatuses"]["invoice"][0] = "due"; // invoice that is due (should suspend)
$CONF["APIstatuses"]["invoice"][1] = "closed"; // invoice that is paid
$CONF["APIstatuses"]["invoice"][2] = "void"; // invoice that is void
$CONF["APIstatuses"]["invoice"][3] = "bad_debt"; // invoice that is baddebt (should suspend)
$CONF["APIstatuses"]["invoice"][4] = "refunded"; // invoice that is refunded
$CONF["APIstatuses"]["invoice"][5] = "declined"; // invoice that is refunded  (should suspend)
$CONF["APIstatuses"]["invoice"][6] = "errored"; // invoice that is refunded

$CONF["statuses"]["transactions"] = array();
$CONF["statuses"]["transactions"][0]   = TRANS_NONE; // no status
$CONF["statuses"]["transactions"][1]   = TRANS_SUCCESSFUL_CHARGE; // successful charge of some sort
$CONF["statuses"]["transactions"][2]   = TRANS_DECLINED_CHARGE; // declined charge of some sort
$CONF["statuses"]["transactions"][3]   = TRANS_ERRORED_CHARGE; // errored charge of some sort
$CONF["statuses"]["transactions"][4]   = TRANS_ERRORED_CHARGE; // errored charge of some sort
$CONF["statuses"]["transactions"][5]   = TRANS_ERRORED_CHARGE; // errored charge of some sort
$CONF["statuses"]["transactions"][40]  = TRANS_AUTHORIZED_CHARGE; // A pre-authorized charge that hasn't been captured yet
$CONF["statuses"]["transactions"][41]  = TRANS_CAPTURED_CHARGE; // A pre-authorized charge that has been captured
$CONF["statuses"]["transactions"][42]  = TRANS_AUTH_CANCELLED_CHARGE; // A pre-authorized charge that has been captured
$CONF["statuses"]["transactions"][100] = TRANS_AUTOFAILED_CHARGE; // declined charge of some sort
$CONF["statuses"]["transactions"][150] = TRANS_CHARGE_REFUNDED; // a refunded charge
$CONF["statuses"]["transactions"][200] = TRANS_MANUALLY_APPLIED; // manually applied payment
$CONF["statuses"]["transactions"][201] = TRANS_PAID_WITH_CREDIT; // payment made with existing credit

$CONF["APIstatuses"]["transactions"] = array();
$CONF["APIstatuses"]["transactions"][0]   = "none"; // no status
$CONF["APIstatuses"]["transactions"][1]   = "successful"; // successful charge of some sort
$CONF["APIstatuses"]["transactions"][2]   = "declined"; // declined charge of some sort
$CONF["APIstatuses"]["transactions"][3]   = "errored"; // errored charge of some sort
$CONF["APIstatuses"]["transactions"][4]   = "errored"; // errored charge of some sort
$CONF["APIstatuses"]["transactions"][5]   = "errored"; // errored charge of some sort
$CONF["APIstatuses"]["transactions"][40]  = "authorized"; // A pre-authorized charge that hasn't been captured yet
$CONF["APIstatuses"]["transactions"][41]  = "captured"; // A pre-authorized charge that has been captured
$CONF["APIstatuses"]["transactions"][42]  = "authcancelled"; // A pre-authorized charge that has been captured
$CONF["APIstatuses"]["transactions"][100] = "autofailed"; // declined charge of some sort
$CONF["APIstatuses"]["transactions"][150] = "refunded"; // a refunded charge
$CONF["APIstatuses"]["transactions"][200] = "manually_applied"; // manually applied payment
$CONF["APIstatuses"]["transactions"][201] = "paid_with_credit"; // payment made with existing credit

$CONF["statuses"]["helpdesk"] = array();
$CONF["statuses"]["helpdesk"][0] = TRANS_CLOSED; // The ticket is closed
$CONF["statuses"]["helpdesk"][1] = TRANS_PENDING; // The ticket is pending an admin response or close
$CONF["statuses"]["helpdesk"][2] = TRANS_OPEN; // The ticket is open

$CONF["APIstatuses"]["helpdesk"] = array();
$CONF["APIstatuses"]["helpdesk"][0] = "closed"; // The ticket is closed
$CONF["APIstatuses"]["helpdesk"][1] = "pending"; // The ticket is pending an admin response or close
$CONF["APIstatuses"]["helpdesk"][2] = "open"; // The ticket is open

$CONF["statuses"]["queue"] = array();
$CONF["statuses"]["queue"][0] = TRANS_NEW;
$CONF["statuses"]["queue"][1] = TRANS_ERROR;
$CONF["statuses"]["queue"][2] = TRANS_COMPLETED;
$CONF["statuses"]["queue"][3] = TRANS_QUEUE_RULE_VIOLATION;

$CONF["APIstatuses"]["queue"] = array();
$CONF["APIstatuses"]["queue"][0] = "new";
$CONF["APIstatuses"]["queue"][1] = "error";
$CONF["APIstatuses"]["queue"][2] = "completed";
$CONF["APIstatuses"]["queue"][3] = "rule";

$CONF["statuses"]["productdependencyrules"] = array();
$CONF["statuses"]["productdependencyrules"][0] = TRANS_OPTIONAL;
$CONF["statuses"]["productdependencyrules"][1] = TRANS_REQUIRED;
$CONF["statuses"]["productdependencyrules"][2] = TRANS_SUPPRESSED;

$CONF["APIstatuses"]["productdependencyrules"] = array();
$CONF["APIstatuses"]["productdependencyrules"][0] = "can";
$CONF["APIstatuses"]["productdependencyrules"][1] = "must";
$CONF["APIstatuses"]["productdependencyrules"][2] = "cannot";

$CONF["statuses"]["subscription"] = array();
$CONF["statuses"]["subscription"][0] = TRANS_ACTIVE;
$CONF["statuses"]["subscription"][1] = TRANS_CANCELLED;
$CONF["statuses"]["subscription"][2] = TRANS_EXPIRED;
$CONF["statuses"]["subscription"][3] = TRANS_FAILED;
$CONF["statuses"]["subscription"][4] = TRANS_INACTIVE;

$CONF["APIstatuses"]["subscription"] = array();
$CONF["APIstatuses"]["subscription"][0] = "active";
$CONF["APIstatuses"]["subscription"][1] = "cancelled";
$CONF["APIstatuses"]["subscription"][2] = "expired";
$CONF["APIstatuses"]["subscription"][3] = "failed";
$CONF["APIstatuses"]["subscription"][4] = "inactive";

// Used by FraudCountryThresholds
$CONF["statuses"]["fraudLevelActions"] = array();
$CONF["statuses"]["fraudLevelActions"][0] = TRANS_ACTIVE_WITH_AUTH_CAPTURE;
$CONF["statuses"]["fraudLevelActions"][1] = TRANS_ACTIVE_WITH_AUTH_ONLY;
$CONF["statuses"]["fraudLevelActions"][2] = TRANS_PENDING_WITH_AUTH_CAPTURE;
$CONF["statuses"]["fraudLevelActions"][3] = TRANS_PENDING_WITH_AUTH_ONLY;
#$CONF["statuses"]["fraudLevelActions"][4] = TRANS_CALL;
$CONF["statuses"]["fraudLevelActions"][5] = TRANS_SOFT_REJECT;
$CONF["statuses"]["fraudLevelActions"][6] = TRANS_HARD_REJECT;

// Used by FraudCountryThresholds
$CONF["APIstatuses"]["fraudLevelActions"] = array();
$CONF["APIstatuses"]["fraudLevelActions"][0] = "activeAuthCapture";
$CONF["APIstatuses"]["fraudLevelActions"][1] = "activeAuthOnly";
$CONF["APIstatuses"]["fraudLevelActions"][2] = "pendingAuthCapture";
$CONF["APIstatuses"]["fraudLevelActions"][3] = "pendingAuthOnly";
#$CONF["APIstatuses"]["fraudLevelActions"][4] = "call";
$CONF["APIstatuses"]["fraudLevelActions"][5] = "rejectSoft";
$CONF["APIstatuses"]["fraudLevelActions"][6] = "rejectHard";

$CONF["statuses"]["ppcCodes"] = array();
$CONF["statuses"]["ppcCodes"][0] = TRANS_RESERVED;
$CONF["statuses"]["ppcCodes"][1] = TRANS_ACCEPTED;
$CONF["statuses"]["ppcCodes"][2] = TRANS_DECLINED;
$CONF["statuses"]["ppcCodes"][3] = TRANS_ACTIVATED;
$CONF["statuses"]["ppcCodes"][4] = TRANS_NOT_NOW;
$CONF["statuses"]["ppcCodes"][5] = TRANS_NEVER_DISPLAY;
$CONF["statuses"]["ppcCodes"][6] = TRANS_SUPPRESS;

$CONF["APIstatuses"]["ppcCodes"] = array();
$CONF["APIstatuses"]["ppcCodes"][0] = "reserved";
$CONF["APIstatuses"]["ppcCodes"][1] = "accepted";
$CONF["APIstatuses"]["ppcCodes"][2] = "declined";
$CONF["APIstatuses"]["ppcCodes"][3] = "activated";
$CONF["APIstatuses"]["ppcCodes"][4] = "notnow";
$CONF["APIstatuses"]["ppcCodes"][5] = "never";
$CONF["APIstatuses"]["ppcCodes"][6] = "suppress";

/**
 * class for handling statuses
 */
class StatusOf {
	/**
	 * string  status
	 */
	var $status;
	
	/**
	 * string  interface
	 */
	var $interface;
	
	/**
	 * constructor
	 *
	 * @param  string  type
	 * @param  boolean  whether to use API names rather than display names
	 */
	function StatusOf($status, $api = false) {
		$this->status = $status;
		$this->interface = $api ? "APIstatuses" : "statuses";
	}
	
	/**
	 * id by name
	 *
	 * @param  string  name
	 * @return  int  id
	 */
	function id($name) {
		global $CONF;
		return isset($CONF[$this->interface][$this->status]) ? array_search($name, $CONF[$this->interface][$this->status]) : false;
	}
	
	/**
	 * name by id
	 *
	 * @param  int  id
	 * @return  string  name
	 */
	function name($id) {
		global $CONF;
		return isset($CONF[$this->interface][$this->status][$id]) ? $CONF[$this->interface][$this->status][$id] : false;
	}
	
	/**
	 * HTML options
	 *
	 * @return  array  of associated names by ID
	 */
	function options() {
		global $CONF;
		return  isset($CONF[$this->interface][$this->status]) ? $CONF[$this->interface][$this->status] : array();
	}
}

/**
 * get status ID from name
 *
 * @param  string  status
 * @param  string  name
 * @return  int  ID
 */
function getStatusID($status, $name) {
	$s =& new StatusOf($status);
	return $s->id($name);
}

/**
 * get status name from ID
 *
 * @param  string  status
 * @param  int  ID
 * @return  string  name
 */
function getStatusName($status, $id) {
	$s =& new StatusOf($status);
	return $s->name($id);
}

/**
 * get status options
 *
 * @param  string  status
 * @return  array  of associated names by ID
 */
function getStatuses($status) {
	$s =& new StatusOf($status);
	return $s->options();
}

/**
 * get API status ID from name
 *
 * @param  string  status
 * @param  string  name
 * @return  int  ID
 */
function getAPIStatusID($status, $name) {
	$s =& new StatusOf($status, true);
	return $s->id($name);
}

/**
 * get API status name from ID
 *
 * @param  string  status
 * @param  int  ID
 * @return  string  name
 */
function getAPIStatusName($status, $id) {
	$s =& new StatusOf($status, true);
	return $s->name($id);
}

/**
 * get API status options
 *
 * @param  string  status
 * @return  array  of associated names by ID
 */
function getAPIStatuses($status) {
	$s =& new StatusOf($status, true);
	return $s->options();
}

?>
