{* $Id: AddHelpdeskBucket.tpl,v 1.10 2006/07/26 21:30:43 bsmith Exp $
 * --------------------------------------------------------------
 * This template displays a form to add a helpdesk bucket. This form should POST to the
 * AddHelpdeskBucketResponse action with at least one adminID selected, at least one helpdeskDepartment
 * selected, and a hdBucketName provided.
 *
 * Smarty Variables:
 *	$helpdeskDepartments - An array of helpdesk departments, whose every element represents a helpdesk department
 *	                       in array form structured as follows:
 *	                         hdDepartmentID -- The ID of the helpdesk department.
 *	                         hdDepartmentName -- The name of the helpdesk department.
 *	                         hdDepartmentDescription -- The description of the helpdesk department.
 *	$admins - An array of admins of the system. Each element in this array represents an admin, and that array
 *	          is structured as follows:
 *	            adminID - The ID of the administrator.
 *	            adminFirstName - The first name of the administrator.
 *	            adminLastName - The last name of the administrator.
 *	            adminUsername - The username of the administrator.
 *	            adminEmail - The email of the administrator.
 *	            adminActive - 1 if the admin is active, or 0 if otherwise.
 *	            themeID - The theme ID of the administrator.
 *	            languageID - The language ID of the administrator.
 *	            countriesID - The country ID of the administrator.
 *}
{include file="$tplDirectory/header.tpl"}

{t c="TRANS_ADD_NEW_BUCKET" d="Add New Bucket:"}
{t c="TRANS_ADD_BUCKET" d="Add Bucket"}

<strong>{$smarty.const.TRANS_ADD_NEW_BUCKET}</strong><br /><br />
<form method="post" action="helpdesk.php">
<input type="hidden" name="action" value="{getActionID action="AddHelpdeskBucketResponse"}" />
<input type="hidden" name="sid" value="{$sid}" />
<table width="50%" valign="top" align="left">
	<tr valign="top">
		<th align="left">Name:</th>
		<td><input type="text" name="hdBucketName" value=""></td>
	</tr>
	<tr valign="top">
		<th align="left">Associated Departments:</th>
		<td>
			<select name="hdDepartmentIDs[]">
				{section name="i" loop="$helpdeskDepartments"}
				<option value="{$helpdeskDepartments[i].hdDepartmentID}">{$helpdeskDepartments[i].hdDepartmentName}</option>
				{/section}
			</select>
		</td>
	</tr>
	<tr valign="top">
		<th align="left">Associated Admins:</th>
		<td>
			<select multiple="multiple">
				{section name="i" loop="$admins"}
				<option value="{$admins[i].adminID}">{$admins[i].adminUsername} ({$admins[i].adminFirstName}
				{$admins[i].adminLastName})</option>
				{/section}
			</select>
		</td>
	</tr>
	<tr><td align="right" colspan="2"><input class="submit" type="submit" name="submit"
		value="{$smarty.const.TRANS_ADD_BUCKET}"></td></tr>
</table>
</form>

{include file="$tplDirectory/footer.tpl"}