{* $Id: AddHelpdeskResponseTemplate.tpl,v 1.11 2006/06/05 19:25:33 bsmith Exp $
 * --------------------------------------------------------------
 * This template displays a form to add a helpdesk response template. This form should POST to the
 * AddHelpdeskResponseTemplateResponse action with at least one helpdesk department selected, and
 * helpdesk response template name and body provided.
 *
 * Smarty Variables:
 *	$helpdeskDepartments - An array of helpdesk departments, whose every element represents a helpdesk department
 *	                       in array form structured as follows:
 *	                         hdDepartmentID -- The ID of the helpdesk department.
 *	                         hdDepartmentName -- The name of the helpdesk department.
 *	                         hdDepartmentDescription -- The description of the helpdesk department.
 *}

{t c="TRANS_MANAGE_HELPDESK" d="Manage Helpdesk"}
{t c="TRANS_ADD_HELPDESK_RESPONSE_TPL" d="Add Helpdesk Response Template"}
{t c="TRANS_RESPONSE_TPL" d="Response Template"}
{t c="TRANS_RESPONSE_TPL_NAME" d="Response Template Name"}
{t c="TRANS_RESPONSE_TPL_BODY" d="Response Template Body"}
{t c="TRANS_DEPARTMENTS" d="Departments"}
{t c="TRANS_ADD" d="Add"}
{t c="TRANS_CLEAR" d="Clear"}
{t c="TRANS_FIELDS" d="Fields"}
{t c="TRANS_FIELD_NAME" d="Field Name"}
{t c="TRANS_FIELD_DESCRIPTION" d="Field Description"}

{t c="TRANS_HDTICKETID_DESC" d="The ID of the helpdesk ticket being responded to."}
{t c="TRANS_HDTICKETKEY_DESC" d="The keyname of the helpdesk ticket being responded to."}
{t c="TRANS_HDTICKETSUBJECT_DESC" d="The subject of the helpdesk ticket being responded to."}
{t c="TRANS_HDTICKETBODY_DESC" d="The message body of the helpdesk ticket being responded to."}
{t c="TRANS_HDTICKETPRIORITY_DESC" d="The priority of the helpdesk ticket being responded to."}
{t c="TRANS_HDTICKETSTATUS_DESC" d="The status of the helpdesk ticket being responded to."}
{t c="TRANS_USERID_DESC" d="The ID of the owner of the helpdesk ticket being responded to."}
{t c="TRANS_USERFIRSTNAME_DESC" d="The first name of the owner of the helpdesk ticket being responded to."}
{t c="TRANS_USERLASTNAME_DESC" d="The last name of the owner of the helpdesk ticket being responded to."}
{t c="TRANS_USEREMAIL_DESC" d="The email address of the owner of the helpdesk ticket being responded to."}
{t c="TRANS_USERNAME_DESC" d="The username of the owner of the helpdesk ticket being responded to."}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_HELPDESK"
	childName="TRANS_ADD_HELPDESK_RESPONSE_TPL"
	sideNavMajor="helpdesk"
	sideNavMinor="helpdesk"}

<table width="770" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_FIELDS"}
</tr>
</thead>

<tbody>
<tr>
	<td>

		<table summary="{$smarty.const.TRANS_RESPONSE_TPL}" width="100%" class="list" cellspacing="0" cellpadding="0">
		<tr class="headerRow">
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_FIELD_NAME" headerClass="firstTD"}
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_FIELD_DESCRIPTION" headerClass="lastTD"}
		</tr>
		
		<tr class="{cycle name="responseTemplateFields" values="alt1,alt2"}">
			<th scope="row">{literal}{hdTicketID}{/literal}</th>
			<td>{$smarty.const.TRANS_HDTICKETID_DESC}</td>
		</tr>
		<tr class="{cycle name="responseTemplateFields" values="alt1,alt2"}">
			<th scope="row">{literal}{hdTicketKey}{/literal}</th>
			<td>{$smarty.const.TRANS_HDTICKETKEY_DESC}</td>
		</tr>
		<tr class="{cycle name="responseTemplateFields" values="alt1,alt2"}">
			<th scope="row">{literal}{hdTicketSubject}{/literal}</th>
			<td>{$smarty.const.TRANS_HDTICKETSUBJECT_DESC}</td>
		</tr>
		<tr class="{cycle name="responseTemplateFields" values="alt1,alt2"}">
			<th scope="row">{literal}{hdTicketBody}{/literal}</th>
			<td>{$smarty.const.TRANS_HDTICKETBODY_DESC}</td>
		</tr>
		<tr class="{cycle name="responseTemplateFields" values="alt1,alt2"}">
			<th scope="row">{literal}{hdTicketPriority}{/literal}</th>
			<td>{$smarty.const.TRANS_HDTICKETPRIORITY_DESC}</td>
		</tr>
		<tr class="{cycle name="responseTemplateFields" values="alt1,alt2"}">
			<th scope="row">{literal}{hdTicketStatus}{/literal}</th>
			<td>{$smarty.const.TRANS_HDTICKETSTATUS_DESC}</td>
		</tr>
		<tr class="{cycle name="responseTemplateFields" values="alt1,alt2"}">
			<th scope="row">{literal}{userID}{/literal}</th>
			<td>{$smarty.const.TRANS_USERID_DESC}</td>
		</tr>
		<tr class="{cycle name="responseTemplateFields" values="alt1,alt2"}">
			<th scope="row">{literal}{userFirstName}{/literal}</th>
			<td>{$smarty.const.TRANS_USERFIRSTNAME_DESC}</td>
		</tr>
		<tr class="{cycle name="responseTemplateFields" values="alt1,alt2"}">
			<th scope="row">{literal}{userLastName}{/literal}</th>
			<td>{$smarty.const.TRANS_USERLASTNAME_DESC}</td>
		</tr>
		<tr class="{cycle name="responseTemplateFields" values="alt1,alt2"}">
			<th scope="row">{literal}{userEmail}{/literal}</th>
			<td>{$smarty.const.TRANS_USEREMAIL_DESC}</td>
		</tr>
		<tr class="{cycle name="responseTemplateFields" values="alt1,alt2"}">
			<th scope="row">{literal}{username}{/literal}</th>
			<td>{$smarty.const.TRANS_USERNAME_DESC}</td>
		</tr>
		</table>
	</td>
</tr>
</table>

<table width="770" border="0" cellpadding="0" cellspacing="0" class="list" >
<thead>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_RESPONSE_TPL"}
</tr>
</thead>

<tr>
	<td>
		<form name="addResponseForm" method="POST" action="helpdesk.php">
		<input type="hidden" name="action" value="{getActionID action="AddHelpdeskResponseTemplateResponse"}" />
		<input type="hidden" name="sid" value="{$sid}" />
		
		<table summary="{$smarty.const.TRANS_RESPONSE_TPL}" width="100%" class="list" cellpadding="0" cellspacing="0">
		<tr class="{cycle name="responseTemplate" values="alt1,alt2"}">
			<th scope="row">{$smarty.const.TRANS_RESPONSE_TPL_NAME}</th>
			<td><input type="text" name="hdRespTplName" size="50" /></td>
		</tr>
		<tr class="{cycle name="responseTemplate" values="alt1,alt2"}">
			<th scope="row">{$smarty.const.TRANS_RESPONSE_TPL_BODY}</th>
			<td><textarea name="hdRespTplBody" rows="15" cols="75"></textarea></td>
		</tr>
		<tr class="{cycle name="responseTemplate" values="alt1,alt2"}">
			<th scope="row">{$smarty.const.TRANS_DEPARTMENTS}</th>
			<td>
				<select name="hdDepartmentIDs[]" multiple="multiple">
				{foreach from=$helpdeskDepartments item=dept}
					<option value="{$dept.hdDepartmentID}">{$dept.hdDepartmentName}</option>
				{/foreach}
				</select>
			</td>
		</tr>
		<tr align="center">
			<td colspan="2">
				<input class="submit" type="submit" name="submit_response" value="{$smarty.const.TRANS_ADD}" />
				<input class="reset" type="reset" name="clear_response" value="{$smarty.const.TRANS_CLEAR}" />
			</td>
		</tr>
		</form>
		</table>
	</td>
</tr>
</table>

{include file="$tplDirectory/footer.tpl"}