{* $Id: EditHelpdeskDepartment.tpl,v 1.12 2006/06/05 19:25:33 bsmith Exp $
 * --------------------------------------------------------------
 * This template displays a form to edit a helpdesk department that currently exists in the system. The
 * form is prepopulated with the current helpdesk departments information. This form should POST to the
 * EditHelpdeskDepartmentResponse action.
 *
 * Smarty Variables:
 *	$helpdeskDepartment - An array of helpdesk department information, which is structured as follows:
 *	                         hdDepartmentID -- The ID of the helpdesk department.
 *	                         hdDepartmentName -- The name of the helpdesk department.
 *	                         hdDepartmentDescription -- The description of the helpdesk department.
 *	                         adminIDs -- An array of admin IDs that're associated with this helpdesk
 *	                                     department. Each element of this array is an admin ID.
 *	$admins - An array of admins of the system. Each element in this array represents an admin, and that array
 *	          is structured as follows:
 *	            adminID - The ID of the administrator.
 *	            adminFirstName - The first name of the administrator.
 *	            adminLastName - The last name of the administrator.
 *	            adminUsername - The username of the administrator.
 *	            adminEmail - The email of the administrator.
 *	            adminActive - 1 if the admin is active, or 0 if otherwise.
 *	            themeID - The theme ID of the administrator.
 *	            languageID - The language ID of the administrator.
 *	            countriesID - The country ID of the administrator.
 *}
{t c="TRANS_EDIT_DEPARTMENT" d="Edit Department"}
{t c="TRANS_MANAGE_HELPDESK" d="Manage Helpdesk"}
{t c="TRANS_ASSOCIATED_ADMINS" d="Associated Admins"}

{include file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_HELPDESK"
	childName="TRANS_EDIT_DEPARTMENT"
	sideNavMajor="helpdesk"
	sideNavMinor="helpdesksetup"}

<strong>Edit Department:</strong><br /><br />
<form method="post" action="helpdesk.php">
<input type="hidden" name="action" value="{getActionID action="EditHelpdeskDepartmentResponse"}" />
<input type="hidden" name="sid" value="{$sid}" />
<input type="hidden" name="hdDepartmentID" value="{$helpdeskDepartment.hdDepartmentID}" />


<table width="50%" valign="top" align="left" class="list" border="0" cellpadding="0" cellspacing="0">
<thead>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_EDIT_DEPARTMENT" headerClass="firstTD"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="&nbsp;" headerClass="lastTD"}
</tr>
</thead>
<tr valign="top" class="{cycle values="alt1,alt2"}">
	<th align="left">{$smarty.const.TRANS_NAME}:</th>
	<td><input type="text" name="hdDepartmentName" value="{$helpdeskDepartment.hdDepartmentName}"></td>
</tr>
<tr valign="top" class="{cycle values="alt1,alt2"}">
	<th align="left">{$smarty.const.TRANS_DESCRIPTION}:</th>
	<td><textarea name="hdDepartmentDescription">{$helpdeskDepartment.hdDepartmentDescription}</textarea></td>
</tr>
<tr valign="top" class="{cycle values="alt1,alt2"}">
	<th align="left">{$smarty.const.TRANS_ASSOCIATED_ADMINS}:</th>
	<td>
		<select name="adminIDs[]" multiple="multiple" size="3">
			{foreach from=$admins item=admin}
				<option value="{$admin.adminID}" {strip}
					{if ($admin.adminID|array_search:$helpdeskDepartment.adminIDs) !== false}
						selected="selected"
					{/if}{/strip}>{$admin.adminUsername} ({$admin.adminFirstName} {$admin.adminLastName})</option>
			{/foreach}
		</select>
	</td>
</tr>
<tr class="{cycle values="alt1,alt2"}">
	<td align="right" colspan="2"><input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_EDIT_DEPARTMENT}"></td>
</tr>
</table>
</form>

{include file="$tplDirectory/footer.tpl"}