{* $Id: ShowHelpdesk.tpl,v 1.20 2006/06/26 21:12:50 bsmith Exp $
 * --------------------------------------------------------------
 * This template displays a list of helpdesk departments, all the buckets within those departments, all of the tickets
 * within those buckets, and all of the tickets within each department. Only departments and buckets that're somehow
 * related to the currently logged in admin are displayed.
 *
 * Smarty Variables:
 *	$helpdeskDepartments (An array of helpdesk departments, and all of the data beneath them)
 *   [$hdDepartmentID]
 *      ["hdDepartmentID"]
 *      ["hdDepartmentName"]
 *      ["hdDepartmentDescription"]
 *      ["numPendingTickets"]
 *      ["numOpenTickets"]
 *      ["buckets"][$bucketID]["hdBucketID"]
 *                            ["hdBucketName"]
 *                            ["numPendingTickets"]
 *                            ["numOpenTickets"]
 *                            ["tickets"]["hdTicketID"]
 *                                       ["..."]
 *                 ["..."]
 *      ["tickets"][$ticketID]["hdTicketID"]
 *                            ["..."]
 *                 ["..."]
 *   ["..."]
 *
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *  $sid					The current sessionID
 *
 * Author: Brian Smith
 *}
{t c="TRANS_DEPARTMENTS" d="Departments"}
{t c="TRANS_BUCKETS" d="Buckets"}
{t c="TRANS_TICKETS" d="Tickets"}
{t c="TRANS_DEPARTMENT_DATA" d="Department Data"}
{t c="TRANS_BUCKET_DATA" d="Bucket Data"}
{t c="TRANS_NO_TICKETS_IN_BUCKET" d="No open tickets were found in this bucket."}
{t c="TRANS_NO_OPEN_TICKETS_IN_DEPARTMENT" d="There are no open tickets in this department without a bucket."}
{t c="TRANS_NO_BUCKETS_IN_DEPARTMENT" d="There are no buckets under this department."}
{t c="TRANS_TICKETS_WITHOUT_BUCKETS" d="Tickets Without Buckets"}
{t c="TRANS_PENDING_RESPONSE" d="Pending Response"}
{t c="TRANS_OPEN" d="Open"}
{t c="TRANS_DEPARTMENT_NAME" d="Department Name"}
{t c="TRANS_TICKETS" d="Tickets"}
{t c="TRANS_MANAGE_HELPDESK" d="Manage Helpdesk"}
{t c="TRANS_NO_DEPARTMENTS_FOUND" d="No Departments Found"}
{t c="TRANS_TICKET_SUBJECT" d="Subject"}
{t c="TRANS_TICKET_USER" d="User"}
{t c="TRANS_ADMIN" d="Admin"}
{t c="TRANS_CLIENT" d="Client"}
{t c="TRANS_TICKET_BODY" d="Issue"}
{t c="TRANS_TICKET_STATUS" d="Status"}
{t c="TRANS_TICKET_DATE_MODIFIED" d="Date Modified"}
{t c="TRANS_VIEW" d="View"}
{t c="TRANS_RESPOND" d="Respond"}
{t c="TRANS_CLOSE" d="Close"}
{t c="TRANS_MOVE" d="Move"}

{t c="TRANS_ONHOLD" d="On Hold"}

{t c="TRANS_UNASSIGNED_TICKETS" d="Unassigned Tickets"}

{t c="TRANS_LAST_REPLIED" d="Last Replied"}
{t c="TRANS_LAST_ACTIVITY" d="Last Activity"}

{t c="TRANS_DISPLAY_DEPARTMENT_DATA" d="Display/Hide Department Data"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_HELPDESK"
	childName="TRANS_DEPARTMENTS"
	sideNavMajor="helpdesk"
	sideNavMinor="helpdesk"}

<table cellpadding="0" border="0" cellspacing="0">
<tr>
	<td onmouseover="this.style.cursor='hand'" onclick="{strip}
		{foreach key=deptID item=dept from=$helpdeskDepartments}
			{foreach key=bucketID item=bucket from=$dept.buckets}
				toggle('brow_{$deptID}_{$bucketID}');
			{/foreach}
		{/foreach} {/strip}return false;"> <a href="javascript:void(0);"><img src="{$imageDirectory}/ico/data_down.gif" width="16" height="16" border="0" /></a href="javascript:void(0);"> {$smarty.const.TRANS_ADDITIONAL_DATA}
	</td>
</tr>
</table>

{foreach from=$helpdeskDepartments key=deptID item=dept}
	{if $dept.hdDepartmentID}
		<table  width="770" border="0" cellpadding="0" cellspacing="0" class="list" style="margin-bottom:15pt;">
		<thead>
		<tr class="headerRow">
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName=$dept.hdDepartmentName headerClass="firstTD" headerAlign="left"}
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_TICKETS" headerAlign="left" colWidth="15%"}
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_LAST_REPLIED" headerAlign="left" colWidth="15%"}
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_LAST_ACTIVITY" headerClass="lastTD" headerAlign="left" colWidth="15%"}
		</tr>
		</thead>
		
		<!-- Bucket Loop -->
		{foreach from=$dept.buckets key=bucketID item=bucket}
			{if $bucketID == 0}
				{assign var="urlARG" value="hdDepartmentID=$deptID"}
			{else}
				{assign var="urlARG" value="hdBucketID=$bucketID"}
			{/if}
			<tbody>
			<tr class="althover">
				<td onmouseover="this.style.cursor='hand'" onClick="return toggle('brow_{$deptID}_{$bucketID}');" colspan="4">
					<img src="{$imageDirectory}/ico/arrow_down_blue.gif" width="16" height="16" border="0" />
						<strong>{strip}
						{if $bucket.hdBucketName == ""}
							{$smarty.const.TRANS_UNASSIGNED_TICKETS}
						{else}
							{$bucket.hdBucketName}
						{/if}{/strip}</strong>
				</td>
			</tr>
			</tbody>
			
			<tbody id="brow_{$deptID}_{$bucketID}">
			<tr class="alt2">
				<td>
					<a href="{getHREF page="helpdesk.php" actionName="ShowHelpdeskBucketTickets" args="$urlARG&hdTicketStatusID=2"}">{$smarty.const.TRANS_OPEN_TICKETS}</a>
				</td>
				<td>
					{if $bucket.stats.2.count}
						{$bucket.stats.2.count}
					{else}
						0
					{/if}
				</td>
				<td>
					{if $bucket.stats.2.lastReplied.firstName == ""}
						{$smarty.const.TRANS_UNKNOWN}
					{else}
						{$bucket.stats.2.lastReplied.firstName}
					{/if}
				</td>
				<td>
					{$bucket.stats.2.lastActivity|getDate:medium}
				</td>
			</tr>
			<tr class="alt2">
				<td>
					
					<a href="{getHREF page="helpdesk.php" actionName="ShowHelpdeskBucketTickets" args="$urlARG&hdTicketStatusID=1"}">{$smarty.const.TRANS_ONHOLD_TICKETS}</a>
				</td>
				<td>
					{if $bucket.stats.1.count}
						{$bucket.stats.1.count}
					{else}
						0
					{/if}
				</td>
				<td>
					{if $bucket.stats.1.lastReplied.firstName == ""}
						{$smarty.const.TRANS_UNKNOWN}
					{else}
						{$bucket.stats.1.lastReplied.firstName}
					{/if}
				</td>
				<td>
					{$bucket.stats.1.lastActivity|getDate:medium}
				</td>
			</tr>
			<tr class="alt2">
				<td>
					<a href="{getHREF page="helpdesk.php" actionName="ShowHelpdeskBucketTickets" args="$urlARG&hdTicketStatusID=0"}">{$smarty.const.TRANS_CLOSED_TICKETS}</a>
				</td>
				<td>
					{if $bucket.stats.0.count}
						{$bucket.stats.0.count}
					{else}
						0
					{/if}
				</td>
				<td>
					{if $bucket.stats.0.lastReplied.firstName == ""}
						{$smarty.const.TRANS_UNKNOWN}
					{else}
						{$bucket.stats.0.lastReplied.firstName}
					{/if}
				</td>
				<td>
					{$bucket.stats.0.lastActivity|getDate:medium}
				</td>
			</tr>
			</tbody>
			<script type="text/javascript">toggle('brow_{$deptID}_{$bucketID}');</script>
		{foreachelse}
			<tr>
				<td>{$smarty.const.TRANS_NO_BUCKETS_IN_DEPARTMENT}</td>
			</tr>
		{/foreach}
		<!-- End Bucket Loop -->
	{/if}
	</table>
{foreachelse}
	{$smarty.const.TRANS_NO_DEPARTMENTS_FOUND}
{/foreach}


{include file="$tplDirectory/widgets/paginationLinks.tpl"}
{include file="$tplDirectory/footer.tpl"}