{* $Id: ShowHelpdeskBucketTickets.tpl,v 1.4 2006/06/07 20:49:30 bsmith Exp $
 * --------------------------------------------------------------
 * This template displays a list of tickets in the helpdesk bucket.
 *
 * Smarty Variables:
 *	$bucket	(Bucket meta data)
 *		["hdBucketID"]
 *		["hdBucketName"]
 *	$tickets	(Tickets in the bucket)
 *	$ticketStatuses
 *	
 * Author: Brian Smith
 *}

{t c="TRANS_KEY" d="Key"}
{t c="TRANS_TICKETS_IN_BUCKET" d="Tickets in Bucket"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_HELPDESK"
	childName="TRANS_TICKETS_IN_BUCKET"
	sideNavMajor="helpdesk"
	sideNavMinor="helpdesk"}
	
<table width="770" cellpadding="0" cellspacing="0" border="0" class="list">
<thead>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_SUBJECT" headerClass="firstTD" headerAlign="left" sortColumn="hdTicketSubject"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_KEY" headerAlign="left"}
	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl" headerName="TRANS_CREATED" headerAlign="left" sortColumn="hdTicketDateCreated"}
	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl" headerName="TRANS_MODIFIED" headerAlign="left" sortColumn="hdTicketDateModified"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_STATUS" headerAlign="left" sortColumn="hdTicketStatusID"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ACTIONS"}
</tr>
</thead>

<tbody>
{foreach from=$tickets item=ticket}
	{if $className=="alt1"}
		{assign var="className" value="alt2"}
	{else}
		{assign var="className" value="alt1"}
	{/if}
	{assign var="ticketID" value=$ticket.hdTicketID}
	
	<tr class="{cycle values="alt1,alt2"}"
			style="cursor:pointer;"
			onmouseover="this.className='althover';"
			onmouseout="this.className='{$className}';"
			onClick="document.location.href='{getHREF page="helpdesk.php" actionName="ShowHelpdeskTicketDetails" args="hdTicketID=$ticketID"}';">
		<td><a href="{getHREF page="helpdesk.php" actionName="ShowHelpdeskTicketDetails" args="hdTicketID=$ticketID"}">{$ticket.hdTicketSubject}</a></td>
		<td>{$ticket.hdTicketKey}</td>
		<td>{$ticket.hdTicketDateCreated|getDate:medium}</td>
		<td>{$ticket.hdTicketDateModified|getDate:medium}</td>
		<td>{$ticket.hdTicketStatusID|getArrayValueByID:$ticketStatuses}</td>
		<td>
			<a href="{getHREF page="helpdesk.php" actionName="ShowHelpdeskTicketDetails" args="hdTicketID=$ticketID"}">
				<img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" />
			</a>
			<a href="{getHREF page="helpdesk.php" actionName="RemoveHelpdeskTicket" args="hdTicketID=$ticketID"}">
				<img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" />
			</a>
		</td>
	</tr>
{foreachelse}
	<tr>
		<td>{$smarty.const.TRANS_NORESULTS}</td>
	</tr>
{/foreach}
</table>

{include file="$tplDirectory/widgets/paginationLinks.tpl"}

{include file="$tplDirectory/footer.tpl"}