{* $Id: ShowHelpdeskDepartments.tpl,v 1.16 2006/06/05 19:25:33 bsmith Exp $
 * --------------------------------------------------------------
 * This template displays a list of helpdesk departments. It links to the AddHelpdeskDepartment,
 * EditHelpdeskDepartment, and RemoveHelpdeskDepartment actions. The edit and remove actions are displayed
 * in the list of helpdesk departments, so that each individual helpdesk department can be modified or
 * removed.
 *
 * Smarty Variables:
 *	$helpdeskDepartments (An array of helpdesk departments)
 *		hdDepartmentID 	The ID of the helpdesk department.
 *		hdDepartmentName 	The name of the helpdesk department.
 *		hdDepartmentDescription	The description of the helpdesk department.
 *		numBuckets	The number of buckets within this helpdesk department.
 *		numTickets	The number of tickets within this helpdesk department.
 *		numAdmins	The number of admins within this helpdesk department.
 *
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *  $sid					The current sessionID
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_ADD_DEPARTMENT" d="Add Department"}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_DEPARTMENTS" d="Departments"}
{t c="TRANS_DEPARTMENT_NAME" d="Department Name"}
{t c="TRANS_DEPARTMENT_DESCRIPTION" d="Department Description"}
{t c="TRANS_TICKETS" d="Tickets"}
{t c="TRANS_MANAGE_HELPDESK" d="Manage Helpdesk"}
{t c="TRANS_NO_DEPARTMENTS_FOUND" d="No Departments Found"}
{t c="TRANS_ADD_NEW_DEPT" d="Add New Department"}
{t c="TRANS_ASSOCIATED_ADMINS" d="Associated Admins"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_HELPDESK"
	childName="TRANS_DEPARTMENTS"
	sideNavMajor="helpdesk"
	sideNavMinor="helpdesksetup"}

<table width="97%" border="0" cellspacing="0" cellpadding="0" class="tab07">
<tr>
	{* left column *}
	<td width="50%" valign="top">
		<table width="80%" border="0" cellpadding="0" cellspacing="0" class="list">
		<thead>
		<tr class="headerRow">
			{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_DEPARTMENTS" sortColumn="hdDepartmentName"}
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ACTIONS" headerAlign="center"}
		</tr>
		</thead>

		<tbody>
		{foreach from=$helpdeskDepartments item=dept}
			{assign var="hdDepartmentID" value=$dept.hdDepartmentID}
			{if $className=="alt1"}
			    {assign var="className" value="alt2"}
			{else}
			    {assign var="className" value="alt1"}
			{/if}
			<tr class="{cycle values="alt1,alt2"}"
				onmouseover="this.className='althover';"
				onmouseout="this.className='{$className}';">
				<td>
					<strong>{$dept.hdDepartmentName}</strong>
					{include
						file="$tplDirectory/widgets/quickEditLink.tpl"
						editActionName="EditHelpdeskDepartmentResponse"
						editID=$hdDepartmentID
						editKey="hdDepartmentID"
						editName="TRANS_DEPARTMENT_NAME"
						editColumn="hdDepartmentName"
						editValue=$dept.hdDepartmentName}
					{if $dept.hdDepartmentDescription}
					<br />
						{$dept.hdDepartmentDescription}
						{include
							file="$tplDirectory/widgets/quickEditLink.tpl"
							editActionName="EditHelpdeskDepartmentResponse"
							editID=$hdDepartmentID
							editKey="hdDepartmentID"
							editName="TRANS_DEPARTMENT_DESCRIPTION"
							editColumn="hdDepartmentDescription"
							editValue=$dept.hdDepartmentDescription}
					{/if}
				</td>
				<td align="center">
					{strip}
					<a href="{getHREF page="helpdesk.php" actionName="EditHelpdeskDepartment" args="hdDepartmentID=$hdDepartmentID"}">
						<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
					</a>
					&nbsp;
					<a href="{getHREF page="helpdesk.php" actionName="RemoveHelpdeskDepartment" args="hdDepartmentID=$hdDepartmentID"}">
						<img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_REMOVE}" title="{$smarty.const.TRANS_REMOVE}" />
					</a>
					{/strip}
				</td>
			</tr>
		{foreachelse}
			<tr>
				<td colspan="2">
						{$smarty.const.TRANS_NO_DEPARTMENTS_FOUND}
				</td>
			</tr>
		{/foreach}
		<tr>
			<td colspan="2">
				{include file="$tplDirectory/widgets/paginationLinks.tpl"}
			</td>
		</tr>
		</thead>
		</table>
	</td>

	{* right column *}
	<td width="50%" valign="top" align="left">
		<form method="post" action="helpdesk.php">
		<input type="hidden" name="action" value="{getActionID action="AddHelpdeskDepartmentResponse"}">
		<input type="hidden" name="redirectURL" value="{$fileName}" />
		<input type="hidden" name="redirectAction" value="{$actionName}" />
		<input type="hidden" name="redirectArgs" value="{$bookmarkArgs}" />
		<input type="hidden" name="sid" value="{$sid}">
		<table width="100%" valign="top" align="left" border="0" cellspacing="0" cellpadding="0" class="list">
		<thead>
		<tr class="headerRow">
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ADD_NEW_DEPT" headerClass="firstTD"}
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="&nbsp;" headerClass="lastTD"}
		</tr>
		</thead>
		
		<tr valign="top" class="{cycle values="alt1,alt2"}">
			<th>{$smarty.const.TRANS_NAME}:</th>
			<td><input type="text" name="hdDepartmentName" value=""></td>
		</tr>
		<tr valign="top" class="{cycle values="alt1,alt2"}">
			<th>{$smarty.const.TRANS_DESCRIPTION}:</th>
			<td><textarea name="hdDepartmentDescription"></textarea></td>
		</tr>
		<tr valign="top" class="{cycle values="alt1,alt2"}">
			<th>{$smarty.const.TRANS_ASSOCIATED_ADMINS}:</th>
			<td>
				<select name="adminIDs[]" multiple="true">
					{foreach from=$admins item=admin}
						<option value="{$admin.adminID}">{$admin.adminUsername} ({$admin.adminFirstName} {$admin.adminLastName})</option>
					{/foreach}
				</select>
			</td>
		</tr>
		<tr>
			<td align="right" colspan="2"><input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_ADD_DEPARTMENT}"></td>
		</tr>
		</table>
		</form>
	</td>
</tr>
</table>

{include file="$tplDirectory/footer.tpl"}