{* $Id: ShowHelpdeskTickets.tpl,v 1.10 2006/06/07 20:49:30 bsmith Exp $
 * --------------------------------------------------------------
 * This template displays a list of helpdesk tickets to the user. From this list, the user should be 
 * able to access the AddHelpdeskTicket, EditHelpdeskTicket, and RemoveHelpdeskTicket actions.
 *
 * Smarty Variables:
 *	$helpdeskTickets - An array of helpdesk tickets. Each element in this array is an array that represents 
 *	                   a helpdesk ticket. Each helpdesk ticket array is strucured as follows:
 *	                     hdTicketID - The ID of the helpdesk ticket.
 *                       helpdeskTicketName - The name of the helpdesk ticket.
 *                       hdDepartmentIDs - An array of helpdesk department IDs that this helpdesk ticket 
 *                                               is associated with. Each element in this array is a helpdesk 
 *                                               department ID.
 *  $helpdeskDepartments - An array of helpdesk departments. Each element in this array is an array that 
 *                         represents a helpdesk department. Each helpdesk department array is structured as 
 *                         follows:
 *                           hdDepartmentIDs - The ID of the helpdesk department.
 *                           hdDepartmentName - The name of the helpdesk department.
 *                           hdDepartmentDescription - The description of the helpdesk department.
 *  $admins - An array of admins of the system. Each element in this array represents an admin, and that array 
 *	          is structured as follows:
 *	            adminID - The ID of the administrator.
 *	            adminFirstName - The first name of the administrator.
 *	            adminLastName - The last name of the administrator.
 *	            adminUsername - The username of the administrator.
 *	            adminEmail - The email of the administrator.
 *	            adminActive - 1 if the admin is active, or 0 if otherwise.
 *	            themeID - The theme ID of the administrator.
 *	            languageID - The language ID of the administrator.
 *	            countriesID - The country ID of the administrator.
 *}
{t c="TRANS_KEY" d="Key"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_HELPDESK"
	childName="TRANS_TICKETS"
	sideNavMajor="helpdesk"
	sideNavMinor="helpdesk"}

<table border="0" cellpadding="0" width="770" cellspacing="0" class="list">
<thead>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_SUBJECT" sortColumn="hdTicketSubject" headerClass="firstTD"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_KEY"}
	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl" headerName="TRANS_CREATED" sortColumn="hdTicketDateCreated"}
	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl" headerName="TRANS_MODIFIED" sortColumn="hdTicketDateModified"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_STATUS" sortColumn="hdTicketStatusID"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ACTIONS"}
</tr>
</thead>

<tbody>
{foreach from=$helpdeskTickets item=ticket}
	{if $className == "alt1"}
		{assign var="className" value="alt2"}
	{else}
		{assign var="className" value="alt1"}
	{/if}
	{assign var=hdTicketID value=$ticket.hdTicketID}
	
	<tr class="{cycle values="alt1,alt2"}" {strip}
			style="cursor:pointer;"
			onmouseover="this.className='althover';"
			onmouseout="this.className='{$className}';"
			{/strip} onClick="document.location.href='{getHREF page="helpdesk.php" actionName="ShowHelpdeskTicketDetails" args="hdTicketID=$hdTicketID"}';">
		<td>{$ticket.hdTicketSubject}</td>
		<td>{$ticket.hdTicketKey}</td>
		<td>{$ticket.hdTicketDateCreated|getDate:medium}</td>
		<td>{$ticket.hdTicketDateModified|getDate:medium}</td>
		<td>{$ticket.hdTicketStatusID|getStatusName:"helpdesk"}</td>
		<td>
			<a href="{getHREF page="helpdesk.php" actionName="ShowHelpdeskTicketsDetails" args="hdTicketID=$hdTicketID"}">
				<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" title="{$smarty.const.TRANS_EDIT}" alt="{$smarty.const.TRANS_EDIT}" />
			</a>
			<a href="{getHREF page="helpdesk.php" actionName="RemoveHelpdeskTicket" args="hdTicketID=$hdTicketID"}">
				<img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" title="{$smarty.const.TRANS_REMOVE}" alt="{$smarty.const.TRANS_REMOVE}" />
			</a>
		</td>
	</tr>
{foreachelse}
	<tr class="{cycle values="alt1,alt2"}">
		<td>{$smarty.const.TRANS_NORESULTS}</td>
	</tr>
{/foreach}
</tbody>
</table>
{include file="$tplDirectory/widgets/paginationLinks.tpl"}

{include file="$tplDirectory/footer.tpl"}