{* $Id: RemoveLedgerAccount.tpl,v 1.4 2006/03/22 00:48:06 kbailey Exp $
 * --------------------------------------------------------------
 * This template displays the ledger accounts management page.
 *
 * Smarty Variables:
 *	$ledgerAccounts (array of ledger account data)
 *		ledgerAccountID
 *		ledgerAccountNumber
 *		ledgerAccountType
 * 		ledgerAccountName
 *		ledgerAccountTransKey
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_REMOVE_LEDGER_ACCOUNT" d="Remove Ledger Account"}
{t c="TRANS_CONFIRM_REMOVE_ACCOUNT" d="Are you sure you wish to remove this ledger account?"}
{t c="TRANS_ACCOUNTING" d="Accounting"}
{t c="TRANS_ACCOUNTS_RECEIVABLE" d="Accounts Receivable"}
{t c="TRANS_ACCOUNTS_PAYABLE" d="Accounts Payable"}
{t c="TRANS_CERTS_PAYABLE" d="Certs Payable"}
{t c="TRANS_CASH" d="Cash 1"}
{t c="TRANS_CASH_1" d="Cash 2"}
{t c="TRANS_CASH_2" d="Cash 3"}
{t c="TRANS_HARDWARE_ASSETS" d="Hardware Assets"}
{t c="TRANS_EQUITY" d="Owner Equity"}
{t c="TRANS_REVENUE" d="Revenue"}
{t c="TRANS_DOMAINS_PAYABLE" d="Domains Payable"}
{t c="TRANS_GL_NUMBER" d="GL Number"}
{t c="TRANS_LEDGER_ACCOUNTS" d="Ledger Accounts"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_NAME" d="Name"}
{t c="TRANS_QUICK_STATS" d="Quick Stats"}
{t c="TRANS_TAXES_PAYABLE" d="Taxes Payable"}
{t c="TRANS_ACTIONS" d="Actions"}

{t c="TRANS_COGS" d="Misc Cost of Goods Sold"}
{t c="TRANS_DOMAIN_COGS" d="Domain COGS"}
{t c="TRANS_CERTS_COGS" d="Certificates COGS"}
{t c="TRANS_SETUP_COGS" d="Setup COGS"}
{t c="TRANS_USAGE_COGS" d="Usage COGS"}
{t c="TRANS_CUSTOMER_CREDITS" d="Client Credits"}

{t c="TRANS_EXPENSE" d="Misc Expense"}
{t c="TRANS_REFUND_EXPENSE" d="Refund Expense"}
{t c="TRANS_CUSTOMER_EXPENSE" d="Customer Relations Expense"}
{t c="TRANS_WAGES_EXPENSE" d="Wages Expense"}
{t c="TRANS_ENTERTAINMENT_EXPENSE" d="Entertainment/Meals Expense"}
{t c="TRANS_RENT_EXPENSE" d="Rent/Lease Expense"}
{t c="TRANS_TRAVEL_EXPENSE" d="Travel Expense"}
{t c="TRANS_COMMISSIONS_EXPENSE" d="Commissions Expense"}
{t c="TRANS_INCOME_TAX_EXPENSE" d="Income Tax Expense"}
{t c="TRANS_DEPRECIATION_EXPENSE" d="Depreciation Expense"}
{t c="TRANS_HARDWARE_LEASE_EXPENSE" d="Hardware Lease Expense"}
{t c="TRANS_COLOCATION_EXPENSE" d="Colocation Expense"}



{t c="TRANS_ASSET_ACCOUNTS" d="Asset Accounts"}
{t c="TRANS_LIABILITY_ACCOUNTS" d="Liability Accounts"}
{t c="TRANS_EQUITY_ACCOUNTS" d="Equity Accounts"}
{t c="TRANS_REVENUE_ACCOUNTS" d="Revenue Accounts"}
{t c="TRANS_COGS_ACCOUNTS" d="Cost of Goods Sold Accounts"}
{t c="TRANS_EXPENSE_ACCOUNTS" d="Expense Accounts"}
{t c="TRANS_OTHER_REVENUE_ACCOUNTS" d="Other Revenue Accounts"}
{t c="TRANS_OTHER_EXPENSE_ACCOUNTS" d="Other Expense Accounts"}

{t c="TRANS_BALANCE_SHEET_ACCOUNTS" d="Balance Sheet Accounts"}
{t c="TRANS_GL_TYPE" d="Account Group"}
{t c="TRANS_FINANCIAL_STATEMENT_ACCOUNTS" d="Financial Statement Accounts"}

{t c="TRANS_CLIENT_NAME" d="Client"}
{t c="TRANS_DATE" d="Date"}
{t c="TRANS_INVOICE_NUMBER" d="Inv. #"}
{t c="TRANS_DESCRIPTION" d="Description"}
{t c="TRANS_DEBITS" d="Debits"}
{t c="TRANS_CREDITS" d="Credits"}
{t c="TRANS_CURRENCY_SHORT" d="Curr."}
{t c="TRANS_GL_TRANSACTIONS" d="Ledger Transactions"}
{t c="TRANS_NO_TRANSACTIONS" d="No transaction in this Ledger Account"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_GL_ACCOUNT_PARENT" d="Parent GL Account"}

{t c="TRANS_SAVE_LEDGER_ACCOUNT_DETAILS" d="Save Ledger Account Details"}
{t c="TRANS_LEDGER_ACCOUNT_LABEL" d="Account Label"}
{t c="TRANS_NO_ACCOUNT_ID_GIVEN" d="No account id provided, please go back to the chart of account."}

{t c="TRANS_YES_I_DO" d="Yes, remove this account."}
{t c="TRANS_NO_I_DONT" d="No, leave this account alone."}
{t c="TRANS_CANNOT_REMOVE_NOT_EMPTY" d="Sorry, this account contains transactions and cannot be removed."}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_FINANCES"
	childName="TRANS_ACCOUNTING"
	grandchildName="TRANS_REMOVE_LEDGER_ACCOUNT"
	sideNavMajor="finances"
	sideNavMinor="accounting"}

{assign var="ledgerAccountID" value=$account.ledgerAccountID}
{assign var="tkey" value=$account.ledgerAccountTransKey}

<h1>{$smarty.const.TRANS_REMOVE_LEDGER_ACCOUNT}</h1>

<br />
<table width="100%" border="0">
<tr><td align="center">
<table border="0" cellpadding="3">
    <tr>
        <td>{if $canRemove}
<strong>{$smarty.const.TRANS_CONFIRM_REMOVE_ACCOUNT}</strong>
<br />
<br />
<strong>{$smarty.const.TRANS_GL_NUMBER}:</strong> {$account.ledgerAccountNumber}<br />
<strong>{$smarty.const.TRANS_LEDGER_ACCOUNT_LABEL}:</strong> {$smarty.const.$tkey|default:$tkey}<br /><br />
<a href="{getHREF page="accounting.php" actionName="RemoveLedgerAccount" args="ledgerAccountID=`$account.ledgerAccountID`&removeLedgerAccount=1"}">{$smarty.const.TRANS_YES_I_DO}</a>
 - <a href="{getHREF page="accounting.php" actionName="ShowLedgerAccounts" args=""}">{$smarty.const.TRANS_NO_I_DONT}</a>
        {else}
        <strong>{$smarty.const.TRANS_CANNOT_REMOVE_NOT_EMPTY}</strong><br />
        <a href="{getHREF page="accounting.php" actionName="ShowLedgerAccounts" args=""}">{$smarty.const.TRANS_CHART_OF_ACCOUNTS}</a>
        {/if}</td>
    </tr>
</table>
</td></tr>
</table>
{include file="$tplDirectory/footer.tpl"}