{* $Id: ShowAccountingStats.tpl,v 1.9 2006/06/20 17:40:09 kbailey Exp $
 * --------------------------------------------------------------
 * This template displays a mini accounting stats report.
 *
 * Smarty Variables:
 *	$invoiceStats (array of invoice status and their count)
 *		invoiceStatus
 *		numInovices
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_ACCOUNTING" d="Accounting"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_QUICK_STATS" d="Quick Stats"}
{t c="TRANS_TODAYS_FINANCIAL_STATEMENTS" d="Today's Financial Statements"}
{t c="TRANS_LIABILITIES_AND_EQUITY" d="Liabilities &amp; Equity"}

{t c="TRANS_CURRENCY" d="Currency"}
{t c="TRANS_EQUITY_RETAINED" d="Current Equity"}
{t c="TRANS_REVENUE" d="Revenue"}
{t c="TRANS_OTHER_REVENUE" d="Other Revenue"}
{t c="TRANS_COGS" d="Cost of Goods"}
{t c="TRANS_EXPENSE" d="Expense"}
{t c="TRANS_OTHER_EXPENSE" d="Other Expense"}
{t c="TRANS_NET_INCOME" d="Net Income"}

{t c="TRANS_ASSETS" d="Assets"}
{t c="TRANS_LIABILITIES" d="Liabilities"}
{t c="TRANS_BALANCE_SHEET_SUMMARY" d="Balance Sheet Summary"}
{t c="TRANS_EQUITY" d="Retained Equity"}

{t c="TRANS_AR_AGING_SUMMARY" d="AR Aging Summary"}
{t c="TRANS_0_TO_30" d="0-30 Days"}
{t c="TRANS_30_TO_60" d="30-60 Days"}
{t c="TRANS_60_TO_90" d="60-90 Days"}
{t c="TRANS_90_TO_120" d="90-120 Days"}
{t c="TRANS_120_PLUS" d="120+ Days"}



{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_FINANCES"
	childName="TRANS_ACCOUNTING"
	grandchildName="TRANS_QUICK_STATS"
	sideNavMajor="finances"
	sideNavMinor="accounting"}

<table  width="770" border="0" cellpadding="0" cellspacing="3" class="tab01" >
<tr>
	<td>
        <h2>{$smarty.const.TRANS_TODAYS_FINANCIAL_STATEMENTS}</h1>

        <table width="100%" cellpadding="4" class="ledger">
            <tr>
                <th class="green">{$smarty.const.TRANS_CURRENCY}</th>
                <th class="green">{$smarty.const.TRANS_REVENUE}</th>
                <th class="green">{$smarty.const.TRANS_OTHER_REVENUE}</th>
                <th class="green">{$smarty.const.TRANS_COGS}</th>
                <th class="green">{$smarty.const.TRANS_EXPENSE}</th>
                <th class="green">{$smarty.const.TRANS_OTHER_EXPENSE}</th>
                <th>{$smarty.const.TRANS_NET_INCOME}</th>
            </tr>

{foreach key="currencyID" item="totals" from=$ledgerTypeTotals}
    {if $didFirst}
        {assign var="class" value=""}
    {else}
        {assign var="didFirst" value=1}
        {assign var="class" value="first"}
    {/if}

            <tr class="{$class}">
                <td align="right">{$currencyID}</th>
                <td align="right">{$totals.revenue|getAmount:$currencyID}</td>
                <td align="right">{$totals.otherRev|getAmount:$currencyID}</td>
                <td align="right">{$totals.cogs|getAmount:$currencyID}</td>
                <td align="right">{$totals.expense|getAmount:$currencyID}</td>
                <td align="right">{$totals.otherExp|getAmount:$currencyID}</td>
                <td align="right">{$totals.total|getAmount:$currencyID}</td>
            </tr>

{/foreach}

        </table>

        <br /><br />
        <h2>{$smarty.const.TRANS_BALANCE_SHEET_SUMMARY}</h1>

        <table width="100%" cellpadding="4" class="ledger">
            <tr>
                <th class="green">{$smarty.const.TRANS_CURRENCY}</th>
                <th class="green">{$smarty.const.TRANS_ASSETS}</th>
                <th class="green">{$smarty.const.TRANS_LIABILITIES}</th>
                <th class="green">{$smarty.const.TRANS_EQUITY}</th>
                <th class="green">{$smarty.const.TRANS_EQUITY_RETAINED}</th>
                <th>{$smarty.const.TRANS_LIABILITIES_AND_EQUITY}</th>
            </tr>

{assign var="didFirst" value=0}
{foreach key="currencyID" item="totals" from=$ledgerTypeTotals}
    {if $didFirst}
        {assign var="class" value=""}
    {else}
        {assign var="didFirst" value=1}
        {assign var="class" value="first"}
    {/if}

            <tr class="{$class}">
                <td align="right">{$currencyID}</th>
                <td align="right">{$totals.asset|getAmount:$currencyID}</td>
                <td align="right">{$totals.liability|getAmount:$currencyID}</td>
                <td align="right">{$totals.equity|getAmount:$currencyID}</td>
                <td align="right">{$totals.equityretained|getAmount:$currencyID}</td>
                <td align="right">{$totals.balancetotal|getAmount:$currencyID}</td>
            </tr>

{/foreach}

        </table>
{*
        <br /><br />
        <h2>{$smarty.const.TRANS_AR_AGING_SUMMARY}</h1>

        <table width="100%" cellpadding="4" class="ledger">
		<tr>
			<th class="green">{$smarty.const.TRANS_CURRENCY}</th>
			<th class="green">{$smarty.const.TRANS_0_TO_30}</th>
			<th class="green">{$smarty.const.TRANS_30_TO_60}</th>
			<th class="green">{$smarty.const.TRANS_60_TO_90}</th>
			<th class="green">{$smarty.const.TRANS_90_TO_120}</th>
			<th>{$smarty.const.TRANS_120_PLUS}</th>
		</tr>

{assign var="didFirst" value=0}


{foreach key="currencyID" item="data" from=$reportData.currencyTotals}
    {if $didFirst}
        {assign var="class" value=""}
    {else}
        {assign var="didFirst" value=1}
        {assign var="class" value="first"}
    {/if}

	<tr class="{$class}">
		<td>{$currencyID}</td>
		<td align="right">{$data.0.total|getAmount:$currencyID}</td>
		<td align="right">{$data.1.total|getAmount:$currencyID}</td>
		<td align="right">{$data.2.total|getAmount:$currencyID}</td>
		<td align="right">{$data.3.total|getAmount:$currencyID}</td>
		<td align="right">{$data.4.total|getAmount:$currencyID}</td>
	</tr>

{/foreach}

</table>


*}
	</td>
</tr>
</table>

{include file="$tplDirectory/footer.tpl"}
