{* $Id: ShowBalanceSheet.tpl,v 1.4 2006/03/22 00:48:06 kbailey Exp $
 * --------------------------------------------------------------
 * This template displays a mini accounting stats report.
 *
 * Smarty Variables:
 *	$invoiceStats (array of invoice status and their count)
 *		invoiceStatus
 *		numInovices
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_ACCOUNTING" d="Accounting"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_QUICK_STATS" d="Quick Stats"}
{t c="TRANS_BALANCE_SHEET" d="Balance Sheet"}

{t c="TRANS_CURRENCY" d="Currency"}

{t c="TRANS_ASSET" d="Asset"}
{t c="TRANS_LIABILITY" d="Liability"}
{t c="TRANS_EQUITY" d="Equity"}

{t c="TRANS_GL_ACCOUNT_NUMBER" d="GL #"}
{t c="TRANS_GL_ACCOUNT_NAME" d="Description"}
{t c="TRANS_BALANCES_AND_TOTALS" d="Balances"}

{t c="TRANS_ASSET_LABEL" d="Asset Accounts"}
{t c="TRANS_LIABILITY_LABEL" d="Liability Accounts"}
{t c="TRANS_EQUITY_LABEL" d="Equity Accounts"}

{t c="TRANS_ASSET_TOTALS" d="Total Assets"}
{t c="TRANS_LIABILITY_TOTALS" d="Total Liabilities"}
{t c="TRANS_EQUITY_TOTALS" d="Total Equity"}

{t c="TRANS_NET_ASSETS" d="Net Assets"}
{t c="TRANS_LIABILITIES_AND_EQUITY" d="Liabilities &amp; Equity"}
{t c="TRANS_GROSS_ASSETS" d="Gross Assets"}

{t c="TRANS_THROUGH" d="Through"}

{t c="TRANS_ACCOUNTS_RECEIVABLE" d="Accounts Receivable"}
{t c="TRANS_ACCOUNTS_PAYABLE" d="Accounts Payable"}
{t c="TRANS_CERTS_PAYABLE" d="Certs Payable"}
{t c="TRANS_CASH" d="Cash 1"}
{t c="TRANS_CASH_1" d="Cash 2"}
{t c="TRANS_CASH_2" d="Cash 3"}
{t c="TRANS_HARDWARE_ASSETS" d="Hardware Assets"}
{t c="TRANS_EQUITY" d="Owner Equity"}
{t c="TRANS_REVENUE" d="Revenue"}
{t c="TRANS_DOMAINS_PAYABLE" d="Domains Payable"}
{t c="TRANS_GL_NUMBER" d="GL Number"}
{t c="TRANS_LEDGER_ACCOUNTS" d="Ledger Accounts"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_NAME" d="Name"}
{t c="TRANS_QUICK_STATS" d="Quick Stats"}
{t c="TRANS_TAXES_PAYABLE" d="Taxes Payable"}
{t c="TRANS_ACTIONS" d="Actions"}

{t c="TRANS_COGS" d="Misc Cost of Goods Sold"}
{t c="TRANS_DOMAIN_COGS" d="Domain COGS"}
{t c="TRANS_CERTS_COGS" d="Certificates COGS"}
{t c="TRANS_SETUP_COGS" d="Setup COGS"}
{t c="TRANS_USAGE_COGS" d="Usage COGS"}

{t c="TRANS_EXPENSE" d="Misc Expense"}
{t c="TRANS_REFUND_EXPENSE" d="Refund Expense"}
{t c="TRANS_CUSTOMER_EXPENSE" d="Customer Relations Expense"}
{t c="TRANS_WAGES_EXPENSE" d="Wages Expense"}
{t c="TRANS_ENTERTAINMENT_EXPENSE" d="Entertainment/Meals Expense"}
{t c="TRANS_RENT_EXPENSE" d="Rent/Lease Expense"}
{t c="TRANS_TRAVEL_EXPENSE" d="Travel Expense"}
{t c="TRANS_COMMISSIONS_EXPENSE" d="Commissions Expense"}
{t c="TRANS_INCOME_TAX_EXPENSE" d="Income Tax Expense"}
{t c="TRANS_DEPRECIATION_EXPENSE" d="Depreciation Expense"}
{t c="TRANS_HARDWARE_LEASE_EXPENSE" d="Hardware Lease Expense"}
{t c="TRANS_COLOCATION_EXPENSE" d="Colocation Expense"}



{t c="TRANS_ASSET_ACCOUNTS" d="Asset Accounts"}
{t c="TRANS_LIABILITY_ACCOUNTS" d="Liability Accounts"}
{t c="TRANS_EQUITY_ACCOUNTS" d="Equity Accounts"}
{t c="TRANS_REVENUE_ACCOUNTS" d="Revenue Accounts"}
{t c="TRANS_COGS_ACCOUNTS" d="Cost of Goods Sold Accounts"}
{t c="TRANS_EXPENSE_ACCOUNTS" d="Expense Accounts"}
{t c="TRANS_OTHER_REVENUE_ACCOUNTS" d="Other Revenue Accounts"}
{t c="TRANS_OTHER_EXPENSE_ACCOUNTS" d="Other Expense Accounts"}

{t c="TRANS_CURRENT_RETAINED_EARNINGS" d="Current Equity*"}
{t c="TRANS_CUSTOMER_CREDITS" d="Client Credits"}

{t c="TRANS_RETAINED_EXPLAINATION" d="* Current equity refers to the net profit shown on the financial statement but not yet closed out to the balance sheet."}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_FINANCES"
	childName="TRANS_ACCOUNTING"
	grandchildName="TRANS_BALANCE_SHEET"
	sideNavMajor="finances"
	sideNavMinor="accounting"}

<table  width="770" border="0" cellpadding="0" cellspacing="3" class="tab01" >
<tr>
	<td>
		<h1>{$smarty.const.TRANS_BALANCE_SHEET}: {$smarty.const.TRANS_THROUGH} {$endDate|getDate:short}</h1>


{foreach key="currencyID" item="totals" from=$ledgerAccountsTotals}

    <h2>{$smarty.const.TRANS_CURRENCY}: {$currencyID}</h2>

        <table width="100%" cellpadding="4" class="ledger">
            <tr>
                <th>{$smarty.const.TRANS_GL_ACCOUNT_NUMBER}</th>
                <th>{$smarty.const.TRANS_GL_ACCOUNT_NAME}</th>
                <th align="right">{$smarty.const.TRANS_BALANCES_AND_TOTALS}</th>
            </tr>

            {* ------------------------ ASSET ------------------------------- *}

            {assign var="didFirst" value=0}
            {assign var="loopData" value=$totals.asset}
            {assign var="totalsData" value=$ledgerTypeTotals.$currencyID.asset}

            {section name="i" loop=$loopData}
                {assign var="accountid" value=$loopData[i].accountInfo.ledgerAccountID}
                {if $didFirst}
                    {assign var="class" value=""}
                {else}
            <tr class="first">
                <td colspan="3"><h1>{$smarty.const.TRANS_ASSET_LABEL}<h1></td>
            </tr>
                    {assign var="didFirst" value=1}
                    {assign var="class" value="first"}
                {/if}

            <tr class="{$class}">
                <td>{$ledgerAccounts.$accountid.ledgerAccountNumber}</td>
                {assign var="tkey" value=$ledgerAccounts.$accountid.ledgerAccountTransKey}
                <td>{$smarty.const.$tkey|default:$tkey}</td>
                <td align="right">{$loopData[i].total|getAmount:$currencyID}</td>
            </tr>
            {/section}
            <tr class="total alt1">
                <td colspan="2" align="right"><h1>{$smarty.const.TRANS_ASSET_TOTALS}</h1></td>
                <td align="right">{$totalsData|getAmount:$currencyID}</td>
            </tr>

            {* ------------------------------------------------------------- *}

            {* ------------------------ LIABILITY -------------------------- *}

            {assign var="didFirst" value=0}
            {assign var="loopData" value=$totals.liability}
            {assign var="totalsData" value=$ledgerTypeTotals.$currencyID.liability}

            {section name="i" loop=$loopData}
                {assign var="accountid" value=$loopData[i].accountInfo.ledgerAccountID}
                {if $didFirst}
                    {assign var="class" value=""}
                {else}
            <tr class="first">
                <td colspan="3"><h1>{$smarty.const.TRANS_LIABILITY_LABEL}<h1></td>
            </tr>
                    {assign var="didFirst" value=1}
                    {assign var="class" value="first"}
                {/if}

            <tr class="{$class}">
                <td>{$ledgerAccounts.$accountid.ledgerAccountNumber}</td>
                {assign var="tkey" value=$ledgerAccounts.$accountid.ledgerAccountTransKey}
                <td>{$smarty.const.$tkey|default:$tkey}</td>
                <td align="right">{$loopData[i].total|getAmount:$currencyID}</td>
            </tr>
            {/section}

            <tr class="total">
                <td colspan="2" align="right"><h1><i>{$smarty.const.TRANS_LIABILITY_TOTALS}</i></h1></td>
                <td align="right">{$totalsData|getAmount:$currencyID}</td>
            </tr>

            {* ------------------------------------------------------------- *}

            {* ------------------------ EQUITY ----------------------------- *}

            {assign var="didFirst" value=0}
            {assign var="loopData" value=$totals.equity}
            {assign var="totalsData" value=$ledgerTypeTotals.$currencyID.equity}

            <tr class="first">
                <td colspan="3"><h1>{$smarty.const.TRANS_EQUITY_LABEL}<h1></td>
            </tr>

            {assign var="class" value="first"}
            {section name="i" loop=$loopData}
                {assign var="accountid" value=$loopData[i].accountInfo.ledgerAccountID}
                {if $didFirst}
                    {assign var="class" value=""}
                {else}
                    {assign var="didFirst" value=1}
                {/if}

            <tr class="{$class}">
                <td>{$ledgerAccounts.$accountid.ledgerAccountNumber}</td>
                {assign var="tkey" value=$ledgerAccounts.$accountid.ledgerAccountTransKey}
                <td>{$smarty.const.$tkey|default:$tkey}</td>
                <td align="right">{$loopData[i].total|getAmount:$currencyID}</td>
            </tr>
            {/section}

            <tr class="{$class}">
                <td> </td>
                <td>{$smarty.const.TRANS_CURRENT_RETAINED_EARNINGS}</td>
                <td align="right">{$ledgerTypeTotals.$currencyID.equityretained|getAmount:$currencyID}</td>
            </tr>

            <tr class="total">
                <td colspan="2" align="right"><h1><i>{$smarty.const.TRANS_EQUITY_TOTALS}</i></h1></td>
                <td align="right">{$totalsData|getAmount:$currencyID}</td>
            </tr>

            {* ------------------------------------------------------------- *}

            <tr class="first alt1">
                <td colspan="2" align="right"><h1>{$smarty.const.TRANS_LIABILITIES_AND_EQUITY}</h1></td>
                <td align="right">{$ledgerTypeTotals.$currencyID.equity+$ledgerTypeTotals.$currencyID.liability|getAmount:$currencyID}</td>
            </tr>


        </table>

{/foreach}

    <br />
    <div class="box07" style="padding: 5px;">
    {$smarty.const.TRANS_RETAINED_EXPLAINATION}
    </div>

	</td>
</tr>
</table>

{include file="$tplDirectory/footer.tpl"}