{* $Id: ShowJournalsMenu.tpl,v 1.10 2006/03/22 00:48:06 kbailey Exp $
 * --------------------------------------------------------------
 * This template displays a the accounting journals menu.
 *
 * Smarty Variables:
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_ACCOUNTING" d="Accounting"}
{t c="TRANS_AMOUNT" d="Amount"}
{t c="TRANS_DATE" d="Date"}
{t c="TRANS_DAILY_JOURNALS" d="Daily Journals"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_PURCHASES_JOURNAL" d="Purchases Journal"}
{t c="TRANS_PURCHASES_JOURNAL_DESC" d="All daily cash disbursements are recorded in the purchases journal."}
{t c="TRANS_SALES_AND_RECEIPTS_JOURNAL" d="Sales & Receipts Journal"}
{t c="TRANS_SALES_AND_RECEIPTS_DESC" d="All daily sales and payments received are recorded in a combined sales and cash receipts journal."}
{t c="TRANS_SELECT_JOURNAL_DATE" d="Select a journal date to view."}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_FINANCES"
	childName="TRANS_ACCOUNTING"
	grandchildName="TRANS_DAILY_JOURNALS"
	sideNavMajor="finances"
	sideNavMinor="accounting"}

<table  width="770" border="0" cellpadding="0" cellspacing="3" class="tab01">
<tr>
	<td>
		<table  width="100%" border="0" cellpadding="0" cellspacing="3" class="tab07">
		<tr class="althover">
			<th width="50%">{$smarty.const.TRANS_SALES_AND_RECEIPTS_JOURNAL}</th>
			<th width="50%">{$smarty.const.TRANS_PURCHASES_JOURNAL}</th>
		</tr>
		<tr class="alt2">
			<td valign="top">{$smarty.const.TRANS_SALES_AND_RECEIPTS_DESC}</td>
			<td valign="top">{$smarty.const.TRANS_PURCHASES_JOURNAL_DESC}</td>
		</tr>
		<tr class="alt1">
			<td align="center" valign="top">
				<form>
					{$smarty.const.TRANS_SELECT_JOURNAL_DATE} <input class="button" type="button" id="salesJournalCal" value=" ... " />
				</form>
				<br />
                {* <img src="{getHREF page="graphs.php" actionName="ShowFinancialGraph"}&{strip}
	                type=bar&
	                dataSource=SalesAndReceiptsJournal&
	                dataSourceArgs=14&
					title={$smarty.const.TRANS_SALES_AND_RECEIPTS_JOURNAL|urlencode}&
					titleBold=1&
					xTitle={$smarty.const.TRANS_DATE|urlencode}&
					xTitleBold=1&
					yTitle={$smarty.const.TRANS_AMOUNT|urlencode}&
					yTitleBold=1&
					{/strip}" /> *}
			</td>
			<td align="center" valign="top">
				<form>
					{$smarty.const.TRANS_SELECT_JOURNAL_DATE} <input class="button" type="button" id="purchasesJournalCal" value=" ... " />
				</form>
				<br />
			</td>
		</tr>
		</table>
	</td>
</tr>
</table>

<script type="text/javascript">//<![CDATA[
{literal}
var startDate;
var endDate;
var callbacks = 0;

function resetDates() {
	startDate = endDate = null;
}

/*
* Given two dates (in seconds) find out if date1 is bigger, date2 is bigger or
* they're the same, taking only the dates, not the time into account.
* In other words, different times on the same date returns equal.
* returns -1 for date1 bigger, 1 for date2 is bigger 0 for equal
*/

function compareDatesOnly(date1, date2) {
	var year1 = date1.getYear();
	var year2 = date2.getYear();
	var month1 = date1.getMonth();
	var month2 = date2.getMonth();
	var day1 = date1.getDate();
	var day2 = date2.getDate();
	if (year1 > year2) {
		return -1;
	}
	if (year2 > year1) {
		return 1;
	}
	//years are equal
	if (month1 > month2) {
		return -1;
	}
	if (month2 > month1) {
		return 1;
	}
	//years and months are equal
	if (day1 > day2) {
		return -1;
	}
	if (day2 > day1) {
		return 1;
	}
	//days are equal
	return 0;
}

function disableDates(date) {
	var now = new Date();
	if (compareDatesOnly(now, date) > 0) {
		return (true);
	}
	//all other days are enabled
	return false;
}

function goSalesJournal(cal) {
	if (cal.dateClicked) {
		{/literal}
		var url = "accounting.php?action={getActionID action="ShowReceiptsJournal"}&dateQuery[]=" + cal.date.print("%Y/%m/%d/") + "&sid={$sid}";
		{literal}
		window.location = url;
	}
}

function goPurchasesJournal(cal) {
	if (cal.dateClicked) {
		{/literal}
		var url = "accounting.php?action={getActionID action="ShowPurchasesJournal"}&dateQuery[]=" + cal.date.print("%Y/%m/%d/") + "&sid={$sid}";
		{literal}
		window.location = url;
	}
}

Zapatec.Calendar.setup({
	weekNumbers       : false,
	showOthers        : false,
	showsTime         : false,
	timeFormat        : "12",
	step              : 2,
	range             : [1990.01, 2020.12],
	dateStatusFunc	  : disableDates,
	button            : "salesJournalCal",
	onSelect          : goSalesJournal
});

Zapatec.Calendar.setup({
	weekNumbers       : false,
	showOthers        : false,
	showsTime         : false,
	timeFormat        : "12",
	step              : 2,
	range             : [1990.01, 2020.12],
	dateStatusFunc	  : disableDates,
	button            : "purchasesJournalCal",
	onSelect          : goPurchasesJournal
});

{/literal}
//]]></script>

{include file="$tplDirectory/footer.tpl"}