{* $Id: ShowLedgersMenu.tpl,v 1.7 2006/03/22 00:48:06 kbailey Exp $
 * --------------------------------------------------------------
 * This template displays a the accounting ledgers menu.
 *
 * Smarty Variables:
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_ACCOUNTING" d="Accounting"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_GENERAL_LEDGERS" d="General Ledgers"}
{t c="TRANS_PURCHASES_JOURNAL_DESC" d="All daily cash disbursements are recorded in the purchases journal."}
{t c="TRANS_GENERAL_LEDGER" d="General Ledger"}
{t c="TRANS_GENERAL_LEDGER_DESC" d="The general ledger is a permanent summary of all supporting daily journals. Financial statements are generated from this ledger."}
{t c="TRANS_ACCOUNTS_RECEIVABLE_LEDGER" d="Accounts Receivable Ledger"}
{t c="TRANS_ACCOUNTS_RECEIVABLE_LEDGER_DESC" d="The accounts receivable ledger is a special general ledger used only for posting accounts receivable journal entries. Monthly client statements are generated from this ledger."}
{t c="TRANS_ACCOUNTS_PAYABLE_LEDGER" d="Accounts Payable Ledger"}
{t c="TRANS_ACCOUNTS_PAYABLE_LEDGER_DESC" d="The accounts payable ledger is a special general ledger used only for posting accounts payable journal entries. Monthly statements for companies you owe are generated from this ledger."}
{t c="TRANS_TAX_PAYABLE_LEDGER" d="Tax Payable Ledger"}
{t c="TRANS_TAX_PAYABLE_LEDGER_DESC" d="The tax payable ledger is a special general ledger used only for posting tax payable journal entries. Annual statements for the taxes you owe are generated from this ledger."}
{t c="TRANS_SELECT_LEDGER_DATE" d="Select a ledger date to view."}
{t c="TRANS_TODAYS_LEDGER" d="View Today"}


{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_FINANCES"
	childName="TRANS_ACCOUNTING"
	grandchildName="TRANS_GENERAL_LEDGERS"
	sideNavMajor="finances"
	sideNavMinor="accounting"}

<table  width="770" border="0" cellpadding="0" cellspacing="3" class="tab01">
<tr>
	<td>
		<table  width="100%" border="0" cellpadding="0" cellspacing="3" class="tab07">
		{* row 1 *}
		<tr class="althover">
			<th width="50%">{$smarty.const.TRANS_GENERAL_LEDGER}</th>
			<th width="50%">{$smarty.const.TRANS_ACCOUNTS_RECEIVABLE_LEDGER}</th>
		</tr>
		<tr class="alt2">
			<td valign="top">{$smarty.const.TRANS_GENERAL_LEDGER_DESC}</td>
			<td valign="top">{$smarty.const.TRANS_ACCOUNTS_RECEIVABLE_LEDGER_DESC}</td>
		</tr>
		<tr class="alt1">
			<td align="center">
				<form>
					{$smarty.const.TRANS_SELECT_LEDGER_DATE} <input class="button" type="button" id="generalLedgerCal" value=" ... " /><br />
                    <input class="button" type="button" value="{$smarty.const.TRANS_TODAYS_LEDGER}" onclick="document.location.href='accounting.php?action={getActionID action="ShowGeneralLedger"}&dateQuery[]={$today}&sid={$sid}&dateColumn=generalLedgerDateCreated&dateCompare[]=&';">
				</form>
			</td>
			<td align="center">
				<form>
					{$smarty.const.TRANS_SELECT_LEDGER_DATE} <input class="button" type="button" id="accountsReceivableLedgerCal" value=" ... " /><br />
                    <input class="button" type="button" value="{$smarty.const.TRANS_TODAYS_LEDGER}" onclick="document.location.href='accounting.php?action={getActionID action="ShowAccountsReceivableLedger"}&dateQuery[]={$today}&sid={$sid}&dateColumn=generalLedgerDateCreated&dateCompare[]=&';">
				</form>
			</td>
		</tr>
		{* row 2 *}
		<tr class="althover">
			<th width="50%">{$smarty.const.TRANS_ACCOUNTS_PAYABLE_LEDGER}</th>
			<th width="50%">{$smarty.const.TRANS_TAX_PAYABLE_LEDGER}</th>
		</tr>
		<tr class="alt2">
			<td valign="top">{$smarty.const.TRANS_ACCOUNTS_PAYABLE_LEDGER_DESC}</td>
			<td valign="top">{$smarty.const.TRANS_TAX_PAYABLE_LEDGER_DESC}</td>
		</tr>
		<tr class="alt1">
			<td align="center">
				<form>
					{$smarty.const.TRANS_SELECT_LEDGER_DATE} <input class="button" type="button" id="accountsPayableLedgerCal" value=" ... " /><br />
                    <input class="button" type="button" value="{$smarty.const.TRANS_TODAYS_LEDGER}" onclick="document.location.href='accounting.php?action={getActionID action="ShowAccountsPayableLedger"}&dateQuery[]={$today}&sid={$sid}&dateColumn=generalLedgerDateCreated&dateCompare[]=&';">
				</form>
			</td>
			<td align="center">
				<form>
					{$smarty.const.TRANS_SELECT_LEDGER_DATE} <input class="button" type="button" id="taxPayableLedgerCal" value=" ... " /><br />
                    <input class="button" type="button" value="{$smarty.const.TRANS_TODAYS_LEDGER}" onclick="document.location.href='accounting.php?action={getActionID action="ShowTaxPayableLedger"}&dateQuery[]={$today}&sid={$sid}&dateColumn=generalLedgerDateCreated&dateCompare[]=&';">
				</form>
			</td>
		</tr>
		</table>
	</td>
</tr>
</table>

<script type="text/javascript">//<![CDATA[
{literal}
var startDate;
var endDate;
var callbacks = 0;

function resetDates() {
	startDate = endDate = null;
}

/*
* Given two dates (in seconds) find out if date1 is bigger, date2 is bigger or
* they're the same, taking only the dates, not the time into account.
* In other words, different times on the same date returns equal.
* returns -1 for date1 bigger, 1 for date2 is bigger 0 for equal
*/

function compareDatesOnly(date1, date2) {
	var year1 = date1.getYear();
	var year2 = date2.getYear();
	var month1 = date1.getMonth();
	var month2 = date2.getMonth();
	var day1 = date1.getDate();
	var day2 = date2.getDate();
	if (year1 > year2) {
		return -1;
	}
	if (year2 > year1) {
		return 1;
	}
	//years are equal
	if (month1 > month2) {
		return -1;
	}
	if (month2 > month1) {
		return 1;
	}
	//years and months are equal
	if (day1 > day2) {
		return -1;
	}
	if (day2 > day1) {
		return 1;
	}
	//days are equal
	return 0;
}

function disableDates(date) {
	var now = new Date();
	if (compareDatesOnly(now, date) > 0) {
		return (true);
	}
	//all other days are enabled
	return false;
}

function goGeneralLedger(cal) {
	if (cal.dateClicked) {
		{/literal}
		var url = "accounting.php?action={getActionID action="ShowGeneralLedger"}&dateQuery[]=" + cal.date.print("%m/%d/%Y") + "&sid={$sid}&dateColumn=generalLedgerDateCreated&dateCompare[]=&";
		{literal}
		window.location = url;
	}
}

function goAccountsReceivableLedger(cal) {
	if (cal.dateClicked) {
		{/literal}
		var url = "accounting.php?action={getActionID action="ShowAccountsReceivableLedger"}&dateQuery[]=" + cal.date.print("%m/%d/%Y") + "&sid={$sid}&dateColumn=generalLedgerDateCreated&dateCompare[]=&";
		{literal}
		window.location = url;
	}
}

function goAccountsPayableLedger(cal) {
	if (cal.dateClicked) {
		{/literal}
		var url = "accounting.php?action={getActionID action="ShowAccountsPayableLedger"}&dateQuery[]=" + cal.date.print("%m/%d/%Y") + "&sid={$sid}&dateColumn=generalLedgerDateCreated&dateCompare[]=&";
		{literal}
		window.location = url;
	}
}

function goTaxPayableLedger(cal) {
	if (cal.dateClicked) {
		{/literal}
		var url = "accounting.php?action={getActionID action="ShowTaxPayableLedger"}&dateQuery[]=" + cal.date.print("%m/%d/%Y") + "&sid={$sid}&dateColumn=generalLedgerDateCreated&dateCompare[]=&";
		{literal}
		window.location = url;
	}
}

Zapatec.Calendar.setup({
	weekNumbers       : false,
	showOthers        : false,
	showsTime         : false,
	timeFormat        : "12",
	step              : 2,
	range             : [1990.01, 2020.12],
	dateStatusFunc	  : disableDates,
	button            : "generalLedgerCal",
	onSelect          : goGeneralLedger
});

Zapatec.Calendar.setup({
	weekNumbers       : false,
	showOthers        : false,
	showsTime         : false,
	timeFormat        : "12",
	step              : 2,
	range             : [1990.01, 2020.12],
	dateStatusFunc	  : disableDates,
	button            : "accountsReceivableLedgerCal",
	onSelect          : goAccountsReceivableLedger
});

Zapatec.Calendar.setup({
	weekNumbers       : false,
	showOthers        : false,
	showsTime         : false,
	timeFormat        : "12",
	step              : 2,
	range             : [1990.01, 2020.12],
	dateStatusFunc	  : disableDates,
	button            : "accountsPayableLedgerCal",
	onSelect          : goAccountsPayableLedger
});

Zapatec.Calendar.setup({
	weekNumbers       : false,
	showOthers        : false,
	showsTime         : false,
	timeFormat        : "12",
	step              : 2,
	range             : [1990.01, 2020.12],
	dateStatusFunc	  : disableDates,
	button            : "taxPayableLedgerCal",
	onSelect          : goTaxPayableLedger
});

{/literal}
//]]></script>

{include file="$tplDirectory/footer.tpl"}