{* $Id: ShowPurchasesJournal.tpl,v 1.13 2006/03/22 00:48:06 kbailey Exp $
 * --------------------------------------------------------------
 * This template displays the daily purchases journal.
 *
 * Smarty Variables:
 *	$purchasesJournal (array of journal entries)
 *		purchaseJournalID
 *		clientID
 *		invoiceID
 *		purchaseDateCreated
 *		purchaseDescription
 *		purchaseDebitAmount
 *		purchaseAccPayDebitAmount
 *		purchaseAccPayCreditAmount
 *		purchaseCashCreditAmount
 *	$purchasesJournalTotals (array of this pages totals)
 *		purchaseDebitAmount
 *		purchaseAccPayDebitAmount
 *		purchaseAccPayCreditAmount
 *		purchaseCashCreditAmount
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_ACCOUNTING" d="Accounting"}
{t c="TRANS_ACCOUNTS_RECEIVABLE" d="Accounts Receivable"}
{t c="TRANS_ACCOUNTS_PAYABLE" d="Accounts Payable"}
{t c="TRANS_AR_CREDIT" d="Accounts Receivable Credit"}
{t c="TRANS_AR_DEBIT" d="Accounts Receivable Debit"}
{t c="TRANS_DEBIT" d="Debit"}
{t c="TRANS_CASH_CREDIT" d="Cash Credit"}
{t c="TRANS_CREDIT" d="Credit"}
{t c="TRANS_DATE" d="Date"}
{t c="TRANS_DESCRIPTION" d="Description"}
{t c="TRANS_INVOICE" d="Invoice"}
{t c="TRANS_PURCHASE_DEBIT" d="Purchase Debit"}
{t c="TRANS_PURCHASES_JOURNAL" d="Purchases Journal"}
{t c="TRANS_SALES_CREDIT" d="Sales Credit"}
{t c="TRANS_LEDGER_ACCOUNTS" d="Ledger Accounts"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_TAX_CREDIT" d="Tax Credit"}
{t c="TRANS_PURCHASES_JOURNAL" d="Purchases Journal"}
{t c="TRANS_PURCHASES_JOURNAL_DESC" d="All daily cash disbursements are recorded in the purchases journal."}
{t c="TRANS_CURRENCY" d="Currency"}
{t c="TRANS_NO_PURCHASES_MATCH_QUERY" d="No purchases match your query."}
{t c="TRANS_CUSTOMER_CREDITS" d="Client Credits"}
{t c="TRANS_PURCHASE" d="Purchase"}
{t c="TRANS_CASH_STRING" d="Cash"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_FINANCES"
	childName="TRANS_ACCOUNTING"
	grandchildName="TRANS_PURCHASES_JOURNAL"
	sideNavMajor="finances"
	sideNavMinor="accounting"}

<table width="97%" border="0" cellspacing="0" cellpadding="0" class="tab07">
<tr>
    <td>
        <table  width="100%" border="0" cellpadding="0" cellspacing="3" class="tab01">
        <tr class="althover">
            <th width="50%">{$smarty.const.TRANS_PURCHASES_JOURNAL}</th>
        </tr>
        <tr class="alt2">
            <td valign="top">{$smarty.const.TRANS_PURCHASES_JOURNAL_DESC}</td>
        </tr>
        <tr class="alt1">
            <td align="center" valign="top">
                <form>
                    {$smarty.const.TRANS_SELECT_JOURNAL_DATE} <input class="button" type="button" id="purchasesJournalCal" value=" ... " />
                </form>
                <br />
            </td>
        </tr>
        </table>
    </td>
</tr>
<tr>
	<td>

{foreach key="currencyID" item="purchasesJournal" from=$currencies}
    {assign var="purchasesJournalTotals" value=$currencies_totals.$currencyID}
    <h2>{$smarty.const.TRANS_CURRENCY}: {$currencyID}</h2>
		<table width="100%" cellpadding="4" class="ledger">
			<tr>
				<th colspan="2">&nbsp;</th>
				<th>&nbsp;</th>
                <th colspan="2">{$smarty.const.TRANS_PURCHASE}</th>
                <th colspan="2">{$smarty.const.TRANS_ACCOUNTS_PAYABLE}</th>
                <th colspan="2">{$smarty.const.TRANS_CASH_STRING}</th>
			</tr>
			<tr>
				<th class="green">{$smarty.const.TRANS_DATE}</th>
				<th>{$smarty.const.TRANS_INVOICE}</th>
				<th>{$smarty.const.TRANS_DESCRIPTION}</th>
                <th class="green">{$smarty.const.TRANS_DEBIT}</th>
                <th>{$smarty.const.TRANS_CREDIT}</th>
                <th class="green">{$smarty.const.TRANS_DEBIT}</th>
                <th>{$smarty.const.TRANS_CREDIT}</th>
                <th class="green">{$smarty.const.TRANS_DEBIT}</th>
                <th>{$smarty.const.TRANS_CREDIT}</th>
			</tr>
			{section name="i" loop=$purchasesJournal}
				{if $smarty.section.i.iteration==1}
					{assign var="class" value="first"}
				{else}
					{assign var="class" value=""}
				{/if}
				<tr class="{$class}">
					<td class="green" align="center">{$purchasesJournal[i].purchaseDateCreated|getDate}</td>
					<td align="right">{$purchasesJournal[i].invoiceID}</td>
					<td>{$purchasesJournal[i].purchaseDescription}</td>
                    <td class="divider" align="right">{$purchasesJournal[i].purchaseDebitAmount|getAmount:$currencyID:false}</td>
                    <td align="right">{$purchasesJournal[i].purchaseCreditAmount|getAmount:$currencyID:false}</td>
					<td class="divider" align="right">{$purchasesJournal[i].purchaseAccPayDebitAmount|getAmount:$currencyID:false}</td>
					<td align="right">{$purchasesJournal[i].purchaseAccPayCreditAmount|getAmount:$currencyID:false}</td>
                    <td class="divider" align="right">{$purchasesJournal[i].purchaseCashDebitAmount|getAmount:$currencyID:false}</td>
                    <td align="right">{$purchasesJournal[i].purchaseCashCreditAmount|getAmount:$currencyID:false}</td>
				</tr>
			{/section}
			<tr class="total">
				<td width="10%" class="green">&nbsp;</td>
				<td width="5%">&nbsp;</td>
				<td width="40%">&nbsp;</td>
                <td width="10%" class="divider" align="right"><strong>{$purchasesJournalTotals.purchaseDebitAmount|getAmount:$currencyID:false}</strong></td>
                <td width="10%" align="right"><strong>{$purchasesJournalTotals.purchaseCreditAmount|getAmount:$currencyID:false}</strong></td>
				<td width="10%" class="divider" align="right"><strong>{$purchasesJournalTotals.purchaseAccPayDebitAmount|getAmount:$currencyID:false}</strong></td>
				<td width="10%" align="right"><strong>{$purchasesJournalTotals.purchaseAccPayCreditAmount|getAmount:$currencyID:false}</strong></td>
                <td width="10%" class="divider" align="right"><strong>{$purchasesJournalTotals.purchaseCashDebitAmount|getAmount:$currencyID:false}</strong></td>
                <td width="10%" align="right"><strong>{$purchasesJournalTotals.purchaseCashCreditAmount|getAmount:$currencyID:false}</strong></td>
			</tr>
		</table>
{foreachelse}
    {$smarty.const.TRANS_NO_PURCHASES_MATCH_QUERY}
{/foreach}

        {include file="$tplDirectory/widgets/paginationLinks.tpl"}


	</td>
</tr>
</table>


<script type="text/javascript">//<![CDATA[
{literal}
var startDate;
var endDate;
var callbacks = 0;

function resetDates() {
    startDate = endDate = null;
}

/*
* Given two dates (in seconds) find out if date1 is bigger, date2 is bigger or
* they're the same, taking only the dates, not the time into account.
* In other words, different times on the same date returns equal.
* returns -1 for date1 bigger, 1 for date2 is bigger 0 for equal
*/

function compareDatesOnly(date1, date2) {
    var year1 = date1.getYear();
    var year2 = date2.getYear();
    var month1 = date1.getMonth();
    var month2 = date2.getMonth();
    var day1 = date1.getDate();
    var day2 = date2.getDate();
    if (year1 > year2) {
        return -1;
    }
    if (year2 > year1) {
        return 1;
    }
    //years are equal
    if (month1 > month2) {
        return -1;
    }
    if (month2 > month1) {
        return 1;
    }
    //years and months are equal
    if (day1 > day2) {
        return -1;
    }
    if (day2 > day1) {
        return 1;
    }
    //days are equal
    return 0;
}

function disableDates(date) {
    var now = new Date();
    if (compareDatesOnly(now, date) > 0) {
        return (true);
    }
    //all other days are enabled
    return false;
}



function goPurchasesJournal(cal) {
    if (cal.dateClicked) {
        {/literal}
        var url = "accounting.php?action={getActionID action="ShowPurchasesJournal"}&dateQuery[]=" + cal.date.print("%Y/%m/%d/") + "&sid={$sid}";
        {literal}
        window.location = url;
    }
}


Zapatec.Calendar.setup({
    weekNumbers       : false,
    showOthers        : false,
    showsTime         : false,
    timeFormat        : "12",
    step              : 2,
    range             : [1990.01, 2020.12],
    dateStatusFunc      : disableDates,
    button            : "purchasesJournalCal",
    onSelect          : goPurchasesJournal
});

{/literal}
//]]></script>

{include file="$tplDirectory/footer.tpl"}