{* $Id: AddClient.tpl,v 1.28 2006/06/19 21:48:57 mgarrett Exp $
 * --------------------------------------------------------------
 * This template displays a form to add a new client.
 *
 * Smarty Variables:
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_CLIENTS" d="Clients"}
{t c="TRANS_MANAGE_CLIENTS" d="Manage Clients"}
{t c="TRANS_ADD" d="Add"}
{t c="TRANS_ADD_CLIENT" d="Add Client"}
{t c="TRANS_FIRST_NAME" d="First Name"}
{t c="TRANS_LAST_NAME" d="Last Name"}
{t c="TRANS_EMAIL" d="Email"}
{t c="TRANS_COMPANY" d="Company"}
{t c="TRANS_BILLING_METHOD" d="Billing Method"}
{t c="TRANS_STATUS" d="Status"}
{t c="TRANS_USERNAME" d="Username"}
{t c="TRANS_ACTIVE" d="Active"}
{t c="TRANS_PASSWORD" d="New Password"}
{t c="TRANS_CONFIRM_PASSWORD" d="Confirm Password"}
{t c="TRANS_TAX_ID_NUMBER" d="Tax ID Number"}
{t c="TRANS_APPLY" d="Apply"}
{t c="TRANS_TAX" d="Tax"}
{t c="TRANS_ACCOUNT" d="Account"}
{t c="TRANS_PERSONAL" d="Personal"}
{t c="TRANS_BILLING" d="Billing"}
{t c="TRANS_RESET" d="Reset"}
{t c="TRANS_LANGUAGE" d="Language"}
{t c="TRANS_COUNTRY" d="Country"}
{t c="TRANS_THEME" d="Theme"}
{t c="TRANS_ADDRESS" d="Street Address"}
{t c="TRANS_ADDRESS2" d="Suite/Apartment"}
{t c="TRANS_CITY" d="City"}
{t c="TRANS_STATE" d="State"}
{t c="TRANS_ZIP" d="Zip"}
{t c="TRANS_PRIMARY_PHONE" d="Primary Phone"}
{t c="TRANS_SECONDARY_PHONE" d="Secondary Phone"}
{t c="TRANS_FAX" d="Fax"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName="TRANS_CLIENTS"
	grandchildName="TRANS_ADD"
	sideNavMajor="clients"
	sideNavMinor="clients"}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

<form method="post" action="clients.php">
<input type="hidden" name="action" value="{getActionID action="AddClientResponse"}" />
<input type="hidden" name="sid" value="{$sid}" />

<table  width="770" border="0" cellpadding="0" cellspacing="3" class="tab01" >
<tbody>
<tr>
	<th scope="col" colspan="2">{$smarty.const.TRANS_ACCOUNT}</th>
</tr>
<tr class="{if $invalid.contactUsername}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactUsername">{$smarty.const.TRANS_USERNAME}</label></th>
	<td width="100%"><input size="20" maxlength="20" type="text" id="contactUsername" name="contactUsername" value="{$formValues.contactUsername}" /> {$invalid.contactUsername}</td>
</tr>
<tr class="{if $invalid.contactPassword}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactPassword">{$smarty.const.TRANS_PASSWORD}</label></th>
	<td width="100%"><input size="32" maxlength="32" type="password" id="contactPassword" name="contactPassword" value="" /> {$invalid.contactPassword}</td>
</tr>
<tr class="{if $invalid.contactPasswordConfirm}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactPasswordConfirm">{$smarty.const.TRANS_CONFIRM_PASSWORD}</label></th>
	<td width="100%"><input size="32" maxlength="32" type="password" id="contactPasswordConfirm" name="contactPasswordConfirm" value="" /> {$invalid.contactPasswordConfirm}</td>
</tr>
<tr class="{if $invalid.clientActive}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="clientActive">{$smarty.const.TRANS_ACTIVE}</label></th>
	<td width="100%">
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="clientActive" value="0">
		<input type="checkbox" id="clientActive" name="clientActive" value="1" {if $formValues.clientActive}checked="checked" {/if}/> <label for="clientActive">{$smarty.const.TRANS_ACTIVE}</label>
 		{$invalid.clientActive}
	</td>
</tr>
<tr class="{if $invalid.themeID}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="themeID">{$smarty.const.TRANS_THEME}</label></th>
	<td width="100%"><select id="themeID" name="themeID"> {html_options options=$themeList selected=$formValues.themeID} </select> {$invalid.themeID}</td>
</tr>
<tr>
	<th scope="col" colspan="2">{$smarty.const.TRANS_PERSONAL}</th>
</tr>
<tr class="{if $invalid.contactFirstName}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactFirstName">{$smarty.const.TRANS_FIRST_NAME}</label></th>
	<td width="100%"><input size="50" maxlength="50" type="text" id="contactFirstName" name="contactFirstName" value="{$formValues.contactFirstName}" /> {$invalid.contactFirstName}</td>
</tr>
<tr class="{if $invalid.contactLastName}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactLastName">{$smarty.const.TRANS_LAST_NAME}</label></th>
	<td width="100%"><input size="50" maxlength="50" type="text" id="contactLastName" name="contactLastName" value="{$formValues.contactLastName}" /> {$invalid.contactLastName}</td>
</tr>
<tr class="{if $invalid.contactEmail}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactEmail">{$smarty.const.TRANS_EMAIL}</label></th>
	<td width="100%"><input size="100" maxlength="100" type="text" id="contactEmail" name="contactEmail" value="{$formValues.contactEmail}" /> {$invalid.contactEmail}</td>
</tr>
<tr class="{if $invalid.languageID}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="languageID">{$smarty.const.TRANS_LANGUAGE}</label></th>
	<td width="100%"><select id="languageID" name="languageID"> {html_options options=$languageList selected=$formValues.languageID} </select> {$invalid.languageID}</td>
</tr>
<tr class="{if $invalid.contactAddress1}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactAddress1">{$smarty.const.TRANS_ADDRESS}</label></th>
	<td width="100%"><input size="100" maxlength="100" type="text" id="contactAddress1" name="contactAddress1" value="{$formValues.contactAddress1}" /> {$invalid.contactAddress1}</td>
</tr>
<tr class="{if $invalid.contactAddress2}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactAddress2">{$smarty.const.TRANS_ADDRESS2}</label></th>
	<td width="100%"><input size="100" maxlength="100" type="text" id="contactAddress2" name="contactAddress2" value="{$formValues.contactAddress2}" /> {$invalid.contactAddress2}</td>
</tr>
<tr class="{if $invalid.contactCity}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactCity">{$smarty.const.TRANS_CITY}</label></th>
	<td width="100%"><input size="100" maxlength="100" type="text" id="contactCity" name="contactCity" value="{$formValues.contactCity}" /> {$invalid.contactCity}</td>
</tr>
<tr class="{if $invalid.contactState}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactState">{$smarty.const.TRANS_STATE}</label></th>
	<td width="100%"><input size="25" maxlength="100" type="text" id="contactState" name="contactState" value="{$formValues.contactState}" /> {$invalid.contactState}</td>
</tr>
<tr class="{if $invalid.contactZip}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactZip">{$smarty.const.TRANS_ZIP}</label></th>
	<td width="100%"><input size="25" maxlength="100" type="text" id="contactZip" name="contactZip" value="{$formValues.contactZip}" /> {$invalid.contactZip}</td>
</tr>
<tr class="{if $invalid.countriesID}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="countriesID">{$smarty.const.TRANS_COUNTRY}</label></th>
	<td width="100%"><select id="countriesID" name="countriesID"> {html_options options=$countryList selected=$formValues.countriesID} </select> {$invalid.countriesID}</td>
</tr>
<tr class="{if $invalid.contactPhone1}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactPhone1">{$smarty.const.TRANS_PRIMARY_PHONE}</label></th>
	<td width="100%"><input size="25" maxlength="25" type="text" id="contactPhone1" name="contactPhone1" value="{$formValues.contactPhone1}" /> {$invalid.contactPhone1}</td>
</tr>
<tr class="{if $invalid.contactPhone2}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactPhone2">{$smarty.const.TRANS_SECONDARY_PHONE}</label></th>
	<td width="100%"><input size="25" maxlength="25" type="text" id="contactPhone2" name="contactPhone2" value="{$formValues.contactPhone2}" /> {$invalid.contactPhone2}</td>
</tr>
<tr class="{if $invalid.contactFax}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactFax">{$smarty.const.TRANS_FAX}</label></th>
	<td width="100%"><input size="25" maxlength="25" type="text" id="contactFax" name="contactFax" value="{$formValues.contactFax}" /> {$invalid.contactFax}</td>
</tr>
<tr>
	<th scope="col" colspan="2">{$smarty.const.TRANS_BILLING}</th>
</tr>
<tr class="{if $invalid.clientCompany}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="clientCompany">{$smarty.const.TRANS_COMPANY}</label></th>
	<td width="100%"><input size="100" maxlength="100" type="text" id="clientCompany" name="clientCompany" value="{$formValues.clientCompany}" /> {$invalid.clientCompany}</td>
</tr>
<tr class="{if $invalid.applyTax}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="applyTax">{$smarty.const.TRANS_TAX}</label></th>
	<td width="100%">
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="applyTax" value="0" />
		<input type="checkbox" id="applyTax" name="applyTax" value="1" {if $formValues.clientActive}checked="checked" {/if}/> <label for="applyTax">{$smarty.const.TRANS_APPLY}</label>
		{$invalid.applyTax}
	</td>
</tr>
<tr class="{if $invalid.taxIDNumber}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="taxIDNumber">{$smarty.const.TRANS_TAX_ID_NUMBER}</label></th>
	<td width="100%"><input size="50" maxlength="50" id="taxIDNumber" type="text" name="taxIDNumber" value="{$formValues.taxIDNumber}" /> {$invalid.taxIDNumber}</td>
</tr>
<tr>
	<td colspan="2">
		<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_ADD_CLIENT}" />
{*		<input class="reset" type="reset" value="{$smarty.const.TRANS_RESET}" /> *}
	</td>
</tr>
</tbody>
</table>
</form>

{include file="$tplDirectory/footer.tpl"}