{* $Id: AddClientContact.tpl,v 1.25 2006/06/07 18:25:37 achrist Exp $
 * --------------------------------------------------------------
 * This template displays a form to add a new client contact.
 *
 * Smarty Variables:
 * $formValues				Array of default form values
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}

{t c="TRANS_EMAIL_FORMAT" d="Email Format"}
{t c="TRANS_HTML" d="HTML"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName="TRANS_CONTACTS"
	grandchildName="TRANS_ADD"
	sideNavMajor="clients"
	sideNavMinor="clients"}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

{include file="$tplDirectory/widgets/context/client.tpl" client=$client}

<form method="post" action="clients.php">
<input type="hidden" name="action" value="{getActionID action="AddClientContactResponse"}">
<input type="hidden" name="clientID" value="{$client.clientID}">
<input type="hidden" name="sid" value="{$sid}">

<table  width="770" border="0" cellpadding="0" cellspacing="3" class="tab01" >
<tbody>
<tr>
	<th scope="col" colspan="2">{$smarty.const.TRANS_CONTACT}</th>
</tr>
<tr class="{if $invalid.contactFirstName}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactFirstName">{$smarty.const.TRANS_FIRST_NAME}</label></th>
	<td width="100%"><input size="50" maxlength="50" type="text" id="contactFirstName" name="contactFirstName" value="{$formValues.contactFirstName}" /> {$invalid.contactFirstName}</td>
</tr>
<tr class="{if $invalid.contactLastName}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactLastName">{$smarty.const.TRANS_LAST_NAME}</label></th>
	<td width="100%"><input size="50" maxlength="50" type="text" id="contactLastName" name="contactLastName" value="{$formValues.contactLastName}" /> {$invalid.contactLastName}</td>
</tr>
<tr class="{if $invalid.contactUsername}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactUsername">{$smarty.const.TRANS_USERNAME}</label></th>
	<td width="100%"><input size="20" maxlength="20" type="text" id="contactUsername" name="contactUsername" value="{$formValues.contactUsername}" /> {$invalid.contactUsername}</td>
</tr>
<tr class="{if $invalid.contactActive}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="clientActive">{$smarty.const.TRANS_ACTIVE}</label></th>
	<td width="100%">
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="contactActive" value="0">
		<input type="checkbox" id="contactActive" name="contactActive" value="1" {if $formValues.contactActive}checked="checked" {/if}/> <label for="contactActive">{$smarty.const.TRANS_ACTIVE}</label>
 		{$invalid.contactActive}
	</td>
</tr>
<tr class="{if $invalid.contactPassword}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactPassword">{$smarty.const.TRANS_PASSWORD}</label></th>
	<td width="100%"><input size="32" maxlength="32" type="password" id="contactPassword" name="contactPassword" value="" /> {$invalid.contactPassword}</td>
</tr>
<tr class="{if $invalid.contactPasswordConfirm}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactPasswordConfirm">{$smarty.const.TRANS_CONFIRM_PASSWORD}</label></th>
	<td width="100%"><input size="32" maxlength="32" type="password" id="contactPasswordConfirm" name="contactPasswordConfirm" value="" /> {$invalid.contactPasswordConfirm}</td>
</tr>
<tr class="{if $invalid.contactEmail}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactEmail">{$smarty.const.TRANS_EMAIL}</label></th>
	<td width="100%"><input size="100" maxlength="100" type="text" id="contactEmail" name="contactEmail" value="{$formValues.contactEmail}" /> {$invalid.contactEmail}</td>
</tr>
<tr class="{if $invalid.contactEmailFormat}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactEmailFormat">{$smarty.const.TRANS_EMAIL_FORMAT}</label></th>
	<td width="100%">
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="contactEmailFormat" value="0">
		{if $invalid}{assign var="isinvalid" value="1"}{else}{assign var="isinvalid" value="0"}{/if}
		<input type="checkbox" id="contactEmailFormat" name="contactEmailFormat" value="1" {if $formValues.contactEmailFormat}checked="checked" {/if}/> <label for="contactEmailFormat">{$smarty.const.TRANS_HTML}</label>
 		{$invalid.contactEmailFormat}
	</td>
</tr>
<tr class="{if $invalid.contactCompany}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactCompany">{$smarty.const.TRANS_COMPANY}</label></th>
	<td width="100%"><input size="100" maxlength="100" type="text" id="contactCompany" name="contactCompany" value="{$formValues.contactCompany}" /> {$invalid.contactCompany}</td>
</tr>
<tr class="{if $invalid.contactAddress1}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactAddress1">{$smarty.const.TRANS_ADDRESS}</label></th>
	<td width="100%"><input size="100" maxlength="100" type="text" id="contactAddress1" name="contactAddress1" value="{$formValues.contactAddress1}" /> {$invalid.contactAddress1}</td>
</tr>
<tr class="{if $invalid.contactAddress2}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactAddress2">{$smarty.const.TRANS_ADDRESS2}</label></th>
	<td width="100%"><input size="100" maxlength="100" type="text" id="contactAddress2" name="contactAddress2" value="{$formValues.contactAddress2}" /> {$invalid.contactAddress2}</td>
</tr>
<tr class="{if $invalid.contactCity}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactCity">{$smarty.const.TRANS_CITY}</label></th>
	<td width="100%"><input size="100" maxlength="100" type="text" id="contactCity" name="contactCity" value="{$formValues.contactCity}" /> {$invalid.contactCity}</td>
</tr>
<tr class="{if $invalid.contactState}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactState">{$smarty.const.TRANS_STATE}</label></th>
	<td width="100%"><input size="25" maxlength="100" type="text" id="contactState" name="contactState" value="{$formValues.contactState}" /> {$invalid.contactState}</td>
</tr>
<tr class="{if $invalid.contactZip}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactZip">{$smarty.const.TRANS_ZIP}</label></th>
	<td width="100%"><input size="25" maxlength="100" type="text" id="contactZip" name="contactZip" value="{$formValues.contactZip}" /> {$invalid.contactZip}</td>
</tr>
<tr class="{if $invalid.countriesID}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="countriesID">{$smarty.const.TRANS_COUNTRY}</label></th>
	<td width="100%"><select id="countriesID" id="countriesID" name="countriesID"> {html_options options=$countryList selected=$formValues.countriesID} </select> {$invalid.countriesID}</td>
</tr>
<tr class="{if $invalid.countriesID}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="languageID">{$smarty.const.TRANS_LANGUAGE}</label></th>
	<td width="100%"><select id="languageID" id="languageID" name="languageID"> {html_options options=$languageList selected=$formValues.languageID} </select> {$invalid.languageID}</td>
</tr>
<tr class="{if $invalid.contactPhone1}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactPhone1">{$smarty.const.TRANS_PRIMARY_PHONE}</label></th>
	<td width="100%"><input size="25" maxlength="25" type="text" id="contactPhone1" name="contactPhone1" value="{$formValues.contactPhone1}" /> {$invalid.contactPhone1}</td>
</tr>
<tr class="{if $invalid.contactPhone2}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactPhone2">{$smarty.const.TRANS_SECONDARY_PHONE}</label></th>
	<td width="100%"><input size="25" maxlength="25" type="text" id="contactPhone2" name="contactPhone2" value="{$formValues.contactPhone2}" /> {$invalid.contactPhone2}</td>
</tr>
<tr class="{if $invalid.contactFax}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactFax">{$smarty.const.TRANS_FAX}</label></th>
	<td width="100%"><input size="25" maxlength="25" type="text" id="contactFax" name="contactFax" value="{$formValues.contactFax}" /> {$invalid.contactFax}</td>
</tr>
<tr class="{if $invalid.contactPrimary}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="contactPrimary">{$smarty.const.TRANS_PRIMARY}</label></th>
	<td width="100%">
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="contactPrimary" value="0">
		{if $invalid}{assign var="isinvalid" value="1"}{else}{assign var="isinvalid" value="0"}{/if}
		<input type="checkbox" id="contactPrimary" name="contactPrimary" value="1" {if $formValues.contactPrimary}checked="checked" {/if}/> <label for="contactPrimary">{$smarty.const.TRANS_SET_PRIMARY}</label>
 		{$invalid.contactPrimary}
	</td>
</tr>
<tr class="{cycle values="alt1,alt2"}">
	<th class="nowrap" scope="row"><label for="emailActions">{$smarty.const.TRANS_EMAIL_ACTIONS}</label></th>
	<td width="100%">
		{html_checkboxes name="emailActionIDs" options=$emailActions separator="<br />"}
	</td>
</tr>
<tr>
	<td colspan="2">
		<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_ADD_CONTACT}" />
{*		<input class="reset" type="reset" value="{$smarty.const.TRANS_RESET}" /> *}
	</td>
</tr>

</table>

</form>

{include file="$tplDirectory/footer.tpl"}
