{* $Id: ManageClientNotes.tpl,v 1.7 2006/03/22 00:48:06 kbailey Exp $
 * --------------------------------------------------------------
 * This template displays a form to add a new client contact.
 *
 * Smarty Variables:
 * $formValues				Array of default form values
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_CLIENTS" d="Clients"}
{t c="TRANS_NOTES" d="Notes"}
{t c="TRANS_NOTE_MESG" d="Note message"}
{t c="TRANS_MANAGE_CLIENTS" d="Manage Clients"}
{t c="TRANS_ADD" d="Add"}
{t c="TRANS_ADD_NOTE" d="Add Note"}
{t c="TRANS_RESET" d="Reset"}
{t c="TRANS_NOTE" d="Note"}
{t c="TRANS_CLIENT" d="Client"}
{t c="TRANS_CLIENTID" d="Client ID"}
{t c="TRANS_CLIENT_USERNAME" d="Client Username"}
{t c="TRANS_CLIENT_FIRSTNAME" d="Client First Name"}
{t c="TRANS_CLIENT_LASTNAME" d="Client Last Name"}
{t c="TRANS_CLIENT_CONTACTID" d="Client Contact ID"}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_DETAILS" d="Details"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_EDIT_NOTE" d="Edit Note"}
{t c="TRANS_REMOVE" d="Remove"}
{t c="TRANS_MODIFIED" d="Modified"}
{t c="TRANS_DELETE_MESG" d="Are you sure you want to delete this note?"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName="TRANS_NOTES"
	grandchildName="TRANS_ADD"
	sideNavMajor="clients"
	sideNavMinor="clients"}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

{include file="$tplDirectory/widgets/context/client.tpl" client=$client}
<br />

{assign var="clientID" value=$client.clientID}

<table  width="770" border="0" cellpadding="0" cellspacing="3" class="tab01" >
<tr>
	<th scope="col" colspan="2">{$smarty.const.TRANS_NOTES}</th>
</tr>
</table>
<hr />
{section name="j" loop=$noteList}
{assign var="note" value=$noteList[j]}
{assign var="clientNoteID" value=$note.clientNoteID}
<a id="n{$clientNoteID}"></a>
<!--[if lt IE 7]>
<a name="n{$clientNoteID}"></a>
<![endif]-->
{include file="$tplDirectory/widgets/context/admin.tpl" admin=$note}
<table  width="770" border="0" cellpadding="0" cellspacing="3" class="tab01" >
<tr class="{if $editNote && $editNote.clientNoteID == $clientNoteID && $invalid.clientNoteText}highlight{else}alt2{/if}">
	<td>
		<div class="floatright" style="border-width: 0 0 1px 1px; border-style: outset; padding: 0 0 0 .25em; margin: 0 0 0 .25em;">
			{$note.clientNoteDateCreated|getDateTime:full}
			{strip}
			<a href="{getHREF page="clients.php" actionName="ManageClientNotes" args="clientID=$clientID&clientNoteID=$clientNoteID"}#n{$clientNoteID}">
				<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
			</a>
			&nbsp;
			{include file="$tplDirectory/widgets/quickDeleteLink.tpl" deleteActionName="RemoveNoteResponse" deleteMesg="TRANS_DELETE_MESG" deleteColumn="clientNoteID" deleteID="$clientNoteID"}
			{*
			<a href="{getHREF page="clients.php" actionName="ManageClientNotes" args="clientID=$clientID&clientNoteID=$clientNoteID&remove=1"}#n{$clientNoteID}">
				<img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_REMOVE}" title="{$smarty.const.TRANS_REMOVE}" />
			</a>
			*}
			{/strip}
		</div>
		{if $editNote && $editNote.clientNoteID == $clientNoteID}
		<form method="post" action="clients.php">
			<input type="hidden" name="action" value="{getActionID action="ManageClientNotesResponse"}" />
			<input type="hidden" name="clientID" value="{$clientID}" />
			<input type="hidden" name="clientNoteID" value="{$clientNoteID}" />
			<input type="hidden" name="sid" value="{$sid}" />
			<textarea cols="80" rows="4" id="clientNoteText" name="clientNoteText">{$formValues.clientNoteText}</textarea> {$invalid.clientNoteText}
			<br />
			<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_EDIT_NOTE}" />
	{*		<input class="reset" type="reset" value="{$smarty.const.TRANS_RESET}" /> *}
		</form>
		{else}
			{$note.clientNoteText|nl2br}
		{/if}
		{if $note.clientNoteDateModified}
			<hr />
			{$smarty.const.TRANS_MODIFIED}: {$note.clientNoteDateModified|getDateTime:full}
		{/if}
	</td>
</tr>
</table>
<hr class="clearright" />
{sectionelse}
{/section}	

<form method="post" action="clients.php">
	<input type="hidden" name="action" value="{getActionID action="ManageClientNotesResponse"}" />
	<input type="hidden" name="clientID" value="{$clientID}" />
	<input type="hidden" name="sid" value="{$sid}" />

<table  width="770" border="0" cellpadding="0" cellspacing="3" class="tab01" >
<tbody>
<tr>
	<th scope="col" colspan="2">{$smarty.const.TRANS_ADD_NOTE}</th>
</tr>
<tr class="{if !$editNote && $invalid.clientNoteText}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="clientNoteText">{$smarty.const.TRANS_NOTE_MESG}</label></th>
	<td width="100%"><textarea cols="80" rows="10" id="clientNoteText" name="clientNoteText">{if !$editNote}{$formValues.clientNoteText}{/if}</textarea> {$invalid.clientNoteText}</td>
</tr>
<tr>
	<td colspan="2">
			<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_ADD_NOTE}" />
	{*		<input class="reset" type="reset" value="{$smarty.const.TRANS_RESET}" /> *}
	</td>
</tr>

</table>

</form>

{include file="$tplDirectory/footer.tpl"}