{* $Id: ShowClientDetails.tpl,v 1.49 2006/07/21 19:51:42 bsmith Exp $
 * --------------------------------------------------------------
 * This template displays a single client record and a summary of all client information.
 *
 * Smarty Variables:
 *	$client (array of client information that matches input criteria)
 *		clientID
 *		clientFirstName
 *		clientLastName
 *		clientEmail
 *		clientCompany
 *		clientBillingMethod
 *		clientComments
 *		clientStatus
 *		contactUsername
 *		applyTax
 *		taxIDNumber
 *		languageID
 *		countriesID
 *		themeID
 *		clientActive
 *		clientDateCreated
 *	$contacts (array of all client contacts for this client)
 *		clientContactID
 *		clientID
 *		contactFirstName
 *		contactLastName
 *		contactEmail
 *		contactCompany
 *		contactAddress1
 *		contactAddress2
 *		contactCity
 *		contactState
 *		contactZip
 *		countriesID
 *		contactPhone1
 *		contactPhone2
 *		contactFax
 *		contactDateCreated
 *		contactPrimary
 *	$primaryContact (array of this clients' primary contact information)
 *		(same elements available as the $contacts array above)
 *  $packageStatuses (counted array of package statuses)
 *		0 = # NONE
 *		1 = # PENDING
 *		2 = # CANCELLED
 *		3 = # FRAUDULENT
 *		4 = # COLLECTIONS
 *		5 = # WORKINPROGRESS
 *		6 = # SUSPENDED
 *		7 = # FAILED
 *  $domainStatuses (counted array of domain statuses)
 *		0 = # NONE
 *		1 = # PENDING
 *		2 = # PENDINGRENEWAL
 *		3 = # EXPIRED
 *  $certStatuses (counted array of cert statuses)
 *		0 = # NONE
 *		1 = # STARTED
 *		2 = # SUBMITTED
 *		3 = # COMPLETED
 *		4 = # CANCELED
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_LOGIN_CLIENT_AREA" d="Login to Client Area"}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName="TRANS_SHOW_CLIENT_SUMMARY"
	sideNavMajor="clients"
	sideNavMinor="clients"
	useMenu="clients"}

{include file="$tplDirectory/widgets/context/client.tpl" client=$client}

<script language="JavaScript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/scriptaculous/lib/prototype.js"></script>
<script language="JavaScript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/scriptaculous/src/scriptaculous.js"></script>
<script language="JavaScript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/scriptaculous/src/unittest.js"></script>
<script language="javascript" type="text/javascript" charset="utf-8">
{literal}
function addPackage(e, qs){
    var curX = (ns6)?e.pageX : e.x+document.body.scrollLeft;
    var curY = (ns6)?e.pageY : e.y+document.body.scrollTop;

	document.getElementById('addPackageDiv').style.top = (curY-150)+"px";
	document.getElementById('addPackageDiv').style.left = (curX-200)+"px";

	addPackageUpdateCell(qs);
	showobjbyid('addPackageDiv');

}

var cp = new cpaint();
cp.set_transfer_mode('get');
cp.set_response_type('text');
//cp.set_debug(2);
{/literal}
var addPackageURL = 'packages.php?ajax=1&action={getActionID action="AddHistoricalPackage"}&sid={$sid}&clientID={$clientID}&';
var addPackageURLnoAjax = 'packages.php?action={getActionID action="AddHistoricalPackage"}&sid={$sid}&clientID={$clientID}&';

{literal}
function addPackageUpdateCell(qs) {
	setLoading('addPackageContentCell');

	var hitURL = addPackageURL+qs+"&"+Math.random();
	cp.call(hitURL, 'addPackageUpdateCell', addPackageUpdateCellResponse);
	return false;
}

function addPackageUpdateCellResponse(result) {
	if (result) {
		document.getElementById('addPackageContentCell').innerHTML = result;
	} else {
		{/literal}
		alert("{$smarty.const.TRANS_FAILED_TO_FETCH_CONTENT}");
		{literal}
	}
}

function addPackageEnd(qs) {
	setLoading('addPackageContentCell');

	var hitURL = addPackageURLnoAjax+qs+"&"+Math.random();
	document.location.href = hitURL;
}

function setLoading(x){
	if (typeof document.getElementById(x)!="undefined"){
		document.getElementById(x).innerHTML = "<img src='{/literal}{$imageDirectory}{literal}/loading2.gif' align='left' height='16' width='16' alt='{/literal}{$smarty.const.TRANS_LOADING}{literal}' /> &nbsp;&nbsp;<b>{/literal}{$smarty.const.TRANS_LOADING}{literal}</b>";
	}
}

{/literal}
</script>


<table  border="1" width="98%" cellpadding="0" cellspacing="12"  class="tab04">
<tr>
	<td width="30%">
		<h1 class="st01">{$smarty.const.TRANS_CLIENT_INFORMATION}</h1>

		<table width="98%"  border="0" cellspacing="2" cellpadding="0" class="tab05">
		<tr>
			<th scope="col" colspan="2"><h1>{$smarty.const.TRANS_ACCOUNT}</h1></th>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_ACTIVE}</th>
			<td>{if $client.clientActive}{$smarty.const.TRANS_YES}{else}{$smarty.const.TRANS_NO}{/if}</td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_STATUS}</th>
			<td>{$client.clientStatus|getStatusName:"client"}</td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_LANGUAGE}</th>
			<td>{$client.languageISO2} - {$client.languageName}</td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_COUNTRY}</th>
			<td>{$clientCountry}</td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_THEME}</th>
			{assign var="clientTheme" value=$client.themeID}
			<td>{$themeList.$clientTheme}</td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_GROUPS}</th>
			<td>
				{section name="group" loop=$clientGroups}
					{if $smarty.section.group.index > 0}, {/if}
					{$clientGroups[group].clientGroupName}
				{/section}
			</td>
		</tr>
		<tr>
			<th scope="col" colspan="2"><h1>{$smarty.const.TRANS_BILLING}</h1></th>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_COMPANY}</th>
			<td>{$client.clientCompany}</td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_TAX}</th>
			<td>{if $client.applyTax}{$smarty.const.TRANS_APPLIED}{else}{$smarty.const.TRANS_NOT_APPLIED}{/if}</td>
		</tr>
		{if $client.taxIDNumber}
		<tr>
			<th scope="row">{$smarty.const.TRANS_TAX_ID_NUMBER}</th>
			<td>{$client.taxIDNumber}</td>
		</tr>
		{/if}
		</table>
		<br />
		<!-- <div class="box06">
			&raquo;<a href="#">{$smarty.const.TRANS_LOGIN}</a>
			&nbsp;
			&raquo;<a href="clients.php?action={getActionID action="EditClient"}&clientID={$client.clientID}&sid={$sid}">{$smarty.const.TRANS_EDIT}</a>
			&nbsp;
			&raquo;<a href="#">{$smarty.const.TRANS_MERGE}</a>
			&nbsp;
			&raquo;<a href="#"><a href="clients.php?action={getActionID action="RemoveClient"}&clientID={$client.clientID}&sid={$sid}">{$smarty.const.TRANS_REMOVE}</a></a>
		</div> -->

		<table width="98%"  border="0" cellspacing="2" cellpadding="0" class="tab05">
		<tr>
			<th scope="col" colspan="2"><h1>{$smarty.const.TRANS_PRIMARY_CONTACT}</h1></th>
		</tr>
		<tr>
			<th scope="col" colspan="2">
				<a href="{getHREF page="clients.php" actionName="ForwardToClientInterface" args="clientID=`$client.clientID`&clientContactID=`$primaryContact.clientContactID`"}" target="_blank">
					{$smarty.const.TRANS_LOGIN_CLIENT_AREA}
				</a>
			</th>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_CONTACTID}</th>
			<td>{$primaryContact.clientContactID}</td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_FIRST_NAME}</th>
			<td>{$primaryContact.contactFirstName}</td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_LAST_NAME}</th>
			<td>{$primaryContact.contactLastName}</td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_EMAIL}</th>
			<td>
				<a href="{getHREF page="clients.php" actionName="SendClientEmail" args="clientID=$clientID"}">
				{$primaryContact.contactEmail}</a></td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_COMPANY}</th>
			<td>{$primaryContact.contactCompany}</td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_ADDRESS_1}</th>
			<td>{$primaryContact.contactAddress1}</td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_ADDRESS_2}</th>
			<td>{$primaryContact.contactAddress2}</td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_CITY}</th>
			<td>{$primaryContact.contactCity}</td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_STATE_OR_REGION}</th>
			<td>{$primaryContact.contactState}</td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_ZIP_OR_POSTALCODE}</th>
			<td>{$primaryContact.contactZip}</td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_COUNTRY}</th>
			<td>{$primaryContactCountry}</td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_PRIMARY_PHONE}</th>
			<td>{$primaryContact.contactPhone1}</td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_SECONDARY_PHONE}</th>
			<td>{$primaryContact.contactPhone2}</td>
		</tr>
		<tr>
			<th scope="row">{$smarty.const.TRANS_FAX}</th>
			<td>{$primaryContact.contactFax}</td>
		</tr>
		</table>

		<div class="box06">
			{assign var=p value=$primaryContact.clientContactID}
			<div class="rm"><a href="{getHREF page="clients.php" actionName="EditClientContact" args="clientContactID=$p"}"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" />{$smarty.const.TRANS_EDIT_PRIMARY}</a></div>
			{assign var=p value=$client.clientID}
			<div class="rm"><a href="{getHREF page="clients.php" actionName="AddClientContact" args="clientID=$p"}"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" />{$smarty.const.TRANS_ADD_NEW}</a></div>
			<div class="rm"><a href="{getHREF page="clients.php" actionName="ShowClientContacts" args="clientID=$p"}"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" />{$smarty.const.TRANS_SHOW_ALL}</a></div>
			<div style="clear:both"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" /></div>
		</div>

		<br />

	</td>
	<td width="30%">
		<h1 class="st03">{$smarty.const.TRANS_ACCOUNTING_INFORMATION}</h1>


		<div class="box07" align="center">
			<div class="st01" align="left"><h1>{$smarty.const.TRANS_CLIENT_ACCOUNTING_TOTALS}</h1></div>
            <br />
			<table width="90%" border="0" cellspacing="2" cellpadding="3" class="ledger">
            <tr>
                <th class="green" align="left">{$smarty.const.TRANS_ACCOUNTING_ACCOUNTS_LABEL}</th>
                <th align="right">{$smarty.const.TRANS_BALANCE}</th>
            </tr>

        {* accounts receivables rows *}

            {assign var="firstTime" value="1"}
            {assign var="rowClass" value="total"}
            {foreach key="currencyID" item="totals" from=$accountingAccountsReceivable}
                <tr class="{$rowClass}">
                    <td width="70%" align="left" class="green">
                        {if $firstTime}
                            {assign var="firstTime" value="0"}
                            {assign var="rowClass" value=""}
                            {assign var=p value=$client.clientID}
                            <strong><a href="{getHREF page="accounting.php" actionName="ShowAgingReport" args="reportParams[clientID]=$p"}">{$smarty.const.TRANS_CLIENT_ACCOUNTING_TOTALS_AR}</a></strong>
                        {/if}
                    </td>
                    <td width="40%" align="right"><strong>{$totals|getAmount:$currencyID}</strong></td>
                </tr>
            {foreachelse}
                <tr class="total">
                    <td width="60%" align="left" class="green">
                            <strong>{$smarty.const.TRANS_CLIENT_ACCOUNTING_TOTALS_AR}</strong>
                    </td>
                    <td width="40%" align="right"><i>{$smarty.const.TRANS_NONE}</i></td>
                </tr>
            {/foreach}

        {* accounts receivables rows *}

            {assign var="firstTime" value="1"}
            {assign var="rowClass" value="total"}
            {foreach key="currencyID" item="totals" from=$accountingAuthorized}
                <tr class="{$rowClass}">
                    <td width="60%" align="left" class="green">
                        {if $firstTime}
                            {assign var="firstTime" value="0"}
                            {assign var="rowClass" value=""}
                            <strong>{$smarty.const.TRANS_CLIENT_ACCOUNTING_TOTALS_AU}</strong>
                        {/if}
                    </td>
                    <td width="40%" align="right"><strong>{$totals|getAmount:$currencyID}</strong></td>
                </tr>
            {foreachelse}
                <tr class="total">
                    <td width="60%" align="left" class="green">
                            <strong>{$smarty.const.TRANS_CLIENT_ACCOUNTING_TOTALS_AU}</strong>
                    </td>
                    <td width="40%" align="right"><i>{$smarty.const.TRANS_NONE}</i></td>
                </tr>
            {/foreach}

        {* customer credits rows *}

            {assign var="firstTime" value="1"}
            {assign var="rowClass" value="total"}
            {foreach key="currencyID" item="totals" from=$accountingCustomerCredits}
                <tr class="{$rowClass}">
                    <td width="60%" align="left" class="green">
                        {if $firstTime}
                            {assign var="firstTime" value="0"}
                            {assign var="rowClass" value=""}
                            <strong>{$smarty.const.TRANS_CLIENT_ACCOUNTING_TOTALS_CC}</strong>
                        {/if}
                    </td>
                    <td width="40%" align="right"><strong>{$totals|getAmount:$currencyID}</strong></td>
                </tr>
            {foreachelse}
                <tr class="total">
                    <td width="60%" align="left" class="green">
                            <strong>{$smarty.const.TRANS_CLIENT_ACCOUNTING_TOTALS_CC}</strong>
                    </td>
                    <td width="40%" align="right"><i>{$smarty.const.TRANS_NONE}</i></td>
                </tr>
            {/foreach}

        {* revenue rows *}

            {assign var="firstTime" value="1"}
            {assign var="rowClass" value="total"}
            {foreach key="currencyID" item="totals" from=$accountingRevenue}
                <tr class="{$rowClass}">
                    <td width="60%" align="left" class="green">
                        {if $firstTime}
                            {assign var="firstTime" value="0"}
                            {assign var="rowClass" value=""}
                            <strong>{$smarty.const.TRANS_CLIENT_ACCOUNTING_TOTALS_IN}</strong>
                        {/if}
                    </td>
                    <td width="40%" align="right"><strong>{$totals|getAmount:$currencyID}</strong></td>
                </tr>
            {foreachelse}
                <tr class="total">
                    <td width="60%" align="left" class="green">
                            <strong>{$smarty.const.TRANS_CLIENT_ACCOUNTING_TOTALS_IN}</strong>
                    </td>
                    <td width="40%" align="right"><i>{$smarty.const.TRANS_NONE}</i></td>
                </tr>
            {/foreach}

        {* accounts payable rows *}

            {assign var="firstTime" value="1"}
            {assign var="rowClass" value="total"}
            {foreach key="currencyID" item="totals" from=$accountingPayables}
                <tr class="{$rowClass}">
                    <td width="60%" align="left" class="green">
                        {if $firstTime}
                            {assign var="firstTime" value="0"}
                            {assign var="rowClass" value=""}
                            <strong>{$smarty.const.TRANS_CLIENT_ACCOUNTING_TOTALS_AP}</strong>
                        {/if}
                    </td>
                    <td width="40%" align="right"><strong>{$totals|getAmount:$currencyID}</strong></td>
                </tr>
            {foreachelse}
                <tr class="total">
                    <td width="60%" align="left" class="green">
                            <strong>{$smarty.const.TRANS_CLIENT_ACCOUNTING_TOTALS_AP}</strong>
                    </td>
                    <td width="40%" align="right"><i>{$smarty.const.TRANS_NONE}</i></td>
                </tr>
            {/foreach}

        {* cost of goods rows *}

            {assign var="firstTime" value="1"}
            {assign var="rowClass" value="total"}
            {foreach key="currencyID" item="totals" from=$accountingCogs}
                <tr class="{$rowClass}">
                    <td width="60%" align="left" class="green">
                        {if $firstTime}
                            {assign var="firstTime" value="0"}
                            {assign var="rowClass" value=""}
                            <strong>{$smarty.const.TRANS_CLIENT_ACCOUNTING_TOTALS_CG}</strong>
                        {/if}
                    </td>
                    <td width="40%" align="right"><strong>{$totals|getAmount:$currencyID}</strong></td>
                </tr>
            {foreachelse}
                <tr class="total">
                    <td width="60%" align="left" class="green">
                            <strong>{$smarty.const.TRANS_CLIENT_ACCOUNTING_TOTALS_CG}</strong>
                    </td>
                    <td width="40%" align="right"><i>{$smarty.const.TRANS_NONE}</i></td>
                </tr>
            {/foreach}

        {* refunds rows *}

            {assign var="firstTime" value="1"}
            {assign var="rowClass" value="total"}
            {foreach key="currencyID" item="totals" from=$accountingRefunds}
                <tr class="{$rowClass}">
                    <td width="60%" align="left" class="green">
                        {if $firstTime}
                            {assign var="firstTime" value="0"}
                            {assign var="rowClass" value=""}
                            <strong>{$smarty.const.TRANS_CLIENT_ACCOUNTING_TOTALS_RF}</strong>
                        {/if}
                    </td>
                    <td width="40%" align="right"><strong>{$totals|getAmount:$currencyID}</strong></td>
                </tr>
            {foreachelse}
                <tr class="total">
                    <td width="60%" align="left" class="green">
                            <strong>{$smarty.const.TRANS_CLIENT_ACCOUNTING_TOTALS_RF}</strong>
                    </td>
                    <td width="40%" align="right"><i>{$smarty.const.TRANS_NONE}</i></td>
                </tr>
            {/foreach}

        {* expense rows *}

            {assign var="firstTime" value="1"}
            {assign var="rowClass" value="total"}
            {foreach key="currencyID" item="totals" from=$accountingExpenses}
                <tr class="{$rowClass}">
                    <td width="60%" align="left" class="green">
                        {if $firstTime}
                            {assign var="firstTime" value="0"}
                            {assign var="rowClass" value=""}
                            <strong>{$smarty.const.TRANS_CLIENT_ACCOUNTING_TOTALS_EX}</strong>
                        {/if}
                    </td>
                    <td width="40%" align="right"><strong>{$totals|getAmount:$currencyID}</strong></td>
                </tr>
            {foreachelse}
                <tr class="total">
                    <td width="60%" align="left" class="green">
                            <strong>{$smarty.const.TRANS_CLIENT_ACCOUNTING_TOTALS_EX}</strong>
                    </td>
                    <td width="40%" align="right"><i>{$smarty.const.TRANS_NONE}</i></td>
                </tr>
            {/foreach}



			</table>
				{include file="$tplDirectory/widgets/quickAddCredit.tpl"
					actionName="AddClientCreditResponse"
					clientID=$clientID
					formName="quickcreditform"
					currencyIDs=$currencyIDs
					sid=$sid
					localeArray=$localeArray
					currencyID=$currencyID
					ledgerAccountNames=$ledgerAccountNames
					redirectURL="clients.php"
					redirectAction="ShowClientDetails"
					redirectArgs="clientID=`$clientID`"}
			<div style="clear:both"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" /></div>
		</div>{* box07 *}

		<br />

		<div class="box07">
			<div class="st01"><h1>{$smarty.const.TRANS_BILLING_ACCOUNT_SUMMARY}</h1></div>
			<table width="90%"  border="0" cellspacing="2" cellpadding="0" class="tab06">
			{section name=typeID loop=$billingAccountTypes}
				<tr>
					<td width="50%">{$smarty.section.typeID.index|getTypeName:"billingAccount"}</td>
					<td width="50%">{$billingAccountTypes[typeID]}</td>
				</tr>
			{/section}
			<tr>
				<td><strong>{$smarty.const.TRANS_TOTAL}</strong></td>
				<td>{array_sum array=$billingAccountTypes}</td>
			</tr>
			</table>
			{assign var=p value=$client.clientID}
			{assign var=k value=$primaryContact.clientContactID}
			<div class="rm"><a href="{getHREF page="clients.php" actionName="AddBillingAccount" args="clientID=$p&clientContactID=$k"}"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" />{$smarty.const.TRANS_ADD_NEW_TO_PRIMARY}</a></div>
			<div class="rm"><a href="{getHREF page="clients.php" actionName="ShowBillingAccounts" args="clientID=$p"}"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" />{$smarty.const.TRANS_SHOW_ALL}</a></div>
			<div style="clear:both"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" /></div>
		</div>{* box07 *}

		<br />

		<div class="box07">{* Note: to change which notes are displayed, just alter the GetNoteData parameter in the GetClients query in the ShowClientsDetails action *}
			<div class="st01"><h1>{$smarty.const.TRANS_LAST_5_NOTES}</h1></div>
				{section name="j" loop=$noteList}
					<div class="note" style="margin: 1px 5%;">
						<div class="floatright">
							{assign var="noteAdminID" value=$noteList[j].adminID}
							<a href="{getHREF page="admins.php" actionName="ShowAdminDetails" args="adminID=$noteAdminID"}">
								{$noteList[j].adminUsername}
							</a>
						</div>
						{$noteList[j].clientNoteText|nl2br}
					</div>
				{sectionelse}
				{/section}
			{assign var=p value=$client.clientID}
			<div class="rm"><a href="{getHREF page="clients.php" actionName="ManageClientNotes" args="clientID=$p"}"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" />{$smarty.const.TRANS_READ_ADD_NOTES}</a></div>
			<div style="clear:both"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" /></div>
		</div>{* box07 *}

		<br />

		<div class="box07">
			<div class="st01"><h1>{$smarty.const.TRANS_ATTRIBUTES}</h1></div>
			<table width="90%"  border="0" cellspacing="2" cellpadding="0" class="tab06">
			{section name=j loop=$clientAttributes}
				<tr>
					<td width="50%">{$clientAttributes[j].attribute.0.attributeName}</td>
					<td width="50%">{$clientAttributes[j].clientAttributeValue}</td>
				</tr>
			{/section}
			</table>
			</div>
		</div>{* box07 *}
	</td>
	<td width="30%">
		<h1 class="st02">{$smarty.const.TRANS_PRODUCTS_AND_SERVICES}</h1>

		<div class="box07">
			<div class="st01"><h1>{$smarty.const.TRANS_PACKAGE_SUMMARY}</h1></div>
			<table width="90%"  border="0" cellspacing="2" cellpadding="0" class="tab06">
			{section name=statusID loop=$packageStatuses}
				<tr>
					<td width="50%">{$smarty.section.statusID.index|getStatusName:"package"}</td>
					<td width="50%">{$packageStatuses[statusID]}</td>
				</tr>
			{/section}
			<tr>
				<td><strong>{$smarty.const.TRANS_TOTAL}</strong></td>
				<td>{array_sum array=$packageStatuses}</td>
			</tr>
			</table>
			<div class="rm"><a style="cursor: pointer;" onclick="addPackage(event, 'mode=1');"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" />{$smarty.const.TRANS_ADD_NEW}</a></div>
			<div class="rm"><a style="cursor: pointer;" onclick="addPackage(event, 'mode=2');"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" />{$smarty.const.TRANS_IMPORT_EXISTING}</a></div>
			{assign var=p value=$client.clientID}
			<div class="rm"><a href="{getHREF page="packages.php" actionName="ShowPackages" args="clientID=$p"}"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" />{$smarty.const.TRANS_SHOW_ALL}</a></div>
			<div style="clear:both"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" /></div>
		</div>{* box07 *}

		<br />

		<div class="box07">
			<div class="st01"><h1>{$smarty.const.TRANS_DOMAIN_SUMMARY}</h1></div>
			<table width="90%"  border="0" cellspacing="2" cellpadding="0" class="tab06">
			{section name=statusID loop=$domainStatuses}
				<tr>
					<td width="50%">{$smarty.section.statusID.index|getStatusName:"domain"}</td>
					<td width="50%">{$domainStatuses[statusID]}</td>
				</tr>
			{/section}
			<tr>
				<td><strong>{$smarty.const.TRANS_TOTAL}</strong></td>
				<td>{array_sum array=$domainStatuses}</td>
			</tr>
			</table>
			<!-- <div class="rm"><a href="{getHREF page="domains.php" actionName="AddDomain"}"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" />{$smarty.const.TRANS_ADD_NEW}</a></div> -->
			{assign var=p value=$client.clientID}
			<div class="rm"><a href="{getHREF page="domains.php" actionName="ShowDomains" args="clientID=$p"}"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" />{$smarty.const.TRANS_SHOW_ALL}</a></div>
			<div style="clear:both"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" /></div>
		</div>{* box07 *}

		<br />

		<div class="box07">
			<div class="st01"><h1>{$smarty.const.TRANS_SSLCERT_SUMMARY}</h1></div>
			<table width="90%"  border="0" cellspacing="2" cellpadding="0" class="tab06">
			{section name=statusID loop=$certStatuses}
				<tr>
					<td width="50%">{$smarty.section.statusID.index|getStatusName:"cert"}</td>
					<td width="50%">{$certStatuses[statusID]}</td>
				</tr>
			{/section}
			<tr>
				<td><strong>{$smarty.const.TRANS_TOTAL}</strong></td>
				<td>{array_sum array=$certStatuses}</td>
			</tr>
			</table>
			<!-- <div class="rm"><a href="certs.php?action={getActionID action="AddCert"}&sid={$sid}"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" />{$smarty.const.TRANS_ADD_NEW}</a></div> -->
			<div class="rm"><a href="{getHREF page="certs.php" actionName="ShowCerts" args="clientID=`$client.clientID`"}"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" />{$smarty.const.TRANS_SHOW_ALL}</a></div>
			<div style="clear:both"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" /></div>
		</div>{* box07 *}

		<br />
		
	</td>
</tr>
</table>

<div id="addPackageDiv" style="visibility: hidden; display: none; position: absolute; width: 300px; background-color: #fff; border: 1px outset #000;">
	<table width="100%" border="0" cellpadding="1" cellspacing="1" class="addData">
		<tr>
			<th id="addPackageDivHandle" style="cursor: pointer; text-align: left;" valign="middle"><div style="float: right; cursor: pointer;" onclick="hideobjbyid('addPackageDiv');"><img src="{$imageDirectory}/ico/remove.gif" width="13" height="13" border="0" alt="" /></div>{$smarty.const.TRANS_ADD_PACKAGE}</th>
		</tr>
		<tr>
			<td><div id="addPackageContentCell" style="height: 300px; overflow: auto;">

			</div>
			</td>
		</tr>
	</table>
</div>
<script type="text/javascript" language="javascript" charset="utf-8">
// <![CDATA[{literal}
  new Draggable('addPackageDiv',{handle:'addPackageDivHandle'});
// ]]>{/literal}
</script>

{include file="$tplDirectory/footer.tpl"}
