{* $Id: ShowConfigs.tpl,v 1.12 2006/05/16 03:50:36 mfountain Exp $
 * --------------------------------------------------------------
 * This template displays a list of config groups and their params for editing.
 *
 * Smarty Variables:
 *	$configGroups (array of config group data)
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_NO_CHILDREN_FOUND" d="No children found."}
{t c="TRANS_CONFIGURATION_PARAMETERS" d="Configuration Parameters"}
{t c="TRANS_SAVE_SETTINGS" d="Save Settings"}
{t c="TRANS_PARAMETERS" d="Parameters"}
{t c="TRANS_SETTINGS_SAVED_SUCCESSFULLY" d="Settings Saved Successfully"}
{t c="TRANS_MANAGE_FRAUD_SETTINGS" d="Manage Fraud Settings"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_SYSTEM"
	childName=$configGroups[0].configGroupTransKey
	sideNavMajor="system"
	parentConfigGroupID=$configGroups[0].parentConfigGroupID}

{if $saved}
{include
	file="$tplDirectory/widgets/showInvalidCustom.tpl"
	duration="4"
	message=$smarty.const.TRANS_SETTINGS_SAVED_SUCCESSFULLY}
{/if}

<table width="770" border="0" cellspacing="0" cellpadding="0" class="tab01">
{section name="i" loop=$configGroups}
	{assign var="configGroupTransKey" value=$configGroups[i].configGroupTransKey}
	{assign var="parentConfigGroupID" value=$configGroups[i].parentConfigGroupID}

    {******************* HEADER ROW *******************}
	<tr>
		<th bgcolor="#CFCDC7">
            {strip}
			<a href="{getHREF page="configs.php" actionName="ShowConfigs" args="parentConfigGroupID=0"}">
				<img src="{$imageDirectory}/ico/arrow_left_blue.gif" width="16" height="16" alt="{$smarty.const.TRANS_PREVIOUS}" title="{$smarty.const.TRANS_PREVIOUS}" style="vertical-align:text-bottom;" />
			</a>
            <strong>
			<a href="{getHREF page="configs.php" actionName="ShowConfigs" args="parentConfigGroupID=0"}">
			{if $configGroupTransKey!="" && defined($configGroupTransKey)}
				{$smarty.const.$configGroupTransKey}
			{else}
				{$configGroupTransKey}
			{/if}
			</a>
			</strong>
            {/strip}
		</th>
	</tr>

	{section name=link loop=$configGroups[i].levelOneConfigGroups.levelOneConfigGroup}
		{* create shorter variables names for easier usage below *}
		{assign var="configChildGroupTransKey" value=$configGroups[i].levelOneConfigGroups.levelOneConfigGroup[link].configGroupTransKey}
		{assign var="configChildGroupID" value=$configGroups[i].levelOneConfigGroups.levelOneConfigGroup[link].configGroupID}
		{assign var="configChildGroupActionFile" value=$configGroups[i].levelOneConfigGroups.levelOneConfigGroup[link].configGroupActionFile}
		{assign var="configChildGroupActionName" value=$configGroups[i].levelOneConfigGroups.levelOneConfigGroup[link].configGroupActionName}
		{if $className=="alt1"}
			{assign var="className" value="alt2"}
		{else}
			{assign var="className" value="alt1"}
		{/if}
		<tr class="{cycle values="alt1,alt2"}">
			<td>
				{if $configChildGroupTransKey!="" && defined($configChildGroupTransKey)}
					{assign var="linkTitle" value=$smarty.const.$configChildGroupTransKey}
				{else}
					{assign var="linkTitle" value=$configChildGroupTransKey}
				{/if}
				{if $configChildGroupActionFile!="" && $configChildGroupActionName!=""}
					<a href="{getHREF page=$configChildGroupActionFile actionName=$configChildGroupActionName args="configGroupID=$configChildGroupID"}" class="inner">
						<img src="{$imageDirectory}/ico/data_next.gif" width="16" height="16" alt="{$smarty.const.TRANS_NEXT}" title="{$smarty.const.TRANS_NEXT}" style="vertical-align:text-bottom;" />
					</a>
					<a href="{getHREF page=$configChildGroupActionFile actionName=$configChildGroupActionName args="configGroupID=$configChildGroupID"}" class="inner">
					{$linkTitle}
					</a>
				{else}
					<a href="{getHREF page="configs.php" actionName="ShowConfigs" args="configGroupID=$configChildGroupID"}" class="inner">
						<img src="{$imageDirectory}/ico/data_next.gif" width="16" height="16" alt="{$smarty.const.TRANS_NEXT}" title="{$smarty.const.TRANS_NEXT}" style="vertical-align:text-bottom;" />
					</a>
					<a href="{getHREF page="configs.php" actionName="ShowConfigs" args="configGroupID=$configChildGroupID"}" class="inner">
					{$linkTitle}
					</a>
				{/if}
			</td>
		</tr>
	{sectionelse}
        {* NO USE FOR THIS YET -- BUT DO NOT REMOVE IT -- MF
		<tr>
			<td>{$smarty.const.TRANS_NO_CHILDREN_FOUND}</td>
		</tr>
        *}
	{/section}
{/section}
</table>

<br />

<form method="post" action="configs.php">
<input type="hidden" name="action" value="{getActionID action="EditConfigParamsResponse"}" />
<input type="hidden" name="adminGroupID" value="{$adminGroup.adminGroupID}" />
<input type="hidden" name="redirectURL" value="{$fileName}" />
<input type="hidden" name="redirectAction" value="{$actionName}" />
<input type="hidden" name="redirectArgs" value="{$bookmarkArgs}" />
<input type="hidden" name="sid" value="{$sid}" />

<table width="770" border="0" cellpadding="0" cellspacing="0" class="list">

	{section name="i" loop="$configParams"}
	{assign var="configParamID" value=$configParams[i].configParamID}
	{assign var="configParamName" value=$configParams[i].configParamName}
	{assign var="configParamTransKey" value=$configParams[i].configParamTransKey}
	{assign var="configParamDescription" value=$configParams[i].configParamDescription}
	{if !$results}
		{assign var="results" value=1}
		<thead>
		<tr class="headerRow">
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="30%" addEmptyTD=1 headerClass="firstTD" headerName="TRANS_CONFIGURATION_PARAMETERS"}
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="40%" addEmptyTD=1 headerName="TRANS_VALUES"}
			{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="30%" headerClass="lastTD" headerName="TRANS_DESCRIPTION"}
		</tr>
		</thead>
	{/if}
	{if $className=="alt1"}
		{assign var="className" value="alt2"}
	{else}
		{assign var="className" value="alt1"}
	{/if}
	{if $configParamTransKey!="" && defined($configParamTransKey)}
		{assign var="configTitle" value=$smarty.const.$configParamTransKey}
	{else}
		{assign var="configTitle" value=$configParamTransKey}
	{/if}
	<tr class="{cycle values="alt1,alt2"}">
		<td align="right" valign="top">
            <strong>{$configTitle}:</strong>
		</td>
		<td class="spacer"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" /></td>
		<td class="nowrap">
			{* the ID must be passed as well! *}
			<input type="hidden" name="configParams[{$configParamName}][configParamID]" value="{$configParams[i].configParamID}" />
			{if !$configParams[i].configParamInputType || $configParams[i].configParamInputType=="t"}
				<input type="text" name="configParams[{$configParamName}][configParamValue]" value="{$configParams[i].configParamValue}" />
			{elseif $configParams[i].configParamInputType=="p"}
				<input type="password" name="configParams[{$configParamName}][configParamValue]" value="{$configParams[i].configParamValue}" />
			{elseif $configParams[i].configParamInputType=="a"}
				<textarea name="configParams[{$configParamName}][configParamValue]" cols="40" rows="3">{$configParams[i].configParamValue}</textarea>
			{elseif $configParams[i].configParamInputType=="s"}
				<select name="configParams[{$configParamName}][configParamValue]">
					{html_options options=$configParamValues[$configParamID] selected=$configParams[i].configParamValue}
				</select>
			{elseif $configParams[i].configParamInputType=="m"}
				<select name="configParams[{$configParamName}][configParamValue]" multiple="multiple">
					{html_options options=$configParamValues[$configParamID] selected=$configParams[i].configParamValue}
				</select>
			{elseif $configParams[i].configParamInputType=="c"}
				{html_checkboxes
					name="configParams[$configParamName][configParamValue]"
					options=$configParamValues[$configParamID]
					selected=$configParams[i].configParamValue
					separator="<br />"}
			{elseif $configParams[i].configParamInputType=="r"}
				{html_radios
					name="configParams[$configParamName][configParamValue]"
					options=$configParamValues[$configParamID]
					selected=$configParams[i].configParamValue
					separator="&nbsp;&nbsp;"}
			{else}
				<input type="text" name="configParam[{$configParamName}][configParamValue]" value="{$configParams[i].configParamValue}" />
			{/if}
		</td>
		<td class="spacer"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" /></td>
		<td>
			{if $configParamDescription!="" && defined($configParamDescription)}
				{assign var="caption" value=$smarty.const.TRANS_DESCRIPTION}
				{assign var="text" value=$smarty.const.$configParamDescription}
				{assign var="closetext" value=$smarty.const.TRANS_CLOSE}
				{strip}
	            <a href="javascript:void(0);" onclick="return overlib('{$text|addslashes}',
	            	STICKY,
					BGCLASS, 'popupBG',
					FGCLASS, 'popupFG',
					CAPTIONFONTCLASS, 'popupCaption',
	            	CAPTION,'{$caption}: {$configTitle}',
	            	CLOSECLICK, CLOSETEXT, '&lt;img src={$imageDirectory}/ico/remove.gif width=13 height=13 border=0 style=\'padding:2px;\' /&gt;',
	            	SNAPX,0,
	            	SNAPY,0,
	            	WIDTH,300);" onmouseout="nd();">
					<img src="{$imageDirectory}/ico/help.gif" width="16" height="16" style="vertical-align:text-bottom;" />
	            </a>
	            {/strip}
			{else}
				<i>{$configParamDescription|default:$smarty.const.TRANS_NONE}</i>
			{/if}
		</td>
	</tr>
	{sectionelse}
		{assign var="results" value=0}
		<tr>
			<td>&nbsp;</td>
			<td>&nbsp;</td>
			<td>{$smarty.const.TRANS_NO_CONFIG_PARAMS_FOUND}</td>
			<td>&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
	{/section}
	{if $results==1}
		<tr>
			<td>&nbsp;</td>
			<td>&nbsp;</td>
			<td><input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_SAVE_SETTINGS}" /></td>
			<td>&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
	{/if}
	</table>

</form>

{include file="$tplDirectory/footer.tpl"}