{* $Id: ShowEmailQueue.tpl,v 1.22 2006/06/09 20:18:22 bsmith Exp $
 * --------------------------------------------------------------
 * This template displays a list of emails in the email queue. From this list, the user should be able to add, edit, or 
 * remove items from the queue, and also run items in the queue. All of these actions can be accessed via events.php, and 
 * their action names are as follows:
 *   AddEmail
 *   EditEmail
 *   RemoveEmail
 *   RunEmailQueue
 *
 * Smarty Variables:
 *	$emails (an array of all emails available to this display)
 *	  emailID  -  The ID of this email
 *	  emailSubject  -  The subject of this email
 *	  emailFromAddress  -  The address of the email's sender
 *	  emailFromName  -  The name of the sender (if this is empty, no name was given)
 *    emailTextBody  -  text body
 *    emailSent  -  1 if this email has been sent, or 0 if otherwise
 *    emailFailed  -  1 if this email failed to send, or 0 if otherwise
 *    emailActive  -  1 if this email is active, and waiting to be sent. 0 if otherwise.
 *    emailToAddresses  -  An array of recipients for this email
 *    emailCCAddresses  -  An array of carbon copied recipients for this email
 *    emailBCCAddresses  -  An array of blind carbon copied recipients for this email
 *    emailReplyToAddresses  -  An array of addresses to have the recipient reply to
 *    emailAttachments  -  An array of filenames that were attached to this email
 *    emailHeaders  -  An array of additional headers applied to this email
 *	  dateCreated  -  The timestamp representing when this queue item was created
 *	  dateSent  -  The timestamp representing when this queue item was sent, this is 0 if this item was never sent
 *	  
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *  $sid					The current sessionID
 *
 * Author: Vic Fryzel
 *}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_CREATED" d="Created"}
{t c="TRANS_DETAILS" d="Details"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_EMAIL" d="Email"}
{t c="TRANS_FROM" d="From"}
{t c="TRANS_ID" d="ID"}
{t c="TRANS_MANAGE_EMAILS" d="Manage Emails"}
{t c="TRANS_NORESULTS" d="No Results"}
{t c="TRANS_REMOVE" d="Remove"}
{t c="TRANS_RUN" d="Run"}
{t c="TRANS_SENT" d="Sent"}
{t c="TRANS_SHOW_EMAILS" d="Show Emails"}
{t c="TRANS_SUBJECT" d="Subject"}
{t c="TRANS_NEVER" d="Never"}
{t c="TRANS_SENT" d="Sent"}
{t c="TRANS_UNSENT" d="Unsent"}
{t c="TRANS_ACTIVE" d="Active"}
{t c="TRANS_SEND" d="Send"}
{t c="TRANS_ADDRESSES" d="Addresses"}
{t c="TRANS_TO" d="To"}
{t c="TRANS_CC" d="CC"}
{t c="TRANS_BCC" d="BCC"}
{t c="TRANS_REPLYTO" d="Reply To"}
{t c="TRANS_HTMLBODY" d="HTML Body"}
{t c="TRANS_PLAINTEXTBODY" d="Plain-Text Body"}
{t c="TRANS_EMAILBODY" d="Email Body"}

{assign var="filterArgs" value="emailActive=$emailActive"}

{include
    file="$tplDirectory/header.tpl"
    parentName="TRANS_MANAGE_EMAILS"
    childName="TRANS_SHOW_EMAILS"
	sideNavMajor="events"
    sideNavMinor="emails"}

<table  width="770" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>
<tr>
	<td colspan="7" onmouseover="this.style.cursor='hand'" onclick="{strip} {section name=iter loop=$emails} 
		toggle('row_{$emails[iter].emailID}'); {/section} {/strip}return false;"> <a href="javascript:void(0);"><img src="{$imageDirectory}/ico/data_down.gif" width="16" height="16" alt="" title="" border="0" /></a> {$smarty.const.TRANS_ADDITIONAL_DATA}
	</td>
</tr>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_ID" sortColumn="emailID" headerClass="firstTD"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_FROM" sortColumn="emailFromAddress"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_SUBJECT" sortColumn="emailSubject"}
	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl" headerName="TRANS_CREATED" sortColumn="emailDateCreated"}
	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl" headerName="TRANS_SENT" sortColumn="emailDateSent"}
	{include file="$tplDirectory/widgets/table/listHeaderFilter.tpl" filterName="TRANS_ACTIVE" filterColumn="emailActive" filterOptions="$activeInactive"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ACTIONS" headerClass="lastTD"}
</tr>
</thead>
{section name=i loop="$emails"}
{assign var="emailID" value=$emails[i].emailID}
{if $className=="alt1"}
    {assign var="className" value="alt2"}
{else}
    {assign var="className" value="alt1"}
{/if}
<tbody>
<tr class="{cycle values="alt1,alt2"}"
	onmouseover="this.className='althover';"
	onmouseout="this.className='{$className}';">
	<td onmouseover="this.style.cursor='hand'" onclick="return toggle('row_{$emailID}');">
	<a href="#e{$emailID}" name="e{$emailID}">{$emailID}</a>
	</td>
	<td>
		{if ($emails[i].emailFromName)}
			{$emails[i].emailFromName} &lt;{$emails[i].emailFromAddress}&gt;
		{else}
			{$emails[i].emailFromAddress}
		{/if}
		{include file="$tplDirectory/widgets/quickEditLink.tpl" editID=$emailID editKey="emailID"
			editActionName="EditEmailResponse" editName="TRANS_EMAIL" editColumn="emailFromAddress"
			editValue=$emails[i].emailFromAddress}
	</td>
	<td>
		{$emails[i].emailSubject}
		{include file="$tplDirectory/widgets/quickEditLink.tpl" editID=$emailID editKey="emailID"
			editActionName="EditEmailResponse" editName="TRANS_EMAIL" editColumn="emailSubject"
			editValue=$emails[i].emailSubject}
	</td>
	<td>
		{$emails[i].emailDateCreated|getDateTime}
	</td>
	<td>
		{if ($emails[i].emailSent)}
			{$emails[i].emailDateSent|getDateTime}
		{else}
			{assign var="emailSent" value=$emails[i].emailSent}
			{$sentUnsent[$emailSent]}
		{/if}
	</td>
	<td>
		{assign var="emailActive" value=$emails[i].emailActive}
		{$activeInactive[$emailActive]}
	</td>
	<td align="center" nowrap="nowrap">
		{strip}
		<a href="{getHREF page="events.php" actionName="ResendEmail" args="emailID=$emailID"}">
			<img src="{$imageDirectory}/ico/014.gif" width="13" height="13" border="0"
				alt="{$smarty.const.TRANS_SEND}" />
		</a>
		&nbsp;
		<a href="{getHREF page="events.php" actionName="ShowEmailDetails" args="emailID=$emailID"}">
			<img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0"
				alt="{$smarty.const.TRANS_DETAILS}" />
		</a>
		&nbsp;
		<a href="{getHREF page="events.php" actionName="RemoveEmail" args="emailID=$emailID"}">
			<img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0"
				alt="{$smarty.const.TRANS_REMOVE}" />
		</a>
		{/strip}
	</td>
</tr>
</tbody>
<tbody id="row_{$emailID}">
<tr class="althover">
	<td colspan="7">
		<table width="90%">
			<tr valign="top">
				<td>
					<table width="100%">
						<tr>
							<th>{$smarty.const.TRANS_TO}</th>
							<th>{$smarty.const.TRANS_CC}</th>
							<th>{$smarty.const.TRANS_BCC}</th>
							<th>{$smarty.const.TRANS_REPLYTO}</th>
						</tr>
						<tr>
							<td>
								{foreach from=$emails[i].emailToAddresses.0.emailToAddress item=address}
									<strong>{$address.emailAddressName}</strong> {$address.emailAddress}&nbsp;
									{assign var="ccid" value=$emails[i].clientContactID}
									<a href="{getHREF page="clients.php" actionName="EditClientContact" args="clientContactID=$ccid"}">
										<img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0"
											alt="{$smarty.const.TRANS_DETAILS}" />
									</a><br />
								{/foreach}
							</td>
							<td>
								{if $emails[i].emailCCAddresses}
									{foreach from=$emails[i].emailCCAddresses.0.emailCCAddress item=address}
										<strong>{$address.emailAddressName}</strong> {$address.emailAddress}<br />
									{/foreach}
								{else}
									{$smarty.const.TRANS_NONE}
								{/if}
							</td>
							<td>
								{if $emails[i].emailBCCAddresses}
									{foreach from=$emails[i].emailBCCAddresses.0.emailBCCAddress item=address}
										<strong>{$address.emailAddressName}</strong> {$address.emailAddress}<br />
									{/foreach}
								{else}
									{$smarty.const.TRANS_NONE}
								{/if}
							</td>
							<td>
								{if $emails[i].emailReplyToAddresses}
									{foreach from=$emails[i].emailReplyToAddresses.0.emailReplyToAddress item=address}
										<strong>{$address.emailAddressName}</strong> {$address.emailAddress}<br />
									{/foreach}
								{else}
									{$smarty.const.TRANS_NONE}
								{/if}
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>
	<script type="text/JavaScript">toggle('row_{$emails[i].emailID}');</script>
	</td>
</tr>
</tbody>
{sectionelse}
<tr class="alt1">
	<td colspan="7">{$smarty.const.TRANS_NORESULTS}</td>
</tr>
{/section}
</table>

{include file="$tplDirectory/widgets/paginationLinks.tpl"}
{include file="$tplDirectory/footer.tpl"}