{* $Id: AddFAQ.tpl,v 1.6 2006/05/19 20:58:44 bsmith Exp $
 * --------------------------------------------------------------
 * This template displays a form to add a new FAQ. The form must post to faqs.php,
 * with the action ID for the AddFAQQuestionResponse action, so that the POST data can
 * be handled by the server. This template takes the $categories smarty variable, used to display
 * the FAQ categories by name.
 *
 * Smarty Variables:
 *	$faqCategories -- array of this FAQ category names and with IDs
 *  $addAdditionalFAQ -- 1 if the user wants to keep adding FAQs after every post,
 *                       or 0 if otherwise.
 *}

{t c="TRANS_MANAGE_HELPDESK" d="Manage Helpdesk"}
{t c="TRANS_ADD_FAQ" d="Add FAQ"}
{t c="TRANS_CATEGORY" d="Category"}
{t c="TRANS_QUESTION" d="Question"}
{t c="TRANS_ANSWER" d="Answer"}
{t c="TRANS_ADD_ANOTHER_FAQ" d="Add another FAQ?"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_HELPDESK"
	childName="TRANS_ADD_FAQ"
	sideNavMajor="helpdesk"
	sideNavMinor="faqs"}

<form method="post" action="faqs.php">
<input type="hidden" name="action" value="{getActionID action="AddFAQResponse"}" />
<input type="hidden" name="sid" value="{$sid}" />

<table  width="770" border="0" cellpadding="0" cellspacing="0" class="list" >
<thead>
	<tr class="headerRow">
		<td scope="col" colspan="2">{$smarty.const.TRANS_ADD_FAQ}</td>
	</tr>
</thead>
<tbody>
	<tr class="{cycle values="alt1,alt2"}">
		<th class="nowrap" scope="row">{$smarty.const.TRANS_CATEGORY}:</th>
		<td width="100%">
			<select id="faqCategoryID" name="faqCategoryID">
			{foreach from=$faqCategories item="cat"}
				<option value="{$cat.faqCategoryID}">{$cat.faqCategoryName}</option>
			{/foreach}
		</select>
	</tr>
	<tr class="{cycle values="alt1,alt2"}">
		<th class="nowrap" scope="row">{$smarty.const.TRANS_QUESTION}:</th>
		<td width="100%"><input type="text" name="faqQuestion" size="100" value=""></td>
	</tr>
	<tr class="{cycle values="alt1,alt2"}">
		<th class="nowrap" scope="row">{$smarty.const.TRANS_ANSWER}:</th>
		<td width="100%"><textarea name="faqAnswer" cols="100" rows="10"></textarea></td>
	</tr>
	<tr class="{cycle values="alt1,alt2"}">
		<th class="nowrap" scope="row">{$smarty.const.TRANS_ADD_ANOTHER_FAQ}</th>
		<td width="100%">
		{if $addAdditionalFAQ}
			<input type="checkbox" name="addAdditionalFAQ" value="1" checked="checked" />
		{else}
			<input type="checkbox" name="addAdditionalFAQ" value="1" />
		{/if}
		</td>
	</tr>
	<tr>
		<td colspan="2">
			<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_ADD_FAQ}">
		</td>
	</tr>
</table>
</tbody>
</form>

{include file="$tplDirectory/footer.tpl"}