{* $Id: ShowFAQs.tpl,v 1.10 2006/05/22 17:05:11 bsmith Exp $
 * --------------------------------------------------------------
 * This template displays a list of FAQs. All pieces of data associated with a
 * FAQ are available in the $faqs variable, which is an array of FAQs.
 *
 * Smarty Variables:
 *	$faqs -- an array of FAQs, who every element is an array of FAQ information
 *	         That information is structured as follows (below is listed the elements of every FAQ):
 *	           faqID --  The ID of the FAQ
 *	           faqCategoryID -- The ID of the FAQ Category that this FAQ belongs to
 *	           faqCategoryData -- An array of data about the FAQ Category that this question belongs to
 *	                            The array is of the form:
 *	                              faqCategoryID -- The ID of the FAQ Category
 *	                              faqCategoryName -- The name of the FAQ Category
 *								  faqCategoryType -- The type of the FAQ Category
 *	           faqQuestion -- The question of the FAQ
 *	           faqAnswer -- The FAQ answer
 *	           faqDateCreated -- The UNIX timestamp of when this FAQ was created
 *}

{t c="TRANS_MANAGE_HELPDESK" d="Manage Helpdesk"}
{t c="TRANS_FAQ_CATEGORIES" d="FAQ Categories"}
{t c="TRANS_ADD_FAQ_CATEGORY" d="Add FAQ Category"}
{t c="TRANS_ADD_FAQ" d="Add FAQ"}
{t c="TRANS_EDIT_FAQ_CATEGORY" d="Edit FAQ Category"}
{t c="TRANS_EDIT_FAQ" d="Edit FAQ"}
{t c="TRANS_REMOVE_FAQ_CATEGORY" d="Remove FAQ Category"}
{t c="TRANS_REMOVE_FAQ" d="Remove FAQ"}
{t c="TRANS_NO_FAQS_IN_FAQ_CATEGORY" d="No FAQs were found in this category."}
{t c="TRANS_NO_FAQ_CATEGORIES_FOUND" d="No FAQ categories were found to display."}
{t c="TRANS_QUESTION" d="Question"}
{t c="TRANS_ANSWER" d="Answer"}
{t c="TRANS_DATE_CREATED" d="Date Created"}
{t c="TRANS_ACTIONS" d="Actions"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_HELPDESK"
	childName="TRANS_FAQS"
	sideNavMajor="helpdesk"
	sideNavMinor="faqs"}

<table  width="770" border="0" cellpadding="0" cellspacing="0" class="list" >
<thead>
<tr>
	<td colspan="7" onmouseover="this.style.cursor='hand'" onclick="{strip}
		{foreach item="cat" from=$faqCategories}
			toggle('category_{$cat.faqCategoryID}');
		{/foreach} {/strip}return false;"> <a href="javascript:void(0);"><img src="{$imageDirectory}/ico/data_down.gif" width="16" height="16" border="0" /></a href="javascript:void(0);"> {$smarty.const.TRANS_ADDITIONAL_DATA}
	</td>
</tr>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerClass="firstTD lastTD" headerName="TRANS_FAQ_CATEGORIES" headerAlign="left"}
</tr>
</thead>

{********* FAQ CATEGORY LOOP *********}
{********* FAQ CATEGORY LOOP *********}
{********* FAQ CATEGORY LOOP *********}
{foreach from=$faqCategories item="cat"}
	{if $cat.faqCategoryID}
		{assign var="faqCategoryID" value=$cat.faqCategoryID}

		{if $className=="alt1"}
    			{assign var="className" value="alt2"}
		{else}
    			{assign var="className" value="alt1"}
		{/if}
		<tbody>
		<tr class="{cycle values="alt1,alt2"}"
			onmouseover="this.className='althover';"
			onmouseout="this.className='{$className}';">
			<td onmouseover="this.style.cursor='hand'" onclick="return toggle('category_{$cat.faqCategoryID}');">
			<img src="{$imageDirectory}/ico/data_down.gif" width="16" height="16" border="0" />
				<a name="category_{$cat.faqCategoryID}"></a>
				<a href="#category_{$cat.faqCategoryID}"><strong>{$cat.faqCategoryName}</strong></a>
			</td>
		</tr>
		</tbody>
		<tbody id="category_{$cat.faqCategoryID}">
		<td>
			<table summary="{$smarty.const.TRANS_FAQ_CATEGORY_DATA}" width="100%" class="small">
				<tr class="{cycle name="faq_$faqID" values="alt1,alt2"}">
					<th scope="row">{$smarty.const.TRANS_ACTIONS}</th>
					<td>
						{assign var="faqID" value=$faq.faqID}
						{strip}
						<a href="{getHREF page="faqs.php" actionName="EditFAQCategory" args="faqCategoryID=$faqCategoryID"}">
							<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0"
								alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
						</a>
						&nbsp;
						<a href="{getHREF page="faqs.php" actionName="RemoveFAQCategory" args="faqCategoryID=$faqCategoryID"}">
							<img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0"
								alt="{$smarty.const.TRANS_REMOVE}" title="{$smarty.const.TRANS_REMOVE}" />
						</a>
						{/strip}
					</td>
				</tr>
				<tr>
					<th scope="col" colspan="2">{$smarty.const.TRANS_FAQS}</th>
				</tr>
				<tr>
					<td colspan="2">



			{********* FAQ LOOP *********}
			{********* FAQ LOOP *********}
			{********* FAQ LOOP *********}
			{assign var="faqs" value=$cat.faqs}
			{foreach from=$faqs item="faq"}
				{assign var="faqID" value=$faq.faqID}
				{if $className2=="alt1"}
					{assign var="className2" value="alt2"}
				{else}
					{assign var="className2" value="alt1"}
				{/if}
				<tbody>
				<tr class="{cycle values="alt1,alt2"}"
					onmouseover="this.className='althover';"
					onmouseout="this.className='{$className2}';">
					<td onmouseover="this.style.cursor='hand'" onclick="return toggle('faq_{$cat.faqCategoryID}_{$faqID}');" colspan="2">
						<a name="faq_{$cat.faqCategoryID}_{$faqID}"></a>
						<a href="#faq_{$cat.faqCategoryID}_{$faqID}">{$faq.faqQuestion}</a>
					</td>
				</tr>
				</tbody>
				<tbody id="faq_{$cat.faqCategoryID}_{$faqID}">
				<td colspan="2">
					<table summary="{$smarty.const.TRANS_FAQ_DATA}" width="100%" class="small">
						<tr class="{cycle name="faq_$faqID" values="alt1,alt2"}">
							<th scope="row">{$smarty.const.TRANS_ACTIONS}</th>
							<td>
								{assign var="faqID" value=$faq.faqID}
								{strip}
								<a href="{getHREF page="faqs.php" actionName="EditFAQ" args="faqID=$faqID"}">
									<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0"
										alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
								</a>
								&nbsp;
								<a href="{getHREF page="faqs.php" actionName="RemoveFAQ" args="faqID=$faqID"}">
									<img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0"
										alt="{$smarty.const.TRANS_REMOVE}" title="{$smarty.const.TRANS_REMOVE}" />
								</a>
								{/strip}
							</td>
						</tr>
						<tr class="{cycle name="faq_$faqID" values="alt1,alt2"}">
							<th scope="row">{$smarty.const.TRANS_QUESTION}</th>
							<td>{$faq.faqQuestion}</td>
						</tr>
						<tr class="{cycle name="faq_$faqID" values="alt1,alt2"}">
							<th scope="row">{$smarty.const.TRANS_ANSWER}</th>
							<td>{$faq.faqAnswer|nl2br}</td>
						</tr>
						<tr class="{cycle name="faq_$faqID" values="alt1,alt2"}">
							<th scope="row">{$smarty.const.TRANS_DATE_CREATED}</th>
							<td>{$faq.faqDateCreated|getDateTime}</td>
						</tr>
					</table>
					<script type="text/javascript">toggle('faq_{$cat.faqCategoryID}_{$faqID}');</script>
				</td>
				</tr>
				</tbody>
			{foreachelse}
				{$smarty.const.TRANS_NO_FAQS_IN_FAQ_CATEGORY}
			{/foreach}
			{********* END FAQ LOOP *********}
			{********* END FAQ LOOP *********}
			{********* END FAQ LOOP *********}

						</td>
					</tr>
				</table>
				<script type="text/javascript">toggle('category_{$cat.faqCategoryID}');</script>
			</td>
			</tr>
			</tbody>
		{/if}
{foreachelse}
	{$smarty.const.TRANS_NO_FAQ_CATEGORIES_FOUND}
{/foreach}
{********* END FAQ CATEGORY LOOP *********}
{********* END FAQ CATEGORY LOOP *********}
{********* END FAQ CATEGORY LOOP *********}


</table>

{include file="$tplDirectory/widgets/paginationLinks.tpl"}
{include file="$tplDirectory/footer.tpl"}