{* $Id: header.print.tpl,v 1.2 2006/07/07 17:18:38 kbailey Exp $
 * --------------------------------------------------------------
 * This is the primary header template for the Admin GUI of ModernBill. Note that this header.tpl
 * file will open several HTML tags must be closed by the footer.tpl file.
 *
 * Smarty Variables:
 *  $htmlTitle		The title of this document
 *  $htmlLang		The language this document will render
 *	$parentName		The page info parent name
 *	$childName		The page info child name
 *	$useMenu		The tab name to highlight
 *	$sideNavMajor		The side navigation file to include
 *	$loginName		The name of the admin user who is logged in
 * 	$cssDirectory	The relative path to the theme's css directory
 *	$jsDirectory	The relative path to the theme's javascript directory
 *	$imageDirectory	The relative path to the theme's image directory
 *
 * Example Usage:
 *  {include file="$tplDirectory/header.tpl" parentName="TRANS_MANAGE_CLIENTS" childName="TRANS_SHOW_CLIENTS" sideNavMajor="clients"}
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_CLIENTS" d="Clients"}
{t c="TRANS_EVENTS" d="Events"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_HELPDESK" d="Helpdesk"}
{t c="TRANS_LOGOFF" d="Logoff"}
{t c="TRANS_LOGGED_IN_AS" d="Logged in as"}
{t c="TRANS_MODULES" d="Modules"}
{t c="TRANS_PRODUCTS" d="Products"}
{t c="TRANS_PROFILE" d="Profile"}
{t c="TRANS_SYSTEM" d="System"}

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="{$htmlLang}" lang="{$htmlLang}" dir="{$smarty.const.TRANS_TEXTDIRECTION}">
<head>
<title>{strip}
	{if $htmlTitle}
		{$htmlTitle}
	{else}
		{if $parentName}
			{$smarty.const.$parentName}
		{/if}
		{if $childName}
			&nbsp;&raquo; {$smarty.const.$childName}
		{/if}
		{if $grandchildName}
			&nbsp;&raquo; {$smarty.const.$grandchildName}
		{/if}
	{/if}
{/strip}</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />

<link rel="stylesheet" type="text/css" href="{$cssDirectory}/style.css" />

<script language="javascript" type="text/javascript" src="{$jsDirectory}/preloadm.js"></script>
<script language="JavaScript" type="text/javascript" src="{$jsDirectory}/overlib.js"></script>
<script language="JavaScript" type="text/javascript" src="{$jsDirectory}/toggle.js"></script>
<script language="JavaScript" type="text/javascript" src="{$jsDirectory}/main.js"></script>
<script language="JavaScript" type="text/javascript" src="{$jsDirectory}/pushpull.js"></script>
{if $systemQueue.systemQueueRunning}
<script language="javascript" type="text/javascript" src="{$jsDirectory}/progress.js" charset="utf-8"></script>
{/if}
{if $includeAjaxJS}
<script language="javascript" type="text/javascript" src="{$jsDirectory}/../ajax/core/ajax.inc.js" charset="utf-8"></script>
{/if}
{if $includeDomainJS}
<script language="javascript" type="text/javascript" src="{$jsDirectory}/domains.js" charset="utf-8"></script>
{/if}
{* the following css & js files support the js calendar *}
<link rel="stylesheet" type="text/css" href="{$jsDirectory}/cal/themes/enx.css" charset="utf-8" />
<link rel="stylesheet" type="text/css" href="{$jsDirectory}/cal/themes/layouts/small.css" charset="utf-8" />
<script language="JavaScript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/scriptaculous/lib/prototype.js"></script>
<script language="JavaScript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/scriptaculous/src/scriptaculous.js"></script>
<script language="JavaScript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/scriptaculous/src/unittest.js"></script>
<script language="javascript" type="text/javascript" src="{$jsDirectory}/cal/src/utils.js" charset="utf-8"></script>
<script language="javascript" type="text/javascript" src="{$jsDirectory}/cal/src/calendar.js" charset="utf-8"></script>
<script language="javascript" type="text/javascript" src="{$jsDirectory}/cal/src/calendar-setup.js" charset="utf-8"></script>
<script language="javascript" type="text/javascript" src="{$jsDirectory}/cal/lang/calendar-{$calendarLanguageFile}.js" charset="utf-8"></script>

</head>
{if $systemQueue.systemQueueRunning && $systemQueue.systemQueueStop!=1}
<body onLoad="checkSystemEventStatus()">
{else}
<body>

			<div class="block02">{* required open div -- do not remove or close *}
				
				<div class="block03">{* required open div -- do not remove or close *}

{/if}

{*
 * Note: Leave the <td> above open. It will be closed at the top of the footer.tpl file.
 * Example: "header.tpl <td>" some content "</td> footer.tpl"
 *}