{* $Id: header.tpl,v 1.70 2006/07/07 17:18:38 kbailey Exp $
 * --------------------------------------------------------------
 * This is the primary header template for the Admin GUI of ModernBill. Note that this header.tpl
 * file will open several HTML tags must be closed by the footer.tpl file.
 *
 * Smarty Variables:
 *  $htmlTitle		The title of this document
 *  $htmlLang		The language this document will render
 *	$parentName		The page info parent name
 *	$childName		The page info child name
 *	$useMenu		The tab name to highlight
 *	$sideNavMajor		The side navigation file to include
 *	$loginName		The name of the admin user who is logged in
 * 	$cssDirectory	The relative path to the theme's css directory
 *	$jsDirectory	The relative path to the theme's javascript directory
 *	$imageDirectory	The relative path to the theme's image directory
 *
 * Example Usage:
 *  {include file="$tplDirectory/header.tpl" parentName="TRANS_MANAGE_CLIENTS" childName="TRANS_SHOW_CLIENTS" sideNavMajor="clients"}
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_CLIENTS" d="Clients"}
{t c="TRANS_EVENTS" d="Events"}
{t c="TRANS_FINANCES" d="Finances"}
{t c="TRANS_HELPDESK" d="Helpdesk"}
{t c="TRANS_LOGOFF" d="Logoff"}
{t c="TRANS_LOGGED_IN_AS" d="Logged in as"}
{t c="TRANS_MODULES" d="Modules"}
{t c="TRANS_PRODUCTS" d="Products"}
{t c="TRANS_PROFILE" d="Profile"}
{t c="TRANS_SYSTEM" d="System"}
{t c="TRANS_SEARCH" d="Search"}
{t c="TRANS_SMART" d="Smart"}
{t c="TRANS_HOME" d="Home"}

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="{$htmlLang}" lang="{$htmlLang}" dir="{$smarty.const.TRANS_TEXTDIRECTION}">
<head>
<title>{strip}
	{if $htmlTitle}
		{$htmlTitle}
	{else}
		{if $parentName}
			{$smarty.const.$parentName|default:$parentName}
		{/if}
		{if $childName}
			&nbsp;&raquo; {$smarty.const.$childName|default:$childName}
		{/if}
		{if $grandchildName}
			&nbsp;&raquo; {$smarty.const.$grandchildName|default:$grandchildName}
		{/if}
	{/if}
{/strip}</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />

<link rel="stylesheet" type="text/css" href="{$cssDirectory}/style.css" />

<script language="javascript" type="text/javascript" src="{$jsDirectory}/preloadm.js"></script>
<script language="JavaScript" type="text/javascript" src="{$jsDirectory}/overlib.js"></script>
<script language="JavaScript" type="text/javascript" src="{$jsDirectory}/toggle.js"></script>
<script language="JavaScript" type="text/javascript" src="{$jsDirectory}/main.js"></script>
<script language="JavaScript" type="text/javascript" src="{$jsDirectory}/pushpull.js"></script>
{if $systemQueue.systemQueueRunning}
<script language="javascript" type="text/javascript" src="{$jsDirectory}/progress.js" charset="utf-8"></script>
{/if}
{if $includeAjaxJS}
<script language="javascript" type="text/javascript" src="{$jsDirectory}/../ajax/core/ajax.inc.js" charset="utf-8"></script>
{/if}
{if $includeDomainJS}
<script language="javascript" type="text/javascript" src="{$jsDirectory}/domains.js" charset="utf-8"></script>
{/if}
{* the following css & js files support the js calendar *}
<link rel="stylesheet" type="text/css" href="{$jsDirectory}/cal/themes/enx.css" charset="utf-8" />
<link rel="stylesheet" type="text/css" href="{$jsDirectory}/cal/themes/layouts/small.css" charset="utf-8" />
<script language="JavaScript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/scriptaculous/lib/prototype.js"></script>
<script language="JavaScript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/scriptaculous/src/scriptaculous.js"></script>
<script language="JavaScript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/scriptaculous/src/unittest.js"></script>
<script language="javascript" type="text/javascript" src="{$jsDirectory}/cal/src/utils.js" charset="utf-8"></script>
<script language="javascript" type="text/javascript" src="{$jsDirectory}/cal/src/calendar.js" charset="utf-8"></script>
<script language="javascript" type="text/javascript" src="{$jsDirectory}/cal/src/calendar-setup.js" charset="utf-8"></script>
<script language="javascript" type="text/javascript" src="{$jsDirectory}/cal/lang/calendar-{$calendarLanguageFile}.js" charset="utf-8"></script>

</head>
{if $systemQueue.systemQueueRunning && $systemQueue.systemQueueStop!=1}
<body onLoad="checkSystemEventStatus()">
{else}
<body>
{/if}
<div id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></div>

<table cellspacing="0" class="top01">
<tr>
	<td class="bg01" valign="top">
	    <div class="top">
			<div class="top01" style="background:url({$imageDirectory}/bg/logobg.gif) no-repeat 0px 0px; width:206px;">
				<img src="{$imageDirectory}/logos/logo.gif" width="120" height="55" alt="Your Logo" title="Your Logo" hspace="40" vspace="5" /></div>
			<div style="float:right;"><img src="{$imageDirectory}/spacer.gif" width="500" height="6" alt="" title="" /></div>
			<div class="menu01">
				{* display is in reverse order *}
				<a href="{getHREF page="configs.php" actionName="ShowConfigs" args="parentConfigGroupID=0"}"
					{toggleClass class1="system" class2="systemo" var="system" value=$useMenu}>{$smarty.const.TRANS_SYSTEM}<br /><img src="{$imageDirectory}/spacer.gif" width="114" height="1" alt="" title="" /></a>
				<a href="{getHREF page="modules.php" actionName="ShowSystemModuleInfo"}"
					{toggleClass class1="modules" class2="moduleso" var="modules" value=$useMenu}>{$smarty.const.TRANS_MODULES}<br /><img src="{$imageDirectory}/spacer.gif" width="114" height="1" alt="" title="" /></a>
				<a href="{getHREF page="products.php" actionName="ShowProducts"}"
					{toggleClass class1="products" class2="productso" var="products" value=$useMenu}>{$smarty.const.TRANS_PRODUCTS}<br /><img src="{$imageDirectory}/spacer.gif" width="114" height="1" alt="" title="" /></a>
				<a href="{getHREF page="events.php" actionName="ShowEvents"}"
					{toggleClass class1="events" class2="eventso" var="events" value=$useMenu}>{$smarty.const.TRANS_EVENTS}<br /><img src="{$imageDirectory}/spacer.gif" width="114" height="1" alt="" title="" /></a>
				<a href="{getHREF page="invoices.php" actionName="ShowInvoices"}"
					{toggleClass class1="finances" class2="financeso" var="finances" value=$useMenu}>{$smarty.const.TRANS_FINANCES}<br /><img src="{$imageDirectory}/spacer.gif" width="114" height="1" alt="" title="" /></a>
				<a href="{getHREF page="helpdesk.php" actionName="ShowHelpdesk"}"
					{toggleClass class1="helpdesk" class2="helpdesko" var="helpdesk" value=$useMenu}>{$smarty.const.TRANS_HELPDESK}<br /><img src="{$imageDirectory}/spacer.gif" width="114" height="1" alt="" title="" /></a>
				<a href="{getHREF page="clients.php" actionName="ShowClientStats"}"
					{toggleClass class1="clients" class2="clientso" var="clients" value=$useMenu}>{$smarty.const.TRANS_CLIENTS}<br /><img src="{$imageDirectory}/spacer.gif" width="100" height="1" alt="" title="" /></a>
			</div>{* menu01 *}
		</div>{* top *}
		<div class="amenu">
			<div style="clear:both"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" /></div>
			{*
			<div style="float: right; margin-right: 10px; margin-top: 4px;">{include file="$tplDirectory/widgets/showToDos.tpl"}</div> {include file="$tplDirectory/widgets/showBookmarks.tpl"}
			*}
			<div style="float: left; margin-left: 5px; margin-top: 4px;">
				{include file="$tplDirectory/widgets/showBookmarks.tpl"}
			</div>
			<div style="float: right; margin-right: 0px; margin-top: 4px;">
				{include file="$tplDirectory/widgets/showSearchBox.tpl"}
			</div>
			<div style="clear:both"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" /></div>
		</div>{* amenu *}
	</td>
</tr>
<tr>
	<td class="bg" valign="top" style="-height:80%">{* see note below *}
		<div style="vertical-align:top;">
			<div class="block01">
				{* only all the following sub-menus if a sub menu file exists *}
				{if $sideNavMajor==""}
					{assign var="sideNavMajor" value=$useMenu}
				{/if}
				{if $sideNavMajor=="clients" 	||
					$sideNavMajor=="finances" 	||
					$sideNavMajor=="helpdesk" 	||
					$sideNavMajor=="events" 	||
					$sideNavMajor=="products" 	||
					$sideNavMajor=="modules" 	||
					$sideNavMajor=="migrate" 	||
					$sideNavMajor=="system"}
					{include file="$tplDirectory/widgets/menus/sideMenuMajor_$sideNavMajor.tpl"}
				{/if}
			</div>{* block01 *}
			<div class="box00"><img src="{$imageDirectory}/spacer.gif" width="1" height="10" alt="" title="" /></div>
			<div class="block02">{* required open div -- do not remove or close *}
				{if $parentName==""}
					{assign var="parentName" value=$sideNavMajor}
				{/if}
				{include file="$tplDirectory/widgets/pageInfo.tpl" parentName=$parentName childName=$childName}
				<div class="loginInfo">
					{if $recording}
					<span id="recordAdminActions"><a href="{getHREF page="admins.php" actionName="RecordAdminActions"}"
					<img src="{$imageDirectory}/loadingcr.gif" width="13" height="13" alt="" title="" />Stop Recording</a></span>
					{else}
					<span id="recordAdminActions"></span>
					{/if}
					{strip}
                    &nbsp;
                    <img src="{$imageDirectory}/ico/homeicon.gif" width="13" height="13" align="middle" alt="" title="" style="vertical-align:middle;border-style:none;" />
					<a href="{getHREF page="todos.php" actionName="ShowTodos"}">
                        {$smarty.const.TRANS_HOME}
                    </a>
                    &nbsp;
                    <img src="{$imageDirectory}/ico/022.gif" width="13" height="13" align="middle" alt="" title="" style="vertical-align:middle;border-style:none;" />
					{$smarty.const.TRANS_LOGGED_IN_AS}: <strong>{$loginUsername}</strong>
                    &nbsp;
                    <img src="{$imageDirectory}/ico/024.gif" width="13" height="13" align="middle" alt="" title="" style="vertical-align:middle;border-style:none;" />
					<a href="{getHREF page="admins.php" actionName="EditMyProfile"}">
                        {$smarty.const.TRANS_PROFILE}
                    </a>
					&nbsp;
                    <img src="{$imageDirectory}/ico/023.gif" width="13" height="13" align="middle" alt="" title="" style="vertical-align:middle;border-style:none;" />
					<a href="{getHREF page="login.php" actionName="LogoutResponse"}">
                        {$smarty.const.TRANS_LOGOFF}
                    </a>
					{/strip}
				</div>{* loginInfo *}
				<div class="hashLine"><img src="{$imageDirectory}/spacer.gif" width="1" height="4" alt="" title="" /></div>
				<div class="block03">{* required open div -- do not remove or close *}

				{if $systemQueue.systemQueueRunning && $systemQueue.systemQueueStop!=1 && $hideEventStatusBar!=1}
					{include file="$tplDirectory/widgets/showEventStatus.tpl"}
				{/if}

{*
 * Note: Leave the <td> above open. It will be closed at the top of the footer.tpl file.
 * Example: "header.tpl <td>" some content "</td> footer.tpl"
 *}