{t c="TRANS_MANAGE_MIGRATIONS" d="Manage Migrations"}
{t c="TRANS_INTRODUCTION" d="Introduction"}
{t c="TRANS_CONFIGURE_MIGRATION" d="Configure Migration"}
{t c="TRANS_CONTINUE_CONFIGURED" d="Continue Configured Migration"}

{t c="TRANS_MIGRATION_INTRO_DESC" d="<p>Welcome to the ModernBill Migration Manager. ModernBill version 5 has a multi-system migration manager designed to migrate client information from any system into ModernBill version 5. The migration manager is capable of migrating clients incrementally and decrementally, meaning that you can go forwards and backwards in the process, browsing other parts of the system at any point. The migration manager is also capable of keeping external references to internal configuration, most likely clients, packages, and perhaps invoices and subscriptions. These references may be kept even after the migration is complete, and may be used by the system to link to outside systems for archival purposes.</p><p>In order to properly deal with migrations from many systems, the migration manager does not create corresponding configuration from each system since configuration will likely overlap. In order to allow configuration consolidation, the migration manager needs to have corresponding kinds of configuration associated between the systems. For example, products and modules in one system need to be associated with the corresponding products and modules in this system. Many of the same kind of configuration in the external system may be associated with one of the same kind in this system.</p><p>Currently, it only supports ModernBill version 4.4 migration, invoicing for starting balances.</p>"}

{t c="TRANS_MIGRATION_MB4_INTRO_DESC" d="<p>Before you can start a ModernBill version 4.4 migration, you need the following configured in ModernBill Version 5 which correspond to ModernBill Version 4.4:</p><ul><li>Products</li><li>Panels</li><li>Registrars</li></ul>"}

{t c="TRANS_MIGRATION_UTF8" d="<p>At least for now, you must have your ModernBill version 4.4 database in UTF-8 encoding. There are instructions on <a href='http://kb.modernbill.com/index.php?article=93'>how to convert your database to UTF-8</a> in the knowledge base.</p>"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_MIGRATIONS"
	childName="TRANS_INTRODUCTION"
	sideNavMajor="migrate"
	sideNavMinor="migrate"}
	
	{$smarty.const.TRANS_MIGRATION_INTRO_DESC}
	<h6>{$smarty.const.TRANS_MODERNBILL4}</h6>
	{$smarty.const.TRANS_MIGRATION_MB4_INTRO_DESC}
	{$smarty.const.TRANS_MIGRATION_UTF8}
	
	<p>
		<div class="rm" style="float: left;"><a class="submit" href="{getHREF page="migrate.php" actionName="ShowMigrationConfigs"}">{$smarty.const.TRANS_SHOW_MIGRATIONS}</a></div>
	</p>
	<p>
		<div class="rm" style="float: left;"><a class="submit" href="{getHREF page="migrate.php" actionName="AddMigrationConfig"}">{$smarty.const.TRANS_ADD_MIGRATION}</a></div>
	</p>
{include file="$tplDirectory/footer.tpl"}
