{* $Id: RemoveNews.tpl,v 1.9 2006/06/23 23:05:39 bsmith Exp $
 * --------------------------------------------------------------
 * This template displays a form to remove an existing news article. The form should be
 * prepopulated with the given data as to identify which news article is being removed.
 *
 * Smarty Variables:
 *	$news -- An array of data about the given news article. This array has the following
 *	         structure:
 *	           newsID --  The ID of the news article
 *	           newsGroupID -- The ID of the news group that this news article belongs to
 *	           newsGroupName -- The name of the news group
 *	           newsGroupDescription -- The description of the news group
 *	           newsGroupActive -- 1 if the news group is active, or 0 if otherwise
 *	           adminID -- The ID of the admin who created the news article
 *             adminUsername -- The username of the admin
 *	           adminFirstName -- The first name of the admin
 *	           adminLastName -- The last name of the admin
 *	           adminEmail -- The email address of the admin
 *	           adminActive -- 1 if the admin is active, or 0 if otherwise
 *	           newsSubject -- The subject of the news article
 *	           newsShortBody -- The short representation of the news article body
 *	           newsBody -- The full body of this news article
 *	           newsDateCreated -- The UNIX timestamp of when this news article was created
 *	           newsActive -- 1 if this news is active for viewing, or 0 if otherwise
 *	           priorityID -- The integer ID of the priority that is associated with this news article
 *}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_HELPDESK"
	childName="TRANS_NEWS"
	grandchildName="TRANS_REMOVE"
	sideNavMajor="helpdesk"
	sideNavMinor="news"}
<table width="770" cellpadding="0" cellspacing="0" border="0" class="list">
<thead>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ID" headerClass="firstTD"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_SUBJECT"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ACTIVE"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_PRIORITY"}
</tr>
</thead>

<tbody>
<tr class="{cycle values="alt1,alt2"}">
	<td>{$article.newsID}</td>
	<td>{$article.newsSubject}</td>
	<td>{$article.newsActive|getArrayValueByID:$activeInactive}</td>
	<td>{$article.priorityID|getArrayValueByID:$priorities}</td>
</tr>

<tr class="{cycle values="alt1,alt2"}">
	<td>&nbsp;</td>
	<td>
		<form action="news.php" method="post">
		<input type="hidden" name="action" value="{getActionID action="RemoveNewsResponse"}" />
		<input type="hidden" name="newsID" value="{$article.newsID}" />
		<input type="hidden" name="sid" value="{$sid}" />
		<input type="submit" class="submit" value="{$smarty.const.TRANS_REMOVE}" />
		</form>
	</td>
	<td>
		<form action="news.php" method="post">
		<input type="hidden" name="action" value="{getActionID action="EditNews"}" />
		<input type="hidden" name="newsID" value="{$article.newsID}" />
		<input type="hidden" name="sid" value="{$sid}" />
		<input type="submit" class="submit" value="{$smarty.const.TRANS_CANCEL}" />
		</form>
	</td>
	<td>&nbsp;</td>
</tr>
</tbody>
</table>

{include file="$tplDirectory/footer.tpl"}