{* $Id: RemoveNewsGroup.tpl,v 1.8 2006/06/23 23:05:39 bsmith Exp $
 * --------------------------------------------------------------
 * This template displays a form to verify the removal of a news group. This template
 * is provided an array of information about the news group about to be removed, and
 * can display that information to the user. This template should contain a form that
 * posts the newsGroupID to the RemoveNewsGroupResponse action of news.php, and also
 * a cancel option, that returns to the ShowNewsGroups action.
 *
 * Smarty Variables:
 *	$newsGroup -- An array of news group information with the following elements:
 *	                newsGroupID -- The ID of the news group we're editing. This should be set
 *	                               as a hidden form field so that the EditNewsGroupResponse
 *	                               action knows which news group to apply the changes to.
 *	                newsGroupName -- The current name of the news group.
 *	                newsGroupDescription -- The current description of the news group.
 *	                newsGroupActive -- 1 if this news group is currently active and can
 *	                                   receive new news articles, or 0 if otherwise.
 *}
{t c="TRANS_NEWS_GROUP_REMOVE_NOTICE" d="Removing this news group will remove all articles inside this group."}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_HELPDESK"
	childName="TRANS_NEWS"
	grandchildName="TRANS_REMOVE"
	sideNavMajor="helpdesk"
	sideNavMinor="news"}

{include file="$tplDirectory/widgets/showInvalidCustom.tpl" message=$smarty.const.TRANS_NEWS_GROUP_REMOVE_NOTICE}

<table width="770" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ID" headerClass="firstTD"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_NAME"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_DESCRIPTION"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ACTIVE"}
</tr>
</thead>

<tbody>
<tr class="{cycle values="alt1,alt2"}">
	<td>{$newsGroup.newsGroupID}</td>
	<td>{$newsGroup.newsGroupName}</td>
	<td>{$newsGroup.newsGroupDescription}</td>
	<td>{$newsGroup.newsGroupActive|getArrayValueByID:$activeInactive}</td>
</tr>

<tr class="{cycle values="alt1,alt2"}">
	<td>&nbsp;</td>
	<td>
		<form method="post" action="news.php">
		<input type="hidden" name="action" value="{getActionID action="RemoveNewsGroupResponse"}">
		<input type="hidden" name="sid" value="{$sid}" />
		<input type="hidden" name="newsGroupID" value="{$newsGroup.newsGroupID}">
		<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_REMOVE}">
		</form>
	</td>
	<td>
		<form method="post" action="news.php">
		<input type="hidden" name="action" value="{getActionID action="ShowNewsGroups"}">
		<input type="hidden" name="sid" value="{$sid}" />
		<input type="hidden" name="newsGroupID" value="{$newsGroup.newsGroupID}">
		<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_CANCEL}"><br />
		</form>
	</td>
	<td>&nbsp;</td>
</tr>
</tbody>
</table>

{include file="$tplDirectory/footer.tpl"}