{* $Id: ShowNews.tpl,v 1.8 2006/06/23 23:05:39 bsmith Exp $
 * --------------------------------------------------------------
 * This template displays a list of news articles. All pieces of data associated with a
 * news article are available in the $news variable, which is an array of news articles.
 *
 * Smarty Variables:
 *	$news -- an array of news articles, who every element is an array of news article information
 *	         That information is structured as follows (below is listed the elements of every article):
 *	           newsID --  The ID of the news article
 *	           newsGroupID -- The ID of the news group that this news article belongs to
 *	           newsGroupName -- The name of the news group
 *	           newsGroupDescription -- The description of the news group
 *	           newsGroupActive -- 1 if the news group is active, or 0 if otherwise
 *	           adminID -- The ID of the admin who created the news article
 *             adminUsername -- The username of the admin
 *	           adminFirstName -- The first name of the admin
 *	           adminLastName -- The last name of the admin
 *	           adminEmail -- The email address of the admin
 *	           adminActive -- 1 if the admin is active, or 0 if otherwise
 *	           newsSubject -- The subject of the news article
 *	           newsShortBody -- The short representation of the news article body
 *	           newsBody -- The full body of this news article
 *	           newsDateCreated -- The UNIX timestamp of when this news article was created
 *	           newsActive -- 1 if this news is active for viewing, or 0 if otherwise
 *	           priorityID -- The integer ID of the priority that is associated with this news article
 *}
{t c="TRANS_MANAGE_HELPDESK" d="Manage Helpdesk"}
{t c="TRANS_NEWS" d="News"}
{t c="TRANS_ADD_NEWS_GROUP" d="Add News Group"}
{t c="TRANS_ADD_NEWS" d="Add News"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_HELPDESK"
	childName="TRANS_NEWS"
	sideNavMajor="helpdesk"
	sideNavMinor="news"}
<table width="770" cellpadding="0" cellspacing="0" border="0" class="list">
<thead>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_ID" sortColumn="newsGroupID" headerClass="firstTD"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_NAME" sortColumn="newsGroupName"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_DESCRIPTION" sortColumn="newsGroupDescription"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_ACTIVE" sortColumn="newsGroupActive"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ACTION" headerClass="lastTD"}
</tr>
</thead>

{foreach from=$news item=n}
	<tr class="{cycle values="alt1,alt2"}" onClick="toggle('row_{$n.newsGroupID}');">
		<td>{$n.newsGroupID}</td>
		<td>{$n.newsGroupName}</td>
		<td>{$n.newsGroupDescription}</td>
		<td>{$n.newsGroupActive|getArrayValueByID:$activeInactive}</td>
		<td>
			<a href="{getHREF page="news.php" actionName="EditNewsGroup" args="newsGroupID=`$n.newsGroupID`"}">
				<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
			</a>
			<a href="{getHREF page="news.php" actionName="RemoveNewsGroup" args="newsGroupID=`$n.newsGroupID`"}">
				<img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DELETE}" title="{$smarty.const.TRANS_DELETE}" />
			</a>
		</td>
	</tr>
	<tbody id="row_{$n.newsGroupID}">
	<tr class="{cycle values="alt1,alt2"}">
		<td colspan="5">
			<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list" style="padding:10px">
			<thead>
			<tr class="headerRow">
				{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ID" headerClass="firstTD"}
				{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_SUBJECT"}
				{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_PRIORITY"}
				{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ACTIVE"}
				{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ACTION" headerClass="lastTD"}
			</tr>
			</thead>

			<tbody>
			{foreach from=$n.articles item=a}
				<tr class="{cycle values="alt1,alt2"}">
					<td>{$a.newsID}</td>
					<td>{$a.newsSubject}</td>
					<td>{$a.priorityID|getArrayValueByID:$priorities}</td>
					<td>{$a.newsActive|getArrayValueByID:$activeInactive}</td>
					<td>
						<a href="{getHREF page="news.php" actionName="EditNews" args="newsID=`$a.newsID`"}">
							<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
						</a>
						<a href="{getHREF page="news.php" actionName="RemoveNews" args="newsID=`$a.newsID`"}">
							<img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DELETE}" title="{$smarty.const.TRANS_DELETE}" />
						</a>
					</td>
				</tr>
			{foreachelse}
				<tr class="{cycle values="alt1,alt2"}">
					<td colspan="5">{$smarty.const.TRANS_NORESULTS}</td>
				</tr>
			{/foreach}
			</tbody>
			</table>
		</td>
	</tr>
	</tbody>
	<script language="javascript">
	//<[[CDATA][
	toggle('row_{$n.newsGroupID}');
	//]]>
	</script>
{foreachelse}
	<tbody>
	<tr class="{cycle values="alt1,alt2"}">
		<td colspan="5">{$smarty.const.TRANS_NORESULTS}</td>
	</tr>
	</tbody>
{/foreach}
</table>
{include file="$tplDirectory/widgets/paginationLinks.tpl"}
{include file="$tplDirectory/footer.tpl"}