{* $Id: ShowNewsGroups.tpl,v 1.7 2006/06/23 23:05:39 bsmith Exp $
 * --------------------------------------------------------------
 * This template displays a list of news groups, a link to add a new news group,
 * and for each news group in the list, a link to edit that news group, and remove
 * that news group. This template links to the actions AddNewsGroup, EditNewsGroup,
 * and RemoveNewsGroup.
 *
 * Smarty Variables:
 *	$newsGroups -- An array of news group information. Every element in this array
 *	               can be considered to be one news group, and as such, every
 *	               element is an array. Every news group has the following keys:
 *	                 newsGroupID  -- The ID of the news group.
 *	                 newsGroupName  -- The name of the news group.
 *	                 newsGroupDescription -- The description of the news group.
 *	                 newsGroupActive -- Either 1 or 0; 1 if the news group is active
 *	                                    and usable, or 0 if otherwise.
 *}

{t c="TRANS_NEWS_GROUPS" d="News Groups"}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_HELPDESK"
	childName="TRANS_NEWS_GROUPS"
	sideNavMajor="helpdesk"
	sideNavMinor="news"}

<table border="0" cellpadding="0" cellspacing="0" class="list" width="770">
<thead>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_ID" headerClass="firstTD" sortColumn="newsGroupID"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_NAME" sortColumn="newsGroupName"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_DESCRIPTION" sortColumn="newsGroupDescription"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_ACTIVE" sortColumn="newsGroupActive"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ACTIONS" headerClass="lastTD"}
</tr>
</thead>

<tbody>
{foreach from=$newsGroups item="ng"}
	<tr class="{cycle values="alt1,alt2"}">
		<td><a href="{getHREF page="news.php" actionName="EditNewsGroup" args="newsGroupID=`$ng.newsGroupID`"}">{$ng.newsGroupID}</a></td>
		<td>{$ng.newsGroupName}</td>
		<td>{$ng.newsGroupDescription}</td>
		<td>{$ng.newsGroupActive|getArrayValueByID:$activeInactive}</td>
		<td>
			<a href="{getHREF page="news.php" actionName="EditNewsGroup" args="newsGroupID=`$ng.newsGroupID`"}">
				<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
			</a>
			<a href="{getHREF page="news.php" actionName="RemoveNewsGroup" args="newsGroupID=`$ng.newsGroupID`"}">
				<img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_REMOVE}" title="{$smarty.const.TRANS_REMOVE}" />
			</a>
		</td>
	</tr>
{foreachelse}
	<tr class="{cycle values="alt1,alt2"}">
		<td>{$smarty.const.TRANS_NORESULTS}</td>
	</tr>
{/foreach}
</tbody>
</table>

{include file="$tplDirectory/footer.tpl"}