{* $Id: EditLedgerGroupEntries.tpl,v 1.5 2006/03/22 00:48:06 kbailey Exp $
 * --------------------------------------------------------------
 * This template displays the ledger accounts management page.
 *
 * Smarty Variables:
 *	$entries (array of journal entries data)
 *		ledgerAccountID
 *		generalDescription
 * 		generalDebitAmount
 *		generalCreditAmount
 *      currencyID
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Kris Bailey

make sure the following code is in your action file using this tpl:


 *}

{t c="TRANS_PRODUCT_LEDGER_GROUPS" d="Ledger Groups"}
{t c="TRANS_EDIT_ENTRIES" d="Edit Entries"}
{t c="TRANS_EDIT_PRODUCT_LEDGER_ENTRIES" d="Edit Product Ledger Entries"}
{t c="TRANS_LEDGER_GROUP_NAME" d="Ledger Group Name"}
{t c="TRANS_FILTER_CURRENCIES" d="Filter Currencies"}
{t c="TRANS_FILTER_CYCLES" d="Filter Cycles"}
{t c="TRANS_LEDGER_ENTRIES" d="Ledger Entries"}
{t c="TRANS_LEDGER_ENTRIES_CURRENCY" d="Currency Of Ledger Entries"}
{t c="TRANS_LEDGER_GROUP_NAME_EXPLAINATION" d="A <b>descriptive name</b> for this group of ledger entries.  <br />For example: if these entries recorded the cost for this <b>product variant</b>, you might just want to enter <i>'Item Cost'</i> here."}
{t c="TRANS_FILTER_CURRENCIES_EXPLAINATION" d="Filter currencies act as a way for you to manage <b>when</b> the ledger entries in this group are created.<br />For example, if you had 2 order forms, one that used GBP and another that used USD, and you only had USD selected here, the ledger entries in this group would only be created when this product variant was purchased through your US Dollars order form."}
{t c="TRANS_FILTER_CYCLES_EXPLAINATION" d="Similar in nature to the filter currencies, filter cycles limit <b>when</b> the ledger entries in this group are created.  The purpose of this is so that you can have different ledger entries that happen when a product is purchased in a <i>monthly</i> cycle as opposed to a <i>yearly</i> (or any other period) cycle.<br />ie - a domain purchase for 1 year would have a different cost than a domain purchased on a 2 year cycle."}
{t c="TRANS_LEDGER_ENTRIES_CURRENCY_EXPLAINATION" d="Whatever currency you select here will be the currency of the ledger entries below."}
{t c="TRANS_LEDGER_ENTRIES_EXPLAINATION" d="Ledger entries are the way that accounting keeps track of everything.  An example of how you might want to keep track of the cost of a domain as accounting entries might be:<br /><table border='0' class='tab01'><tr><th>Account</th><th>Comment</th><th>Debit</th><th>Credit</th></tr><tr class='alt1'><td>Cash 1</td><td>Paid for a domain</td><td>0.00</td><td>7.95</td></tr><tr class='alt1'><td>Domain Cost of Goods</td><td>Domain Cost</td><td>7.95</td><td>0.00</td></tr></table><br />To learn more about accounting and how you can use it to keep track of things, just search the 'net for 'accounting tutorial', or go to your local library and check out a book."}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_PRODUCTS"
	childName="TRANS_PRODUCT_LEDGER_GROUPS"
	grandchildName="TRANS_EDIT_ENTRIES"
	sideNavMajor="products"}

<form name="ledgerform" method="post" action="products.php">
    <input type="hidden" name="sid" value="{$sid}">
    <input type="hidden" name="ledgerGroupID" value="{$ledgerGroupID}">
    <input type="hidden" name="productVariantID" value="{$productVariantID}">
    <input type="hidden" name="action" value="{getActionID action="EditLedgerGroupEntriesResponse"}">
{section name=i loop=$failreason}
	{include
	    file="$tplDirectory/widgets/showInvalidCustom.tpl"
	    message=$failreason[i]
	    identifier=$smarty.section.i.index
	    class="highlight"}
{/section}

    <table border="0" width="770" class="tab01">
        <tr>
            <td colspan="2">
            <div class="rm" style="float: right;"><a href="javascript:history.go(-1);">{$smarty.const.TRANS_BACK}</a></div>
            <h6>{$smarty.const.TRANS_EDIT_PRODUCT_LEDGER_ENTRIES}</h6>
            </td>
        </tr>
        <tr>
            <td class="alt2" valign="top" width="200">{include
	    						file="$tplDirectory/widgets/showTips.tpl"
	    						title="TRANS_LEDGER_GROUP_NAME"
	    						msg="TRANS_LEDGER_GROUP_NAME_EXPLAINATION"}</td>
            <td align="left" valign="top" class="alt1"><input type="text" size="50" name="ledgerGroupName" value="{$ledgerGroupName}"></td>
        </tr>
    </table>

    <table border="0" width="770" class="tab01">
		<tr>
			<td class="alt2" valign="top" width="50%">{include
	    						file="$tplDirectory/widgets/showTips.tpl"
	    						title="TRANS_FILTER_CURRENCIES"
	    						msg="TRANS_FILTER_CURRENCIES_EXPLAINATION"}</td>
			<td class="alt2" valign="top" width="50%">{include
	    						file="$tplDirectory/widgets/showTips.tpl"
	    						title="TRANS_FILTER_CYCLES"
	    						msg="TRANS_FILTER_CYCLES_EXPLAINATION"}</td>
		</tr>
		<tr>
			<td class="alt1" width="50%">
                        {include file="$tplDirectory/widgets/comboBox.tpl"
			comboTitleLeft=TRANS_SELECTED
			comboNameLeft="filterCurrencyIDs"
			comboOptionsLeft=$selectedCurrencies

			comboTitleRight=TRANS_SELECTABLE
			comboNameRight="selectableFilterCurrencyIDs"
			comboOptionsRight=$selectableCurrencies
			formName="ledgerform"
			submitName="suppress"}
						</td>

						<td class="alt1" width="50%">
                        {include file="$tplDirectory/widgets/comboBox.tpl"
			comboTitleLeft=TRANS_SELECTED
			comboNameLeft="filterCycleIDs"
			comboOptionsLeft=$selectedCycles

			comboTitleRight=TRANS_SELECTABLE
			comboNameRight="selectableFilterCycleIDs"
			comboOptionsRight=$selectableCycles
			formName="ledgerform"
			submitName="suppress"}
			</td>
		</tr>
	</table>


  <table border="0" width="770" class="tab01">
        <tr>
            <td class="alt2" align="right" width="200">{include
	    						file="$tplDirectory/widgets/showTips.tpl"
	    						title="TRANS_LEDGER_ENTRIES_CURRENCY"
	    						msg="TRANS_LEDGER_ENTRIES_CURRENCY_EXPLAINATION"}</td>
            <td valign="top" align="left" class="alt1"><select name="currencyID">
            {html_options options=$currencyIDs selected=$currencyID}
            </select></td>
        </tr>
   </table>

<table border="0" width="770" class="tab01">
  	<tr class="alt2">
  		<td>{include
	    						file="$tplDirectory/widgets/showTips.tpl"
	    						title="TRANS_LEDGER_ENTRIES"
	    						msg="TRANS_LEDGER_ENTRIES_EXPLAINATION"}</td>
	</tr>
</table>
<table border="0" width="770" cellpadding="15">
	<tr bgcolor="white">
		<td><br />
		<div align="center">
{include file="$tplDirectory/widgets/variantLedgerForm.tpl"
      containerClass="box01"
      containerName="leDiv"
      fieldPrefix="ledgerGroup"
      printScript=1
      currency=""
      formname="ledgerform"
      existingEntries=$existingEntries
      ledgerAccounts=$ledgerAccounts
      ledgerTypes=$ledgerTypes}

<div style="margin-left: 262px;"><input class="submit" type="submit" id="save" name="save" value="{$smarty.const.TRANS_SAVE}" onclick="selectAllOptions(document.ledgerform.elements['filterCurrencyIDs[]']);selectAllOptions(document.ledgerform.elements['filterCycleIDs[]']);"></div>
		</div>
<br />
		</td>
	</tr>
</table>
<br />

</form>


{include file="$tplDirectory/footer.tpl"}