{* $Id: EditTLD.tpl,v 1.17 2006/03/22 00:48:06 kbailey Exp $
 * --------------------------------------------------------------
 * This template displays a form to edit an existing client.
 *
 * Smarty Variables:
 *	$formValues (array of this clients data)
 *		clientID			A unique client ID
 *		clientFirstName		A client's first name
 *		clientLastName		A client's last name
 *		clientEmail			A client's email address
 *		clientCompany		A client's company name
 *		clientActive		The active state of a client
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_TLDID" d="TLD ID"}
{t c="TRANS_TLDS" d="TLDs"}
{t c="TRANS_TLD" d="TLD"}
{t c="TRANS_MANAGE_PRODUCTS" d="Manage Products"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_EDIT_TLD" d="Edit TLD"}
{t c="TRANS_RESET" d="Reset"}

{t c="TRANS_ID" d="ID"}
{t c="TRANS_NAME" d="Name"}
{t c="TRANS_EXTENSION" d="Extension"}
{t c="TRANS_WHOIS_SERVER" d="Whois Server"}
{t c="TRANS_WHOIS_RESPONSE" d="Whois Response"}
{t c="TRANS_ACCEPTED" d="Accepted"}
{t c="TRANS_ACCEPTABLE" d="Acceptable"}
{t c="TRANS_UNACCEPTABLE" d="Unacceptable"}
{t c="TRANS_AUTO_SEARCH" d="Auto Search"}
{t c="TRANS_TRANSFER_MINIMUM_CYCLE" d="Transfer Minimum Term"}
{t c="TRANS_MINIMUM_TERM" d="Minimum Term"}
{t c="TRANS_MAXIMUM_TERM" d="Maximum Term"}
{t c="TRANS_LOCAL_RENEW_TYPE" d="Local Renew Type"}
{t c="TRANS_IS_TRANSFERABLE" d="Is Transferable"}
{t c="TRANS_TRANSFER_TYPE" d="Transfer Type"}
{t c="TRANS_IDN_SUPPORT" d="IDN Support"}
{t c="TRANS_IDN_TYPE" d="IDN Type"}
{t c="TRANS_REMOTE_LOCK" d="Remote Lock"}
{t c="TRANS_REMOTE_AUTORENEW" d="Remote Autorenew"}
{t c="TRANS_REGISTRAR" d="Registrar"}
{t c="TRANS_ACTIONS" d="Actions"}

{t c="TRANS_YEAR" d="Year"}
{t c="TRANS_ENABLED" d="Enabled"}

{t c="TRANS_ORDER_FORMS" d="Order Forms"}
{t c="TRANS_ORDER_FORM_ID" d="Order Form ID"}
{t c="TRANS_ORDER_FORM_NAME" d="Order Form Name"}

{t c="TRANS_CYCLES" d="Cycles"}

{t c="TRANS_SELECTED" d="Selected"}
{t c="TRANS_SELECTABLE" d="Selectable"}

{t c="TRANS_CURRENCY_ID" d="Currency ID"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_PRODUCTS"
	childName="TRANS_TLDS"
	grandchildName="TRANS_EDIT"
	sideNavMajor="products"
	sideNavMinor="tlds"}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

{include file="$tplDirectory/widgets/context/tld.tpl" tld=$TLD}

<form name="editTLD" method="post" action="products.php">
<input type="hidden" name="action" value="{getActionID action="EditTLDResponse"}">
<input type="hidden" name="tldID" value="{$formValues.tldID}">
<input type="hidden" name="sid" value="{$sid}">

<table  width="770" border="0" cellpadding="0" cellspacing="3" class="tab01" >
<tbody>
<tr>
	<th scope="col" colspan="2">{$smarty.const.TRANS_TLD}</th>
</tr>
<tr class="{cycle values="alt1,alt2"}">
	<th class="nowrap" scope="row"><label for="tldID">{$smarty.const.TRANS_TLDID}</label></th>
	<td width="100%">{$formValues.tldID}</td>
</tr>
<tr class="{if $invalid.tldName}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="tldName">{$smarty.const.TRANS_NAME}</label></th>
	<td width="100%"><input size="80"	maxlength="100" type="text" id="tldName" name="tldName" value="{$formValues.tldName}" /> {$invalid.tldName}</td>
</tr>
<tr class="{if $invalid.tldExtension}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="tldExtension">{$smarty.const.TRANS_EXTENSION}</label></th>
	<td width="100%"><input size="25" maxlength="25" type="text" id="tldExtension" name="tldExtension" value="{$formValues.tldExtension}" /> {$invalid.tldExtension}</td>
</tr>
<tr class="{if $invalid.registrarID}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="registrarID">{$smarty.const.TRANS_REGISTRAR}</label></th>
	<td width="100%"><select id="registrarID" name="registrarID"> {html_options options=$registrars selected=$formValues.registrarID} </select> {$invalid.registrarID}</td>
</tr>
<tr class="{if $invalid.tldAccepted}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="tldActive">{$smarty.const.TRANS_ACTIVE}</label></th>
	<td width="100%">
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="tldActive" value="0">
		<input type="checkbox" id="tldActive" name="tldActive" value="1" {strip}
			{if $formValues.tldActive}
				checked="checked"
			{/if}
		{/strip} /> <label for="tldActive">{$smarty.const.TRANS_ACTIVE}</label>
		{$invalid.tldActive}
	</td>
</tr>
<tr class="{if $invalid.tldWhoisServer}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="tldWhoisServer">{$smarty.const.TRANS_WHOIS_SERVER}</label></th>
	<td width="100%"><input size="80" 	maxlength="100" type="text" id="tldWhoisServer" name="tldWhoisServer" value="{$formValues.tldWhoisServer}" /> {$smarty.const.TRANS_OVERRIDE} {$invalid.tldWhoisServer}</td>
</tr>
<tr class="{if $invalid.tldWhoisResp}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="tldWhoisResp">{$smarty.const.TRANS_WHOIS_RESPONSE}</label></th>
	<td width="100%"><input size="80" 	maxlength="100" type="text" id="tldWhoisResp" name="tldWhoisResp" value="{$formValues.tldWhoisResp}" /> {$smarty.const.TRANS_OVERRIDE} {$invalid.tldWhoisResp}</td>
</tr>
<tr class="{if $invalid.tldAutoSearch}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="tldAutoSearch">{$smarty.const.TRANS_AUTO_SEARCH}</label></th>
	<td width="100%">
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="tldAutoSearch" value="0">
		<input type="checkbox" id="tldAutoSearch" name="tldAutoSearch" value="1" {strip}
			{if $formValues.tldAutoSearch}
				checked="checked"
			{/if}
		{/strip} /> <label for="tldAutoSearch">{$smarty.const.TRANS_ENABLED}</label>
		{$invalid.tldAutoSearch}
	</td>
</tr>
<tr class="{if $invalid.tldIsTransferable}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="tldIsTransferable">{$smarty.const.TRANS_IS_TRANSFERABLE}</label></th>
	<td width="100%">
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="tldIsTransferable" value="0">
		<input type="checkbox" id="tldIsTransferable" name="tldIsTransferable" value="1" {strip}
			{if $formValues.tldIsTransferable}
				checked="checked"
			{/if}
		{/strip} /> <label for="tldIsTransferable">{$smarty.const.TRANS_YES}</label>
		{$invalid.tldIsTransferable}
	</td>
</tr>
<tr class="{if $invalid.tldTransferType}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="tldTransferType">{$smarty.const.TRANS_TRANSFER_TYPE}</label></th>
	<td width="100%"><select id="tldTransferType" name="tldTransferType"> {html_options options=$transferTypes selected=$formValues.tldTransferType} </select> {$invalid.tldTransferType}</td>
</tr>
<tr class="{if $invalid.tldTransferMinimumCycleID}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="tldTransferMinimumCycleID">{$smarty.const.TRANS_TRANSFER_MINIMUM_CYCLE}</label></th>
	<td width="100%"><select id="tldTransferMinimumCycleID" name="tldTransferMinimumCycleID"> {html_options options=$cycleList selected=$formValues.tldTransferMinimumCycleID} </select> {$invalid.tldTransferMinimumCycleID}</td>
</tr>
<tr class="{if $invalid.tldMinimumCycleID}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="tldMinimumCycleID">{$smarty.const.TRANS_MINIMUM_TERM}</label></th>
	<td width="100%"><select id="tldMinimumCycleID" name="tldMinimumCycleID"> {html_options options=$cycleList selected=$formValues.tldMinimumCycleID} </select> {$invalid.tldMinimumCycleID}</td>
</tr>
<tr class="{if $invalid.tldMaximumCycleID}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="tldMaximumCycleID">{$smarty.const.TRANS_MAXIMUM_TERM}</label></th>
	<td width="100%"><select id="tldMaximumCycleID" name="tldMaximumCycleID"> {html_options options=$cycleList selected=$formValues.tldMaximumCycleID} </select> {$invalid.tldMaximumCycleID}</td>
</tr>
<tr class="{if $invalid.tldRenewType}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="tldRenewType">{$smarty.const.TRANS_LOCAL_RENEW_TYPE}</label></th>
	<td width="100%"><select id="tldRenewType" name="tldRenewType"> {html_options options=$tldRenewTypes selected=$formValues.tldRenewType} </select> {$invalid.tldRenewType}</td>
</tr>
<tr class="{if $invalid.tldIDNSupport}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="tldIDNSupport">{$smarty.const.TRANS_IDN_SUPPORT}</label></th>
	<td width="100%">
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="tldIDNSupport" value="0">
		<input type="checkbox" id="tldIDNSupport" name="tldIDNSupport" value="1" {strip}
			{if $formValues.tldIDNSupport}
				checked="checked"
			{/if}
		{/strip} /> <label for="tldIDNSupport">{$smarty.const.TRANS_YES}</label>
		{$invalid.tldIDNSupport}
	</td>
</tr>
<tr class="{if $invalid.tldIDNType}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="tldIDNType">{$smarty.const.TRANS_IDN_TYPE}</label></th>
	<td width="100%"><select id="tldIDNType" name="tldIDNType"> {html_options options=$IDNTypes selected=$formValues.tldIDNType} </select> {$invalid.tldIDNType}</td>
</tr>
<tr class="{if $invalid.tldRemoteLockEnabled}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="tldRemoteLockEnabled">{$smarty.const.TRANS_REMOTE_LOCK}</label></th>
	<td width="100%">
		<!-- The hidden input is to make sure 0 is set if not checked, which is overridden if checked. PHP uses the last arg sent. -->
		<input type="hidden" name="tldRemoteLockEnabled" value="0">
		<input type="checkbox" id="tldRemoteLockEnabled" name="tldRemoteLockEnabled" value="1" {strip}
			{if $formValues.tldRemoteLockEnabled}
				checked="checked"
			{/if}
		{/strip} /> <label for="tldRemoteLockEnabled">{$smarty.const.TRANS_ENABLED}</label>
		{$invalid.tldRemoteLockEnabled}
	</td>
</tr>

<tr>
	<td colspan="2">
		<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_EDIT_TLD}" onClick="selectAllOptions(document.editTLD.elements['orderForms[]']);selectAllOptions(document.editTLD.elements['cycles[]']);" />
		<input class="reset" type="reset" value="{$smarty.const.TRANS_RESET}" />
	</td>
</tr>
</tbody>
</table>
</form>

{include file="$tplDirectory/footer.tpl"}