{* $Id: ShowProductVariants.tpl,v 1.11 2006/07/17 05:04:08 bwoolley Exp $
 * --------------------------------------------------------------
 * This template displays a list of product variants.
 *
 * Author: Ben Woolley
 *}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_TYPE" d="Type"}
{t c="TRANS_NAME" d="Name"}
{t c="TRANS_PRODUCT_VARIANT_ID" d="Product Variant ID"}
{t c="TRANS_VARIANT_ID" d="Variant ID"}
{t c="TRANS_COMMENTS" d="Comments"}
{t c="TRANS_DETAILS" d="Details"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_MANAGE_PRODUCTS" d="Manage Products"}
{t c="TRANS_NORESULTS" d="No Results"}
{t c="TRANS_REMOVE" d="Remove"}
{t c="TRANS_SHOW_PRODUCT_VARIANTS" d="Show Product Variants"}
{t c="TRANS_STATUS" d="Status"}
{t c="TRANS_TIMESTAMP" d="TimeStamp"}
{t c="TRANS_UNDEFINED" d="Undefined"}
{t c="TRANS_REGULAR" d="Regular"}
{t c="TRANS_DOMAIN" d="Domain"}
{t c="TRANS_CERT" d="Cert"}
{t c="TRANS_VARIATION_OF" d="Variation of"}
{t c="TRANS_VARIATION_FOR" d="Variation for"}
{t c="TRANS_ITSELF" d="Itself"}
{t c="TRANS_PRICING" d="Pricing"}
{t c="TRANS_EXPLAIN_PRODUCT_VARIANTS" d="Explain Product Variants"}
{t c="TRANS_VARIANT_EXPLANATION" d='<p><dfn>Product variants</dfn> are designed to handle variations in products which may affect pricing, known in the system as <dfn>product variables</dfn>. Prices are therefore managed through these product variants. One product may have multiple variants, which in turn may have multliple prices.</p><p>A product may have applied to it no product variable, or a single product variable. A product variable may have zero or more <dfn>product variable values</dfn>.</p><ul><li>If no variable is applied to a product, a single <dfn>implied variant</dfn> is created for handling the prices of the product itself. The result is always a single variant.</li><li>If a variable is applied to a product, the <em>variable values</em> are applied to the product in the form of <em>variants</em>. The result is a <em>variant</em> for each <em>value</em> of the <em>variable</em> applied.</li></ul><p>Currently, the only product variable is <var>TLD</var>, which is built-in, and automatically applied to all domain registration products. Soon, the system will handle <dfn>user-defined product variables</dfn>. Any of the product variants may be activated or deactivated, which essentially is a way to associate and disassociate product variants to their product. Clients will only be able to order <em>active</em> product variants.</p><p>When a new value is added to a variable, like a new <var>TLD</var>, an <em>inactive</em> variant is automatically applied to all products to which the variable has already been applied, maintaining consistency across variants, variables, and values. So too as in when a value is deleted, variants for the value are automatically deleted.</p><p>It is possible to abuse the product variant concept by using them instead of creating another product. Product variants should only be used for <em>stylistic</em> differences in products, otherwise some flexibility may be lost. A good example is a difference in size or color. For example, a T-shirt product may have a product variable of <kbd>size</kbd>, with values <kbd>small</kbd>, <kbd>medium</kbd>, <kbd>large</kbd>, and so on. Note that the values will have to cover all permutations of distinct combinations since only one variable may be applied. For example, <kbd>small/blue</kbd>, <kbd>small/red</kbd>, <kbd>medium/blue</kbd>, <kbd>medium/red</kbd>, and so on.</p>'}
{t c="TRANS_VARIANT_LEDGER_ENTRIES" d="Ledger<br />Entries"}
{t c="TRANS_ADD_LEDGER_ENTRY_GROUP" d="Add Ledger Entry Group"}

{assign var="filterArgs" value="productVariantActive=$productVariantActive"}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_PRODUCTS"
	childName="TRANS_SHOW_PRODUCT_VARIANTS"
	sideNavMajor="products"
	sideNavMinor="variants"}

    {include file="$tplDirectory/widgets/showTips.tpl"
        title="TRANS_EXPLAIN_PRODUCT_VARIANTS"
        msg="TRANS_VARIANT_EXPLANATION"
        width="100%"
        align="center"}

<table  width="770" border="0" cellpadding="0" cellspacing="3" class="tab01">
<thead>
<tr>
{t c="TRANS_ADDITIONAL_DATA" d="Display/Hide Additional Data"}
	<td colspan="7" style="cursor: pointer;" onclick="{strip} {section name=iter loop=$productVariants}
		toggle('row_{$productVariants[iter].productVariantID}'); {/section} {/strip}return false;"> <a href="javascript:void(0);"><img src="{$imageDirectory}/ico/data_down.gif" width="16" height="16" alt="" title="" border="0" /></a> {$smarty.const.TRANS_ADDITIONAL_DATA}
	</td>
</tr>
<tr>
	{include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_VARIANT_ID" sortColumn="productVariantID"}
	{include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_NAME" sortColumn="productVariantName"}
	{include file="$tplDirectory/widgets/table/tableFilterHeader.tpl" filterName="TRANS_STATUS" filterColumn="productVariantActive" filterOptions="$activeInactive"}
	{include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_VARIATION_OF"}
	{include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_VARIATION_FOR"}
	{include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_PRICING"}
	{include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_VARIANT_LEDGER_ENTRIES"}
</tr>
</thead>
{section name=i loop="$productVariants"}
{assign var="productVariantID" value=$productVariants[i].productVariantID}
{if $className=="alt1"}
    {assign var="className" value="alt2"}
{else}
    {assign var="className" value="alt1"}
{/if}
<tbody>
<tr class="{cycle values="alt1,alt2"}"
	onmouseover="this.className='althover';"
	onmouseout="this.className='{$className}';">
	<td onmouseover="this.style.cursor='hand'" onclick="return toggle('row_{$productVariantID}');">
		<a href="#p{$productVariantID}" name="p{$productVariantID}">{$productVariantID}</a>
	</td>
	<td>
		{$productVariants[i].productVariantDisplayName}
		{include
			file="$tplDirectory/widgets/quickEditLink.tpl"
			editID=$productVariantID
			editKey="productVariantID"
			editActionName="EditProductVariantResponse"
			editName="TRANS_NAME"
			editColumn="productVariantDisplayName"
			editValue=$productVariants[i].productVariantDisplayName}
	</td>
	<td align="center">
		{$productVariants[i].productVariantActive|getArrayValueByID:$activeInactive}
		{include
			file="$tplDirectory/widgets/quickEditCheckboxLink.tpl"
			editID=$productVariantID
			editKey="productVariantID"
			editActionName="EditProductVariantResponse"
			editName="TRANS_ACTIVE"
			editColumn="productVariantActive"
			editValue=$productVariants[i].productVariantActive}
	</td>
	<td>
		{assign var="productID" value=$productVariants[i].productID}
		<a href="{getHREF page="products.php" actionName="ShowProductDetails"}&productID={$productID}">{$products.$productID}</a>
	</td>
	<td>
		{assign var="tldID" value=$productVariants[i].tldID}
		{if $tldID}<a href="{getHREF page="products.php" actionName="ShowTLDs"}&tldID={$tldID}">{$TLDs.$tldID}</a> {$smarty.const.TRANS_TLD}{else}{$smarty.const.TRANS_ITSELF}{/if}
	</td>
	<td align="center" class="nowrap">
		{strip}
		{*
		<a href="{getHREF page="products.php" actionName="ShowProductVariants" args="productVariantID=$productVariantID"}">
			<img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DETAILS}" title="{$smarty.const.TRANS_DETAILS}" />
		</a>
		&nbsp;
		*}
		<a href="{getHREF page="products.php" actionName="EditProductVariantPrices" args="productVariantID=$productVariantID"}">
			<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DETAILS}" title="{$smarty.const.TRANS_DETAILS}" />
		</a>
		{/strip}
	</td>
	<td align="center" class="nowrap">
		{strip}
		<a href="javascript:toggle('row_{$productVariantID}');">
			<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DETAILS}" title="{$smarty.const.TRANS_DETAILS}" />
		</a>
		{/strip}
	</td>
</tr>
</tbody>
<tbody id="row_{$productVariantID}" class="off">
	{assign var="groups" value=$productVariants[i].ledgerGroups}
	{section name=j loop=$groups}
<tr>
	<td></td>
	<td colspan="5" class="{if $smarty.section.j.index%2==0}alt1{else}alt2{/if}">
			<a href="{getHREF page="products.php" actionName="EditLedgerGroupEntries" args="productVariantID=$productVariantID&ledgerGroupID=`$groups[j].ledgerGroupID`"}">{$groups[j].ledgerGroupName}</a>
	</td>
	<td align="center" class="{if $smarty.section.j.index%2==0}alt1{else}alt2{/if}">
		<a href="{getHREF page="products.php" actionName="EditLedgerGroupEntries" args="productVariantID=$productVariantID&ledgerGroupID=`$groups[j].ledgerGroupID`"}"><img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DETAILS}" title="{$smarty.const.TRANS_DETAILS}" /></a>
		<a href="{getHREF page="products.php" actionName="RemoveLedgerGroup" args="productVariantID=$productVariantID&ledgerGroupID=`$groups[j].ledgerGroupID`"}"><img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DELETE}" title="{$smarty.const.TRANS_DELETE}" /></a>
	</td>
</tr>
	{/section}
<tr>
	<td></td>
	<td colspan="6">
		<input class="button" type="button" value="{$smarty.const.TRANS_ADD_LEDGER_ENTRY_GROUP}" onclick="document.location.href='{getHREF page="products.php" actionName="EditLedgerGroupEntries" args="ledgerGroupID=0&productVariantID=$productVariantID"}';" />
	</td>
</tr>
</tbody>
{sectionelse}
<tr class="alt1">
	<td colspan="5">{$smarty.const.TRANS_NORESULTS}</td>
</tr>
{/section}
</table>

{include file="$tplDirectory/widgets/paginationLinks.tpl"}
{include file="$tplDirectory/footer.tpl"}
