{* $Id: ShowProducts.tpl,v 1.20 2006/06/29 01:26:04 mfountain Exp $
 * --------------------------------------------------------------
 * This template displays a list of products.
 *
 * Smarty Variables:
 *	$products (array of products that match criteria)
 *		$productID		    Product ID
 *		$productType		Product Type
 *		$productName		Product Name
 *		$productComments	Product Comments
 *		$productActive		Product Active
 *		$productDisplayOrder	Product Display Order
 *	$productActive			The $_REQUEST value of product Active filter option
 *	$productType			The $_REQUEST value of product Type filter option
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *  $sid					The current sessionID
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_TYPE" d="Type"}
{t c="TRANS_NAME" d="Name"}
{t c="TRANS_PRODUCTID" d="Product ID"}
{t c="TRANS_COMMENTS" d="Comments"}
{t c="TRANS_DETAILS" d="Details"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_MANAGE_PRODUCTS" d="Manage Products"}
{t c="TRANS_NORESULTS" d="No Results"}
{t c="TRANS_REMOVE" d="Remove"}
{t c="TRANS_SHOW_PRODUCTS" d="Show Products"}
{t c="TRANS_STATUS" d="Status"}
{t c="TRANS_TIMESTAMP" d="TimeStamp"}
{t c="TRANS_UNDEFINED" d="Undefined"}
{t c="TRANS_REGULAR" d="Regular"}
{t c="TRANS_DOMAIN" d="Domain"}
{t c="TRANS_CERT" d="Cert"}

{t c="TRANS_ADDITIONAL_DATA" d="Display/Hide Additional Data"}

{assign var="filterArgs" value="productType=$productType&productActive=$productActive"}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_PRODUCTS"
	childName="TRANS_SHOW_PRODUCTS"
	sideNavMajor="products"
	sideNavMinor="products"}

<table  width="770" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>
<tr>
	<td colspan="9" onmouseover="this.style.cursor='hand'" onclick="{strip} {section name=iter loop=$products}
		toggle('row_{$products[iter].productID}'); {/section} {/strip}return false;"> <a href="javascript:void(0);"><img src="{$imageDirectory}/ico/up_down.gif" width="13" height="16" alt="" title="" border="0" /></a> {$smarty.const.TRANS_ADDITIONAL_DATA}
	</td>
</tr>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" addEmptyTD=1 headerClass="firstTD" headerName="TRANS_PRODUCTID" sortColumn="productID" headerClass="firstTD"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" addEmptyTD=1 headerName="TRANS_NAME" sortColumn="productName"}
	{include file="$tplDirectory/widgets/table/listHeaderFilter.tpl" addEmptyTD=1 filterName="TRANS_TYPE" filterColumn="productType"}
	{include file="$tplDirectory/widgets/table/listHeaderFilter.tpl" addEmptyTD=1 filterName="TRANS_STATUS" filterColumn="productActive" filterOptions=$activeInactive}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerClass="lastTD" headerName="TRANS_ACTIONS" headerClass="lastTD"}
</tr>
</thead>
{section name=i loop="$products"}
{assign var="productID" value=$products[i].productID}
{if $className=="alt1"}
    {assign var="className" value="alt2"}
{else}
    {assign var="className" value="alt1"}
{/if}
<tbody>
<tr class="{cycle values="alt1,alt2"}"
	onmouseover="this.className='althover';"
	onmouseout="this.className='{$className}';">
	<td onmouseover="this.style.cursor='hand'" onclick="return toggle('row_{$productID}');">
		<img src="{$imageDirectory}/ico/arrow_down_blue.gif" width="13" height="16" alt="" title="" border="0" />
		{$productID}
	</td>
	<td class="spacer"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" /></td>
	<td>
		{$products[i].productName}
		{include
			file="$tplDirectory/widgets/quickEditLink.tpl"
			editID=$productID
			editKey="productID"
			editActionName="EditProductResponse"
			editName="TRANS_NAME"
			editColumn="productName"
			editValue=$products[i].productName}
	</td>
	<td class="spacer"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" /></td>
	<td>
		{$products[i].productType|getTypeName:"products"}
	</td>
	<td class="spacer"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" /></td>
	<td align="center">
		{$products[i].productActive|getArrayValueByID:$activeInactive}
	</td>
	<td class="spacer"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" /></td>
	<td align="center" class="nowrap">
		{strip}
        {include file="$tplDirectory/widgets/actionLink.tpl"
			page="products.php"
			actionName="ShowProductDetails"
			args="productID=$productID"
			icoImage="view"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_DETAILS"
			titleText=""
			linkText="TRANS_DETAILS"
			noSpace="1"
		}	
		&nbsp;
        {include file="$tplDirectory/widgets/actionLink.tpl"
			page="products.php"
			actionName="RemoveProduct"
			args="productID=$productID"
			icoImage="remove"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_REMOVE"
			titleText=""
			linkText="TRANS_REMOVE"
			noSpace="1"
		}
		{/strip}
	</td>
</tr>
</tbody>
<tbody id="row_{$productID}" class="off">
<tr>
	<td colspan="9" class="comments altinner">
		<b>{$smarty.const.TRANS_COMMENTS}:</b> {$products[i].productComments|default:$smarty.const.TRANS_NONE}<br />
	</td>
</tr>
</tbody>
{sectionelse}
<tr class="alt1">
	<td colspan="9">{$smarty.const.TRANS_NORESULTS}</td>
</tr>
{/section}
</table>

{include file="$tplDirectory/widgets/paginationLinks.tpl"}
{include file="$tplDirectory/footer.tpl"}