{* $Id: EditTaxZone.tpl,v 1.13 2006/06/19 21:48:58 mgarrett Exp $
 * --------------------------------------------------------------
 * This template displays a form to edit a tax zone. Note that for now, one is unable to 
 * change the administrator associated with a tax zone.
 *
 * Smarty Variables:
 *	$taxzone - The array representation of the current tax zone. This array is 
 *	               structured as follows:
 *                   taxZoneID --  The ID of the tax zone
 *      	         taxZoneName -- The zones within the country to apply taxes to
 *					 countriesISO2 -- The tax zone country
 *	                 taxZoneAmount -- The tax percentage. Allows a tax up to 999.999%
 *	                 taxZoneDescription -- Description of the tax used in invoices
 *      	         taxZoneActive -- 1 if the tax is active, or 0 if otherwise
 *	$countrylist -- List of countries to choose from. 
 *}

{t c="TRANS_MANAGE_TAX_ZONES" d="Manage Tax Zones"}
{t c="TRANS_EDIT_TAX_ZONE" d="Edit Tax Zone"}
{t c="TRANS_TAX_ZONE_GROUPS" d="Tax Zone Groups"}
{t c="TRANS_LEDGER_ACCOUNT" d="Ledger Account"}

{include
    file="$tplDirectory/header.tpl"
    parentName="TRANS_MANAGE_SYSTEM"
    childName="TRANS_MANAGE_TAXES"
    grandchildName="TRANS_MANAGE_TAX_ZONES"
    sideNavMajor="system"
   	sideNavMinor="taxes"
    parentConfigGroupID=0}

<h2>{$smarty.const.TRANS_EDIT_TAX_ZONE}</h2>
<form method="post" action="taxes.php" name="EditTaxes">
<input name="taxZoneID" type="hidden" value="{$taxzone.taxZoneID}" />
<input type="hidden" name="action" value="{getActionID action="EditTaxZoneResponse"}">
<input type="hidden" name="sid" value="{$sid}">

<table border="0" cellpadding="3" cellspacing="3" class="tab01">
    <tr>
        <th align="right" scope="row">{$smarty.const.TRANS_COUNTRY}</th>
        <td><select id="countriesISO2" name="countriesISO2">
{html_options options=$countryList selected=$taxzone.countriesISO2}
</select></td>
    </tr>
    <tr>
        <th align="right" scope="row">{$smarty.const.TRANS_TAX_ZONE_NAME}</th>
        <td><input type="text" name="taxZoneName" value="{$taxzone.taxZoneName}" /></td>
    </tr>
    <tr>
        <th align="right" scope="row">{$smarty.const.TRANS_TAX_ZONE_TYPE}</th>
        <td><select id="taxZoneAmountType" name="taxZoneAmountType">
            <option value="0">{$smarty.const.TRANS_PERCENTAGE}</option>
            <option value="1"{if $taxzone.taxZoneAmountType} selected="selected"{/if}>{$smarty.const.TRANS_SET_AMOUNT}</option>
        </select></td>
    </tr>
    <tr>
        <th align="right" scope="row">{$smarty.const.TRANS_TAX_ZONE_AMOUNT}</th>
        <td><input type="text" name="taxZoneAmount" value="{$taxzone.taxZoneAmount}" /></td>
    </tr>
    <tr>
        <th align="right" scope="row">{$smarty.const.TRANS_TAX_ZONE_DESCRIPTION}</th>
        <td><input type="text" name="taxZoneDescription" value="{$taxzone.taxZoneDescription}" /></td>
    </tr>

    <tr>
        <th align="right" scope="row">{$smarty.const.TRANS_TAX_ZONE_ACTIVE}</th>
        <td><select id="taxZoneActive" name="taxZoneActive">
{html_options options=$activeInactive selected=$taxzone.taxZoneActive}
</select></td>
    </tr>

	<tr>
		<th align="right" scope="row">{$smarty.const.TRANS_LEDGER_ACCOUNT}</th>
		<td><select name="ledgerAccountID">{include file="$tplDirectory/widgets/accountingLedgerSelect.tpl"
			selectedLedgerID=$taxzone.ledgerAccountID
			ledgerAccounts=$ledgerAccounts
			accountTypes=$accountTypes}</select></td>
	</tr>

    <tr>
		<th align="right" scope="row">{$smarty.const.TRANS_TAX_ZONE_GROUPS}</th>
		<td>
		{include file="$tplDirectory/widgets/comboBox.tpl"
			comboTitleLeft=TRANS_SELECTED
			comboNameLeft="taxZoneGroups"
			comboOptionsLeft=$selectedTaxZoneGroups

			comboTitleRight=TRANS_SELECTABLE
			comboNameRight="selectableTaxZoneGroups"
			comboOptionsRight=$selectableTaxZoneGroups
			formName="EditTaxes"
			submitName="suppress"
		}
		</td>
    </tr>

    <tr>
        <td></td>
        <td><input class="submit" type="submit" value="{$smarty.const.TRANS_SAVE}" onclick="selectAllOptions(document.EditTaxes.elements['taxZoneGroups[]']);"></td>
    </tr>
</table>


</form>


{include file="$tplDirectory/footer.tpl"}
