{* $Id: ShowTaxZoneGroups.tpl,v 1.5 2006/05/09 22:06:47 kbailey Exp $
 * --------------------------------------------------------------
 * This template displays a list of tax zones. All pieces of data associated with a 
 * tax zone are available in the $taxzones variable, which is an array of tax zones.
 *
 * Smarty Variables:
 *	$taxzone - The array representation of the current tax zone. This array is 
 *	               structured as follows:
 *                   taxZoneID --  The ID of the tax zone
 *      	         taxZoneName -- The zones within the country to apply taxes to
 *					 countriesISO2 -- The tax zone country
 *	                 taxZoneAmount -- The tax percentage. Allows a tax up to 999.999%
 *	                 taxZoneDescription -- Description of the tax used in invoices
 *      	         taxZoneActive -- 1 if the tax is active, or 0 if otherwise
 *}


{t c="TRANS_NO_TAX_ZONES" d="No Tax Zone Groups Found."}
{t c="TRANS_TAX_ZONE_AMOUNT" d="Amount"}
{t c="TRANS_TAX_ZONE_AMOUNT_TYPE" d="Type"}
{t c="TRANS_TAX_ZONES" d="Tax Zones"}
{t c="TRANS_ADD_TAX_ZONE" d="Add Tax Zone"}
{t c="TRANS_TAX_ZONE_GROUPS" d="Tax Zone Groups"}
{t c="TRANS_LEDGER_ACCOUNT" d="Ledger Account"}
{t c="TRANS_MANAGE_TAX_ZONE_GROUPS" d="Manage Tax Zone Groups"}
{t c="TRANS_ADD_TAX_ZONE_GROUP" d="Add Tax Zone Group"}
{t c="TRANS_NO_TAX_ZONE_GROUPS" d="No Tax Zone Groups Found"}

{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_SYSTEM"
	childName="TRANS_MANAGE_TAXES"
	grandchildName="TRANS_MANAGE_TAX_ZONE_GROUPS"
	sideNavMajor="system"
	sideNavMinor="taxes"
	parentConfigGroupID=0}

<table border="0" width="100%" cellpadding="3" cellspacing="3" class="tab01">

	<tr>
		<td colspan="4">
			<div class="rm" style="float: right;"><a href="taxes.php?action={getActionID action="AddTaxZoneGroup"}&sid={$sid}">{$smarty.const.TRANS_ADD_TAX_ZONE_GROUP}</a></div>
			<h2>{$smarty.const.TRANS_TAX_ZONE_GROUPS}</h2>
		</td>
	</tr>

	<tr>
		<td colspan="4" style="cursor: pointer;" onclick="{strip} {section name="i" loop=$taxGroups}
			toggle('group{$taxGroups[i].taxZoneGroupID}'); {/section} {/strip}return false;"> <a href="javascript:void(0);"><img src="{$imageDirectory}/ico/data_down.gif" width="16" height="16" alt="" title="" border="0" /></a> {$smarty.const.TRANS_ADDITIONAL_DATA}
		</td>
	</tr>

	<tr>
		{include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ID"}
		{include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_TAX_ZONE_GROUP_NAME"}
		{include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ACTIVE"}
		{include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ACTIONS"}
	</tr>

{section name="i" loop=$taxGroups}
	<tr class="{cycle values="alt1,alt2"}" style="cursor: pointer;">
        <td onclick="toggle('group{$taxGroups[i].taxZoneGroupID}');">{$taxGroups[i].taxZoneGroupID}</td>
        <td onclick="toggle('group{$taxGroups[i].taxZoneGroupID}');">{$taxGroups[i].taxZoneGroupName}</td>
        <td onclick="toggle('group{$taxGroups[i].taxZoneGroupID}');">{$taxGroups[i].taxZoneGroupActive|getArrayValueByID:$activeInactive}</td>
        <td width="54">
        {strip}
        <a href="taxes.php?action={getActionID action="EditTaxZoneGroup"}&taxZoneGroupID={$taxGroups[i].taxZoneGroupID}&sid={$sid}">
            <img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
        </a>
        &nbsp;
        <a href="taxes.php?action={getActionID action="RemoveTaxZoneGroup"}&taxZoneGroupID={$taxGroups[i].taxZoneGroupID}&sid={$sid}">
            <img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_REMOVE}" title="{$smarty.const.TRANS_REMOVE}" />
        </a>
        {/strip}
        </td>
	</tr>
	<tbody id="group{$taxGroups[i].taxZoneGroupID}" class="off">
	<tr>
		<td colspan="4" valign="top" xstyle="border-bottom: 1px dashed #333;">
			<table width="100%" border="0" cellpadding="1" cellspacing="1" class="addData">
                <tr>
                    <th colspan="4"><strong>{$smarty.const.TRANS_TAX_ZONES}</strong></th>
                </tr>

                {section name="j" loop=$taxGroups[i].taxZones.0.taxZone}
				<tr class="{if $smarty.section.j.index%2==0}alt1{else}alt2{/if}">
					<td>{$taxGroups[i].taxZones.0.taxZone[j].taxZoneID}</td>
					<td>{$taxGroups[i].taxZones.0.taxZone[j].taxZoneName}</td>
					<td>{$taxGroups[i].taxZones.0.taxZone[j].taxZoneDescription}</td>
					<td>{$taxGroups[i].taxZones.0.taxZone[j].countriesISO2} - {$taxGroups[i].taxZones.0.taxZone[j].countryName}</td>
				</tr>
                {/section}

            </table></td>
	</tr>
	</tbody>
{sectionelse}
    <tr>
        <td colspan="8" class="alt1">{$smarty.const.TRANS_NO_TAX_ZONE_GROUPS}</td>
    </tr>
{/section}


</table>

{include file="$tplDirectory/widgets/paginationLinks.tpl"}


{include file="$tplDirectory/footer.tpl"}
