{* $Id: ShowTaxZones.tpl,v 1.9 2006/03/22 00:48:06 kbailey Exp $
 * --------------------------------------------------------------
 * This template displays a list of tax zones. All pieces of data associated with a 
 * tax zone are available in the $taxzones variable, which is an array of tax zones.
 *
 * Smarty Variables:
 *	$taxzone - The array representation of the current tax zone. This array is 
 *	               structured as follows:
 *                   taxZoneID --  The ID of the tax zone
 *      	         taxZoneName -- The zones within the country to apply taxes to
 *					 countriesISO2 -- The tax zone country
 *	                 taxZoneAmount -- The tax percentage. Allows a tax up to 999.999%
 *	                 taxZoneDescription -- Description of the tax used in invoices
 *      	         taxZoneActive -- 1 if the tax is active, or 0 if otherwise
 *}


{t c="TRANS_NO_TAX_ZONES" d="No Tax Zones Found."}
{t c="TRANS_TAX_ZONE_AMOUNT" d="Amount"}
{t c="TRANS_TAX_ZONE_AMOUNT_TYPE" d="Type"}
{t c="TRANS_TAX_ZONES" d="Tax Zones"}
{t c="TRANS_ADD_TAX_ZONE" d="Add Tax Zone"}
{t c="TRANS_TAX_ZONE_GROUPS" d="Tax Zone Groups"}
{t c="TRANS_LEDGER_ACCOUNT" d="Ledger Account"}

{include
    file="$tplDirectory/header.tpl"
    parentName="TRANS_MANAGE_SYSTEM"
    childName="TRANS_MANAGE_TAXES"
    grandchildName="TRANS_MANAGE_TAX_ZONES"
    sideNavMajor="system"
   	sideNavMinor="taxes"
    parentConfigGroupID=0}

<table border="0" width="100%" cellpadding="3" cellspacing="3" class="tab01">

	<tr>
		<td colspan="8">
			<div class="rm" style="float: right;"><a href="taxes.php?action={getActionID action="AddTaxZone"}&sid={$sid}">{$smarty.const.TRANS_ADD_TAX_ZONE}</a></div>
			<h2>{$smarty.const.TRANS_TAX_ZONES}</h2>
		</td>
	</tr>

	<tr>
		<td colspan="8" style="cursor: pointer;" onclick="{strip} {section name="i" loop=$taxzones}
			toggle('zonerow{$taxzones[i].taxZoneID}'); {/section} {/strip}return false;"> <a href="javascript:void(0);"><img src="{$imageDirectory}/ico/data_down.gif" width="16" height="16" alt="" title="" border="0" /></a> {$smarty.const.TRANS_ADDITIONAL_DATA}
		</td>
	</tr>


    <tr>
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ID"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_COUNTRY"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_TAX_ZONE_NAME"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_TAX_ZONE_AMOUNT"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_TAX_ZONE_AMOUNT_TYPE"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_TAX_ZONE_DESCRIPTION"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ACTIVE"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ACTIONS"}
    </tr>

{section name="i" loop=$taxzones}
	<tr class="{cycle values="alt1,alt2"}" style="cursor: pointer;">
        <td onclick="toggle('zonerow{$taxzones[i].taxZoneID}');">{$taxzones[i].taxZoneID}</td>
        <td onclick="toggle('zonerow{$taxzones[i].taxZoneID}');">{$taxzones[i].countriesISO2} - {$taxzones[i].countryName}</td>
        <td onclick="toggle('zonerow{$taxzones[i].taxZoneID}');">{$taxzones[i].taxZoneName}</td>
        <td onclick="toggle('zonerow{$taxzones[i].taxZoneID}');">{$taxzones[i].taxZoneAmount}</td>
        <td onclick="toggle('zonerow{$taxzones[i].taxZoneID}');">{if !$taxzones[i].taxZoneAmountType}{$smarty.const.TRANS_PERCENTAGE}{else}{$smarty.const.TRANS_SET_AMOUNT}{/if}</td>
        <td onclick="toggle('zonerow{$taxzones[i].taxZoneID}');">{$taxzones[i].taxZoneDescription}</td>
        <td onclick="toggle('zonerow{$taxzones[i].taxZoneID}');">{$taxzones[i].taxZoneActive|getArrayValueByID:$activeInactive}</td>
        <td width="54">
        {strip}
        <a href="taxes.php?action={getActionID action="EditTaxZone"}&taxZoneID={$taxzones[i].taxZoneID}&sid={$sid}">
            <img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
        </a>
        &nbsp;
        <a href="taxes.php?action={getActionID action="RemoveTaxZone"}&taxZoneID={$taxzones[i].taxZoneID}&sid={$sid}">
            <img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_REMOVE}" title="{$smarty.const.TRANS_REMOVE}" />
        </a>
        {/strip}
        </td>
	</tr>
	<tbody id="zonerow{$taxzones[i].taxZoneID}" class="off">
	<tr>
		<td colspan="4" valign="top" xstyle="border-bottom: 1px dashed #333;">
			<table width="100%" border="0" cellpadding="1" cellspacing="1" class="addData">
                <tr>
                    <th colspan="2"><strong>{$smarty.const.TRANS_TAX_ZONE_GROUPS}</strong></th>
                </tr>

                {section name="j" loop=$taxzones[i].taxZoneGroups.0.taxZoneGroup}
				<tr class="{if $smarty.section.j.index%2==0}alt1{else}alt2{/if}">
					<td>{$taxzones[i].taxZoneGroups.0.taxZoneGroup[j].taxZoneGroupID}</td>
					<td>{$taxzones[i].taxZoneGroups.0.taxZoneGroup[j].taxZoneGroupName}</td>
				</tr>
                {/section}

            </table></td>
		<td colspan="4" valign="top" xstyle="border-bottom: 1px dashed #333;">
			<table width="100%" border="0" cellpadding="1" cellspacing="1" class="addData">
                <tr>
                    <th colspan="2"><strong>{$smarty.const.TRANS_LEDGER_ACCOUNT}</strong></th>
                </tr>
                <tr>
                    <td colspan="2">&nbsp;{$taxzones[i].ledgerAccountNumber} - {assign var="ledgerAccountTransKey" value=$taxzones[i].ledgerAccountTransKey}
    					{$smarty.const.$ledgerAccountTransKey|default:$ledgerAccountTransKey}</td>
                </tr>

            </table></td>
	</tr>
	</tbody>
{sectionelse}
    <tr>
        <td colspan="8" class="alt1">{$smarty.const.TRANS_NO_TAX_ZONES}</td>
    </tr>
{/section}


</table>

{include file="$tplDirectory/widgets/paginationLinks.tpl"}


{include file="$tplDirectory/footer.tpl"}