{* $Id: EditWebsiteWidget.tpl,v 1.4 2006/06/19 21:48:58 mgarrett Exp $
 * --------------------------------------------------------------
 * This template displays a form to edit a tax zone. Note that for now, one is unable to 
 * change the administrator associated with a tax zone.
 *
 * Smarty Variables:
 *	$taxzone - The array representation of the current tax zone. This array is 
 *	               structured as follows:
 *                   taxZoneID --  The ID of the tax zone
 *      	         taxZoneName -- The zones within the country to apply taxes to
 *					 countriesISO2 -- The tax zone country
 *	                 taxZoneAmount -- The tax percentage. Allows a tax up to 999.999%
 *	                 taxZoneDescription -- Description of the tax used in invoices
 *      	         taxZoneActive -- 1 if the tax is active, or 0 if otherwise
 *	$countrylist -- List of countries to choose from. 
 *}

{t c="TRANS_NO_WEBSITE_WIDGETS" d="No Website Widgets Found."}
{t c="TRANS_WEBSITE_WIDGET_ID" d="ID"}
{t c="TRANS_WEBSITE_WIDGET_NAME" d="Website Widget Name"}
{t c="TRANS_WEBSITE_WIDGETS" d="Website Widgets"}
{t c="TRANS_ADD_WEBSITE_WIDGET" d="Add Website Widget"}
{t c="TRANS_WEBSITE_WIDGET_TEMPLATE" d="Widget Template"}
{t c="TRANS_MANAGE_WIDGETS" d="Manage Widgets"}
{t c="TRANS_SHOW_WEBSITE_WIDGETS" d="Website Widgets"}
{t c="TRANS_LOCAL_INCLUDE_CODE" d="Local Include Code"}
{t c="TRANS_REMOTE_INCLUDE_CODE" d="Remote Include Code"}
{t c="TRANS_WEBSITE_WIDGET_PRODUCTS" d="Products"}
{t c="TRANS_EDIT_WEBSITE_WIDGET" d="Edit Website Widget"}

{t c="TRANS_NO_PRODUCTS_TIED_TO_ORDER_FORM" d="You have no products associated with the order form for this website widget, please associate products with the order form."}


{include
    file="$tplDirectory/header.tpl"
    parentName="TRANS_MANAGE_SYSTEM"
    childName="TRANS_MANAGE_WIDGETS"
    grandchildName="TRANS_EDIT_WEBSITE_WIDGET"
    sideNavMajor="products"
   	sideNavMinor="websitewidgets"
    parentConfigGroupID=0}

<h2>{$smarty.const.TRANS_EDIT_WEBSITE_WIDGET}</h2>
<form method="post" action="websitewidgets.php" name="EditWebsiteWidget">
<input name="websiteWidgetID" type="hidden" value="{$websiteWidgetInfo.websiteWidgetID}" />
<input type="hidden" name="action" value="{getActionID action="EditWebsiteWidgetResponse"}">
<input type="hidden" name="sid" value="{$sid}">


<table border="0" cellpadding="3" cellspacing="3" class="tab01">

    <tr>
        <th align="right" scope="row">{$smarty.const.TRANS_WEBSITE_WIDGET_NAME}</th>
        <td><input type="text" name="websiteWidgetName" value="{$websiteWidgetInfo.websiteWidgetName}" /></td>
    </tr>

    <tr>
        <th align="right" scope="row">{$smarty.const.TRANS_WEBSITE_WIDGET_TEMPLATE}</th>
        <td><select name="websiteWidgetTpl">
{html_options options=$wwTemplates selected=$websiteWidgetInfo.websiteWidgetTpl}
</select></td>
    </tr>

	<tr>
		<th align="right" scope="row">{$smarty.const.TRANS_ORDER_FORM}</th>
		<td><a href="orderforms.php?action={getActionID action="EditOrderForm"}&orderFormID={$orderFormInfo.orderFormID}&sid={$sid}">{$orderFormInfo.orderFormName}</a></td>
	</tr>

	{if $noProducts<1}

    <tr>
		<th align="right" scope="row">{$smarty.const.TRANS_WEBSITE_WIDGET_PRODUCTS}</th>
		<td>
		{include file="$tplDirectory/widgets/comboBox.tpl"
			comboTitleLeft=TRANS_SELECTED
			comboNameLeft="products"
			comboOptionsLeft=$selectedProducts
			positionButtons="yes"
			comboTitleRight=TRANS_SELECTABLE
			comboNameRight="selectableProducts"
			comboOptionsRight=$selectableProducts
			formName="EditWebsiteWidget"
			submitName="suppress"
		}
		</td>
    </tr>

	{else}
	<tr>
		<td></td>
		<td>{$smarty.const.TRANS_NO_PRODUCTS_TIED_TO_ORDER_FORM}</td>
	</tr>
	{/if}

    <tr>
        <td></td>
        <td><input class="submit" type="submit" value="{$smarty.const.TRANS_SAVE}" onclick="selectAllOptions(document.EditWebsiteWidget.elements['products[]']);"></td>
    </tr>
</table>


</form>


{include file="$tplDirectory/footer.tpl"}
