{* $Id: ShowWebsiteWidgets.tpl,v 1.2 2006/04/26 20:36:25 kbailey Exp $
 * --------------------------------------------------------------
 * This template displays a list of tax zones. All pieces of data associated with a 
 * tax zone are available in the $taxzones variable, which is an array of tax zones.
 *
 * Smarty Variables:
 *	$taxzone - The array representation of the current tax zone. This array is 
 *	               structured as follows:
 *                   taxZoneID --  The ID of the tax zone
 *      	         taxZoneName -- The zones within the country to apply taxes to
 *					 countriesISO2 -- The tax zone country
 *	                 taxZoneAmount -- The tax percentage. Allows a tax up to 999.999%
 *	                 taxZoneDescription -- Description of the tax used in invoices
 *      	         taxZoneActive -- 1 if the tax is active, or 0 if otherwise
 *}


{t c="TRANS_NO_WEBSITE_WIDGETS" d="No Website Widgets Found."}
{t c="TRANS_WEBSITE_WIDGET_ID" d="ID"}
{t c="TRANS_WEBSITE_WIDGET_NAME" d="Website Widget Name"}
{t c="TRANS_WEBSITE_WIDGETS" d="Website Widgets"}
{t c="TRANS_ADD_WEBSITE_WIDGET" d="Add Website Widget"}
{t c="TRANS_WEBSITE_WIDGET_TEMPLATE" d="Widget Template"}
{t c="TRANS_MANAGE_WIDGETS" d="Manage Widgets"}
{t c="TRANS_SHOW_WEBSITE_WIDGETS" d="Website Widgets"}
{t c="TRANS_LOCAL_INCLUDE_CODE" d="Local Include Code"}
{t c="TRANS_REMOTE_INCLUDE_CODE" d="Remote Include Code"}


{include
    file="$tplDirectory/header.tpl"
    parentName="TRANS_MANAGE_SYSTEM"
    childName="TRANS_MANAGE_WIDGETS"
    grandchildName="TRANS_SHOW_WEBSITE_WIDGETS"
    sideNavMajor="products"
   	sideNavMinor="websitewidgets"
    parentConfigGroupID=0}

<table border="0" width="100%" cellpadding="3" cellspacing="3" class="tab01">

	<tr>
		<td colspan="8">
			<div class="rm" style="float: right;"><a href="websitewidgets.php?action={getActionID action="AddWebsiteWidget"}&sid={$sid}">{$smarty.const.TRANS_ADD_WEBSITE_WIDGET}</a></div>
			<h6>{$smarty.const.TRANS_WEBSITE_WIDGETS}</h6>
		</td>
	</tr>

	<tr>
		<td colspan="8" style="cursor: pointer;" onclick="{strip} {section name="i" loop=$websiteWidgets}
			toggle('widgetrow{$websiteWidgets[i].websiteWidgetID}'); {/section} {/strip}return false;"> <a href="javascript:void(0);"><img src="{$imageDirectory}/ico/data_down.gif" width="16" height="16" alt="" title="" border="0" /></a> {$smarty.const.TRANS_ADDITIONAL_DATA}
		</td>
	</tr>


    <tr>
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_WEBSITE_WIDGET_ID"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_WEBSITE_WIDGET_NAME"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_WEBSITE_WIDGET_TEMPLATE"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ORDER_FORM"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_CURRENCY"}
        {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ACTIONS"}
    </tr>

{section name="i" loop=$websiteWidgets}
	<tr class="{cycle values="alt1,alt2"}" style="cursor: pointer;">
        <td onclick="toggle('widgetrow{$websiteWidgets[i].websiteWidgetID}');">{$websiteWidgets[i].websiteWidgetID}</td>
        <td onclick="toggle('widgetrow{$websiteWidgets[i].websiteWidgetID}');">{$websiteWidgets[i].websiteWidgetName}</td>
        <td onclick="toggle('widgetrow{$websiteWidgets[i].websiteWidgetID}');">{$websiteWidgets[i].websiteWidgetTpl}</td>
        <td onclick="toggle('widgetrow{$websiteWidgets[i].websiteWidgetID}');">{$websiteWidgets[i].orderFormName}</td>
        <td onclick="toggle('widgetrow{$websiteWidgets[i].websiteWidgetID}');">{$websiteWidgets[i].paymentGroupCurrencyID}</td>
        <td width="54">
        {strip}
        <a href="websitewidgets.php?action={getActionID action="EditWebsiteWidget"}&websiteWidgetID={$websiteWidgets[i].websiteWidgetID}&sid={$sid}">
            <img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
        </a>
        &nbsp;
        <a href="websitewidgets.php?action={getActionID action="RemoveWebsiteWidget"}&websiteWidgetID={$websiteWidgets[i].websiteWidgetID}&sid={$sid}">
            <img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_REMOVE}" title="{$smarty.const.TRANS_REMOVE}" />
        </a>
        {/strip}
        </td>
	</tr>
	<tbody id="widgetrow{$websiteWidgets[i].websiteWidgetID}" class="off">
	<tr>
		<td colspan="6">
			<h6>{$smarty.const.TRANS_LOCAL_INCLUDE_CODE}</h6>
			<pre style="padding: 10px; border: 1px dashed #333;">&lt;?php
$websiteWidgetArgs = array(
	'widgetID' => {$websiteWidgets[i].websiteWidgetID},
	'method' => 'local',
	'whoisWidget' => 0,
	'urlORpath' => '{$wwLocalPath}'
);
include("{$wwLocalPath}/website_widget_creator.php");
chdir(dirname(__FILE__));
?></pre><br />
			<h6>{$smarty.const.TRANS_REMOTE_INCLUDE_CODE}</h6>
			<pre style="padding: 10px; border: 1px dashed #333;">&lt;?php
$websiteWidgetArgs = array(
	'widgetID' => {$websiteWidgets[i].websiteWidgetID},
	'method' => 'fopen',
	'whoisWidget' => 0,
	'urlORpath' => '{$wwRemotePath}'
);
include("website_widget_creator.php");
chdir(dirname(__FILE__));
?></pre>
		</td>
	</tr>
	</tbody>
{sectionelse}
    <tr>
        <td colspan="8" class="alt1">{$smarty.const.TRANS_NO_WEBSITE_WIDGETS}</td>
    </tr>
{/section}


</table>

{include file="$tplDirectory/widgets/paginationLinks.tpl"}


{include file="$tplDirectory/footer.tpl"}
