{* $Id: quickEditSelectLink.tpl,v 1.9 2006/07/22 00:50:20 bwoolley Exp $
 * --------------------------------------------------------------
 * This widget template is used to display each <th></th> that allows sorting of that column.
 * We only want to allow sort options if the column has infinite values.
 *
 * This widget also builds a special search box for amount columns, that when you click on
 * the header name, will only search this column using amounts!
 *
 * Smarty Variables:
 *	$editActionName	The action name to get the action id for.
 *	$editID  		The id of the record to edit.
 *	$editKey		The primary key column name of the record to edit.
 *  $editColumn		The the column to edit.
 *  $useEditIcon    1 or 0
 *	$sortArgs		The sort arguments to pass to the sortLinks widget.
 *	$recordOffset	The current record offset value
 *	$imageDirectory	The image directory for this theme.
 *  $extraparam		Extra parameter, if necessary
 *  $extravalue		Extra param value, if necessary
 *  $sid			The current sessionID
 *
 * Example Usage:
 * {include file="$tplDirectory/widgets/quickEditSelectLink.tpl" useEditIcon=0 editID=$billingAccountID editKey="billingAccountID" editActionName="EditBillingAccountResponse" editName="TRANS_TYPE" editColumn="billingAccountType" editOptions=$billingAccountTypes editSelected=$contactBillingAccount.billingAccountType}
 *}
{t c="TRANS_CLOSE" d="Close"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_QUICK_EDIT_ID" d="Quick Edit ID"}

{strip}
<a href="javascript:void(0);" onclick="return overlib('&lt;div style=\'white-space: nowrap\'&gt;
&lt;form method=\'post\' action=\'{$fileName}\'&gt;
&lt;input type=\'hidden\' name=\'action\' value=\'{getActionID action="$editActionName"}\' /&gt;
&lt;input type=\'hidden\' name=\'{$editKey}\' value=\'{$editID}\' /&gt;
&lt;input type=\'hidden\' name=\'redirectURL\' value=\'{$fileName}\' /&gt;
&lt;input type=\'hidden\' name=\'redirectAction\' value=\'{$actionName}\' /&gt;
&lt;input type=\'hidden\' name=\'redirectArgs\' value=\'{$bookmarkArgs}\' /&gt;
&lt;input type=\'hidden\' name=\'sid\' value=\'{$sid}\' /&gt;
{if $extraparam}
&lt;input type=\'hidden\' name=\'{$extraparam}\' value=\'{$extravalue}\' /&gt;
{/if}
{$smarty.const.$editName}:&nbsp;
{escape type="html"}
<select name="{$editColumn}">
{escape type="quotes" strip=1}
{if $allowNull}<option value="0">{$smarty.const.TRANS_NONE}</option>{/if}
{html_options options=$editOptions selected=$editSelected}
{/escape}
</select>
{/escape}
&lt;input type=\'submit\' name=\'submit\' value=\'{$smarty.const.TRANS_EDIT}\' /&gt;
&lt;/form&gt;&lt;/div&gt;', BGCLASS, 'popupBG', FGCLASS, 'popupFG', CENTER, STICKY, CAPTION, '{$smarty.const.TRANS_QUICK_EDIT_ID}: {$editID}', CLOSECLICK, CLOSETEXT, '&lt;img src={$imageDirectory}/ico/remove.gif width=13 height=13 border=0 /&gt;');" onmouseout="return nd();">
{if $useEditIcon}
<img src="{$imageDirectory}/ico/quickedit.gif" width="11" height="10" alt="{$smarty.const.TRANS_QUICK_EDIT}" title="{$smarty.const.TRANS_QUICK_EDIT}" />
{else}
<img src="{$imageDirectory}/spacer.gif" width="10" height="10" alt="{$smarty.const.TRANS_QUICK_EDIT}" title="{$smarty.const.TRANS_QUICK_EDIT}" />
{/if}
</a>
{/strip}
