{* $Id: wizardQuestionInputMultiSelect.tpl,v 1.4 2006/06/27 03:41:34 kbailey Exp $
 * --------------------------------------------------------------
 * This widget template displays a multiple select menu to the user, to allow them to answer a question.
 *
 * Smarty Variables:
 *  $questionID  The ID of this question.
 *	$question  The question to ask.
 *  $questionAnswers  An array with every element being of the form:
 *                      array(
 *                        "value"  The literal value the array should take on when posted.
 *                        "answer"  The answer to display.
 *                        "selected"  1 if the answer is to be selected, or 0 if otherwise.
 *                      )
 *  $questionSize  The size of this question's field.
 *  $questionMaxLength  The maximum length of this question's field (not applicable to all fields.
 *}
 
 
{if $smarty.const.WIZARD_CART_DISPLAY==1}

	<tr class="{if $questionErrorMesgs}highlight{else}{cycle values="alt1,alt2"}{/if}">
		<td align="right" valign="top"><label for="{$questionID}">{$question}</label></td>
		<td>

			{assign var="comboNameLeft" value=$questionID}
			{assign var="comboNameRight" value="selectable$questionID"}
			{assign var="formName" value="wizard$wizardID"}

			<table cellpadding="1" cellspacing="1" class="tab07">
				<tr>
					<td valign="top" align="center">
						<strong>{$smarty.const.TRANS_SELECTED}</strong>
						<br />
						<select multiple="multiple" size="10" id="{$comboNameLeft}[]" name="{$comboNameLeft}[]" style="width:150px" onDBLClick="moveSelectedOptions(this.form.elements['{$comboNameLeft}[]'],this.form.elements['{$comboNameRight}[]']);">
							{section name="i" loop=$questionAnswers}
								{if ($questionAnswers[i].selected)}<option {if ($questionAnswers[i].value !== "")}value="{$questionAnswers[i].value}"{/if}>{$questionAnswers[i].answer}</option>{/if}
							{/section}
						</select>
						<br />
						<input class="button" type="button" onClick="moveAllOptions(this.form.elements['{$comboNameLeft}[]'],this.form.elements['{$comboNameRight}[]']);" value="&gt;&gt;">
						&nbsp;
						<input class="button" type="button" onClick="moveSelectedOptions(this.form.elements['{$comboNameLeft}[]'],this.form.elements['{$comboNameRight}[]']);" value="&gt;">
					</td>
					<td valign="top" align="center">
						<strong>{$smarty.const.TRANS_SELECTABLE}</strong>
						<br />
						<select multiple="multiple" size="10" name="{$comboNameRight}[]" style="width:150px" onDBLClick="moveSelectedOptions(this.form.elements['{$comboNameRight}[]'],this.form.elements['{$comboNameLeft}[]']);">
							{section name="i" loop=$questionAnswers}
								{if (!$questionAnswers[i].selected)}<option {if ($questionAnswers[i].value !== "")}value="{$questionAnswers[i].value}"{/if}>{$questionAnswers[i].answer}</option>{/if}
							{/section}
						</select>
						<br />
						<input class="button" type="button" onClick="moveSelectedOptions(this.form.elements['{$comboNameRight}[]'],this.form.elements['{$comboNameLeft}[]']);" value="&lt;">
						&nbsp;
						<input class="button" type="button" onClick="moveAllOptions(this.form.elements['{$comboNameRight}[]'],this.form.elements['{$comboNameLeft}[]']);" value="&lt;&lt;">
					</td>
				</tr>
			</table>
			{$questionDescription} {$questionErrorMesgs}

		</td>
	</tr>

{elseif $smarty.const.WIZARD_ADMIN_ADDON_DISPLAY==1}

			{assign var="comboNameLeft" value=$questionID}
			{assign var="comboNameRight" value="selectable$questionID"}
			{assign var="formName" value="wizard$wizardID"}

			<table cellpadding="1" cellspacing="1" class="tab07">
				<tr>
					<td valign="top" align="center">
						<strong>{$smarty.const.TRANS_SELECTED}</strong>
						<br />
						<select multiple="multiple" size="10" id="addonValues[{literal}{ID}{/literal}][{$comboNameLeft}][]" name="addonValues[{literal}{ID}{/literal}][{$comboNameLeft}][]" style="width:150px" onDBLClick="moveSelectedOptions(this.form.elements['addonValues[{literal}{ID}{/literal}][{$comboNameLeft}][]'],this.form.elements['{$comboNameRight}[]']);">
							{section name="i" loop=$questionAnswers}
								{if ($questionAnswers[i].selected)}<option {if ($questionAnswers[i].value !== "")}value="{$questionAnswers[i].value}"{/if}>{$questionAnswers[i].answer}</option>{/if}
							{/section}
						</select>
						<br />
						<input class="button" type="button" onClick="moveAllOptions(this.form.elements['addonValues[{literal}{ID}{/literal}][{$comboNameLeft}][]'],this.form.elements['{$comboNameRight}[]']);" value="&gt;&gt;">
						&nbsp;
						<input class="button" type="button" onClick="moveSelectedOptions(this.form.elements['addonValues[{literal}{ID}{/literal}][{$comboNameLeft}][]'],this.form.elements['{$comboNameRight}[]']);" value="&gt;">
					</td>
					<td valign="top" align="center">
						<strong>{$smarty.const.TRANS_SELECTABLE}</strong>
						<br />
						<select multiple="multiple" size="10" name="{$comboNameRight}[]" style="width:150px" onDBLClick="moveSelectedOptions(this.form.elements['{$comboNameRight}[]'],this.form.elements['addonValues[{literal}{ID}{/literal}][{$comboNameLeft}][]']);">
							{section name="i" loop=$questionAnswers}
								{if (!$questionAnswers[i].selected)}<option {if ($questionAnswers[i].value !== "")}value="{$questionAnswers[i].value}"{/if}>{$questionAnswers[i].answer}</option>{/if}
							{/section}
						</select>
						<br />
						<input class="button" type="button" onClick="moveSelectedOptions(this.form.elements['{$comboNameRight}[]'],this.form.elements['addonValues[{literal}{ID}{/literal}][{$comboNameLeft}][]']);" value="&lt;">
						&nbsp;
						<input class="button" type="button" onClick="moveAllOptions(this.form.elements['{$comboNameRight}[]'],this.form.elements['addonValues[{literal}{ID}{/literal}][{$comboNameLeft}][]']);" value="&lt;&lt;">
					</td>
				</tr>
			</table>
			{$questionDescription} {$questionErrorMesgs}

{else}
 
	<tr class="{if $questionErrorMesgs}highlight{else}{cycle values="alt1,alt2"}{/if}">
		<th class="nowrap" scope="row"><label for="{$questionID}">{$question}</label></th>
		<td width="100%">
	

			{assign var="comboNameLeft" value=$questionID}
			{assign var="comboNameRight" value="selectable$questionID"}
			{assign var="formName" value="wizard$wizardID"}
			{t c="TRANS_SELECTED" d="Selected"}
			{t c="TRANS_SELECTABLE" d="Selectable"}

			<table cellpadding="1" cellspacing="1" class="tab07">
				<tr>
					<td valign="top" align="center">
						<input type="hidden" name="{$questionID}" value="" />
						<strong>{$smarty.const.TRANS_SELECTED}</strong>
						<br />
						<select multiple="multiple" size="10" id="{$comboNameLeft}[]" name="{$comboNameLeft}[]" style="width:150px" onDBLClick="moveSelectedOptions(this.form.elements['{$comboNameLeft}[]'],this.form.elements['{$comboNameRight}[]']);">
							{section name="i" loop=$questionAnswers}
								{if ($questionAnswers[i].selected)}<option {if ($questionAnswers[i].value !== "")}value="{$questionAnswers[i].value}"{/if}>{$questionAnswers[i].answer}</option>{/if}
							{/section}
						</select>
						<br />
						<input class="button" type="button" onClick="moveAllOptions(this.form.elements['{$comboNameLeft}[]'],this.form.elements['{$comboNameRight}[]']);" value="&gt;&gt;">
						&nbsp;
						<input class="button" type="button" onClick="moveSelectedOptions(this.form.elements['{$comboNameLeft}[]'],this.form.elements['{$comboNameRight}[]']);" value="&gt;">
					</td>
					<td valign="top" align="center">
						<strong>{$smarty.const.TRANS_SELECTABLE}</strong>
						<br />
						<select multiple="multiple" size="10" name="{$comboNameRight}[]" style="width:150px" onDBLClick="moveSelectedOptions(this.form.elements['{$comboNameRight}[]'],this.form.elements['{$comboNameLeft}[]']);">
							{section name="i" loop=$questionAnswers}
								{if (!$questionAnswers[i].selected)}<option {if ($questionAnswers[i].value !== "")}value="{$questionAnswers[i].value}"{/if}>{$questionAnswers[i].answer}</option>{/if}
							{/section}
						</select>
						<br />
						<input class="button" type="button" onClick="moveSelectedOptions(this.form.elements['{$comboNameRight}[]'],this.form.elements['{$comboNameLeft}[]']);" value="&lt;">
						&nbsp;
						<input class="button" type="button" onClick="moveAllOptions(this.form.elements['{$comboNameRight}[]'],this.form.elements['{$comboNameLeft}[]']);" value="&lt;&lt;">
					</td>
				</tr>
			</table>
			{$questionDescription} {$questionErrorMesgs}
			<script type="text/javascript">
			{literal}
			multiSelects{/literal}{$wizardID}{literal}.push(document.getElementById('{/literal}{$comboNameLeft}{literal}[]'));
			{/literal}
			</script>
			{* selectAllOptions(document.{$formName}.elements['{$comboNameLeft}[]']); *}

		</td>
	</tr>

{/if}
