{* $Id: wizardQuestionInputSelect.tpl,v 1.3 2006/06/06 01:26:44 kbailey Exp $
 * --------------------------------------------------------------
 * This widget template displays a question input select menu.
 *
 * Smarty Variables:
 *	$question		The question.
 *  $inputName		The name of the select menu.
 *  $selectOptions	An array of the select options.
 *  $selected		The selected options value.
 *  $appendText		The appended text messege.
 *
 * Example Usage:
 *  {include file="$tplDirectory/admin/widgets/wizard/questionInputSelect.tpl" question="Some Question" inputName="" selectOptions="" selected="" appendText=""}
 *}
 
{if $smarty.const.WIZARD_CART_DISPLAY==1}

	<tr class="{if $questionErrorMesgs}highlight{else}{cycle values="alt1,alt2"}{/if}">
		<td align="right"><label for="{$questionID}">{$question}</label></td>
		<td>
			<select name="{$questionID}" {if ($questionSize)}size="{$questionAnswers[i].size}"{else}size="1"{/if}>
				{section name="i" loop=$questionAnswers}
					<option {if ($questionAnswers[i].value !== "")}value="{$questionAnswers[i].value}"{/if}
					{if ($questionAnswers[i].selected)}selected="selected"{/if}>{$questionAnswers[i].answer}</option>
				{/section}
			</select>
			{$questionDescription} {$questionErrorMesgs}
		</td>
	</tr>

{elseif $smarty.const.WIZARD_ADMIN_ADDON_DISPLAY==1}

	<select name="addonValues[{literal}{ID}{/literal}][{$questionID}]" {if ($questionSize)}size="{$questionAnswers[i].size}"{else}size="1"{/if}>
		{section name="i" loop=$questionAnswers}
			<option {if ($questionAnswers[i].value !== "")}value="{$questionAnswers[i].value}"{/if}
			{if ($questionAnswers[i].selected)}selected="selected"{/if}>{$questionAnswers[i].answer}</option>
		{/section}
	</select>
	{$questionDescription} {$questionErrorMesgs}

{else}

	<tr class="{if $questionErrorMesgs}highlight{else}{cycle values="alt1,alt2"}{/if}">
		<th class="nowrap" scope="row"><label for="{$questionID}">{$question}</label></th>
		<td width="100%">
			<input type="hidden" name="{$questionID}" value="" />
			<select name="{$questionID}" {if ($questionSize)}size="{$questionAnswers[i].size}"{else}size="1"{/if}>
				{section name="i" loop=$questionAnswers}
					<option {if ($questionAnswers[i].value !== "")}value="{$questionAnswers[i].value}"{/if}
					{if ($questionAnswers[i].selected)}selected="selected"{/if}>{$questionAnswers[i].answer}</option>
				{/section}
			</select>
			{$questionDescription} {$questionErrorMesgs}
		</td>
	</tr>

{/if}
