{* $Id: ShowDashboard.tpl,v 1.23 2006/07/10 21:40:23 mgarrett Exp $
 * --------------------------------------------------------------
 * This template displays the client dashboard.
 *
 * Smarty Variables:
 *  $invoices (array of invoice data)
 *  $packages (array of package data)
 *  $helpdeskTicketsOpen (array of open tickets)
 *  $helpdeskTicketsOpenSubject (array of open ticket's subjects)
 *  $helpdeskEnabled (1 or 0 to show the helpdesk section)
 *
 * 	$cssDirectory	The relative path to the theme's css directory
 *	$jsDirectory	The relative path to the theme's javascript directory
 *	$imageDirectory	The relative path to the theme's image directory
 *	$tplDirectory	The relative path to the theme's template directory
 *
 * Author: Michael Fountain
 *}
{strip}
{t c="TRANS_ACCOUNT_SUMMARY" d="Account Summary"}
{t c="TRANS_PACKAGE_SUMMARY" d="Package Summary"}
{t c="TRANS_DOMAIN_SUMMARY" d="Domain Summary"}
{t c="TRANS_SSLCERT_SUMMARY" d="SSL Certificate Summary"}
{t c="TRANS_NONE" d="None"}
{t c="TRANS_ACCOUNTING_ACCOUNTS_LABEL" d="Account"}
{t c="TRANS_ACCOUNT_BALANCE" d="Account Balance"}
{t c="TRANS_AVAILABLE_CREDIT" d="Available Credits"}
{t c="TRANS_BALANCE" d="Balance"}
{t c="TRANS_OPEN_TICKETS" d="Open Tickets"}
{t c="TRANS_INVOICES_DUE" d="Invoices Due"}
{t c="TRANS_ACTIVE_BILLABLE_PACKAGES" d="Active & Billable Packages"}
{t c="TRANS_NEWS_AND_ANNOUNCMENTS" d="News & Announcements"}
{t c="TRANS_ID" d="ID"}
{t c="TRANS_PRODUCT" d="Product"}
{t c="TRANS_PRICE" d="Price"}
{t c="TRANS_BILLING_CYCLE" d="Billing Cycle"}
{t c="TRANS_NEXT_RENEWAL" d="Next Renewal"}
{t c="TRANS_MANAGE" d="Manage"}
{t c="TRANS_ACTION" d="Action"}
{t c="TRANS_INVOICE_NUMBER" d="Invoice Number"}
{t c="TRANS_AMOUNT" d="Amount"}
{t c="TRANS_AMOUNT_PAID" d="Amount Paid"}
{t c="TRANS_DATE_GENERATED" d="Date Generated"}
{t c="TRANS_DATE_DUE" d="Date Due"}
{t c="TRANS_PAY_NOW" d="Pay Now"}
{t c="TRANS_NEW_TICKET" d="Create a New Ticket"}
{t c="TRANS_NONEWS" d="No News"}
{t c="TRANS_DETAILS" d="Details"}

{t c="TRANS_SUBJECT" d="Subject"}
{t c="TRANS_DESCRIPTION" d="Description"}
{/strip}
{include file="$tplDirectory/header.tpl" tabMajor="dashboard" tabMinor="overview"}

{if $showPPCOffer}
    {include file="$tplDirectory/widgets/google/showAcceptedOffer.tpl"}
    <br />
{/if}

<div class="box07">
	<div class="st01"><h1>{$smarty.const.TRANS_INVOICES_DUE}</h1></div>
	<table width="100%"  border="0" cellspacing="2" cellpadding="0" class="list">
    <tr class="subHeaderRow" bgcolor="#CCCCCC">
	    <td class="firstTD" style="text-align: center;">
            {$smarty.const.TRANS_INVOICE_NUMBER}
        </td>
        <td style="text-align: center;">
            {$smarty.const.TRANS_AMOUNT}
        </td>
        <td style="text-align: center;">
            {$smarty.const.TRANS_AMOUNT_PAID}
        </td>
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_DATE_GENERATED}
	    </td>
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_DATE_DUE}
	    </td>
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_STATUS}
	    </td>
	    <td  style="text-align: center;">
		    {$smarty.const.TRANS_ACTION}
	    </td>
    </tr>
    {section name=i loop=$invoices}
        <tr>
            <td style="text-align: center;">
				<a href="{getHREF page="invoices.php" actionName="ShowInvoiceDetails" args="invoiceID=`$invoices[i].invoiceID`"}">
					{$invoices[i].invoiceNumber}
				</a>
            </td>
            <td style="text-align: right;">
                {$invoices[i].invoiceAmount|getAmount:$invoices[i].currencyID}
            </td>
            <td style="text-align: right;">
                {$invoices[i].invoiceAmountPaid|getAmount:$invoices[i].currencyID}
            </td>
	        <td style="text-align: center;">
		        {$invoices[i].invoiceDateEntered|getDate}
	        </td>
	        <td style="text-align: center;">
		        {$invoices[i].invoiceDateDue|getDate}
	        </td>
	        <td style="text-align: center;">
		        {$invoices[i].invoiceStatus|getStatusName:"invoice"}
	        </td>
	        <td  style="text-align: center;">
		        <a href="{getHREF page="invoices.php" actionName="PayInvoices"}">{$smarty.const.TRANS_PAY_NOW}</a> 
				<a href="{getHREF page="invoices.php" actionName="ShowInvoiceDetails" args="invoiceID=`$invoices[i].invoiceID`"}">
					{$smarty.const.TRANS_DETAILS}
				</a>
	        </td>
        </tr>
    {sectionelse}
        <tr bgcolor="#EEEDE9">
            <td style="text-align: left;" colspan="7"><i>{$smarty.const.TRANS_NONE}</i></td>
        </tr>
    {/section}
	</table>
</div>{* box07 *}
<br />

<div class="box07">
	<div class="st01"><h1>{$smarty.const.TRANS_ACTIVE_BILLABLE_PACKAGES}</h1></div>
	<table width="100%"  border="0" cellspacing="2" cellpadding="0" class="list">
    <tr class="subHeaderRow" bgcolor="#CCCCCC">
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_PACKAGE}
	    </td>
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_PRICE}
	    </td>
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_BILLING_CYCLE}
	    </td>
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_NEXT_RENEWAL}
	    </td>
	    <td  style="text-align: center;">
		    {$smarty.const.TRANS_STATUS}
	    </td>
	    <td  style="text-align: center;">
		    {$smarty.const.TRANS_ACTION}
	    </td>
    </tr>
    {section name=i loop=$packages}
        <tr>
	        <td style="text-align: left;">
		        {$packages[i].packageName|stripslashes}
	        </td>
	        <td style="text-align: right;">
		        {$packages[i].packagePrice|getAmount:$packages[i].paymentGroupCurrencyID}
	        </td>
	        <td style="text-align: center;">
		        {$packages[i].cycleID|getArrayValueByID:$cycles}
	        </td>
	        <td style="text-align: center;">
		        {$packages[i].packageDateNextRenewal|getDate}
	        </td>
	        <td  style="text-align: center;">
		        {$packages[i].packageStatus|getStatusName:"package"}
	        </td>
	        <td  style="text-align: center;">
		        <a href="#">{$smarty.const.TRANS_MANAGE}</a>
	        </td>
        </tr>
    {sectionelse}
        <tr bgcolor="#EEEDE9">
            <td style="text-align: left;" colspan="6"><i>{$smarty.const.TRANS_NONE}</i></td>
        </tr>
    {/section}
	</table>
</div>{* box07 *}
<br />

{if $helpdeskEnabled}
<div class="box07">
	<div class="st01"><h1>{$smarty.const.TRANS_OPEN_TICKETS}</h1></div>
	<table width="100%"  border="0" cellspacing="2" cellpadding="0" class="list">
	{foreach key=ticketID item=ticketName from=$helpdeskTicketsOpen}
        <tr>
            <td style="text-align: left;">
				<div class="floatright">{$helpdeskTicketsOpenSubject[$ticketID]}...</div>
				<a href="{getHREF page="helpdesk.php"
					actionName="ShowHelpdeskTicketDetails"
					args="hdTicketID=$ticketID"}">{$ticketName}</a>
            </td>
        </tr>
	{/foreach}
	</table>
	<br clear="all" />
	<table width="100%"  border="0" cellspacing="2" cellpadding="0" class="list">
    <tr bgcolor="#EEEDE9">
        <td>
        	<i>
        		<a href="{getHREF page="helpdesk.php" actionName="AddHelpdeskTicket"}">{$smarty.const.TRANS_NEW_TICKET}</a>
        	</i>
        </td>
    </tr>
	</table>
<br class="clearright" />
</div>{* box07 *}
<br />
{/if}

<div class="box07">
	<div class="st01"><h1>{$smarty.const.TRANS_NEWS_AND_ANNOUNCMENTS}</h1></div>
	<table width="100%"  border="0" cellspacing="2" cellpadding="0" class="list">
	 <tr class="subHeaderRow" bgcolor="#CCCCCC">
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_SUBJECT}
	    </td>
	    <td style="text-align: center;">
		    {$smarty.const.TRANS_DESCRIPTION}
	    </td>
	</tr>
	{foreach from=$news item=n}
    		<tr style="cursor:pointer;" onClick="toggle('row_{$n.newsGroupID}');">
    			<td>{$n.newsGroupName}</td>
    			<td>{$n.newsGroupDescription}</td>
    		</tr>
    		<tbody id="row_{$n.newsGroupID}">
    		<tr>
    			<td colspan="2">
    				<table width="100%" cellspacing="2" cellpadding="0" border="0" class="list">
    				<tr class="subHeaderRow" bgcolor="#CCCCCC">
    					<td style="text-align:center;">
    						{$smarty.const.TRANS_SUBJECT}
    					</td>
    					<td style="text-align:center;">
    						{$smarty.const.TRANS_PRIORITY}
    					</td>
    				</tr>
    				{foreach from=$n.articles item=a}
					<tr style="cursor:pointer;" onClick="toggle('article_{$a.newsID}');">
						<td>{$a.newsSubject}</td>
						<td>{$a.priorityID|getArrayValueByID:$priorities}</td>
					</tr>
					<tbody id="article_{$a.newsID}">
						<td colspan="2">
							{$a.newsBody|nl2br|html_entity_decode}
						</td>
					</tbody>
					<script language="javascript">
					//<[[CDATA][
					toggle('article_{$a.newsID}');
					//]]>
					</script>
    				{foreachelse}
    					<tr bgcolor="#EEEDE9">
    						<td colspan="2"><i>{$smarty.const.TRANS_NORESULTS}</a></td>
    					</tr>
    				{/foreach}
    				</table>
    			</td>
    		</tr>
    		<script language="javascript">
		//<[[CDATA][
		toggle('row_{$n.newsGroupID}');
		//]]>
		</script>
    	{foreachelse}
    		<tr bgcolor="#EEEDE9">
	        	<td colspan="2"><i>{$smarty.const.TRANS_NONEWS}</i></td>
	    	</tr>
	{/foreach}
	</table>
</div>{* box07 *}

{include file="$tplDirectory/footer.tpl"}