{* $Id: ShowDomainDetails.tpl,v 1.11 2006/06/08 01:25:56 kbailey Exp $
 * --------------------------------------------------------------
 * This template displays the domains.
 *
 * Smarty Variables:
 *  $domain (array of domain data)
 *  $rules (array of domain management rules for this registrar)
 *  $capabilities (array of management options this domain's registrar is capable of)
 *       domainGetRenewDate
 *       domainContact
 *       domainRenewType
 *       domainLock
 *       domainPassword
 *       domainDNS
 *       domainLiveRenew
 *
 * 	$cssDirectory	The relative path to the theme's css directory
 *	$jsDirectory	The relative path to the theme's javascript directory
 *	$imageDirectory	The relative path to the theme's image directory
 *	$tplDirectory	The relative path to the theme's template directory
 *
 * Author: Andy Christ
 *}

{t c="TRANS_DOMAIN_NAME" d="Domain Name"}
{t c="TRANS_DOMAIN_EXPIRES" d="Expires"}

{t c="TRANS_DOMAIN_CHANGE_CONTACT_INFO" d="Edit Contact Info"}
{t c="TRANS_DOMAIN_CHANGE_DNS" d="Edit DNS Settings"}
{t c="TRANS_DOMAIN_CHANGE_REGISTRAR_LOCK" d="Change Registrar Lock Setting"}
{t c="TRANS_DOMAIN_CHANGE_AUTORENEW" d="Change Autorenew Setting"}
{t c="TRANS_DOMAIN_CHANGE_DOMAIN_PASSWORD" d="Change Domain Password"}

{include file="$tplDirectory/header.tpl" tabMajor="packages" tabMinor="domains"}

<table  border="0" width="98%" cellpadding="0" cellspacing="12"  class="tab01">
<tr>
    <td colspan="2">
		<div class="box07">
			<div class="st01"><h1>{$domain.domainSLD}.{$domain.domainTLD}</h1></div>
			<table width="95%"  border="0" cellspacing="2" cellpadding="0" class="tab06">
            <tr>
	            <th style="text-align: right;">
		            {$smarty.const.TRANS_DOMAIN_NAME}
	            </th>
	            <th  style="text-align: center;">
		            {$smarty.const.TRANS_DOMAIN_EXPIRES}
	            </th>
            </tr>
			<tr>
				<td style="text-align: right;">
					{$domain.domainSLD}.{$domain.domainTLD}

				</td>
				<td style="text-align: right;">
					{$domain.domainDateExpires|getDate}
				</td>
			</tr>
			{assign var=domainID value=$domain.domainID}
			{if $rules.moduleAllowChangeContactInfo && $capabilities.domainContact}
				<tr>
					<td style="text-align: left;" colspan="2">
						<a href="{getHREF page="domains.php"
							actionName="EditDomainContactData"
							args="domainID=$domainID"}">{$smarty.const.TRANS_DOMAIN_CHANGE_CONTACT_INFO}</a>
					</td>
				</tr>
			{/if}
			{if $rules.moduleAllowChangeDNS && $capabilities.domainDNS}
				<tr>
					<td style="text-align: left;" colspan="2">
						<a href="{getHREF page="domains.php"
							actionName="EditDomainDNS"
							args="domainID=$domainID"}">{$smarty.const.TRANS_DOMAIN_CHANGE_DNS}</a>
					</td>
				</tr>
			{/if}
			{if $rules.moduleAllowChangeRegistrarLock && $capabilities.domainLock}
				<tr>
					<td style="text-align: left;" colspan="2">
						<a href="{getHREF page="domains.php"
							actionName="EditDomainRegistrarLockOptions"
							args="domainID=$domainID"}">{$smarty.const.TRANS_DOMAIN_CHANGE_REGISTRAR_LOCK}</a>
					</td>
				</tr>
			{/if}
			{if $rules.moduleAllowChangeAutorenew && $capabilities.domainRenewType}
				<tr>
					<td style="text-align: left;" colspan="2">
						<a href="{getHREF page="domains.php"
							actionName="EditDomainRenewTypeOptions"
							args="domainID=$domainID"}">{$smarty.const.TRANS_DOMAIN_CHANGE_AUTORENEW}</a>
					</td>
				</tr>
			{/if}
			{if $rules.moduleAllowChangeUpdateDomainPassword && $capabilities.domainPassword}
				<tr>
					<td style="text-align: left;" colspan="2">
						<a href="{getHREF page="domains.php"
							actionName="EditDomainAccessPassword"
							args="domainID=$domainID"}">{$smarty.const.TRANS_DOMAIN_CHANGE_DOMAIN_PASSWORD}</a>
					</td>
				</tr>
			{/if}
			</table>
		</div>{* box07 *}
        <br />


    </td>
</tr>

</table>

{include file="$tplDirectory/footer.tpl"}
