{* $Id: ShowLogin.tpl,v 1.11 2006/08/01 22:11:03 mgarrett Exp $
 * --------------------------------------------------------------
 * This template displays the client login form.
 *
 * Smarty Variables:
 *  $redirectActionID  -  The action ID to redirect to. This is 0 if we're not redirecting.
 *  $redirectActionFile  -  The filename to redirect to. This is "" if we're not redirecting.
 *
 *  $htmlLang		The language this document will render
 *	$userIP			The logged IP address of the user
 * 	$cssDirectory	The relative path to the theme's css directory
 *	$jsDirectory	The relative path to the theme's javascript directory
 *	$imageDirectory	The relative path to the theme's image directory
 *}
{t c="TRANS_CLIENT_LOGIN" d="Client Login"}
{t c="TRANS_IP_LOGGING_ENABLED" d="IP Logging Enabled"}
{t c="TRANS_INVALIDSESSION" d="Invalid Session"}
{t c="TRANS_FORGOT" d="Forgot"}
{t c="TRANS_FORGOT_YOUR_PASSWORD" d="Forgot your password"}
{t c="TRANS_LOGIN" d="Login"}
{t c="TRANS_LOGINFAILURE" d="Login Failure"}
{t c="TRANS_LOGOUTSUCCESSFUL" d="Logout Successful"}
{t c="TRANS_USERNAME" d="Username"}
{t c="TRANS_PASSWORD" d="Password"}

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="{$htmlLang}" lang="{$htmlLang}" dir="{$smarty.const.TRANS_TEXTDIRECTION}">
<head>
<title>{strip}
	{if $htmlTitle}
		{$htmlTitle}
	{else}
		{if $parentName}
			{$smarty.const.$parentName}
		{/if}
		{if $childName}
			&nbsp;&raquo; {$smarty.const.$childName}
		{/if}
		{if $grandchildName}
			&nbsp;&raquo; {$smarty.const.$grandchildName}
		{/if}
	{/if}
{/strip}</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<meta name="copyright" content="2006, ModernGigabyte, LLC" />
<meta name="description" content="{$appParentName} {$appParentVersion} {$appCurrentName}-{$appCurrentVersion}" />
<link rel="stylesheet" type="text/css" href="{$cssDirectory}/style.css" charset="utf-8" />
<link rel="stylesheet" type="text/css" href="{$cssDirectory}/clientstyle.css" charset="utf-8" />
<link rel="stylesheet" type="text/css" href="{$cssDirectory}/tabs.css" charset="utf-8" />
<script language="JavaScript" type="text/javascript" charset="utf-8" src="{$jsDirectory}/toggle.js"></script>
</head>
<body>

<table border="0" cellspacing="0" cellpadding="0" align="center" class="tabw">
<tr>
	<td valign="middle">
		<form name="login" method="post" action="login.php">
		<input type="hidden" name="action" value="{getActionID action="LoginResponse"}" />
		{if ($redirectActionID && $redirectActionFile)}
		    <input type="hidden" name="redirectActionID" value="{$redirectActionID}" />
		    <input type="hidden" name="redirectActionFile" value="{$redirectActionFile}" />
		    <input type="hidden" name="redirectArgs" value="{$redirectArgs}" />
		{/if}
		<div class="login">
			{assign var="msg" value=$smarty.request.msg}
			<div class="login03">{$smarty.const.TRANS_IP_LOGGING_ENABLED}: {$userIP} {if $smarty.request.msg} - <strong>{$smarty.request.msg|urldecode|stripslashes}</strong>{/if}</div>
			<table>
			<tr>
				<td>
					<div class="login01">
						<a href="http://www.modernbill.com/" title="ModernBill Billing Software" target="_blank"><img src="{$imageDirectory}/logos/logo.gif" alt="ModernBill Billing Software" width="120" height="55" border="0" /></a>
					</div>
				</td>
				<td>
					<div class="login02">
						<h1>{$smarty.const.TRANS_CLIENT_LOGIN}</h1>
						<table width="200"  border="0" cellspacing="0" cellpadding="0" class="login04">
						<tr>
							<td align="right">{$smarty.const.TRANS_USERNAME}:</td>
							<td><input name="contactUsername" type="text" value="" /></td>
						</tr>
						<tr>
							<td align="right">&nbsp;{$smarty.const.TRANS_PASSWORD}:</td>
							<td><input name="contactPassword" type="password" value="" /></td>
						</tr>
						<tr>
							<td align="center">&nbsp;</td>
							<td><div class="rm_login"><input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_LOGIN}" /></div></td>
						</tr>
						</table>
						<a href="#">{$smarty.const.TRANS_FORGOT_YOUR_PASSWORD}?</a>
					</div>{* login02 *}
				</td>
			</tr>
			</table>
			<div style="clear:both"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" alt="" title="" /></div>
			</div>{* login *}
		</form>
	</td>
</tr>
</table>

</td></tr>
</table>

</body>
</html>
