{* $Id: ShowPackages.tpl,v 1.19 2006/07/06 17:47:33 bsmith Exp $
 * --------------------------------------------------------------
 * This template displays a list of packages.
 *
 * Smarty Variables:
 *	$packages (array of packages that match criteria)
 *      $packageUsage (array of usage info)
 *
 *}
{strip}
 
{t c="TRANS_NAME" d="Name"}
{t c="TRANS_CONFIGURE" d="Configure"}
{t c="TRANS_UPGRADE_DOWNGRADE" d="Upgrade/Downgrade"}
{t c="TRANS_WITHDRAW_CANCELLATION" d="Withdraw Cancellation"}
{t c="TRANS_PACKAGE_PENDING_CANCELLATION" d="PACKAGE PENDING CANCELLATION"}
{t c="TRANS_NO_PACKAGES_FOUND" d="No Packages Found"}
{t c="TRANS_UPGRADE" d="Upgrade"} 
{t c="TRANS_DOMAIN" d="Domain"}
{t c="TRANS_PANEL_OPTIONS" d="Panel Options"}
{/strip}
{include file="$tplDirectory/header.tpl" tabMajor="packages" tabMinor="packages"}


{if $numPackages==0}
	<h6>{$smarty.const.TRANS_NO_PACKAGES_FOUND}</h6>
{else}

	{foreach key="statusID" item="packageGroup" from=$statusPackages}
		{assign var="packages" value=$packageGroup.packages}

		<div class="box07">
			<div class="st01"><h1>{$packageStatuses.$statusID}</h1></div>
			<table width="100%" border="0" cellpadding="0" cellspacing="2" class="list">
				<tr class="subHeaderRow" bgcolor="#CCCCCC">
					<td class="firstTD" style="text-align: center;">
						{$smarty.const.TRANS_ID}
					</td>
					<td style="text-align: center; white-space: nowrap;">
						{$smarty.const.TRANS_PACKAGE_NAME}
					</td>
					<td style="text-align: center; white-space: nowrap;">
						{$smarty.const.TRANS_PRICE}
					</td>
					<td style="text-align: center; white-space: nowrap;">
						{$smarty.const.TRANS_BILLING_CYCLE}
					</td>
					<td style="text-align: center; white-space: nowrap;">
						{$smarty.const.TRANS_NEXT_RENEWAL}
					</td>
					<td style="text-align: center; white-space: nowrap;">
						{$smarty.const.TRANS_ACTION}
					</td>
				</tr>

				{section name="i" loop=$packages}
				<tr class="{cycle values="alt1,alt2"} {if $packages[i].packagePendingCancellation>0 && $packages[i].packageStatus != $cancelledStatusID}highlight{/if}">
					<td style="text-align: center;">
						{$packages[i].packageID}
					</td>
					<td style="text-align: left;">
						{$packages[i].packageName}
						{section name="x" loop=$packages[i].domains}
							<br />{$smarty.const.TRANS_DOMAIN}: <strong>{$packages[i].domains[x].domainSLD}.{$packages[i].domains[x].domainTLD}</strong>
						{/section}
						{if $packages[i].packagePendingCancellation>0 && $packages[i].packageStatus != $cancelledStatusID}
							<br /><strong>{$smarty.const.TRANS_PACKAGE_PENDING_CANCELLATION}</strong>
						{/if}
					</td>
					<td style="text-align: right;">
						{$packages[i].packagePrice|getAmount:$packages[i].paymentGroupCurrencyID}
					</td>
					<td style="text-align: center;">
						{$packages[i].cycleID|getArrayValueByID:$cycles}
					</td>
					<td style="text-align: center;">
						{$packages[i].packageDateNextRenewal|getDate:short}
					</td>
					<td  style="text-align: center;">
						{if $packages[i].clientCancel==1}
							{if $packages[i].packagePendingCancellation==0 && $packages[i].mayCancel==1}
								{include file="$tplDirectory/widgets/actionLink.tpl"
									page="packages.php"
									actionName="CancelPackage"
									args="packageID=`$packages[i].packageID`"
									icoImage="cancel"
									icoWidth=""
									icoHeight=""
									icoStyle=""
									altText="TRANS_CANCEL"
									titleText="TRANS_CANCEL"
									linkText="TRANS_CANCEL"
									noSpace="1"
								}
							{/if}
							{if $packages[i].packagePendingCancellation==1}
								{include file="$tplDirectory/widgets/actionLink.tpl"
									page="packages.php"
									actionName="CancelPackage"
									args="packageID=`$packages[i].packageID`"
									icoImage="uncancel"
									icoWidth=""
									icoHeight=""
									icoStyle=""
									altText="TRANS_WITHDRAW_CANCELLATION"
									titleText="TRANS_WITHDRAW_CANCELLATION"
									linkText="TRANS_WITHDRAW_CANCELLATION"
									noSpace="1"
								}
							{/if}
						{/if}
						{if $statusID == "none"|get_status_id:"package"}
							{include file="$tplDirectory/widgets/actionLink.tpl"
										page="packages.php"
										actionName="ShowPanelOptions"
										args="packageID=`$packages[i].packageID`"
										icoImage="view"
										icoWidth=""
										icoHeight=""
										icoStyle=""
										altText="TRANS_PANEL_OPTIONS"
										titleText="TRANS_PANEL_OPTIONS"
										linkText="TRANS_PANEL_OPTIONS"
										noSpace="1"
										}
						{/if}
						{if $packages[i].packagePendingCancellation==0 && $upgradeDowngradeStatuses.$statusID==1}
							{*if $packages[i].rules.addons==1}
        							{include file="$tplDirectory/widgets/actionLink.tpl"
									    page="packages.php"
									    actionName="EditPackageAddons"
									    args="packageID=`$packages[i].packageID`"
									    icoImage="addons"
									    icoWidth=""
									    icoHeight=""
									    icoStyle=""
									    altText="TRANS_CONFIGURE"
									    titleText="TRANS_CONFIGURE"
									    linkText="TRANS_CONFIGURE"
									    noSpace="1"
									}
							{/if *}
							{if $packages[i].rules.upgrade==1}
        							{include file="$tplDirectory/widgets/actionLink.tpl"
									    page="packages.php"
									    actionName="UpgradePackage"
									    args="packageID=`$packages[i].packageID`"
									    icoImage="upgrade"
									    icoWidth=""
									    icoHeight=""
									    icoStyle=""
									    altText="TRANS_UPGRADE"
									    titleText="TRANS_UPGRADE"
									    linkText="TRANS_UPGRADE"
									    noSpace="1"
									}
							{/if}
							{if $packages[i].rules.downgrade==1}
        							{include file="$tplDirectory/widgets/actionLink.tpl"
									    page="packages.php"
									    actionName="DowngradePackage"
									    args="packageID=`$packages[i].packageID`"
									    icoImage="downgrade"
									    icoWidth=""
									    icoHeight=""
									    icoStyle=""
									    altText="TRANS_DOWNGRADE"
									    titleText="TRANS_DOWNGRADE"
									    linkText="TRANS_DOWNGRADE"
									    noSpace="1"
									}
							{/if}
						{/if}
					</td>
				</tr>			
					{assign var="packageID" value=$packages[i].packageID}
					{if $packageUsage[$packageID]}
						{assign var="usage" value=$packageUsage[$packageID]}
						{section name=j loop=$usage}
							{if $usage[j].packageUsage != 0}
							<tr align="right">
								<td colspan="6">
									<img class="graph" src="graphs.php?action={getActionID action="ShowGenericBar"}&sid={$sid}&amount={$usage[j].packageUsage}&limit={$usage[j].packageUsageLimit}" border="0" />
									{$usage[j].packageUsageUnit}
								</td>
							</tr>
							{/if}
						{/section}
					{/if}
				{/section}

			</table>

		</div>
		<br />

	{/foreach}

{/if}


{include file="$tplDirectory/footer.tpl"}
