{* $Id: AddTodo.tpl,v 1.4 2006/06/08 01:25:57 kbailey Exp $
 * --------------------------------------------------------------
 * This template displays a form to add a new to-do. The form must post to todos.php, 
 * with the action ID for the AddTodoResponse action, so that the POST data can 
 * be handled by the server. This template takes the $todostatus smarty variable, used to display
 * the options for the status of the to-do.
 *
 * Smarty Variables:
 *	$todostatus -- Array of possible statuses for the To Do item.
 *
 *}

{t c="TRANS_ADD_TODO" d="Add Todo"}
{t c="TRANS_IS_PUBLIC" d="Is Public"}

{include file="$tplDirectory/header.tpl" tabMajor="dashboard" tabMinor="todos"}

<table  border="0" width="98%" cellpadding="0" cellspacing="12"  class="tab01">
<tr>
    <td colspan="2">
		<div class="box07">
			<div class="st01"><h1>{$smarty.const.TRANS_ADD_TODO}</h1></div>
			<form method="post" action="todos.php">
			<input type="hidden" name="action" value="{getActionID action="AddTodoResponse"}" />
			<input type="hidden" name="sid" value="{$sid}" />
			
			<table  width="770" border="0" cellpadding="0" cellspacing="3" class="form">
			<tr class="headerRow">
				<td colspan="2">{$smarty.const.TRANS_TODOS}</td>
			</tr>
			<tbody>
			<tr class="{if $invalid.todoTitle}highlight{else}{cycle values="alt1,alt2"}{/if}">
				<th nowrap><label for="todoTitle">{$smarty.const.TRANS_TITLE}:</label></th>
				<td width="100%"><input size="20" maxlength="255" type="text" id="todoTitle" name="todoTitle" value="{$formValues.todoTitle}" /> {$invalid.todoTitle}</td>
			</tr>
			<tr class="{if $invalid.todoDesc}highlight{else}{cycle values="alt1,alt2"}{/if}">
				<th nowrap><label for="todoDesc">{$smarty.const.TRANS_DESCRIPTION}:</label></th>
				<td width="100%"><textarea cols="40" rows="5" id="todoDesc" name="todoDesc">{$formValues.todoDesc}</textarea> {$invalid.todoDesc}</td>
			</tr>
			<tr class="{if $invalid.todoAssignedAdminID}highlight{else}{cycle values="alt1,alt2"}{/if}">
				<th nowrap><label for="todoAssignedAdminID">{$smarty.const.TRANS_ASSIGNED_ADMINS}:</label></th>
				<td width="100%"><select id="todoAssignedAdminID" name="todoAssignedAdminID">{html_options options=$adminsList selected=$formValue.todoAssignedAdminID}</select> {$invalid.todoAssignedAdminID}</td>
			</tr>
			<tr class="{if $invalid.todoStatusID}highlight{else}{cycle values="alt1,alt2"}{/if}">
				<th nowrap><label for="todoStatusID">{$smarty.const.TRANS_STATUS}:</label></th>
				<td width="100%"><select id="todoStatusID" name="todoStatusID"> {html_options options=$todostatus selected=$formValue.todoStatusID} </select> {$invalid.todoStatusID}</td>
			</tr>
			<tr class="{cycle values="alt1,alt2"}">
				<th nowrap><label for="todoIsPublic">{$smarty.const.TRANS_IS_PUBLIC}:</label></th>
				<td width="100%"><input type="checkbox" id="todoIsPublic" name="todoIsPublic" value="1" {if $todoIsPublic}checked="checked"{/if} /></td>
			</tr>
			<tr class="{if $invalid.todoDateDue}highlight{else}{cycle values="alt1,alt2"}{/if}">
				<th nowrap><label for="todoDateDue">{$smarty.const.TRANS_DATE_DUE}:</label></th>
				<td width="100%">{include file="$tplDirectory/widgets/dateSelector.tpl" param="todoDateDue"}{$invalid.todoDateDue}</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
				<td>
					<input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_ADD_TODO}" />
				</td>
			</tr>
			</tbody>
			</table>
			</form>
		</div>
	</td>
</tr>
</table>
{include file="$tplDirectory/footer.tpl"}
