{* $Id: ShowTodoDetails.tpl,v 1.3 2006/06/08 01:25:57 kbailey Exp $
 * --------------------------------------------------------------
 * This template displays a single to-do item's details in a readable manner. This template 
 * will eventually display more information about a to-do item than the ShowTodos action; but 
 * for now the same amount of data is shown in both templates.
 *
 * Smarty Variables:
 *	$todo -- an array data about the given to-do item
 *	         That information is structured as follows:
 *	           todoID --  The ID of the to-do item
 *	           todoTitle -- The title of the todo
 *	           todoDesc -- A longer description of the todo item. This may include links to other actions.
 *	           adminID -- The ID of the admin who created the to-do item, or was assigned to
 *	           adminData -- An array of data about the administrator who created this todo
 *	                        The array is of the form:
 *	                          adminID -- The ID of the admin
 *	                          adminUsername -- The username of the admin
 *	                          adminFirstName -- The first name of the admin
 *	                          adminLastName -- The last name of the admin
 *	           todoDateCreated -- The UNIX timestamp of when this to-do item was created
 *	           todoDue -- The UNIX timestamp of when this to-do item is due
 *	           todoStatusID -- The integer ID of the status that is associated with this to-do item
 *}

{t c="TRANS_TODO_DETAILS" d="Todo Details"}
{t c="TRANS_TODOS" d="Todos"}

{t c="TRANS_MANAGE_TODOS" d="Manage Todos"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_DELETE" d="Delete"}

{t c="TRANS_TITLE" d="Title"}
{t c="TRANS_DESCRIPTION" d="Description"}
{t c="TRANS_AUTHOR" d="Author"}
{t c="TRANS_ASSIGNED_ADMINS" d="Assigned Admins"}
{t c="TRANS_DATE_DUE" d="Date Due"}
{t c="TRANS_DATE_CREATED" d="Date Created"}

{t c="TRANS_OPEN" d="Open"}
{t c="TRANS_CLOSED" d="Closed"}

{include file="$tplDirectory/header.tpl" tabMajor="dashboard" tabMinor="todos"}

{assign var=todoID value=$todo.todoID}
<table  border="0" width="98%" cellpadding="0" cellspacing="12"  class="tab01">
<tr>
    <td colspan="2">
		<div class="box07">
			<div class="st01"><h1>{$smarty.const.TRANS_TODO_DETAILS}</h1></div>
			<table  width="770" border="0" cellpadding="0" cellspacing="3" class="tab01" >
			<tbody>
			<tr>
				<th scope="col" colspan="2">{$smarty.const.TRANS_TODOS} <span style="margin-left:70%;"><input class="submit" type="button" onClick="document.location.href='{getHREF page="todos.php" actionName="EditTodo" args="todoID=$todoID"}';" value="{$smarty.const.TRANS_EDIT}" />  <input class="submit" type="button" onClick="document.location.href='{getHREF page="todos.php" actionName="RemoveTodo" args="todoID=$todoID"}';" value="{$smarty.const.TRANS_DELETE}" /></span></th>
			</tr>
			<tr class="{cycle values="alt1,alt2"}">
				<th class="nowrap" scope="row"><label for="todoTitle">{$smarty.const.TRANS_TITLE}</label></th>
				<td width="100%">{$todo.todoTitle|constant}</td>
			</tr>
			<tr class="{cycle values="alt1,alt2"}">
				<th class="nowrap" scope="row"><label for="todoDesc">{$smarty.const.TRANS_DESCRIPTION}</label></th>
				<td width="100%">{$todo.todoDesc|nl2br|constant}
				{if $todo.todoLinkFile}
					{assign var=todoLinkFile value=$todo.todoLinkFile}
					{assign var=todoLinkActionName value=$todo.todoLinkActionName}
					{assign var=todoLinkPk value=$todo.todoLinkPk}
					{assign var=todoLinkName value=$todo.todoLinkName}
					<a href="{getHREF page="$todoLinkFile" actionName="$todoLinkActionName" args="$todoLinkName=$todoLinkPk"}">
						<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
					</a>
				{/if}
				</td>
			</tr>
			<tr class="{cycle values="alt1,alt2"}">
				<th class="nowrap" scope="row"><label for="todoAdminID">{$smarty.const.TRANS_AUTHOR}</label></th>
				<td width="100%">{$todo.admins.0.adminFirstName} {$todo.admins.0.adminLastName}</td>
			</tr>
			<tr class="{cycle values="alt1,alt2"}">
				<th class="nowrap" scope="row"><label for="todoAdmin">{$smarty.const.TRANS_ASSIGNED_ADMINS}</label></th>
				<td width="100%">{$todo.assigned.0.adminFirstName} {$todo.assigned.0.adminLastName} - {$todo.assigned.0.adminUsername}</td>
			</tr>
			<tr class="{cycle values="alt1,alt2"}">
				<th class="nowrap" scope="row"><label for="todoStatusID">{$smarty.const.TRANS_STATUS}</label></th>
				<td width="100%">{$todo.todoStatusID|getArrayValueByID:$todostatus}</td>
			</tr>
			<tr class="{cycle values="alt1,alt2"}">
				<th class="nowrap" scope="row"><label for="todoDateDue">{$smarty.const.TRANS_DATE_DUE}</label></th>
				<td width="100%">{$todo.todoDateDue|getDate:medium}</td>
			</tr>
			<tr class="{cycle values="alt1,alt2"}">
				<th class="nowrap" scope="row"><label for="todoDateDue">{$smarty.const.TRANS_DATE_CREATED}</label></th>
				<td width="100%">{$todo.todoDateCreated|getDate:medium}</td>
			</tr>
			</tbody>
			</table>
		</div>
	</td>
</tr>
</table>
{include file="$tplDirectory/footer.tpl"}
