{* $Id: ShowTodos.tpl,v 1.5 2006/06/08 04:21:20 mfountain Exp $
 * --------------------------------------------------------------
 * This template displays a single to-do item's details in a readable manner. This template
 * will eventually display less information about a to-do item than the ShowTodoDetails action; but
 * for now the same amount of data is shown in both templates.
 *
 * Smarty Variables:
 *	$todo -- an array data about the given to-do item
 *	         That information is structured as follows:
 *	           todoID --  The ID of the to-do item
 *	           todoTitle -- The title of the todo
 *	           todoDesc -- A longer description of the todo item. This may include links to other actions.
 *	           adminID -- The ID of the admin who created the to-do item, or was assigned to
 *	           adminData -- An array of data about the administrator who created this todo
 *	                        The array is of the form:
 *	                          adminID -- The ID of the admin
 *	                          adminUsername -- The username of the admin
 *	                          adminFirstName -- The first name of the admin
 *	                          adminLastName -- The last name of the admin
 *	           todoDateCreated -- The UNIX timestamp of when this to-do item was created
 *	           todoDue -- The UNIX timestamp of when this to-do item is due
 *	           todoStatusID -- The integer ID of the status that is associated with this to-do item
 *
 * Author: Brian Smith
 *}
{t c="TRANS_MY_TODO_ITEMS" d="My Todo Items"}
{t c="TRANS_ASSIGNED" d="Assigned"}
{t c="TRANS_PAST_DUE" d="Past Due"}
{t c="TRANS_PUBLIC" d="Public"}

{* for todo assignments of certs *}
{t c="TRANS_TODO_BEGIN_CERT_REQUEST" d="Begin Cert Request"}
{t c="TRANS_TODO_BEGIN_CERT_REQUEST_MSG" d="Your SSL Certificate token has been purchased. Please continue to order the certificate."}

{include file="$tplDirectory/header.tpl" tabMajor="dashboard" tabMinor="todos"}

{foreach key=key item=title from=$todostatusheaders}
	<table width="100%" border="0" cellpadding="0" cellspacing="0" class="tab01 todoCapsule todoCapsule_{$key}">
	<thead>
		<tr>
			<td colspan="5"><img src="{$imageDirectory}/ico/note.gif" width="16" height="16" alt="" title="" style="vertical-align:middle;" /> {$title|upper}</td>
		</tr>
	</thead>
	<tbody>
		<tr class="high1">
			<td  width="33%" class="mine">
				<b>{$smarty.const.TRANS_MY_TODO_ITEMS}</b>
			</td>
			<td class="spacer"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" /></td>
			<td  width="33%" class="assigned" valign="top">
				<b>{$smarty.const.TRANS_ASSIGNED}</b>
			</td>
			<td class="spacer"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" /></td>
			<td  width="33%" class="public" valign="top">
				<b>{$smarty.const.TRANS_PUBLIC}</b>
			</td>
		</tr>
		{assign var=i value="-1"}
		{cycle reset=true values="high1,high2" print=false}
		{section start=0 loop=$rowCount.$key step=1 name=loop}
			{assign var=$i value=$i++}
			<tr class="{cycle values="high2,high1"}">
				<td class="mine" valign="top">
					{if $todos.$key.mine.$i.todoID != ''}
						{assign var=todoID value=$todos.$key.mine.$i.todoID}
						&#187; {$todos.$key.mine.$i.todoDateDue|getDate:medium}: <a href="{getHREF page="todos.php" actionName="ShowTodoDetails" args="todoID=$todoID"}">{$todos.$key.mine.$i.todoTitle|constant}</a>
					{else}
						{if $i == "0"}
							<i>{$smarty.const.TRANS_NONE}</i>
						{else}
							&nbsp;
						{/if}
					{/if}
				</td>
				<td class="spacer"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" /></td>
				<td class="assigned" valign="top">
					{if $todos.$key.assigned.$i.todoID != ''}
						{assign var=todoID value=$todos.$key.assigned.$i.todoID}
						&#187; {$todos.$key.assigned.$i.todoDateDue|getDate:medium}: <a href="{getHREF page="todos.php" actionName="ShowTodoDetails" args="todoID=$todoID"}">{$todos.$key.assigned.$i.todoTitle|constant}</a> {$todos.$key.assigned.$i.assigned.0.adminFirstName} {$todos.$key.assigned.$i.assigned.0.adminLastName}
					{else}
						{if $i == "0"}
							<i>{$smarty.const.TRANS_NONE}</i>
						{else}
							&nbsp;
						{/if}
					{/if}
				</td>
				<td class="spacer"><img src="{$imageDirectory}/spacer.gif" width="1" height="1" /></td>
				<td class="public" valign="top">
					{if $todos.$key.public.$i.todoID != ''}
						{assign var=todoID value=$todos.$key.public.$i.todoID}
						&#187; {$todos.$key.public.$i.todoDateDue|getDate:medium}: <a href="{getHREF page="todos.php" actionName="ShowTodoDetails" args="todoID=$todoID"}">{$todos.$key.public.$i.todoTitle|constant}</a> {$todos.$key.public.$i.public.0.adminFirstName} {$todos.$key.public.$i.public.0.adminLastName}
					{else}
						{if $i == "0"}
							<i>{$smarty.const.TRANS_NONE}</i>
						{else}
							&nbsp;
						{/if}
					{/if}
				</td>
			</tr>
		{/section}
	</tbody>
	</table>
	<br clear="all" />
{/foreach}


{include file="$tplDirectory/footer.tpl"}