{* $Id: listHeaderFilter.tpl,v 1.2 2006/06/09 20:36:41 kbailey Exp $
 * --------------------------------------------------------------
 * This widget template is used to display each <th></th> that allows filtering of that column.
 * We only want to allow filter options if the column has a finate set of values.
 *
 * Smarty Variables:
 *	$fileName		The page name to submit to.
 *	$actionID		The actionID to submit to.
 *  $sortColumn		A sort column state that you need to maintain for this filter.
 *  $sortDir		A sort direction state that you need to maintain for this filter.
 *  $query			A search query that you need to maintain for this filter.
 *  $queryColumn	A search query column that you need to maintain for this filter.
 *	$filterName		The name of the column to be filtered.
 *	$filterColumn	The database column to be filtered.
 *	$filterOptions	An array of filtered select options.
 *  $sid			The current sessionID
 *
 * Example Usage:
 *	{include file="$tplDirectory/widgets/table/tableFilterHeader.tpl" filterName="CONSTANT" filterColumn="someColumnName" filterOptions="$someOptionsArrayVariable"}
 *}
{t c="TRANS_FILTER_BY" d="Filter By"}
{t c="TRANS_SHOW_ALL" d="Show All"}
{t c="TRANS_STATE" d="State"}

{if $fileName==""}
	{assign var="thisFile" value=$smarty.server.PHP_SELF}
{/if}

{assign var="newSort" value="asc"}
{assign var="newSortTitle" value=$smarty.const.TRANS_SORT_ASC}
{if $smarty.request.sortDir == "asc"}
	{assign var="newSort" value="desc"}
	{assign var="newSortTitle" value=$smarty.const.TRANS_SORT_DESC}
{/if}

{strip}
<td nowrap="nowrap"{if $colWidth>0} width="{$colWidth}"{/if} style="text-align:center;">
<form method="get" action="{$fileName}">
<input type="hidden" name="action" value="{$actionID}" />
{if $sortColumn}<input type="hidden" name="sortColumn" value="{$sortColumn}" />{/if}
{if $sortDir}<input type="hidden" name="sortDir" value="{$sortDir}" />{/if}
{if $query}<input type="hidden" name="query" value="{$query}" />{/if}
{if $queryLeast}<input type="hidden" name="queryLeast" value="{$queryLeast}" />{/if}
{if $queryGreatest}<input type="hidden" name="queryGreatest" value="{$queryGreatest}" />{/if}
{if $queryColumn}<input type="hidden" name="queryColumn" value="{$queryColumn}" />{/if}
{if $amountQuery}<input type="hidden" name="amountQuery" value="{$amountQuery}" />{/if}
{if $amountCompare}<input type="hidden" name="amountCompare" value="{$amountCompare}" />{/if}
{if $amountBool}<input type="hidden" name="amountBool" value="{$amountBool}" />{/if}
{if $amountColumn}<input type="hidden" name="amountColumn" value="{$amountColumn}" />{/if}
{if $dateQuery}<input type="hidden" name="dateQuery" value="{$dateQuery}" />{/if}
{if $dateCompare}<input type="hidden" name="dateCompare" value="{$dateCompare}" />{/if}
{if $dateBool}<input type="hidden" name="dateBool" value="{$dateBool}" />{/if}
{if $dateColumn}<input type="hidden" name="dateColumn" value="{$dateColumn}" />{/if}
{foreach from=$filters item=filter}
	{if $smarty.request.$filter}<input type="hidden" name="{$filter}" value="{$smarty.request.$filter}" />{/if}
{/foreach}
<a href="{getHREF page=$fileName actionID=$actionID args="$queryArgs&$filterArgs&sortColumn=$sortColumn&sortDir=$newSort"}" title="{$newSortTitle}"><b><span style="vertical-align: baseline;">{$smarty.const.$filterName}:</span></b></a>
<select name="{$filterColumn}" style="margin-left:2px;">
	<option value="">{$smarty.const.TRANS_SHOW_ALL}</option>
	{mb_html_options options=$filterOptions selected=$smarty.request.$filterColumn pre=" |-- "}
</select>
<input type="image" src="{$imageDirectory}/ico/030.gif" size="13" alt="" title="" style="margin-left:2px; vertical-align: text-bottom;" />
<input type="hidden" name="sid" value="{$sid}" />
</form>
</td>
{if $addEmptyTD}
<td>&nbsp;</td>
{/if}
{/strip}
