{* $Id: ShowClients.tpl,v 1.1 2006/03/27 20:34:40 mfountain Exp $
 * --------------------------------------------------------------
 * This template displays a list of client records.
 *
 * Smarty Variables:
 *	$clients (array of clients that match input criteria)
 *		clientID			A unique client ID
 *		clientFirstName		A client's first name
 *		clientLastName		A client's last name
 *		clientEmail			A client's email address
 *		clientCompany		A client's company name
 *		clientActive		The active state of a client
 *	$clientActive			The $_REQUEST value of clientActive filter option
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *  $sid					The current sessionID
 *
 * Author: Michael Fountain
 * Author: Ben Woolley
 *}
{t c="TRANS_ACCOUNT_BALANCE" d="Account Balance"}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_ADD_NEW_CONTACT" d="Add new contact"}
{t c="TRANS_ACTIVE" d="Active"}
{t c="TRANS_CLIENT_ID" d="Client ID"}
{t c="TRANS_LAST_NOTE" d="Last Note"}
{t c="TRANS_NOTE" d="Note"}
{t c="TRANS_NO_NOTES" d="No Notes"}
{t c="TRANS_COMPANY" d="Company"}
{t c="TRANS_DETAILS" d="Details"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_EMAIL" d="Email"}
{t c="TRANS_FIRST_NAME" d="First Name"}
{t c="TRANS_LAST_NAME" d="Last Name"}
{t c="TRANS_NAME" d="Name"}
{t c="TRANS_MANAGE_CLIENTS" d="Manage Clients"}
{t c="TRANS_NORESULTS" d="No Results"}
{t c="TRANS_REMOVE" d="Remove"}
{t c="TRANS_SHOW_ALL" d="Show All"}
{t c="TRANS_STATUS" d="Status"}
{t c="TRANS_TIMESTAMP" d="TimeStamp"}
{t c="TRANS_USERNAME" d="Username"}
{t c="TRANS_DATE_CREATED" d="Date Created"}
{t c="TRANS_PRIMARY_CONTACT" d="Primary Contact"}
{t c="TRANS_PHONE" d="Phone"}
{t c="TRANS_LAST_ACCESS" d="Last Access"}
{t c="TRANS_LAST_TICKET" d="Last Ticket"}
{t c="TRANS_ONLINE" d="Online"}
{t c="TRANS_OFFLINE" d="Offline"}
{t c="TRANS_SHOW_ALL_ADD_NEW" d="Show All/Add New"}
{t c="TRANS_ADD_NEW" d="Add New"}
{t c="TRANS_ID" d="ID"}
{t c="TRANS_ADDITIONAL_INFORMATION" d="Additional Information"}
{t c="TRANS_ADDITIONAL_DATA" d="Display/Hide Additional Data"}

{assign var="filterArgs" value="clientActive=$clientActive&clientStatus=$clientStatus"}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName="TRANS_SHOW_ALL"
	sideNavMajor="clients"
	sideNavMinor="clients"}

<table  border="0" width="98%" cellpadding="0" cellspacing="12"  class="tab01">
<tr>
    <td colspan="2">
		<div class="box07">
			<div class="st01"><h1>{$smarty.const.TRANS_CLIENTS}</h1></div>

            <table width="100%"  border="0" cellspacing="2" cellpadding="0" class="tab01">
            <thead>
            <tr>
	            {include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_ID" sortColumn="clientID"}
	            {include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_NAME" sortColumn="clientLastName"}
	            {include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_COMPANY" sortColumn="clientCompany"}
	            {include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_EMAIL" sortColumn="clientEmail"}
	            {include file="$tplDirectory/widgets/table/tableFilterHeader.tpl" filterName="TRANS_ACTIVE" filterColumn="clientActive" filterOptions="$activeInactive"}
	            {include file="$tplDirectory/widgets/table/tableFilterHeader.tpl" filterName="TRANS_STATUS" filterColumn="clientStatus" filterOptions="$clientStatusList"}
	            {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ACTIONS"}
            </tr>
            </thead>
            {section name=i loop="$clients"}
            {assign var="clientID" value=$clients[i].clientID}
            {if $className=="alt1"}
                {assign var="className" value="alt2"}
            {else}
                {assign var="className" value="alt1"}
            {/if}
            <tbody>
            <tr class="{cycle values="alt1,alt2"}"
	            onmouseover="this.className='althover';"
	            onmouseout="this.className='{$className}';">
	            <td>
		            {$clientID}
	            </td>
	            <td>
		            {$clients[i].clientLastName|stripslashes}, {$clients[i].clientFirstName|stripslashes}
	            </td>
	            <td>
		            {$clients[i].clientCompany|default:$smarty.const.TRANS_EMPTY|stripslashes}
	            </td>
	            <td>
		            {mailto address=$clients[i].clientEmail}
	            </td>
	            <td align="center">
		            {$clients[i].clientActive|getArrayValueByID:$activeInactive}
	            </td>
	            <td align="center">
		            {$clients[i].clientStatus|getStatusName:"client"}
	            </td>
	            <td align="center" class="nowrap">
		            {strip}
		            <a href="{getHREF page="clients.php" actionName="ShowClientDetails" args="clientID=$clientID"}">
			            <img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DETAILS}" title="{$smarty.const.TRANS_DETAILS}" />
		            </a>
		            &nbsp;
		            <a href="{getHREF page="clients.php" actionName="EditClient" args="clientID=$clientID"}">
			            <img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
		            </a>
		            &nbsp;
		            <a href="{getHREF page="clients.php" actionName="RemoveClient" args="clientID=$clientID"}">
			            <img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_REMOVE}" title="{$smarty.const.TRANS_REMOVE}" />
		            </a>
		            {/strip}
	            </td>
            </tr>
            </tbody>

            {sectionelse}
            <tr class="alt1">
	            <td colspan="7">{$smarty.const.TRANS_NORESULTS}</td>
            </tr>
            {/section}
            </table>
		</div>{* box07 *}

    </td>
</tr>

</table>

{include file="$tplDirectory/widgets/paginationLinks.tpl"}
{include file="$tplDirectory/footer.tpl"}
