{* $Id: header.tpl,v 1.6 2006/05/12 01:18:31 mfountain Exp $
 * --------------------------------------------------------------
 * This is the primary header template for the Client GUI of ModernBill. Note that this header.tpl
 * file will open several HTML tags must be closed by the footer.tpl file.
 *
 * Smarty Variables:
 *  $htmlTitle		The title of this document
 *  $htmlLang		The language this document will render
 *	$parentName		The page info parent name
 *	$childName		The page info child name
 *	$useMenu		The tab name to highlight
 *	$sideNavMajor		The side navigation file to include
 *	$loginName		The name of the admin user who is logged in
 * 	$cssDirectory	The relative path to the theme's css directory
 *	$jsDirectory	The relative path to the theme's javascript directory
 *	$imageDirectory	The relative path to the theme's image directory
 *
 * Example Usage:
 *  {include file="$tplDirectory/client/header.tpl" parentName="TRANS_" childName="TRANS_" sideNavMajor="dashboard"}
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_DASHBOARD" d="Dashboard"}
{t c="TRANS_RESELLERS" d="Resellers"}
{t c="TRANS_GOOGLE_CODES" d="Google Codes"}
{t c="TRANS_IMPORT_NEW_CODES" d="Import New Codes"}
{t c="TRANS_SYSTEM" d="System"}
{t c="TRANS_LOGOFF" d="Logoff"}
{t c="TRANS_ADD_RESELLER" d="Add Reseller"}
{t c="TRANS_LOGGED_IN_AS" d="Logged in as"}
{t c="TRANS_PROVISION_CODE" d="Provision Code"}

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="{$htmlLang}" lang="{$htmlLang}" dir="{$smarty.const.TRANS_TEXTDIRECTION}">
<head>
<title>{strip}
	{if $htmlTitle}
		{$htmlTitle}
	{else}
		{if $parentName}
			{$smarty.const.$parentName}
		{/if}
		{if $childName}
			&nbsp;&raquo; {$smarty.const.$childName}
		{/if}
		{if $grandchildName}
			&nbsp;&raquo; {$smarty.const.$grandchildName}
		{/if}
	{/if}
{/strip}</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />

<link rel="stylesheet" type="text/css" href="{$cssDirectory}/style.css" charset="utf-8" />
<link rel="stylesheet" type="text/css" href="{$cssDirectory}/clientstyle.css" charset="utf-8" />

<script language="javascript" type="text/javascript" src="{$jsDirectory}/preloadm.js" charset="utf-8"></script>
<script language="JavaScript" type="text/javascript" src="{$jsDirectory}/overlib.js" charset="utf-8"></script>
<script language="JavaScript" type="text/javascript" src="{$jsDirectory}/toggle.js" charset="utf-8"></script>
<script language="JavaScript" type="text/javascript" src="{$jsDirectory}/main.js" charset="utf-8"></script>
<script language="JavaScript" type="text/javascript" src="{$jsDirectory}/pushpull.js" charset="utf-8"></script>
{if $systemQueue.systemQueueRunning}
<script language="javascript" type="text/javascript" src="{$jsDirectory}/progress.js" charset="utf-8"></script>
{/if}
{if $includeAjaxJS}
<script language="javascript" type="text/javascript" src="{$jsDirectory}/../ajax/core/ajax.inc.js" charset="utf-8"></script>
{/if}
{if $includeDomainJS}
<script language="javascript" type="text/javascript" src="{$jsDirectory}/domains.js" charset="utf-8"></script>
{/if}
{* the following css & js files support the js calendar *}
<link rel="stylesheet" type="text/css" href="{$jsDirectory}/cal/themes/enx.css" charset="utf-8" />
<link rel="stylesheet" type="text/css" href="{$jsDirectory}/cal/themes/layouts/small.css" charset="utf-8" />
<script language="javascript" type="text/javascript" src="{$jsDirectory}/cal/src/utils.js" charset="utf-8"></script>
<script language="javascript" type="text/javascript" src="{$jsDirectory}/cal/src/calendar.js" charset="utf-8"></script>
<script language="javascript" type="text/javascript" src="{$jsDirectory}/cal/src/calendar-setup.js" charset="utf-8"></script>
<script language="javascript" type="text/javascript" src="{$jsDirectory}/cal/lang/calendar-{$calendarLanguageFile}.js" charset="utf-8"></script>
<body>

<center>
<table width="770" border="0" cellpadding="0" cellspacing="3" class="tab01" bgcolor="#FFFFFF">
{if $loginFirstName && $loginLastName}
<tr>
    <td colspan="2" align="left">
        <img src="{$imageDirectory}/logos/modernadvertise.gif" width="192" height="60" alt="ModernAdvertise" title="ModernAdvertise" />
    </td>
    <td colspan="2" align="right" valign="bottom">
		{strip}
        <img src="{$imageDirectory}/ico/022.gif" width="13" height="13" align="middle" alt="" title="" style="vertical-align:middle;border-style:none;" />
		&nbsp;
        {$smarty.const.TRANS_LOGGED_IN_AS}: <strong>{$loginFirstName} {$loginLastName}</strong>
        &nbsp;
        <img src="{$imageDirectory}/ico/024.gif" width="13" height="13" align="middle" alt="" title="" style="vertical-align:middle;border-style:none;" />
		&nbsp;
        <a href="{getHREF page="admins.php" actionName="EditMyProfile"}">
            {$smarty.const.TRANS_PROFILE}
        </a>
		&nbsp;
        <img src="{$imageDirectory}/ico/023.gif" width="13" height="13" align="middle" alt="" title="" style="vertical-align:middle;border-style:none;" />
		&nbsp;
        <a href="{getHREF page="login.php" actionName="LogoutResponse"}">
            {$smarty.const.TRANS_LOGOFF}
        </a>
		{/strip}
    </td>
</tr>
<tr>
    <th width="25%" id="ShowDashboard"
        {if $sideNavMajor=="dashboard"}
            style="background-color:#D3D3D3"
            class="th2"
        {else}
            style="background-color:#EEEDE9"
        {/if}>
        <center>
            <a href="{getHREF page="dashboard.php" actionName="ShowDashboard"}">
                {$smarty.const.TRANS_DASHBOARD}
            </a>
        </center>
    </th>
    <th width="25%" id="Show1"
        {if $sideNavMajor=="resellers"}
            style="background-color:#D3D3D3"
            class="th2"
        {else}
            style="background-color:#EEEDE9"
        {/if}>
        <center>
            <a href="{getHREF page="resellers.php" actionName="ShowResellers"}">
                {$smarty.const.TRANS_RESELLERS}
            </a>
        </center>
    </th>
    <th width="25%" id="Show2"
        {if $sideNavMajor=="ppc"}
            style="background-color:#D3D3D3"
            class="th2"
        {else}
            style="background-color:#EEEDE9"
        {/if}>
        <center>
            <a href="{getHREF page="ppc.php" actionName="ShowGoogleCodes"}">
                {$smarty.const.TRANS_GOOGLE_CODES}
            </a>
        </center>
    </th>
    <th width="25%" id="Show3"
        {if $sideNavMajor=="system"}
            style="background-color:#D3D3D3"
            class="th2"
        {else}
            style="background-color:#EEEDE9"
        {/if}>
        <center>
            <a href="{getHREF page="system.php" actionName="ShowSystem"}">
                {$smarty.const.TRANS_SYSTEM}
            </a>
        </center>
    </th>
</tr>
{if $sideNavMajor=="ppc"}
<tr>
    <td colspan="4" align="center" >
        <table border="0" cellpadding="0" cellspacing="3" class="tab01" bgcolor="#FFFFFF">
        <tr>
            <th>
                <a href="{getHREF page="ppc.php" actionName="ProvisionGoogleCode"}">
                    {$smarty.const.TRANS_PROVISION_CODE}
                </a>
            </th>
        </tr>
        </table>
    </td>
</tr>
{/if} {* $sideNavMajor *}
{if $sideNavMajor=="resellers"}
<tr>
    <td colspan="4" align="center" >
        <table border="0" cellpadding="0" cellspacing="3" class="tab01" bgcolor="#FFFFFF">
        <tr>
            <th>
                <a href="{getHREF page="resellers.php" actionName="AddReseller"}">
                    {$smarty.const.TRANS_ADD_RESELLER}
                </a>
            </th>
        </tr>
        </table>
    </td>
</tr>
{/if} {* $sideNavMajor *}
{/if} {* $loginFirstName && $loginLastName *}
<tr>
    <td colspan="4">
{*
 * Note: Leave the <td> above open. It will be closed at the top of the footer.tpl file.
 * Example: "header.tpl <td>" some content "</td> footer.tpl"
 *}