{* $Id: ShowResellers.tpl,v 1.2 2006/04/11 19:35:25 mfountain Exp $
 * --------------------------------------------------------------
 * This template displays a list of reseller records.
 *
 * Smarty Variables:
 *	$resellers (array of resellers that match input criteria)
 *		resellerID			A unique reseller ID
 *		resellerFirstName		A reseller's first name
 *		resellerLastName		A reseller's last name
 *		resellerEmail			A reseller's email address
 *		resellerCompany		A reseller's company name
 *		resellerActive		The active state of a reseller
 *	$resellerActive			The $_REQUEST value of resellerActive filter option
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *  $sid					The current sessionID
 *
 * Author: Michael Fountain
 * Author: Ben Woolley
 *}
{t c="TRANS_ACCOUNT_BALANCE" d="Account Balance"}
{t c="TRANS_ACTIONS" d="Actions"}
{t c="TRANS_ADD_NEW_CONTACT" d="Add new contact"}
{t c="TRANS_ACTIVE" d="Active"}
{t c="TRANS_RESELLER_ID" d="Client ID"}
{t c="TRANS_LAST_NOTE" d="Last Note"}
{t c="TRANS_NOTE" d="Note"}
{t c="TRANS_NO_NOTES" d="No Notes"}
{t c="TRANS_COMPANY" d="Company"}
{t c="TRANS_DETAILS" d="Details"}
{t c="TRANS_EDIT" d="Edit"}
{t c="TRANS_EMAIL" d="Email"}
{t c="TRANS_FIRST_NAME" d="First Name"}
{t c="TRANS_LAST_NAME" d="Last Name"}
{t c="TRANS_NAME" d="Name"}
{t c="TRANS_MANAGE_RESELLERS" d="Manage Clients"}
{t c="TRANS_NORESULTS" d="No Results"}
{t c="TRANS_REMOVE" d="Remove"}
{t c="TRANS_SHOW_ALL" d="Show All"}
{t c="TRANS_STATUS" d="Status"}
{t c="TRANS_TIMESTAMP" d="TimeStamp"}
{t c="TRANS_USERNAME" d="Username"}
{t c="TRANS_DATE_CREATED" d="Date Created"}
{t c="TRANS_PRIMARY_CONTACT" d="Primary Contact"}
{t c="TRANS_PHONE" d="Phone"}
{t c="TRANS_LAST_ACCESS" d="Last Access"}
{t c="TRANS_LAST_TICKET" d="Last Ticket"}
{t c="TRANS_ONLINE" d="Online"}
{t c="TRANS_OFFLINE" d="Offline"}
{t c="TRANS_SHOW_ALL_ADD_NEW" d="Show All/Add New"}
{t c="TRANS_ADD_NEW" d="Add New"}
{t c="TRANS_ID" d="ID"}
{t c="TRANS_ADDITIONAL_INFORMATION" d="Additional Information"}
{t c="TRANS_ADDITIONAL_DATA" d="Display/Hide Additional Data"}

{assign var="filterArgs" value="resellerActive=$resellerActive&resellerStatus=$resellerStatus"}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_RESELLERS"
	childName="TRANS_SHOW_ALL"
	sideNavMajor="resellers"
	sideNavMinor="resellers"}

<table  border="0" width="98%" cellpadding="0" cellspacing="12"  class="tab01">
<tr>
    <td colspan="2">
		<div class="box07">
			<div class="st01"><h1>{$smarty.const.TRANS_RESELLERS}</h1></div>

            <table width="100%"  border="0" cellspacing="2" cellpadding="0" class="tab01">
            <thead>
            <tr>
	            {include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_ID" sortColumn="resellerID"}
	            {include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_NAME" sortColumn="resellerLastName"}
	            {include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_COMPANY" sortColumn="resellerCompany"}
	            {include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_EMAIL" sortColumn="resellerEmail"}
	            {include file="$tplDirectory/widgets/table/tableFilterHeader.tpl" filterName="TRANS_STATUS" filterColumn="resellerStatus" filterOptions="$resellerStatusList"}
	            {include file="$tplDirectory/widgets/table/tableHeader.tpl" headerName="TRANS_ACTIONS"}
            </tr>
            </thead>
            {section name=i loop="$resellers"}
            {assign var="resellerID" value=$resellers[i].resellerID}
            {if $className=="alt1"}
                {assign var="className" value="alt2"}
            {else}
                {assign var="className" value="alt1"}
            {/if}
            <tbody>
            <tr class="{cycle values="alt1,alt2"}"
	            onmouseover="this.className='althover';"
	            onmouseout="this.className='{$className}';">
	            <td>
		            {$resellerID}
	            </td>
	            <td>
		            {$resellers[i].resellerLastName|stripslashes}, {$resellers[i].resellerFirstName|stripslashes}
	            </td>
	            <td>
		            {$resellers[i].resellerCompany|default:$smarty.const.TRANS_EMPTY|stripslashes}
	            </td>
	            <td>
		            {mailto address=$resellers[i].resellerEmail}
	            </td>
	            <td align="center">
		            {$resellers[i].resellerStatus|getStatusName:"reseller"}
	            </td>
	            <td align="center" class="nowrap">
		            {strip}
		            <a href="{getHREF page="resellers.php" actionName="ShowResellerDetails" args="resellerID=$resellerID"}">
			            <img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_DETAILS}" title="{$smarty.const.TRANS_DETAILS}" />
		            </a>
		            &nbsp;
		            <a href="{getHREF page="resellers.php" actionName="EditReseller" args="resellerID=$resellerID"}">
			            <img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_EDIT}" title="{$smarty.const.TRANS_EDIT}" />
		            </a>
		            &nbsp;
		            <a href="{getHREF page="resellers.php" actionName="RemoveReseller" args="resellerID=$resellerID"}">
			            <img src="{$imageDirectory}/ico/data_delete.gif" width="16" height="16" border="0" alt="{$smarty.const.TRANS_REMOVE}" title="{$smarty.const.TRANS_REMOVE}" />
		            </a>
		            {/strip}
	            </td>
            </tr>
            </tbody>

            {sectionelse}
            <tr class="alt1">
	            <td colspan="6">{$smarty.const.TRANS_NORESULTS}</td>
            </tr>
            {/section}
            </table>
		</div>{* box07 *}

    </td>
</tr>

</table>

{include file="$tplDirectory/widgets/paginationLinks.tpl"}
{include file="$tplDirectory/footer.tpl"}
