{* $Id: tableSortDateHeader.tpl,v 1.1 2006/03/26 22:21:05 mfountain Exp $
 * --------------------------------------------------------------
 * This widget template is used to display each <th></th> that allows sorting of that column.
 * We only want to allow sort options if the column has infinite values.
 *
 * This widget also builds a special search box for date columns, that when you click on
 * the header name, will only search this column using dates!
 *
 * Smarty Variables:
 *	$headerName  	The constant representation of that column name.
 *	$fileName		The file name to submit to
 *	$actionID		The current actionID
 *  $sortColumn		The sort column to pass to the sortLinks widget.
 *	$sortArgs		The sort arguments to pass to the sortLinks widget.
 *	$recordOffset	The current record offset value
 *	$imageDirectory	The image directory for this theme.
 *  $sid			The current sessionID
 *
 * Example Usage:
 *	{include file="$tplDirectory/widgets/table/tableSortDateHeader.tpl" headerName="TRANS_X" sortColumn="someColumnName"}
 *}
{t c="TRANS_AND" d="AND"}
{t c="TRANS_OR" d="OR"}
{t c="TRANS_DATE" d="Date"}
{t c="TRANS_EQUAL_TO" d="equal to (=)"}
{t c="TRANS_FIND_EXACT_MATCH" d="Find Exact Match"}
{t c="TRANS_FIND_DATE_RANGE" d="Find Date Range"}
{t c="TRANS_GREATER_THAN" d="greater than (&gt;=)"}
{t c="TRANS_LESS_THAN" d="less than (&lt;=)"}
{t c="TRANS_QUICK_FIND" d="Quick Find"}
{t c="TRANS_SORT_ASC" d="Ascending Sort"}
{t c="TRANS_SORT_DESC" d="Descending Sort"}
{t c="TRANS_DATE_FORMAT" d="Date Format: YYYY/MM/DD"}

{if $fileName==""}
	{assign var="thisFile" value=$smarty.server.PHP_SELF}
{/if}

{strip}
{if $smarty.request.sortColumn == $sortColumn}
<th class="sortcol"{if $colWidth>0} width="{$colWidth}"{/if}>
{else}
<th{if $colWidth>0} width="{$colWidth}"{/if}>
{/if}
	<table width="100%" cellspacing="0" cellpadding="0" border="0">
	<tr>
		<td align="left" nowrap="nowrap">
			<a href="javascript:void(0);" onclick="return overlib('&lt;center&gt;&lt;strong&gt;MM/DD/YYYY&lt;/strong&gt;&lt;/center&gt;
					&lt;br /&gt;
					&lt;form method=\'get\' action=\'{$fileName}\' name=\'DateSort\'&gt;
						&lt;input type=\'hidden\' name=\'action\' value=\'{$actionID}\' /&gt;
						{if $sortColumn}&lt;input type=\'hidden\' name=\'sortColumn\' value=\'{$sortColumn}\' /&gt;{/if}
						{if $sortDir}&lt;input type=\'hidden\' name=\'sortDir\' value=\'{$sortDir}\' /&gt;{/if}
						&lt;input type=\'hidden\' name=\'dateColumn\' value=\'{$sortColumn}\' /&gt;
                        &lt;input type=\'hidden\' name=\'sid\' value=\'{$sid}\'&gt;
                        {if $queryArgCol}&lt;input type=\'hidden\' name=\'{$queryArgCol}\' value=\'{$queryArgValue}\'&gt;{/if}
		                &lt;fieldset&gt;
			                &lt;legend&gt;{$smarty.const.TRANS_FIND_EXACT_MATCH}&lt;/legend&gt;
							&lt;table width=\'230\'&gt;
							&lt;tr&gt;
								&lt;td width=\'20%\'&gt;{$smarty.const.TRANS_DATE}&lt;/td&gt;
								&lt;td width=\'60%\'&gt;
									&lt;select name=\'dateCompare[]\' style=\'width:100%\'&gt;
										&lt;option value=\'\' selected=\'selected\'&gt;{$smarty.const.TRANS_EQUAL_TO}&lt;/option&gt;
									&lt;/select&gt;
								&lt;/td&gt;
								&lt;td width=\'20%\'&gt;
									&lt;input type=\'text\' name=\'dateQuery[]\' value=\'\' size=\'10\' /&gt;
								&lt;/td&gt;
							&lt;/tr&gt;
							&lt;tr&gt;
								&lt;td&gt;&nbsp;&lt;/td&gt;
								&lt;td colspan=\'2\' align=\'right\'&gt;&lt;input type=\'submit\' name=\'submit\' value=\'{$smarty.const.TRANS_FIND_EXACT_MATCH}\' /&gt;&lt;/td&gt;
							&lt;/tr&gt;
							&lt;/table&gt;
						&lt;/fieldset&gt;
					&lt;/form&gt;
					&lt;form method=\'get\' action=\'{$fileName}\'&gt;
						&lt;input type=\'hidden\' name=\'action\' value=\'{$actionID}\' /&gt;
						{if $sortColumn}&lt;input type=\'hidden\' name=\'sortColumn\' value=\'{$sortColumn}\' /&gt;{/if}
						{if $sortDir}&lt;input type=\'hidden\' name=\'sortDir\' value=\'{$sortDir}\' /&gt;{/if}
						&lt;input type=\'hidden\' name=\'dateColumn\' value=\'{$sortColumn}\' /&gt;
						&lt;input type=\'hidden\' name=\'sid\' value=\'{$sid}\'&gt;
                        {if $queryArgCol}&lt;input type=\'hidden\' name=\'{$queryArgCol}\' value=\'{$queryArgValue}\'&gt;{/if}
		                &lt;fieldset&gt;
			                &lt;legend&gt;{$smarty.const.TRANS_FIND_DATE_RANGE}&lt;/legend&gt;
							&lt;table width=\'230\'&gt;
							&lt;tr&gt;
								&lt;td width=\'20%\'&gt;{$smarty.const.TRANS_DATE}&lt;/td&gt;
								&lt;td width=\'60%\'&gt;
									&lt;select name=\'dateCompare[]\' style=\'width:100%\'&gt;
										&lt;option value=\'Least\' selected=\'selected\'&gt;{$smarty.const.TRANS_GREATER_THAN}&lt;/option&gt;
										{* &lt;option value=\'\'&gt;{$smarty.const.TRANS_EQUAL_TO}&lt;/option&gt; *}
										{* &lt;option value=\'Greatest\'&gt;{$smarty.const.TRANS_LESS_THAN}&lt;/option&gt; *}
									&lt;/select&gt;
								&lt;/td&gt;
								&lt;td width=\'20%\'&gt;&lt;input type=\'text\' name=\'dateQuery[]\' value=\'\' size=\'10\' /&gt;&lt;/td&gt;
							&lt;/tr&gt;
							&lt;tr&gt;
								&lt;td&gt;&nbsp;&lt;/td&gt;
								&lt;td&gt;
									&lt;select name=\'dateBool[]\' style=\'width:100%\'&gt;
										&lt;option value=\'AND\' selected=\'selected\'&gt;{$smarty.const.TRANS_AND}&lt;/option&gt;
										{* &lt;option value=\'OR\'&gt;{$smarty.const.TRANS_OR}&lt;/option&gt; *}
									&lt;/select&gt;
								&lt;/td&gt;
								&lt;td&gt;&nbsp;&lt;/td&gt;
							&lt;/tr&gt;
							&lt;tr&gt;
								&lt;td&gt;{$smarty.const.TRANS_DATE}&lt;/td&gt;
								&lt;td&gt;
									&lt;select name=\'dateCompare[]\' style=\'width:100%\'&gt;
										{* &lt;option value=\'Least\'&gt;{$smarty.const.TRANS_GREATER_THAN}&lt;/option&gt; *}
										{* &lt;option value=\'equal\'&gt;{$smarty.const.TRANS_EQUAL_TO}&lt;/option&gt; *}
										&lt;option value=\'Greatest\' selected=\'selected\'&gt;{$smarty.const.TRANS_LESS_THAN}&lt;/option&gt;
									&lt;/select&gt;
								&lt;/td&gt;
								&lt;td&gt;&lt;input type=\'text\' name=\'dateQuery[]\' value=\'\' size=\'10\' /&gt;&lt;/td&gt;
							&lt;/tr&gt;
							&lt;tr&gt;
								&lt;td&gt;&nbsp;&lt;/td&gt;
								&lt;td colspan=\'2\' align=\'right\'&gt;&lt;input type=\'submit\' name=\'submit\' value=\'{$smarty.const.TRANS_FIND_DATE_RANGE}\' /&gt;&lt;/td&gt;
							&lt;/tr&gt;
							&lt;/table&gt;
						&lt;/fieldset&gt;
					&lt;/form&gt;',
				BGCLASS, 'popupBG',
				FGCLASS, 'popupFG',
				CENTER, STICKY,
				CAPTION, '&nbsp;{$smarty.const.TRANS_QUICK_FIND}: {$smarty.const.$headerName}', CLOSECLICK, CLOSETEXT, '&lt;img src={$imageDirectory}/ico/remove.gif width=13 height=13 border=0 /&gt;');" onmouseout="return nd();">
				<b>{$smarty.const.$headerName}</b>
			</a>
		</td>
		<td align="right" nowrap="nowrap">
			<a href="{getHREF page=$fileName actionID=$actionID args="$queryArgs&$filterArgs&sortColumn=$sortColumn&sortDir=asc"}">
				<img src="{$imageDirectory}/ico/asc.gif" width="9" height="9" border="0" alt="{$smarty.const.TRANS_SORT_ASC}" title="{$smarty.const.TRANS_SORT_ASC}" />
			</a>
			<a href="{getHREF page=$fileName actionID=$actionID args="$queryArgs&$filterArgs&sortColumn=$sortColumn&sortDir=desc"}">
				<img src="{$imageDirectory}/ico/desc.gif" width="9" height="9" border="0" alt="{$smarty.const.TRANS_SORT_DESC}" title="{$smarty.const.TRANS_SORT_DESC}" />
			</a>
		</td>
	</tr>
	</table>
</th>
{/strip}