{* $Id: ShowResellerRegisterForm.tpl,v 1.2 2006/05/11 19:51:26 mfountain Exp $
 * --------------------------------------------------------------
 * This template displays a form to edit an reseller's profile.
 *
 * Smarty Variables:
 *	$reseller (array of this reseller's data)
 *		resellerID			A unique reseller ID
 *		resellerFirstName	An reseller's first name
 *		resellerLastName	An reseller's last name
 *		resellerEmail		An reseller's email address
 *		resellerUsername	An reseller's username
 *		resellerActive		The active state of an reseller
 *		themeID 		The unique themeID
 *		languageID 		The unique languageID
 *		countriesID 	The unique countriesID
 *	$actionID			The unique action ID for this page view
 *  $actionName			The action name for this action ID
 *	$imageDirectory		The image directory for this theme
 *	$tplDirectory		The template directory for this theme
 *
 * Author: Michael Fountain
 *}
{t c="TRANS_ADD_ADMIN_PROFILE" d="Add Admin Profile"}
{t c="TRANS_ASSIGNED_ADMIN_GROUPS" d="Assigned Admin Groups"}
{t c="TRANS_COUNTRY" d="Country"}
{t c="TRANS_CHANGE_REMOTE_ACCESS_HASH" d="Change Remote Access Hash"}
{t c="TRANS_EMAIL" d="Email"}
{t c="TRANS_FIRST_NAME" d="First Name"}
{t c="TRANS_LANGUAGE" d="Language"}
{t c="TRANS_LAST_NAME" d="Last Name"}
{t c="TRANS_MANAGE_ADMINS" d="Manage Admins"}
{t c="TRANS_MANAGE_SYSTEM" d="Manage System"}
{t c="TRANS_NEW_PASSWORD" d="New Password"}
{t c="TRANS_ENTER_PASSWORD_AGAIN" d="Enter Password Again"}
{t c="TRANS_THEME" d="Theme"}
{t c="TRANS_UPDATE_PROFILE" d="Update Profile"}
{t c="TRANS_NEW_USERNAME" d="New Username"}
{t c="TRANS_TERMS_OF_SERVICE" d="Terms of Service"}
{t c="TRANS_NOTICE" d="Notice"}
{t c="TRANS_MODERNBILL_LICENSE_NUM" d="ModernBill License #"}
{t c="TRANS_MODERNADVERTISE_REGISTER_INTRO" d="Register below for your FREE ModernAdvertise account. "}
{t c="TRANS_ALL_FIELDS_ARE_REQUIRED" d="All fields are required."}
{t c="TRANS_MODERNBILL_EMAIL" d="ModernBill Email"}

{include file="$tplDirectory/header.tpl"}

<center>
<h2>{$smarty.const.TRANS_MODERNADVERTISE_REGISTER_INTRO}</h2>
<i>{$smarty.const.TRANS_ALL_FIELDS_ARE_REQUIRED}</i>
</center>

<br />

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

<hr size="1" color="#CCCCCC" />

<form method="post" action="register.php">
<input type="hidden" name="action" value="{getActionID action="ShowResellerRegisterFormResponse"}" />
<input type="hidden" name="sid" value="{$sid}" />

<table width="100%" border="0" cellpadding="0" cellspacing="3" class="tab01">
<tbody>
{include
	file="$tplDirectory/widgets/forms/validateInputText.tpl"
	name="modernbillLicense"
	value=$formValues.modernbillLicense|stripslashes
	title="TRANS_MODERNBILL_LICENSE_NUM"}
{include
	file="$tplDirectory/widgets/forms/validateInputText.tpl"
	name="resellerEmail"
	value=$formValues.resellerEmail|stripslashes
	title="TRANS_MODERNBILL_EMAIL"}
{include
	file="$tplDirectory/widgets/forms/validateInputText.tpl"
	name="resellerFirstName"
	value=$formValues.resellerFirstName|stripslashes
	title="TRANS_FIRST_NAME"}
{include
	file="$tplDirectory/widgets/forms/validateInputText.tpl"
	name="resellerLastName"
	value=$formValues.resellerLastName|stripslashes
	title="TRANS_LAST_NAME"}
{include
	file="$tplDirectory/widgets/forms/validateInputText.tpl"
	name="resellerCompany"
	value=$formValues.resellerCompany|stripslashes
	title="TRANS_COMPANY"}
{include
	file="$tplDirectory/widgets/forms/validateInputText.tpl"
	name="resellerUsername"
	value=$formValues.resellerUsername|stripslashes
	title="TRANS_NEW_USERNAME"}
{include
	file="$tplDirectory/widgets/forms/validateInputPassword.tpl"
	name="resellerPassword"
	value=$formValues.resellerPassword
	title="TRANS_NEW_PASSWORD"}
{include
	file="$tplDirectory/widgets/forms/validateInputPassword.tpl"
	name="resellerPasswordConfirm"
	value=$formValues.resellerPasswordConfirm
	title="TRANS_ENTER_PASSWORD_AGAIN"}
<tr class="{if $invalid.languageID}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="languageID">{$smarty.const.TRANS_LANGUAGE}</label></th>
	<td width="100%"><select id="languageID" name="languageID" style="width:200px;"> {html_options options=$languageList selected=$formValues.languageID} </select> {$invalid.languageID}</td>
</tr>
<tr class="{if $invalid.countriesID}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="countriesID">{$smarty.const.TRANS_COUNTRY}</label></th>
	<td width="100%"><select id="countriesID" name="countriesID" style="width:200px;"> {html_options options=$countryList selected=$formValues.countriesID} </select> {$invalid.countriesID}</td>
</tr>
<tr class="{if $invalid.languageID}highlight{else}{cycle values="alt1,alt2"}{/if}">
	<th class="nowrap" scope="row"><label for="eula">{$smarty.const.TRANS_TERMS_OF_SERVICE}</label></th>
	<td width="100%"><input type="checkbox" name="eula" value="1" id="eula" /> Check here to <b>agree</b> to abide by the terms of service below.</td>
</tr>
<tr>
	<td colspan="2">
		<div style="height:200px; clipping:auto; overflow:auto; border:solid #CCCCCC 1px; padding:5px;">
		<p align="justify">
		{include file="$tplDirectory/../../lib-ppcfactory/templates/widgets/eula.tpl"}
		</p>
		</div>
	</td>
</tr>
<tr>
	<td colspan="2">
		<center>
        <input class="submit" type="submit" name="submit" value="{$smarty.const.TRANS_REGISTER}" />
        </center>
    </td>
</tr>
</tbody>
</table>

</form>

<br />
<br />

{include file="$tplDirectory/footer.tpl"}