{* $Id: paginationLinks.tpl,v 1.1 2006/06/13 15:36:57 mfountain Exp $
 * --------------------------------------------------------------
 * This template is a widget that displays the pagination links for a list of results.
 *
 * Smarty Variables:
 *	$fileName 				The name of the file to link to in the URL
 *	$queryArgs 				All urldecoded query args to append to the URL
 *	$filterArgs 			All urldecoded filter args to append to the URL
 *	$sortArgs 				All urldecoded sort args to append to the URL
 *	$paginationLinks 		An array of all pagination information if you want to override our biz rules
 *	$displayMinorPageList 	The flag to display minor page list
 *	$displayPrevMinorLink 	The flag to display previous minor href link
 *  $displayNextMinorLink   The flag to display next minor href link
 *  $displayAllPageSelect   The flag to display a select menu to go to any page.
 *
 * Example Usage:
 *  {include file="$tplDirectory/widgets/paginationLinks.tpl"}
 *}
{t c="TRANS_NEXT" d="Next"}
{t c="TRANS_PREVIOUS" d="Previous"}
{t c="TRANS_RESULTS" d="Results"}
{t c="TRANS_GOTO" d="Jump To: "}

{strip}
<div class="pagination">

{if $paginationLinks.paginationStats.totalRows > 0}

    {$smarty.const.TRANS_RESULTS}: <strong>{$paginationLinks.paginationStats.startingRowNum} - {$paginationLinks.paginationStats.stoppingRowNum}</strong> ~ {$paginationLinks.paginationStats.totalRows}
    <br />

    {if $displayPrevMinorLink}
		{assign var="recordOffset" value=$paginationLinks.prevNextLinks.previousLinkOffset}
		<a href="{getHREF page=$fileName actionID=$actionID args="$queryArgs&$filterArgs&$sortArgs&recordOffset=$recordOffset"}">
			<img src="{$imageDirectory}/ico/data_previous.gif" width="16" height="16" alt="{$smarty.const.TRANS_PREVIOUS}" title="{$smarty.const.TRANS_PREVIOUS}" />
		</a>
    {else}
        <img src="{$imageDirectory}/ico/data_previous.gif" width="16" height="16" alt="{$smarty.const.TRANS_PREVIOUS}" title="{$smarty.const.TRANS_PREVIOUS}" class="pad10" />
    {/if}

    {section name=page loop=$paginationLinks.pageLinks.pages}
        {if $paginationLinks.pageLinks.currentPageNumber == $paginationLinks.pageLinks.pages[page].pageNumber}
            <em>{$paginationLinks.pageLinks.pages[page].pageNumber}</em>
        {else}
			{assign var="recordOffset" value=$paginationLinks.pageLinks.pages[page].pageOffset}
			<a href="{getHREF page=$fileName actionID=$actionID args="$queryArgs&$filterArgs&$sortArgs&recordOffset=$recordOffset"}">
				{$paginationLinks.pageLinks.pages[page].pageNumber}
			</a>
        {/if}
    {sectionelse}
		<em>1</em>
	{/section}

    {if $displayNextMinorLink}
		{assign var="recordOffset" value=$paginationLinks.prevNextLinks.nextLinkOffset}
		<a href="{getHREF page=$fileName actionID=$actionID args="$queryArgs&$filterArgs&$sortArgs&recordOffset=$recordOffset"}">
			<img src="{$imageDirectory}/ico/data_next.gif" width="16" height="16" alt="{$smarty.const.TRANS_NEXT}" title="{$smarty.const.TRANS_NEXT}" />
		</a>
    {else}
        <img src="{$imageDirectory}/ico/data_next.gif" width="16" height="16" alt="{$smarty.const.TRANS_NEXT}" title="{$smarty.const.TRANS_NEXT}" class="pad10" />
    {/if}

    {if $displayAllPageSelect && $paginationLinks.paginationStats.totalPages>1}
    <br />
        {$smarty.const.TRANS_GOTO}
        <select style="width: 50px;" name="pageinationSelect" onChange="document.location.href='{getHREF page=$fileName actionID=$actionID args="$queryArgs&$filterArgs&$sortArgs"}&amp;recordOffset='+this.options[this.selectedIndex].value;">
        {mb_html_options selected=$paginationLinks.paginationStats.startingRowNum-1 paginationrowsperpage=$paginationLinks.paginationStats.rowsPerPage paginationtotalpages=$paginationLinks.paginationStats.totalPages paginationtotalrows=$paginationLinks.paginationStats.totalRows}
        </select>
    {/if}




{/if}

</div>
{/strip}